/*****************************************************************************
 * Copyright (c) 2014 Rowley Associates Limited.                             *
 *                                                                           *
 * This file may be distributed under the terms of the License Agreement     *
 * provided with this software.                                              *
 *                                                                           *
 * THIS FILE IS PROVIDED AS IS WITH NO WARRANTY OF ANY KIND, INCLUDING THE   *
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. *
 *****************************************************************************/

.macro ISR_HANDLER name=
  .section .vectors, "ax"
  .word \name
  .section .init, "ax"
  .thumb_func
  .weak \name
\name:
1: b 1b /* endless loop */
.endm

.macro ISR_RESERVED
  .section .vectors, "ax"
  .thumb_func
  .word 0
.endm

  .syntax unified
  .global Reset_Handler

  .section .vectors, "ax"
  .align 0
  .code 16
  .global _vectors

.macro DEFAULT_ISR_HANDLER name=
  .thumb_func
  .weak \name
\name:
1: b 1b /* endless loop */
.endm

 .extern SysTick_Handler
 .extern PendSV_Handler

_vectors:
  .word __stack_end__
  .word Reset_Handler
ISR_HANDLER NMI_Handler
ISR_HANDLER HardFault_Handler
ISR_HANDLER MemManage_Handler
ISR_HANDLER BusFault_Handler
ISR_HANDLER UsageFault_Handler
ISR_RESERVED
ISR_RESERVED
ISR_RESERVED
ISR_RESERVED
ISR_HANDLER SVC_Handler
ISR_RESERVED
ISR_RESERVED
ISR_HANDLER PendSV_Handler
ISR_HANDLER SysTick_Handler
  // External interrupts start her
ISR_HANDLER SUPC_Handler   /* 0  Supply Controller */
ISR_HANDLER RSTC_Handler   /* 1  Reset Controller */
ISR_HANDLER RTC_Handler    /* 2  Real Time Clock */
ISR_HANDLER RTT_Handler    /* 3  Real Time Timer */
ISR_HANDLER WDT_Handler    /* 4  Watchdog Timer 0 */
ISR_HANDLER PMC_Handler    /* 5  Power Management Controller */
ISR_HANDLER EFC_Handler    /* 6  Enhanced Embedded Flash Controller */
ISR_HANDLER UART0_Handler  /* 7  UART 0 */
ISR_HANDLER UART1_Handler  /* 8  UART 1 */
ISR_RESERVED               /* 9  Reserved */
ISR_HANDLER PIOA_Handler   /* 10 Parallel I/O Controller A */
ISR_HANDLER PIOB_Handler   /* 11 Parallel I/O Controller B */
ISR_HANDLER PIOC_Handler   /* 12 Parallel I/O Controller C */
ISR_HANDLER USART0_Handler /* 13 USART 0 */
ISR_HANDLER USART1_Handler /* 14 USART 1 */
ISR_HANDLER USART2_Handler /* 15 USART 2 */
ISR_HANDLER PIOD_Handler   /* 16 Parallel I/O Controller D */
ISR_HANDLER PIOE_Handler   /* 17 Parallel I/O Controller E */
ISR_HANDLER HSMCI_Handler  /* 18 Multimedia Card Interface */
ISR_HANDLER TWIHS0_Handler /* 19 Two Wire Interface 0 HS */
ISR_HANDLER TWIHS1_Handler /* 20 Two Wire Interface 1 HS */
ISR_HANDLER SPI0_Handler   /* 21 Serial Peripheral Interface 0 */
ISR_HANDLER SSC_Handler    /* 22 Synchronous Serial Controller */
ISR_HANDLER TC0_Handler    /* 23 Timer/Counter 0 */
ISR_HANDLER TC1_Handler    /* 24 Timer/Counter 1 */
ISR_HANDLER TC2_Handler    /* 25 Timer/Counter 2 */
ISR_HANDLER TC3_Handler    /* 26 Timer/Counter 3 */
ISR_HANDLER TC4_Handler    /* 27 Timer/Counter 4 */
ISR_HANDLER TC5_Handler    /* 28 Timer/Counter 5 */
ISR_HANDLER AFEC0_Handler  /* 29 Analog Front End 0 */
ISR_HANDLER DACC_Handler   /* 30 Digital To Analog Converter */
ISR_HANDLER PWM0_Handler   /* 31 Pulse Width Modulation 0 */
ISR_HANDLER ICM_Handler    /* 32 Integrity Check Monitor */
ISR_HANDLER ACC_Handler    /* 33 Analog Comparator */
ISR_HANDLER USBHS_Handler  /* 34 USB Host / Device Controller */
ISR_HANDLER MCAN0_Handler  /* 35 CAN Controller 0 */
ISR_RESERVED               /* 36 Reserved */
ISR_HANDLER MCAN1_Handler  /* 37 CAN Controller 1 */
ISR_RESERVED               /* 38 Reserved */
ISR_HANDLER GMAC_Handler   /* 39 Ethernet MAC */
ISR_HANDLER AFEC1_Handler  /* 40 Analog Front End 1 */
ISR_HANDLER TWIHS2_Handler /* 41 Two Wire Interface 2 HS */
ISR_HANDLER SPI1_Handler   /* 42 Serial Peripheral Interface 1 */
ISR_HANDLER QSPI_Handler   /* 43 Quad I/O Serial Peripheral Interface */
ISR_HANDLER UART2_Handler  /* 44 UART 2 */
ISR_HANDLER UART3_Handler  /* 45 UART 3 */
ISR_HANDLER UART4_Handler  /* 46 UART 4 */
ISR_HANDLER TC6_Handler    /* 47 Timer/Counter 6 */
ISR_HANDLER TC7_Handler    /* 48 Timer/Counter 7 */
ISR_HANDLER TC8_Handler    /* 49 Timer/Counter 8 */
ISR_HANDLER TC9_Handler    /* 50 Timer/Counter 9 */
ISR_HANDLER TC10_Handler   /* 51 Timer/Counter 10 */
ISR_HANDLER TC11_Handler   /* 52 Timer/Counter 11 */
ISR_HANDLER MLB_Handler    /* 53 MediaLB */
ISR_RESERVED               /* 54 Reserved */
ISR_RESERVED               /* 55 Reserved */
ISR_HANDLER AES_Handler    /* 56 AES */
ISR_HANDLER TRNG_Handler   /* 57 True Random Generator */
ISR_HANDLER XDMAC_Handler  /* 58 DMA */
ISR_HANDLER ISI_Handler    /* 59 Camera Interface */
ISR_HANDLER PWM1_Handler   /* 60 Pulse Width Modulation 1 */
ISR_RESERVED               /* 61 Reserved */
ISR_HANDLER SDRAMC_Handler /* 62 SDRAM Controller */
ISR_HANDLER RSWDT_Handler  /* 63 Watchdog Timer 1 */

  .section .vectors, "ax"
_vectors_end:

  .section .init, "ax"
  .thumb_func

  Reset_Handler:

#ifndef __NO_SYSTEM_INIT
  ldr r0, =__RAM1_segment_end__
  mov sp, r0
  bl SystemInit
#endif

#if !defined(__SOFTFP__)
  // Enable CP11 and CP10 with CPACR |= (0xf<<20)
  movw r0, 0xED88
  movt r0, 0xE000
  ldr r1, [r0]
  orrs r1, r1, #(0xf << 20)
  str r1, [r0]
#ifndef __NO_RUNFAST_MODE
  nop
  nop
  nop
  nop
  nop
  vmrs r0, fpscr
  orrs r0, r0, #(0x3 << 24) // FZ and DN
  vmsr fpscr, r0
  // clear the CONTROL.FPCA bit
  mov r0, #0
  msr control, r0
  // FPDSCR similarly
  movw r1, 0xEF3C
  movt r1, 0xE000
  ldr r0, [r1]
  orrs r0, r0, #(0x3 << 24) // FZ and DN
  str r0, [r1]
#endif
#endif

#ifndef __ARM_ARCH_6M__
  /* Configure vector table offset register */
  ldr r0, =0xE000ED08
  ldr r1, =_vectors
  str r1, [r0]
#endif

  ldr r0, =_start
  blx r0

#ifndef __NO_SYSTEM_INIT
  .thumb_func
  .weak SystemInit
SystemInit:
  bx lr
#endif
