/******************************************************************************
  Target Script for TIVA

  Copyright (c) 2013 Rowley Associates Limited.

  This file may be distributed under the terms of the License Agreement
  provided with this software.

  THIS FILE IS PROVIDED AS IS WITH NO WARRANTY OF ANY KIND, INCLUDING THE
  WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 ******************************************************************************/

function Reset()
{ 
  // Stop
  TargetInterface.pokeWord(0xE000EDF0, 0xA05F0003); // set C_HALT and C_DEBUGEN in DHCSR
  TargetInterface.waitForDebugState(1000);
  // Reset and stop
  TargetInterface.pokeWord(0xE000EDFC, 0x1); // set VC_CORERESET in DEMCR
  TargetInterface.pokeWord(0xE000ED0C, 0x05FA0004); // set SYSRESETREQ in AIRCR
  TargetInterface.waitForDebugState(1000);
}

function RAMReset()
{
  Reset();
}

function FLASHReset()
{
  Reset();
  TargetInterface.pokeWord(0x400FE0F0,1); // RMCTL = 1
}

function GetPartName()
{  
  var DID0 = TargetInterface.peekWord(0x400FE000);
  var DID1 = TargetInterface.peekWord(0x400FE004);
  if ((((DID0>>16) & 0xff) == 5) || (((DID0>>16) & 0xff) == 10))
    switch (DID1 & 0x00FF0000)
      {
        case 0x00C80000: return "SC4CE290NCPZ";
        case 0x00220000: return "TM4C1230C3PM";
        case 0x00230000: return "TM4C1230D5PM";
        case 0x00200000: return "TM4C1230E6PM";
        case 0x00210000: return "TM4C1230H6PM";
        case 0x00180000: return "TM4C1231C3PM";
        case 0x00190000: return "TM4C1231D5PM";
        case 0x00360000: return "TM4C1231D5PZ";
        case 0x00100000: return "TM4C1231E6PM";
        case 0x00300000: return "TM4C1231E6PZ";
        case 0x00350000: return "TM4C1231H6PGE";
        case 0x00110000: return "TM4C1231H6PM";
        case 0x00310000: return "TM4C1231H6PZ";
        case 0x00080000: return "TM4C1232C3PM";
        case 0x00090000: return "TM4C1232D5PM";
        case 0x000A0000: return "TM4C1232E6PM";
        case 0x000B0000: return "TM4C1232H6PM";
        case 0x00010000: return "TM4C1233C3PM";
        case 0x00020000: return "TM4C1233D5PM";
        case 0x00D00000: return "TM4C1233D5PZ";
        case 0x00030000: return "TM4C1233E6PM";
        case 0x00D10000: return "TM4C1233E6PZ";
        case 0x00D60000: return "TM4C1233H6PGE";
        case 0x00040000: return "TM4C1233H6PM";
        case 0x00D20000: return "TM4C1233H6PZ";
        case 0x00520000: return "TM4C1236D5PM";
        case 0x00500000: return "TM4C1236E6PM";
        case 0x00510000: return "TM4C1236H6PM";
        case 0x00480000: return "TM4C1237D5PM";
        case 0x00660000: return "TM4C1237D5PZ";
        case 0x00400000: return "TM4C1237E6PM";
        case 0x00600000: return "TM4C1237E6PZ";
        case 0x00650000: return "TM4C1237H6PGE";
        case 0x00410000: return "TM4C1237H6PM";
        case 0x00610000: return "TM4C1237H6PZ";
        case 0x00800000: return "TM4C123AE6PM";
        case 0x00830000: return "TM4C123AH6PM";
        case 0x00700000: return "TM4C123BE6PM";
        case 0x00C30000: return "TM4C123BE6PZ";
        case 0x00C60000: return "TM4C123BH6PGE";
        case 0x00730000: return "TM4C123BH6PM";
        case 0x00C40000: return "TM4C123BH6PZ";
        case 0x00E90000: return "TM4C123BH6ZRB";
        case 0x00B00000: return "TM4C123FE6PM";
        case 0x00B10000: return "TM4C123FH6PM";
        case 0x00A00000: return "TM4C123GE6PM";
        case 0x00C00000: return "TM4C123GE6PZ";
        case 0x00C50000: return "TM4C123GH6PGE";
        case 0x00A10000: return "TM4C123GH6PM";
        case 0x00C10000: return "TM4C123GH6PZ";
        case 0x00E30000: return "TM4C123GH6ZRB";
        case 0x00190000: return "TM4C1290NCPDT";
        case 0x001B0000: return "TM4C1290NCZAD";
        case 0x001C0000: return "TM4C1292NCPDT";
        case 0x001E0000: return "TM4C1292NCZAD";
        case 0x001F0000: return "TM4C1294NCPDT";
        case 0x00210000: return "TM4C1294NCZAD";
        case 0x00240000: return "TM4C129CNCPDT";
        case 0x00260000: return "TM4C129CNCZAD";
        case 0x00270000: return "TM4C129DNCPDT";
        case 0x00290000: return "TM4C129DNCZAD";
        case 0x002D0000: return "TM4C129ENCPDT";
        case 0x002F0000: return "TM4C129ENCZAD";
        case 0x00320000: return "TM4C129XNCZAD";   
      }
}

function MatchPartName(name)
{
  return name && name.substring(0, 8) == GetPartName().substring(0, 8);
}
