// LPC4088 register and bit definitions.
//
// Copyright (c) 2014 Rowley Associates Limited.
//
// This file may be distributed under the terms of the License Agreement
// provided with this software.
//
// THIS FILE IS PROVIDED AS IS WITH NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

#ifndef LPC4088_h
#define LPC4088_h


#ifndef LPC_FLASHCTRL_BASE_ADDRESS
#define LPC_FLASHCTRL_BASE_ADDRESS 0x200000
#endif

#define LPC_FLASHCTRL_FMSSTART (*(volatile unsigned long *)0x200020)
#define LPC_FLASHCTRL_FMSSTART_OFFSET 0x20
#define LPC_FLASHCTRL_FMSSTART_START_MASK 0x1FFFF
#define LPC_FLASHCTRL_FMSSTART_START_BIT 0

#define LPC_FLASHCTRL_FMSSTOP (*(volatile unsigned long *)0x200024)
#define LPC_FLASHCTRL_FMSSTOP_OFFSET 0x24
#define LPC_FLASHCTRL_FMSSTOP_STOP_MASK 0x1FFFF
#define LPC_FLASHCTRL_FMSSTOP_STOP_BIT 0
#define LPC_FLASHCTRL_FMSSTOP_SIG_START_MASK 0x20000
#define LPC_FLASHCTRL_FMSSTOP_SIG_START 0x20000
#define LPC_FLASHCTRL_FMSSTOP_SIG_START_BIT 17

#define LPC_FLASHCTRL_FMSW0 (*(volatile unsigned long *)0x20002C)
#define LPC_FLASHCTRL_FMSW0_OFFSET 0x2C
#define LPC_FLASHCTRL_FMSW0_SW0_31_0_MASK 0xFFFFFFFF
#define LPC_FLASHCTRL_FMSW0_SW0_31_0_BIT 0

#define LPC_FLASHCTRL_FMSW1 (*(volatile unsigned long *)0x200030)
#define LPC_FLASHCTRL_FMSW1_OFFSET 0x30
#define LPC_FLASHCTRL_FMSW1_SW1_63_32_MASK 0xFFFFFFFF
#define LPC_FLASHCTRL_FMSW1_SW1_63_32_BIT 0

#define LPC_FLASHCTRL_FMSW2 (*(volatile unsigned long *)0x200034)
#define LPC_FLASHCTRL_FMSW2_OFFSET 0x34
#define LPC_FLASHCTRL_FMSW2_SW2_95_64_MASK 0xFFFFFFFF
#define LPC_FLASHCTRL_FMSW2_SW2_95_64_BIT 0

#define LPC_FLASHCTRL_FMSW3 (*(volatile unsigned long *)0x200038)
#define LPC_FLASHCTRL_FMSW3_OFFSET 0x38
#define LPC_FLASHCTRL_FMSW3_SW3_127_96_MASK 0xFFFFFFFF
#define LPC_FLASHCTRL_FMSW3_SW3_127_96_BIT 0

#define LPC_FLASHCTRL_EECMD (*(volatile unsigned long *)0x200080)
#define LPC_FLASHCTRL_EECMD_OFFSET 0x80
#define LPC_FLASHCTRL_EECMD_CMD_MASK 0x7
#define LPC_FLASHCTRL_EECMD_CMD_BIT 0
#define LPC_FLASHCTRL_EECMD_RDPREFETCH_MASK 0x8
#define LPC_FLASHCTRL_EECMD_RDPREFETCH 0x8
#define LPC_FLASHCTRL_EECMD_RDPREFETCH_BIT 3

#define LPC_FLASHCTRL_EEADDR (*(volatile unsigned long *)0x200084)
#define LPC_FLASHCTRL_EEADDR_OFFSET 0x84
#define LPC_FLASHCTRL_EEADDR_ADDR_MASK 0xFFF
#define LPC_FLASHCTRL_EEADDR_ADDR_BIT 0

#define LPC_FLASHCTRL_EEWDATA (*(volatile unsigned long *)0x200088)
#define LPC_FLASHCTRL_EEWDATA_OFFSET 0x88
#define LPC_FLASHCTRL_EEWDATA_WDATA_MASK 0xFFFFFFFF
#define LPC_FLASHCTRL_EEWDATA_WDATA_BIT 0

#define LPC_FLASHCTRL_EERDATA (*(volatile unsigned long *)0x20008C)
#define LPC_FLASHCTRL_EERDATA_OFFSET 0x8C
#define LPC_FLASHCTRL_EERDATA_RDATA_MASK 0xFFFFFFFF
#define LPC_FLASHCTRL_EERDATA_RDATA_BIT 0

#define LPC_FLASHCTRL_EEWSTATE (*(volatile unsigned long *)0x200090)
#define LPC_FLASHCTRL_EEWSTATE_OFFSET 0x90
#define LPC_FLASHCTRL_EEWSTATE_PHASE3_MASK 0xFF
#define LPC_FLASHCTRL_EEWSTATE_PHASE3_BIT 0
#define LPC_FLASHCTRL_EEWSTATE_PHASE2_MASK 0xFF00
#define LPC_FLASHCTRL_EEWSTATE_PHASE2_BIT 8
#define LPC_FLASHCTRL_EEWSTATE_PHASE1_MASK 0xFF0000
#define LPC_FLASHCTRL_EEWSTATE_PHASE1_BIT 16

#define LPC_FLASHCTRL_EECLKDIV (*(volatile unsigned long *)0x200094)
#define LPC_FLASHCTRL_EECLKDIV_OFFSET 0x94
#define LPC_FLASHCTRL_EECLKDIV_CLKDIV_MASK 0xFFFF
#define LPC_FLASHCTRL_EECLKDIV_CLKDIV_BIT 0

#define LPC_FLASHCTRL_EEPWRDWN (*(volatile unsigned long *)0x200098)
#define LPC_FLASHCTRL_EEPWRDWN_OFFSET 0x98
#define LPC_FLASHCTRL_EEPWRDWN_PWRDWN_MASK 0x1
#define LPC_FLASHCTRL_EEPWRDWN_PWRDWN 0x1
#define LPC_FLASHCTRL_EEPWRDWN_PWRDWN_BIT 0

#define LPC_FLASHCTRL_STAT (*(volatile unsigned long *)0x200FE0)
#define LPC_FLASHCTRL_STAT_OFFSET 0xFE0
#define LPC_FLASHCTRL_STAT_SIG_DONE_MASK 0x4
#define LPC_FLASHCTRL_STAT_SIG_DONE 0x4
#define LPC_FLASHCTRL_STAT_SIG_DONE_BIT 2
#define LPC_FLASHCTRL_STAT_END_OF_RDWR_MASK 0x4000000
#define LPC_FLASHCTRL_STAT_END_OF_RDWR 0x4000000
#define LPC_FLASHCTRL_STAT_END_OF_RDWR_BIT 26
#define LPC_FLASHCTRL_STAT_END_OF_PROG1_MASK 0x10000000
#define LPC_FLASHCTRL_STAT_END_OF_PROG1 0x10000000
#define LPC_FLASHCTRL_STAT_END_OF_PROG1_BIT 28

#define LPC_FLASHCTRL_INTEN (*(volatile unsigned long *)0x200FE4)
#define LPC_FLASHCTRL_INTEN_OFFSET 0xFE4
#define LPC_FLASHCTRL_INTEN_EE_RW_DONE_MASK 0x4000000
#define LPC_FLASHCTRL_INTEN_EE_RW_DONE 0x4000000
#define LPC_FLASHCTRL_INTEN_EE_RW_DONE_BIT 26
#define LPC_FLASHCTRL_INTEN_EE_PROG_DONE_MASK 0x10000000
#define LPC_FLASHCTRL_INTEN_EE_PROG_DONE 0x10000000
#define LPC_FLASHCTRL_INTEN_EE_PROG_DONE_BIT 28

#define LPC_FLASHCTRL_STATCLR (*(volatile unsigned long *)0x200FE8)
#define LPC_FLASHCTRL_STATCLR_OFFSET 0xFE8
#define LPC_FLASHCTRL_STATCLR_SIG_DONE_CLR_MASK 0x4
#define LPC_FLASHCTRL_STATCLR_SIG_DONE_CLR 0x4
#define LPC_FLASHCTRL_STATCLR_SIG_DONE_CLR_BIT 2
#define LPC_FLASHCTRL_STATCLR_RDWR_CLR_ST_MASK 0x4000000
#define LPC_FLASHCTRL_STATCLR_RDWR_CLR_ST 0x4000000
#define LPC_FLASHCTRL_STATCLR_RDWR_CLR_ST_BIT 26
#define LPC_FLASHCTRL_STATCLR_PROG1_CLR_ST_MASK 0x10000000
#define LPC_FLASHCTRL_STATCLR_PROG1_CLR_ST 0x10000000
#define LPC_FLASHCTRL_STATCLR_PROG1_CLR_ST_BIT 28

#define LPC_FLASHCTRL_ENCLR (*(volatile unsigned long *)0x200FD8)
#define LPC_FLASHCTRL_ENCLR_OFFSET 0xFD8
#define LPC_FLASHCTRL_ENCLR_RDWR_CLR_EN_MASK 0x4000000
#define LPC_FLASHCTRL_ENCLR_RDWR_CLR_EN 0x4000000
#define LPC_FLASHCTRL_ENCLR_RDWR_CLR_EN_BIT 26
#define LPC_FLASHCTRL_ENCLR_PROG1_CLR_EN_MASK 0x10000000
#define LPC_FLASHCTRL_ENCLR_PROG1_CLR_EN 0x10000000
#define LPC_FLASHCTRL_ENCLR_PROG1_CLR_EN_BIT 28

#define LPC_FLASHCTRL_ENSET (*(volatile unsigned long *)0x200FDC)
#define LPC_FLASHCTRL_ENSET_OFFSET 0xFDC
#define LPC_FLASHCTRL_ENSET_RDWR_SET_EN_MASK 0x4000000
#define LPC_FLASHCTRL_ENSET_RDWR_SET_EN 0x4000000
#define LPC_FLASHCTRL_ENSET_RDWR_SET_EN_BIT 26
#define LPC_FLASHCTRL_ENSET_PROG1_SET_EN_MASK 0x10000000
#define LPC_FLASHCTRL_ENSET_PROG1_SET_EN 0x10000000
#define LPC_FLASHCTRL_ENSET_PROG1_SET_EN_BIT 28

#ifndef LPC_GPDMA_BASE_ADDRESS
#define LPC_GPDMA_BASE_ADDRESS 0x20080000
#endif

#define LPC_GPDMA_INTSTAT (*(volatile unsigned long *)0x20080000)
#define LPC_GPDMA_INTSTAT_OFFSET 0x0
#define LPC_GPDMA_INTSTAT_INTSTAT0_MASK 0x1
#define LPC_GPDMA_INTSTAT_INTSTAT0 0x1
#define LPC_GPDMA_INTSTAT_INTSTAT0_BIT 0
#define LPC_GPDMA_INTSTAT_INTSTAT1_MASK 0x2
#define LPC_GPDMA_INTSTAT_INTSTAT1 0x2
#define LPC_GPDMA_INTSTAT_INTSTAT1_BIT 1
#define LPC_GPDMA_INTSTAT_INTSTAT2_MASK 0x4
#define LPC_GPDMA_INTSTAT_INTSTAT2 0x4
#define LPC_GPDMA_INTSTAT_INTSTAT2_BIT 2
#define LPC_GPDMA_INTSTAT_INTSTAT3_MASK 0x8
#define LPC_GPDMA_INTSTAT_INTSTAT3 0x8
#define LPC_GPDMA_INTSTAT_INTSTAT3_BIT 3
#define LPC_GPDMA_INTSTAT_INTSTAT4_MASK 0x10
#define LPC_GPDMA_INTSTAT_INTSTAT4 0x10
#define LPC_GPDMA_INTSTAT_INTSTAT4_BIT 4
#define LPC_GPDMA_INTSTAT_INTSTAT5_MASK 0x20
#define LPC_GPDMA_INTSTAT_INTSTAT5 0x20
#define LPC_GPDMA_INTSTAT_INTSTAT5_BIT 5
#define LPC_GPDMA_INTSTAT_INTSTAT6_MASK 0x40
#define LPC_GPDMA_INTSTAT_INTSTAT6 0x40
#define LPC_GPDMA_INTSTAT_INTSTAT6_BIT 6
#define LPC_GPDMA_INTSTAT_INTSTAT7_MASK 0x80
#define LPC_GPDMA_INTSTAT_INTSTAT7 0x80
#define LPC_GPDMA_INTSTAT_INTSTAT7_BIT 7

#define LPC_GPDMA_INTTCSTAT (*(volatile unsigned long *)0x20080004)
#define LPC_GPDMA_INTTCSTAT_OFFSET 0x4
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT0_MASK 0x1
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT0 0x1
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT0_BIT 0
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT1_MASK 0x2
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT1 0x2
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT1_BIT 1
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT2_MASK 0x4
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT2 0x4
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT2_BIT 2
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT3_MASK 0x8
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT3 0x8
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT3_BIT 3
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT4_MASK 0x10
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT4 0x10
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT4_BIT 4
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT5_MASK 0x20
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT5 0x20
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT5_BIT 5
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT6_MASK 0x40
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT6 0x40
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT6_BIT 6
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT7_MASK 0x80
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT7 0x80
#define LPC_GPDMA_INTTCSTAT_INTTCSTAT7_BIT 7

#define LPC_GPDMA_INTTCCLEAR (*(volatile unsigned long *)0x20080008)
#define LPC_GPDMA_INTTCCLEAR_OFFSET 0x8
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR0_MASK 0x1
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR0 0x1
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR0_BIT 0
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR1_MASK 0x2
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR1 0x2
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR1_BIT 1
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR2_MASK 0x4
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR2 0x4
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR2_BIT 2
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR3_MASK 0x8
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR3 0x8
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR3_BIT 3
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR4_MASK 0x10
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR4 0x10
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR4_BIT 4
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR5_MASK 0x20
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR5 0x20
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR5_BIT 5
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR6_MASK 0x40
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR6 0x40
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR6_BIT 6
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR7_MASK 0x80
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR7 0x80
#define LPC_GPDMA_INTTCCLEAR_INTTCCLEAR7_BIT 7

#define LPC_GPDMA_INTERRSTAT (*(volatile unsigned long *)0x2008000C)
#define LPC_GPDMA_INTERRSTAT_OFFSET 0xC
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT0_MASK 0x1
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT0 0x1
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT0_BIT 0
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT1_MASK 0x2
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT1 0x2
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT1_BIT 1
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT2_MASK 0x4
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT2 0x4
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT2_BIT 2
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT3_MASK 0x8
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT3 0x8
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT3_BIT 3
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT4_MASK 0x10
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT4 0x10
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT4_BIT 4
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT5_MASK 0x20
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT5 0x20
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT5_BIT 5
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT6_MASK 0x40
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT6 0x40
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT6_BIT 6
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT7_MASK 0x80
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT7 0x80
#define LPC_GPDMA_INTERRSTAT_INTERRSTAT7_BIT 7

#define LPC_GPDMA_INTERRCLR (*(volatile unsigned long *)0x20080010)
#define LPC_GPDMA_INTERRCLR_OFFSET 0x10
#define LPC_GPDMA_INTERRCLR_INTERRCLR0_MASK 0x1
#define LPC_GPDMA_INTERRCLR_INTERRCLR0 0x1
#define LPC_GPDMA_INTERRCLR_INTERRCLR0_BIT 0
#define LPC_GPDMA_INTERRCLR_INTERRCLR1_MASK 0x2
#define LPC_GPDMA_INTERRCLR_INTERRCLR1 0x2
#define LPC_GPDMA_INTERRCLR_INTERRCLR1_BIT 1
#define LPC_GPDMA_INTERRCLR_INTERRCLR2_MASK 0x4
#define LPC_GPDMA_INTERRCLR_INTERRCLR2 0x4
#define LPC_GPDMA_INTERRCLR_INTERRCLR2_BIT 2
#define LPC_GPDMA_INTERRCLR_INTERRCLR3_MASK 0x8
#define LPC_GPDMA_INTERRCLR_INTERRCLR3 0x8
#define LPC_GPDMA_INTERRCLR_INTERRCLR3_BIT 3
#define LPC_GPDMA_INTERRCLR_INTERRCLR4_MASK 0x10
#define LPC_GPDMA_INTERRCLR_INTERRCLR4 0x10
#define LPC_GPDMA_INTERRCLR_INTERRCLR4_BIT 4
#define LPC_GPDMA_INTERRCLR_INTERRCLR5_MASK 0x20
#define LPC_GPDMA_INTERRCLR_INTERRCLR5 0x20
#define LPC_GPDMA_INTERRCLR_INTERRCLR5_BIT 5
#define LPC_GPDMA_INTERRCLR_INTERRCLR6_MASK 0x40
#define LPC_GPDMA_INTERRCLR_INTERRCLR6 0x40
#define LPC_GPDMA_INTERRCLR_INTERRCLR6_BIT 6
#define LPC_GPDMA_INTERRCLR_INTERRCLR7_MASK 0x80
#define LPC_GPDMA_INTERRCLR_INTERRCLR7 0x80
#define LPC_GPDMA_INTERRCLR_INTERRCLR7_BIT 7

#define LPC_GPDMA_RAWINTTCSTAT (*(volatile unsigned long *)0x20080014)
#define LPC_GPDMA_RAWINTTCSTAT_OFFSET 0x14
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT0_MASK 0x1
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT0 0x1
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT0_BIT 0
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT1_MASK 0x2
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT1 0x2
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT1_BIT 1
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT2_MASK 0x4
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT2 0x4
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT2_BIT 2
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT3_MASK 0x8
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT3 0x8
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT3_BIT 3
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT4_MASK 0x10
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT4 0x10
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT4_BIT 4
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT5_MASK 0x20
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT5 0x20
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT5_BIT 5
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT6_MASK 0x40
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT6 0x40
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT6_BIT 6
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT7_MASK 0x80
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT7 0x80
#define LPC_GPDMA_RAWINTTCSTAT_RAWINTTCSTAT7_BIT 7

#define LPC_GPDMA_RAWINTERRSTAT (*(volatile unsigned long *)0x20080018)
#define LPC_GPDMA_RAWINTERRSTAT_OFFSET 0x18
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT0_MASK 0x1
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT0 0x1
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT0_BIT 0
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT1_MASK 0x2
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT1 0x2
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT1_BIT 1
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT2_MASK 0x4
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT2 0x4
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT2_BIT 2
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT3_MASK 0x8
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT3 0x8
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT3_BIT 3
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT4_MASK 0x10
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT4 0x10
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT4_BIT 4
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT5_MASK 0x20
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT5 0x20
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT5_BIT 5
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT6_MASK 0x40
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT6 0x40
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT6_BIT 6
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT7_MASK 0x80
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT7 0x80
#define LPC_GPDMA_RAWINTERRSTAT_RAWINTERRSTAT7_BIT 7

#define LPC_GPDMA_ENBLDCHNS (*(volatile unsigned long *)0x2008001C)
#define LPC_GPDMA_ENBLDCHNS_OFFSET 0x1C
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS0_MASK 0x1
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS0 0x1
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS0_BIT 0
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS1_MASK 0x2
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS1 0x2
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS1_BIT 1
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS2_MASK 0x4
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS2 0x4
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS2_BIT 2
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS3_MASK 0x8
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS3 0x8
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS3_BIT 3
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS4_MASK 0x10
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS4 0x10
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS4_BIT 4
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS5_MASK 0x20
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS5 0x20
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS5_BIT 5
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS6_MASK 0x40
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS6 0x40
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS6_BIT 6
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS7_MASK 0x80
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS7 0x80
#define LPC_GPDMA_ENBLDCHNS_ENABLEDCHANNELS7_BIT 7

#define LPC_GPDMA_SOFTBREQ (*(volatile unsigned long *)0x20080020)
#define LPC_GPDMA_SOFTBREQ_OFFSET 0x20
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ0_MASK 0x1
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ0 0x1
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ0_BIT 0
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ1_MASK 0x2
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ1 0x2
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ1_BIT 1
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ2_MASK 0x4
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ2 0x4
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ2_BIT 2
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ3_MASK 0x8
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ3 0x8
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ3_BIT 3
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ4_MASK 0x10
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ4 0x10
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ4_BIT 4
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ5_MASK 0x20
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ5 0x20
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ5_BIT 5
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ6_MASK 0x40
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ6 0x40
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ6_BIT 6
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ7_MASK 0x80
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ7 0x80
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ7_BIT 7
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ8_MASK 0x100
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ8 0x100
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ8_BIT 8
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ9_MASK 0x200
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ9 0x200
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ9_BIT 9
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ10_MASK 0x400
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ10 0x400
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ10_BIT 10
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ11_MASK 0x800
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ11 0x800
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ11_BIT 11
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ12_MASK 0x1000
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ12 0x1000
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ12_BIT 12
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ13_MASK 0x2000
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ13 0x2000
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ13_BIT 13
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ14_MASK 0x4000
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ14 0x4000
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ14_BIT 14
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ15_MASK 0x8000
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ15 0x8000
#define LPC_GPDMA_SOFTBREQ_SOFTBREQ15_BIT 15

#define LPC_GPDMA_SOFTSREQ (*(volatile unsigned long *)0x20080024)
#define LPC_GPDMA_SOFTSREQ_OFFSET 0x24
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ0_MASK 0x1
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ0 0x1
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ0_BIT 0
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ1_MASK 0x2
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ1 0x2
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ1_BIT 1
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ2_MASK 0x4
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ2 0x4
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ2_BIT 2
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ3_MASK 0x8
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ3 0x8
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ3_BIT 3
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ4_MASK 0x10
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ4 0x10
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ4_BIT 4
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ5_MASK 0x20
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ5 0x20
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ5_BIT 5
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ6_MASK 0x40
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ6 0x40
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ6_BIT 6
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ7_MASK 0x80
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ7 0x80
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ7_BIT 7
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ8_MASK 0x100
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ8 0x100
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ8_BIT 8
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ9_MASK 0x200
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ9 0x200
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ9_BIT 9
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ10_MASK 0x400
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ10 0x400
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ10_BIT 10
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ11_MASK 0x800
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ11 0x800
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ11_BIT 11
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ12_MASK 0x1000
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ12 0x1000
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ12_BIT 12
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ13_MASK 0x2000
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ13 0x2000
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ13_BIT 13
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ14_MASK 0x4000
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ14 0x4000
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ14_BIT 14
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ15_MASK 0x8000
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ15 0x8000
#define LPC_GPDMA_SOFTSREQ_SOFTSREQ15_BIT 15

#define LPC_GPDMA_SOFTLBREQ (*(volatile unsigned long *)0x20080028)
#define LPC_GPDMA_SOFTLBREQ_OFFSET 0x28
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ0_MASK 0x1
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ0 0x1
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ0_BIT 0
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ1_MASK 0x2
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ1 0x2
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ1_BIT 1
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ2_MASK 0x4
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ2 0x4
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ2_BIT 2
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ3_MASK 0x8
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ3 0x8
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ3_BIT 3
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ4_MASK 0x10
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ4 0x10
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ4_BIT 4
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ5_MASK 0x20
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ5 0x20
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ5_BIT 5
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ6_MASK 0x40
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ6 0x40
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ6_BIT 6
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ7_MASK 0x80
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ7 0x80
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ7_BIT 7
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ8_MASK 0x100
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ8 0x100
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ8_BIT 8
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ9_MASK 0x200
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ9 0x200
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ9_BIT 9
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ10_MASK 0x400
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ10 0x400
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ10_BIT 10
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ11_MASK 0x800
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ11 0x800
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ11_BIT 11
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ12_MASK 0x1000
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ12 0x1000
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ12_BIT 12
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ13_MASK 0x2000
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ13 0x2000
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ13_BIT 13
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ14_MASK 0x4000
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ14 0x4000
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ14_BIT 14
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ15_MASK 0x8000
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ15 0x8000
#define LPC_GPDMA_SOFTLBREQ_SOFTLBREQ15_BIT 15

#define LPC_GPDMA_SOFTLSREQ (*(volatile unsigned long *)0x2008002C)
#define LPC_GPDMA_SOFTLSREQ_OFFSET 0x2C
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ0_MASK 0x1
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ0 0x1
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ0_BIT 0
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ1_MASK 0x2
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ1 0x2
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ1_BIT 1
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ2_MASK 0x4
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ2 0x4
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ2_BIT 2
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ3_MASK 0x8
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ3 0x8
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ3_BIT 3
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ4_MASK 0x10
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ4 0x10
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ4_BIT 4
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ5_MASK 0x20
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ5 0x20
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ5_BIT 5
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ6_MASK 0x40
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ6 0x40
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ6_BIT 6
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ7_MASK 0x80
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ7 0x80
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ7_BIT 7
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ8_MASK 0x100
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ8 0x100
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ8_BIT 8
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ9_MASK 0x200
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ9 0x200
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ9_BIT 9
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ10_MASK 0x400
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ10 0x400
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ10_BIT 10
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ11_MASK 0x800
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ11 0x800
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ11_BIT 11
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ12_MASK 0x1000
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ12 0x1000
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ12_BIT 12
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ13_MASK 0x2000
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ13 0x2000
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ13_BIT 13
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ14_MASK 0x4000
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ14 0x4000
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ14_BIT 14
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ15_MASK 0x8000
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ15 0x8000
#define LPC_GPDMA_SOFTLSREQ_SOFTLSREQ15_BIT 15

#define LPC_GPDMA_CONFIG (*(volatile unsigned long *)0x20080030)
#define LPC_GPDMA_CONFIG_OFFSET 0x30
#define LPC_GPDMA_CONFIG_E_MASK 0x1
#define LPC_GPDMA_CONFIG_E 0x1
#define LPC_GPDMA_CONFIG_E_BIT 0
#define LPC_GPDMA_CONFIG_M_MASK 0x2
#define LPC_GPDMA_CONFIG_M 0x2
#define LPC_GPDMA_CONFIG_M_BIT 1

#define LPC_GPDMA_SYNC (*(volatile unsigned long *)0x20080034)
#define LPC_GPDMA_SYNC_OFFSET 0x34
#define LPC_GPDMA_SYNC_DMACSYNC0_MASK 0x1
#define LPC_GPDMA_SYNC_DMACSYNC0 0x1
#define LPC_GPDMA_SYNC_DMACSYNC0_BIT 0
#define LPC_GPDMA_SYNC_DMACSYNC1_MASK 0x2
#define LPC_GPDMA_SYNC_DMACSYNC1 0x2
#define LPC_GPDMA_SYNC_DMACSYNC1_BIT 1
#define LPC_GPDMA_SYNC_DMACSYNC2_MASK 0x4
#define LPC_GPDMA_SYNC_DMACSYNC2 0x4
#define LPC_GPDMA_SYNC_DMACSYNC2_BIT 2
#define LPC_GPDMA_SYNC_DMACSYNC3_MASK 0x8
#define LPC_GPDMA_SYNC_DMACSYNC3 0x8
#define LPC_GPDMA_SYNC_DMACSYNC3_BIT 3
#define LPC_GPDMA_SYNC_DMACSYNC4_MASK 0x10
#define LPC_GPDMA_SYNC_DMACSYNC4 0x10
#define LPC_GPDMA_SYNC_DMACSYNC4_BIT 4
#define LPC_GPDMA_SYNC_DMACSYNC5_MASK 0x20
#define LPC_GPDMA_SYNC_DMACSYNC5 0x20
#define LPC_GPDMA_SYNC_DMACSYNC5_BIT 5
#define LPC_GPDMA_SYNC_DMACSYNC6_MASK 0x40
#define LPC_GPDMA_SYNC_DMACSYNC6 0x40
#define LPC_GPDMA_SYNC_DMACSYNC6_BIT 6
#define LPC_GPDMA_SYNC_DMACSYNC7_MASK 0x80
#define LPC_GPDMA_SYNC_DMACSYNC7 0x80
#define LPC_GPDMA_SYNC_DMACSYNC7_BIT 7
#define LPC_GPDMA_SYNC_DMACSYNC8_MASK 0x100
#define LPC_GPDMA_SYNC_DMACSYNC8 0x100
#define LPC_GPDMA_SYNC_DMACSYNC8_BIT 8
#define LPC_GPDMA_SYNC_DMACSYNC9_MASK 0x200
#define LPC_GPDMA_SYNC_DMACSYNC9 0x200
#define LPC_GPDMA_SYNC_DMACSYNC9_BIT 9
#define LPC_GPDMA_SYNC_DMACSYNC10_MASK 0x400
#define LPC_GPDMA_SYNC_DMACSYNC10 0x400
#define LPC_GPDMA_SYNC_DMACSYNC10_BIT 10
#define LPC_GPDMA_SYNC_DMACSYNC11_MASK 0x800
#define LPC_GPDMA_SYNC_DMACSYNC11 0x800
#define LPC_GPDMA_SYNC_DMACSYNC11_BIT 11
#define LPC_GPDMA_SYNC_DMACSYNC12_MASK 0x1000
#define LPC_GPDMA_SYNC_DMACSYNC12 0x1000
#define LPC_GPDMA_SYNC_DMACSYNC12_BIT 12
#define LPC_GPDMA_SYNC_DMACSYNC13_MASK 0x2000
#define LPC_GPDMA_SYNC_DMACSYNC13 0x2000
#define LPC_GPDMA_SYNC_DMACSYNC13_BIT 13
#define LPC_GPDMA_SYNC_DMACSYNC14_MASK 0x4000
#define LPC_GPDMA_SYNC_DMACSYNC14 0x4000
#define LPC_GPDMA_SYNC_DMACSYNC14_BIT 14
#define LPC_GPDMA_SYNC_DMACSYNC15_MASK 0x8000
#define LPC_GPDMA_SYNC_DMACSYNC15 0x8000
#define LPC_GPDMA_SYNC_DMACSYNC15_BIT 15

#define LPC_GPDMA_SRCADDR0 (*(volatile unsigned long *)0x20080100)
#define LPC_GPDMA_SRCADDR0_OFFSET 0x100
#define LPC_GPDMA_SRCADDR0_SRCADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_SRCADDR0_SRCADDR_BIT 0

#define LPC_GPDMA_SRCADDR1 (*(volatile unsigned long *)0x20080120)
#define LPC_GPDMA_SRCADDR1_OFFSET 0x120
#define LPC_GPDMA_SRCADDR1_SRCADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_SRCADDR1_SRCADDR_BIT 0

#define LPC_GPDMA_SRCADDR2 (*(volatile unsigned long *)0x20080140)
#define LPC_GPDMA_SRCADDR2_OFFSET 0x140
#define LPC_GPDMA_SRCADDR2_SRCADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_SRCADDR2_SRCADDR_BIT 0

#define LPC_GPDMA_SRCADDR3 (*(volatile unsigned long *)0x20080160)
#define LPC_GPDMA_SRCADDR3_OFFSET 0x160
#define LPC_GPDMA_SRCADDR3_SRCADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_SRCADDR3_SRCADDR_BIT 0

#define LPC_GPDMA_SRCADDR4 (*(volatile unsigned long *)0x20080180)
#define LPC_GPDMA_SRCADDR4_OFFSET 0x180
#define LPC_GPDMA_SRCADDR4_SRCADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_SRCADDR4_SRCADDR_BIT 0

#define LPC_GPDMA_SRCADDR5 (*(volatile unsigned long *)0x200801A0)
#define LPC_GPDMA_SRCADDR5_OFFSET 0x1A0
#define LPC_GPDMA_SRCADDR5_SRCADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_SRCADDR5_SRCADDR_BIT 0

#define LPC_GPDMA_SRCADDR6 (*(volatile unsigned long *)0x200801C0)
#define LPC_GPDMA_SRCADDR6_OFFSET 0x1C0
#define LPC_GPDMA_SRCADDR6_SRCADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_SRCADDR6_SRCADDR_BIT 0

#define LPC_GPDMA_SRCADDR7 (*(volatile unsigned long *)0x200801E0)
#define LPC_GPDMA_SRCADDR7_OFFSET 0x1E0
#define LPC_GPDMA_SRCADDR7_SRCADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_SRCADDR7_SRCADDR_BIT 0

#define LPC_GPDMA_DESTADDR0 (*(volatile unsigned long *)0x20080104)
#define LPC_GPDMA_DESTADDR0_OFFSET 0x104
#define LPC_GPDMA_DESTADDR0_DESTADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_DESTADDR0_DESTADDR_BIT 0

#define LPC_GPDMA_DESTADDR1 (*(volatile unsigned long *)0x20080124)
#define LPC_GPDMA_DESTADDR1_OFFSET 0x124
#define LPC_GPDMA_DESTADDR1_DESTADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_DESTADDR1_DESTADDR_BIT 0

#define LPC_GPDMA_DESTADDR2 (*(volatile unsigned long *)0x20080144)
#define LPC_GPDMA_DESTADDR2_OFFSET 0x144
#define LPC_GPDMA_DESTADDR2_DESTADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_DESTADDR2_DESTADDR_BIT 0

#define LPC_GPDMA_DESTADDR3 (*(volatile unsigned long *)0x20080164)
#define LPC_GPDMA_DESTADDR3_OFFSET 0x164
#define LPC_GPDMA_DESTADDR3_DESTADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_DESTADDR3_DESTADDR_BIT 0

#define LPC_GPDMA_DESTADDR4 (*(volatile unsigned long *)0x20080184)
#define LPC_GPDMA_DESTADDR4_OFFSET 0x184
#define LPC_GPDMA_DESTADDR4_DESTADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_DESTADDR4_DESTADDR_BIT 0

#define LPC_GPDMA_DESTADDR5 (*(volatile unsigned long *)0x200801A4)
#define LPC_GPDMA_DESTADDR5_OFFSET 0x1A4
#define LPC_GPDMA_DESTADDR5_DESTADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_DESTADDR5_DESTADDR_BIT 0

#define LPC_GPDMA_DESTADDR6 (*(volatile unsigned long *)0x200801C4)
#define LPC_GPDMA_DESTADDR6_OFFSET 0x1C4
#define LPC_GPDMA_DESTADDR6_DESTADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_DESTADDR6_DESTADDR_BIT 0

#define LPC_GPDMA_DESTADDR7 (*(volatile unsigned long *)0x200801E4)
#define LPC_GPDMA_DESTADDR7_OFFSET 0x1E4
#define LPC_GPDMA_DESTADDR7_DESTADDR_MASK 0xFFFFFFFF
#define LPC_GPDMA_DESTADDR7_DESTADDR_BIT 0

#define LPC_GPDMA_LLI0 (*(volatile unsigned long *)0x20080108)
#define LPC_GPDMA_LLI0_OFFSET 0x108
#define LPC_GPDMA_LLI0_LLI_MASK 0xFFFFFFFC
#define LPC_GPDMA_LLI0_LLI_BIT 2

#define LPC_GPDMA_LLI1 (*(volatile unsigned long *)0x20080128)
#define LPC_GPDMA_LLI1_OFFSET 0x128
#define LPC_GPDMA_LLI1_LLI_MASK 0xFFFFFFFC
#define LPC_GPDMA_LLI1_LLI_BIT 2

#define LPC_GPDMA_LLI2 (*(volatile unsigned long *)0x20080148)
#define LPC_GPDMA_LLI2_OFFSET 0x148
#define LPC_GPDMA_LLI2_LLI_MASK 0xFFFFFFFC
#define LPC_GPDMA_LLI2_LLI_BIT 2

#define LPC_GPDMA_LLI3 (*(volatile unsigned long *)0x20080168)
#define LPC_GPDMA_LLI3_OFFSET 0x168
#define LPC_GPDMA_LLI3_LLI_MASK 0xFFFFFFFC
#define LPC_GPDMA_LLI3_LLI_BIT 2

#define LPC_GPDMA_LLI4 (*(volatile unsigned long *)0x20080188)
#define LPC_GPDMA_LLI4_OFFSET 0x188
#define LPC_GPDMA_LLI4_LLI_MASK 0xFFFFFFFC
#define LPC_GPDMA_LLI4_LLI_BIT 2

#define LPC_GPDMA_LLI5 (*(volatile unsigned long *)0x200801A8)
#define LPC_GPDMA_LLI5_OFFSET 0x1A8
#define LPC_GPDMA_LLI5_LLI_MASK 0xFFFFFFFC
#define LPC_GPDMA_LLI5_LLI_BIT 2

#define LPC_GPDMA_LLI6 (*(volatile unsigned long *)0x200801C8)
#define LPC_GPDMA_LLI6_OFFSET 0x1C8
#define LPC_GPDMA_LLI6_LLI_MASK 0xFFFFFFFC
#define LPC_GPDMA_LLI6_LLI_BIT 2

#define LPC_GPDMA_LLI7 (*(volatile unsigned long *)0x200801E8)
#define LPC_GPDMA_LLI7_OFFSET 0x1E8
#define LPC_GPDMA_LLI7_LLI_MASK 0xFFFFFFFC
#define LPC_GPDMA_LLI7_LLI_BIT 2

#define LPC_GPDMA_CONTROL0 (*(volatile unsigned long *)0x2008010C)
#define LPC_GPDMA_CONTROL0_OFFSET 0x10C
#define LPC_GPDMA_CONTROL0_TRANSFERSIZE_MASK 0xFFF
#define LPC_GPDMA_CONTROL0_TRANSFERSIZE_BIT 0
#define LPC_GPDMA_CONTROL0_SBSIZE_MASK 0x7000
#define LPC_GPDMA_CONTROL0_SBSIZE_BIT 12
#define LPC_GPDMA_CONTROL0_DBSIZE_MASK 0x38000
#define LPC_GPDMA_CONTROL0_DBSIZE_BIT 15
#define LPC_GPDMA_CONTROL0_SWIDTH_MASK 0x1C0000
#define LPC_GPDMA_CONTROL0_SWIDTH_BIT 18
#define LPC_GPDMA_CONTROL0_DWIDTH_MASK 0xE00000
#define LPC_GPDMA_CONTROL0_DWIDTH_BIT 21
#define LPC_GPDMA_CONTROL0_SI_MASK 0x4000000
#define LPC_GPDMA_CONTROL0_SI 0x4000000
#define LPC_GPDMA_CONTROL0_SI_BIT 26
#define LPC_GPDMA_CONTROL0_DI_MASK 0x8000000
#define LPC_GPDMA_CONTROL0_DI 0x8000000
#define LPC_GPDMA_CONTROL0_DI_BIT 27
#define LPC_GPDMA_CONTROL0_PROT1_MASK 0x10000000
#define LPC_GPDMA_CONTROL0_PROT1 0x10000000
#define LPC_GPDMA_CONTROL0_PROT1_BIT 28
#define LPC_GPDMA_CONTROL0_PROT2_MASK 0x20000000
#define LPC_GPDMA_CONTROL0_PROT2 0x20000000
#define LPC_GPDMA_CONTROL0_PROT2_BIT 29
#define LPC_GPDMA_CONTROL0_PROT3_MASK 0x40000000
#define LPC_GPDMA_CONTROL0_PROT3 0x40000000
#define LPC_GPDMA_CONTROL0_PROT3_BIT 30
#define LPC_GPDMA_CONTROL0_I_MASK 0x80000000
#define LPC_GPDMA_CONTROL0_I 0x80000000
#define LPC_GPDMA_CONTROL0_I_BIT 31

#define LPC_GPDMA_CONTROL1 (*(volatile unsigned long *)0x2008012C)
#define LPC_GPDMA_CONTROL1_OFFSET 0x12C
#define LPC_GPDMA_CONTROL1_TRANSFERSIZE_MASK 0xFFF
#define LPC_GPDMA_CONTROL1_TRANSFERSIZE_BIT 0
#define LPC_GPDMA_CONTROL1_SBSIZE_MASK 0x7000
#define LPC_GPDMA_CONTROL1_SBSIZE_BIT 12
#define LPC_GPDMA_CONTROL1_DBSIZE_MASK 0x38000
#define LPC_GPDMA_CONTROL1_DBSIZE_BIT 15
#define LPC_GPDMA_CONTROL1_SWIDTH_MASK 0x1C0000
#define LPC_GPDMA_CONTROL1_SWIDTH_BIT 18
#define LPC_GPDMA_CONTROL1_DWIDTH_MASK 0xE00000
#define LPC_GPDMA_CONTROL1_DWIDTH_BIT 21
#define LPC_GPDMA_CONTROL1_SI_MASK 0x4000000
#define LPC_GPDMA_CONTROL1_SI 0x4000000
#define LPC_GPDMA_CONTROL1_SI_BIT 26
#define LPC_GPDMA_CONTROL1_DI_MASK 0x8000000
#define LPC_GPDMA_CONTROL1_DI 0x8000000
#define LPC_GPDMA_CONTROL1_DI_BIT 27
#define LPC_GPDMA_CONTROL1_PROT1_MASK 0x10000000
#define LPC_GPDMA_CONTROL1_PROT1 0x10000000
#define LPC_GPDMA_CONTROL1_PROT1_BIT 28
#define LPC_GPDMA_CONTROL1_PROT2_MASK 0x20000000
#define LPC_GPDMA_CONTROL1_PROT2 0x20000000
#define LPC_GPDMA_CONTROL1_PROT2_BIT 29
#define LPC_GPDMA_CONTROL1_PROT3_MASK 0x40000000
#define LPC_GPDMA_CONTROL1_PROT3 0x40000000
#define LPC_GPDMA_CONTROL1_PROT3_BIT 30
#define LPC_GPDMA_CONTROL1_I_MASK 0x80000000
#define LPC_GPDMA_CONTROL1_I 0x80000000
#define LPC_GPDMA_CONTROL1_I_BIT 31

#define LPC_GPDMA_CONTROL2 (*(volatile unsigned long *)0x2008014C)
#define LPC_GPDMA_CONTROL2_OFFSET 0x14C
#define LPC_GPDMA_CONTROL2_TRANSFERSIZE_MASK 0xFFF
#define LPC_GPDMA_CONTROL2_TRANSFERSIZE_BIT 0
#define LPC_GPDMA_CONTROL2_SBSIZE_MASK 0x7000
#define LPC_GPDMA_CONTROL2_SBSIZE_BIT 12
#define LPC_GPDMA_CONTROL2_DBSIZE_MASK 0x38000
#define LPC_GPDMA_CONTROL2_DBSIZE_BIT 15
#define LPC_GPDMA_CONTROL2_SWIDTH_MASK 0x1C0000
#define LPC_GPDMA_CONTROL2_SWIDTH_BIT 18
#define LPC_GPDMA_CONTROL2_DWIDTH_MASK 0xE00000
#define LPC_GPDMA_CONTROL2_DWIDTH_BIT 21
#define LPC_GPDMA_CONTROL2_SI_MASK 0x4000000
#define LPC_GPDMA_CONTROL2_SI 0x4000000
#define LPC_GPDMA_CONTROL2_SI_BIT 26
#define LPC_GPDMA_CONTROL2_DI_MASK 0x8000000
#define LPC_GPDMA_CONTROL2_DI 0x8000000
#define LPC_GPDMA_CONTROL2_DI_BIT 27
#define LPC_GPDMA_CONTROL2_PROT1_MASK 0x10000000
#define LPC_GPDMA_CONTROL2_PROT1 0x10000000
#define LPC_GPDMA_CONTROL2_PROT1_BIT 28
#define LPC_GPDMA_CONTROL2_PROT2_MASK 0x20000000
#define LPC_GPDMA_CONTROL2_PROT2 0x20000000
#define LPC_GPDMA_CONTROL2_PROT2_BIT 29
#define LPC_GPDMA_CONTROL2_PROT3_MASK 0x40000000
#define LPC_GPDMA_CONTROL2_PROT3 0x40000000
#define LPC_GPDMA_CONTROL2_PROT3_BIT 30
#define LPC_GPDMA_CONTROL2_I_MASK 0x80000000
#define LPC_GPDMA_CONTROL2_I 0x80000000
#define LPC_GPDMA_CONTROL2_I_BIT 31

#define LPC_GPDMA_CONTROL3 (*(volatile unsigned long *)0x2008016C)
#define LPC_GPDMA_CONTROL3_OFFSET 0x16C
#define LPC_GPDMA_CONTROL3_TRANSFERSIZE_MASK 0xFFF
#define LPC_GPDMA_CONTROL3_TRANSFERSIZE_BIT 0
#define LPC_GPDMA_CONTROL3_SBSIZE_MASK 0x7000
#define LPC_GPDMA_CONTROL3_SBSIZE_BIT 12
#define LPC_GPDMA_CONTROL3_DBSIZE_MASK 0x38000
#define LPC_GPDMA_CONTROL3_DBSIZE_BIT 15
#define LPC_GPDMA_CONTROL3_SWIDTH_MASK 0x1C0000
#define LPC_GPDMA_CONTROL3_SWIDTH_BIT 18
#define LPC_GPDMA_CONTROL3_DWIDTH_MASK 0xE00000
#define LPC_GPDMA_CONTROL3_DWIDTH_BIT 21
#define LPC_GPDMA_CONTROL3_SI_MASK 0x4000000
#define LPC_GPDMA_CONTROL3_SI 0x4000000
#define LPC_GPDMA_CONTROL3_SI_BIT 26
#define LPC_GPDMA_CONTROL3_DI_MASK 0x8000000
#define LPC_GPDMA_CONTROL3_DI 0x8000000
#define LPC_GPDMA_CONTROL3_DI_BIT 27
#define LPC_GPDMA_CONTROL3_PROT1_MASK 0x10000000
#define LPC_GPDMA_CONTROL3_PROT1 0x10000000
#define LPC_GPDMA_CONTROL3_PROT1_BIT 28
#define LPC_GPDMA_CONTROL3_PROT2_MASK 0x20000000
#define LPC_GPDMA_CONTROL3_PROT2 0x20000000
#define LPC_GPDMA_CONTROL3_PROT2_BIT 29
#define LPC_GPDMA_CONTROL3_PROT3_MASK 0x40000000
#define LPC_GPDMA_CONTROL3_PROT3 0x40000000
#define LPC_GPDMA_CONTROL3_PROT3_BIT 30
#define LPC_GPDMA_CONTROL3_I_MASK 0x80000000
#define LPC_GPDMA_CONTROL3_I 0x80000000
#define LPC_GPDMA_CONTROL3_I_BIT 31

#define LPC_GPDMA_CONTROL4 (*(volatile unsigned long *)0x2008018C)
#define LPC_GPDMA_CONTROL4_OFFSET 0x18C
#define LPC_GPDMA_CONTROL4_TRANSFERSIZE_MASK 0xFFF
#define LPC_GPDMA_CONTROL4_TRANSFERSIZE_BIT 0
#define LPC_GPDMA_CONTROL4_SBSIZE_MASK 0x7000
#define LPC_GPDMA_CONTROL4_SBSIZE_BIT 12
#define LPC_GPDMA_CONTROL4_DBSIZE_MASK 0x38000
#define LPC_GPDMA_CONTROL4_DBSIZE_BIT 15
#define LPC_GPDMA_CONTROL4_SWIDTH_MASK 0x1C0000
#define LPC_GPDMA_CONTROL4_SWIDTH_BIT 18
#define LPC_GPDMA_CONTROL4_DWIDTH_MASK 0xE00000
#define LPC_GPDMA_CONTROL4_DWIDTH_BIT 21
#define LPC_GPDMA_CONTROL4_SI_MASK 0x4000000
#define LPC_GPDMA_CONTROL4_SI 0x4000000
#define LPC_GPDMA_CONTROL4_SI_BIT 26
#define LPC_GPDMA_CONTROL4_DI_MASK 0x8000000
#define LPC_GPDMA_CONTROL4_DI 0x8000000
#define LPC_GPDMA_CONTROL4_DI_BIT 27
#define LPC_GPDMA_CONTROL4_PROT1_MASK 0x10000000
#define LPC_GPDMA_CONTROL4_PROT1 0x10000000
#define LPC_GPDMA_CONTROL4_PROT1_BIT 28
#define LPC_GPDMA_CONTROL4_PROT2_MASK 0x20000000
#define LPC_GPDMA_CONTROL4_PROT2 0x20000000
#define LPC_GPDMA_CONTROL4_PROT2_BIT 29
#define LPC_GPDMA_CONTROL4_PROT3_MASK 0x40000000
#define LPC_GPDMA_CONTROL4_PROT3 0x40000000
#define LPC_GPDMA_CONTROL4_PROT3_BIT 30
#define LPC_GPDMA_CONTROL4_I_MASK 0x80000000
#define LPC_GPDMA_CONTROL4_I 0x80000000
#define LPC_GPDMA_CONTROL4_I_BIT 31

#define LPC_GPDMA_CONTROL5 (*(volatile unsigned long *)0x200801AC)
#define LPC_GPDMA_CONTROL5_OFFSET 0x1AC
#define LPC_GPDMA_CONTROL5_TRANSFERSIZE_MASK 0xFFF
#define LPC_GPDMA_CONTROL5_TRANSFERSIZE_BIT 0
#define LPC_GPDMA_CONTROL5_SBSIZE_MASK 0x7000
#define LPC_GPDMA_CONTROL5_SBSIZE_BIT 12
#define LPC_GPDMA_CONTROL5_DBSIZE_MASK 0x38000
#define LPC_GPDMA_CONTROL5_DBSIZE_BIT 15
#define LPC_GPDMA_CONTROL5_SWIDTH_MASK 0x1C0000
#define LPC_GPDMA_CONTROL5_SWIDTH_BIT 18
#define LPC_GPDMA_CONTROL5_DWIDTH_MASK 0xE00000
#define LPC_GPDMA_CONTROL5_DWIDTH_BIT 21
#define LPC_GPDMA_CONTROL5_SI_MASK 0x4000000
#define LPC_GPDMA_CONTROL5_SI 0x4000000
#define LPC_GPDMA_CONTROL5_SI_BIT 26
#define LPC_GPDMA_CONTROL5_DI_MASK 0x8000000
#define LPC_GPDMA_CONTROL5_DI 0x8000000
#define LPC_GPDMA_CONTROL5_DI_BIT 27
#define LPC_GPDMA_CONTROL5_PROT1_MASK 0x10000000
#define LPC_GPDMA_CONTROL5_PROT1 0x10000000
#define LPC_GPDMA_CONTROL5_PROT1_BIT 28
#define LPC_GPDMA_CONTROL5_PROT2_MASK 0x20000000
#define LPC_GPDMA_CONTROL5_PROT2 0x20000000
#define LPC_GPDMA_CONTROL5_PROT2_BIT 29
#define LPC_GPDMA_CONTROL5_PROT3_MASK 0x40000000
#define LPC_GPDMA_CONTROL5_PROT3 0x40000000
#define LPC_GPDMA_CONTROL5_PROT3_BIT 30
#define LPC_GPDMA_CONTROL5_I_MASK 0x80000000
#define LPC_GPDMA_CONTROL5_I 0x80000000
#define LPC_GPDMA_CONTROL5_I_BIT 31

#define LPC_GPDMA_CONTROL6 (*(volatile unsigned long *)0x200801CC)
#define LPC_GPDMA_CONTROL6_OFFSET 0x1CC
#define LPC_GPDMA_CONTROL6_TRANSFERSIZE_MASK 0xFFF
#define LPC_GPDMA_CONTROL6_TRANSFERSIZE_BIT 0
#define LPC_GPDMA_CONTROL6_SBSIZE_MASK 0x7000
#define LPC_GPDMA_CONTROL6_SBSIZE_BIT 12
#define LPC_GPDMA_CONTROL6_DBSIZE_MASK 0x38000
#define LPC_GPDMA_CONTROL6_DBSIZE_BIT 15
#define LPC_GPDMA_CONTROL6_SWIDTH_MASK 0x1C0000
#define LPC_GPDMA_CONTROL6_SWIDTH_BIT 18
#define LPC_GPDMA_CONTROL6_DWIDTH_MASK 0xE00000
#define LPC_GPDMA_CONTROL6_DWIDTH_BIT 21
#define LPC_GPDMA_CONTROL6_SI_MASK 0x4000000
#define LPC_GPDMA_CONTROL6_SI 0x4000000
#define LPC_GPDMA_CONTROL6_SI_BIT 26
#define LPC_GPDMA_CONTROL6_DI_MASK 0x8000000
#define LPC_GPDMA_CONTROL6_DI 0x8000000
#define LPC_GPDMA_CONTROL6_DI_BIT 27
#define LPC_GPDMA_CONTROL6_PROT1_MASK 0x10000000
#define LPC_GPDMA_CONTROL6_PROT1 0x10000000
#define LPC_GPDMA_CONTROL6_PROT1_BIT 28
#define LPC_GPDMA_CONTROL6_PROT2_MASK 0x20000000
#define LPC_GPDMA_CONTROL6_PROT2 0x20000000
#define LPC_GPDMA_CONTROL6_PROT2_BIT 29
#define LPC_GPDMA_CONTROL6_PROT3_MASK 0x40000000
#define LPC_GPDMA_CONTROL6_PROT3 0x40000000
#define LPC_GPDMA_CONTROL6_PROT3_BIT 30
#define LPC_GPDMA_CONTROL6_I_MASK 0x80000000
#define LPC_GPDMA_CONTROL6_I 0x80000000
#define LPC_GPDMA_CONTROL6_I_BIT 31

#define LPC_GPDMA_CONTROL7 (*(volatile unsigned long *)0x200801EC)
#define LPC_GPDMA_CONTROL7_OFFSET 0x1EC
#define LPC_GPDMA_CONTROL7_TRANSFERSIZE_MASK 0xFFF
#define LPC_GPDMA_CONTROL7_TRANSFERSIZE_BIT 0
#define LPC_GPDMA_CONTROL7_SBSIZE_MASK 0x7000
#define LPC_GPDMA_CONTROL7_SBSIZE_BIT 12
#define LPC_GPDMA_CONTROL7_DBSIZE_MASK 0x38000
#define LPC_GPDMA_CONTROL7_DBSIZE_BIT 15
#define LPC_GPDMA_CONTROL7_SWIDTH_MASK 0x1C0000
#define LPC_GPDMA_CONTROL7_SWIDTH_BIT 18
#define LPC_GPDMA_CONTROL7_DWIDTH_MASK 0xE00000
#define LPC_GPDMA_CONTROL7_DWIDTH_BIT 21
#define LPC_GPDMA_CONTROL7_SI_MASK 0x4000000
#define LPC_GPDMA_CONTROL7_SI 0x4000000
#define LPC_GPDMA_CONTROL7_SI_BIT 26
#define LPC_GPDMA_CONTROL7_DI_MASK 0x8000000
#define LPC_GPDMA_CONTROL7_DI 0x8000000
#define LPC_GPDMA_CONTROL7_DI_BIT 27
#define LPC_GPDMA_CONTROL7_PROT1_MASK 0x10000000
#define LPC_GPDMA_CONTROL7_PROT1 0x10000000
#define LPC_GPDMA_CONTROL7_PROT1_BIT 28
#define LPC_GPDMA_CONTROL7_PROT2_MASK 0x20000000
#define LPC_GPDMA_CONTROL7_PROT2 0x20000000
#define LPC_GPDMA_CONTROL7_PROT2_BIT 29
#define LPC_GPDMA_CONTROL7_PROT3_MASK 0x40000000
#define LPC_GPDMA_CONTROL7_PROT3 0x40000000
#define LPC_GPDMA_CONTROL7_PROT3_BIT 30
#define LPC_GPDMA_CONTROL7_I_MASK 0x80000000
#define LPC_GPDMA_CONTROL7_I 0x80000000
#define LPC_GPDMA_CONTROL7_I_BIT 31

#define LPC_GPDMA_CONFIG0 (*(volatile unsigned long *)0x20080110)
#define LPC_GPDMA_CONFIG0_OFFSET 0x110
#define LPC_GPDMA_CONFIG0_E_MASK 0x1
#define LPC_GPDMA_CONFIG0_E 0x1
#define LPC_GPDMA_CONFIG0_E_BIT 0
#define LPC_GPDMA_CONFIG0_SRCPERIPHERAL_MASK 0x3E
#define LPC_GPDMA_CONFIG0_SRCPERIPHERAL_BIT 1
#define LPC_GPDMA_CONFIG0_DESTPERIPHERAL_MASK 0x7C0
#define LPC_GPDMA_CONFIG0_DESTPERIPHERAL_BIT 6
#define LPC_GPDMA_CONFIG0_TRANSFERTYPE_MASK 0x3800
#define LPC_GPDMA_CONFIG0_TRANSFERTYPE_BIT 11
#define LPC_GPDMA_CONFIG0_IE_MASK 0x4000
#define LPC_GPDMA_CONFIG0_IE 0x4000
#define LPC_GPDMA_CONFIG0_IE_BIT 14
#define LPC_GPDMA_CONFIG0_ITC_MASK 0x8000
#define LPC_GPDMA_CONFIG0_ITC 0x8000
#define LPC_GPDMA_CONFIG0_ITC_BIT 15
#define LPC_GPDMA_CONFIG0_L_MASK 0x10000
#define LPC_GPDMA_CONFIG0_L 0x10000
#define LPC_GPDMA_CONFIG0_L_BIT 16
#define LPC_GPDMA_CONFIG0_A_MASK 0x20000
#define LPC_GPDMA_CONFIG0_A 0x20000
#define LPC_GPDMA_CONFIG0_A_BIT 17
#define LPC_GPDMA_CONFIG0_H_MASK 0x40000
#define LPC_GPDMA_CONFIG0_H 0x40000
#define LPC_GPDMA_CONFIG0_H_BIT 18

#define LPC_GPDMA_CONFIG1 (*(volatile unsigned long *)0x20080130)
#define LPC_GPDMA_CONFIG1_OFFSET 0x130
#define LPC_GPDMA_CONFIG1_E_MASK 0x1
#define LPC_GPDMA_CONFIG1_E 0x1
#define LPC_GPDMA_CONFIG1_E_BIT 0
#define LPC_GPDMA_CONFIG1_SRCPERIPHERAL_MASK 0x3E
#define LPC_GPDMA_CONFIG1_SRCPERIPHERAL_BIT 1
#define LPC_GPDMA_CONFIG1_DESTPERIPHERAL_MASK 0x7C0
#define LPC_GPDMA_CONFIG1_DESTPERIPHERAL_BIT 6
#define LPC_GPDMA_CONFIG1_TRANSFERTYPE_MASK 0x3800
#define LPC_GPDMA_CONFIG1_TRANSFERTYPE_BIT 11
#define LPC_GPDMA_CONFIG1_IE_MASK 0x4000
#define LPC_GPDMA_CONFIG1_IE 0x4000
#define LPC_GPDMA_CONFIG1_IE_BIT 14
#define LPC_GPDMA_CONFIG1_ITC_MASK 0x8000
#define LPC_GPDMA_CONFIG1_ITC 0x8000
#define LPC_GPDMA_CONFIG1_ITC_BIT 15
#define LPC_GPDMA_CONFIG1_L_MASK 0x10000
#define LPC_GPDMA_CONFIG1_L 0x10000
#define LPC_GPDMA_CONFIG1_L_BIT 16
#define LPC_GPDMA_CONFIG1_A_MASK 0x20000
#define LPC_GPDMA_CONFIG1_A 0x20000
#define LPC_GPDMA_CONFIG1_A_BIT 17
#define LPC_GPDMA_CONFIG1_H_MASK 0x40000
#define LPC_GPDMA_CONFIG1_H 0x40000
#define LPC_GPDMA_CONFIG1_H_BIT 18

#define LPC_GPDMA_CONFIG2 (*(volatile unsigned long *)0x20080150)
#define LPC_GPDMA_CONFIG2_OFFSET 0x150
#define LPC_GPDMA_CONFIG2_E_MASK 0x1
#define LPC_GPDMA_CONFIG2_E 0x1
#define LPC_GPDMA_CONFIG2_E_BIT 0
#define LPC_GPDMA_CONFIG2_SRCPERIPHERAL_MASK 0x3E
#define LPC_GPDMA_CONFIG2_SRCPERIPHERAL_BIT 1
#define LPC_GPDMA_CONFIG2_DESTPERIPHERAL_MASK 0x7C0
#define LPC_GPDMA_CONFIG2_DESTPERIPHERAL_BIT 6
#define LPC_GPDMA_CONFIG2_TRANSFERTYPE_MASK 0x3800
#define LPC_GPDMA_CONFIG2_TRANSFERTYPE_BIT 11
#define LPC_GPDMA_CONFIG2_IE_MASK 0x4000
#define LPC_GPDMA_CONFIG2_IE 0x4000
#define LPC_GPDMA_CONFIG2_IE_BIT 14
#define LPC_GPDMA_CONFIG2_ITC_MASK 0x8000
#define LPC_GPDMA_CONFIG2_ITC 0x8000
#define LPC_GPDMA_CONFIG2_ITC_BIT 15
#define LPC_GPDMA_CONFIG2_L_MASK 0x10000
#define LPC_GPDMA_CONFIG2_L 0x10000
#define LPC_GPDMA_CONFIG2_L_BIT 16
#define LPC_GPDMA_CONFIG2_A_MASK 0x20000
#define LPC_GPDMA_CONFIG2_A 0x20000
#define LPC_GPDMA_CONFIG2_A_BIT 17
#define LPC_GPDMA_CONFIG2_H_MASK 0x40000
#define LPC_GPDMA_CONFIG2_H 0x40000
#define LPC_GPDMA_CONFIG2_H_BIT 18

#define LPC_GPDMA_CONFIG3 (*(volatile unsigned long *)0x20080170)
#define LPC_GPDMA_CONFIG3_OFFSET 0x170
#define LPC_GPDMA_CONFIG3_E_MASK 0x1
#define LPC_GPDMA_CONFIG3_E 0x1
#define LPC_GPDMA_CONFIG3_E_BIT 0
#define LPC_GPDMA_CONFIG3_SRCPERIPHERAL_MASK 0x3E
#define LPC_GPDMA_CONFIG3_SRCPERIPHERAL_BIT 1
#define LPC_GPDMA_CONFIG3_DESTPERIPHERAL_MASK 0x7C0
#define LPC_GPDMA_CONFIG3_DESTPERIPHERAL_BIT 6
#define LPC_GPDMA_CONFIG3_TRANSFERTYPE_MASK 0x3800
#define LPC_GPDMA_CONFIG3_TRANSFERTYPE_BIT 11
#define LPC_GPDMA_CONFIG3_IE_MASK 0x4000
#define LPC_GPDMA_CONFIG3_IE 0x4000
#define LPC_GPDMA_CONFIG3_IE_BIT 14
#define LPC_GPDMA_CONFIG3_ITC_MASK 0x8000
#define LPC_GPDMA_CONFIG3_ITC 0x8000
#define LPC_GPDMA_CONFIG3_ITC_BIT 15
#define LPC_GPDMA_CONFIG3_L_MASK 0x10000
#define LPC_GPDMA_CONFIG3_L 0x10000
#define LPC_GPDMA_CONFIG3_L_BIT 16
#define LPC_GPDMA_CONFIG3_A_MASK 0x20000
#define LPC_GPDMA_CONFIG3_A 0x20000
#define LPC_GPDMA_CONFIG3_A_BIT 17
#define LPC_GPDMA_CONFIG3_H_MASK 0x40000
#define LPC_GPDMA_CONFIG3_H 0x40000
#define LPC_GPDMA_CONFIG3_H_BIT 18

#define LPC_GPDMA_CONFIG4 (*(volatile unsigned long *)0x20080190)
#define LPC_GPDMA_CONFIG4_OFFSET 0x190
#define LPC_GPDMA_CONFIG4_E_MASK 0x1
#define LPC_GPDMA_CONFIG4_E 0x1
#define LPC_GPDMA_CONFIG4_E_BIT 0
#define LPC_GPDMA_CONFIG4_SRCPERIPHERAL_MASK 0x3E
#define LPC_GPDMA_CONFIG4_SRCPERIPHERAL_BIT 1
#define LPC_GPDMA_CONFIG4_DESTPERIPHERAL_MASK 0x7C0
#define LPC_GPDMA_CONFIG4_DESTPERIPHERAL_BIT 6
#define LPC_GPDMA_CONFIG4_TRANSFERTYPE_MASK 0x3800
#define LPC_GPDMA_CONFIG4_TRANSFERTYPE_BIT 11
#define LPC_GPDMA_CONFIG4_IE_MASK 0x4000
#define LPC_GPDMA_CONFIG4_IE 0x4000
#define LPC_GPDMA_CONFIG4_IE_BIT 14
#define LPC_GPDMA_CONFIG4_ITC_MASK 0x8000
#define LPC_GPDMA_CONFIG4_ITC 0x8000
#define LPC_GPDMA_CONFIG4_ITC_BIT 15
#define LPC_GPDMA_CONFIG4_L_MASK 0x10000
#define LPC_GPDMA_CONFIG4_L 0x10000
#define LPC_GPDMA_CONFIG4_L_BIT 16
#define LPC_GPDMA_CONFIG4_A_MASK 0x20000
#define LPC_GPDMA_CONFIG4_A 0x20000
#define LPC_GPDMA_CONFIG4_A_BIT 17
#define LPC_GPDMA_CONFIG4_H_MASK 0x40000
#define LPC_GPDMA_CONFIG4_H 0x40000
#define LPC_GPDMA_CONFIG4_H_BIT 18

#define LPC_GPDMA_CONFIG5 (*(volatile unsigned long *)0x200801B0)
#define LPC_GPDMA_CONFIG5_OFFSET 0x1B0
#define LPC_GPDMA_CONFIG5_E_MASK 0x1
#define LPC_GPDMA_CONFIG5_E 0x1
#define LPC_GPDMA_CONFIG5_E_BIT 0
#define LPC_GPDMA_CONFIG5_SRCPERIPHERAL_MASK 0x3E
#define LPC_GPDMA_CONFIG5_SRCPERIPHERAL_BIT 1
#define LPC_GPDMA_CONFIG5_DESTPERIPHERAL_MASK 0x7C0
#define LPC_GPDMA_CONFIG5_DESTPERIPHERAL_BIT 6
#define LPC_GPDMA_CONFIG5_TRANSFERTYPE_MASK 0x3800
#define LPC_GPDMA_CONFIG5_TRANSFERTYPE_BIT 11
#define LPC_GPDMA_CONFIG5_IE_MASK 0x4000
#define LPC_GPDMA_CONFIG5_IE 0x4000
#define LPC_GPDMA_CONFIG5_IE_BIT 14
#define LPC_GPDMA_CONFIG5_ITC_MASK 0x8000
#define LPC_GPDMA_CONFIG5_ITC 0x8000
#define LPC_GPDMA_CONFIG5_ITC_BIT 15
#define LPC_GPDMA_CONFIG5_L_MASK 0x10000
#define LPC_GPDMA_CONFIG5_L 0x10000
#define LPC_GPDMA_CONFIG5_L_BIT 16
#define LPC_GPDMA_CONFIG5_A_MASK 0x20000
#define LPC_GPDMA_CONFIG5_A 0x20000
#define LPC_GPDMA_CONFIG5_A_BIT 17
#define LPC_GPDMA_CONFIG5_H_MASK 0x40000
#define LPC_GPDMA_CONFIG5_H 0x40000
#define LPC_GPDMA_CONFIG5_H_BIT 18

#define LPC_GPDMA_CONFIG6 (*(volatile unsigned long *)0x200801D0)
#define LPC_GPDMA_CONFIG6_OFFSET 0x1D0
#define LPC_GPDMA_CONFIG6_E_MASK 0x1
#define LPC_GPDMA_CONFIG6_E 0x1
#define LPC_GPDMA_CONFIG6_E_BIT 0
#define LPC_GPDMA_CONFIG6_SRCPERIPHERAL_MASK 0x3E
#define LPC_GPDMA_CONFIG6_SRCPERIPHERAL_BIT 1
#define LPC_GPDMA_CONFIG6_DESTPERIPHERAL_MASK 0x7C0
#define LPC_GPDMA_CONFIG6_DESTPERIPHERAL_BIT 6
#define LPC_GPDMA_CONFIG6_TRANSFERTYPE_MASK 0x3800
#define LPC_GPDMA_CONFIG6_TRANSFERTYPE_BIT 11
#define LPC_GPDMA_CONFIG6_IE_MASK 0x4000
#define LPC_GPDMA_CONFIG6_IE 0x4000
#define LPC_GPDMA_CONFIG6_IE_BIT 14
#define LPC_GPDMA_CONFIG6_ITC_MASK 0x8000
#define LPC_GPDMA_CONFIG6_ITC 0x8000
#define LPC_GPDMA_CONFIG6_ITC_BIT 15
#define LPC_GPDMA_CONFIG6_L_MASK 0x10000
#define LPC_GPDMA_CONFIG6_L 0x10000
#define LPC_GPDMA_CONFIG6_L_BIT 16
#define LPC_GPDMA_CONFIG6_A_MASK 0x20000
#define LPC_GPDMA_CONFIG6_A 0x20000
#define LPC_GPDMA_CONFIG6_A_BIT 17
#define LPC_GPDMA_CONFIG6_H_MASK 0x40000
#define LPC_GPDMA_CONFIG6_H 0x40000
#define LPC_GPDMA_CONFIG6_H_BIT 18

#define LPC_GPDMA_CONFIG7 (*(volatile unsigned long *)0x200801F0)
#define LPC_GPDMA_CONFIG7_OFFSET 0x1F0
#define LPC_GPDMA_CONFIG7_E_MASK 0x1
#define LPC_GPDMA_CONFIG7_E 0x1
#define LPC_GPDMA_CONFIG7_E_BIT 0
#define LPC_GPDMA_CONFIG7_SRCPERIPHERAL_MASK 0x3E
#define LPC_GPDMA_CONFIG7_SRCPERIPHERAL_BIT 1
#define LPC_GPDMA_CONFIG7_DESTPERIPHERAL_MASK 0x7C0
#define LPC_GPDMA_CONFIG7_DESTPERIPHERAL_BIT 6
#define LPC_GPDMA_CONFIG7_TRANSFERTYPE_MASK 0x3800
#define LPC_GPDMA_CONFIG7_TRANSFERTYPE_BIT 11
#define LPC_GPDMA_CONFIG7_IE_MASK 0x4000
#define LPC_GPDMA_CONFIG7_IE 0x4000
#define LPC_GPDMA_CONFIG7_IE_BIT 14
#define LPC_GPDMA_CONFIG7_ITC_MASK 0x8000
#define LPC_GPDMA_CONFIG7_ITC 0x8000
#define LPC_GPDMA_CONFIG7_ITC_BIT 15
#define LPC_GPDMA_CONFIG7_L_MASK 0x10000
#define LPC_GPDMA_CONFIG7_L 0x10000
#define LPC_GPDMA_CONFIG7_L_BIT 16
#define LPC_GPDMA_CONFIG7_A_MASK 0x20000
#define LPC_GPDMA_CONFIG7_A 0x20000
#define LPC_GPDMA_CONFIG7_A_BIT 17
#define LPC_GPDMA_CONFIG7_H_MASK 0x40000
#define LPC_GPDMA_CONFIG7_H 0x40000
#define LPC_GPDMA_CONFIG7_H_BIT 18

#ifndef LPC_ETHERNET_BASE_ADDRESS
#define LPC_ETHERNET_BASE_ADDRESS 0x20084000
#endif

#define LPC_ETHERNET_MAC1 (*(volatile unsigned long *)0x20084000)
#define LPC_ETHERNET_MAC1_OFFSET 0x0
#define LPC_ETHERNET_MAC1_RXENABLE_MASK 0x1
#define LPC_ETHERNET_MAC1_RXENABLE 0x1
#define LPC_ETHERNET_MAC1_RXENABLE_BIT 0
#define LPC_ETHERNET_MAC1_PARF_MASK 0x2
#define LPC_ETHERNET_MAC1_PARF 0x2
#define LPC_ETHERNET_MAC1_PARF_BIT 1
#define LPC_ETHERNET_MAC1_RXFLOWCTRL_MASK 0x4
#define LPC_ETHERNET_MAC1_RXFLOWCTRL 0x4
#define LPC_ETHERNET_MAC1_RXFLOWCTRL_BIT 2
#define LPC_ETHERNET_MAC1_TXFLOWCTRL_MASK 0x8
#define LPC_ETHERNET_MAC1_TXFLOWCTRL 0x8
#define LPC_ETHERNET_MAC1_TXFLOWCTRL_BIT 3
#define LPC_ETHERNET_MAC1_LOOPBACK_MASK 0x10
#define LPC_ETHERNET_MAC1_LOOPBACK 0x10
#define LPC_ETHERNET_MAC1_LOOPBACK_BIT 4
#define LPC_ETHERNET_MAC1_RESETTX_MASK 0x100
#define LPC_ETHERNET_MAC1_RESETTX 0x100
#define LPC_ETHERNET_MAC1_RESETTX_BIT 8
#define LPC_ETHERNET_MAC1_RESETMCSTX_MASK 0x200
#define LPC_ETHERNET_MAC1_RESETMCSTX 0x200
#define LPC_ETHERNET_MAC1_RESETMCSTX_BIT 9
#define LPC_ETHERNET_MAC1_RESETRX_MASK 0x400
#define LPC_ETHERNET_MAC1_RESETRX 0x400
#define LPC_ETHERNET_MAC1_RESETRX_BIT 10
#define LPC_ETHERNET_MAC1_RESETMCSRX_MASK 0x800
#define LPC_ETHERNET_MAC1_RESETMCSRX 0x800
#define LPC_ETHERNET_MAC1_RESETMCSRX_BIT 11
#define LPC_ETHERNET_MAC1_SIMRESET_MASK 0x4000
#define LPC_ETHERNET_MAC1_SIMRESET 0x4000
#define LPC_ETHERNET_MAC1_SIMRESET_BIT 14
#define LPC_ETHERNET_MAC1_SOFTRESET_MASK 0x8000
#define LPC_ETHERNET_MAC1_SOFTRESET 0x8000
#define LPC_ETHERNET_MAC1_SOFTRESET_BIT 15

#define LPC_ETHERNET_MAC2 (*(volatile unsigned long *)0x20084004)
#define LPC_ETHERNET_MAC2_OFFSET 0x4
#define LPC_ETHERNET_MAC2_FULLDUPLEX_MASK 0x1
#define LPC_ETHERNET_MAC2_FULLDUPLEX 0x1
#define LPC_ETHERNET_MAC2_FULLDUPLEX_BIT 0
#define LPC_ETHERNET_MAC2_FLC_MASK 0x2
#define LPC_ETHERNET_MAC2_FLC 0x2
#define LPC_ETHERNET_MAC2_FLC_BIT 1
#define LPC_ETHERNET_MAC2_HFEN_MASK 0x4
#define LPC_ETHERNET_MAC2_HFEN 0x4
#define LPC_ETHERNET_MAC2_HFEN_BIT 2
#define LPC_ETHERNET_MAC2_DELAYEDCRC_MASK 0x8
#define LPC_ETHERNET_MAC2_DELAYEDCRC 0x8
#define LPC_ETHERNET_MAC2_DELAYEDCRC_BIT 3
#define LPC_ETHERNET_MAC2_CRCEN_MASK 0x10
#define LPC_ETHERNET_MAC2_CRCEN 0x10
#define LPC_ETHERNET_MAC2_CRCEN_BIT 4
#define LPC_ETHERNET_MAC2_PADCRCEN_MASK 0x20
#define LPC_ETHERNET_MAC2_PADCRCEN 0x20
#define LPC_ETHERNET_MAC2_PADCRCEN_BIT 5
#define LPC_ETHERNET_MAC2_VLANPADEN_MASK 0x40
#define LPC_ETHERNET_MAC2_VLANPADEN 0x40
#define LPC_ETHERNET_MAC2_VLANPADEN_BIT 6
#define LPC_ETHERNET_MAC2_AUTODETPADEN_MASK 0x80
#define LPC_ETHERNET_MAC2_AUTODETPADEN 0x80
#define LPC_ETHERNET_MAC2_AUTODETPADEN_BIT 7
#define LPC_ETHERNET_MAC2_PPENF_MASK 0x100
#define LPC_ETHERNET_MAC2_PPENF 0x100
#define LPC_ETHERNET_MAC2_PPENF_BIT 8
#define LPC_ETHERNET_MAC2_LPENF_MASK 0x200
#define LPC_ETHERNET_MAC2_LPENF 0x200
#define LPC_ETHERNET_MAC2_LPENF_BIT 9
#define LPC_ETHERNET_MAC2_NOBACKOFF_MASK 0x1000
#define LPC_ETHERNET_MAC2_NOBACKOFF 0x1000
#define LPC_ETHERNET_MAC2_NOBACKOFF_BIT 12
#define LPC_ETHERNET_MAC2_BP_NOBACKOFF_MASK 0x2000
#define LPC_ETHERNET_MAC2_BP_NOBACKOFF 0x2000
#define LPC_ETHERNET_MAC2_BP_NOBACKOFF_BIT 13
#define LPC_ETHERNET_MAC2_EXCESSDEFER_MASK 0x4000
#define LPC_ETHERNET_MAC2_EXCESSDEFER 0x4000
#define LPC_ETHERNET_MAC2_EXCESSDEFER_BIT 14

#define LPC_ETHERNET_IPGT (*(volatile unsigned long *)0x20084008)
#define LPC_ETHERNET_IPGT_OFFSET 0x8
#define LPC_ETHERNET_IPGT_BTOBINTEGAP_MASK 0x7F
#define LPC_ETHERNET_IPGT_BTOBINTEGAP_BIT 0

#define LPC_ETHERNET_IPGR (*(volatile unsigned long *)0x2008400C)
#define LPC_ETHERNET_IPGR_OFFSET 0xC
#define LPC_ETHERNET_IPGR_NBTOBINTEGAP2_MASK 0x7F
#define LPC_ETHERNET_IPGR_NBTOBINTEGAP2_BIT 0
#define LPC_ETHERNET_IPGR_NBTOBINTEGAP1_MASK 0x7F00
#define LPC_ETHERNET_IPGR_NBTOBINTEGAP1_BIT 8

#define LPC_ETHERNET_CLRT (*(volatile unsigned long *)0x20084010)
#define LPC_ETHERNET_CLRT_OFFSET 0x10
#define LPC_ETHERNET_CLRT_RETRANSMAX_MASK 0xF
#define LPC_ETHERNET_CLRT_RETRANSMAX_BIT 0
#define LPC_ETHERNET_CLRT_COLLWIN_MASK 0x3F00
#define LPC_ETHERNET_CLRT_COLLWIN_BIT 8

#define LPC_ETHERNET_MAXF (*(volatile unsigned long *)0x20084014)
#define LPC_ETHERNET_MAXF_OFFSET 0x14
#define LPC_ETHERNET_MAXF_MAXFLEN_MASK 0xFFFF
#define LPC_ETHERNET_MAXF_MAXFLEN_BIT 0

#define LPC_ETHERNET_SUPP (*(volatile unsigned long *)0x20084018)
#define LPC_ETHERNET_SUPP_OFFSET 0x18
#define LPC_ETHERNET_SUPP_SPEED_MASK 0x100
#define LPC_ETHERNET_SUPP_SPEED 0x100
#define LPC_ETHERNET_SUPP_SPEED_BIT 8

#define LPC_ETHERNET_TEST (*(volatile unsigned long *)0x2008401C)
#define LPC_ETHERNET_TEST_OFFSET 0x1C
#define LPC_ETHERNET_TEST_SCPQ_MASK 0x1
#define LPC_ETHERNET_TEST_SCPQ 0x1
#define LPC_ETHERNET_TEST_SCPQ_BIT 0
#define LPC_ETHERNET_TEST_TESTPAUSE_MASK 0x2
#define LPC_ETHERNET_TEST_TESTPAUSE 0x2
#define LPC_ETHERNET_TEST_TESTPAUSE_BIT 1
#define LPC_ETHERNET_TEST_TESTBP_MASK 0x4
#define LPC_ETHERNET_TEST_TESTBP 0x4
#define LPC_ETHERNET_TEST_TESTBP_BIT 2

#define LPC_ETHERNET_MCFG (*(volatile unsigned long *)0x20084020)
#define LPC_ETHERNET_MCFG_OFFSET 0x20
#define LPC_ETHERNET_MCFG_SCANINC_MASK 0x1
#define LPC_ETHERNET_MCFG_SCANINC 0x1
#define LPC_ETHERNET_MCFG_SCANINC_BIT 0
#define LPC_ETHERNET_MCFG_SUPPPREAMBLE_MASK 0x2
#define LPC_ETHERNET_MCFG_SUPPPREAMBLE 0x2
#define LPC_ETHERNET_MCFG_SUPPPREAMBLE_BIT 1
#define LPC_ETHERNET_MCFG_CLOCKSEL_MASK 0x3C
#define LPC_ETHERNET_MCFG_CLOCKSEL_BIT 2
#define LPC_ETHERNET_MCFG_RESETMIIMGMT_MASK 0x8000
#define LPC_ETHERNET_MCFG_RESETMIIMGMT 0x8000
#define LPC_ETHERNET_MCFG_RESETMIIMGMT_BIT 15

#define LPC_ETHERNET_MCMD (*(volatile unsigned long *)0x20084024)
#define LPC_ETHERNET_MCMD_OFFSET 0x24
#define LPC_ETHERNET_MCMD_READ_MASK 0x1
#define LPC_ETHERNET_MCMD_READ 0x1
#define LPC_ETHERNET_MCMD_READ_BIT 0
#define LPC_ETHERNET_MCMD_SCAN_MASK 0x2
#define LPC_ETHERNET_MCMD_SCAN 0x2
#define LPC_ETHERNET_MCMD_SCAN_BIT 1

#define LPC_ETHERNET_MADR (*(volatile unsigned long *)0x20084028)
#define LPC_ETHERNET_MADR_OFFSET 0x28
#define LPC_ETHERNET_MADR_REGADDR_MASK 0x1F
#define LPC_ETHERNET_MADR_REGADDR_BIT 0
#define LPC_ETHERNET_MADR_PHYADDR_MASK 0x1F00
#define LPC_ETHERNET_MADR_PHYADDR_BIT 8

#define LPC_ETHERNET_MWTD (*(volatile unsigned long *)0x2008402C)
#define LPC_ETHERNET_MWTD_OFFSET 0x2C
#define LPC_ETHERNET_MWTD_WRITEDATA_MASK 0xFFFF
#define LPC_ETHERNET_MWTD_WRITEDATA_BIT 0

#define LPC_ETHERNET_MRDD (*(volatile unsigned long *)0x20084030)
#define LPC_ETHERNET_MRDD_OFFSET 0x30
#define LPC_ETHERNET_MRDD_READDATA_MASK 0xFFFF
#define LPC_ETHERNET_MRDD_READDATA_BIT 0

#define LPC_ETHERNET_MIND (*(volatile unsigned long *)0x20084034)
#define LPC_ETHERNET_MIND_OFFSET 0x34
#define LPC_ETHERNET_MIND_BUSY_MASK 0x1
#define LPC_ETHERNET_MIND_BUSY 0x1
#define LPC_ETHERNET_MIND_BUSY_BIT 0
#define LPC_ETHERNET_MIND_SCANNING_MASK 0x2
#define LPC_ETHERNET_MIND_SCANNING 0x2
#define LPC_ETHERNET_MIND_SCANNING_BIT 1
#define LPC_ETHERNET_MIND_NOTVALID_MASK 0x4
#define LPC_ETHERNET_MIND_NOTVALID 0x4
#define LPC_ETHERNET_MIND_NOTVALID_BIT 2
#define LPC_ETHERNET_MIND_MIILINKFAIL_MASK 0x8
#define LPC_ETHERNET_MIND_MIILINKFAIL 0x8
#define LPC_ETHERNET_MIND_MIILINKFAIL_BIT 3

#define LPC_ETHERNET_SA0 (*(volatile unsigned long *)0x20084040)
#define LPC_ETHERNET_SA0_OFFSET 0x40
#define LPC_ETHERNET_SA0_SADDR2_MASK 0xFF
#define LPC_ETHERNET_SA0_SADDR2_BIT 0
#define LPC_ETHERNET_SA0_SADDR1_MASK 0xFF00
#define LPC_ETHERNET_SA0_SADDR1_BIT 8

#define LPC_ETHERNET_SA1 (*(volatile unsigned long *)0x20084044)
#define LPC_ETHERNET_SA1_OFFSET 0x44
#define LPC_ETHERNET_SA1_SADDR4_MASK 0xFF
#define LPC_ETHERNET_SA1_SADDR4_BIT 0
#define LPC_ETHERNET_SA1_SADDR3_MASK 0xFF00
#define LPC_ETHERNET_SA1_SADDR3_BIT 8

#define LPC_ETHERNET_SA2 (*(volatile unsigned long *)0x20084048)
#define LPC_ETHERNET_SA2_OFFSET 0x48
#define LPC_ETHERNET_SA2_SADDR6_MASK 0xFF
#define LPC_ETHERNET_SA2_SADDR6_BIT 0
#define LPC_ETHERNET_SA2_SADDR5_MASK 0xFF00
#define LPC_ETHERNET_SA2_SADDR5_BIT 8

#define LPC_ETHERNET_COMMAND (*(volatile unsigned long *)0x20084100)
#define LPC_ETHERNET_COMMAND_OFFSET 0x100
#define LPC_ETHERNET_COMMAND_RXENABLE_MASK 0x1
#define LPC_ETHERNET_COMMAND_RXENABLE 0x1
#define LPC_ETHERNET_COMMAND_RXENABLE_BIT 0
#define LPC_ETHERNET_COMMAND_TXENABLE_MASK 0x2
#define LPC_ETHERNET_COMMAND_TXENABLE 0x2
#define LPC_ETHERNET_COMMAND_TXENABLE_BIT 1
#define LPC_ETHERNET_COMMAND_REGRESET_MASK 0x8
#define LPC_ETHERNET_COMMAND_REGRESET 0x8
#define LPC_ETHERNET_COMMAND_REGRESET_BIT 3
#define LPC_ETHERNET_COMMAND_TXRESET_MASK 0x10
#define LPC_ETHERNET_COMMAND_TXRESET 0x10
#define LPC_ETHERNET_COMMAND_TXRESET_BIT 4
#define LPC_ETHERNET_COMMAND_RXRESET_MASK 0x20
#define LPC_ETHERNET_COMMAND_RXRESET 0x20
#define LPC_ETHERNET_COMMAND_RXRESET_BIT 5
#define LPC_ETHERNET_COMMAND_PASSRUNTFRAME_MASK 0x40
#define LPC_ETHERNET_COMMAND_PASSRUNTFRAME 0x40
#define LPC_ETHERNET_COMMAND_PASSRUNTFRAME_BIT 6
#define LPC_ETHERNET_COMMAND_PASSRXFILTER_MASK 0x80
#define LPC_ETHERNET_COMMAND_PASSRXFILTER 0x80
#define LPC_ETHERNET_COMMAND_PASSRXFILTER_BIT 7
#define LPC_ETHERNET_COMMAND_TXFLOWCONTROL_MASK 0x100
#define LPC_ETHERNET_COMMAND_TXFLOWCONTROL 0x100
#define LPC_ETHERNET_COMMAND_TXFLOWCONTROL_BIT 8
#define LPC_ETHERNET_COMMAND_RMII_MASK 0x200
#define LPC_ETHERNET_COMMAND_RMII 0x200
#define LPC_ETHERNET_COMMAND_RMII_BIT 9
#define LPC_ETHERNET_COMMAND_FULLDUPLEX_MASK 0x400
#define LPC_ETHERNET_COMMAND_FULLDUPLEX 0x400
#define LPC_ETHERNET_COMMAND_FULLDUPLEX_BIT 10

#define LPC_ETHERNET_STATUS (*(volatile unsigned long *)0x20084104)
#define LPC_ETHERNET_STATUS_OFFSET 0x104
#define LPC_ETHERNET_STATUS_RXSTATUS_MASK 0x1
#define LPC_ETHERNET_STATUS_RXSTATUS 0x1
#define LPC_ETHERNET_STATUS_RXSTATUS_BIT 0
#define LPC_ETHERNET_STATUS_TXSTATUS_MASK 0x2
#define LPC_ETHERNET_STATUS_TXSTATUS 0x2
#define LPC_ETHERNET_STATUS_TXSTATUS_BIT 1

#define LPC_ETHERNET_RXDESCRIPTOR (*(volatile unsigned long *)0x20084108)
#define LPC_ETHERNET_RXDESCRIPTOR_OFFSET 0x108
#define LPC_ETHERNET_RXDESCRIPTOR_RXDESCRIPTOR_MASK 0xFFFFFFFC
#define LPC_ETHERNET_RXDESCRIPTOR_RXDESCRIPTOR_BIT 2

#define LPC_ETHERNET_RXSTATUS (*(volatile unsigned long *)0x2008410C)
#define LPC_ETHERNET_RXSTATUS_OFFSET 0x10C
#define LPC_ETHERNET_RXSTATUS_RXSTATUS_MASK 0xFFFFFFF8
#define LPC_ETHERNET_RXSTATUS_RXSTATUS_BIT 3

#define LPC_ETHERNET_RXDESCRIPTORNUMBER (*(volatile unsigned long *)0x20084110)
#define LPC_ETHERNET_RXDESCRIPTORNUMBER_OFFSET 0x110
#define LPC_ETHERNET_RXDESCRIPTORNUMBER_RXDESCRIPTORN_MASK 0xFFFF
#define LPC_ETHERNET_RXDESCRIPTORNUMBER_RXDESCRIPTORN_BIT 0

#define LPC_ETHERNET_RXPRODUCEINDEX (*(volatile unsigned long *)0x20084114)
#define LPC_ETHERNET_RXPRODUCEINDEX_OFFSET 0x114
#define LPC_ETHERNET_RXPRODUCEINDEX_RXPRODUCEIX_MASK 0xFFFF
#define LPC_ETHERNET_RXPRODUCEINDEX_RXPRODUCEIX_BIT 0

#define LPC_ETHERNET_RXCONSUMEINDEX (*(volatile unsigned long *)0x20084118)
#define LPC_ETHERNET_RXCONSUMEINDEX_OFFSET 0x118
#define LPC_ETHERNET_RXCONSUMEINDEX_RXCONSUMEIX_MASK 0xFFFF
#define LPC_ETHERNET_RXCONSUMEINDEX_RXCONSUMEIX_BIT 0

#define LPC_ETHERNET_TXDESCRIPTOR (*(volatile unsigned long *)0x2008411C)
#define LPC_ETHERNET_TXDESCRIPTOR_OFFSET 0x11C
#define LPC_ETHERNET_TXDESCRIPTOR_TXD_MASK 0xFFFFFFFC
#define LPC_ETHERNET_TXDESCRIPTOR_TXD_BIT 2

#define LPC_ETHERNET_TXSTATUS (*(volatile unsigned long *)0x20084120)
#define LPC_ETHERNET_TXSTATUS_OFFSET 0x120
#define LPC_ETHERNET_TXSTATUS_TXSTAT_MASK 0xFFFFFFFC
#define LPC_ETHERNET_TXSTATUS_TXSTAT_BIT 2

#define LPC_ETHERNET_TXDESCRIPTORNUMBER (*(volatile unsigned long *)0x20084124)
#define LPC_ETHERNET_TXDESCRIPTORNUMBER_OFFSET 0x124
#define LPC_ETHERNET_TXDESCRIPTORNUMBER_TXDN_MASK 0xFFFF
#define LPC_ETHERNET_TXDESCRIPTORNUMBER_TXDN_BIT 0

#define LPC_ETHERNET_TXPRODUCEINDEX (*(volatile unsigned long *)0x20084128)
#define LPC_ETHERNET_TXPRODUCEINDEX_OFFSET 0x128
#define LPC_ETHERNET_TXPRODUCEINDEX_TXPI_MASK 0xFFFF
#define LPC_ETHERNET_TXPRODUCEINDEX_TXPI_BIT 0

#define LPC_ETHERNET_TXCONSUMEINDEX (*(volatile unsigned long *)0x2008412C)
#define LPC_ETHERNET_TXCONSUMEINDEX_OFFSET 0x12C
#define LPC_ETHERNET_TXCONSUMEINDEX_TXCI_MASK 0xFFFF
#define LPC_ETHERNET_TXCONSUMEINDEX_TXCI_BIT 0

#define LPC_ETHERNET_TSV0 (*(volatile unsigned long *)0x20084158)
#define LPC_ETHERNET_TSV0_OFFSET 0x158
#define LPC_ETHERNET_TSV0_CRCERR_MASK 0x1
#define LPC_ETHERNET_TSV0_CRCERR 0x1
#define LPC_ETHERNET_TSV0_CRCERR_BIT 0
#define LPC_ETHERNET_TSV0_LCE_MASK 0x2
#define LPC_ETHERNET_TSV0_LCE 0x2
#define LPC_ETHERNET_TSV0_LCE_BIT 1
#define LPC_ETHERNET_TSV0_LOR_MASK 0x4
#define LPC_ETHERNET_TSV0_LOR 0x4
#define LPC_ETHERNET_TSV0_LOR_BIT 2
#define LPC_ETHERNET_TSV0_DONE_MASK 0x8
#define LPC_ETHERNET_TSV0_DONE 0x8
#define LPC_ETHERNET_TSV0_DONE_BIT 3
#define LPC_ETHERNET_TSV0_MULTICAST_MASK 0x10
#define LPC_ETHERNET_TSV0_MULTICAST 0x10
#define LPC_ETHERNET_TSV0_MULTICAST_BIT 4
#define LPC_ETHERNET_TSV0_BROADCAST_MASK 0x20
#define LPC_ETHERNET_TSV0_BROADCAST 0x20
#define LPC_ETHERNET_TSV0_BROADCAST_BIT 5
#define LPC_ETHERNET_TSV0_PACKETDEFER_MASK 0x40
#define LPC_ETHERNET_TSV0_PACKETDEFER 0x40
#define LPC_ETHERNET_TSV0_PACKETDEFER_BIT 6
#define LPC_ETHERNET_TSV0_EXDF_MASK 0x80
#define LPC_ETHERNET_TSV0_EXDF 0x80
#define LPC_ETHERNET_TSV0_EXDF_BIT 7
#define LPC_ETHERNET_TSV0_EXCOL_MASK 0x100
#define LPC_ETHERNET_TSV0_EXCOL 0x100
#define LPC_ETHERNET_TSV0_EXCOL_BIT 8
#define LPC_ETHERNET_TSV0_LCOL_MASK 0x200
#define LPC_ETHERNET_TSV0_LCOL 0x200
#define LPC_ETHERNET_TSV0_LCOL_BIT 9
#define LPC_ETHERNET_TSV0_GIANT_MASK 0x400
#define LPC_ETHERNET_TSV0_GIANT 0x400
#define LPC_ETHERNET_TSV0_GIANT_BIT 10
#define LPC_ETHERNET_TSV0_UNDERRUN_MASK 0x800
#define LPC_ETHERNET_TSV0_UNDERRUN 0x800
#define LPC_ETHERNET_TSV0_UNDERRUN_BIT 11
#define LPC_ETHERNET_TSV0_TOTALBYTES_MASK 0xFFFF000
#define LPC_ETHERNET_TSV0_TOTALBYTES_BIT 12
#define LPC_ETHERNET_TSV0_CONTROLFRAME_MASK 0x10000000
#define LPC_ETHERNET_TSV0_CONTROLFRAME 0x10000000
#define LPC_ETHERNET_TSV0_CONTROLFRAME_BIT 28
#define LPC_ETHERNET_TSV0_PAUSE_MASK 0x20000000
#define LPC_ETHERNET_TSV0_PAUSE 0x20000000
#define LPC_ETHERNET_TSV0_PAUSE_BIT 29
#define LPC_ETHERNET_TSV0_BACKPRESSURE_MASK 0x40000000
#define LPC_ETHERNET_TSV0_BACKPRESSURE 0x40000000
#define LPC_ETHERNET_TSV0_BACKPRESSURE_BIT 30
#define LPC_ETHERNET_TSV0_VLAN_MASK 0x80000000
#define LPC_ETHERNET_TSV0_VLAN 0x80000000
#define LPC_ETHERNET_TSV0_VLAN_BIT 31

#define LPC_ETHERNET_TSV1 (*(volatile unsigned long *)0x2008415C)
#define LPC_ETHERNET_TSV1_OFFSET 0x15C
#define LPC_ETHERNET_TSV1_TBC_MASK 0xFFFF
#define LPC_ETHERNET_TSV1_TBC_BIT 0
#define LPC_ETHERNET_TSV1_TCC_MASK 0xF0000
#define LPC_ETHERNET_TSV1_TCC_BIT 16

#define LPC_ETHERNET_RSV (*(volatile unsigned long *)0x20084160)
#define LPC_ETHERNET_RSV_OFFSET 0x160
#define LPC_ETHERNET_RSV_RBC_MASK 0xFFFF
#define LPC_ETHERNET_RSV_RBC_BIT 0
#define LPC_ETHERNET_RSV_PPI_MASK 0x10000
#define LPC_ETHERNET_RSV_PPI 0x10000
#define LPC_ETHERNET_RSV_PPI_BIT 16
#define LPC_ETHERNET_RSV_RXDVSEEN_MASK 0x20000
#define LPC_ETHERNET_RSV_RXDVSEEN 0x20000
#define LPC_ETHERNET_RSV_RXDVSEEN_BIT 17
#define LPC_ETHERNET_RSV_CESEEN_MASK 0x40000
#define LPC_ETHERNET_RSV_CESEEN 0x40000
#define LPC_ETHERNET_RSV_CESEEN_BIT 18
#define LPC_ETHERNET_RSV_RCV_MASK 0x80000
#define LPC_ETHERNET_RSV_RCV 0x80000
#define LPC_ETHERNET_RSV_RCV_BIT 19
#define LPC_ETHERNET_RSV_CRCERR_MASK 0x100000
#define LPC_ETHERNET_RSV_CRCERR 0x100000
#define LPC_ETHERNET_RSV_CRCERR_BIT 20
#define LPC_ETHERNET_RSV_LCERR_MASK 0x200000
#define LPC_ETHERNET_RSV_LCERR 0x200000
#define LPC_ETHERNET_RSV_LCERR_BIT 21
#define LPC_ETHERNET_RSV_LOR_MASK 0x400000
#define LPC_ETHERNET_RSV_LOR 0x400000
#define LPC_ETHERNET_RSV_LOR_BIT 22
#define LPC_ETHERNET_RSV_ROK_MASK 0x800000
#define LPC_ETHERNET_RSV_ROK 0x800000
#define LPC_ETHERNET_RSV_ROK_BIT 23
#define LPC_ETHERNET_RSV_MULTICAST_MASK 0x1000000
#define LPC_ETHERNET_RSV_MULTICAST 0x1000000
#define LPC_ETHERNET_RSV_MULTICAST_BIT 24
#define LPC_ETHERNET_RSV_BROADCAST_MASK 0x2000000
#define LPC_ETHERNET_RSV_BROADCAST 0x2000000
#define LPC_ETHERNET_RSV_BROADCAST_BIT 25
#define LPC_ETHERNET_RSV_DRIBBLENIBBLE_MASK 0x4000000
#define LPC_ETHERNET_RSV_DRIBBLENIBBLE 0x4000000
#define LPC_ETHERNET_RSV_DRIBBLENIBBLE_BIT 26
#define LPC_ETHERNET_RSV_CONTROLFRAME_MASK 0x8000000
#define LPC_ETHERNET_RSV_CONTROLFRAME 0x8000000
#define LPC_ETHERNET_RSV_CONTROLFRAME_BIT 27
#define LPC_ETHERNET_RSV_PAUSE_MASK 0x10000000
#define LPC_ETHERNET_RSV_PAUSE 0x10000000
#define LPC_ETHERNET_RSV_PAUSE_BIT 28
#define LPC_ETHERNET_RSV_UO_MASK 0x20000000
#define LPC_ETHERNET_RSV_UO 0x20000000
#define LPC_ETHERNET_RSV_UO_BIT 29
#define LPC_ETHERNET_RSV_VLAN_MASK 0x40000000
#define LPC_ETHERNET_RSV_VLAN 0x40000000
#define LPC_ETHERNET_RSV_VLAN_BIT 30

#define LPC_ETHERNET_FLOWCONTROLCOUNTER (*(volatile unsigned long *)0x20084170)
#define LPC_ETHERNET_FLOWCONTROLCOUNTER_OFFSET 0x170
#define LPC_ETHERNET_FLOWCONTROLCOUNTER_MC_MASK 0xFFFF
#define LPC_ETHERNET_FLOWCONTROLCOUNTER_MC_BIT 0
#define LPC_ETHERNET_FLOWCONTROLCOUNTER_PT_MASK 0xFFFF0000
#define LPC_ETHERNET_FLOWCONTROLCOUNTER_PT_BIT 16

#define LPC_ETHERNET_FLOWCONTROLSTATUS (*(volatile unsigned long *)0x20084174)
#define LPC_ETHERNET_FLOWCONTROLSTATUS_OFFSET 0x174
#define LPC_ETHERNET_FLOWCONTROLSTATUS_MCC_MASK 0xFFFF
#define LPC_ETHERNET_FLOWCONTROLSTATUS_MCC_BIT 0

#define LPC_ETHERNET_RXFILTERCTRL (*(volatile unsigned long *)0x20084200)
#define LPC_ETHERNET_RXFILTERCTRL_OFFSET 0x200
#define LPC_ETHERNET_RXFILTERCTRL_AUE_MASK 0x1
#define LPC_ETHERNET_RXFILTERCTRL_AUE 0x1
#define LPC_ETHERNET_RXFILTERCTRL_AUE_BIT 0
#define LPC_ETHERNET_RXFILTERCTRL_ABE_MASK 0x2
#define LPC_ETHERNET_RXFILTERCTRL_ABE 0x2
#define LPC_ETHERNET_RXFILTERCTRL_ABE_BIT 1
#define LPC_ETHERNET_RXFILTERCTRL_AME_MASK 0x4
#define LPC_ETHERNET_RXFILTERCTRL_AME 0x4
#define LPC_ETHERNET_RXFILTERCTRL_AME_BIT 2
#define LPC_ETHERNET_RXFILTERCTRL_AUHE_MASK 0x8
#define LPC_ETHERNET_RXFILTERCTRL_AUHE 0x8
#define LPC_ETHERNET_RXFILTERCTRL_AUHE_BIT 3
#define LPC_ETHERNET_RXFILTERCTRL_AMHE_MASK 0x10
#define LPC_ETHERNET_RXFILTERCTRL_AMHE 0x10
#define LPC_ETHERNET_RXFILTERCTRL_AMHE_BIT 4
#define LPC_ETHERNET_RXFILTERCTRL_APE_MASK 0x20
#define LPC_ETHERNET_RXFILTERCTRL_APE 0x20
#define LPC_ETHERNET_RXFILTERCTRL_APE_BIT 5
#define LPC_ETHERNET_RXFILTERCTRL_MPEW_MASK 0x1000
#define LPC_ETHERNET_RXFILTERCTRL_MPEW 0x1000
#define LPC_ETHERNET_RXFILTERCTRL_MPEW_BIT 12
#define LPC_ETHERNET_RXFILTERCTRL_RFEW_MASK 0x2000
#define LPC_ETHERNET_RXFILTERCTRL_RFEW 0x2000
#define LPC_ETHERNET_RXFILTERCTRL_RFEW_BIT 13

#define LPC_ETHERNET_RXFILTERWOLSTATUS (*(volatile unsigned long *)0x20084204)
#define LPC_ETHERNET_RXFILTERWOLSTATUS_OFFSET 0x204
#define LPC_ETHERNET_RXFILTERWOLSTATUS_AUW_MASK 0x1
#define LPC_ETHERNET_RXFILTERWOLSTATUS_AUW 0x1
#define LPC_ETHERNET_RXFILTERWOLSTATUS_AUW_BIT 0
#define LPC_ETHERNET_RXFILTERWOLSTATUS_ABW_MASK 0x2
#define LPC_ETHERNET_RXFILTERWOLSTATUS_ABW 0x2
#define LPC_ETHERNET_RXFILTERWOLSTATUS_ABW_BIT 1
#define LPC_ETHERNET_RXFILTERWOLSTATUS_AMW_MASK 0x4
#define LPC_ETHERNET_RXFILTERWOLSTATUS_AMW 0x4
#define LPC_ETHERNET_RXFILTERWOLSTATUS_AMW_BIT 2
#define LPC_ETHERNET_RXFILTERWOLSTATUS_AUHW_MASK 0x8
#define LPC_ETHERNET_RXFILTERWOLSTATUS_AUHW 0x8
#define LPC_ETHERNET_RXFILTERWOLSTATUS_AUHW_BIT 3
#define LPC_ETHERNET_RXFILTERWOLSTATUS_AMHW_MASK 0x10
#define LPC_ETHERNET_RXFILTERWOLSTATUS_AMHW 0x10
#define LPC_ETHERNET_RXFILTERWOLSTATUS_AMHW_BIT 4
#define LPC_ETHERNET_RXFILTERWOLSTATUS_APW_MASK 0x20
#define LPC_ETHERNET_RXFILTERWOLSTATUS_APW 0x20
#define LPC_ETHERNET_RXFILTERWOLSTATUS_APW_BIT 5
#define LPC_ETHERNET_RXFILTERWOLSTATUS_RFW_MASK 0x80
#define LPC_ETHERNET_RXFILTERWOLSTATUS_RFW 0x80
#define LPC_ETHERNET_RXFILTERWOLSTATUS_RFW_BIT 7
#define LPC_ETHERNET_RXFILTERWOLSTATUS_MPW_MASK 0x100
#define LPC_ETHERNET_RXFILTERWOLSTATUS_MPW 0x100
#define LPC_ETHERNET_RXFILTERWOLSTATUS_MPW_BIT 8

#define LPC_ETHERNET_RXFILTERWOLCLEAR (*(volatile unsigned long *)0x20084208)
#define LPC_ETHERNET_RXFILTERWOLCLEAR_OFFSET 0x208
#define LPC_ETHERNET_RXFILTERWOLCLEAR_AUWCLR_MASK 0x1
#define LPC_ETHERNET_RXFILTERWOLCLEAR_AUWCLR 0x1
#define LPC_ETHERNET_RXFILTERWOLCLEAR_AUWCLR_BIT 0
#define LPC_ETHERNET_RXFILTERWOLCLEAR_ABWCLR_MASK 0x2
#define LPC_ETHERNET_RXFILTERWOLCLEAR_ABWCLR 0x2
#define LPC_ETHERNET_RXFILTERWOLCLEAR_ABWCLR_BIT 1
#define LPC_ETHERNET_RXFILTERWOLCLEAR_AMWCLR_MASK 0x4
#define LPC_ETHERNET_RXFILTERWOLCLEAR_AMWCLR 0x4
#define LPC_ETHERNET_RXFILTERWOLCLEAR_AMWCLR_BIT 2
#define LPC_ETHERNET_RXFILTERWOLCLEAR_AUHWCLR_MASK 0x8
#define LPC_ETHERNET_RXFILTERWOLCLEAR_AUHWCLR 0x8
#define LPC_ETHERNET_RXFILTERWOLCLEAR_AUHWCLR_BIT 3
#define LPC_ETHERNET_RXFILTERWOLCLEAR_AMHWCLR_MASK 0x10
#define LPC_ETHERNET_RXFILTERWOLCLEAR_AMHWCLR 0x10
#define LPC_ETHERNET_RXFILTERWOLCLEAR_AMHWCLR_BIT 4
#define LPC_ETHERNET_RXFILTERWOLCLEAR_APWCLR_MASK 0x20
#define LPC_ETHERNET_RXFILTERWOLCLEAR_APWCLR 0x20
#define LPC_ETHERNET_RXFILTERWOLCLEAR_APWCLR_BIT 5
#define LPC_ETHERNET_RXFILTERWOLCLEAR_RFWCLR_MASK 0x80
#define LPC_ETHERNET_RXFILTERWOLCLEAR_RFWCLR 0x80
#define LPC_ETHERNET_RXFILTERWOLCLEAR_RFWCLR_BIT 7
#define LPC_ETHERNET_RXFILTERWOLCLEAR_MPWCLR_MASK 0x100
#define LPC_ETHERNET_RXFILTERWOLCLEAR_MPWCLR 0x100
#define LPC_ETHERNET_RXFILTERWOLCLEAR_MPWCLR_BIT 8

#define LPC_ETHERNET_HASHFILTERL (*(volatile unsigned long *)0x20084210)
#define LPC_ETHERNET_HASHFILTERL_OFFSET 0x210
#define LPC_ETHERNET_HASHFILTERL_HFL_MASK 0xFFFFFFFF
#define LPC_ETHERNET_HASHFILTERL_HFL_BIT 0

#define LPC_ETHERNET_HASHFILTERH (*(volatile unsigned long *)0x20084214)
#define LPC_ETHERNET_HASHFILTERH_OFFSET 0x214
#define LPC_ETHERNET_HASHFILTERH_HFH_MASK 0xFFFFFFFF
#define LPC_ETHERNET_HASHFILTERH_HFH_BIT 0

#define LPC_ETHERNET_INTSTATUS (*(volatile unsigned long *)0x20084FE0)
#define LPC_ETHERNET_INTSTATUS_OFFSET 0xFE0
#define LPC_ETHERNET_INTSTATUS_RXOVERRUNINT_MASK 0x1
#define LPC_ETHERNET_INTSTATUS_RXOVERRUNINT 0x1
#define LPC_ETHERNET_INTSTATUS_RXOVERRUNINT_BIT 0
#define LPC_ETHERNET_INTSTATUS_RXERRORINT_MASK 0x2
#define LPC_ETHERNET_INTSTATUS_RXERRORINT 0x2
#define LPC_ETHERNET_INTSTATUS_RXERRORINT_BIT 1
#define LPC_ETHERNET_INTSTATUS_RXFINISHEDINT_MASK 0x4
#define LPC_ETHERNET_INTSTATUS_RXFINISHEDINT 0x4
#define LPC_ETHERNET_INTSTATUS_RXFINISHEDINT_BIT 2
#define LPC_ETHERNET_INTSTATUS_RXDONEINT_MASK 0x8
#define LPC_ETHERNET_INTSTATUS_RXDONEINT 0x8
#define LPC_ETHERNET_INTSTATUS_RXDONEINT_BIT 3
#define LPC_ETHERNET_INTSTATUS_TXUNDERRUNINT_MASK 0x10
#define LPC_ETHERNET_INTSTATUS_TXUNDERRUNINT 0x10
#define LPC_ETHERNET_INTSTATUS_TXUNDERRUNINT_BIT 4
#define LPC_ETHERNET_INTSTATUS_TXERRORINT_MASK 0x20
#define LPC_ETHERNET_INTSTATUS_TXERRORINT 0x20
#define LPC_ETHERNET_INTSTATUS_TXERRORINT_BIT 5
#define LPC_ETHERNET_INTSTATUS_TXFINISHEDINT_MASK 0x40
#define LPC_ETHERNET_INTSTATUS_TXFINISHEDINT 0x40
#define LPC_ETHERNET_INTSTATUS_TXFINISHEDINT_BIT 6
#define LPC_ETHERNET_INTSTATUS_TXDONEINT_MASK 0x80
#define LPC_ETHERNET_INTSTATUS_TXDONEINT 0x80
#define LPC_ETHERNET_INTSTATUS_TXDONEINT_BIT 7
#define LPC_ETHERNET_INTSTATUS_SOFTINT_MASK 0x1000
#define LPC_ETHERNET_INTSTATUS_SOFTINT 0x1000
#define LPC_ETHERNET_INTSTATUS_SOFTINT_BIT 12
#define LPC_ETHERNET_INTSTATUS_WAKEUPINT_MASK 0x2000
#define LPC_ETHERNET_INTSTATUS_WAKEUPINT 0x2000
#define LPC_ETHERNET_INTSTATUS_WAKEUPINT_BIT 13

#define LPC_ETHERNET_INTENABLE (*(volatile unsigned long *)0x20084FE4)
#define LPC_ETHERNET_INTENABLE_OFFSET 0xFE4
#define LPC_ETHERNET_INTENABLE_RXOVERRUNINTEN_MASK 0x1
#define LPC_ETHERNET_INTENABLE_RXOVERRUNINTEN 0x1
#define LPC_ETHERNET_INTENABLE_RXOVERRUNINTEN_BIT 0
#define LPC_ETHERNET_INTENABLE_RXERRORINTEN_MASK 0x2
#define LPC_ETHERNET_INTENABLE_RXERRORINTEN 0x2
#define LPC_ETHERNET_INTENABLE_RXERRORINTEN_BIT 1
#define LPC_ETHERNET_INTENABLE_RXFINISHEDINTEN_MASK 0x4
#define LPC_ETHERNET_INTENABLE_RXFINISHEDINTEN 0x4
#define LPC_ETHERNET_INTENABLE_RXFINISHEDINTEN_BIT 2
#define LPC_ETHERNET_INTENABLE_RXDONEINTEN_MASK 0x8
#define LPC_ETHERNET_INTENABLE_RXDONEINTEN 0x8
#define LPC_ETHERNET_INTENABLE_RXDONEINTEN_BIT 3
#define LPC_ETHERNET_INTENABLE_TXUNDERRUNINTEN_MASK 0x10
#define LPC_ETHERNET_INTENABLE_TXUNDERRUNINTEN 0x10
#define LPC_ETHERNET_INTENABLE_TXUNDERRUNINTEN_BIT 4
#define LPC_ETHERNET_INTENABLE_TXERRORINTEN_MASK 0x20
#define LPC_ETHERNET_INTENABLE_TXERRORINTEN 0x20
#define LPC_ETHERNET_INTENABLE_TXERRORINTEN_BIT 5
#define LPC_ETHERNET_INTENABLE_TXFINISHEDINTEN_MASK 0x40
#define LPC_ETHERNET_INTENABLE_TXFINISHEDINTEN 0x40
#define LPC_ETHERNET_INTENABLE_TXFINISHEDINTEN_BIT 6
#define LPC_ETHERNET_INTENABLE_TXDONEINTEN_MASK 0x80
#define LPC_ETHERNET_INTENABLE_TXDONEINTEN 0x80
#define LPC_ETHERNET_INTENABLE_TXDONEINTEN_BIT 7
#define LPC_ETHERNET_INTENABLE_SOFTINTEN_MASK 0x1000
#define LPC_ETHERNET_INTENABLE_SOFTINTEN 0x1000
#define LPC_ETHERNET_INTENABLE_SOFTINTEN_BIT 12
#define LPC_ETHERNET_INTENABLE_WAKEUPINTEN_MASK 0x2000
#define LPC_ETHERNET_INTENABLE_WAKEUPINTEN 0x2000
#define LPC_ETHERNET_INTENABLE_WAKEUPINTEN_BIT 13

#define LPC_ETHERNET_INTCLEAR (*(volatile unsigned long *)0x20084FE8)
#define LPC_ETHERNET_INTCLEAR_OFFSET 0xFE8
#define LPC_ETHERNET_INTCLEAR_RXOVERRUNINTCLR_MASK 0x1
#define LPC_ETHERNET_INTCLEAR_RXOVERRUNINTCLR 0x1
#define LPC_ETHERNET_INTCLEAR_RXOVERRUNINTCLR_BIT 0
#define LPC_ETHERNET_INTCLEAR_RXERRORINTCLR_MASK 0x2
#define LPC_ETHERNET_INTCLEAR_RXERRORINTCLR 0x2
#define LPC_ETHERNET_INTCLEAR_RXERRORINTCLR_BIT 1
#define LPC_ETHERNET_INTCLEAR_RXFINISHEDINTCLR_MASK 0x4
#define LPC_ETHERNET_INTCLEAR_RXFINISHEDINTCLR 0x4
#define LPC_ETHERNET_INTCLEAR_RXFINISHEDINTCLR_BIT 2
#define LPC_ETHERNET_INTCLEAR_RXDONEINTCLR_MASK 0x8
#define LPC_ETHERNET_INTCLEAR_RXDONEINTCLR 0x8
#define LPC_ETHERNET_INTCLEAR_RXDONEINTCLR_BIT 3
#define LPC_ETHERNET_INTCLEAR_TXUNDERRUNINTCLR_MASK 0x10
#define LPC_ETHERNET_INTCLEAR_TXUNDERRUNINTCLR 0x10
#define LPC_ETHERNET_INTCLEAR_TXUNDERRUNINTCLR_BIT 4
#define LPC_ETHERNET_INTCLEAR_TXERRORINTCLR_MASK 0x20
#define LPC_ETHERNET_INTCLEAR_TXERRORINTCLR 0x20
#define LPC_ETHERNET_INTCLEAR_TXERRORINTCLR_BIT 5
#define LPC_ETHERNET_INTCLEAR_TXFINISHEDINTCLR_MASK 0x40
#define LPC_ETHERNET_INTCLEAR_TXFINISHEDINTCLR 0x40
#define LPC_ETHERNET_INTCLEAR_TXFINISHEDINTCLR_BIT 6
#define LPC_ETHERNET_INTCLEAR_TXDONEINTCLR_MASK 0x80
#define LPC_ETHERNET_INTCLEAR_TXDONEINTCLR 0x80
#define LPC_ETHERNET_INTCLEAR_TXDONEINTCLR_BIT 7
#define LPC_ETHERNET_INTCLEAR_SOFTINTCLR_MASK 0x1000
#define LPC_ETHERNET_INTCLEAR_SOFTINTCLR 0x1000
#define LPC_ETHERNET_INTCLEAR_SOFTINTCLR_BIT 12
#define LPC_ETHERNET_INTCLEAR_WAKEUPINTCLR_MASK 0x2000
#define LPC_ETHERNET_INTCLEAR_WAKEUPINTCLR 0x2000
#define LPC_ETHERNET_INTCLEAR_WAKEUPINTCLR_BIT 13

#define LPC_ETHERNET_INTSET (*(volatile unsigned long *)0x20084FEC)
#define LPC_ETHERNET_INTSET_OFFSET 0xFEC
#define LPC_ETHERNET_INTSET_RXOVERRUNINTSET_MASK 0x1
#define LPC_ETHERNET_INTSET_RXOVERRUNINTSET 0x1
#define LPC_ETHERNET_INTSET_RXOVERRUNINTSET_BIT 0
#define LPC_ETHERNET_INTSET_RXERRORINTSET_MASK 0x2
#define LPC_ETHERNET_INTSET_RXERRORINTSET 0x2
#define LPC_ETHERNET_INTSET_RXERRORINTSET_BIT 1
#define LPC_ETHERNET_INTSET_RXFINISHEDINTSET_MASK 0x4
#define LPC_ETHERNET_INTSET_RXFINISHEDINTSET 0x4
#define LPC_ETHERNET_INTSET_RXFINISHEDINTSET_BIT 2
#define LPC_ETHERNET_INTSET_RXDONEINTSET_MASK 0x8
#define LPC_ETHERNET_INTSET_RXDONEINTSET 0x8
#define LPC_ETHERNET_INTSET_RXDONEINTSET_BIT 3
#define LPC_ETHERNET_INTSET_TXUNDERRUNINTSET_MASK 0x10
#define LPC_ETHERNET_INTSET_TXUNDERRUNINTSET 0x10
#define LPC_ETHERNET_INTSET_TXUNDERRUNINTSET_BIT 4
#define LPC_ETHERNET_INTSET_TXERRORINTSET_MASK 0x20
#define LPC_ETHERNET_INTSET_TXERRORINTSET 0x20
#define LPC_ETHERNET_INTSET_TXERRORINTSET_BIT 5
#define LPC_ETHERNET_INTSET_TXFINISHEDINTSET_MASK 0x40
#define LPC_ETHERNET_INTSET_TXFINISHEDINTSET 0x40
#define LPC_ETHERNET_INTSET_TXFINISHEDINTSET_BIT 6
#define LPC_ETHERNET_INTSET_TXDONEINTSET_MASK 0x80
#define LPC_ETHERNET_INTSET_TXDONEINTSET 0x80
#define LPC_ETHERNET_INTSET_TXDONEINTSET_BIT 7
#define LPC_ETHERNET_INTSET_SOFTINTSET_MASK 0x1000
#define LPC_ETHERNET_INTSET_SOFTINTSET 0x1000
#define LPC_ETHERNET_INTSET_SOFTINTSET_BIT 12
#define LPC_ETHERNET_INTSET_WAKEUPINTSET_MASK 0x2000
#define LPC_ETHERNET_INTSET_WAKEUPINTSET 0x2000
#define LPC_ETHERNET_INTSET_WAKEUPINTSET_BIT 13

#define LPC_ETHERNET_POWERDOWN (*(volatile unsigned long *)0x20084FF4)
#define LPC_ETHERNET_POWERDOWN_OFFSET 0xFF4
#define LPC_ETHERNET_POWERDOWN_PD_MASK 0x80000000
#define LPC_ETHERNET_POWERDOWN_PD 0x80000000
#define LPC_ETHERNET_POWERDOWN_PD_BIT 31

#ifndef LPC_LCD_BASE_ADDRESS
#define LPC_LCD_BASE_ADDRESS 0x20088000
#endif

#define LPC_LCD_TIMH (*(volatile unsigned long *)0x20088000)
#define LPC_LCD_TIMH_OFFSET 0x0
#define LPC_LCD_TIMH_PPL_MASK 0xFC
#define LPC_LCD_TIMH_PPL_BIT 2
#define LPC_LCD_TIMH_HSW_MASK 0xFF00
#define LPC_LCD_TIMH_HSW_BIT 8
#define LPC_LCD_TIMH_HFP_MASK 0xFF0000
#define LPC_LCD_TIMH_HFP_BIT 16
#define LPC_LCD_TIMH_HBP_MASK 0xFF000000
#define LPC_LCD_TIMH_HBP_BIT 24

#define LPC_LCD_TIMV (*(volatile unsigned long *)0x20088004)
#define LPC_LCD_TIMV_OFFSET 0x4
#define LPC_LCD_TIMV_LPP_MASK 0x3FF
#define LPC_LCD_TIMV_LPP_BIT 0
#define LPC_LCD_TIMV_VSW_MASK 0xFC00
#define LPC_LCD_TIMV_VSW_BIT 10
#define LPC_LCD_TIMV_VFP_MASK 0xFF0000
#define LPC_LCD_TIMV_VFP_BIT 16
#define LPC_LCD_TIMV_VBP_MASK 0xFF000000
#define LPC_LCD_TIMV_VBP_BIT 24

#define LPC_LCD_POL (*(volatile unsigned long *)0x20088008)
#define LPC_LCD_POL_OFFSET 0x8
#define LPC_LCD_POL_PCD_LO_MASK 0x1F
#define LPC_LCD_POL_PCD_LO_BIT 0
#define LPC_LCD_POL_CLKSEL_MASK 0x20
#define LPC_LCD_POL_CLKSEL 0x20
#define LPC_LCD_POL_CLKSEL_BIT 5
#define LPC_LCD_POL_ACB_MASK 0x7C0
#define LPC_LCD_POL_ACB_BIT 6
#define LPC_LCD_POL_IVS_MASK 0x800
#define LPC_LCD_POL_IVS 0x800
#define LPC_LCD_POL_IVS_BIT 11
#define LPC_LCD_POL_IHS_MASK 0x1000
#define LPC_LCD_POL_IHS 0x1000
#define LPC_LCD_POL_IHS_BIT 12
#define LPC_LCD_POL_IPC_MASK 0x2000
#define LPC_LCD_POL_IPC 0x2000
#define LPC_LCD_POL_IPC_BIT 13
#define LPC_LCD_POL_IOE_MASK 0x4000
#define LPC_LCD_POL_IOE 0x4000
#define LPC_LCD_POL_IOE_BIT 14
#define LPC_LCD_POL_CPL_MASK 0x3FF0000
#define LPC_LCD_POL_CPL_BIT 16
#define LPC_LCD_POL_BCD_MASK 0x4000000
#define LPC_LCD_POL_BCD 0x4000000
#define LPC_LCD_POL_BCD_BIT 26
#define LPC_LCD_POL_PCD_HI_MASK 0xF8000000
#define LPC_LCD_POL_PCD_HI_BIT 27

#define LPC_LCD_LE (*(volatile unsigned long *)0x2008800C)
#define LPC_LCD_LE_OFFSET 0xC
#define LPC_LCD_LE_LED_MASK 0x7F
#define LPC_LCD_LE_LED_BIT 0
#define LPC_LCD_LE_LEE_MASK 0x10000
#define LPC_LCD_LE_LEE 0x10000
#define LPC_LCD_LE_LEE_BIT 16

#define LPC_LCD_UPBASE (*(volatile unsigned long *)0x20088010)
#define LPC_LCD_UPBASE_OFFSET 0x10
#define LPC_LCD_UPBASE_LCDUPBASE_MASK 0xFFFFFFF8
#define LPC_LCD_UPBASE_LCDUPBASE_BIT 3

#define LPC_LCD_LPBASE (*(volatile unsigned long *)0x20088014)
#define LPC_LCD_LPBASE_OFFSET 0x14
#define LPC_LCD_LPBASE_LCDLPBASE_MASK 0xFFFFFFF8
#define LPC_LCD_LPBASE_LCDLPBASE_BIT 3

#define LPC_LCD_CTRL (*(volatile unsigned long *)0x20088018)
#define LPC_LCD_CTRL_OFFSET 0x18
#define LPC_LCD_CTRL_LCDEN_MASK 0x1
#define LPC_LCD_CTRL_LCDEN 0x1
#define LPC_LCD_CTRL_LCDEN_BIT 0
#define LPC_LCD_CTRL_LCDBPP_MASK 0xE
#define LPC_LCD_CTRL_LCDBPP_BIT 1
#define LPC_LCD_CTRL_LCDBW_MASK 0x10
#define LPC_LCD_CTRL_LCDBW 0x10
#define LPC_LCD_CTRL_LCDBW_BIT 4
#define LPC_LCD_CTRL_LCDTFT_MASK 0x20
#define LPC_LCD_CTRL_LCDTFT 0x20
#define LPC_LCD_CTRL_LCDTFT_BIT 5
#define LPC_LCD_CTRL_LCDMONO8_MASK 0x40
#define LPC_LCD_CTRL_LCDMONO8 0x40
#define LPC_LCD_CTRL_LCDMONO8_BIT 6
#define LPC_LCD_CTRL_LCDDUAL_MASK 0x80
#define LPC_LCD_CTRL_LCDDUAL 0x80
#define LPC_LCD_CTRL_LCDDUAL_BIT 7
#define LPC_LCD_CTRL_BGR_MASK 0x100
#define LPC_LCD_CTRL_BGR 0x100
#define LPC_LCD_CTRL_BGR_BIT 8
#define LPC_LCD_CTRL_BEBO_MASK 0x200
#define LPC_LCD_CTRL_BEBO 0x200
#define LPC_LCD_CTRL_BEBO_BIT 9
#define LPC_LCD_CTRL_BEPO_MASK 0x400
#define LPC_LCD_CTRL_BEPO 0x400
#define LPC_LCD_CTRL_BEPO_BIT 10
#define LPC_LCD_CTRL_LCDPWR_MASK 0x800
#define LPC_LCD_CTRL_LCDPWR 0x800
#define LPC_LCD_CTRL_LCDPWR_BIT 11
#define LPC_LCD_CTRL_LCDVCOMP_MASK 0x3000
#define LPC_LCD_CTRL_LCDVCOMP_BIT 12
#define LPC_LCD_CTRL_WATERMARK_MASK 0x10000
#define LPC_LCD_CTRL_WATERMARK 0x10000
#define LPC_LCD_CTRL_WATERMARK_BIT 16

#define LPC_LCD_INTMSK (*(volatile unsigned long *)0x2008801C)
#define LPC_LCD_INTMSK_OFFSET 0x1C
#define LPC_LCD_INTMSK_FUFIM_MASK 0x2
#define LPC_LCD_INTMSK_FUFIM 0x2
#define LPC_LCD_INTMSK_FUFIM_BIT 1
#define LPC_LCD_INTMSK_LNBUIM_MASK 0x4
#define LPC_LCD_INTMSK_LNBUIM 0x4
#define LPC_LCD_INTMSK_LNBUIM_BIT 2
#define LPC_LCD_INTMSK_VCOMPIM_MASK 0x8
#define LPC_LCD_INTMSK_VCOMPIM 0x8
#define LPC_LCD_INTMSK_VCOMPIM_BIT 3
#define LPC_LCD_INTMSK_BERIM_MASK 0x10
#define LPC_LCD_INTMSK_BERIM 0x10
#define LPC_LCD_INTMSK_BERIM_BIT 4

#define LPC_LCD_INTRAW (*(volatile unsigned long *)0x20088020)
#define LPC_LCD_INTRAW_OFFSET 0x20
#define LPC_LCD_INTRAW_FUFRIS_MASK 0x2
#define LPC_LCD_INTRAW_FUFRIS 0x2
#define LPC_LCD_INTRAW_FUFRIS_BIT 1
#define LPC_LCD_INTRAW_LNBURIS_MASK 0x4
#define LPC_LCD_INTRAW_LNBURIS 0x4
#define LPC_LCD_INTRAW_LNBURIS_BIT 2
#define LPC_LCD_INTRAW_VCOMPRIS_MASK 0x8
#define LPC_LCD_INTRAW_VCOMPRIS 0x8
#define LPC_LCD_INTRAW_VCOMPRIS_BIT 3
#define LPC_LCD_INTRAW_BERRAW_MASK 0x10
#define LPC_LCD_INTRAW_BERRAW 0x10
#define LPC_LCD_INTRAW_BERRAW_BIT 4

#define LPC_LCD_INTSTAT (*(volatile unsigned long *)0x20088024)
#define LPC_LCD_INTSTAT_OFFSET 0x24
#define LPC_LCD_INTSTAT_FUFMIS_MASK 0x2
#define LPC_LCD_INTSTAT_FUFMIS 0x2
#define LPC_LCD_INTSTAT_FUFMIS_BIT 1
#define LPC_LCD_INTSTAT_LNBUMIS_MASK 0x4
#define LPC_LCD_INTSTAT_LNBUMIS 0x4
#define LPC_LCD_INTSTAT_LNBUMIS_BIT 2
#define LPC_LCD_INTSTAT_VCOMPMIS_MASK 0x8
#define LPC_LCD_INTSTAT_VCOMPMIS 0x8
#define LPC_LCD_INTSTAT_VCOMPMIS_BIT 3
#define LPC_LCD_INTSTAT_BERMIS_MASK 0x10
#define LPC_LCD_INTSTAT_BERMIS 0x10
#define LPC_LCD_INTSTAT_BERMIS_BIT 4

#define LPC_LCD_INTCLR (*(volatile unsigned long *)0x20088028)
#define LPC_LCD_INTCLR_OFFSET 0x28
#define LPC_LCD_INTCLR_FUFIC_MASK 0x2
#define LPC_LCD_INTCLR_FUFIC 0x2
#define LPC_LCD_INTCLR_FUFIC_BIT 1
#define LPC_LCD_INTCLR_LNBUIC_MASK 0x4
#define LPC_LCD_INTCLR_LNBUIC 0x4
#define LPC_LCD_INTCLR_LNBUIC_BIT 2
#define LPC_LCD_INTCLR_VCOMPIC_MASK 0x8
#define LPC_LCD_INTCLR_VCOMPIC 0x8
#define LPC_LCD_INTCLR_VCOMPIC_BIT 3
#define LPC_LCD_INTCLR_BERIC_MASK 0x10
#define LPC_LCD_INTCLR_BERIC 0x10
#define LPC_LCD_INTCLR_BERIC_BIT 4

#define LPC_LCD_UPCURR (*(volatile unsigned long *)0x2008802C)
#define LPC_LCD_UPCURR_OFFSET 0x2C
#define LPC_LCD_UPCURR_LCDUPCURR_MASK 0xFFFFFFFF
#define LPC_LCD_UPCURR_LCDUPCURR_BIT 0

#define LPC_LCD_LPCURR (*(volatile unsigned long *)0x20088030)
#define LPC_LCD_LPCURR_OFFSET 0x30
#define LPC_LCD_LPCURR_LCDLPCURR_MASK 0xFFFFFFFF
#define LPC_LCD_LPCURR_LCDLPCURR_BIT 0

#define LPC_LCD_PAL0 (*(volatile unsigned long *)0x20088200)
#define LPC_LCD_PAL0_OFFSET 0x200
#define LPC_LCD_PAL0_R04_0_MASK 0x1F
#define LPC_LCD_PAL0_R04_0_BIT 0
#define LPC_LCD_PAL0_G04_0_MASK 0x3E0
#define LPC_LCD_PAL0_G04_0_BIT 5
#define LPC_LCD_PAL0_B04_0_MASK 0x7C00
#define LPC_LCD_PAL0_B04_0_BIT 10
#define LPC_LCD_PAL0_I0_MASK 0x8000
#define LPC_LCD_PAL0_I0 0x8000
#define LPC_LCD_PAL0_I0_BIT 15
#define LPC_LCD_PAL0_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL0_R14_0_BIT 16
#define LPC_LCD_PAL0_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL0_G14_0_BIT 21
#define LPC_LCD_PAL0_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL0_B14_0_BIT 26
#define LPC_LCD_PAL0_I1_MASK 0x80000000
#define LPC_LCD_PAL0_I1 0x80000000
#define LPC_LCD_PAL0_I1_BIT 31

#define LPC_LCD_PAL1 (*(volatile unsigned long *)0x20088204)
#define LPC_LCD_PAL1_OFFSET 0x204
#define LPC_LCD_PAL1_R04_0_MASK 0x1F
#define LPC_LCD_PAL1_R04_0_BIT 0
#define LPC_LCD_PAL1_G04_0_MASK 0x3E0
#define LPC_LCD_PAL1_G04_0_BIT 5
#define LPC_LCD_PAL1_B04_0_MASK 0x7C00
#define LPC_LCD_PAL1_B04_0_BIT 10
#define LPC_LCD_PAL1_I0_MASK 0x8000
#define LPC_LCD_PAL1_I0 0x8000
#define LPC_LCD_PAL1_I0_BIT 15
#define LPC_LCD_PAL1_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL1_R14_0_BIT 16
#define LPC_LCD_PAL1_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL1_G14_0_BIT 21
#define LPC_LCD_PAL1_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL1_B14_0_BIT 26
#define LPC_LCD_PAL1_I1_MASK 0x80000000
#define LPC_LCD_PAL1_I1 0x80000000
#define LPC_LCD_PAL1_I1_BIT 31

#define LPC_LCD_PAL2 (*(volatile unsigned long *)0x20088208)
#define LPC_LCD_PAL2_OFFSET 0x208
#define LPC_LCD_PAL2_R04_0_MASK 0x1F
#define LPC_LCD_PAL2_R04_0_BIT 0
#define LPC_LCD_PAL2_G04_0_MASK 0x3E0
#define LPC_LCD_PAL2_G04_0_BIT 5
#define LPC_LCD_PAL2_B04_0_MASK 0x7C00
#define LPC_LCD_PAL2_B04_0_BIT 10
#define LPC_LCD_PAL2_I0_MASK 0x8000
#define LPC_LCD_PAL2_I0 0x8000
#define LPC_LCD_PAL2_I0_BIT 15
#define LPC_LCD_PAL2_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL2_R14_0_BIT 16
#define LPC_LCD_PAL2_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL2_G14_0_BIT 21
#define LPC_LCD_PAL2_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL2_B14_0_BIT 26
#define LPC_LCD_PAL2_I1_MASK 0x80000000
#define LPC_LCD_PAL2_I1 0x80000000
#define LPC_LCD_PAL2_I1_BIT 31

#define LPC_LCD_PAL3 (*(volatile unsigned long *)0x2008820C)
#define LPC_LCD_PAL3_OFFSET 0x20C
#define LPC_LCD_PAL3_R04_0_MASK 0x1F
#define LPC_LCD_PAL3_R04_0_BIT 0
#define LPC_LCD_PAL3_G04_0_MASK 0x3E0
#define LPC_LCD_PAL3_G04_0_BIT 5
#define LPC_LCD_PAL3_B04_0_MASK 0x7C00
#define LPC_LCD_PAL3_B04_0_BIT 10
#define LPC_LCD_PAL3_I0_MASK 0x8000
#define LPC_LCD_PAL3_I0 0x8000
#define LPC_LCD_PAL3_I0_BIT 15
#define LPC_LCD_PAL3_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL3_R14_0_BIT 16
#define LPC_LCD_PAL3_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL3_G14_0_BIT 21
#define LPC_LCD_PAL3_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL3_B14_0_BIT 26
#define LPC_LCD_PAL3_I1_MASK 0x80000000
#define LPC_LCD_PAL3_I1 0x80000000
#define LPC_LCD_PAL3_I1_BIT 31

#define LPC_LCD_PAL4 (*(volatile unsigned long *)0x20088210)
#define LPC_LCD_PAL4_OFFSET 0x210
#define LPC_LCD_PAL4_R04_0_MASK 0x1F
#define LPC_LCD_PAL4_R04_0_BIT 0
#define LPC_LCD_PAL4_G04_0_MASK 0x3E0
#define LPC_LCD_PAL4_G04_0_BIT 5
#define LPC_LCD_PAL4_B04_0_MASK 0x7C00
#define LPC_LCD_PAL4_B04_0_BIT 10
#define LPC_LCD_PAL4_I0_MASK 0x8000
#define LPC_LCD_PAL4_I0 0x8000
#define LPC_LCD_PAL4_I0_BIT 15
#define LPC_LCD_PAL4_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL4_R14_0_BIT 16
#define LPC_LCD_PAL4_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL4_G14_0_BIT 21
#define LPC_LCD_PAL4_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL4_B14_0_BIT 26
#define LPC_LCD_PAL4_I1_MASK 0x80000000
#define LPC_LCD_PAL4_I1 0x80000000
#define LPC_LCD_PAL4_I1_BIT 31

#define LPC_LCD_PAL5 (*(volatile unsigned long *)0x20088214)
#define LPC_LCD_PAL5_OFFSET 0x214
#define LPC_LCD_PAL5_R04_0_MASK 0x1F
#define LPC_LCD_PAL5_R04_0_BIT 0
#define LPC_LCD_PAL5_G04_0_MASK 0x3E0
#define LPC_LCD_PAL5_G04_0_BIT 5
#define LPC_LCD_PAL5_B04_0_MASK 0x7C00
#define LPC_LCD_PAL5_B04_0_BIT 10
#define LPC_LCD_PAL5_I0_MASK 0x8000
#define LPC_LCD_PAL5_I0 0x8000
#define LPC_LCD_PAL5_I0_BIT 15
#define LPC_LCD_PAL5_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL5_R14_0_BIT 16
#define LPC_LCD_PAL5_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL5_G14_0_BIT 21
#define LPC_LCD_PAL5_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL5_B14_0_BIT 26
#define LPC_LCD_PAL5_I1_MASK 0x80000000
#define LPC_LCD_PAL5_I1 0x80000000
#define LPC_LCD_PAL5_I1_BIT 31

#define LPC_LCD_PAL6 (*(volatile unsigned long *)0x20088218)
#define LPC_LCD_PAL6_OFFSET 0x218
#define LPC_LCD_PAL6_R04_0_MASK 0x1F
#define LPC_LCD_PAL6_R04_0_BIT 0
#define LPC_LCD_PAL6_G04_0_MASK 0x3E0
#define LPC_LCD_PAL6_G04_0_BIT 5
#define LPC_LCD_PAL6_B04_0_MASK 0x7C00
#define LPC_LCD_PAL6_B04_0_BIT 10
#define LPC_LCD_PAL6_I0_MASK 0x8000
#define LPC_LCD_PAL6_I0 0x8000
#define LPC_LCD_PAL6_I0_BIT 15
#define LPC_LCD_PAL6_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL6_R14_0_BIT 16
#define LPC_LCD_PAL6_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL6_G14_0_BIT 21
#define LPC_LCD_PAL6_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL6_B14_0_BIT 26
#define LPC_LCD_PAL6_I1_MASK 0x80000000
#define LPC_LCD_PAL6_I1 0x80000000
#define LPC_LCD_PAL6_I1_BIT 31

#define LPC_LCD_PAL7 (*(volatile unsigned long *)0x2008821C)
#define LPC_LCD_PAL7_OFFSET 0x21C
#define LPC_LCD_PAL7_R04_0_MASK 0x1F
#define LPC_LCD_PAL7_R04_0_BIT 0
#define LPC_LCD_PAL7_G04_0_MASK 0x3E0
#define LPC_LCD_PAL7_G04_0_BIT 5
#define LPC_LCD_PAL7_B04_0_MASK 0x7C00
#define LPC_LCD_PAL7_B04_0_BIT 10
#define LPC_LCD_PAL7_I0_MASK 0x8000
#define LPC_LCD_PAL7_I0 0x8000
#define LPC_LCD_PAL7_I0_BIT 15
#define LPC_LCD_PAL7_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL7_R14_0_BIT 16
#define LPC_LCD_PAL7_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL7_G14_0_BIT 21
#define LPC_LCD_PAL7_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL7_B14_0_BIT 26
#define LPC_LCD_PAL7_I1_MASK 0x80000000
#define LPC_LCD_PAL7_I1 0x80000000
#define LPC_LCD_PAL7_I1_BIT 31

#define LPC_LCD_PAL8 (*(volatile unsigned long *)0x20088220)
#define LPC_LCD_PAL8_OFFSET 0x220
#define LPC_LCD_PAL8_R04_0_MASK 0x1F
#define LPC_LCD_PAL8_R04_0_BIT 0
#define LPC_LCD_PAL8_G04_0_MASK 0x3E0
#define LPC_LCD_PAL8_G04_0_BIT 5
#define LPC_LCD_PAL8_B04_0_MASK 0x7C00
#define LPC_LCD_PAL8_B04_0_BIT 10
#define LPC_LCD_PAL8_I0_MASK 0x8000
#define LPC_LCD_PAL8_I0 0x8000
#define LPC_LCD_PAL8_I0_BIT 15
#define LPC_LCD_PAL8_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL8_R14_0_BIT 16
#define LPC_LCD_PAL8_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL8_G14_0_BIT 21
#define LPC_LCD_PAL8_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL8_B14_0_BIT 26
#define LPC_LCD_PAL8_I1_MASK 0x80000000
#define LPC_LCD_PAL8_I1 0x80000000
#define LPC_LCD_PAL8_I1_BIT 31

#define LPC_LCD_PAL9 (*(volatile unsigned long *)0x20088224)
#define LPC_LCD_PAL9_OFFSET 0x224
#define LPC_LCD_PAL9_R04_0_MASK 0x1F
#define LPC_LCD_PAL9_R04_0_BIT 0
#define LPC_LCD_PAL9_G04_0_MASK 0x3E0
#define LPC_LCD_PAL9_G04_0_BIT 5
#define LPC_LCD_PAL9_B04_0_MASK 0x7C00
#define LPC_LCD_PAL9_B04_0_BIT 10
#define LPC_LCD_PAL9_I0_MASK 0x8000
#define LPC_LCD_PAL9_I0 0x8000
#define LPC_LCD_PAL9_I0_BIT 15
#define LPC_LCD_PAL9_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL9_R14_0_BIT 16
#define LPC_LCD_PAL9_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL9_G14_0_BIT 21
#define LPC_LCD_PAL9_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL9_B14_0_BIT 26
#define LPC_LCD_PAL9_I1_MASK 0x80000000
#define LPC_LCD_PAL9_I1 0x80000000
#define LPC_LCD_PAL9_I1_BIT 31

#define LPC_LCD_PAL10 (*(volatile unsigned long *)0x20088228)
#define LPC_LCD_PAL10_OFFSET 0x228
#define LPC_LCD_PAL10_R04_0_MASK 0x1F
#define LPC_LCD_PAL10_R04_0_BIT 0
#define LPC_LCD_PAL10_G04_0_MASK 0x3E0
#define LPC_LCD_PAL10_G04_0_BIT 5
#define LPC_LCD_PAL10_B04_0_MASK 0x7C00
#define LPC_LCD_PAL10_B04_0_BIT 10
#define LPC_LCD_PAL10_I0_MASK 0x8000
#define LPC_LCD_PAL10_I0 0x8000
#define LPC_LCD_PAL10_I0_BIT 15
#define LPC_LCD_PAL10_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL10_R14_0_BIT 16
#define LPC_LCD_PAL10_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL10_G14_0_BIT 21
#define LPC_LCD_PAL10_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL10_B14_0_BIT 26
#define LPC_LCD_PAL10_I1_MASK 0x80000000
#define LPC_LCD_PAL10_I1 0x80000000
#define LPC_LCD_PAL10_I1_BIT 31

#define LPC_LCD_PAL11 (*(volatile unsigned long *)0x2008822C)
#define LPC_LCD_PAL11_OFFSET 0x22C
#define LPC_LCD_PAL11_R04_0_MASK 0x1F
#define LPC_LCD_PAL11_R04_0_BIT 0
#define LPC_LCD_PAL11_G04_0_MASK 0x3E0
#define LPC_LCD_PAL11_G04_0_BIT 5
#define LPC_LCD_PAL11_B04_0_MASK 0x7C00
#define LPC_LCD_PAL11_B04_0_BIT 10
#define LPC_LCD_PAL11_I0_MASK 0x8000
#define LPC_LCD_PAL11_I0 0x8000
#define LPC_LCD_PAL11_I0_BIT 15
#define LPC_LCD_PAL11_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL11_R14_0_BIT 16
#define LPC_LCD_PAL11_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL11_G14_0_BIT 21
#define LPC_LCD_PAL11_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL11_B14_0_BIT 26
#define LPC_LCD_PAL11_I1_MASK 0x80000000
#define LPC_LCD_PAL11_I1 0x80000000
#define LPC_LCD_PAL11_I1_BIT 31

#define LPC_LCD_PAL12 (*(volatile unsigned long *)0x20088230)
#define LPC_LCD_PAL12_OFFSET 0x230
#define LPC_LCD_PAL12_R04_0_MASK 0x1F
#define LPC_LCD_PAL12_R04_0_BIT 0
#define LPC_LCD_PAL12_G04_0_MASK 0x3E0
#define LPC_LCD_PAL12_G04_0_BIT 5
#define LPC_LCD_PAL12_B04_0_MASK 0x7C00
#define LPC_LCD_PAL12_B04_0_BIT 10
#define LPC_LCD_PAL12_I0_MASK 0x8000
#define LPC_LCD_PAL12_I0 0x8000
#define LPC_LCD_PAL12_I0_BIT 15
#define LPC_LCD_PAL12_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL12_R14_0_BIT 16
#define LPC_LCD_PAL12_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL12_G14_0_BIT 21
#define LPC_LCD_PAL12_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL12_B14_0_BIT 26
#define LPC_LCD_PAL12_I1_MASK 0x80000000
#define LPC_LCD_PAL12_I1 0x80000000
#define LPC_LCD_PAL12_I1_BIT 31

#define LPC_LCD_PAL13 (*(volatile unsigned long *)0x20088234)
#define LPC_LCD_PAL13_OFFSET 0x234
#define LPC_LCD_PAL13_R04_0_MASK 0x1F
#define LPC_LCD_PAL13_R04_0_BIT 0
#define LPC_LCD_PAL13_G04_0_MASK 0x3E0
#define LPC_LCD_PAL13_G04_0_BIT 5
#define LPC_LCD_PAL13_B04_0_MASK 0x7C00
#define LPC_LCD_PAL13_B04_0_BIT 10
#define LPC_LCD_PAL13_I0_MASK 0x8000
#define LPC_LCD_PAL13_I0 0x8000
#define LPC_LCD_PAL13_I0_BIT 15
#define LPC_LCD_PAL13_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL13_R14_0_BIT 16
#define LPC_LCD_PAL13_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL13_G14_0_BIT 21
#define LPC_LCD_PAL13_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL13_B14_0_BIT 26
#define LPC_LCD_PAL13_I1_MASK 0x80000000
#define LPC_LCD_PAL13_I1 0x80000000
#define LPC_LCD_PAL13_I1_BIT 31

#define LPC_LCD_PAL14 (*(volatile unsigned long *)0x20088238)
#define LPC_LCD_PAL14_OFFSET 0x238
#define LPC_LCD_PAL14_R04_0_MASK 0x1F
#define LPC_LCD_PAL14_R04_0_BIT 0
#define LPC_LCD_PAL14_G04_0_MASK 0x3E0
#define LPC_LCD_PAL14_G04_0_BIT 5
#define LPC_LCD_PAL14_B04_0_MASK 0x7C00
#define LPC_LCD_PAL14_B04_0_BIT 10
#define LPC_LCD_PAL14_I0_MASK 0x8000
#define LPC_LCD_PAL14_I0 0x8000
#define LPC_LCD_PAL14_I0_BIT 15
#define LPC_LCD_PAL14_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL14_R14_0_BIT 16
#define LPC_LCD_PAL14_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL14_G14_0_BIT 21
#define LPC_LCD_PAL14_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL14_B14_0_BIT 26
#define LPC_LCD_PAL14_I1_MASK 0x80000000
#define LPC_LCD_PAL14_I1 0x80000000
#define LPC_LCD_PAL14_I1_BIT 31

#define LPC_LCD_PAL15 (*(volatile unsigned long *)0x2008823C)
#define LPC_LCD_PAL15_OFFSET 0x23C
#define LPC_LCD_PAL15_R04_0_MASK 0x1F
#define LPC_LCD_PAL15_R04_0_BIT 0
#define LPC_LCD_PAL15_G04_0_MASK 0x3E0
#define LPC_LCD_PAL15_G04_0_BIT 5
#define LPC_LCD_PAL15_B04_0_MASK 0x7C00
#define LPC_LCD_PAL15_B04_0_BIT 10
#define LPC_LCD_PAL15_I0_MASK 0x8000
#define LPC_LCD_PAL15_I0 0x8000
#define LPC_LCD_PAL15_I0_BIT 15
#define LPC_LCD_PAL15_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL15_R14_0_BIT 16
#define LPC_LCD_PAL15_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL15_G14_0_BIT 21
#define LPC_LCD_PAL15_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL15_B14_0_BIT 26
#define LPC_LCD_PAL15_I1_MASK 0x80000000
#define LPC_LCD_PAL15_I1 0x80000000
#define LPC_LCD_PAL15_I1_BIT 31

#define LPC_LCD_PAL16 (*(volatile unsigned long *)0x20088240)
#define LPC_LCD_PAL16_OFFSET 0x240
#define LPC_LCD_PAL16_R04_0_MASK 0x1F
#define LPC_LCD_PAL16_R04_0_BIT 0
#define LPC_LCD_PAL16_G04_0_MASK 0x3E0
#define LPC_LCD_PAL16_G04_0_BIT 5
#define LPC_LCD_PAL16_B04_0_MASK 0x7C00
#define LPC_LCD_PAL16_B04_0_BIT 10
#define LPC_LCD_PAL16_I0_MASK 0x8000
#define LPC_LCD_PAL16_I0 0x8000
#define LPC_LCD_PAL16_I0_BIT 15
#define LPC_LCD_PAL16_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL16_R14_0_BIT 16
#define LPC_LCD_PAL16_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL16_G14_0_BIT 21
#define LPC_LCD_PAL16_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL16_B14_0_BIT 26
#define LPC_LCD_PAL16_I1_MASK 0x80000000
#define LPC_LCD_PAL16_I1 0x80000000
#define LPC_LCD_PAL16_I1_BIT 31

#define LPC_LCD_PAL17 (*(volatile unsigned long *)0x20088244)
#define LPC_LCD_PAL17_OFFSET 0x244
#define LPC_LCD_PAL17_R04_0_MASK 0x1F
#define LPC_LCD_PAL17_R04_0_BIT 0
#define LPC_LCD_PAL17_G04_0_MASK 0x3E0
#define LPC_LCD_PAL17_G04_0_BIT 5
#define LPC_LCD_PAL17_B04_0_MASK 0x7C00
#define LPC_LCD_PAL17_B04_0_BIT 10
#define LPC_LCD_PAL17_I0_MASK 0x8000
#define LPC_LCD_PAL17_I0 0x8000
#define LPC_LCD_PAL17_I0_BIT 15
#define LPC_LCD_PAL17_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL17_R14_0_BIT 16
#define LPC_LCD_PAL17_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL17_G14_0_BIT 21
#define LPC_LCD_PAL17_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL17_B14_0_BIT 26
#define LPC_LCD_PAL17_I1_MASK 0x80000000
#define LPC_LCD_PAL17_I1 0x80000000
#define LPC_LCD_PAL17_I1_BIT 31

#define LPC_LCD_PAL18 (*(volatile unsigned long *)0x20088248)
#define LPC_LCD_PAL18_OFFSET 0x248
#define LPC_LCD_PAL18_R04_0_MASK 0x1F
#define LPC_LCD_PAL18_R04_0_BIT 0
#define LPC_LCD_PAL18_G04_0_MASK 0x3E0
#define LPC_LCD_PAL18_G04_0_BIT 5
#define LPC_LCD_PAL18_B04_0_MASK 0x7C00
#define LPC_LCD_PAL18_B04_0_BIT 10
#define LPC_LCD_PAL18_I0_MASK 0x8000
#define LPC_LCD_PAL18_I0 0x8000
#define LPC_LCD_PAL18_I0_BIT 15
#define LPC_LCD_PAL18_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL18_R14_0_BIT 16
#define LPC_LCD_PAL18_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL18_G14_0_BIT 21
#define LPC_LCD_PAL18_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL18_B14_0_BIT 26
#define LPC_LCD_PAL18_I1_MASK 0x80000000
#define LPC_LCD_PAL18_I1 0x80000000
#define LPC_LCD_PAL18_I1_BIT 31

#define LPC_LCD_PAL19 (*(volatile unsigned long *)0x2008824C)
#define LPC_LCD_PAL19_OFFSET 0x24C
#define LPC_LCD_PAL19_R04_0_MASK 0x1F
#define LPC_LCD_PAL19_R04_0_BIT 0
#define LPC_LCD_PAL19_G04_0_MASK 0x3E0
#define LPC_LCD_PAL19_G04_0_BIT 5
#define LPC_LCD_PAL19_B04_0_MASK 0x7C00
#define LPC_LCD_PAL19_B04_0_BIT 10
#define LPC_LCD_PAL19_I0_MASK 0x8000
#define LPC_LCD_PAL19_I0 0x8000
#define LPC_LCD_PAL19_I0_BIT 15
#define LPC_LCD_PAL19_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL19_R14_0_BIT 16
#define LPC_LCD_PAL19_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL19_G14_0_BIT 21
#define LPC_LCD_PAL19_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL19_B14_0_BIT 26
#define LPC_LCD_PAL19_I1_MASK 0x80000000
#define LPC_LCD_PAL19_I1 0x80000000
#define LPC_LCD_PAL19_I1_BIT 31

#define LPC_LCD_PAL20 (*(volatile unsigned long *)0x20088250)
#define LPC_LCD_PAL20_OFFSET 0x250
#define LPC_LCD_PAL20_R04_0_MASK 0x1F
#define LPC_LCD_PAL20_R04_0_BIT 0
#define LPC_LCD_PAL20_G04_0_MASK 0x3E0
#define LPC_LCD_PAL20_G04_0_BIT 5
#define LPC_LCD_PAL20_B04_0_MASK 0x7C00
#define LPC_LCD_PAL20_B04_0_BIT 10
#define LPC_LCD_PAL20_I0_MASK 0x8000
#define LPC_LCD_PAL20_I0 0x8000
#define LPC_LCD_PAL20_I0_BIT 15
#define LPC_LCD_PAL20_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL20_R14_0_BIT 16
#define LPC_LCD_PAL20_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL20_G14_0_BIT 21
#define LPC_LCD_PAL20_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL20_B14_0_BIT 26
#define LPC_LCD_PAL20_I1_MASK 0x80000000
#define LPC_LCD_PAL20_I1 0x80000000
#define LPC_LCD_PAL20_I1_BIT 31

#define LPC_LCD_PAL21 (*(volatile unsigned long *)0x20088254)
#define LPC_LCD_PAL21_OFFSET 0x254
#define LPC_LCD_PAL21_R04_0_MASK 0x1F
#define LPC_LCD_PAL21_R04_0_BIT 0
#define LPC_LCD_PAL21_G04_0_MASK 0x3E0
#define LPC_LCD_PAL21_G04_0_BIT 5
#define LPC_LCD_PAL21_B04_0_MASK 0x7C00
#define LPC_LCD_PAL21_B04_0_BIT 10
#define LPC_LCD_PAL21_I0_MASK 0x8000
#define LPC_LCD_PAL21_I0 0x8000
#define LPC_LCD_PAL21_I0_BIT 15
#define LPC_LCD_PAL21_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL21_R14_0_BIT 16
#define LPC_LCD_PAL21_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL21_G14_0_BIT 21
#define LPC_LCD_PAL21_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL21_B14_0_BIT 26
#define LPC_LCD_PAL21_I1_MASK 0x80000000
#define LPC_LCD_PAL21_I1 0x80000000
#define LPC_LCD_PAL21_I1_BIT 31

#define LPC_LCD_PAL22 (*(volatile unsigned long *)0x20088258)
#define LPC_LCD_PAL22_OFFSET 0x258
#define LPC_LCD_PAL22_R04_0_MASK 0x1F
#define LPC_LCD_PAL22_R04_0_BIT 0
#define LPC_LCD_PAL22_G04_0_MASK 0x3E0
#define LPC_LCD_PAL22_G04_0_BIT 5
#define LPC_LCD_PAL22_B04_0_MASK 0x7C00
#define LPC_LCD_PAL22_B04_0_BIT 10
#define LPC_LCD_PAL22_I0_MASK 0x8000
#define LPC_LCD_PAL22_I0 0x8000
#define LPC_LCD_PAL22_I0_BIT 15
#define LPC_LCD_PAL22_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL22_R14_0_BIT 16
#define LPC_LCD_PAL22_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL22_G14_0_BIT 21
#define LPC_LCD_PAL22_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL22_B14_0_BIT 26
#define LPC_LCD_PAL22_I1_MASK 0x80000000
#define LPC_LCD_PAL22_I1 0x80000000
#define LPC_LCD_PAL22_I1_BIT 31

#define LPC_LCD_PAL23 (*(volatile unsigned long *)0x2008825C)
#define LPC_LCD_PAL23_OFFSET 0x25C
#define LPC_LCD_PAL23_R04_0_MASK 0x1F
#define LPC_LCD_PAL23_R04_0_BIT 0
#define LPC_LCD_PAL23_G04_0_MASK 0x3E0
#define LPC_LCD_PAL23_G04_0_BIT 5
#define LPC_LCD_PAL23_B04_0_MASK 0x7C00
#define LPC_LCD_PAL23_B04_0_BIT 10
#define LPC_LCD_PAL23_I0_MASK 0x8000
#define LPC_LCD_PAL23_I0 0x8000
#define LPC_LCD_PAL23_I0_BIT 15
#define LPC_LCD_PAL23_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL23_R14_0_BIT 16
#define LPC_LCD_PAL23_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL23_G14_0_BIT 21
#define LPC_LCD_PAL23_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL23_B14_0_BIT 26
#define LPC_LCD_PAL23_I1_MASK 0x80000000
#define LPC_LCD_PAL23_I1 0x80000000
#define LPC_LCD_PAL23_I1_BIT 31

#define LPC_LCD_PAL24 (*(volatile unsigned long *)0x20088260)
#define LPC_LCD_PAL24_OFFSET 0x260
#define LPC_LCD_PAL24_R04_0_MASK 0x1F
#define LPC_LCD_PAL24_R04_0_BIT 0
#define LPC_LCD_PAL24_G04_0_MASK 0x3E0
#define LPC_LCD_PAL24_G04_0_BIT 5
#define LPC_LCD_PAL24_B04_0_MASK 0x7C00
#define LPC_LCD_PAL24_B04_0_BIT 10
#define LPC_LCD_PAL24_I0_MASK 0x8000
#define LPC_LCD_PAL24_I0 0x8000
#define LPC_LCD_PAL24_I0_BIT 15
#define LPC_LCD_PAL24_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL24_R14_0_BIT 16
#define LPC_LCD_PAL24_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL24_G14_0_BIT 21
#define LPC_LCD_PAL24_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL24_B14_0_BIT 26
#define LPC_LCD_PAL24_I1_MASK 0x80000000
#define LPC_LCD_PAL24_I1 0x80000000
#define LPC_LCD_PAL24_I1_BIT 31

#define LPC_LCD_PAL25 (*(volatile unsigned long *)0x20088264)
#define LPC_LCD_PAL25_OFFSET 0x264
#define LPC_LCD_PAL25_R04_0_MASK 0x1F
#define LPC_LCD_PAL25_R04_0_BIT 0
#define LPC_LCD_PAL25_G04_0_MASK 0x3E0
#define LPC_LCD_PAL25_G04_0_BIT 5
#define LPC_LCD_PAL25_B04_0_MASK 0x7C00
#define LPC_LCD_PAL25_B04_0_BIT 10
#define LPC_LCD_PAL25_I0_MASK 0x8000
#define LPC_LCD_PAL25_I0 0x8000
#define LPC_LCD_PAL25_I0_BIT 15
#define LPC_LCD_PAL25_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL25_R14_0_BIT 16
#define LPC_LCD_PAL25_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL25_G14_0_BIT 21
#define LPC_LCD_PAL25_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL25_B14_0_BIT 26
#define LPC_LCD_PAL25_I1_MASK 0x80000000
#define LPC_LCD_PAL25_I1 0x80000000
#define LPC_LCD_PAL25_I1_BIT 31

#define LPC_LCD_PAL26 (*(volatile unsigned long *)0x20088268)
#define LPC_LCD_PAL26_OFFSET 0x268
#define LPC_LCD_PAL26_R04_0_MASK 0x1F
#define LPC_LCD_PAL26_R04_0_BIT 0
#define LPC_LCD_PAL26_G04_0_MASK 0x3E0
#define LPC_LCD_PAL26_G04_0_BIT 5
#define LPC_LCD_PAL26_B04_0_MASK 0x7C00
#define LPC_LCD_PAL26_B04_0_BIT 10
#define LPC_LCD_PAL26_I0_MASK 0x8000
#define LPC_LCD_PAL26_I0 0x8000
#define LPC_LCD_PAL26_I0_BIT 15
#define LPC_LCD_PAL26_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL26_R14_0_BIT 16
#define LPC_LCD_PAL26_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL26_G14_0_BIT 21
#define LPC_LCD_PAL26_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL26_B14_0_BIT 26
#define LPC_LCD_PAL26_I1_MASK 0x80000000
#define LPC_LCD_PAL26_I1 0x80000000
#define LPC_LCD_PAL26_I1_BIT 31

#define LPC_LCD_PAL27 (*(volatile unsigned long *)0x2008826C)
#define LPC_LCD_PAL27_OFFSET 0x26C
#define LPC_LCD_PAL27_R04_0_MASK 0x1F
#define LPC_LCD_PAL27_R04_0_BIT 0
#define LPC_LCD_PAL27_G04_0_MASK 0x3E0
#define LPC_LCD_PAL27_G04_0_BIT 5
#define LPC_LCD_PAL27_B04_0_MASK 0x7C00
#define LPC_LCD_PAL27_B04_0_BIT 10
#define LPC_LCD_PAL27_I0_MASK 0x8000
#define LPC_LCD_PAL27_I0 0x8000
#define LPC_LCD_PAL27_I0_BIT 15
#define LPC_LCD_PAL27_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL27_R14_0_BIT 16
#define LPC_LCD_PAL27_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL27_G14_0_BIT 21
#define LPC_LCD_PAL27_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL27_B14_0_BIT 26
#define LPC_LCD_PAL27_I1_MASK 0x80000000
#define LPC_LCD_PAL27_I1 0x80000000
#define LPC_LCD_PAL27_I1_BIT 31

#define LPC_LCD_PAL28 (*(volatile unsigned long *)0x20088270)
#define LPC_LCD_PAL28_OFFSET 0x270
#define LPC_LCD_PAL28_R04_0_MASK 0x1F
#define LPC_LCD_PAL28_R04_0_BIT 0
#define LPC_LCD_PAL28_G04_0_MASK 0x3E0
#define LPC_LCD_PAL28_G04_0_BIT 5
#define LPC_LCD_PAL28_B04_0_MASK 0x7C00
#define LPC_LCD_PAL28_B04_0_BIT 10
#define LPC_LCD_PAL28_I0_MASK 0x8000
#define LPC_LCD_PAL28_I0 0x8000
#define LPC_LCD_PAL28_I0_BIT 15
#define LPC_LCD_PAL28_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL28_R14_0_BIT 16
#define LPC_LCD_PAL28_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL28_G14_0_BIT 21
#define LPC_LCD_PAL28_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL28_B14_0_BIT 26
#define LPC_LCD_PAL28_I1_MASK 0x80000000
#define LPC_LCD_PAL28_I1 0x80000000
#define LPC_LCD_PAL28_I1_BIT 31

#define LPC_LCD_PAL29 (*(volatile unsigned long *)0x20088274)
#define LPC_LCD_PAL29_OFFSET 0x274
#define LPC_LCD_PAL29_R04_0_MASK 0x1F
#define LPC_LCD_PAL29_R04_0_BIT 0
#define LPC_LCD_PAL29_G04_0_MASK 0x3E0
#define LPC_LCD_PAL29_G04_0_BIT 5
#define LPC_LCD_PAL29_B04_0_MASK 0x7C00
#define LPC_LCD_PAL29_B04_0_BIT 10
#define LPC_LCD_PAL29_I0_MASK 0x8000
#define LPC_LCD_PAL29_I0 0x8000
#define LPC_LCD_PAL29_I0_BIT 15
#define LPC_LCD_PAL29_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL29_R14_0_BIT 16
#define LPC_LCD_PAL29_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL29_G14_0_BIT 21
#define LPC_LCD_PAL29_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL29_B14_0_BIT 26
#define LPC_LCD_PAL29_I1_MASK 0x80000000
#define LPC_LCD_PAL29_I1 0x80000000
#define LPC_LCD_PAL29_I1_BIT 31

#define LPC_LCD_PAL30 (*(volatile unsigned long *)0x20088278)
#define LPC_LCD_PAL30_OFFSET 0x278
#define LPC_LCD_PAL30_R04_0_MASK 0x1F
#define LPC_LCD_PAL30_R04_0_BIT 0
#define LPC_LCD_PAL30_G04_0_MASK 0x3E0
#define LPC_LCD_PAL30_G04_0_BIT 5
#define LPC_LCD_PAL30_B04_0_MASK 0x7C00
#define LPC_LCD_PAL30_B04_0_BIT 10
#define LPC_LCD_PAL30_I0_MASK 0x8000
#define LPC_LCD_PAL30_I0 0x8000
#define LPC_LCD_PAL30_I0_BIT 15
#define LPC_LCD_PAL30_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL30_R14_0_BIT 16
#define LPC_LCD_PAL30_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL30_G14_0_BIT 21
#define LPC_LCD_PAL30_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL30_B14_0_BIT 26
#define LPC_LCD_PAL30_I1_MASK 0x80000000
#define LPC_LCD_PAL30_I1 0x80000000
#define LPC_LCD_PAL30_I1_BIT 31

#define LPC_LCD_PAL31 (*(volatile unsigned long *)0x2008827C)
#define LPC_LCD_PAL31_OFFSET 0x27C
#define LPC_LCD_PAL31_R04_0_MASK 0x1F
#define LPC_LCD_PAL31_R04_0_BIT 0
#define LPC_LCD_PAL31_G04_0_MASK 0x3E0
#define LPC_LCD_PAL31_G04_0_BIT 5
#define LPC_LCD_PAL31_B04_0_MASK 0x7C00
#define LPC_LCD_PAL31_B04_0_BIT 10
#define LPC_LCD_PAL31_I0_MASK 0x8000
#define LPC_LCD_PAL31_I0 0x8000
#define LPC_LCD_PAL31_I0_BIT 15
#define LPC_LCD_PAL31_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL31_R14_0_BIT 16
#define LPC_LCD_PAL31_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL31_G14_0_BIT 21
#define LPC_LCD_PAL31_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL31_B14_0_BIT 26
#define LPC_LCD_PAL31_I1_MASK 0x80000000
#define LPC_LCD_PAL31_I1 0x80000000
#define LPC_LCD_PAL31_I1_BIT 31

#define LPC_LCD_PAL32 (*(volatile unsigned long *)0x20088280)
#define LPC_LCD_PAL32_OFFSET 0x280
#define LPC_LCD_PAL32_R04_0_MASK 0x1F
#define LPC_LCD_PAL32_R04_0_BIT 0
#define LPC_LCD_PAL32_G04_0_MASK 0x3E0
#define LPC_LCD_PAL32_G04_0_BIT 5
#define LPC_LCD_PAL32_B04_0_MASK 0x7C00
#define LPC_LCD_PAL32_B04_0_BIT 10
#define LPC_LCD_PAL32_I0_MASK 0x8000
#define LPC_LCD_PAL32_I0 0x8000
#define LPC_LCD_PAL32_I0_BIT 15
#define LPC_LCD_PAL32_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL32_R14_0_BIT 16
#define LPC_LCD_PAL32_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL32_G14_0_BIT 21
#define LPC_LCD_PAL32_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL32_B14_0_BIT 26
#define LPC_LCD_PAL32_I1_MASK 0x80000000
#define LPC_LCD_PAL32_I1 0x80000000
#define LPC_LCD_PAL32_I1_BIT 31

#define LPC_LCD_PAL33 (*(volatile unsigned long *)0x20088284)
#define LPC_LCD_PAL33_OFFSET 0x284
#define LPC_LCD_PAL33_R04_0_MASK 0x1F
#define LPC_LCD_PAL33_R04_0_BIT 0
#define LPC_LCD_PAL33_G04_0_MASK 0x3E0
#define LPC_LCD_PAL33_G04_0_BIT 5
#define LPC_LCD_PAL33_B04_0_MASK 0x7C00
#define LPC_LCD_PAL33_B04_0_BIT 10
#define LPC_LCD_PAL33_I0_MASK 0x8000
#define LPC_LCD_PAL33_I0 0x8000
#define LPC_LCD_PAL33_I0_BIT 15
#define LPC_LCD_PAL33_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL33_R14_0_BIT 16
#define LPC_LCD_PAL33_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL33_G14_0_BIT 21
#define LPC_LCD_PAL33_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL33_B14_0_BIT 26
#define LPC_LCD_PAL33_I1_MASK 0x80000000
#define LPC_LCD_PAL33_I1 0x80000000
#define LPC_LCD_PAL33_I1_BIT 31

#define LPC_LCD_PAL34 (*(volatile unsigned long *)0x20088288)
#define LPC_LCD_PAL34_OFFSET 0x288
#define LPC_LCD_PAL34_R04_0_MASK 0x1F
#define LPC_LCD_PAL34_R04_0_BIT 0
#define LPC_LCD_PAL34_G04_0_MASK 0x3E0
#define LPC_LCD_PAL34_G04_0_BIT 5
#define LPC_LCD_PAL34_B04_0_MASK 0x7C00
#define LPC_LCD_PAL34_B04_0_BIT 10
#define LPC_LCD_PAL34_I0_MASK 0x8000
#define LPC_LCD_PAL34_I0 0x8000
#define LPC_LCD_PAL34_I0_BIT 15
#define LPC_LCD_PAL34_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL34_R14_0_BIT 16
#define LPC_LCD_PAL34_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL34_G14_0_BIT 21
#define LPC_LCD_PAL34_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL34_B14_0_BIT 26
#define LPC_LCD_PAL34_I1_MASK 0x80000000
#define LPC_LCD_PAL34_I1 0x80000000
#define LPC_LCD_PAL34_I1_BIT 31

#define LPC_LCD_PAL35 (*(volatile unsigned long *)0x2008828C)
#define LPC_LCD_PAL35_OFFSET 0x28C
#define LPC_LCD_PAL35_R04_0_MASK 0x1F
#define LPC_LCD_PAL35_R04_0_BIT 0
#define LPC_LCD_PAL35_G04_0_MASK 0x3E0
#define LPC_LCD_PAL35_G04_0_BIT 5
#define LPC_LCD_PAL35_B04_0_MASK 0x7C00
#define LPC_LCD_PAL35_B04_0_BIT 10
#define LPC_LCD_PAL35_I0_MASK 0x8000
#define LPC_LCD_PAL35_I0 0x8000
#define LPC_LCD_PAL35_I0_BIT 15
#define LPC_LCD_PAL35_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL35_R14_0_BIT 16
#define LPC_LCD_PAL35_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL35_G14_0_BIT 21
#define LPC_LCD_PAL35_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL35_B14_0_BIT 26
#define LPC_LCD_PAL35_I1_MASK 0x80000000
#define LPC_LCD_PAL35_I1 0x80000000
#define LPC_LCD_PAL35_I1_BIT 31

#define LPC_LCD_PAL36 (*(volatile unsigned long *)0x20088290)
#define LPC_LCD_PAL36_OFFSET 0x290
#define LPC_LCD_PAL36_R04_0_MASK 0x1F
#define LPC_LCD_PAL36_R04_0_BIT 0
#define LPC_LCD_PAL36_G04_0_MASK 0x3E0
#define LPC_LCD_PAL36_G04_0_BIT 5
#define LPC_LCD_PAL36_B04_0_MASK 0x7C00
#define LPC_LCD_PAL36_B04_0_BIT 10
#define LPC_LCD_PAL36_I0_MASK 0x8000
#define LPC_LCD_PAL36_I0 0x8000
#define LPC_LCD_PAL36_I0_BIT 15
#define LPC_LCD_PAL36_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL36_R14_0_BIT 16
#define LPC_LCD_PAL36_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL36_G14_0_BIT 21
#define LPC_LCD_PAL36_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL36_B14_0_BIT 26
#define LPC_LCD_PAL36_I1_MASK 0x80000000
#define LPC_LCD_PAL36_I1 0x80000000
#define LPC_LCD_PAL36_I1_BIT 31

#define LPC_LCD_PAL37 (*(volatile unsigned long *)0x20088294)
#define LPC_LCD_PAL37_OFFSET 0x294
#define LPC_LCD_PAL37_R04_0_MASK 0x1F
#define LPC_LCD_PAL37_R04_0_BIT 0
#define LPC_LCD_PAL37_G04_0_MASK 0x3E0
#define LPC_LCD_PAL37_G04_0_BIT 5
#define LPC_LCD_PAL37_B04_0_MASK 0x7C00
#define LPC_LCD_PAL37_B04_0_BIT 10
#define LPC_LCD_PAL37_I0_MASK 0x8000
#define LPC_LCD_PAL37_I0 0x8000
#define LPC_LCD_PAL37_I0_BIT 15
#define LPC_LCD_PAL37_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL37_R14_0_BIT 16
#define LPC_LCD_PAL37_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL37_G14_0_BIT 21
#define LPC_LCD_PAL37_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL37_B14_0_BIT 26
#define LPC_LCD_PAL37_I1_MASK 0x80000000
#define LPC_LCD_PAL37_I1 0x80000000
#define LPC_LCD_PAL37_I1_BIT 31

#define LPC_LCD_PAL38 (*(volatile unsigned long *)0x20088298)
#define LPC_LCD_PAL38_OFFSET 0x298
#define LPC_LCD_PAL38_R04_0_MASK 0x1F
#define LPC_LCD_PAL38_R04_0_BIT 0
#define LPC_LCD_PAL38_G04_0_MASK 0x3E0
#define LPC_LCD_PAL38_G04_0_BIT 5
#define LPC_LCD_PAL38_B04_0_MASK 0x7C00
#define LPC_LCD_PAL38_B04_0_BIT 10
#define LPC_LCD_PAL38_I0_MASK 0x8000
#define LPC_LCD_PAL38_I0 0x8000
#define LPC_LCD_PAL38_I0_BIT 15
#define LPC_LCD_PAL38_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL38_R14_0_BIT 16
#define LPC_LCD_PAL38_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL38_G14_0_BIT 21
#define LPC_LCD_PAL38_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL38_B14_0_BIT 26
#define LPC_LCD_PAL38_I1_MASK 0x80000000
#define LPC_LCD_PAL38_I1 0x80000000
#define LPC_LCD_PAL38_I1_BIT 31

#define LPC_LCD_PAL39 (*(volatile unsigned long *)0x2008829C)
#define LPC_LCD_PAL39_OFFSET 0x29C
#define LPC_LCD_PAL39_R04_0_MASK 0x1F
#define LPC_LCD_PAL39_R04_0_BIT 0
#define LPC_LCD_PAL39_G04_0_MASK 0x3E0
#define LPC_LCD_PAL39_G04_0_BIT 5
#define LPC_LCD_PAL39_B04_0_MASK 0x7C00
#define LPC_LCD_PAL39_B04_0_BIT 10
#define LPC_LCD_PAL39_I0_MASK 0x8000
#define LPC_LCD_PAL39_I0 0x8000
#define LPC_LCD_PAL39_I0_BIT 15
#define LPC_LCD_PAL39_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL39_R14_0_BIT 16
#define LPC_LCD_PAL39_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL39_G14_0_BIT 21
#define LPC_LCD_PAL39_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL39_B14_0_BIT 26
#define LPC_LCD_PAL39_I1_MASK 0x80000000
#define LPC_LCD_PAL39_I1 0x80000000
#define LPC_LCD_PAL39_I1_BIT 31

#define LPC_LCD_PAL40 (*(volatile unsigned long *)0x200882A0)
#define LPC_LCD_PAL40_OFFSET 0x2A0
#define LPC_LCD_PAL40_R04_0_MASK 0x1F
#define LPC_LCD_PAL40_R04_0_BIT 0
#define LPC_LCD_PAL40_G04_0_MASK 0x3E0
#define LPC_LCD_PAL40_G04_0_BIT 5
#define LPC_LCD_PAL40_B04_0_MASK 0x7C00
#define LPC_LCD_PAL40_B04_0_BIT 10
#define LPC_LCD_PAL40_I0_MASK 0x8000
#define LPC_LCD_PAL40_I0 0x8000
#define LPC_LCD_PAL40_I0_BIT 15
#define LPC_LCD_PAL40_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL40_R14_0_BIT 16
#define LPC_LCD_PAL40_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL40_G14_0_BIT 21
#define LPC_LCD_PAL40_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL40_B14_0_BIT 26
#define LPC_LCD_PAL40_I1_MASK 0x80000000
#define LPC_LCD_PAL40_I1 0x80000000
#define LPC_LCD_PAL40_I1_BIT 31

#define LPC_LCD_PAL41 (*(volatile unsigned long *)0x200882A4)
#define LPC_LCD_PAL41_OFFSET 0x2A4
#define LPC_LCD_PAL41_R04_0_MASK 0x1F
#define LPC_LCD_PAL41_R04_0_BIT 0
#define LPC_LCD_PAL41_G04_0_MASK 0x3E0
#define LPC_LCD_PAL41_G04_0_BIT 5
#define LPC_LCD_PAL41_B04_0_MASK 0x7C00
#define LPC_LCD_PAL41_B04_0_BIT 10
#define LPC_LCD_PAL41_I0_MASK 0x8000
#define LPC_LCD_PAL41_I0 0x8000
#define LPC_LCD_PAL41_I0_BIT 15
#define LPC_LCD_PAL41_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL41_R14_0_BIT 16
#define LPC_LCD_PAL41_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL41_G14_0_BIT 21
#define LPC_LCD_PAL41_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL41_B14_0_BIT 26
#define LPC_LCD_PAL41_I1_MASK 0x80000000
#define LPC_LCD_PAL41_I1 0x80000000
#define LPC_LCD_PAL41_I1_BIT 31

#define LPC_LCD_PAL42 (*(volatile unsigned long *)0x200882A8)
#define LPC_LCD_PAL42_OFFSET 0x2A8
#define LPC_LCD_PAL42_R04_0_MASK 0x1F
#define LPC_LCD_PAL42_R04_0_BIT 0
#define LPC_LCD_PAL42_G04_0_MASK 0x3E0
#define LPC_LCD_PAL42_G04_0_BIT 5
#define LPC_LCD_PAL42_B04_0_MASK 0x7C00
#define LPC_LCD_PAL42_B04_0_BIT 10
#define LPC_LCD_PAL42_I0_MASK 0x8000
#define LPC_LCD_PAL42_I0 0x8000
#define LPC_LCD_PAL42_I0_BIT 15
#define LPC_LCD_PAL42_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL42_R14_0_BIT 16
#define LPC_LCD_PAL42_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL42_G14_0_BIT 21
#define LPC_LCD_PAL42_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL42_B14_0_BIT 26
#define LPC_LCD_PAL42_I1_MASK 0x80000000
#define LPC_LCD_PAL42_I1 0x80000000
#define LPC_LCD_PAL42_I1_BIT 31

#define LPC_LCD_PAL43 (*(volatile unsigned long *)0x200882AC)
#define LPC_LCD_PAL43_OFFSET 0x2AC
#define LPC_LCD_PAL43_R04_0_MASK 0x1F
#define LPC_LCD_PAL43_R04_0_BIT 0
#define LPC_LCD_PAL43_G04_0_MASK 0x3E0
#define LPC_LCD_PAL43_G04_0_BIT 5
#define LPC_LCD_PAL43_B04_0_MASK 0x7C00
#define LPC_LCD_PAL43_B04_0_BIT 10
#define LPC_LCD_PAL43_I0_MASK 0x8000
#define LPC_LCD_PAL43_I0 0x8000
#define LPC_LCD_PAL43_I0_BIT 15
#define LPC_LCD_PAL43_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL43_R14_0_BIT 16
#define LPC_LCD_PAL43_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL43_G14_0_BIT 21
#define LPC_LCD_PAL43_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL43_B14_0_BIT 26
#define LPC_LCD_PAL43_I1_MASK 0x80000000
#define LPC_LCD_PAL43_I1 0x80000000
#define LPC_LCD_PAL43_I1_BIT 31

#define LPC_LCD_PAL44 (*(volatile unsigned long *)0x200882B0)
#define LPC_LCD_PAL44_OFFSET 0x2B0
#define LPC_LCD_PAL44_R04_0_MASK 0x1F
#define LPC_LCD_PAL44_R04_0_BIT 0
#define LPC_LCD_PAL44_G04_0_MASK 0x3E0
#define LPC_LCD_PAL44_G04_0_BIT 5
#define LPC_LCD_PAL44_B04_0_MASK 0x7C00
#define LPC_LCD_PAL44_B04_0_BIT 10
#define LPC_LCD_PAL44_I0_MASK 0x8000
#define LPC_LCD_PAL44_I0 0x8000
#define LPC_LCD_PAL44_I0_BIT 15
#define LPC_LCD_PAL44_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL44_R14_0_BIT 16
#define LPC_LCD_PAL44_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL44_G14_0_BIT 21
#define LPC_LCD_PAL44_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL44_B14_0_BIT 26
#define LPC_LCD_PAL44_I1_MASK 0x80000000
#define LPC_LCD_PAL44_I1 0x80000000
#define LPC_LCD_PAL44_I1_BIT 31

#define LPC_LCD_PAL45 (*(volatile unsigned long *)0x200882B4)
#define LPC_LCD_PAL45_OFFSET 0x2B4
#define LPC_LCD_PAL45_R04_0_MASK 0x1F
#define LPC_LCD_PAL45_R04_0_BIT 0
#define LPC_LCD_PAL45_G04_0_MASK 0x3E0
#define LPC_LCD_PAL45_G04_0_BIT 5
#define LPC_LCD_PAL45_B04_0_MASK 0x7C00
#define LPC_LCD_PAL45_B04_0_BIT 10
#define LPC_LCD_PAL45_I0_MASK 0x8000
#define LPC_LCD_PAL45_I0 0x8000
#define LPC_LCD_PAL45_I0_BIT 15
#define LPC_LCD_PAL45_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL45_R14_0_BIT 16
#define LPC_LCD_PAL45_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL45_G14_0_BIT 21
#define LPC_LCD_PAL45_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL45_B14_0_BIT 26
#define LPC_LCD_PAL45_I1_MASK 0x80000000
#define LPC_LCD_PAL45_I1 0x80000000
#define LPC_LCD_PAL45_I1_BIT 31

#define LPC_LCD_PAL46 (*(volatile unsigned long *)0x200882B8)
#define LPC_LCD_PAL46_OFFSET 0x2B8
#define LPC_LCD_PAL46_R04_0_MASK 0x1F
#define LPC_LCD_PAL46_R04_0_BIT 0
#define LPC_LCD_PAL46_G04_0_MASK 0x3E0
#define LPC_LCD_PAL46_G04_0_BIT 5
#define LPC_LCD_PAL46_B04_0_MASK 0x7C00
#define LPC_LCD_PAL46_B04_0_BIT 10
#define LPC_LCD_PAL46_I0_MASK 0x8000
#define LPC_LCD_PAL46_I0 0x8000
#define LPC_LCD_PAL46_I0_BIT 15
#define LPC_LCD_PAL46_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL46_R14_0_BIT 16
#define LPC_LCD_PAL46_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL46_G14_0_BIT 21
#define LPC_LCD_PAL46_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL46_B14_0_BIT 26
#define LPC_LCD_PAL46_I1_MASK 0x80000000
#define LPC_LCD_PAL46_I1 0x80000000
#define LPC_LCD_PAL46_I1_BIT 31

#define LPC_LCD_PAL47 (*(volatile unsigned long *)0x200882BC)
#define LPC_LCD_PAL47_OFFSET 0x2BC
#define LPC_LCD_PAL47_R04_0_MASK 0x1F
#define LPC_LCD_PAL47_R04_0_BIT 0
#define LPC_LCD_PAL47_G04_0_MASK 0x3E0
#define LPC_LCD_PAL47_G04_0_BIT 5
#define LPC_LCD_PAL47_B04_0_MASK 0x7C00
#define LPC_LCD_PAL47_B04_0_BIT 10
#define LPC_LCD_PAL47_I0_MASK 0x8000
#define LPC_LCD_PAL47_I0 0x8000
#define LPC_LCD_PAL47_I0_BIT 15
#define LPC_LCD_PAL47_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL47_R14_0_BIT 16
#define LPC_LCD_PAL47_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL47_G14_0_BIT 21
#define LPC_LCD_PAL47_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL47_B14_0_BIT 26
#define LPC_LCD_PAL47_I1_MASK 0x80000000
#define LPC_LCD_PAL47_I1 0x80000000
#define LPC_LCD_PAL47_I1_BIT 31

#define LPC_LCD_PAL48 (*(volatile unsigned long *)0x200882C0)
#define LPC_LCD_PAL48_OFFSET 0x2C0
#define LPC_LCD_PAL48_R04_0_MASK 0x1F
#define LPC_LCD_PAL48_R04_0_BIT 0
#define LPC_LCD_PAL48_G04_0_MASK 0x3E0
#define LPC_LCD_PAL48_G04_0_BIT 5
#define LPC_LCD_PAL48_B04_0_MASK 0x7C00
#define LPC_LCD_PAL48_B04_0_BIT 10
#define LPC_LCD_PAL48_I0_MASK 0x8000
#define LPC_LCD_PAL48_I0 0x8000
#define LPC_LCD_PAL48_I0_BIT 15
#define LPC_LCD_PAL48_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL48_R14_0_BIT 16
#define LPC_LCD_PAL48_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL48_G14_0_BIT 21
#define LPC_LCD_PAL48_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL48_B14_0_BIT 26
#define LPC_LCD_PAL48_I1_MASK 0x80000000
#define LPC_LCD_PAL48_I1 0x80000000
#define LPC_LCD_PAL48_I1_BIT 31

#define LPC_LCD_PAL49 (*(volatile unsigned long *)0x200882C4)
#define LPC_LCD_PAL49_OFFSET 0x2C4
#define LPC_LCD_PAL49_R04_0_MASK 0x1F
#define LPC_LCD_PAL49_R04_0_BIT 0
#define LPC_LCD_PAL49_G04_0_MASK 0x3E0
#define LPC_LCD_PAL49_G04_0_BIT 5
#define LPC_LCD_PAL49_B04_0_MASK 0x7C00
#define LPC_LCD_PAL49_B04_0_BIT 10
#define LPC_LCD_PAL49_I0_MASK 0x8000
#define LPC_LCD_PAL49_I0 0x8000
#define LPC_LCD_PAL49_I0_BIT 15
#define LPC_LCD_PAL49_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL49_R14_0_BIT 16
#define LPC_LCD_PAL49_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL49_G14_0_BIT 21
#define LPC_LCD_PAL49_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL49_B14_0_BIT 26
#define LPC_LCD_PAL49_I1_MASK 0x80000000
#define LPC_LCD_PAL49_I1 0x80000000
#define LPC_LCD_PAL49_I1_BIT 31

#define LPC_LCD_PAL50 (*(volatile unsigned long *)0x200882C8)
#define LPC_LCD_PAL50_OFFSET 0x2C8
#define LPC_LCD_PAL50_R04_0_MASK 0x1F
#define LPC_LCD_PAL50_R04_0_BIT 0
#define LPC_LCD_PAL50_G04_0_MASK 0x3E0
#define LPC_LCD_PAL50_G04_0_BIT 5
#define LPC_LCD_PAL50_B04_0_MASK 0x7C00
#define LPC_LCD_PAL50_B04_0_BIT 10
#define LPC_LCD_PAL50_I0_MASK 0x8000
#define LPC_LCD_PAL50_I0 0x8000
#define LPC_LCD_PAL50_I0_BIT 15
#define LPC_LCD_PAL50_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL50_R14_0_BIT 16
#define LPC_LCD_PAL50_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL50_G14_0_BIT 21
#define LPC_LCD_PAL50_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL50_B14_0_BIT 26
#define LPC_LCD_PAL50_I1_MASK 0x80000000
#define LPC_LCD_PAL50_I1 0x80000000
#define LPC_LCD_PAL50_I1_BIT 31

#define LPC_LCD_PAL51 (*(volatile unsigned long *)0x200882CC)
#define LPC_LCD_PAL51_OFFSET 0x2CC
#define LPC_LCD_PAL51_R04_0_MASK 0x1F
#define LPC_LCD_PAL51_R04_0_BIT 0
#define LPC_LCD_PAL51_G04_0_MASK 0x3E0
#define LPC_LCD_PAL51_G04_0_BIT 5
#define LPC_LCD_PAL51_B04_0_MASK 0x7C00
#define LPC_LCD_PAL51_B04_0_BIT 10
#define LPC_LCD_PAL51_I0_MASK 0x8000
#define LPC_LCD_PAL51_I0 0x8000
#define LPC_LCD_PAL51_I0_BIT 15
#define LPC_LCD_PAL51_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL51_R14_0_BIT 16
#define LPC_LCD_PAL51_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL51_G14_0_BIT 21
#define LPC_LCD_PAL51_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL51_B14_0_BIT 26
#define LPC_LCD_PAL51_I1_MASK 0x80000000
#define LPC_LCD_PAL51_I1 0x80000000
#define LPC_LCD_PAL51_I1_BIT 31

#define LPC_LCD_PAL52 (*(volatile unsigned long *)0x200882D0)
#define LPC_LCD_PAL52_OFFSET 0x2D0
#define LPC_LCD_PAL52_R04_0_MASK 0x1F
#define LPC_LCD_PAL52_R04_0_BIT 0
#define LPC_LCD_PAL52_G04_0_MASK 0x3E0
#define LPC_LCD_PAL52_G04_0_BIT 5
#define LPC_LCD_PAL52_B04_0_MASK 0x7C00
#define LPC_LCD_PAL52_B04_0_BIT 10
#define LPC_LCD_PAL52_I0_MASK 0x8000
#define LPC_LCD_PAL52_I0 0x8000
#define LPC_LCD_PAL52_I0_BIT 15
#define LPC_LCD_PAL52_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL52_R14_0_BIT 16
#define LPC_LCD_PAL52_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL52_G14_0_BIT 21
#define LPC_LCD_PAL52_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL52_B14_0_BIT 26
#define LPC_LCD_PAL52_I1_MASK 0x80000000
#define LPC_LCD_PAL52_I1 0x80000000
#define LPC_LCD_PAL52_I1_BIT 31

#define LPC_LCD_PAL53 (*(volatile unsigned long *)0x200882D4)
#define LPC_LCD_PAL53_OFFSET 0x2D4
#define LPC_LCD_PAL53_R04_0_MASK 0x1F
#define LPC_LCD_PAL53_R04_0_BIT 0
#define LPC_LCD_PAL53_G04_0_MASK 0x3E0
#define LPC_LCD_PAL53_G04_0_BIT 5
#define LPC_LCD_PAL53_B04_0_MASK 0x7C00
#define LPC_LCD_PAL53_B04_0_BIT 10
#define LPC_LCD_PAL53_I0_MASK 0x8000
#define LPC_LCD_PAL53_I0 0x8000
#define LPC_LCD_PAL53_I0_BIT 15
#define LPC_LCD_PAL53_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL53_R14_0_BIT 16
#define LPC_LCD_PAL53_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL53_G14_0_BIT 21
#define LPC_LCD_PAL53_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL53_B14_0_BIT 26
#define LPC_LCD_PAL53_I1_MASK 0x80000000
#define LPC_LCD_PAL53_I1 0x80000000
#define LPC_LCD_PAL53_I1_BIT 31

#define LPC_LCD_PAL54 (*(volatile unsigned long *)0x200882D8)
#define LPC_LCD_PAL54_OFFSET 0x2D8
#define LPC_LCD_PAL54_R04_0_MASK 0x1F
#define LPC_LCD_PAL54_R04_0_BIT 0
#define LPC_LCD_PAL54_G04_0_MASK 0x3E0
#define LPC_LCD_PAL54_G04_0_BIT 5
#define LPC_LCD_PAL54_B04_0_MASK 0x7C00
#define LPC_LCD_PAL54_B04_0_BIT 10
#define LPC_LCD_PAL54_I0_MASK 0x8000
#define LPC_LCD_PAL54_I0 0x8000
#define LPC_LCD_PAL54_I0_BIT 15
#define LPC_LCD_PAL54_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL54_R14_0_BIT 16
#define LPC_LCD_PAL54_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL54_G14_0_BIT 21
#define LPC_LCD_PAL54_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL54_B14_0_BIT 26
#define LPC_LCD_PAL54_I1_MASK 0x80000000
#define LPC_LCD_PAL54_I1 0x80000000
#define LPC_LCD_PAL54_I1_BIT 31

#define LPC_LCD_PAL55 (*(volatile unsigned long *)0x200882DC)
#define LPC_LCD_PAL55_OFFSET 0x2DC
#define LPC_LCD_PAL55_R04_0_MASK 0x1F
#define LPC_LCD_PAL55_R04_0_BIT 0
#define LPC_LCD_PAL55_G04_0_MASK 0x3E0
#define LPC_LCD_PAL55_G04_0_BIT 5
#define LPC_LCD_PAL55_B04_0_MASK 0x7C00
#define LPC_LCD_PAL55_B04_0_BIT 10
#define LPC_LCD_PAL55_I0_MASK 0x8000
#define LPC_LCD_PAL55_I0 0x8000
#define LPC_LCD_PAL55_I0_BIT 15
#define LPC_LCD_PAL55_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL55_R14_0_BIT 16
#define LPC_LCD_PAL55_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL55_G14_0_BIT 21
#define LPC_LCD_PAL55_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL55_B14_0_BIT 26
#define LPC_LCD_PAL55_I1_MASK 0x80000000
#define LPC_LCD_PAL55_I1 0x80000000
#define LPC_LCD_PAL55_I1_BIT 31

#define LPC_LCD_PAL56 (*(volatile unsigned long *)0x200882E0)
#define LPC_LCD_PAL56_OFFSET 0x2E0
#define LPC_LCD_PAL56_R04_0_MASK 0x1F
#define LPC_LCD_PAL56_R04_0_BIT 0
#define LPC_LCD_PAL56_G04_0_MASK 0x3E0
#define LPC_LCD_PAL56_G04_0_BIT 5
#define LPC_LCD_PAL56_B04_0_MASK 0x7C00
#define LPC_LCD_PAL56_B04_0_BIT 10
#define LPC_LCD_PAL56_I0_MASK 0x8000
#define LPC_LCD_PAL56_I0 0x8000
#define LPC_LCD_PAL56_I0_BIT 15
#define LPC_LCD_PAL56_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL56_R14_0_BIT 16
#define LPC_LCD_PAL56_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL56_G14_0_BIT 21
#define LPC_LCD_PAL56_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL56_B14_0_BIT 26
#define LPC_LCD_PAL56_I1_MASK 0x80000000
#define LPC_LCD_PAL56_I1 0x80000000
#define LPC_LCD_PAL56_I1_BIT 31

#define LPC_LCD_PAL57 (*(volatile unsigned long *)0x200882E4)
#define LPC_LCD_PAL57_OFFSET 0x2E4
#define LPC_LCD_PAL57_R04_0_MASK 0x1F
#define LPC_LCD_PAL57_R04_0_BIT 0
#define LPC_LCD_PAL57_G04_0_MASK 0x3E0
#define LPC_LCD_PAL57_G04_0_BIT 5
#define LPC_LCD_PAL57_B04_0_MASK 0x7C00
#define LPC_LCD_PAL57_B04_0_BIT 10
#define LPC_LCD_PAL57_I0_MASK 0x8000
#define LPC_LCD_PAL57_I0 0x8000
#define LPC_LCD_PAL57_I0_BIT 15
#define LPC_LCD_PAL57_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL57_R14_0_BIT 16
#define LPC_LCD_PAL57_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL57_G14_0_BIT 21
#define LPC_LCD_PAL57_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL57_B14_0_BIT 26
#define LPC_LCD_PAL57_I1_MASK 0x80000000
#define LPC_LCD_PAL57_I1 0x80000000
#define LPC_LCD_PAL57_I1_BIT 31

#define LPC_LCD_PAL58 (*(volatile unsigned long *)0x200882E8)
#define LPC_LCD_PAL58_OFFSET 0x2E8
#define LPC_LCD_PAL58_R04_0_MASK 0x1F
#define LPC_LCD_PAL58_R04_0_BIT 0
#define LPC_LCD_PAL58_G04_0_MASK 0x3E0
#define LPC_LCD_PAL58_G04_0_BIT 5
#define LPC_LCD_PAL58_B04_0_MASK 0x7C00
#define LPC_LCD_PAL58_B04_0_BIT 10
#define LPC_LCD_PAL58_I0_MASK 0x8000
#define LPC_LCD_PAL58_I0 0x8000
#define LPC_LCD_PAL58_I0_BIT 15
#define LPC_LCD_PAL58_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL58_R14_0_BIT 16
#define LPC_LCD_PAL58_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL58_G14_0_BIT 21
#define LPC_LCD_PAL58_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL58_B14_0_BIT 26
#define LPC_LCD_PAL58_I1_MASK 0x80000000
#define LPC_LCD_PAL58_I1 0x80000000
#define LPC_LCD_PAL58_I1_BIT 31

#define LPC_LCD_PAL59 (*(volatile unsigned long *)0x200882EC)
#define LPC_LCD_PAL59_OFFSET 0x2EC
#define LPC_LCD_PAL59_R04_0_MASK 0x1F
#define LPC_LCD_PAL59_R04_0_BIT 0
#define LPC_LCD_PAL59_G04_0_MASK 0x3E0
#define LPC_LCD_PAL59_G04_0_BIT 5
#define LPC_LCD_PAL59_B04_0_MASK 0x7C00
#define LPC_LCD_PAL59_B04_0_BIT 10
#define LPC_LCD_PAL59_I0_MASK 0x8000
#define LPC_LCD_PAL59_I0 0x8000
#define LPC_LCD_PAL59_I0_BIT 15
#define LPC_LCD_PAL59_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL59_R14_0_BIT 16
#define LPC_LCD_PAL59_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL59_G14_0_BIT 21
#define LPC_LCD_PAL59_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL59_B14_0_BIT 26
#define LPC_LCD_PAL59_I1_MASK 0x80000000
#define LPC_LCD_PAL59_I1 0x80000000
#define LPC_LCD_PAL59_I1_BIT 31

#define LPC_LCD_PAL60 (*(volatile unsigned long *)0x200882F0)
#define LPC_LCD_PAL60_OFFSET 0x2F0
#define LPC_LCD_PAL60_R04_0_MASK 0x1F
#define LPC_LCD_PAL60_R04_0_BIT 0
#define LPC_LCD_PAL60_G04_0_MASK 0x3E0
#define LPC_LCD_PAL60_G04_0_BIT 5
#define LPC_LCD_PAL60_B04_0_MASK 0x7C00
#define LPC_LCD_PAL60_B04_0_BIT 10
#define LPC_LCD_PAL60_I0_MASK 0x8000
#define LPC_LCD_PAL60_I0 0x8000
#define LPC_LCD_PAL60_I0_BIT 15
#define LPC_LCD_PAL60_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL60_R14_0_BIT 16
#define LPC_LCD_PAL60_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL60_G14_0_BIT 21
#define LPC_LCD_PAL60_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL60_B14_0_BIT 26
#define LPC_LCD_PAL60_I1_MASK 0x80000000
#define LPC_LCD_PAL60_I1 0x80000000
#define LPC_LCD_PAL60_I1_BIT 31

#define LPC_LCD_PAL61 (*(volatile unsigned long *)0x200882F4)
#define LPC_LCD_PAL61_OFFSET 0x2F4
#define LPC_LCD_PAL61_R04_0_MASK 0x1F
#define LPC_LCD_PAL61_R04_0_BIT 0
#define LPC_LCD_PAL61_G04_0_MASK 0x3E0
#define LPC_LCD_PAL61_G04_0_BIT 5
#define LPC_LCD_PAL61_B04_0_MASK 0x7C00
#define LPC_LCD_PAL61_B04_0_BIT 10
#define LPC_LCD_PAL61_I0_MASK 0x8000
#define LPC_LCD_PAL61_I0 0x8000
#define LPC_LCD_PAL61_I0_BIT 15
#define LPC_LCD_PAL61_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL61_R14_0_BIT 16
#define LPC_LCD_PAL61_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL61_G14_0_BIT 21
#define LPC_LCD_PAL61_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL61_B14_0_BIT 26
#define LPC_LCD_PAL61_I1_MASK 0x80000000
#define LPC_LCD_PAL61_I1 0x80000000
#define LPC_LCD_PAL61_I1_BIT 31

#define LPC_LCD_PAL62 (*(volatile unsigned long *)0x200882F8)
#define LPC_LCD_PAL62_OFFSET 0x2F8
#define LPC_LCD_PAL62_R04_0_MASK 0x1F
#define LPC_LCD_PAL62_R04_0_BIT 0
#define LPC_LCD_PAL62_G04_0_MASK 0x3E0
#define LPC_LCD_PAL62_G04_0_BIT 5
#define LPC_LCD_PAL62_B04_0_MASK 0x7C00
#define LPC_LCD_PAL62_B04_0_BIT 10
#define LPC_LCD_PAL62_I0_MASK 0x8000
#define LPC_LCD_PAL62_I0 0x8000
#define LPC_LCD_PAL62_I0_BIT 15
#define LPC_LCD_PAL62_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL62_R14_0_BIT 16
#define LPC_LCD_PAL62_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL62_G14_0_BIT 21
#define LPC_LCD_PAL62_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL62_B14_0_BIT 26
#define LPC_LCD_PAL62_I1_MASK 0x80000000
#define LPC_LCD_PAL62_I1 0x80000000
#define LPC_LCD_PAL62_I1_BIT 31

#define LPC_LCD_PAL63 (*(volatile unsigned long *)0x200882FC)
#define LPC_LCD_PAL63_OFFSET 0x2FC
#define LPC_LCD_PAL63_R04_0_MASK 0x1F
#define LPC_LCD_PAL63_R04_0_BIT 0
#define LPC_LCD_PAL63_G04_0_MASK 0x3E0
#define LPC_LCD_PAL63_G04_0_BIT 5
#define LPC_LCD_PAL63_B04_0_MASK 0x7C00
#define LPC_LCD_PAL63_B04_0_BIT 10
#define LPC_LCD_PAL63_I0_MASK 0x8000
#define LPC_LCD_PAL63_I0 0x8000
#define LPC_LCD_PAL63_I0_BIT 15
#define LPC_LCD_PAL63_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL63_R14_0_BIT 16
#define LPC_LCD_PAL63_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL63_G14_0_BIT 21
#define LPC_LCD_PAL63_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL63_B14_0_BIT 26
#define LPC_LCD_PAL63_I1_MASK 0x80000000
#define LPC_LCD_PAL63_I1 0x80000000
#define LPC_LCD_PAL63_I1_BIT 31

#define LPC_LCD_PAL64 (*(volatile unsigned long *)0x20088300)
#define LPC_LCD_PAL64_OFFSET 0x300
#define LPC_LCD_PAL64_R04_0_MASK 0x1F
#define LPC_LCD_PAL64_R04_0_BIT 0
#define LPC_LCD_PAL64_G04_0_MASK 0x3E0
#define LPC_LCD_PAL64_G04_0_BIT 5
#define LPC_LCD_PAL64_B04_0_MASK 0x7C00
#define LPC_LCD_PAL64_B04_0_BIT 10
#define LPC_LCD_PAL64_I0_MASK 0x8000
#define LPC_LCD_PAL64_I0 0x8000
#define LPC_LCD_PAL64_I0_BIT 15
#define LPC_LCD_PAL64_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL64_R14_0_BIT 16
#define LPC_LCD_PAL64_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL64_G14_0_BIT 21
#define LPC_LCD_PAL64_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL64_B14_0_BIT 26
#define LPC_LCD_PAL64_I1_MASK 0x80000000
#define LPC_LCD_PAL64_I1 0x80000000
#define LPC_LCD_PAL64_I1_BIT 31

#define LPC_LCD_PAL65 (*(volatile unsigned long *)0x20088304)
#define LPC_LCD_PAL65_OFFSET 0x304
#define LPC_LCD_PAL65_R04_0_MASK 0x1F
#define LPC_LCD_PAL65_R04_0_BIT 0
#define LPC_LCD_PAL65_G04_0_MASK 0x3E0
#define LPC_LCD_PAL65_G04_0_BIT 5
#define LPC_LCD_PAL65_B04_0_MASK 0x7C00
#define LPC_LCD_PAL65_B04_0_BIT 10
#define LPC_LCD_PAL65_I0_MASK 0x8000
#define LPC_LCD_PAL65_I0 0x8000
#define LPC_LCD_PAL65_I0_BIT 15
#define LPC_LCD_PAL65_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL65_R14_0_BIT 16
#define LPC_LCD_PAL65_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL65_G14_0_BIT 21
#define LPC_LCD_PAL65_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL65_B14_0_BIT 26
#define LPC_LCD_PAL65_I1_MASK 0x80000000
#define LPC_LCD_PAL65_I1 0x80000000
#define LPC_LCD_PAL65_I1_BIT 31

#define LPC_LCD_PAL66 (*(volatile unsigned long *)0x20088308)
#define LPC_LCD_PAL66_OFFSET 0x308
#define LPC_LCD_PAL66_R04_0_MASK 0x1F
#define LPC_LCD_PAL66_R04_0_BIT 0
#define LPC_LCD_PAL66_G04_0_MASK 0x3E0
#define LPC_LCD_PAL66_G04_0_BIT 5
#define LPC_LCD_PAL66_B04_0_MASK 0x7C00
#define LPC_LCD_PAL66_B04_0_BIT 10
#define LPC_LCD_PAL66_I0_MASK 0x8000
#define LPC_LCD_PAL66_I0 0x8000
#define LPC_LCD_PAL66_I0_BIT 15
#define LPC_LCD_PAL66_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL66_R14_0_BIT 16
#define LPC_LCD_PAL66_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL66_G14_0_BIT 21
#define LPC_LCD_PAL66_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL66_B14_0_BIT 26
#define LPC_LCD_PAL66_I1_MASK 0x80000000
#define LPC_LCD_PAL66_I1 0x80000000
#define LPC_LCD_PAL66_I1_BIT 31

#define LPC_LCD_PAL67 (*(volatile unsigned long *)0x2008830C)
#define LPC_LCD_PAL67_OFFSET 0x30C
#define LPC_LCD_PAL67_R04_0_MASK 0x1F
#define LPC_LCD_PAL67_R04_0_BIT 0
#define LPC_LCD_PAL67_G04_0_MASK 0x3E0
#define LPC_LCD_PAL67_G04_0_BIT 5
#define LPC_LCD_PAL67_B04_0_MASK 0x7C00
#define LPC_LCD_PAL67_B04_0_BIT 10
#define LPC_LCD_PAL67_I0_MASK 0x8000
#define LPC_LCD_PAL67_I0 0x8000
#define LPC_LCD_PAL67_I0_BIT 15
#define LPC_LCD_PAL67_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL67_R14_0_BIT 16
#define LPC_LCD_PAL67_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL67_G14_0_BIT 21
#define LPC_LCD_PAL67_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL67_B14_0_BIT 26
#define LPC_LCD_PAL67_I1_MASK 0x80000000
#define LPC_LCD_PAL67_I1 0x80000000
#define LPC_LCD_PAL67_I1_BIT 31

#define LPC_LCD_PAL68 (*(volatile unsigned long *)0x20088310)
#define LPC_LCD_PAL68_OFFSET 0x310
#define LPC_LCD_PAL68_R04_0_MASK 0x1F
#define LPC_LCD_PAL68_R04_0_BIT 0
#define LPC_LCD_PAL68_G04_0_MASK 0x3E0
#define LPC_LCD_PAL68_G04_0_BIT 5
#define LPC_LCD_PAL68_B04_0_MASK 0x7C00
#define LPC_LCD_PAL68_B04_0_BIT 10
#define LPC_LCD_PAL68_I0_MASK 0x8000
#define LPC_LCD_PAL68_I0 0x8000
#define LPC_LCD_PAL68_I0_BIT 15
#define LPC_LCD_PAL68_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL68_R14_0_BIT 16
#define LPC_LCD_PAL68_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL68_G14_0_BIT 21
#define LPC_LCD_PAL68_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL68_B14_0_BIT 26
#define LPC_LCD_PAL68_I1_MASK 0x80000000
#define LPC_LCD_PAL68_I1 0x80000000
#define LPC_LCD_PAL68_I1_BIT 31

#define LPC_LCD_PAL69 (*(volatile unsigned long *)0x20088314)
#define LPC_LCD_PAL69_OFFSET 0x314
#define LPC_LCD_PAL69_R04_0_MASK 0x1F
#define LPC_LCD_PAL69_R04_0_BIT 0
#define LPC_LCD_PAL69_G04_0_MASK 0x3E0
#define LPC_LCD_PAL69_G04_0_BIT 5
#define LPC_LCD_PAL69_B04_0_MASK 0x7C00
#define LPC_LCD_PAL69_B04_0_BIT 10
#define LPC_LCD_PAL69_I0_MASK 0x8000
#define LPC_LCD_PAL69_I0 0x8000
#define LPC_LCD_PAL69_I0_BIT 15
#define LPC_LCD_PAL69_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL69_R14_0_BIT 16
#define LPC_LCD_PAL69_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL69_G14_0_BIT 21
#define LPC_LCD_PAL69_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL69_B14_0_BIT 26
#define LPC_LCD_PAL69_I1_MASK 0x80000000
#define LPC_LCD_PAL69_I1 0x80000000
#define LPC_LCD_PAL69_I1_BIT 31

#define LPC_LCD_PAL70 (*(volatile unsigned long *)0x20088318)
#define LPC_LCD_PAL70_OFFSET 0x318
#define LPC_LCD_PAL70_R04_0_MASK 0x1F
#define LPC_LCD_PAL70_R04_0_BIT 0
#define LPC_LCD_PAL70_G04_0_MASK 0x3E0
#define LPC_LCD_PAL70_G04_0_BIT 5
#define LPC_LCD_PAL70_B04_0_MASK 0x7C00
#define LPC_LCD_PAL70_B04_0_BIT 10
#define LPC_LCD_PAL70_I0_MASK 0x8000
#define LPC_LCD_PAL70_I0 0x8000
#define LPC_LCD_PAL70_I0_BIT 15
#define LPC_LCD_PAL70_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL70_R14_0_BIT 16
#define LPC_LCD_PAL70_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL70_G14_0_BIT 21
#define LPC_LCD_PAL70_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL70_B14_0_BIT 26
#define LPC_LCD_PAL70_I1_MASK 0x80000000
#define LPC_LCD_PAL70_I1 0x80000000
#define LPC_LCD_PAL70_I1_BIT 31

#define LPC_LCD_PAL71 (*(volatile unsigned long *)0x2008831C)
#define LPC_LCD_PAL71_OFFSET 0x31C
#define LPC_LCD_PAL71_R04_0_MASK 0x1F
#define LPC_LCD_PAL71_R04_0_BIT 0
#define LPC_LCD_PAL71_G04_0_MASK 0x3E0
#define LPC_LCD_PAL71_G04_0_BIT 5
#define LPC_LCD_PAL71_B04_0_MASK 0x7C00
#define LPC_LCD_PAL71_B04_0_BIT 10
#define LPC_LCD_PAL71_I0_MASK 0x8000
#define LPC_LCD_PAL71_I0 0x8000
#define LPC_LCD_PAL71_I0_BIT 15
#define LPC_LCD_PAL71_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL71_R14_0_BIT 16
#define LPC_LCD_PAL71_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL71_G14_0_BIT 21
#define LPC_LCD_PAL71_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL71_B14_0_BIT 26
#define LPC_LCD_PAL71_I1_MASK 0x80000000
#define LPC_LCD_PAL71_I1 0x80000000
#define LPC_LCD_PAL71_I1_BIT 31

#define LPC_LCD_PAL72 (*(volatile unsigned long *)0x20088320)
#define LPC_LCD_PAL72_OFFSET 0x320
#define LPC_LCD_PAL72_R04_0_MASK 0x1F
#define LPC_LCD_PAL72_R04_0_BIT 0
#define LPC_LCD_PAL72_G04_0_MASK 0x3E0
#define LPC_LCD_PAL72_G04_0_BIT 5
#define LPC_LCD_PAL72_B04_0_MASK 0x7C00
#define LPC_LCD_PAL72_B04_0_BIT 10
#define LPC_LCD_PAL72_I0_MASK 0x8000
#define LPC_LCD_PAL72_I0 0x8000
#define LPC_LCD_PAL72_I0_BIT 15
#define LPC_LCD_PAL72_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL72_R14_0_BIT 16
#define LPC_LCD_PAL72_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL72_G14_0_BIT 21
#define LPC_LCD_PAL72_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL72_B14_0_BIT 26
#define LPC_LCD_PAL72_I1_MASK 0x80000000
#define LPC_LCD_PAL72_I1 0x80000000
#define LPC_LCD_PAL72_I1_BIT 31

#define LPC_LCD_PAL73 (*(volatile unsigned long *)0x20088324)
#define LPC_LCD_PAL73_OFFSET 0x324
#define LPC_LCD_PAL73_R04_0_MASK 0x1F
#define LPC_LCD_PAL73_R04_0_BIT 0
#define LPC_LCD_PAL73_G04_0_MASK 0x3E0
#define LPC_LCD_PAL73_G04_0_BIT 5
#define LPC_LCD_PAL73_B04_0_MASK 0x7C00
#define LPC_LCD_PAL73_B04_0_BIT 10
#define LPC_LCD_PAL73_I0_MASK 0x8000
#define LPC_LCD_PAL73_I0 0x8000
#define LPC_LCD_PAL73_I0_BIT 15
#define LPC_LCD_PAL73_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL73_R14_0_BIT 16
#define LPC_LCD_PAL73_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL73_G14_0_BIT 21
#define LPC_LCD_PAL73_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL73_B14_0_BIT 26
#define LPC_LCD_PAL73_I1_MASK 0x80000000
#define LPC_LCD_PAL73_I1 0x80000000
#define LPC_LCD_PAL73_I1_BIT 31

#define LPC_LCD_PAL74 (*(volatile unsigned long *)0x20088328)
#define LPC_LCD_PAL74_OFFSET 0x328
#define LPC_LCD_PAL74_R04_0_MASK 0x1F
#define LPC_LCD_PAL74_R04_0_BIT 0
#define LPC_LCD_PAL74_G04_0_MASK 0x3E0
#define LPC_LCD_PAL74_G04_0_BIT 5
#define LPC_LCD_PAL74_B04_0_MASK 0x7C00
#define LPC_LCD_PAL74_B04_0_BIT 10
#define LPC_LCD_PAL74_I0_MASK 0x8000
#define LPC_LCD_PAL74_I0 0x8000
#define LPC_LCD_PAL74_I0_BIT 15
#define LPC_LCD_PAL74_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL74_R14_0_BIT 16
#define LPC_LCD_PAL74_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL74_G14_0_BIT 21
#define LPC_LCD_PAL74_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL74_B14_0_BIT 26
#define LPC_LCD_PAL74_I1_MASK 0x80000000
#define LPC_LCD_PAL74_I1 0x80000000
#define LPC_LCD_PAL74_I1_BIT 31

#define LPC_LCD_PAL75 (*(volatile unsigned long *)0x2008832C)
#define LPC_LCD_PAL75_OFFSET 0x32C
#define LPC_LCD_PAL75_R04_0_MASK 0x1F
#define LPC_LCD_PAL75_R04_0_BIT 0
#define LPC_LCD_PAL75_G04_0_MASK 0x3E0
#define LPC_LCD_PAL75_G04_0_BIT 5
#define LPC_LCD_PAL75_B04_0_MASK 0x7C00
#define LPC_LCD_PAL75_B04_0_BIT 10
#define LPC_LCD_PAL75_I0_MASK 0x8000
#define LPC_LCD_PAL75_I0 0x8000
#define LPC_LCD_PAL75_I0_BIT 15
#define LPC_LCD_PAL75_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL75_R14_0_BIT 16
#define LPC_LCD_PAL75_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL75_G14_0_BIT 21
#define LPC_LCD_PAL75_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL75_B14_0_BIT 26
#define LPC_LCD_PAL75_I1_MASK 0x80000000
#define LPC_LCD_PAL75_I1 0x80000000
#define LPC_LCD_PAL75_I1_BIT 31

#define LPC_LCD_PAL76 (*(volatile unsigned long *)0x20088330)
#define LPC_LCD_PAL76_OFFSET 0x330
#define LPC_LCD_PAL76_R04_0_MASK 0x1F
#define LPC_LCD_PAL76_R04_0_BIT 0
#define LPC_LCD_PAL76_G04_0_MASK 0x3E0
#define LPC_LCD_PAL76_G04_0_BIT 5
#define LPC_LCD_PAL76_B04_0_MASK 0x7C00
#define LPC_LCD_PAL76_B04_0_BIT 10
#define LPC_LCD_PAL76_I0_MASK 0x8000
#define LPC_LCD_PAL76_I0 0x8000
#define LPC_LCD_PAL76_I0_BIT 15
#define LPC_LCD_PAL76_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL76_R14_0_BIT 16
#define LPC_LCD_PAL76_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL76_G14_0_BIT 21
#define LPC_LCD_PAL76_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL76_B14_0_BIT 26
#define LPC_LCD_PAL76_I1_MASK 0x80000000
#define LPC_LCD_PAL76_I1 0x80000000
#define LPC_LCD_PAL76_I1_BIT 31

#define LPC_LCD_PAL77 (*(volatile unsigned long *)0x20088334)
#define LPC_LCD_PAL77_OFFSET 0x334
#define LPC_LCD_PAL77_R04_0_MASK 0x1F
#define LPC_LCD_PAL77_R04_0_BIT 0
#define LPC_LCD_PAL77_G04_0_MASK 0x3E0
#define LPC_LCD_PAL77_G04_0_BIT 5
#define LPC_LCD_PAL77_B04_0_MASK 0x7C00
#define LPC_LCD_PAL77_B04_0_BIT 10
#define LPC_LCD_PAL77_I0_MASK 0x8000
#define LPC_LCD_PAL77_I0 0x8000
#define LPC_LCD_PAL77_I0_BIT 15
#define LPC_LCD_PAL77_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL77_R14_0_BIT 16
#define LPC_LCD_PAL77_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL77_G14_0_BIT 21
#define LPC_LCD_PAL77_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL77_B14_0_BIT 26
#define LPC_LCD_PAL77_I1_MASK 0x80000000
#define LPC_LCD_PAL77_I1 0x80000000
#define LPC_LCD_PAL77_I1_BIT 31

#define LPC_LCD_PAL78 (*(volatile unsigned long *)0x20088338)
#define LPC_LCD_PAL78_OFFSET 0x338
#define LPC_LCD_PAL78_R04_0_MASK 0x1F
#define LPC_LCD_PAL78_R04_0_BIT 0
#define LPC_LCD_PAL78_G04_0_MASK 0x3E0
#define LPC_LCD_PAL78_G04_0_BIT 5
#define LPC_LCD_PAL78_B04_0_MASK 0x7C00
#define LPC_LCD_PAL78_B04_0_BIT 10
#define LPC_LCD_PAL78_I0_MASK 0x8000
#define LPC_LCD_PAL78_I0 0x8000
#define LPC_LCD_PAL78_I0_BIT 15
#define LPC_LCD_PAL78_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL78_R14_0_BIT 16
#define LPC_LCD_PAL78_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL78_G14_0_BIT 21
#define LPC_LCD_PAL78_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL78_B14_0_BIT 26
#define LPC_LCD_PAL78_I1_MASK 0x80000000
#define LPC_LCD_PAL78_I1 0x80000000
#define LPC_LCD_PAL78_I1_BIT 31

#define LPC_LCD_PAL79 (*(volatile unsigned long *)0x2008833C)
#define LPC_LCD_PAL79_OFFSET 0x33C
#define LPC_LCD_PAL79_R04_0_MASK 0x1F
#define LPC_LCD_PAL79_R04_0_BIT 0
#define LPC_LCD_PAL79_G04_0_MASK 0x3E0
#define LPC_LCD_PAL79_G04_0_BIT 5
#define LPC_LCD_PAL79_B04_0_MASK 0x7C00
#define LPC_LCD_PAL79_B04_0_BIT 10
#define LPC_LCD_PAL79_I0_MASK 0x8000
#define LPC_LCD_PAL79_I0 0x8000
#define LPC_LCD_PAL79_I0_BIT 15
#define LPC_LCD_PAL79_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL79_R14_0_BIT 16
#define LPC_LCD_PAL79_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL79_G14_0_BIT 21
#define LPC_LCD_PAL79_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL79_B14_0_BIT 26
#define LPC_LCD_PAL79_I1_MASK 0x80000000
#define LPC_LCD_PAL79_I1 0x80000000
#define LPC_LCD_PAL79_I1_BIT 31

#define LPC_LCD_PAL80 (*(volatile unsigned long *)0x20088340)
#define LPC_LCD_PAL80_OFFSET 0x340
#define LPC_LCD_PAL80_R04_0_MASK 0x1F
#define LPC_LCD_PAL80_R04_0_BIT 0
#define LPC_LCD_PAL80_G04_0_MASK 0x3E0
#define LPC_LCD_PAL80_G04_0_BIT 5
#define LPC_LCD_PAL80_B04_0_MASK 0x7C00
#define LPC_LCD_PAL80_B04_0_BIT 10
#define LPC_LCD_PAL80_I0_MASK 0x8000
#define LPC_LCD_PAL80_I0 0x8000
#define LPC_LCD_PAL80_I0_BIT 15
#define LPC_LCD_PAL80_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL80_R14_0_BIT 16
#define LPC_LCD_PAL80_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL80_G14_0_BIT 21
#define LPC_LCD_PAL80_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL80_B14_0_BIT 26
#define LPC_LCD_PAL80_I1_MASK 0x80000000
#define LPC_LCD_PAL80_I1 0x80000000
#define LPC_LCD_PAL80_I1_BIT 31

#define LPC_LCD_PAL81 (*(volatile unsigned long *)0x20088344)
#define LPC_LCD_PAL81_OFFSET 0x344
#define LPC_LCD_PAL81_R04_0_MASK 0x1F
#define LPC_LCD_PAL81_R04_0_BIT 0
#define LPC_LCD_PAL81_G04_0_MASK 0x3E0
#define LPC_LCD_PAL81_G04_0_BIT 5
#define LPC_LCD_PAL81_B04_0_MASK 0x7C00
#define LPC_LCD_PAL81_B04_0_BIT 10
#define LPC_LCD_PAL81_I0_MASK 0x8000
#define LPC_LCD_PAL81_I0 0x8000
#define LPC_LCD_PAL81_I0_BIT 15
#define LPC_LCD_PAL81_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL81_R14_0_BIT 16
#define LPC_LCD_PAL81_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL81_G14_0_BIT 21
#define LPC_LCD_PAL81_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL81_B14_0_BIT 26
#define LPC_LCD_PAL81_I1_MASK 0x80000000
#define LPC_LCD_PAL81_I1 0x80000000
#define LPC_LCD_PAL81_I1_BIT 31

#define LPC_LCD_PAL82 (*(volatile unsigned long *)0x20088348)
#define LPC_LCD_PAL82_OFFSET 0x348
#define LPC_LCD_PAL82_R04_0_MASK 0x1F
#define LPC_LCD_PAL82_R04_0_BIT 0
#define LPC_LCD_PAL82_G04_0_MASK 0x3E0
#define LPC_LCD_PAL82_G04_0_BIT 5
#define LPC_LCD_PAL82_B04_0_MASK 0x7C00
#define LPC_LCD_PAL82_B04_0_BIT 10
#define LPC_LCD_PAL82_I0_MASK 0x8000
#define LPC_LCD_PAL82_I0 0x8000
#define LPC_LCD_PAL82_I0_BIT 15
#define LPC_LCD_PAL82_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL82_R14_0_BIT 16
#define LPC_LCD_PAL82_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL82_G14_0_BIT 21
#define LPC_LCD_PAL82_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL82_B14_0_BIT 26
#define LPC_LCD_PAL82_I1_MASK 0x80000000
#define LPC_LCD_PAL82_I1 0x80000000
#define LPC_LCD_PAL82_I1_BIT 31

#define LPC_LCD_PAL83 (*(volatile unsigned long *)0x2008834C)
#define LPC_LCD_PAL83_OFFSET 0x34C
#define LPC_LCD_PAL83_R04_0_MASK 0x1F
#define LPC_LCD_PAL83_R04_0_BIT 0
#define LPC_LCD_PAL83_G04_0_MASK 0x3E0
#define LPC_LCD_PAL83_G04_0_BIT 5
#define LPC_LCD_PAL83_B04_0_MASK 0x7C00
#define LPC_LCD_PAL83_B04_0_BIT 10
#define LPC_LCD_PAL83_I0_MASK 0x8000
#define LPC_LCD_PAL83_I0 0x8000
#define LPC_LCD_PAL83_I0_BIT 15
#define LPC_LCD_PAL83_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL83_R14_0_BIT 16
#define LPC_LCD_PAL83_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL83_G14_0_BIT 21
#define LPC_LCD_PAL83_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL83_B14_0_BIT 26
#define LPC_LCD_PAL83_I1_MASK 0x80000000
#define LPC_LCD_PAL83_I1 0x80000000
#define LPC_LCD_PAL83_I1_BIT 31

#define LPC_LCD_PAL84 (*(volatile unsigned long *)0x20088350)
#define LPC_LCD_PAL84_OFFSET 0x350
#define LPC_LCD_PAL84_R04_0_MASK 0x1F
#define LPC_LCD_PAL84_R04_0_BIT 0
#define LPC_LCD_PAL84_G04_0_MASK 0x3E0
#define LPC_LCD_PAL84_G04_0_BIT 5
#define LPC_LCD_PAL84_B04_0_MASK 0x7C00
#define LPC_LCD_PAL84_B04_0_BIT 10
#define LPC_LCD_PAL84_I0_MASK 0x8000
#define LPC_LCD_PAL84_I0 0x8000
#define LPC_LCD_PAL84_I0_BIT 15
#define LPC_LCD_PAL84_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL84_R14_0_BIT 16
#define LPC_LCD_PAL84_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL84_G14_0_BIT 21
#define LPC_LCD_PAL84_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL84_B14_0_BIT 26
#define LPC_LCD_PAL84_I1_MASK 0x80000000
#define LPC_LCD_PAL84_I1 0x80000000
#define LPC_LCD_PAL84_I1_BIT 31

#define LPC_LCD_PAL85 (*(volatile unsigned long *)0x20088354)
#define LPC_LCD_PAL85_OFFSET 0x354
#define LPC_LCD_PAL85_R04_0_MASK 0x1F
#define LPC_LCD_PAL85_R04_0_BIT 0
#define LPC_LCD_PAL85_G04_0_MASK 0x3E0
#define LPC_LCD_PAL85_G04_0_BIT 5
#define LPC_LCD_PAL85_B04_0_MASK 0x7C00
#define LPC_LCD_PAL85_B04_0_BIT 10
#define LPC_LCD_PAL85_I0_MASK 0x8000
#define LPC_LCD_PAL85_I0 0x8000
#define LPC_LCD_PAL85_I0_BIT 15
#define LPC_LCD_PAL85_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL85_R14_0_BIT 16
#define LPC_LCD_PAL85_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL85_G14_0_BIT 21
#define LPC_LCD_PAL85_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL85_B14_0_BIT 26
#define LPC_LCD_PAL85_I1_MASK 0x80000000
#define LPC_LCD_PAL85_I1 0x80000000
#define LPC_LCD_PAL85_I1_BIT 31

#define LPC_LCD_PAL86 (*(volatile unsigned long *)0x20088358)
#define LPC_LCD_PAL86_OFFSET 0x358
#define LPC_LCD_PAL86_R04_0_MASK 0x1F
#define LPC_LCD_PAL86_R04_0_BIT 0
#define LPC_LCD_PAL86_G04_0_MASK 0x3E0
#define LPC_LCD_PAL86_G04_0_BIT 5
#define LPC_LCD_PAL86_B04_0_MASK 0x7C00
#define LPC_LCD_PAL86_B04_0_BIT 10
#define LPC_LCD_PAL86_I0_MASK 0x8000
#define LPC_LCD_PAL86_I0 0x8000
#define LPC_LCD_PAL86_I0_BIT 15
#define LPC_LCD_PAL86_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL86_R14_0_BIT 16
#define LPC_LCD_PAL86_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL86_G14_0_BIT 21
#define LPC_LCD_PAL86_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL86_B14_0_BIT 26
#define LPC_LCD_PAL86_I1_MASK 0x80000000
#define LPC_LCD_PAL86_I1 0x80000000
#define LPC_LCD_PAL86_I1_BIT 31

#define LPC_LCD_PAL87 (*(volatile unsigned long *)0x2008835C)
#define LPC_LCD_PAL87_OFFSET 0x35C
#define LPC_LCD_PAL87_R04_0_MASK 0x1F
#define LPC_LCD_PAL87_R04_0_BIT 0
#define LPC_LCD_PAL87_G04_0_MASK 0x3E0
#define LPC_LCD_PAL87_G04_0_BIT 5
#define LPC_LCD_PAL87_B04_0_MASK 0x7C00
#define LPC_LCD_PAL87_B04_0_BIT 10
#define LPC_LCD_PAL87_I0_MASK 0x8000
#define LPC_LCD_PAL87_I0 0x8000
#define LPC_LCD_PAL87_I0_BIT 15
#define LPC_LCD_PAL87_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL87_R14_0_BIT 16
#define LPC_LCD_PAL87_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL87_G14_0_BIT 21
#define LPC_LCD_PAL87_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL87_B14_0_BIT 26
#define LPC_LCD_PAL87_I1_MASK 0x80000000
#define LPC_LCD_PAL87_I1 0x80000000
#define LPC_LCD_PAL87_I1_BIT 31

#define LPC_LCD_PAL88 (*(volatile unsigned long *)0x20088360)
#define LPC_LCD_PAL88_OFFSET 0x360
#define LPC_LCD_PAL88_R04_0_MASK 0x1F
#define LPC_LCD_PAL88_R04_0_BIT 0
#define LPC_LCD_PAL88_G04_0_MASK 0x3E0
#define LPC_LCD_PAL88_G04_0_BIT 5
#define LPC_LCD_PAL88_B04_0_MASK 0x7C00
#define LPC_LCD_PAL88_B04_0_BIT 10
#define LPC_LCD_PAL88_I0_MASK 0x8000
#define LPC_LCD_PAL88_I0 0x8000
#define LPC_LCD_PAL88_I0_BIT 15
#define LPC_LCD_PAL88_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL88_R14_0_BIT 16
#define LPC_LCD_PAL88_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL88_G14_0_BIT 21
#define LPC_LCD_PAL88_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL88_B14_0_BIT 26
#define LPC_LCD_PAL88_I1_MASK 0x80000000
#define LPC_LCD_PAL88_I1 0x80000000
#define LPC_LCD_PAL88_I1_BIT 31

#define LPC_LCD_PAL89 (*(volatile unsigned long *)0x20088364)
#define LPC_LCD_PAL89_OFFSET 0x364
#define LPC_LCD_PAL89_R04_0_MASK 0x1F
#define LPC_LCD_PAL89_R04_0_BIT 0
#define LPC_LCD_PAL89_G04_0_MASK 0x3E0
#define LPC_LCD_PAL89_G04_0_BIT 5
#define LPC_LCD_PAL89_B04_0_MASK 0x7C00
#define LPC_LCD_PAL89_B04_0_BIT 10
#define LPC_LCD_PAL89_I0_MASK 0x8000
#define LPC_LCD_PAL89_I0 0x8000
#define LPC_LCD_PAL89_I0_BIT 15
#define LPC_LCD_PAL89_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL89_R14_0_BIT 16
#define LPC_LCD_PAL89_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL89_G14_0_BIT 21
#define LPC_LCD_PAL89_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL89_B14_0_BIT 26
#define LPC_LCD_PAL89_I1_MASK 0x80000000
#define LPC_LCD_PAL89_I1 0x80000000
#define LPC_LCD_PAL89_I1_BIT 31

#define LPC_LCD_PAL90 (*(volatile unsigned long *)0x20088368)
#define LPC_LCD_PAL90_OFFSET 0x368
#define LPC_LCD_PAL90_R04_0_MASK 0x1F
#define LPC_LCD_PAL90_R04_0_BIT 0
#define LPC_LCD_PAL90_G04_0_MASK 0x3E0
#define LPC_LCD_PAL90_G04_0_BIT 5
#define LPC_LCD_PAL90_B04_0_MASK 0x7C00
#define LPC_LCD_PAL90_B04_0_BIT 10
#define LPC_LCD_PAL90_I0_MASK 0x8000
#define LPC_LCD_PAL90_I0 0x8000
#define LPC_LCD_PAL90_I0_BIT 15
#define LPC_LCD_PAL90_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL90_R14_0_BIT 16
#define LPC_LCD_PAL90_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL90_G14_0_BIT 21
#define LPC_LCD_PAL90_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL90_B14_0_BIT 26
#define LPC_LCD_PAL90_I1_MASK 0x80000000
#define LPC_LCD_PAL90_I1 0x80000000
#define LPC_LCD_PAL90_I1_BIT 31

#define LPC_LCD_PAL91 (*(volatile unsigned long *)0x2008836C)
#define LPC_LCD_PAL91_OFFSET 0x36C
#define LPC_LCD_PAL91_R04_0_MASK 0x1F
#define LPC_LCD_PAL91_R04_0_BIT 0
#define LPC_LCD_PAL91_G04_0_MASK 0x3E0
#define LPC_LCD_PAL91_G04_0_BIT 5
#define LPC_LCD_PAL91_B04_0_MASK 0x7C00
#define LPC_LCD_PAL91_B04_0_BIT 10
#define LPC_LCD_PAL91_I0_MASK 0x8000
#define LPC_LCD_PAL91_I0 0x8000
#define LPC_LCD_PAL91_I0_BIT 15
#define LPC_LCD_PAL91_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL91_R14_0_BIT 16
#define LPC_LCD_PAL91_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL91_G14_0_BIT 21
#define LPC_LCD_PAL91_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL91_B14_0_BIT 26
#define LPC_LCD_PAL91_I1_MASK 0x80000000
#define LPC_LCD_PAL91_I1 0x80000000
#define LPC_LCD_PAL91_I1_BIT 31

#define LPC_LCD_PAL92 (*(volatile unsigned long *)0x20088370)
#define LPC_LCD_PAL92_OFFSET 0x370
#define LPC_LCD_PAL92_R04_0_MASK 0x1F
#define LPC_LCD_PAL92_R04_0_BIT 0
#define LPC_LCD_PAL92_G04_0_MASK 0x3E0
#define LPC_LCD_PAL92_G04_0_BIT 5
#define LPC_LCD_PAL92_B04_0_MASK 0x7C00
#define LPC_LCD_PAL92_B04_0_BIT 10
#define LPC_LCD_PAL92_I0_MASK 0x8000
#define LPC_LCD_PAL92_I0 0x8000
#define LPC_LCD_PAL92_I0_BIT 15
#define LPC_LCD_PAL92_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL92_R14_0_BIT 16
#define LPC_LCD_PAL92_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL92_G14_0_BIT 21
#define LPC_LCD_PAL92_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL92_B14_0_BIT 26
#define LPC_LCD_PAL92_I1_MASK 0x80000000
#define LPC_LCD_PAL92_I1 0x80000000
#define LPC_LCD_PAL92_I1_BIT 31

#define LPC_LCD_PAL93 (*(volatile unsigned long *)0x20088374)
#define LPC_LCD_PAL93_OFFSET 0x374
#define LPC_LCD_PAL93_R04_0_MASK 0x1F
#define LPC_LCD_PAL93_R04_0_BIT 0
#define LPC_LCD_PAL93_G04_0_MASK 0x3E0
#define LPC_LCD_PAL93_G04_0_BIT 5
#define LPC_LCD_PAL93_B04_0_MASK 0x7C00
#define LPC_LCD_PAL93_B04_0_BIT 10
#define LPC_LCD_PAL93_I0_MASK 0x8000
#define LPC_LCD_PAL93_I0 0x8000
#define LPC_LCD_PAL93_I0_BIT 15
#define LPC_LCD_PAL93_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL93_R14_0_BIT 16
#define LPC_LCD_PAL93_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL93_G14_0_BIT 21
#define LPC_LCD_PAL93_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL93_B14_0_BIT 26
#define LPC_LCD_PAL93_I1_MASK 0x80000000
#define LPC_LCD_PAL93_I1 0x80000000
#define LPC_LCD_PAL93_I1_BIT 31

#define LPC_LCD_PAL94 (*(volatile unsigned long *)0x20088378)
#define LPC_LCD_PAL94_OFFSET 0x378
#define LPC_LCD_PAL94_R04_0_MASK 0x1F
#define LPC_LCD_PAL94_R04_0_BIT 0
#define LPC_LCD_PAL94_G04_0_MASK 0x3E0
#define LPC_LCD_PAL94_G04_0_BIT 5
#define LPC_LCD_PAL94_B04_0_MASK 0x7C00
#define LPC_LCD_PAL94_B04_0_BIT 10
#define LPC_LCD_PAL94_I0_MASK 0x8000
#define LPC_LCD_PAL94_I0 0x8000
#define LPC_LCD_PAL94_I0_BIT 15
#define LPC_LCD_PAL94_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL94_R14_0_BIT 16
#define LPC_LCD_PAL94_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL94_G14_0_BIT 21
#define LPC_LCD_PAL94_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL94_B14_0_BIT 26
#define LPC_LCD_PAL94_I1_MASK 0x80000000
#define LPC_LCD_PAL94_I1 0x80000000
#define LPC_LCD_PAL94_I1_BIT 31

#define LPC_LCD_PAL95 (*(volatile unsigned long *)0x2008837C)
#define LPC_LCD_PAL95_OFFSET 0x37C
#define LPC_LCD_PAL95_R04_0_MASK 0x1F
#define LPC_LCD_PAL95_R04_0_BIT 0
#define LPC_LCD_PAL95_G04_0_MASK 0x3E0
#define LPC_LCD_PAL95_G04_0_BIT 5
#define LPC_LCD_PAL95_B04_0_MASK 0x7C00
#define LPC_LCD_PAL95_B04_0_BIT 10
#define LPC_LCD_PAL95_I0_MASK 0x8000
#define LPC_LCD_PAL95_I0 0x8000
#define LPC_LCD_PAL95_I0_BIT 15
#define LPC_LCD_PAL95_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL95_R14_0_BIT 16
#define LPC_LCD_PAL95_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL95_G14_0_BIT 21
#define LPC_LCD_PAL95_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL95_B14_0_BIT 26
#define LPC_LCD_PAL95_I1_MASK 0x80000000
#define LPC_LCD_PAL95_I1 0x80000000
#define LPC_LCD_PAL95_I1_BIT 31

#define LPC_LCD_PAL96 (*(volatile unsigned long *)0x20088380)
#define LPC_LCD_PAL96_OFFSET 0x380
#define LPC_LCD_PAL96_R04_0_MASK 0x1F
#define LPC_LCD_PAL96_R04_0_BIT 0
#define LPC_LCD_PAL96_G04_0_MASK 0x3E0
#define LPC_LCD_PAL96_G04_0_BIT 5
#define LPC_LCD_PAL96_B04_0_MASK 0x7C00
#define LPC_LCD_PAL96_B04_0_BIT 10
#define LPC_LCD_PAL96_I0_MASK 0x8000
#define LPC_LCD_PAL96_I0 0x8000
#define LPC_LCD_PAL96_I0_BIT 15
#define LPC_LCD_PAL96_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL96_R14_0_BIT 16
#define LPC_LCD_PAL96_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL96_G14_0_BIT 21
#define LPC_LCD_PAL96_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL96_B14_0_BIT 26
#define LPC_LCD_PAL96_I1_MASK 0x80000000
#define LPC_LCD_PAL96_I1 0x80000000
#define LPC_LCD_PAL96_I1_BIT 31

#define LPC_LCD_PAL97 (*(volatile unsigned long *)0x20088384)
#define LPC_LCD_PAL97_OFFSET 0x384
#define LPC_LCD_PAL97_R04_0_MASK 0x1F
#define LPC_LCD_PAL97_R04_0_BIT 0
#define LPC_LCD_PAL97_G04_0_MASK 0x3E0
#define LPC_LCD_PAL97_G04_0_BIT 5
#define LPC_LCD_PAL97_B04_0_MASK 0x7C00
#define LPC_LCD_PAL97_B04_0_BIT 10
#define LPC_LCD_PAL97_I0_MASK 0x8000
#define LPC_LCD_PAL97_I0 0x8000
#define LPC_LCD_PAL97_I0_BIT 15
#define LPC_LCD_PAL97_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL97_R14_0_BIT 16
#define LPC_LCD_PAL97_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL97_G14_0_BIT 21
#define LPC_LCD_PAL97_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL97_B14_0_BIT 26
#define LPC_LCD_PAL97_I1_MASK 0x80000000
#define LPC_LCD_PAL97_I1 0x80000000
#define LPC_LCD_PAL97_I1_BIT 31

#define LPC_LCD_PAL98 (*(volatile unsigned long *)0x20088388)
#define LPC_LCD_PAL98_OFFSET 0x388
#define LPC_LCD_PAL98_R04_0_MASK 0x1F
#define LPC_LCD_PAL98_R04_0_BIT 0
#define LPC_LCD_PAL98_G04_0_MASK 0x3E0
#define LPC_LCD_PAL98_G04_0_BIT 5
#define LPC_LCD_PAL98_B04_0_MASK 0x7C00
#define LPC_LCD_PAL98_B04_0_BIT 10
#define LPC_LCD_PAL98_I0_MASK 0x8000
#define LPC_LCD_PAL98_I0 0x8000
#define LPC_LCD_PAL98_I0_BIT 15
#define LPC_LCD_PAL98_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL98_R14_0_BIT 16
#define LPC_LCD_PAL98_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL98_G14_0_BIT 21
#define LPC_LCD_PAL98_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL98_B14_0_BIT 26
#define LPC_LCD_PAL98_I1_MASK 0x80000000
#define LPC_LCD_PAL98_I1 0x80000000
#define LPC_LCD_PAL98_I1_BIT 31

#define LPC_LCD_PAL99 (*(volatile unsigned long *)0x2008838C)
#define LPC_LCD_PAL99_OFFSET 0x38C
#define LPC_LCD_PAL99_R04_0_MASK 0x1F
#define LPC_LCD_PAL99_R04_0_BIT 0
#define LPC_LCD_PAL99_G04_0_MASK 0x3E0
#define LPC_LCD_PAL99_G04_0_BIT 5
#define LPC_LCD_PAL99_B04_0_MASK 0x7C00
#define LPC_LCD_PAL99_B04_0_BIT 10
#define LPC_LCD_PAL99_I0_MASK 0x8000
#define LPC_LCD_PAL99_I0 0x8000
#define LPC_LCD_PAL99_I0_BIT 15
#define LPC_LCD_PAL99_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL99_R14_0_BIT 16
#define LPC_LCD_PAL99_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL99_G14_0_BIT 21
#define LPC_LCD_PAL99_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL99_B14_0_BIT 26
#define LPC_LCD_PAL99_I1_MASK 0x80000000
#define LPC_LCD_PAL99_I1 0x80000000
#define LPC_LCD_PAL99_I1_BIT 31

#define LPC_LCD_PAL100 (*(volatile unsigned long *)0x20088390)
#define LPC_LCD_PAL100_OFFSET 0x390
#define LPC_LCD_PAL100_R04_0_MASK 0x1F
#define LPC_LCD_PAL100_R04_0_BIT 0
#define LPC_LCD_PAL100_G04_0_MASK 0x3E0
#define LPC_LCD_PAL100_G04_0_BIT 5
#define LPC_LCD_PAL100_B04_0_MASK 0x7C00
#define LPC_LCD_PAL100_B04_0_BIT 10
#define LPC_LCD_PAL100_I0_MASK 0x8000
#define LPC_LCD_PAL100_I0 0x8000
#define LPC_LCD_PAL100_I0_BIT 15
#define LPC_LCD_PAL100_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL100_R14_0_BIT 16
#define LPC_LCD_PAL100_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL100_G14_0_BIT 21
#define LPC_LCD_PAL100_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL100_B14_0_BIT 26
#define LPC_LCD_PAL100_I1_MASK 0x80000000
#define LPC_LCD_PAL100_I1 0x80000000
#define LPC_LCD_PAL100_I1_BIT 31

#define LPC_LCD_PAL101 (*(volatile unsigned long *)0x20088394)
#define LPC_LCD_PAL101_OFFSET 0x394
#define LPC_LCD_PAL101_R04_0_MASK 0x1F
#define LPC_LCD_PAL101_R04_0_BIT 0
#define LPC_LCD_PAL101_G04_0_MASK 0x3E0
#define LPC_LCD_PAL101_G04_0_BIT 5
#define LPC_LCD_PAL101_B04_0_MASK 0x7C00
#define LPC_LCD_PAL101_B04_0_BIT 10
#define LPC_LCD_PAL101_I0_MASK 0x8000
#define LPC_LCD_PAL101_I0 0x8000
#define LPC_LCD_PAL101_I0_BIT 15
#define LPC_LCD_PAL101_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL101_R14_0_BIT 16
#define LPC_LCD_PAL101_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL101_G14_0_BIT 21
#define LPC_LCD_PAL101_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL101_B14_0_BIT 26
#define LPC_LCD_PAL101_I1_MASK 0x80000000
#define LPC_LCD_PAL101_I1 0x80000000
#define LPC_LCD_PAL101_I1_BIT 31

#define LPC_LCD_PAL102 (*(volatile unsigned long *)0x20088398)
#define LPC_LCD_PAL102_OFFSET 0x398
#define LPC_LCD_PAL102_R04_0_MASK 0x1F
#define LPC_LCD_PAL102_R04_0_BIT 0
#define LPC_LCD_PAL102_G04_0_MASK 0x3E0
#define LPC_LCD_PAL102_G04_0_BIT 5
#define LPC_LCD_PAL102_B04_0_MASK 0x7C00
#define LPC_LCD_PAL102_B04_0_BIT 10
#define LPC_LCD_PAL102_I0_MASK 0x8000
#define LPC_LCD_PAL102_I0 0x8000
#define LPC_LCD_PAL102_I0_BIT 15
#define LPC_LCD_PAL102_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL102_R14_0_BIT 16
#define LPC_LCD_PAL102_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL102_G14_0_BIT 21
#define LPC_LCD_PAL102_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL102_B14_0_BIT 26
#define LPC_LCD_PAL102_I1_MASK 0x80000000
#define LPC_LCD_PAL102_I1 0x80000000
#define LPC_LCD_PAL102_I1_BIT 31

#define LPC_LCD_PAL103 (*(volatile unsigned long *)0x2008839C)
#define LPC_LCD_PAL103_OFFSET 0x39C
#define LPC_LCD_PAL103_R04_0_MASK 0x1F
#define LPC_LCD_PAL103_R04_0_BIT 0
#define LPC_LCD_PAL103_G04_0_MASK 0x3E0
#define LPC_LCD_PAL103_G04_0_BIT 5
#define LPC_LCD_PAL103_B04_0_MASK 0x7C00
#define LPC_LCD_PAL103_B04_0_BIT 10
#define LPC_LCD_PAL103_I0_MASK 0x8000
#define LPC_LCD_PAL103_I0 0x8000
#define LPC_LCD_PAL103_I0_BIT 15
#define LPC_LCD_PAL103_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL103_R14_0_BIT 16
#define LPC_LCD_PAL103_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL103_G14_0_BIT 21
#define LPC_LCD_PAL103_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL103_B14_0_BIT 26
#define LPC_LCD_PAL103_I1_MASK 0x80000000
#define LPC_LCD_PAL103_I1 0x80000000
#define LPC_LCD_PAL103_I1_BIT 31

#define LPC_LCD_PAL104 (*(volatile unsigned long *)0x200883A0)
#define LPC_LCD_PAL104_OFFSET 0x3A0
#define LPC_LCD_PAL104_R04_0_MASK 0x1F
#define LPC_LCD_PAL104_R04_0_BIT 0
#define LPC_LCD_PAL104_G04_0_MASK 0x3E0
#define LPC_LCD_PAL104_G04_0_BIT 5
#define LPC_LCD_PAL104_B04_0_MASK 0x7C00
#define LPC_LCD_PAL104_B04_0_BIT 10
#define LPC_LCD_PAL104_I0_MASK 0x8000
#define LPC_LCD_PAL104_I0 0x8000
#define LPC_LCD_PAL104_I0_BIT 15
#define LPC_LCD_PAL104_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL104_R14_0_BIT 16
#define LPC_LCD_PAL104_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL104_G14_0_BIT 21
#define LPC_LCD_PAL104_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL104_B14_0_BIT 26
#define LPC_LCD_PAL104_I1_MASK 0x80000000
#define LPC_LCD_PAL104_I1 0x80000000
#define LPC_LCD_PAL104_I1_BIT 31

#define LPC_LCD_PAL105 (*(volatile unsigned long *)0x200883A4)
#define LPC_LCD_PAL105_OFFSET 0x3A4
#define LPC_LCD_PAL105_R04_0_MASK 0x1F
#define LPC_LCD_PAL105_R04_0_BIT 0
#define LPC_LCD_PAL105_G04_0_MASK 0x3E0
#define LPC_LCD_PAL105_G04_0_BIT 5
#define LPC_LCD_PAL105_B04_0_MASK 0x7C00
#define LPC_LCD_PAL105_B04_0_BIT 10
#define LPC_LCD_PAL105_I0_MASK 0x8000
#define LPC_LCD_PAL105_I0 0x8000
#define LPC_LCD_PAL105_I0_BIT 15
#define LPC_LCD_PAL105_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL105_R14_0_BIT 16
#define LPC_LCD_PAL105_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL105_G14_0_BIT 21
#define LPC_LCD_PAL105_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL105_B14_0_BIT 26
#define LPC_LCD_PAL105_I1_MASK 0x80000000
#define LPC_LCD_PAL105_I1 0x80000000
#define LPC_LCD_PAL105_I1_BIT 31

#define LPC_LCD_PAL106 (*(volatile unsigned long *)0x200883A8)
#define LPC_LCD_PAL106_OFFSET 0x3A8
#define LPC_LCD_PAL106_R04_0_MASK 0x1F
#define LPC_LCD_PAL106_R04_0_BIT 0
#define LPC_LCD_PAL106_G04_0_MASK 0x3E0
#define LPC_LCD_PAL106_G04_0_BIT 5
#define LPC_LCD_PAL106_B04_0_MASK 0x7C00
#define LPC_LCD_PAL106_B04_0_BIT 10
#define LPC_LCD_PAL106_I0_MASK 0x8000
#define LPC_LCD_PAL106_I0 0x8000
#define LPC_LCD_PAL106_I0_BIT 15
#define LPC_LCD_PAL106_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL106_R14_0_BIT 16
#define LPC_LCD_PAL106_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL106_G14_0_BIT 21
#define LPC_LCD_PAL106_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL106_B14_0_BIT 26
#define LPC_LCD_PAL106_I1_MASK 0x80000000
#define LPC_LCD_PAL106_I1 0x80000000
#define LPC_LCD_PAL106_I1_BIT 31

#define LPC_LCD_PAL107 (*(volatile unsigned long *)0x200883AC)
#define LPC_LCD_PAL107_OFFSET 0x3AC
#define LPC_LCD_PAL107_R04_0_MASK 0x1F
#define LPC_LCD_PAL107_R04_0_BIT 0
#define LPC_LCD_PAL107_G04_0_MASK 0x3E0
#define LPC_LCD_PAL107_G04_0_BIT 5
#define LPC_LCD_PAL107_B04_0_MASK 0x7C00
#define LPC_LCD_PAL107_B04_0_BIT 10
#define LPC_LCD_PAL107_I0_MASK 0x8000
#define LPC_LCD_PAL107_I0 0x8000
#define LPC_LCD_PAL107_I0_BIT 15
#define LPC_LCD_PAL107_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL107_R14_0_BIT 16
#define LPC_LCD_PAL107_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL107_G14_0_BIT 21
#define LPC_LCD_PAL107_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL107_B14_0_BIT 26
#define LPC_LCD_PAL107_I1_MASK 0x80000000
#define LPC_LCD_PAL107_I1 0x80000000
#define LPC_LCD_PAL107_I1_BIT 31

#define LPC_LCD_PAL108 (*(volatile unsigned long *)0x200883B0)
#define LPC_LCD_PAL108_OFFSET 0x3B0
#define LPC_LCD_PAL108_R04_0_MASK 0x1F
#define LPC_LCD_PAL108_R04_0_BIT 0
#define LPC_LCD_PAL108_G04_0_MASK 0x3E0
#define LPC_LCD_PAL108_G04_0_BIT 5
#define LPC_LCD_PAL108_B04_0_MASK 0x7C00
#define LPC_LCD_PAL108_B04_0_BIT 10
#define LPC_LCD_PAL108_I0_MASK 0x8000
#define LPC_LCD_PAL108_I0 0x8000
#define LPC_LCD_PAL108_I0_BIT 15
#define LPC_LCD_PAL108_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL108_R14_0_BIT 16
#define LPC_LCD_PAL108_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL108_G14_0_BIT 21
#define LPC_LCD_PAL108_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL108_B14_0_BIT 26
#define LPC_LCD_PAL108_I1_MASK 0x80000000
#define LPC_LCD_PAL108_I1 0x80000000
#define LPC_LCD_PAL108_I1_BIT 31

#define LPC_LCD_PAL109 (*(volatile unsigned long *)0x200883B4)
#define LPC_LCD_PAL109_OFFSET 0x3B4
#define LPC_LCD_PAL109_R04_0_MASK 0x1F
#define LPC_LCD_PAL109_R04_0_BIT 0
#define LPC_LCD_PAL109_G04_0_MASK 0x3E0
#define LPC_LCD_PAL109_G04_0_BIT 5
#define LPC_LCD_PAL109_B04_0_MASK 0x7C00
#define LPC_LCD_PAL109_B04_0_BIT 10
#define LPC_LCD_PAL109_I0_MASK 0x8000
#define LPC_LCD_PAL109_I0 0x8000
#define LPC_LCD_PAL109_I0_BIT 15
#define LPC_LCD_PAL109_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL109_R14_0_BIT 16
#define LPC_LCD_PAL109_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL109_G14_0_BIT 21
#define LPC_LCD_PAL109_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL109_B14_0_BIT 26
#define LPC_LCD_PAL109_I1_MASK 0x80000000
#define LPC_LCD_PAL109_I1 0x80000000
#define LPC_LCD_PAL109_I1_BIT 31

#define LPC_LCD_PAL110 (*(volatile unsigned long *)0x200883B8)
#define LPC_LCD_PAL110_OFFSET 0x3B8
#define LPC_LCD_PAL110_R04_0_MASK 0x1F
#define LPC_LCD_PAL110_R04_0_BIT 0
#define LPC_LCD_PAL110_G04_0_MASK 0x3E0
#define LPC_LCD_PAL110_G04_0_BIT 5
#define LPC_LCD_PAL110_B04_0_MASK 0x7C00
#define LPC_LCD_PAL110_B04_0_BIT 10
#define LPC_LCD_PAL110_I0_MASK 0x8000
#define LPC_LCD_PAL110_I0 0x8000
#define LPC_LCD_PAL110_I0_BIT 15
#define LPC_LCD_PAL110_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL110_R14_0_BIT 16
#define LPC_LCD_PAL110_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL110_G14_0_BIT 21
#define LPC_LCD_PAL110_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL110_B14_0_BIT 26
#define LPC_LCD_PAL110_I1_MASK 0x80000000
#define LPC_LCD_PAL110_I1 0x80000000
#define LPC_LCD_PAL110_I1_BIT 31

#define LPC_LCD_PAL111 (*(volatile unsigned long *)0x200883BC)
#define LPC_LCD_PAL111_OFFSET 0x3BC
#define LPC_LCD_PAL111_R04_0_MASK 0x1F
#define LPC_LCD_PAL111_R04_0_BIT 0
#define LPC_LCD_PAL111_G04_0_MASK 0x3E0
#define LPC_LCD_PAL111_G04_0_BIT 5
#define LPC_LCD_PAL111_B04_0_MASK 0x7C00
#define LPC_LCD_PAL111_B04_0_BIT 10
#define LPC_LCD_PAL111_I0_MASK 0x8000
#define LPC_LCD_PAL111_I0 0x8000
#define LPC_LCD_PAL111_I0_BIT 15
#define LPC_LCD_PAL111_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL111_R14_0_BIT 16
#define LPC_LCD_PAL111_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL111_G14_0_BIT 21
#define LPC_LCD_PAL111_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL111_B14_0_BIT 26
#define LPC_LCD_PAL111_I1_MASK 0x80000000
#define LPC_LCD_PAL111_I1 0x80000000
#define LPC_LCD_PAL111_I1_BIT 31

#define LPC_LCD_PAL112 (*(volatile unsigned long *)0x200883C0)
#define LPC_LCD_PAL112_OFFSET 0x3C0
#define LPC_LCD_PAL112_R04_0_MASK 0x1F
#define LPC_LCD_PAL112_R04_0_BIT 0
#define LPC_LCD_PAL112_G04_0_MASK 0x3E0
#define LPC_LCD_PAL112_G04_0_BIT 5
#define LPC_LCD_PAL112_B04_0_MASK 0x7C00
#define LPC_LCD_PAL112_B04_0_BIT 10
#define LPC_LCD_PAL112_I0_MASK 0x8000
#define LPC_LCD_PAL112_I0 0x8000
#define LPC_LCD_PAL112_I0_BIT 15
#define LPC_LCD_PAL112_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL112_R14_0_BIT 16
#define LPC_LCD_PAL112_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL112_G14_0_BIT 21
#define LPC_LCD_PAL112_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL112_B14_0_BIT 26
#define LPC_LCD_PAL112_I1_MASK 0x80000000
#define LPC_LCD_PAL112_I1 0x80000000
#define LPC_LCD_PAL112_I1_BIT 31

#define LPC_LCD_PAL113 (*(volatile unsigned long *)0x200883C4)
#define LPC_LCD_PAL113_OFFSET 0x3C4
#define LPC_LCD_PAL113_R04_0_MASK 0x1F
#define LPC_LCD_PAL113_R04_0_BIT 0
#define LPC_LCD_PAL113_G04_0_MASK 0x3E0
#define LPC_LCD_PAL113_G04_0_BIT 5
#define LPC_LCD_PAL113_B04_0_MASK 0x7C00
#define LPC_LCD_PAL113_B04_0_BIT 10
#define LPC_LCD_PAL113_I0_MASK 0x8000
#define LPC_LCD_PAL113_I0 0x8000
#define LPC_LCD_PAL113_I0_BIT 15
#define LPC_LCD_PAL113_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL113_R14_0_BIT 16
#define LPC_LCD_PAL113_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL113_G14_0_BIT 21
#define LPC_LCD_PAL113_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL113_B14_0_BIT 26
#define LPC_LCD_PAL113_I1_MASK 0x80000000
#define LPC_LCD_PAL113_I1 0x80000000
#define LPC_LCD_PAL113_I1_BIT 31

#define LPC_LCD_PAL114 (*(volatile unsigned long *)0x200883C8)
#define LPC_LCD_PAL114_OFFSET 0x3C8
#define LPC_LCD_PAL114_R04_0_MASK 0x1F
#define LPC_LCD_PAL114_R04_0_BIT 0
#define LPC_LCD_PAL114_G04_0_MASK 0x3E0
#define LPC_LCD_PAL114_G04_0_BIT 5
#define LPC_LCD_PAL114_B04_0_MASK 0x7C00
#define LPC_LCD_PAL114_B04_0_BIT 10
#define LPC_LCD_PAL114_I0_MASK 0x8000
#define LPC_LCD_PAL114_I0 0x8000
#define LPC_LCD_PAL114_I0_BIT 15
#define LPC_LCD_PAL114_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL114_R14_0_BIT 16
#define LPC_LCD_PAL114_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL114_G14_0_BIT 21
#define LPC_LCD_PAL114_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL114_B14_0_BIT 26
#define LPC_LCD_PAL114_I1_MASK 0x80000000
#define LPC_LCD_PAL114_I1 0x80000000
#define LPC_LCD_PAL114_I1_BIT 31

#define LPC_LCD_PAL115 (*(volatile unsigned long *)0x200883CC)
#define LPC_LCD_PAL115_OFFSET 0x3CC
#define LPC_LCD_PAL115_R04_0_MASK 0x1F
#define LPC_LCD_PAL115_R04_0_BIT 0
#define LPC_LCD_PAL115_G04_0_MASK 0x3E0
#define LPC_LCD_PAL115_G04_0_BIT 5
#define LPC_LCD_PAL115_B04_0_MASK 0x7C00
#define LPC_LCD_PAL115_B04_0_BIT 10
#define LPC_LCD_PAL115_I0_MASK 0x8000
#define LPC_LCD_PAL115_I0 0x8000
#define LPC_LCD_PAL115_I0_BIT 15
#define LPC_LCD_PAL115_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL115_R14_0_BIT 16
#define LPC_LCD_PAL115_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL115_G14_0_BIT 21
#define LPC_LCD_PAL115_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL115_B14_0_BIT 26
#define LPC_LCD_PAL115_I1_MASK 0x80000000
#define LPC_LCD_PAL115_I1 0x80000000
#define LPC_LCD_PAL115_I1_BIT 31

#define LPC_LCD_PAL116 (*(volatile unsigned long *)0x200883D0)
#define LPC_LCD_PAL116_OFFSET 0x3D0
#define LPC_LCD_PAL116_R04_0_MASK 0x1F
#define LPC_LCD_PAL116_R04_0_BIT 0
#define LPC_LCD_PAL116_G04_0_MASK 0x3E0
#define LPC_LCD_PAL116_G04_0_BIT 5
#define LPC_LCD_PAL116_B04_0_MASK 0x7C00
#define LPC_LCD_PAL116_B04_0_BIT 10
#define LPC_LCD_PAL116_I0_MASK 0x8000
#define LPC_LCD_PAL116_I0 0x8000
#define LPC_LCD_PAL116_I0_BIT 15
#define LPC_LCD_PAL116_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL116_R14_0_BIT 16
#define LPC_LCD_PAL116_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL116_G14_0_BIT 21
#define LPC_LCD_PAL116_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL116_B14_0_BIT 26
#define LPC_LCD_PAL116_I1_MASK 0x80000000
#define LPC_LCD_PAL116_I1 0x80000000
#define LPC_LCD_PAL116_I1_BIT 31

#define LPC_LCD_PAL117 (*(volatile unsigned long *)0x200883D4)
#define LPC_LCD_PAL117_OFFSET 0x3D4
#define LPC_LCD_PAL117_R04_0_MASK 0x1F
#define LPC_LCD_PAL117_R04_0_BIT 0
#define LPC_LCD_PAL117_G04_0_MASK 0x3E0
#define LPC_LCD_PAL117_G04_0_BIT 5
#define LPC_LCD_PAL117_B04_0_MASK 0x7C00
#define LPC_LCD_PAL117_B04_0_BIT 10
#define LPC_LCD_PAL117_I0_MASK 0x8000
#define LPC_LCD_PAL117_I0 0x8000
#define LPC_LCD_PAL117_I0_BIT 15
#define LPC_LCD_PAL117_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL117_R14_0_BIT 16
#define LPC_LCD_PAL117_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL117_G14_0_BIT 21
#define LPC_LCD_PAL117_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL117_B14_0_BIT 26
#define LPC_LCD_PAL117_I1_MASK 0x80000000
#define LPC_LCD_PAL117_I1 0x80000000
#define LPC_LCD_PAL117_I1_BIT 31

#define LPC_LCD_PAL118 (*(volatile unsigned long *)0x200883D8)
#define LPC_LCD_PAL118_OFFSET 0x3D8
#define LPC_LCD_PAL118_R04_0_MASK 0x1F
#define LPC_LCD_PAL118_R04_0_BIT 0
#define LPC_LCD_PAL118_G04_0_MASK 0x3E0
#define LPC_LCD_PAL118_G04_0_BIT 5
#define LPC_LCD_PAL118_B04_0_MASK 0x7C00
#define LPC_LCD_PAL118_B04_0_BIT 10
#define LPC_LCD_PAL118_I0_MASK 0x8000
#define LPC_LCD_PAL118_I0 0x8000
#define LPC_LCD_PAL118_I0_BIT 15
#define LPC_LCD_PAL118_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL118_R14_0_BIT 16
#define LPC_LCD_PAL118_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL118_G14_0_BIT 21
#define LPC_LCD_PAL118_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL118_B14_0_BIT 26
#define LPC_LCD_PAL118_I1_MASK 0x80000000
#define LPC_LCD_PAL118_I1 0x80000000
#define LPC_LCD_PAL118_I1_BIT 31

#define LPC_LCD_PAL119 (*(volatile unsigned long *)0x200883DC)
#define LPC_LCD_PAL119_OFFSET 0x3DC
#define LPC_LCD_PAL119_R04_0_MASK 0x1F
#define LPC_LCD_PAL119_R04_0_BIT 0
#define LPC_LCD_PAL119_G04_0_MASK 0x3E0
#define LPC_LCD_PAL119_G04_0_BIT 5
#define LPC_LCD_PAL119_B04_0_MASK 0x7C00
#define LPC_LCD_PAL119_B04_0_BIT 10
#define LPC_LCD_PAL119_I0_MASK 0x8000
#define LPC_LCD_PAL119_I0 0x8000
#define LPC_LCD_PAL119_I0_BIT 15
#define LPC_LCD_PAL119_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL119_R14_0_BIT 16
#define LPC_LCD_PAL119_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL119_G14_0_BIT 21
#define LPC_LCD_PAL119_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL119_B14_0_BIT 26
#define LPC_LCD_PAL119_I1_MASK 0x80000000
#define LPC_LCD_PAL119_I1 0x80000000
#define LPC_LCD_PAL119_I1_BIT 31

#define LPC_LCD_PAL120 (*(volatile unsigned long *)0x200883E0)
#define LPC_LCD_PAL120_OFFSET 0x3E0
#define LPC_LCD_PAL120_R04_0_MASK 0x1F
#define LPC_LCD_PAL120_R04_0_BIT 0
#define LPC_LCD_PAL120_G04_0_MASK 0x3E0
#define LPC_LCD_PAL120_G04_0_BIT 5
#define LPC_LCD_PAL120_B04_0_MASK 0x7C00
#define LPC_LCD_PAL120_B04_0_BIT 10
#define LPC_LCD_PAL120_I0_MASK 0x8000
#define LPC_LCD_PAL120_I0 0x8000
#define LPC_LCD_PAL120_I0_BIT 15
#define LPC_LCD_PAL120_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL120_R14_0_BIT 16
#define LPC_LCD_PAL120_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL120_G14_0_BIT 21
#define LPC_LCD_PAL120_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL120_B14_0_BIT 26
#define LPC_LCD_PAL120_I1_MASK 0x80000000
#define LPC_LCD_PAL120_I1 0x80000000
#define LPC_LCD_PAL120_I1_BIT 31

#define LPC_LCD_PAL121 (*(volatile unsigned long *)0x200883E4)
#define LPC_LCD_PAL121_OFFSET 0x3E4
#define LPC_LCD_PAL121_R04_0_MASK 0x1F
#define LPC_LCD_PAL121_R04_0_BIT 0
#define LPC_LCD_PAL121_G04_0_MASK 0x3E0
#define LPC_LCD_PAL121_G04_0_BIT 5
#define LPC_LCD_PAL121_B04_0_MASK 0x7C00
#define LPC_LCD_PAL121_B04_0_BIT 10
#define LPC_LCD_PAL121_I0_MASK 0x8000
#define LPC_LCD_PAL121_I0 0x8000
#define LPC_LCD_PAL121_I0_BIT 15
#define LPC_LCD_PAL121_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL121_R14_0_BIT 16
#define LPC_LCD_PAL121_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL121_G14_0_BIT 21
#define LPC_LCD_PAL121_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL121_B14_0_BIT 26
#define LPC_LCD_PAL121_I1_MASK 0x80000000
#define LPC_LCD_PAL121_I1 0x80000000
#define LPC_LCD_PAL121_I1_BIT 31

#define LPC_LCD_PAL122 (*(volatile unsigned long *)0x200883E8)
#define LPC_LCD_PAL122_OFFSET 0x3E8
#define LPC_LCD_PAL122_R04_0_MASK 0x1F
#define LPC_LCD_PAL122_R04_0_BIT 0
#define LPC_LCD_PAL122_G04_0_MASK 0x3E0
#define LPC_LCD_PAL122_G04_0_BIT 5
#define LPC_LCD_PAL122_B04_0_MASK 0x7C00
#define LPC_LCD_PAL122_B04_0_BIT 10
#define LPC_LCD_PAL122_I0_MASK 0x8000
#define LPC_LCD_PAL122_I0 0x8000
#define LPC_LCD_PAL122_I0_BIT 15
#define LPC_LCD_PAL122_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL122_R14_0_BIT 16
#define LPC_LCD_PAL122_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL122_G14_0_BIT 21
#define LPC_LCD_PAL122_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL122_B14_0_BIT 26
#define LPC_LCD_PAL122_I1_MASK 0x80000000
#define LPC_LCD_PAL122_I1 0x80000000
#define LPC_LCD_PAL122_I1_BIT 31

#define LPC_LCD_PAL123 (*(volatile unsigned long *)0x200883EC)
#define LPC_LCD_PAL123_OFFSET 0x3EC
#define LPC_LCD_PAL123_R04_0_MASK 0x1F
#define LPC_LCD_PAL123_R04_0_BIT 0
#define LPC_LCD_PAL123_G04_0_MASK 0x3E0
#define LPC_LCD_PAL123_G04_0_BIT 5
#define LPC_LCD_PAL123_B04_0_MASK 0x7C00
#define LPC_LCD_PAL123_B04_0_BIT 10
#define LPC_LCD_PAL123_I0_MASK 0x8000
#define LPC_LCD_PAL123_I0 0x8000
#define LPC_LCD_PAL123_I0_BIT 15
#define LPC_LCD_PAL123_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL123_R14_0_BIT 16
#define LPC_LCD_PAL123_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL123_G14_0_BIT 21
#define LPC_LCD_PAL123_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL123_B14_0_BIT 26
#define LPC_LCD_PAL123_I1_MASK 0x80000000
#define LPC_LCD_PAL123_I1 0x80000000
#define LPC_LCD_PAL123_I1_BIT 31

#define LPC_LCD_PAL124 (*(volatile unsigned long *)0x200883F0)
#define LPC_LCD_PAL124_OFFSET 0x3F0
#define LPC_LCD_PAL124_R04_0_MASK 0x1F
#define LPC_LCD_PAL124_R04_0_BIT 0
#define LPC_LCD_PAL124_G04_0_MASK 0x3E0
#define LPC_LCD_PAL124_G04_0_BIT 5
#define LPC_LCD_PAL124_B04_0_MASK 0x7C00
#define LPC_LCD_PAL124_B04_0_BIT 10
#define LPC_LCD_PAL124_I0_MASK 0x8000
#define LPC_LCD_PAL124_I0 0x8000
#define LPC_LCD_PAL124_I0_BIT 15
#define LPC_LCD_PAL124_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL124_R14_0_BIT 16
#define LPC_LCD_PAL124_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL124_G14_0_BIT 21
#define LPC_LCD_PAL124_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL124_B14_0_BIT 26
#define LPC_LCD_PAL124_I1_MASK 0x80000000
#define LPC_LCD_PAL124_I1 0x80000000
#define LPC_LCD_PAL124_I1_BIT 31

#define LPC_LCD_PAL125 (*(volatile unsigned long *)0x200883F4)
#define LPC_LCD_PAL125_OFFSET 0x3F4
#define LPC_LCD_PAL125_R04_0_MASK 0x1F
#define LPC_LCD_PAL125_R04_0_BIT 0
#define LPC_LCD_PAL125_G04_0_MASK 0x3E0
#define LPC_LCD_PAL125_G04_0_BIT 5
#define LPC_LCD_PAL125_B04_0_MASK 0x7C00
#define LPC_LCD_PAL125_B04_0_BIT 10
#define LPC_LCD_PAL125_I0_MASK 0x8000
#define LPC_LCD_PAL125_I0 0x8000
#define LPC_LCD_PAL125_I0_BIT 15
#define LPC_LCD_PAL125_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL125_R14_0_BIT 16
#define LPC_LCD_PAL125_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL125_G14_0_BIT 21
#define LPC_LCD_PAL125_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL125_B14_0_BIT 26
#define LPC_LCD_PAL125_I1_MASK 0x80000000
#define LPC_LCD_PAL125_I1 0x80000000
#define LPC_LCD_PAL125_I1_BIT 31

#define LPC_LCD_PAL126 (*(volatile unsigned long *)0x200883F8)
#define LPC_LCD_PAL126_OFFSET 0x3F8
#define LPC_LCD_PAL126_R04_0_MASK 0x1F
#define LPC_LCD_PAL126_R04_0_BIT 0
#define LPC_LCD_PAL126_G04_0_MASK 0x3E0
#define LPC_LCD_PAL126_G04_0_BIT 5
#define LPC_LCD_PAL126_B04_0_MASK 0x7C00
#define LPC_LCD_PAL126_B04_0_BIT 10
#define LPC_LCD_PAL126_I0_MASK 0x8000
#define LPC_LCD_PAL126_I0 0x8000
#define LPC_LCD_PAL126_I0_BIT 15
#define LPC_LCD_PAL126_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL126_R14_0_BIT 16
#define LPC_LCD_PAL126_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL126_G14_0_BIT 21
#define LPC_LCD_PAL126_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL126_B14_0_BIT 26
#define LPC_LCD_PAL126_I1_MASK 0x80000000
#define LPC_LCD_PAL126_I1 0x80000000
#define LPC_LCD_PAL126_I1_BIT 31

#define LPC_LCD_PAL127 (*(volatile unsigned long *)0x200883FC)
#define LPC_LCD_PAL127_OFFSET 0x3FC
#define LPC_LCD_PAL127_R04_0_MASK 0x1F
#define LPC_LCD_PAL127_R04_0_BIT 0
#define LPC_LCD_PAL127_G04_0_MASK 0x3E0
#define LPC_LCD_PAL127_G04_0_BIT 5
#define LPC_LCD_PAL127_B04_0_MASK 0x7C00
#define LPC_LCD_PAL127_B04_0_BIT 10
#define LPC_LCD_PAL127_I0_MASK 0x8000
#define LPC_LCD_PAL127_I0 0x8000
#define LPC_LCD_PAL127_I0_BIT 15
#define LPC_LCD_PAL127_R14_0_MASK 0x1F0000
#define LPC_LCD_PAL127_R14_0_BIT 16
#define LPC_LCD_PAL127_G14_0_MASK 0x3E00000
#define LPC_LCD_PAL127_G14_0_BIT 21
#define LPC_LCD_PAL127_B14_0_MASK 0x7C000000
#define LPC_LCD_PAL127_B14_0_BIT 26
#define LPC_LCD_PAL127_I1_MASK 0x80000000
#define LPC_LCD_PAL127_I1 0x80000000
#define LPC_LCD_PAL127_I1_BIT 31

#define LPC_LCD_CRSR_IMG0 (*(volatile unsigned long *)0x20088800)
#define LPC_LCD_CRSR_IMG0_OFFSET 0x800
#define LPC_LCD_CRSR_IMG0_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG0_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG1 (*(volatile unsigned long *)0x20088804)
#define LPC_LCD_CRSR_IMG1_OFFSET 0x804
#define LPC_LCD_CRSR_IMG1_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG1_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG2 (*(volatile unsigned long *)0x20088808)
#define LPC_LCD_CRSR_IMG2_OFFSET 0x808
#define LPC_LCD_CRSR_IMG2_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG2_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG3 (*(volatile unsigned long *)0x2008880C)
#define LPC_LCD_CRSR_IMG3_OFFSET 0x80C
#define LPC_LCD_CRSR_IMG3_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG3_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG4 (*(volatile unsigned long *)0x20088810)
#define LPC_LCD_CRSR_IMG4_OFFSET 0x810
#define LPC_LCD_CRSR_IMG4_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG4_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG5 (*(volatile unsigned long *)0x20088814)
#define LPC_LCD_CRSR_IMG5_OFFSET 0x814
#define LPC_LCD_CRSR_IMG5_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG5_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG6 (*(volatile unsigned long *)0x20088818)
#define LPC_LCD_CRSR_IMG6_OFFSET 0x818
#define LPC_LCD_CRSR_IMG6_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG6_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG7 (*(volatile unsigned long *)0x2008881C)
#define LPC_LCD_CRSR_IMG7_OFFSET 0x81C
#define LPC_LCD_CRSR_IMG7_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG7_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG8 (*(volatile unsigned long *)0x20088820)
#define LPC_LCD_CRSR_IMG8_OFFSET 0x820
#define LPC_LCD_CRSR_IMG8_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG8_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG9 (*(volatile unsigned long *)0x20088824)
#define LPC_LCD_CRSR_IMG9_OFFSET 0x824
#define LPC_LCD_CRSR_IMG9_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG9_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG10 (*(volatile unsigned long *)0x20088828)
#define LPC_LCD_CRSR_IMG10_OFFSET 0x828
#define LPC_LCD_CRSR_IMG10_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG10_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG11 (*(volatile unsigned long *)0x2008882C)
#define LPC_LCD_CRSR_IMG11_OFFSET 0x82C
#define LPC_LCD_CRSR_IMG11_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG11_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG12 (*(volatile unsigned long *)0x20088830)
#define LPC_LCD_CRSR_IMG12_OFFSET 0x830
#define LPC_LCD_CRSR_IMG12_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG12_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG13 (*(volatile unsigned long *)0x20088834)
#define LPC_LCD_CRSR_IMG13_OFFSET 0x834
#define LPC_LCD_CRSR_IMG13_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG13_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG14 (*(volatile unsigned long *)0x20088838)
#define LPC_LCD_CRSR_IMG14_OFFSET 0x838
#define LPC_LCD_CRSR_IMG14_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG14_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG15 (*(volatile unsigned long *)0x2008883C)
#define LPC_LCD_CRSR_IMG15_OFFSET 0x83C
#define LPC_LCD_CRSR_IMG15_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG15_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG16 (*(volatile unsigned long *)0x20088840)
#define LPC_LCD_CRSR_IMG16_OFFSET 0x840
#define LPC_LCD_CRSR_IMG16_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG16_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG17 (*(volatile unsigned long *)0x20088844)
#define LPC_LCD_CRSR_IMG17_OFFSET 0x844
#define LPC_LCD_CRSR_IMG17_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG17_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG18 (*(volatile unsigned long *)0x20088848)
#define LPC_LCD_CRSR_IMG18_OFFSET 0x848
#define LPC_LCD_CRSR_IMG18_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG18_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG19 (*(volatile unsigned long *)0x2008884C)
#define LPC_LCD_CRSR_IMG19_OFFSET 0x84C
#define LPC_LCD_CRSR_IMG19_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG19_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG20 (*(volatile unsigned long *)0x20088850)
#define LPC_LCD_CRSR_IMG20_OFFSET 0x850
#define LPC_LCD_CRSR_IMG20_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG20_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG21 (*(volatile unsigned long *)0x20088854)
#define LPC_LCD_CRSR_IMG21_OFFSET 0x854
#define LPC_LCD_CRSR_IMG21_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG21_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG22 (*(volatile unsigned long *)0x20088858)
#define LPC_LCD_CRSR_IMG22_OFFSET 0x858
#define LPC_LCD_CRSR_IMG22_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG22_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG23 (*(volatile unsigned long *)0x2008885C)
#define LPC_LCD_CRSR_IMG23_OFFSET 0x85C
#define LPC_LCD_CRSR_IMG23_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG23_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG24 (*(volatile unsigned long *)0x20088860)
#define LPC_LCD_CRSR_IMG24_OFFSET 0x860
#define LPC_LCD_CRSR_IMG24_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG24_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG25 (*(volatile unsigned long *)0x20088864)
#define LPC_LCD_CRSR_IMG25_OFFSET 0x864
#define LPC_LCD_CRSR_IMG25_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG25_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG26 (*(volatile unsigned long *)0x20088868)
#define LPC_LCD_CRSR_IMG26_OFFSET 0x868
#define LPC_LCD_CRSR_IMG26_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG26_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG27 (*(volatile unsigned long *)0x2008886C)
#define LPC_LCD_CRSR_IMG27_OFFSET 0x86C
#define LPC_LCD_CRSR_IMG27_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG27_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG28 (*(volatile unsigned long *)0x20088870)
#define LPC_LCD_CRSR_IMG28_OFFSET 0x870
#define LPC_LCD_CRSR_IMG28_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG28_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG29 (*(volatile unsigned long *)0x20088874)
#define LPC_LCD_CRSR_IMG29_OFFSET 0x874
#define LPC_LCD_CRSR_IMG29_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG29_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG30 (*(volatile unsigned long *)0x20088878)
#define LPC_LCD_CRSR_IMG30_OFFSET 0x878
#define LPC_LCD_CRSR_IMG30_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG30_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG31 (*(volatile unsigned long *)0x2008887C)
#define LPC_LCD_CRSR_IMG31_OFFSET 0x87C
#define LPC_LCD_CRSR_IMG31_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG31_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG32 (*(volatile unsigned long *)0x20088880)
#define LPC_LCD_CRSR_IMG32_OFFSET 0x880
#define LPC_LCD_CRSR_IMG32_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG32_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG33 (*(volatile unsigned long *)0x20088884)
#define LPC_LCD_CRSR_IMG33_OFFSET 0x884
#define LPC_LCD_CRSR_IMG33_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG33_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG34 (*(volatile unsigned long *)0x20088888)
#define LPC_LCD_CRSR_IMG34_OFFSET 0x888
#define LPC_LCD_CRSR_IMG34_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG34_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG35 (*(volatile unsigned long *)0x2008888C)
#define LPC_LCD_CRSR_IMG35_OFFSET 0x88C
#define LPC_LCD_CRSR_IMG35_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG35_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG36 (*(volatile unsigned long *)0x20088890)
#define LPC_LCD_CRSR_IMG36_OFFSET 0x890
#define LPC_LCD_CRSR_IMG36_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG36_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG37 (*(volatile unsigned long *)0x20088894)
#define LPC_LCD_CRSR_IMG37_OFFSET 0x894
#define LPC_LCD_CRSR_IMG37_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG37_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG38 (*(volatile unsigned long *)0x20088898)
#define LPC_LCD_CRSR_IMG38_OFFSET 0x898
#define LPC_LCD_CRSR_IMG38_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG38_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG39 (*(volatile unsigned long *)0x2008889C)
#define LPC_LCD_CRSR_IMG39_OFFSET 0x89C
#define LPC_LCD_CRSR_IMG39_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG39_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG40 (*(volatile unsigned long *)0x200888A0)
#define LPC_LCD_CRSR_IMG40_OFFSET 0x8A0
#define LPC_LCD_CRSR_IMG40_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG40_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG41 (*(volatile unsigned long *)0x200888A4)
#define LPC_LCD_CRSR_IMG41_OFFSET 0x8A4
#define LPC_LCD_CRSR_IMG41_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG41_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG42 (*(volatile unsigned long *)0x200888A8)
#define LPC_LCD_CRSR_IMG42_OFFSET 0x8A8
#define LPC_LCD_CRSR_IMG42_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG42_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG43 (*(volatile unsigned long *)0x200888AC)
#define LPC_LCD_CRSR_IMG43_OFFSET 0x8AC
#define LPC_LCD_CRSR_IMG43_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG43_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG44 (*(volatile unsigned long *)0x200888B0)
#define LPC_LCD_CRSR_IMG44_OFFSET 0x8B0
#define LPC_LCD_CRSR_IMG44_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG44_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG45 (*(volatile unsigned long *)0x200888B4)
#define LPC_LCD_CRSR_IMG45_OFFSET 0x8B4
#define LPC_LCD_CRSR_IMG45_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG45_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG46 (*(volatile unsigned long *)0x200888B8)
#define LPC_LCD_CRSR_IMG46_OFFSET 0x8B8
#define LPC_LCD_CRSR_IMG46_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG46_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG47 (*(volatile unsigned long *)0x200888BC)
#define LPC_LCD_CRSR_IMG47_OFFSET 0x8BC
#define LPC_LCD_CRSR_IMG47_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG47_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG48 (*(volatile unsigned long *)0x200888C0)
#define LPC_LCD_CRSR_IMG48_OFFSET 0x8C0
#define LPC_LCD_CRSR_IMG48_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG48_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG49 (*(volatile unsigned long *)0x200888C4)
#define LPC_LCD_CRSR_IMG49_OFFSET 0x8C4
#define LPC_LCD_CRSR_IMG49_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG49_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG50 (*(volatile unsigned long *)0x200888C8)
#define LPC_LCD_CRSR_IMG50_OFFSET 0x8C8
#define LPC_LCD_CRSR_IMG50_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG50_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG51 (*(volatile unsigned long *)0x200888CC)
#define LPC_LCD_CRSR_IMG51_OFFSET 0x8CC
#define LPC_LCD_CRSR_IMG51_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG51_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG52 (*(volatile unsigned long *)0x200888D0)
#define LPC_LCD_CRSR_IMG52_OFFSET 0x8D0
#define LPC_LCD_CRSR_IMG52_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG52_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG53 (*(volatile unsigned long *)0x200888D4)
#define LPC_LCD_CRSR_IMG53_OFFSET 0x8D4
#define LPC_LCD_CRSR_IMG53_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG53_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG54 (*(volatile unsigned long *)0x200888D8)
#define LPC_LCD_CRSR_IMG54_OFFSET 0x8D8
#define LPC_LCD_CRSR_IMG54_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG54_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG55 (*(volatile unsigned long *)0x200888DC)
#define LPC_LCD_CRSR_IMG55_OFFSET 0x8DC
#define LPC_LCD_CRSR_IMG55_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG55_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG56 (*(volatile unsigned long *)0x200888E0)
#define LPC_LCD_CRSR_IMG56_OFFSET 0x8E0
#define LPC_LCD_CRSR_IMG56_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG56_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG57 (*(volatile unsigned long *)0x200888E4)
#define LPC_LCD_CRSR_IMG57_OFFSET 0x8E4
#define LPC_LCD_CRSR_IMG57_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG57_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG58 (*(volatile unsigned long *)0x200888E8)
#define LPC_LCD_CRSR_IMG58_OFFSET 0x8E8
#define LPC_LCD_CRSR_IMG58_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG58_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG59 (*(volatile unsigned long *)0x200888EC)
#define LPC_LCD_CRSR_IMG59_OFFSET 0x8EC
#define LPC_LCD_CRSR_IMG59_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG59_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG60 (*(volatile unsigned long *)0x200888F0)
#define LPC_LCD_CRSR_IMG60_OFFSET 0x8F0
#define LPC_LCD_CRSR_IMG60_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG60_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG61 (*(volatile unsigned long *)0x200888F4)
#define LPC_LCD_CRSR_IMG61_OFFSET 0x8F4
#define LPC_LCD_CRSR_IMG61_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG61_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG62 (*(volatile unsigned long *)0x200888F8)
#define LPC_LCD_CRSR_IMG62_OFFSET 0x8F8
#define LPC_LCD_CRSR_IMG62_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG62_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG63 (*(volatile unsigned long *)0x200888FC)
#define LPC_LCD_CRSR_IMG63_OFFSET 0x8FC
#define LPC_LCD_CRSR_IMG63_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG63_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG64 (*(volatile unsigned long *)0x20088900)
#define LPC_LCD_CRSR_IMG64_OFFSET 0x900
#define LPC_LCD_CRSR_IMG64_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG64_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG65 (*(volatile unsigned long *)0x20088904)
#define LPC_LCD_CRSR_IMG65_OFFSET 0x904
#define LPC_LCD_CRSR_IMG65_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG65_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG66 (*(volatile unsigned long *)0x20088908)
#define LPC_LCD_CRSR_IMG66_OFFSET 0x908
#define LPC_LCD_CRSR_IMG66_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG66_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG67 (*(volatile unsigned long *)0x2008890C)
#define LPC_LCD_CRSR_IMG67_OFFSET 0x90C
#define LPC_LCD_CRSR_IMG67_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG67_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG68 (*(volatile unsigned long *)0x20088910)
#define LPC_LCD_CRSR_IMG68_OFFSET 0x910
#define LPC_LCD_CRSR_IMG68_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG68_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG69 (*(volatile unsigned long *)0x20088914)
#define LPC_LCD_CRSR_IMG69_OFFSET 0x914
#define LPC_LCD_CRSR_IMG69_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG69_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG70 (*(volatile unsigned long *)0x20088918)
#define LPC_LCD_CRSR_IMG70_OFFSET 0x918
#define LPC_LCD_CRSR_IMG70_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG70_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG71 (*(volatile unsigned long *)0x2008891C)
#define LPC_LCD_CRSR_IMG71_OFFSET 0x91C
#define LPC_LCD_CRSR_IMG71_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG71_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG72 (*(volatile unsigned long *)0x20088920)
#define LPC_LCD_CRSR_IMG72_OFFSET 0x920
#define LPC_LCD_CRSR_IMG72_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG72_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG73 (*(volatile unsigned long *)0x20088924)
#define LPC_LCD_CRSR_IMG73_OFFSET 0x924
#define LPC_LCD_CRSR_IMG73_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG73_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG74 (*(volatile unsigned long *)0x20088928)
#define LPC_LCD_CRSR_IMG74_OFFSET 0x928
#define LPC_LCD_CRSR_IMG74_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG74_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG75 (*(volatile unsigned long *)0x2008892C)
#define LPC_LCD_CRSR_IMG75_OFFSET 0x92C
#define LPC_LCD_CRSR_IMG75_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG75_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG76 (*(volatile unsigned long *)0x20088930)
#define LPC_LCD_CRSR_IMG76_OFFSET 0x930
#define LPC_LCD_CRSR_IMG76_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG76_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG77 (*(volatile unsigned long *)0x20088934)
#define LPC_LCD_CRSR_IMG77_OFFSET 0x934
#define LPC_LCD_CRSR_IMG77_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG77_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG78 (*(volatile unsigned long *)0x20088938)
#define LPC_LCD_CRSR_IMG78_OFFSET 0x938
#define LPC_LCD_CRSR_IMG78_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG78_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG79 (*(volatile unsigned long *)0x2008893C)
#define LPC_LCD_CRSR_IMG79_OFFSET 0x93C
#define LPC_LCD_CRSR_IMG79_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG79_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG80 (*(volatile unsigned long *)0x20088940)
#define LPC_LCD_CRSR_IMG80_OFFSET 0x940
#define LPC_LCD_CRSR_IMG80_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG80_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG81 (*(volatile unsigned long *)0x20088944)
#define LPC_LCD_CRSR_IMG81_OFFSET 0x944
#define LPC_LCD_CRSR_IMG81_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG81_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG82 (*(volatile unsigned long *)0x20088948)
#define LPC_LCD_CRSR_IMG82_OFFSET 0x948
#define LPC_LCD_CRSR_IMG82_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG82_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG83 (*(volatile unsigned long *)0x2008894C)
#define LPC_LCD_CRSR_IMG83_OFFSET 0x94C
#define LPC_LCD_CRSR_IMG83_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG83_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG84 (*(volatile unsigned long *)0x20088950)
#define LPC_LCD_CRSR_IMG84_OFFSET 0x950
#define LPC_LCD_CRSR_IMG84_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG84_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG85 (*(volatile unsigned long *)0x20088954)
#define LPC_LCD_CRSR_IMG85_OFFSET 0x954
#define LPC_LCD_CRSR_IMG85_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG85_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG86 (*(volatile unsigned long *)0x20088958)
#define LPC_LCD_CRSR_IMG86_OFFSET 0x958
#define LPC_LCD_CRSR_IMG86_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG86_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG87 (*(volatile unsigned long *)0x2008895C)
#define LPC_LCD_CRSR_IMG87_OFFSET 0x95C
#define LPC_LCD_CRSR_IMG87_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG87_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG88 (*(volatile unsigned long *)0x20088960)
#define LPC_LCD_CRSR_IMG88_OFFSET 0x960
#define LPC_LCD_CRSR_IMG88_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG88_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG89 (*(volatile unsigned long *)0x20088964)
#define LPC_LCD_CRSR_IMG89_OFFSET 0x964
#define LPC_LCD_CRSR_IMG89_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG89_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG90 (*(volatile unsigned long *)0x20088968)
#define LPC_LCD_CRSR_IMG90_OFFSET 0x968
#define LPC_LCD_CRSR_IMG90_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG90_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG91 (*(volatile unsigned long *)0x2008896C)
#define LPC_LCD_CRSR_IMG91_OFFSET 0x96C
#define LPC_LCD_CRSR_IMG91_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG91_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG92 (*(volatile unsigned long *)0x20088970)
#define LPC_LCD_CRSR_IMG92_OFFSET 0x970
#define LPC_LCD_CRSR_IMG92_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG92_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG93 (*(volatile unsigned long *)0x20088974)
#define LPC_LCD_CRSR_IMG93_OFFSET 0x974
#define LPC_LCD_CRSR_IMG93_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG93_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG94 (*(volatile unsigned long *)0x20088978)
#define LPC_LCD_CRSR_IMG94_OFFSET 0x978
#define LPC_LCD_CRSR_IMG94_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG94_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG95 (*(volatile unsigned long *)0x2008897C)
#define LPC_LCD_CRSR_IMG95_OFFSET 0x97C
#define LPC_LCD_CRSR_IMG95_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG95_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG96 (*(volatile unsigned long *)0x20088980)
#define LPC_LCD_CRSR_IMG96_OFFSET 0x980
#define LPC_LCD_CRSR_IMG96_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG96_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG97 (*(volatile unsigned long *)0x20088984)
#define LPC_LCD_CRSR_IMG97_OFFSET 0x984
#define LPC_LCD_CRSR_IMG97_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG97_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG98 (*(volatile unsigned long *)0x20088988)
#define LPC_LCD_CRSR_IMG98_OFFSET 0x988
#define LPC_LCD_CRSR_IMG98_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG98_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG99 (*(volatile unsigned long *)0x2008898C)
#define LPC_LCD_CRSR_IMG99_OFFSET 0x98C
#define LPC_LCD_CRSR_IMG99_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG99_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG100 (*(volatile unsigned long *)0x20088990)
#define LPC_LCD_CRSR_IMG100_OFFSET 0x990
#define LPC_LCD_CRSR_IMG100_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG100_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG101 (*(volatile unsigned long *)0x20088994)
#define LPC_LCD_CRSR_IMG101_OFFSET 0x994
#define LPC_LCD_CRSR_IMG101_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG101_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG102 (*(volatile unsigned long *)0x20088998)
#define LPC_LCD_CRSR_IMG102_OFFSET 0x998
#define LPC_LCD_CRSR_IMG102_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG102_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG103 (*(volatile unsigned long *)0x2008899C)
#define LPC_LCD_CRSR_IMG103_OFFSET 0x99C
#define LPC_LCD_CRSR_IMG103_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG103_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG104 (*(volatile unsigned long *)0x200889A0)
#define LPC_LCD_CRSR_IMG104_OFFSET 0x9A0
#define LPC_LCD_CRSR_IMG104_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG104_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG105 (*(volatile unsigned long *)0x200889A4)
#define LPC_LCD_CRSR_IMG105_OFFSET 0x9A4
#define LPC_LCD_CRSR_IMG105_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG105_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG106 (*(volatile unsigned long *)0x200889A8)
#define LPC_LCD_CRSR_IMG106_OFFSET 0x9A8
#define LPC_LCD_CRSR_IMG106_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG106_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG107 (*(volatile unsigned long *)0x200889AC)
#define LPC_LCD_CRSR_IMG107_OFFSET 0x9AC
#define LPC_LCD_CRSR_IMG107_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG107_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG108 (*(volatile unsigned long *)0x200889B0)
#define LPC_LCD_CRSR_IMG108_OFFSET 0x9B0
#define LPC_LCD_CRSR_IMG108_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG108_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG109 (*(volatile unsigned long *)0x200889B4)
#define LPC_LCD_CRSR_IMG109_OFFSET 0x9B4
#define LPC_LCD_CRSR_IMG109_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG109_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG110 (*(volatile unsigned long *)0x200889B8)
#define LPC_LCD_CRSR_IMG110_OFFSET 0x9B8
#define LPC_LCD_CRSR_IMG110_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG110_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG111 (*(volatile unsigned long *)0x200889BC)
#define LPC_LCD_CRSR_IMG111_OFFSET 0x9BC
#define LPC_LCD_CRSR_IMG111_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG111_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG112 (*(volatile unsigned long *)0x200889C0)
#define LPC_LCD_CRSR_IMG112_OFFSET 0x9C0
#define LPC_LCD_CRSR_IMG112_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG112_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG113 (*(volatile unsigned long *)0x200889C4)
#define LPC_LCD_CRSR_IMG113_OFFSET 0x9C4
#define LPC_LCD_CRSR_IMG113_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG113_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG114 (*(volatile unsigned long *)0x200889C8)
#define LPC_LCD_CRSR_IMG114_OFFSET 0x9C8
#define LPC_LCD_CRSR_IMG114_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG114_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG115 (*(volatile unsigned long *)0x200889CC)
#define LPC_LCD_CRSR_IMG115_OFFSET 0x9CC
#define LPC_LCD_CRSR_IMG115_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG115_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG116 (*(volatile unsigned long *)0x200889D0)
#define LPC_LCD_CRSR_IMG116_OFFSET 0x9D0
#define LPC_LCD_CRSR_IMG116_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG116_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG117 (*(volatile unsigned long *)0x200889D4)
#define LPC_LCD_CRSR_IMG117_OFFSET 0x9D4
#define LPC_LCD_CRSR_IMG117_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG117_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG118 (*(volatile unsigned long *)0x200889D8)
#define LPC_LCD_CRSR_IMG118_OFFSET 0x9D8
#define LPC_LCD_CRSR_IMG118_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG118_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG119 (*(volatile unsigned long *)0x200889DC)
#define LPC_LCD_CRSR_IMG119_OFFSET 0x9DC
#define LPC_LCD_CRSR_IMG119_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG119_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG120 (*(volatile unsigned long *)0x200889E0)
#define LPC_LCD_CRSR_IMG120_OFFSET 0x9E0
#define LPC_LCD_CRSR_IMG120_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG120_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG121 (*(volatile unsigned long *)0x200889E4)
#define LPC_LCD_CRSR_IMG121_OFFSET 0x9E4
#define LPC_LCD_CRSR_IMG121_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG121_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG122 (*(volatile unsigned long *)0x200889E8)
#define LPC_LCD_CRSR_IMG122_OFFSET 0x9E8
#define LPC_LCD_CRSR_IMG122_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG122_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG123 (*(volatile unsigned long *)0x200889EC)
#define LPC_LCD_CRSR_IMG123_OFFSET 0x9EC
#define LPC_LCD_CRSR_IMG123_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG123_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG124 (*(volatile unsigned long *)0x200889F0)
#define LPC_LCD_CRSR_IMG124_OFFSET 0x9F0
#define LPC_LCD_CRSR_IMG124_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG124_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG125 (*(volatile unsigned long *)0x200889F4)
#define LPC_LCD_CRSR_IMG125_OFFSET 0x9F4
#define LPC_LCD_CRSR_IMG125_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG125_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG126 (*(volatile unsigned long *)0x200889F8)
#define LPC_LCD_CRSR_IMG126_OFFSET 0x9F8
#define LPC_LCD_CRSR_IMG126_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG126_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG127 (*(volatile unsigned long *)0x200889FC)
#define LPC_LCD_CRSR_IMG127_OFFSET 0x9FC
#define LPC_LCD_CRSR_IMG127_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG127_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG128 (*(volatile unsigned long *)0x20088A00)
#define LPC_LCD_CRSR_IMG128_OFFSET 0xA00
#define LPC_LCD_CRSR_IMG128_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG128_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG129 (*(volatile unsigned long *)0x20088A04)
#define LPC_LCD_CRSR_IMG129_OFFSET 0xA04
#define LPC_LCD_CRSR_IMG129_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG129_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG130 (*(volatile unsigned long *)0x20088A08)
#define LPC_LCD_CRSR_IMG130_OFFSET 0xA08
#define LPC_LCD_CRSR_IMG130_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG130_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG131 (*(volatile unsigned long *)0x20088A0C)
#define LPC_LCD_CRSR_IMG131_OFFSET 0xA0C
#define LPC_LCD_CRSR_IMG131_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG131_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG132 (*(volatile unsigned long *)0x20088A10)
#define LPC_LCD_CRSR_IMG132_OFFSET 0xA10
#define LPC_LCD_CRSR_IMG132_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG132_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG133 (*(volatile unsigned long *)0x20088A14)
#define LPC_LCD_CRSR_IMG133_OFFSET 0xA14
#define LPC_LCD_CRSR_IMG133_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG133_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG134 (*(volatile unsigned long *)0x20088A18)
#define LPC_LCD_CRSR_IMG134_OFFSET 0xA18
#define LPC_LCD_CRSR_IMG134_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG134_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG135 (*(volatile unsigned long *)0x20088A1C)
#define LPC_LCD_CRSR_IMG135_OFFSET 0xA1C
#define LPC_LCD_CRSR_IMG135_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG135_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG136 (*(volatile unsigned long *)0x20088A20)
#define LPC_LCD_CRSR_IMG136_OFFSET 0xA20
#define LPC_LCD_CRSR_IMG136_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG136_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG137 (*(volatile unsigned long *)0x20088A24)
#define LPC_LCD_CRSR_IMG137_OFFSET 0xA24
#define LPC_LCD_CRSR_IMG137_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG137_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG138 (*(volatile unsigned long *)0x20088A28)
#define LPC_LCD_CRSR_IMG138_OFFSET 0xA28
#define LPC_LCD_CRSR_IMG138_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG138_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG139 (*(volatile unsigned long *)0x20088A2C)
#define LPC_LCD_CRSR_IMG139_OFFSET 0xA2C
#define LPC_LCD_CRSR_IMG139_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG139_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG140 (*(volatile unsigned long *)0x20088A30)
#define LPC_LCD_CRSR_IMG140_OFFSET 0xA30
#define LPC_LCD_CRSR_IMG140_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG140_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG141 (*(volatile unsigned long *)0x20088A34)
#define LPC_LCD_CRSR_IMG141_OFFSET 0xA34
#define LPC_LCD_CRSR_IMG141_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG141_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG142 (*(volatile unsigned long *)0x20088A38)
#define LPC_LCD_CRSR_IMG142_OFFSET 0xA38
#define LPC_LCD_CRSR_IMG142_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG142_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG143 (*(volatile unsigned long *)0x20088A3C)
#define LPC_LCD_CRSR_IMG143_OFFSET 0xA3C
#define LPC_LCD_CRSR_IMG143_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG143_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG144 (*(volatile unsigned long *)0x20088A40)
#define LPC_LCD_CRSR_IMG144_OFFSET 0xA40
#define LPC_LCD_CRSR_IMG144_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG144_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG145 (*(volatile unsigned long *)0x20088A44)
#define LPC_LCD_CRSR_IMG145_OFFSET 0xA44
#define LPC_LCD_CRSR_IMG145_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG145_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG146 (*(volatile unsigned long *)0x20088A48)
#define LPC_LCD_CRSR_IMG146_OFFSET 0xA48
#define LPC_LCD_CRSR_IMG146_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG146_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG147 (*(volatile unsigned long *)0x20088A4C)
#define LPC_LCD_CRSR_IMG147_OFFSET 0xA4C
#define LPC_LCD_CRSR_IMG147_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG147_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG148 (*(volatile unsigned long *)0x20088A50)
#define LPC_LCD_CRSR_IMG148_OFFSET 0xA50
#define LPC_LCD_CRSR_IMG148_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG148_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG149 (*(volatile unsigned long *)0x20088A54)
#define LPC_LCD_CRSR_IMG149_OFFSET 0xA54
#define LPC_LCD_CRSR_IMG149_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG149_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG150 (*(volatile unsigned long *)0x20088A58)
#define LPC_LCD_CRSR_IMG150_OFFSET 0xA58
#define LPC_LCD_CRSR_IMG150_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG150_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG151 (*(volatile unsigned long *)0x20088A5C)
#define LPC_LCD_CRSR_IMG151_OFFSET 0xA5C
#define LPC_LCD_CRSR_IMG151_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG151_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG152 (*(volatile unsigned long *)0x20088A60)
#define LPC_LCD_CRSR_IMG152_OFFSET 0xA60
#define LPC_LCD_CRSR_IMG152_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG152_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG153 (*(volatile unsigned long *)0x20088A64)
#define LPC_LCD_CRSR_IMG153_OFFSET 0xA64
#define LPC_LCD_CRSR_IMG153_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG153_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG154 (*(volatile unsigned long *)0x20088A68)
#define LPC_LCD_CRSR_IMG154_OFFSET 0xA68
#define LPC_LCD_CRSR_IMG154_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG154_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG155 (*(volatile unsigned long *)0x20088A6C)
#define LPC_LCD_CRSR_IMG155_OFFSET 0xA6C
#define LPC_LCD_CRSR_IMG155_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG155_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG156 (*(volatile unsigned long *)0x20088A70)
#define LPC_LCD_CRSR_IMG156_OFFSET 0xA70
#define LPC_LCD_CRSR_IMG156_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG156_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG157 (*(volatile unsigned long *)0x20088A74)
#define LPC_LCD_CRSR_IMG157_OFFSET 0xA74
#define LPC_LCD_CRSR_IMG157_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG157_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG158 (*(volatile unsigned long *)0x20088A78)
#define LPC_LCD_CRSR_IMG158_OFFSET 0xA78
#define LPC_LCD_CRSR_IMG158_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG158_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG159 (*(volatile unsigned long *)0x20088A7C)
#define LPC_LCD_CRSR_IMG159_OFFSET 0xA7C
#define LPC_LCD_CRSR_IMG159_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG159_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG160 (*(volatile unsigned long *)0x20088A80)
#define LPC_LCD_CRSR_IMG160_OFFSET 0xA80
#define LPC_LCD_CRSR_IMG160_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG160_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG161 (*(volatile unsigned long *)0x20088A84)
#define LPC_LCD_CRSR_IMG161_OFFSET 0xA84
#define LPC_LCD_CRSR_IMG161_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG161_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG162 (*(volatile unsigned long *)0x20088A88)
#define LPC_LCD_CRSR_IMG162_OFFSET 0xA88
#define LPC_LCD_CRSR_IMG162_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG162_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG163 (*(volatile unsigned long *)0x20088A8C)
#define LPC_LCD_CRSR_IMG163_OFFSET 0xA8C
#define LPC_LCD_CRSR_IMG163_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG163_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG164 (*(volatile unsigned long *)0x20088A90)
#define LPC_LCD_CRSR_IMG164_OFFSET 0xA90
#define LPC_LCD_CRSR_IMG164_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG164_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG165 (*(volatile unsigned long *)0x20088A94)
#define LPC_LCD_CRSR_IMG165_OFFSET 0xA94
#define LPC_LCD_CRSR_IMG165_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG165_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG166 (*(volatile unsigned long *)0x20088A98)
#define LPC_LCD_CRSR_IMG166_OFFSET 0xA98
#define LPC_LCD_CRSR_IMG166_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG166_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG167 (*(volatile unsigned long *)0x20088A9C)
#define LPC_LCD_CRSR_IMG167_OFFSET 0xA9C
#define LPC_LCD_CRSR_IMG167_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG167_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG168 (*(volatile unsigned long *)0x20088AA0)
#define LPC_LCD_CRSR_IMG168_OFFSET 0xAA0
#define LPC_LCD_CRSR_IMG168_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG168_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG169 (*(volatile unsigned long *)0x20088AA4)
#define LPC_LCD_CRSR_IMG169_OFFSET 0xAA4
#define LPC_LCD_CRSR_IMG169_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG169_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG170 (*(volatile unsigned long *)0x20088AA8)
#define LPC_LCD_CRSR_IMG170_OFFSET 0xAA8
#define LPC_LCD_CRSR_IMG170_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG170_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG171 (*(volatile unsigned long *)0x20088AAC)
#define LPC_LCD_CRSR_IMG171_OFFSET 0xAAC
#define LPC_LCD_CRSR_IMG171_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG171_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG172 (*(volatile unsigned long *)0x20088AB0)
#define LPC_LCD_CRSR_IMG172_OFFSET 0xAB0
#define LPC_LCD_CRSR_IMG172_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG172_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG173 (*(volatile unsigned long *)0x20088AB4)
#define LPC_LCD_CRSR_IMG173_OFFSET 0xAB4
#define LPC_LCD_CRSR_IMG173_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG173_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG174 (*(volatile unsigned long *)0x20088AB8)
#define LPC_LCD_CRSR_IMG174_OFFSET 0xAB8
#define LPC_LCD_CRSR_IMG174_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG174_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG175 (*(volatile unsigned long *)0x20088ABC)
#define LPC_LCD_CRSR_IMG175_OFFSET 0xABC
#define LPC_LCD_CRSR_IMG175_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG175_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG176 (*(volatile unsigned long *)0x20088AC0)
#define LPC_LCD_CRSR_IMG176_OFFSET 0xAC0
#define LPC_LCD_CRSR_IMG176_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG176_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG177 (*(volatile unsigned long *)0x20088AC4)
#define LPC_LCD_CRSR_IMG177_OFFSET 0xAC4
#define LPC_LCD_CRSR_IMG177_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG177_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG178 (*(volatile unsigned long *)0x20088AC8)
#define LPC_LCD_CRSR_IMG178_OFFSET 0xAC8
#define LPC_LCD_CRSR_IMG178_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG178_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG179 (*(volatile unsigned long *)0x20088ACC)
#define LPC_LCD_CRSR_IMG179_OFFSET 0xACC
#define LPC_LCD_CRSR_IMG179_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG179_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG180 (*(volatile unsigned long *)0x20088AD0)
#define LPC_LCD_CRSR_IMG180_OFFSET 0xAD0
#define LPC_LCD_CRSR_IMG180_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG180_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG181 (*(volatile unsigned long *)0x20088AD4)
#define LPC_LCD_CRSR_IMG181_OFFSET 0xAD4
#define LPC_LCD_CRSR_IMG181_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG181_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG182 (*(volatile unsigned long *)0x20088AD8)
#define LPC_LCD_CRSR_IMG182_OFFSET 0xAD8
#define LPC_LCD_CRSR_IMG182_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG182_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG183 (*(volatile unsigned long *)0x20088ADC)
#define LPC_LCD_CRSR_IMG183_OFFSET 0xADC
#define LPC_LCD_CRSR_IMG183_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG183_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG184 (*(volatile unsigned long *)0x20088AE0)
#define LPC_LCD_CRSR_IMG184_OFFSET 0xAE0
#define LPC_LCD_CRSR_IMG184_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG184_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG185 (*(volatile unsigned long *)0x20088AE4)
#define LPC_LCD_CRSR_IMG185_OFFSET 0xAE4
#define LPC_LCD_CRSR_IMG185_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG185_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG186 (*(volatile unsigned long *)0x20088AE8)
#define LPC_LCD_CRSR_IMG186_OFFSET 0xAE8
#define LPC_LCD_CRSR_IMG186_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG186_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG187 (*(volatile unsigned long *)0x20088AEC)
#define LPC_LCD_CRSR_IMG187_OFFSET 0xAEC
#define LPC_LCD_CRSR_IMG187_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG187_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG188 (*(volatile unsigned long *)0x20088AF0)
#define LPC_LCD_CRSR_IMG188_OFFSET 0xAF0
#define LPC_LCD_CRSR_IMG188_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG188_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG189 (*(volatile unsigned long *)0x20088AF4)
#define LPC_LCD_CRSR_IMG189_OFFSET 0xAF4
#define LPC_LCD_CRSR_IMG189_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG189_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG190 (*(volatile unsigned long *)0x20088AF8)
#define LPC_LCD_CRSR_IMG190_OFFSET 0xAF8
#define LPC_LCD_CRSR_IMG190_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG190_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG191 (*(volatile unsigned long *)0x20088AFC)
#define LPC_LCD_CRSR_IMG191_OFFSET 0xAFC
#define LPC_LCD_CRSR_IMG191_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG191_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG192 (*(volatile unsigned long *)0x20088B00)
#define LPC_LCD_CRSR_IMG192_OFFSET 0xB00
#define LPC_LCD_CRSR_IMG192_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG192_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG193 (*(volatile unsigned long *)0x20088B04)
#define LPC_LCD_CRSR_IMG193_OFFSET 0xB04
#define LPC_LCD_CRSR_IMG193_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG193_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG194 (*(volatile unsigned long *)0x20088B08)
#define LPC_LCD_CRSR_IMG194_OFFSET 0xB08
#define LPC_LCD_CRSR_IMG194_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG194_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG195 (*(volatile unsigned long *)0x20088B0C)
#define LPC_LCD_CRSR_IMG195_OFFSET 0xB0C
#define LPC_LCD_CRSR_IMG195_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG195_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG196 (*(volatile unsigned long *)0x20088B10)
#define LPC_LCD_CRSR_IMG196_OFFSET 0xB10
#define LPC_LCD_CRSR_IMG196_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG196_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG197 (*(volatile unsigned long *)0x20088B14)
#define LPC_LCD_CRSR_IMG197_OFFSET 0xB14
#define LPC_LCD_CRSR_IMG197_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG197_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG198 (*(volatile unsigned long *)0x20088B18)
#define LPC_LCD_CRSR_IMG198_OFFSET 0xB18
#define LPC_LCD_CRSR_IMG198_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG198_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG199 (*(volatile unsigned long *)0x20088B1C)
#define LPC_LCD_CRSR_IMG199_OFFSET 0xB1C
#define LPC_LCD_CRSR_IMG199_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG199_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG200 (*(volatile unsigned long *)0x20088B20)
#define LPC_LCD_CRSR_IMG200_OFFSET 0xB20
#define LPC_LCD_CRSR_IMG200_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG200_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG201 (*(volatile unsigned long *)0x20088B24)
#define LPC_LCD_CRSR_IMG201_OFFSET 0xB24
#define LPC_LCD_CRSR_IMG201_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG201_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG202 (*(volatile unsigned long *)0x20088B28)
#define LPC_LCD_CRSR_IMG202_OFFSET 0xB28
#define LPC_LCD_CRSR_IMG202_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG202_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG203 (*(volatile unsigned long *)0x20088B2C)
#define LPC_LCD_CRSR_IMG203_OFFSET 0xB2C
#define LPC_LCD_CRSR_IMG203_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG203_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG204 (*(volatile unsigned long *)0x20088B30)
#define LPC_LCD_CRSR_IMG204_OFFSET 0xB30
#define LPC_LCD_CRSR_IMG204_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG204_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG205 (*(volatile unsigned long *)0x20088B34)
#define LPC_LCD_CRSR_IMG205_OFFSET 0xB34
#define LPC_LCD_CRSR_IMG205_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG205_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG206 (*(volatile unsigned long *)0x20088B38)
#define LPC_LCD_CRSR_IMG206_OFFSET 0xB38
#define LPC_LCD_CRSR_IMG206_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG206_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG207 (*(volatile unsigned long *)0x20088B3C)
#define LPC_LCD_CRSR_IMG207_OFFSET 0xB3C
#define LPC_LCD_CRSR_IMG207_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG207_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG208 (*(volatile unsigned long *)0x20088B40)
#define LPC_LCD_CRSR_IMG208_OFFSET 0xB40
#define LPC_LCD_CRSR_IMG208_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG208_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG209 (*(volatile unsigned long *)0x20088B44)
#define LPC_LCD_CRSR_IMG209_OFFSET 0xB44
#define LPC_LCD_CRSR_IMG209_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG209_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG210 (*(volatile unsigned long *)0x20088B48)
#define LPC_LCD_CRSR_IMG210_OFFSET 0xB48
#define LPC_LCD_CRSR_IMG210_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG210_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG211 (*(volatile unsigned long *)0x20088B4C)
#define LPC_LCD_CRSR_IMG211_OFFSET 0xB4C
#define LPC_LCD_CRSR_IMG211_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG211_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG212 (*(volatile unsigned long *)0x20088B50)
#define LPC_LCD_CRSR_IMG212_OFFSET 0xB50
#define LPC_LCD_CRSR_IMG212_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG212_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG213 (*(volatile unsigned long *)0x20088B54)
#define LPC_LCD_CRSR_IMG213_OFFSET 0xB54
#define LPC_LCD_CRSR_IMG213_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG213_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG214 (*(volatile unsigned long *)0x20088B58)
#define LPC_LCD_CRSR_IMG214_OFFSET 0xB58
#define LPC_LCD_CRSR_IMG214_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG214_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG215 (*(volatile unsigned long *)0x20088B5C)
#define LPC_LCD_CRSR_IMG215_OFFSET 0xB5C
#define LPC_LCD_CRSR_IMG215_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG215_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG216 (*(volatile unsigned long *)0x20088B60)
#define LPC_LCD_CRSR_IMG216_OFFSET 0xB60
#define LPC_LCD_CRSR_IMG216_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG216_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG217 (*(volatile unsigned long *)0x20088B64)
#define LPC_LCD_CRSR_IMG217_OFFSET 0xB64
#define LPC_LCD_CRSR_IMG217_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG217_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG218 (*(volatile unsigned long *)0x20088B68)
#define LPC_LCD_CRSR_IMG218_OFFSET 0xB68
#define LPC_LCD_CRSR_IMG218_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG218_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG219 (*(volatile unsigned long *)0x20088B6C)
#define LPC_LCD_CRSR_IMG219_OFFSET 0xB6C
#define LPC_LCD_CRSR_IMG219_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG219_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG220 (*(volatile unsigned long *)0x20088B70)
#define LPC_LCD_CRSR_IMG220_OFFSET 0xB70
#define LPC_LCD_CRSR_IMG220_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG220_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG221 (*(volatile unsigned long *)0x20088B74)
#define LPC_LCD_CRSR_IMG221_OFFSET 0xB74
#define LPC_LCD_CRSR_IMG221_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG221_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG222 (*(volatile unsigned long *)0x20088B78)
#define LPC_LCD_CRSR_IMG222_OFFSET 0xB78
#define LPC_LCD_CRSR_IMG222_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG222_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG223 (*(volatile unsigned long *)0x20088B7C)
#define LPC_LCD_CRSR_IMG223_OFFSET 0xB7C
#define LPC_LCD_CRSR_IMG223_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG223_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG224 (*(volatile unsigned long *)0x20088B80)
#define LPC_LCD_CRSR_IMG224_OFFSET 0xB80
#define LPC_LCD_CRSR_IMG224_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG224_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG225 (*(volatile unsigned long *)0x20088B84)
#define LPC_LCD_CRSR_IMG225_OFFSET 0xB84
#define LPC_LCD_CRSR_IMG225_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG225_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG226 (*(volatile unsigned long *)0x20088B88)
#define LPC_LCD_CRSR_IMG226_OFFSET 0xB88
#define LPC_LCD_CRSR_IMG226_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG226_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG227 (*(volatile unsigned long *)0x20088B8C)
#define LPC_LCD_CRSR_IMG227_OFFSET 0xB8C
#define LPC_LCD_CRSR_IMG227_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG227_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG228 (*(volatile unsigned long *)0x20088B90)
#define LPC_LCD_CRSR_IMG228_OFFSET 0xB90
#define LPC_LCD_CRSR_IMG228_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG228_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG229 (*(volatile unsigned long *)0x20088B94)
#define LPC_LCD_CRSR_IMG229_OFFSET 0xB94
#define LPC_LCD_CRSR_IMG229_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG229_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG230 (*(volatile unsigned long *)0x20088B98)
#define LPC_LCD_CRSR_IMG230_OFFSET 0xB98
#define LPC_LCD_CRSR_IMG230_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG230_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG231 (*(volatile unsigned long *)0x20088B9C)
#define LPC_LCD_CRSR_IMG231_OFFSET 0xB9C
#define LPC_LCD_CRSR_IMG231_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG231_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG232 (*(volatile unsigned long *)0x20088BA0)
#define LPC_LCD_CRSR_IMG232_OFFSET 0xBA0
#define LPC_LCD_CRSR_IMG232_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG232_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG233 (*(volatile unsigned long *)0x20088BA4)
#define LPC_LCD_CRSR_IMG233_OFFSET 0xBA4
#define LPC_LCD_CRSR_IMG233_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG233_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG234 (*(volatile unsigned long *)0x20088BA8)
#define LPC_LCD_CRSR_IMG234_OFFSET 0xBA8
#define LPC_LCD_CRSR_IMG234_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG234_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG235 (*(volatile unsigned long *)0x20088BAC)
#define LPC_LCD_CRSR_IMG235_OFFSET 0xBAC
#define LPC_LCD_CRSR_IMG235_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG235_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG236 (*(volatile unsigned long *)0x20088BB0)
#define LPC_LCD_CRSR_IMG236_OFFSET 0xBB0
#define LPC_LCD_CRSR_IMG236_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG236_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG237 (*(volatile unsigned long *)0x20088BB4)
#define LPC_LCD_CRSR_IMG237_OFFSET 0xBB4
#define LPC_LCD_CRSR_IMG237_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG237_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG238 (*(volatile unsigned long *)0x20088BB8)
#define LPC_LCD_CRSR_IMG238_OFFSET 0xBB8
#define LPC_LCD_CRSR_IMG238_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG238_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG239 (*(volatile unsigned long *)0x20088BBC)
#define LPC_LCD_CRSR_IMG239_OFFSET 0xBBC
#define LPC_LCD_CRSR_IMG239_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG239_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG240 (*(volatile unsigned long *)0x20088BC0)
#define LPC_LCD_CRSR_IMG240_OFFSET 0xBC0
#define LPC_LCD_CRSR_IMG240_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG240_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG241 (*(volatile unsigned long *)0x20088BC4)
#define LPC_LCD_CRSR_IMG241_OFFSET 0xBC4
#define LPC_LCD_CRSR_IMG241_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG241_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG242 (*(volatile unsigned long *)0x20088BC8)
#define LPC_LCD_CRSR_IMG242_OFFSET 0xBC8
#define LPC_LCD_CRSR_IMG242_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG242_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG243 (*(volatile unsigned long *)0x20088BCC)
#define LPC_LCD_CRSR_IMG243_OFFSET 0xBCC
#define LPC_LCD_CRSR_IMG243_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG243_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG244 (*(volatile unsigned long *)0x20088BD0)
#define LPC_LCD_CRSR_IMG244_OFFSET 0xBD0
#define LPC_LCD_CRSR_IMG244_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG244_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG245 (*(volatile unsigned long *)0x20088BD4)
#define LPC_LCD_CRSR_IMG245_OFFSET 0xBD4
#define LPC_LCD_CRSR_IMG245_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG245_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG246 (*(volatile unsigned long *)0x20088BD8)
#define LPC_LCD_CRSR_IMG246_OFFSET 0xBD8
#define LPC_LCD_CRSR_IMG246_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG246_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG247 (*(volatile unsigned long *)0x20088BDC)
#define LPC_LCD_CRSR_IMG247_OFFSET 0xBDC
#define LPC_LCD_CRSR_IMG247_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG247_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG248 (*(volatile unsigned long *)0x20088BE0)
#define LPC_LCD_CRSR_IMG248_OFFSET 0xBE0
#define LPC_LCD_CRSR_IMG248_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG248_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG249 (*(volatile unsigned long *)0x20088BE4)
#define LPC_LCD_CRSR_IMG249_OFFSET 0xBE4
#define LPC_LCD_CRSR_IMG249_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG249_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG250 (*(volatile unsigned long *)0x20088BE8)
#define LPC_LCD_CRSR_IMG250_OFFSET 0xBE8
#define LPC_LCD_CRSR_IMG250_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG250_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG251 (*(volatile unsigned long *)0x20088BEC)
#define LPC_LCD_CRSR_IMG251_OFFSET 0xBEC
#define LPC_LCD_CRSR_IMG251_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG251_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG252 (*(volatile unsigned long *)0x20088BF0)
#define LPC_LCD_CRSR_IMG252_OFFSET 0xBF0
#define LPC_LCD_CRSR_IMG252_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG252_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG253 (*(volatile unsigned long *)0x20088BF4)
#define LPC_LCD_CRSR_IMG253_OFFSET 0xBF4
#define LPC_LCD_CRSR_IMG253_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG253_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG254 (*(volatile unsigned long *)0x20088BF8)
#define LPC_LCD_CRSR_IMG254_OFFSET 0xBF8
#define LPC_LCD_CRSR_IMG254_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG254_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_IMG255 (*(volatile unsigned long *)0x20088BFC)
#define LPC_LCD_CRSR_IMG255_OFFSET 0xBFC
#define LPC_LCD_CRSR_IMG255_CRSR_IMG_MASK 0xFFFFFFFF
#define LPC_LCD_CRSR_IMG255_CRSR_IMG_BIT 0

#define LPC_LCD_CRSR_CTRL (*(volatile unsigned long *)0x20088C00)
#define LPC_LCD_CRSR_CTRL_OFFSET 0xC00
#define LPC_LCD_CRSR_CTRL_CRSRON_MASK 0x1
#define LPC_LCD_CRSR_CTRL_CRSRON 0x1
#define LPC_LCD_CRSR_CTRL_CRSRON_BIT 0
#define LPC_LCD_CRSR_CTRL_CRSRNUM1_0_MASK 0x30
#define LPC_LCD_CRSR_CTRL_CRSRNUM1_0_BIT 4

#define LPC_LCD_CRSR_CFG (*(volatile unsigned long *)0x20088C04)
#define LPC_LCD_CRSR_CFG_OFFSET 0xC04
#define LPC_LCD_CRSR_CFG_CRSRSIZE_MASK 0x1
#define LPC_LCD_CRSR_CFG_CRSRSIZE 0x1
#define LPC_LCD_CRSR_CFG_CRSRSIZE_BIT 0
#define LPC_LCD_CRSR_CFG_FRAMESYNC_MASK 0x2
#define LPC_LCD_CRSR_CFG_FRAMESYNC 0x2
#define LPC_LCD_CRSR_CFG_FRAMESYNC_BIT 1

#define LPC_LCD_CRSR_PAL0 (*(volatile unsigned long *)0x20088C08)
#define LPC_LCD_CRSR_PAL0_OFFSET 0xC08
#define LPC_LCD_CRSR_PAL0_RED_MASK 0xFF
#define LPC_LCD_CRSR_PAL0_RED_BIT 0
#define LPC_LCD_CRSR_PAL0_GREEN_MASK 0xFF00
#define LPC_LCD_CRSR_PAL0_GREEN_BIT 8
#define LPC_LCD_CRSR_PAL0_BLUE_MASK 0xFF0000
#define LPC_LCD_CRSR_PAL0_BLUE_BIT 16

#define LPC_LCD_CRSR_PAL1 (*(volatile unsigned long *)0x20088C0C)
#define LPC_LCD_CRSR_PAL1_OFFSET 0xC0C
#define LPC_LCD_CRSR_PAL1_RED_MASK 0xFF
#define LPC_LCD_CRSR_PAL1_RED_BIT 0
#define LPC_LCD_CRSR_PAL1_GREEN_MASK 0xFF00
#define LPC_LCD_CRSR_PAL1_GREEN_BIT 8
#define LPC_LCD_CRSR_PAL1_BLUE_MASK 0xFF0000
#define LPC_LCD_CRSR_PAL1_BLUE_BIT 16

#define LPC_LCD_CRSR_XY (*(volatile unsigned long *)0x20088C10)
#define LPC_LCD_CRSR_XY_OFFSET 0xC10
#define LPC_LCD_CRSR_XY_CRSRX_MASK 0x3FF
#define LPC_LCD_CRSR_XY_CRSRX_BIT 0
#define LPC_LCD_CRSR_XY_CRSRY_MASK 0x3FF0000
#define LPC_LCD_CRSR_XY_CRSRY_BIT 16

#define LPC_LCD_CRSR_CLIP (*(volatile unsigned long *)0x20088C14)
#define LPC_LCD_CRSR_CLIP_OFFSET 0xC14
#define LPC_LCD_CRSR_CLIP_CRSRCLIPX_MASK 0x3F
#define LPC_LCD_CRSR_CLIP_CRSRCLIPX_BIT 0
#define LPC_LCD_CRSR_CLIP_CRSRCLIPY_MASK 0x3F00
#define LPC_LCD_CRSR_CLIP_CRSRCLIPY_BIT 8

#define LPC_LCD_CRSR_INTMSK (*(volatile unsigned long *)0x20088C20)
#define LPC_LCD_CRSR_INTMSK_OFFSET 0xC20
#define LPC_LCD_CRSR_INTMSK_CRSRIM_MASK 0x1
#define LPC_LCD_CRSR_INTMSK_CRSRIM 0x1
#define LPC_LCD_CRSR_INTMSK_CRSRIM_BIT 0

#define LPC_LCD_CRSR_INTCLR (*(volatile unsigned long *)0x20088C24)
#define LPC_LCD_CRSR_INTCLR_OFFSET 0xC24
#define LPC_LCD_CRSR_INTCLR_CRSRIC_MASK 0x1
#define LPC_LCD_CRSR_INTCLR_CRSRIC 0x1
#define LPC_LCD_CRSR_INTCLR_CRSRIC_BIT 0

#define LPC_LCD_CRSR_INTRAW (*(volatile unsigned long *)0x20088C28)
#define LPC_LCD_CRSR_INTRAW_OFFSET 0xC28
#define LPC_LCD_CRSR_INTRAW_CRSRRIS_MASK 0x1
#define LPC_LCD_CRSR_INTRAW_CRSRRIS 0x1
#define LPC_LCD_CRSR_INTRAW_CRSRRIS_BIT 0

#define LPC_LCD_CRSR_INTSTAT (*(volatile unsigned long *)0x20088C2C)
#define LPC_LCD_CRSR_INTSTAT_OFFSET 0xC2C
#define LPC_LCD_CRSR_INTSTAT_CRSRMIS_MASK 0x1
#define LPC_LCD_CRSR_INTSTAT_CRSRMIS 0x1
#define LPC_LCD_CRSR_INTSTAT_CRSRMIS_BIT 0

#ifndef LPC_USB_BASE_ADDRESS
#define LPC_USB_BASE_ADDRESS 0x2008C000
#endif

#define LPC_USB_INTST (*(volatile unsigned long *)0x2008C100)
#define LPC_USB_INTST_OFFSET 0x100
#define LPC_USB_INTST_TMR_MASK 0x1
#define LPC_USB_INTST_TMR 0x1
#define LPC_USB_INTST_TMR_BIT 0
#define LPC_USB_INTST_REMOVE_PU_MASK 0x2
#define LPC_USB_INTST_REMOVE_PU 0x2
#define LPC_USB_INTST_REMOVE_PU_BIT 1
#define LPC_USB_INTST_HNP_FAILURE_MASK 0x4
#define LPC_USB_INTST_HNP_FAILURE 0x4
#define LPC_USB_INTST_HNP_FAILURE_BIT 2
#define LPC_USB_INTST_HNP_SUCCESS_MASK 0x8
#define LPC_USB_INTST_HNP_SUCCESS 0x8
#define LPC_USB_INTST_HNP_SUCCESS_BIT 3

#define LPC_USB_INTEN (*(volatile unsigned long *)0x2008C104)
#define LPC_USB_INTEN_OFFSET 0x104
#define LPC_USB_INTEN_TMR_EN_MASK 0x1
#define LPC_USB_INTEN_TMR_EN 0x1
#define LPC_USB_INTEN_TMR_EN_BIT 0
#define LPC_USB_INTEN_REMOVE_PU_EN_MASK 0x2
#define LPC_USB_INTEN_REMOVE_PU_EN 0x2
#define LPC_USB_INTEN_REMOVE_PU_EN_BIT 1
#define LPC_USB_INTEN_HNP_FAILURE_EN_MASK 0x4
#define LPC_USB_INTEN_HNP_FAILURE_EN 0x4
#define LPC_USB_INTEN_HNP_FAILURE_EN_BIT 2
#define LPC_USB_INTEN_HNP_SUCCES_EN_MASK 0x8
#define LPC_USB_INTEN_HNP_SUCCES_EN 0x8
#define LPC_USB_INTEN_HNP_SUCCES_EN_BIT 3

#define LPC_USB_INTSET (*(volatile unsigned long *)0x2008C108)
#define LPC_USB_INTSET_OFFSET 0x108
#define LPC_USB_INTSET_TMR_SET_MASK 0x1
#define LPC_USB_INTSET_TMR_SET 0x1
#define LPC_USB_INTSET_TMR_SET_BIT 0
#define LPC_USB_INTSET_REMOVE_PU_SET_MASK 0x2
#define LPC_USB_INTSET_REMOVE_PU_SET 0x2
#define LPC_USB_INTSET_REMOVE_PU_SET_BIT 1
#define LPC_USB_INTSET_HNP_FAILURE_SET_MASK 0x4
#define LPC_USB_INTSET_HNP_FAILURE_SET 0x4
#define LPC_USB_INTSET_HNP_FAILURE_SET_BIT 2
#define LPC_USB_INTSET_HNP_SUCCES_SET_MASK 0x8
#define LPC_USB_INTSET_HNP_SUCCES_SET 0x8
#define LPC_USB_INTSET_HNP_SUCCES_SET_BIT 3

#define LPC_USB_INCLR (*(volatile unsigned long *)0x2008C10C)
#define LPC_USB_INCLR_OFFSET 0x10C
#define LPC_USB_INCLR_TMR_CLR_MASK 0x1
#define LPC_USB_INCLR_TMR_CLR 0x1
#define LPC_USB_INCLR_TMR_CLR_BIT 0
#define LPC_USB_INCLR_REMOVE_PU_CLR_MASK 0x2
#define LPC_USB_INCLR_REMOVE_PU_CLR 0x2
#define LPC_USB_INCLR_REMOVE_PU_CLR_BIT 1
#define LPC_USB_INCLR_HNP_FAILURE_CLR_MASK 0x4
#define LPC_USB_INCLR_HNP_FAILURE_CLR 0x4
#define LPC_USB_INCLR_HNP_FAILURE_CLR_BIT 2
#define LPC_USB_INCLR_HNP_SUCCES_CLR_MASK 0x8
#define LPC_USB_INCLR_HNP_SUCCES_CLR 0x8
#define LPC_USB_INCLR_HNP_SUCCES_CLR_BIT 3

#define LPC_USB_PORTSEL (*(volatile unsigned long *)0x2008C110)
#define LPC_USB_PORTSEL_OFFSET 0x110
#define LPC_USB_PORTSEL_PORTSEL_MASK 0x3
#define LPC_USB_PORTSEL_PORTSEL_BIT 0
#define LPC_USB_PORTSEL_TMR_SCALE_MASK 0xC
#define LPC_USB_PORTSEL_TMR_SCALE_BIT 2
#define LPC_USB_PORTSEL_TMR_MODE_MASK 0x10
#define LPC_USB_PORTSEL_TMR_MODE 0x10
#define LPC_USB_PORTSEL_TMR_MODE_BIT 4
#define LPC_USB_PORTSEL_TMR_EN_MASK 0x20
#define LPC_USB_PORTSEL_TMR_EN 0x20
#define LPC_USB_PORTSEL_TMR_EN_BIT 5
#define LPC_USB_PORTSEL_TMR_RST_MASK 0x40
#define LPC_USB_PORTSEL_TMR_RST 0x40
#define LPC_USB_PORTSEL_TMR_RST_BIT 6
#define LPC_USB_PORTSEL_B_HNP_TRACK_MASK 0x100
#define LPC_USB_PORTSEL_B_HNP_TRACK 0x100
#define LPC_USB_PORTSEL_B_HNP_TRACK_BIT 8
#define LPC_USB_PORTSEL_A_HNP_TRACK_MASK 0x200
#define LPC_USB_PORTSEL_A_HNP_TRACK 0x200
#define LPC_USB_PORTSEL_A_HNP_TRACK_BIT 9
#define LPC_USB_PORTSEL_PU_REMOVED_MASK 0x400
#define LPC_USB_PORTSEL_PU_REMOVED 0x400
#define LPC_USB_PORTSEL_PU_REMOVED_BIT 10
#define LPC_USB_PORTSEL_TMR_CNT_MASK 0xFFFF0000
#define LPC_USB_PORTSEL_TMR_CNT_BIT 16

#define LPC_USB_TMR (*(volatile unsigned long *)0x2008C114)
#define LPC_USB_TMR_OFFSET 0x114
#define LPC_USB_TMR_TIMEOUT_CNT_MASK 0xFFFF
#define LPC_USB_TMR_TIMEOUT_CNT_BIT 0

#define LPC_USB_DEVINTST (*(volatile unsigned long *)0x2008C200)
#define LPC_USB_DEVINTST_OFFSET 0x200
#define LPC_USB_DEVINTST_FRAME_MASK 0x1
#define LPC_USB_DEVINTST_FRAME 0x1
#define LPC_USB_DEVINTST_FRAME_BIT 0
#define LPC_USB_DEVINTST_EP_FAST_MASK 0x2
#define LPC_USB_DEVINTST_EP_FAST 0x2
#define LPC_USB_DEVINTST_EP_FAST_BIT 1
#define LPC_USB_DEVINTST_EP_SLOW_MASK 0x4
#define LPC_USB_DEVINTST_EP_SLOW 0x4
#define LPC_USB_DEVINTST_EP_SLOW_BIT 2
#define LPC_USB_DEVINTST_DEV_STAT_MASK 0x8
#define LPC_USB_DEVINTST_DEV_STAT 0x8
#define LPC_USB_DEVINTST_DEV_STAT_BIT 3
#define LPC_USB_DEVINTST_CCEMPTY_MASK 0x10
#define LPC_USB_DEVINTST_CCEMPTY 0x10
#define LPC_USB_DEVINTST_CCEMPTY_BIT 4
#define LPC_USB_DEVINTST_CDFULL_MASK 0x20
#define LPC_USB_DEVINTST_CDFULL 0x20
#define LPC_USB_DEVINTST_CDFULL_BIT 5
#define LPC_USB_DEVINTST_RxENDPKT_MASK 0x40
#define LPC_USB_DEVINTST_RxENDPKT 0x40
#define LPC_USB_DEVINTST_RxENDPKT_BIT 6
#define LPC_USB_DEVINTST_TxENDPKT_MASK 0x80
#define LPC_USB_DEVINTST_TxENDPKT 0x80
#define LPC_USB_DEVINTST_TxENDPKT_BIT 7
#define LPC_USB_DEVINTST_EP_RLZED_MASK 0x100
#define LPC_USB_DEVINTST_EP_RLZED 0x100
#define LPC_USB_DEVINTST_EP_RLZED_BIT 8
#define LPC_USB_DEVINTST_ERR_INT_MASK 0x200
#define LPC_USB_DEVINTST_ERR_INT 0x200
#define LPC_USB_DEVINTST_ERR_INT_BIT 9

#define LPC_USB_DEVINTEN (*(volatile unsigned long *)0x2008C204)
#define LPC_USB_DEVINTEN_OFFSET 0x204
#define LPC_USB_DEVINTEN_FRAMEEN_MASK 0x1
#define LPC_USB_DEVINTEN_FRAMEEN 0x1
#define LPC_USB_DEVINTEN_FRAMEEN_BIT 0
#define LPC_USB_DEVINTEN_EP_FASTEN_MASK 0x2
#define LPC_USB_DEVINTEN_EP_FASTEN 0x2
#define LPC_USB_DEVINTEN_EP_FASTEN_BIT 1
#define LPC_USB_DEVINTEN_EP_SLOWEN_MASK 0x4
#define LPC_USB_DEVINTEN_EP_SLOWEN 0x4
#define LPC_USB_DEVINTEN_EP_SLOWEN_BIT 2
#define LPC_USB_DEVINTEN_DEV_STATEN_MASK 0x8
#define LPC_USB_DEVINTEN_DEV_STATEN 0x8
#define LPC_USB_DEVINTEN_DEV_STATEN_BIT 3
#define LPC_USB_DEVINTEN_CCEMPTYEN_MASK 0x10
#define LPC_USB_DEVINTEN_CCEMPTYEN 0x10
#define LPC_USB_DEVINTEN_CCEMPTYEN_BIT 4
#define LPC_USB_DEVINTEN_CDFULLEN_MASK 0x20
#define LPC_USB_DEVINTEN_CDFULLEN 0x20
#define LPC_USB_DEVINTEN_CDFULLEN_BIT 5
#define LPC_USB_DEVINTEN_RxENDPKTEN_MASK 0x40
#define LPC_USB_DEVINTEN_RxENDPKTEN 0x40
#define LPC_USB_DEVINTEN_RxENDPKTEN_BIT 6
#define LPC_USB_DEVINTEN_TxENDPKTEN_MASK 0x80
#define LPC_USB_DEVINTEN_TxENDPKTEN 0x80
#define LPC_USB_DEVINTEN_TxENDPKTEN_BIT 7
#define LPC_USB_DEVINTEN_EP_RLZEDEN_MASK 0x100
#define LPC_USB_DEVINTEN_EP_RLZEDEN 0x100
#define LPC_USB_DEVINTEN_EP_RLZEDEN_BIT 8
#define LPC_USB_DEVINTEN_ERR_INTEN_MASK 0x200
#define LPC_USB_DEVINTEN_ERR_INTEN 0x200
#define LPC_USB_DEVINTEN_ERR_INTEN_BIT 9

#define LPC_USB_DEVINTCLR (*(volatile unsigned long *)0x2008C208)
#define LPC_USB_DEVINTCLR_OFFSET 0x208
#define LPC_USB_DEVINTCLR_FRAMECLR_MASK 0x1
#define LPC_USB_DEVINTCLR_FRAMECLR 0x1
#define LPC_USB_DEVINTCLR_FRAMECLR_BIT 0
#define LPC_USB_DEVINTCLR_EP_FASTCLR_MASK 0x2
#define LPC_USB_DEVINTCLR_EP_FASTCLR 0x2
#define LPC_USB_DEVINTCLR_EP_FASTCLR_BIT 1
#define LPC_USB_DEVINTCLR_EP_SLOWCLR_MASK 0x4
#define LPC_USB_DEVINTCLR_EP_SLOWCLR 0x4
#define LPC_USB_DEVINTCLR_EP_SLOWCLR_BIT 2
#define LPC_USB_DEVINTCLR_DEV_STATCLR_MASK 0x8
#define LPC_USB_DEVINTCLR_DEV_STATCLR 0x8
#define LPC_USB_DEVINTCLR_DEV_STATCLR_BIT 3
#define LPC_USB_DEVINTCLR_CCEMPTYCLR_MASK 0x10
#define LPC_USB_DEVINTCLR_CCEMPTYCLR 0x10
#define LPC_USB_DEVINTCLR_CCEMPTYCLR_BIT 4
#define LPC_USB_DEVINTCLR_CDFULLCLR_MASK 0x20
#define LPC_USB_DEVINTCLR_CDFULLCLR 0x20
#define LPC_USB_DEVINTCLR_CDFULLCLR_BIT 5
#define LPC_USB_DEVINTCLR_RxENDPKTCLR_MASK 0x40
#define LPC_USB_DEVINTCLR_RxENDPKTCLR 0x40
#define LPC_USB_DEVINTCLR_RxENDPKTCLR_BIT 6
#define LPC_USB_DEVINTCLR_TxENDPKTCLR_MASK 0x80
#define LPC_USB_DEVINTCLR_TxENDPKTCLR 0x80
#define LPC_USB_DEVINTCLR_TxENDPKTCLR_BIT 7
#define LPC_USB_DEVINTCLR_EP_RLZEDCLR_MASK 0x100
#define LPC_USB_DEVINTCLR_EP_RLZEDCLR 0x100
#define LPC_USB_DEVINTCLR_EP_RLZEDCLR_BIT 8
#define LPC_USB_DEVINTCLR_ERR_INTCLR_MASK 0x200
#define LPC_USB_DEVINTCLR_ERR_INTCLR 0x200
#define LPC_USB_DEVINTCLR_ERR_INTCLR_BIT 9

#define LPC_USB_DEVINTSET (*(volatile unsigned long *)0x2008C20C)
#define LPC_USB_DEVINTSET_OFFSET 0x20C
#define LPC_USB_DEVINTSET_FRAMESET_MASK 0x1
#define LPC_USB_DEVINTSET_FRAMESET 0x1
#define LPC_USB_DEVINTSET_FRAMESET_BIT 0
#define LPC_USB_DEVINTSET_EP_FASTSET_MASK 0x2
#define LPC_USB_DEVINTSET_EP_FASTSET 0x2
#define LPC_USB_DEVINTSET_EP_FASTSET_BIT 1
#define LPC_USB_DEVINTSET_EP_SLOWSET_MASK 0x4
#define LPC_USB_DEVINTSET_EP_SLOWSET 0x4
#define LPC_USB_DEVINTSET_EP_SLOWSET_BIT 2
#define LPC_USB_DEVINTSET_DEV_STATSET_MASK 0x8
#define LPC_USB_DEVINTSET_DEV_STATSET 0x8
#define LPC_USB_DEVINTSET_DEV_STATSET_BIT 3
#define LPC_USB_DEVINTSET_CCEMPTYSET_MASK 0x10
#define LPC_USB_DEVINTSET_CCEMPTYSET 0x10
#define LPC_USB_DEVINTSET_CCEMPTYSET_BIT 4
#define LPC_USB_DEVINTSET_CDFULLSET_MASK 0x20
#define LPC_USB_DEVINTSET_CDFULLSET 0x20
#define LPC_USB_DEVINTSET_CDFULLSET_BIT 5
#define LPC_USB_DEVINTSET_RxENDPKTSET_MASK 0x40
#define LPC_USB_DEVINTSET_RxENDPKTSET 0x40
#define LPC_USB_DEVINTSET_RxENDPKTSET_BIT 6
#define LPC_USB_DEVINTSET_TxENDPKTSET_MASK 0x80
#define LPC_USB_DEVINTSET_TxENDPKTSET 0x80
#define LPC_USB_DEVINTSET_TxENDPKTSET_BIT 7
#define LPC_USB_DEVINTSET_EP_RLZEDSET_MASK 0x100
#define LPC_USB_DEVINTSET_EP_RLZEDSET 0x100
#define LPC_USB_DEVINTSET_EP_RLZEDSET_BIT 8
#define LPC_USB_DEVINTSET_ERR_INTSET_MASK 0x200
#define LPC_USB_DEVINTSET_ERR_INTSET 0x200
#define LPC_USB_DEVINTSET_ERR_INTSET_BIT 9

#define LPC_USB_DEVINTPRI (*(volatile unsigned long *)0x2008C22C)
#define LPC_USB_DEVINTPRI_OFFSET 0x22C
#define LPC_USB_DEVINTPRI_FRAME_MASK 0x1
#define LPC_USB_DEVINTPRI_FRAME 0x1
#define LPC_USB_DEVINTPRI_FRAME_BIT 0
#define LPC_USB_DEVINTPRI_EP_FAST_MASK 0x2
#define LPC_USB_DEVINTPRI_EP_FAST 0x2
#define LPC_USB_DEVINTPRI_EP_FAST_BIT 1

#define LPC_USB_EPINTST (*(volatile unsigned long *)0x2008C230)
#define LPC_USB_EPINTST_OFFSET 0x230
#define LPC_USB_EPINTST_EPST0_MASK 0x1
#define LPC_USB_EPINTST_EPST0 0x1
#define LPC_USB_EPINTST_EPST0_BIT 0
#define LPC_USB_EPINTST_EPST1_MASK 0x2
#define LPC_USB_EPINTST_EPST1 0x2
#define LPC_USB_EPINTST_EPST1_BIT 1
#define LPC_USB_EPINTST_EPST2_MASK 0x4
#define LPC_USB_EPINTST_EPST2 0x4
#define LPC_USB_EPINTST_EPST2_BIT 2
#define LPC_USB_EPINTST_EPST3_MASK 0x8
#define LPC_USB_EPINTST_EPST3 0x8
#define LPC_USB_EPINTST_EPST3_BIT 3
#define LPC_USB_EPINTST_EPST4_MASK 0x10
#define LPC_USB_EPINTST_EPST4 0x10
#define LPC_USB_EPINTST_EPST4_BIT 4
#define LPC_USB_EPINTST_EPST5_MASK 0x20
#define LPC_USB_EPINTST_EPST5 0x20
#define LPC_USB_EPINTST_EPST5_BIT 5
#define LPC_USB_EPINTST_EPST6_MASK 0x40
#define LPC_USB_EPINTST_EPST6 0x40
#define LPC_USB_EPINTST_EPST6_BIT 6
#define LPC_USB_EPINTST_EPST7_MASK 0x80
#define LPC_USB_EPINTST_EPST7 0x80
#define LPC_USB_EPINTST_EPST7_BIT 7
#define LPC_USB_EPINTST_EPST8_MASK 0x100
#define LPC_USB_EPINTST_EPST8 0x100
#define LPC_USB_EPINTST_EPST8_BIT 8
#define LPC_USB_EPINTST_EPST9_MASK 0x200
#define LPC_USB_EPINTST_EPST9 0x200
#define LPC_USB_EPINTST_EPST9_BIT 9
#define LPC_USB_EPINTST_EPST10_MASK 0x400
#define LPC_USB_EPINTST_EPST10 0x400
#define LPC_USB_EPINTST_EPST10_BIT 10
#define LPC_USB_EPINTST_EPST11_MASK 0x800
#define LPC_USB_EPINTST_EPST11 0x800
#define LPC_USB_EPINTST_EPST11_BIT 11
#define LPC_USB_EPINTST_EPST12_MASK 0x1000
#define LPC_USB_EPINTST_EPST12 0x1000
#define LPC_USB_EPINTST_EPST12_BIT 12
#define LPC_USB_EPINTST_EPST13_MASK 0x2000
#define LPC_USB_EPINTST_EPST13 0x2000
#define LPC_USB_EPINTST_EPST13_BIT 13
#define LPC_USB_EPINTST_EPST14_MASK 0x4000
#define LPC_USB_EPINTST_EPST14 0x4000
#define LPC_USB_EPINTST_EPST14_BIT 14
#define LPC_USB_EPINTST_EPST15_MASK 0x8000
#define LPC_USB_EPINTST_EPST15 0x8000
#define LPC_USB_EPINTST_EPST15_BIT 15
#define LPC_USB_EPINTST_EPST16_MASK 0x10000
#define LPC_USB_EPINTST_EPST16 0x10000
#define LPC_USB_EPINTST_EPST16_BIT 16
#define LPC_USB_EPINTST_EPST17_MASK 0x20000
#define LPC_USB_EPINTST_EPST17 0x20000
#define LPC_USB_EPINTST_EPST17_BIT 17
#define LPC_USB_EPINTST_EPST18_MASK 0x40000
#define LPC_USB_EPINTST_EPST18 0x40000
#define LPC_USB_EPINTST_EPST18_BIT 18
#define LPC_USB_EPINTST_EPST19_MASK 0x80000
#define LPC_USB_EPINTST_EPST19 0x80000
#define LPC_USB_EPINTST_EPST19_BIT 19
#define LPC_USB_EPINTST_EPST20_MASK 0x100000
#define LPC_USB_EPINTST_EPST20 0x100000
#define LPC_USB_EPINTST_EPST20_BIT 20
#define LPC_USB_EPINTST_EPST21_MASK 0x200000
#define LPC_USB_EPINTST_EPST21 0x200000
#define LPC_USB_EPINTST_EPST21_BIT 21
#define LPC_USB_EPINTST_EPST22_MASK 0x400000
#define LPC_USB_EPINTST_EPST22 0x400000
#define LPC_USB_EPINTST_EPST22_BIT 22
#define LPC_USB_EPINTST_EPST23_MASK 0x800000
#define LPC_USB_EPINTST_EPST23 0x800000
#define LPC_USB_EPINTST_EPST23_BIT 23
#define LPC_USB_EPINTST_EPST24_MASK 0x1000000
#define LPC_USB_EPINTST_EPST24 0x1000000
#define LPC_USB_EPINTST_EPST24_BIT 24
#define LPC_USB_EPINTST_EPST25_MASK 0x2000000
#define LPC_USB_EPINTST_EPST25 0x2000000
#define LPC_USB_EPINTST_EPST25_BIT 25
#define LPC_USB_EPINTST_EPST26_MASK 0x4000000
#define LPC_USB_EPINTST_EPST26 0x4000000
#define LPC_USB_EPINTST_EPST26_BIT 26
#define LPC_USB_EPINTST_EPST27_MASK 0x8000000
#define LPC_USB_EPINTST_EPST27 0x8000000
#define LPC_USB_EPINTST_EPST27_BIT 27
#define LPC_USB_EPINTST_EPST28_MASK 0x10000000
#define LPC_USB_EPINTST_EPST28 0x10000000
#define LPC_USB_EPINTST_EPST28_BIT 28
#define LPC_USB_EPINTST_EPST29_MASK 0x20000000
#define LPC_USB_EPINTST_EPST29 0x20000000
#define LPC_USB_EPINTST_EPST29_BIT 29
#define LPC_USB_EPINTST_EPST30_MASK 0x40000000
#define LPC_USB_EPINTST_EPST30 0x40000000
#define LPC_USB_EPINTST_EPST30_BIT 30
#define LPC_USB_EPINTST_EPST31_MASK 0x80000000
#define LPC_USB_EPINTST_EPST31 0x80000000
#define LPC_USB_EPINTST_EPST31_BIT 31

#define LPC_USB_EPINTEN (*(volatile unsigned long *)0x2008C234)
#define LPC_USB_EPINTEN_OFFSET 0x234
#define LPC_USB_EPINTEN_EPEN0_MASK 0x1
#define LPC_USB_EPINTEN_EPEN0 0x1
#define LPC_USB_EPINTEN_EPEN0_BIT 0
#define LPC_USB_EPINTEN_EPEN1_MASK 0x2
#define LPC_USB_EPINTEN_EPEN1 0x2
#define LPC_USB_EPINTEN_EPEN1_BIT 1
#define LPC_USB_EPINTEN_EPEN2_MASK 0x4
#define LPC_USB_EPINTEN_EPEN2 0x4
#define LPC_USB_EPINTEN_EPEN2_BIT 2
#define LPC_USB_EPINTEN_EPEN3_MASK 0x8
#define LPC_USB_EPINTEN_EPEN3 0x8
#define LPC_USB_EPINTEN_EPEN3_BIT 3
#define LPC_USB_EPINTEN_EPEN4_MASK 0x10
#define LPC_USB_EPINTEN_EPEN4 0x10
#define LPC_USB_EPINTEN_EPEN4_BIT 4
#define LPC_USB_EPINTEN_EPEN5_MASK 0x20
#define LPC_USB_EPINTEN_EPEN5 0x20
#define LPC_USB_EPINTEN_EPEN5_BIT 5
#define LPC_USB_EPINTEN_EPEN6_MASK 0x40
#define LPC_USB_EPINTEN_EPEN6 0x40
#define LPC_USB_EPINTEN_EPEN6_BIT 6
#define LPC_USB_EPINTEN_EPEN7_MASK 0x80
#define LPC_USB_EPINTEN_EPEN7 0x80
#define LPC_USB_EPINTEN_EPEN7_BIT 7
#define LPC_USB_EPINTEN_EPEN8_MASK 0x100
#define LPC_USB_EPINTEN_EPEN8 0x100
#define LPC_USB_EPINTEN_EPEN8_BIT 8
#define LPC_USB_EPINTEN_EPEN9_MASK 0x200
#define LPC_USB_EPINTEN_EPEN9 0x200
#define LPC_USB_EPINTEN_EPEN9_BIT 9
#define LPC_USB_EPINTEN_EPEN10_MASK 0x400
#define LPC_USB_EPINTEN_EPEN10 0x400
#define LPC_USB_EPINTEN_EPEN10_BIT 10
#define LPC_USB_EPINTEN_EPEN11_MASK 0x800
#define LPC_USB_EPINTEN_EPEN11 0x800
#define LPC_USB_EPINTEN_EPEN11_BIT 11
#define LPC_USB_EPINTEN_EPEN12_MASK 0x1000
#define LPC_USB_EPINTEN_EPEN12 0x1000
#define LPC_USB_EPINTEN_EPEN12_BIT 12
#define LPC_USB_EPINTEN_EPEN13_MASK 0x2000
#define LPC_USB_EPINTEN_EPEN13 0x2000
#define LPC_USB_EPINTEN_EPEN13_BIT 13
#define LPC_USB_EPINTEN_EPEN14_MASK 0x4000
#define LPC_USB_EPINTEN_EPEN14 0x4000
#define LPC_USB_EPINTEN_EPEN14_BIT 14
#define LPC_USB_EPINTEN_EPEN15_MASK 0x8000
#define LPC_USB_EPINTEN_EPEN15 0x8000
#define LPC_USB_EPINTEN_EPEN15_BIT 15
#define LPC_USB_EPINTEN_EPEN16_MASK 0x10000
#define LPC_USB_EPINTEN_EPEN16 0x10000
#define LPC_USB_EPINTEN_EPEN16_BIT 16
#define LPC_USB_EPINTEN_EPEN17_MASK 0x20000
#define LPC_USB_EPINTEN_EPEN17 0x20000
#define LPC_USB_EPINTEN_EPEN17_BIT 17
#define LPC_USB_EPINTEN_EPEN18_MASK 0x40000
#define LPC_USB_EPINTEN_EPEN18 0x40000
#define LPC_USB_EPINTEN_EPEN18_BIT 18
#define LPC_USB_EPINTEN_EPEN19_MASK 0x80000
#define LPC_USB_EPINTEN_EPEN19 0x80000
#define LPC_USB_EPINTEN_EPEN19_BIT 19
#define LPC_USB_EPINTEN_EPEN20_MASK 0x100000
#define LPC_USB_EPINTEN_EPEN20 0x100000
#define LPC_USB_EPINTEN_EPEN20_BIT 20
#define LPC_USB_EPINTEN_EPEN21_MASK 0x200000
#define LPC_USB_EPINTEN_EPEN21 0x200000
#define LPC_USB_EPINTEN_EPEN21_BIT 21
#define LPC_USB_EPINTEN_EPEN22_MASK 0x400000
#define LPC_USB_EPINTEN_EPEN22 0x400000
#define LPC_USB_EPINTEN_EPEN22_BIT 22
#define LPC_USB_EPINTEN_EPEN23_MASK 0x800000
#define LPC_USB_EPINTEN_EPEN23 0x800000
#define LPC_USB_EPINTEN_EPEN23_BIT 23
#define LPC_USB_EPINTEN_EPEN24_MASK 0x1000000
#define LPC_USB_EPINTEN_EPEN24 0x1000000
#define LPC_USB_EPINTEN_EPEN24_BIT 24
#define LPC_USB_EPINTEN_EPEN25_MASK 0x2000000
#define LPC_USB_EPINTEN_EPEN25 0x2000000
#define LPC_USB_EPINTEN_EPEN25_BIT 25
#define LPC_USB_EPINTEN_EPEN26_MASK 0x4000000
#define LPC_USB_EPINTEN_EPEN26 0x4000000
#define LPC_USB_EPINTEN_EPEN26_BIT 26
#define LPC_USB_EPINTEN_EPEN27_MASK 0x8000000
#define LPC_USB_EPINTEN_EPEN27 0x8000000
#define LPC_USB_EPINTEN_EPEN27_BIT 27
#define LPC_USB_EPINTEN_EPEN28_MASK 0x10000000
#define LPC_USB_EPINTEN_EPEN28 0x10000000
#define LPC_USB_EPINTEN_EPEN28_BIT 28
#define LPC_USB_EPINTEN_EPEN29_MASK 0x20000000
#define LPC_USB_EPINTEN_EPEN29 0x20000000
#define LPC_USB_EPINTEN_EPEN29_BIT 29
#define LPC_USB_EPINTEN_EPEN30_MASK 0x40000000
#define LPC_USB_EPINTEN_EPEN30 0x40000000
#define LPC_USB_EPINTEN_EPEN30_BIT 30
#define LPC_USB_EPINTEN_EPEN31_MASK 0x80000000
#define LPC_USB_EPINTEN_EPEN31 0x80000000
#define LPC_USB_EPINTEN_EPEN31_BIT 31

#define LPC_USB_EPINTCLR (*(volatile unsigned long *)0x2008C238)
#define LPC_USB_EPINTCLR_OFFSET 0x238
#define LPC_USB_EPINTCLR_EPCLR0_MASK 0x1
#define LPC_USB_EPINTCLR_EPCLR0 0x1
#define LPC_USB_EPINTCLR_EPCLR0_BIT 0
#define LPC_USB_EPINTCLR_EPCLR1_MASK 0x2
#define LPC_USB_EPINTCLR_EPCLR1 0x2
#define LPC_USB_EPINTCLR_EPCLR1_BIT 1
#define LPC_USB_EPINTCLR_EPCLR2_MASK 0x4
#define LPC_USB_EPINTCLR_EPCLR2 0x4
#define LPC_USB_EPINTCLR_EPCLR2_BIT 2
#define LPC_USB_EPINTCLR_EPCLR3_MASK 0x8
#define LPC_USB_EPINTCLR_EPCLR3 0x8
#define LPC_USB_EPINTCLR_EPCLR3_BIT 3
#define LPC_USB_EPINTCLR_EPCLR4_MASK 0x10
#define LPC_USB_EPINTCLR_EPCLR4 0x10
#define LPC_USB_EPINTCLR_EPCLR4_BIT 4
#define LPC_USB_EPINTCLR_EPCLR5_MASK 0x20
#define LPC_USB_EPINTCLR_EPCLR5 0x20
#define LPC_USB_EPINTCLR_EPCLR5_BIT 5
#define LPC_USB_EPINTCLR_EPCLR6_MASK 0x40
#define LPC_USB_EPINTCLR_EPCLR6 0x40
#define LPC_USB_EPINTCLR_EPCLR6_BIT 6
#define LPC_USB_EPINTCLR_EPCLR7_MASK 0x80
#define LPC_USB_EPINTCLR_EPCLR7 0x80
#define LPC_USB_EPINTCLR_EPCLR7_BIT 7
#define LPC_USB_EPINTCLR_EPCLR8_MASK 0x100
#define LPC_USB_EPINTCLR_EPCLR8 0x100
#define LPC_USB_EPINTCLR_EPCLR8_BIT 8
#define LPC_USB_EPINTCLR_EPCLR9_MASK 0x200
#define LPC_USB_EPINTCLR_EPCLR9 0x200
#define LPC_USB_EPINTCLR_EPCLR9_BIT 9
#define LPC_USB_EPINTCLR_EPCLR10_MASK 0x400
#define LPC_USB_EPINTCLR_EPCLR10 0x400
#define LPC_USB_EPINTCLR_EPCLR10_BIT 10
#define LPC_USB_EPINTCLR_EPCLR11_MASK 0x800
#define LPC_USB_EPINTCLR_EPCLR11 0x800
#define LPC_USB_EPINTCLR_EPCLR11_BIT 11
#define LPC_USB_EPINTCLR_EPCLR12_MASK 0x1000
#define LPC_USB_EPINTCLR_EPCLR12 0x1000
#define LPC_USB_EPINTCLR_EPCLR12_BIT 12
#define LPC_USB_EPINTCLR_EPCLR13_MASK 0x2000
#define LPC_USB_EPINTCLR_EPCLR13 0x2000
#define LPC_USB_EPINTCLR_EPCLR13_BIT 13
#define LPC_USB_EPINTCLR_EPCLR14_MASK 0x4000
#define LPC_USB_EPINTCLR_EPCLR14 0x4000
#define LPC_USB_EPINTCLR_EPCLR14_BIT 14
#define LPC_USB_EPINTCLR_EPCLR15_MASK 0x8000
#define LPC_USB_EPINTCLR_EPCLR15 0x8000
#define LPC_USB_EPINTCLR_EPCLR15_BIT 15
#define LPC_USB_EPINTCLR_EPCLR16_MASK 0x10000
#define LPC_USB_EPINTCLR_EPCLR16 0x10000
#define LPC_USB_EPINTCLR_EPCLR16_BIT 16
#define LPC_USB_EPINTCLR_EPCLR17_MASK 0x20000
#define LPC_USB_EPINTCLR_EPCLR17 0x20000
#define LPC_USB_EPINTCLR_EPCLR17_BIT 17
#define LPC_USB_EPINTCLR_EPCLR18_MASK 0x40000
#define LPC_USB_EPINTCLR_EPCLR18 0x40000
#define LPC_USB_EPINTCLR_EPCLR18_BIT 18
#define LPC_USB_EPINTCLR_EPCLR19_MASK 0x80000
#define LPC_USB_EPINTCLR_EPCLR19 0x80000
#define LPC_USB_EPINTCLR_EPCLR19_BIT 19
#define LPC_USB_EPINTCLR_EPCLR20_MASK 0x100000
#define LPC_USB_EPINTCLR_EPCLR20 0x100000
#define LPC_USB_EPINTCLR_EPCLR20_BIT 20
#define LPC_USB_EPINTCLR_EPCLR21_MASK 0x200000
#define LPC_USB_EPINTCLR_EPCLR21 0x200000
#define LPC_USB_EPINTCLR_EPCLR21_BIT 21
#define LPC_USB_EPINTCLR_EPCLR22_MASK 0x400000
#define LPC_USB_EPINTCLR_EPCLR22 0x400000
#define LPC_USB_EPINTCLR_EPCLR22_BIT 22
#define LPC_USB_EPINTCLR_EPCLR23_MASK 0x800000
#define LPC_USB_EPINTCLR_EPCLR23 0x800000
#define LPC_USB_EPINTCLR_EPCLR23_BIT 23
#define LPC_USB_EPINTCLR_EPCLR24_MASK 0x1000000
#define LPC_USB_EPINTCLR_EPCLR24 0x1000000
#define LPC_USB_EPINTCLR_EPCLR24_BIT 24
#define LPC_USB_EPINTCLR_EPCLR25_MASK 0x2000000
#define LPC_USB_EPINTCLR_EPCLR25 0x2000000
#define LPC_USB_EPINTCLR_EPCLR25_BIT 25
#define LPC_USB_EPINTCLR_EPCLR26_MASK 0x4000000
#define LPC_USB_EPINTCLR_EPCLR26 0x4000000
#define LPC_USB_EPINTCLR_EPCLR26_BIT 26
#define LPC_USB_EPINTCLR_EPCLR27_MASK 0x8000000
#define LPC_USB_EPINTCLR_EPCLR27 0x8000000
#define LPC_USB_EPINTCLR_EPCLR27_BIT 27
#define LPC_USB_EPINTCLR_EPCLR28_MASK 0x10000000
#define LPC_USB_EPINTCLR_EPCLR28 0x10000000
#define LPC_USB_EPINTCLR_EPCLR28_BIT 28
#define LPC_USB_EPINTCLR_EPCLR29_MASK 0x20000000
#define LPC_USB_EPINTCLR_EPCLR29 0x20000000
#define LPC_USB_EPINTCLR_EPCLR29_BIT 29
#define LPC_USB_EPINTCLR_EPCLR30_MASK 0x40000000
#define LPC_USB_EPINTCLR_EPCLR30 0x40000000
#define LPC_USB_EPINTCLR_EPCLR30_BIT 30
#define LPC_USB_EPINTCLR_EPCLR31_MASK 0x80000000
#define LPC_USB_EPINTCLR_EPCLR31 0x80000000
#define LPC_USB_EPINTCLR_EPCLR31_BIT 31

#define LPC_USB_EPINTSET (*(volatile unsigned long *)0x2008C23C)
#define LPC_USB_EPINTSET_OFFSET 0x23C
#define LPC_USB_EPINTSET_EPSET0_MASK 0x1
#define LPC_USB_EPINTSET_EPSET0 0x1
#define LPC_USB_EPINTSET_EPSET0_BIT 0
#define LPC_USB_EPINTSET_EPSET1_MASK 0x2
#define LPC_USB_EPINTSET_EPSET1 0x2
#define LPC_USB_EPINTSET_EPSET1_BIT 1
#define LPC_USB_EPINTSET_EPSET2_MASK 0x4
#define LPC_USB_EPINTSET_EPSET2 0x4
#define LPC_USB_EPINTSET_EPSET2_BIT 2
#define LPC_USB_EPINTSET_EPSET3_MASK 0x8
#define LPC_USB_EPINTSET_EPSET3 0x8
#define LPC_USB_EPINTSET_EPSET3_BIT 3
#define LPC_USB_EPINTSET_EPSET4_MASK 0x10
#define LPC_USB_EPINTSET_EPSET4 0x10
#define LPC_USB_EPINTSET_EPSET4_BIT 4
#define LPC_USB_EPINTSET_EPSET5_MASK 0x20
#define LPC_USB_EPINTSET_EPSET5 0x20
#define LPC_USB_EPINTSET_EPSET5_BIT 5
#define LPC_USB_EPINTSET_EPSET6_MASK 0x40
#define LPC_USB_EPINTSET_EPSET6 0x40
#define LPC_USB_EPINTSET_EPSET6_BIT 6
#define LPC_USB_EPINTSET_EPSET7_MASK 0x80
#define LPC_USB_EPINTSET_EPSET7 0x80
#define LPC_USB_EPINTSET_EPSET7_BIT 7
#define LPC_USB_EPINTSET_EPSET8_MASK 0x100
#define LPC_USB_EPINTSET_EPSET8 0x100
#define LPC_USB_EPINTSET_EPSET8_BIT 8
#define LPC_USB_EPINTSET_EPSET9_MASK 0x200
#define LPC_USB_EPINTSET_EPSET9 0x200
#define LPC_USB_EPINTSET_EPSET9_BIT 9
#define LPC_USB_EPINTSET_EPSET10_MASK 0x400
#define LPC_USB_EPINTSET_EPSET10 0x400
#define LPC_USB_EPINTSET_EPSET10_BIT 10
#define LPC_USB_EPINTSET_EPSET11_MASK 0x800
#define LPC_USB_EPINTSET_EPSET11 0x800
#define LPC_USB_EPINTSET_EPSET11_BIT 11
#define LPC_USB_EPINTSET_EPSET12_MASK 0x1000
#define LPC_USB_EPINTSET_EPSET12 0x1000
#define LPC_USB_EPINTSET_EPSET12_BIT 12
#define LPC_USB_EPINTSET_EPSET13_MASK 0x2000
#define LPC_USB_EPINTSET_EPSET13 0x2000
#define LPC_USB_EPINTSET_EPSET13_BIT 13
#define LPC_USB_EPINTSET_EPSET14_MASK 0x4000
#define LPC_USB_EPINTSET_EPSET14 0x4000
#define LPC_USB_EPINTSET_EPSET14_BIT 14
#define LPC_USB_EPINTSET_EPSET15_MASK 0x8000
#define LPC_USB_EPINTSET_EPSET15 0x8000
#define LPC_USB_EPINTSET_EPSET15_BIT 15
#define LPC_USB_EPINTSET_EPSET16_MASK 0x10000
#define LPC_USB_EPINTSET_EPSET16 0x10000
#define LPC_USB_EPINTSET_EPSET16_BIT 16
#define LPC_USB_EPINTSET_EPSET17_MASK 0x20000
#define LPC_USB_EPINTSET_EPSET17 0x20000
#define LPC_USB_EPINTSET_EPSET17_BIT 17
#define LPC_USB_EPINTSET_EPSET18_MASK 0x40000
#define LPC_USB_EPINTSET_EPSET18 0x40000
#define LPC_USB_EPINTSET_EPSET18_BIT 18
#define LPC_USB_EPINTSET_EPSET19_MASK 0x80000
#define LPC_USB_EPINTSET_EPSET19 0x80000
#define LPC_USB_EPINTSET_EPSET19_BIT 19
#define LPC_USB_EPINTSET_EPSET20_MASK 0x100000
#define LPC_USB_EPINTSET_EPSET20 0x100000
#define LPC_USB_EPINTSET_EPSET20_BIT 20
#define LPC_USB_EPINTSET_EPSET21_MASK 0x200000
#define LPC_USB_EPINTSET_EPSET21 0x200000
#define LPC_USB_EPINTSET_EPSET21_BIT 21
#define LPC_USB_EPINTSET_EPSET22_MASK 0x400000
#define LPC_USB_EPINTSET_EPSET22 0x400000
#define LPC_USB_EPINTSET_EPSET22_BIT 22
#define LPC_USB_EPINTSET_EPSET23_MASK 0x800000
#define LPC_USB_EPINTSET_EPSET23 0x800000
#define LPC_USB_EPINTSET_EPSET23_BIT 23
#define LPC_USB_EPINTSET_EPSET24_MASK 0x1000000
#define LPC_USB_EPINTSET_EPSET24 0x1000000
#define LPC_USB_EPINTSET_EPSET24_BIT 24
#define LPC_USB_EPINTSET_EPSET25_MASK 0x2000000
#define LPC_USB_EPINTSET_EPSET25 0x2000000
#define LPC_USB_EPINTSET_EPSET25_BIT 25
#define LPC_USB_EPINTSET_EPSET26_MASK 0x4000000
#define LPC_USB_EPINTSET_EPSET26 0x4000000
#define LPC_USB_EPINTSET_EPSET26_BIT 26
#define LPC_USB_EPINTSET_EPSET27_MASK 0x8000000
#define LPC_USB_EPINTSET_EPSET27 0x8000000
#define LPC_USB_EPINTSET_EPSET27_BIT 27
#define LPC_USB_EPINTSET_EPSET28_MASK 0x10000000
#define LPC_USB_EPINTSET_EPSET28 0x10000000
#define LPC_USB_EPINTSET_EPSET28_BIT 28
#define LPC_USB_EPINTSET_EPSET29_MASK 0x20000000
#define LPC_USB_EPINTSET_EPSET29 0x20000000
#define LPC_USB_EPINTSET_EPSET29_BIT 29
#define LPC_USB_EPINTSET_EPSET30_MASK 0x40000000
#define LPC_USB_EPINTSET_EPSET30 0x40000000
#define LPC_USB_EPINTSET_EPSET30_BIT 30
#define LPC_USB_EPINTSET_EPSET31_MASK 0x80000000
#define LPC_USB_EPINTSET_EPSET31 0x80000000
#define LPC_USB_EPINTSET_EPSET31_BIT 31

#define LPC_USB_EPINTPRI (*(volatile unsigned long *)0x2008C240)
#define LPC_USB_EPINTPRI_OFFSET 0x240
#define LPC_USB_EPINTPRI_EPPRI0_MASK 0x1
#define LPC_USB_EPINTPRI_EPPRI0 0x1
#define LPC_USB_EPINTPRI_EPPRI0_BIT 0
#define LPC_USB_EPINTPRI_EPPRI1_MASK 0x2
#define LPC_USB_EPINTPRI_EPPRI1 0x2
#define LPC_USB_EPINTPRI_EPPRI1_BIT 1
#define LPC_USB_EPINTPRI_EPPRI2_MASK 0x4
#define LPC_USB_EPINTPRI_EPPRI2 0x4
#define LPC_USB_EPINTPRI_EPPRI2_BIT 2
#define LPC_USB_EPINTPRI_EPPRI3_MASK 0x8
#define LPC_USB_EPINTPRI_EPPRI3 0x8
#define LPC_USB_EPINTPRI_EPPRI3_BIT 3
#define LPC_USB_EPINTPRI_EPPRI4_MASK 0x10
#define LPC_USB_EPINTPRI_EPPRI4 0x10
#define LPC_USB_EPINTPRI_EPPRI4_BIT 4
#define LPC_USB_EPINTPRI_EPPRI5_MASK 0x20
#define LPC_USB_EPINTPRI_EPPRI5 0x20
#define LPC_USB_EPINTPRI_EPPRI5_BIT 5
#define LPC_USB_EPINTPRI_EPPRI6_MASK 0x40
#define LPC_USB_EPINTPRI_EPPRI6 0x40
#define LPC_USB_EPINTPRI_EPPRI6_BIT 6
#define LPC_USB_EPINTPRI_EPPRI7_MASK 0x80
#define LPC_USB_EPINTPRI_EPPRI7 0x80
#define LPC_USB_EPINTPRI_EPPRI7_BIT 7
#define LPC_USB_EPINTPRI_EPPRI8_MASK 0x100
#define LPC_USB_EPINTPRI_EPPRI8 0x100
#define LPC_USB_EPINTPRI_EPPRI8_BIT 8
#define LPC_USB_EPINTPRI_EPPRI9_MASK 0x200
#define LPC_USB_EPINTPRI_EPPRI9 0x200
#define LPC_USB_EPINTPRI_EPPRI9_BIT 9
#define LPC_USB_EPINTPRI_EPPRI10_MASK 0x400
#define LPC_USB_EPINTPRI_EPPRI10 0x400
#define LPC_USB_EPINTPRI_EPPRI10_BIT 10
#define LPC_USB_EPINTPRI_EPPRI11_MASK 0x800
#define LPC_USB_EPINTPRI_EPPRI11 0x800
#define LPC_USB_EPINTPRI_EPPRI11_BIT 11
#define LPC_USB_EPINTPRI_EPPRI12_MASK 0x1000
#define LPC_USB_EPINTPRI_EPPRI12 0x1000
#define LPC_USB_EPINTPRI_EPPRI12_BIT 12
#define LPC_USB_EPINTPRI_EPPRI13_MASK 0x2000
#define LPC_USB_EPINTPRI_EPPRI13 0x2000
#define LPC_USB_EPINTPRI_EPPRI13_BIT 13
#define LPC_USB_EPINTPRI_EPPRI14_MASK 0x4000
#define LPC_USB_EPINTPRI_EPPRI14 0x4000
#define LPC_USB_EPINTPRI_EPPRI14_BIT 14
#define LPC_USB_EPINTPRI_EPPRI15_MASK 0x8000
#define LPC_USB_EPINTPRI_EPPRI15 0x8000
#define LPC_USB_EPINTPRI_EPPRI15_BIT 15
#define LPC_USB_EPINTPRI_EPPRI16_MASK 0x10000
#define LPC_USB_EPINTPRI_EPPRI16 0x10000
#define LPC_USB_EPINTPRI_EPPRI16_BIT 16
#define LPC_USB_EPINTPRI_EPPRI17_MASK 0x20000
#define LPC_USB_EPINTPRI_EPPRI17 0x20000
#define LPC_USB_EPINTPRI_EPPRI17_BIT 17
#define LPC_USB_EPINTPRI_EPPRI18_MASK 0x40000
#define LPC_USB_EPINTPRI_EPPRI18 0x40000
#define LPC_USB_EPINTPRI_EPPRI18_BIT 18
#define LPC_USB_EPINTPRI_EPPRI19_MASK 0x80000
#define LPC_USB_EPINTPRI_EPPRI19 0x80000
#define LPC_USB_EPINTPRI_EPPRI19_BIT 19
#define LPC_USB_EPINTPRI_EPPRI20_MASK 0x100000
#define LPC_USB_EPINTPRI_EPPRI20 0x100000
#define LPC_USB_EPINTPRI_EPPRI20_BIT 20
#define LPC_USB_EPINTPRI_EPPRI21_MASK 0x200000
#define LPC_USB_EPINTPRI_EPPRI21 0x200000
#define LPC_USB_EPINTPRI_EPPRI21_BIT 21
#define LPC_USB_EPINTPRI_EPPRI22_MASK 0x400000
#define LPC_USB_EPINTPRI_EPPRI22 0x400000
#define LPC_USB_EPINTPRI_EPPRI22_BIT 22
#define LPC_USB_EPINTPRI_EPPRI23_MASK 0x800000
#define LPC_USB_EPINTPRI_EPPRI23 0x800000
#define LPC_USB_EPINTPRI_EPPRI23_BIT 23
#define LPC_USB_EPINTPRI_EPPRI24_MASK 0x1000000
#define LPC_USB_EPINTPRI_EPPRI24 0x1000000
#define LPC_USB_EPINTPRI_EPPRI24_BIT 24
#define LPC_USB_EPINTPRI_EPPRI25_MASK 0x2000000
#define LPC_USB_EPINTPRI_EPPRI25 0x2000000
#define LPC_USB_EPINTPRI_EPPRI25_BIT 25
#define LPC_USB_EPINTPRI_EPPRI26_MASK 0x4000000
#define LPC_USB_EPINTPRI_EPPRI26 0x4000000
#define LPC_USB_EPINTPRI_EPPRI26_BIT 26
#define LPC_USB_EPINTPRI_EPPRI27_MASK 0x8000000
#define LPC_USB_EPINTPRI_EPPRI27 0x8000000
#define LPC_USB_EPINTPRI_EPPRI27_BIT 27
#define LPC_USB_EPINTPRI_EPPRI28_MASK 0x10000000
#define LPC_USB_EPINTPRI_EPPRI28 0x10000000
#define LPC_USB_EPINTPRI_EPPRI28_BIT 28
#define LPC_USB_EPINTPRI_EPPRI29_MASK 0x20000000
#define LPC_USB_EPINTPRI_EPPRI29 0x20000000
#define LPC_USB_EPINTPRI_EPPRI29_BIT 29
#define LPC_USB_EPINTPRI_EPPRI30_MASK 0x40000000
#define LPC_USB_EPINTPRI_EPPRI30 0x40000000
#define LPC_USB_EPINTPRI_EPPRI30_BIT 30
#define LPC_USB_EPINTPRI_EPPRI31_MASK 0x80000000
#define LPC_USB_EPINTPRI_EPPRI31 0x80000000
#define LPC_USB_EPINTPRI_EPPRI31_BIT 31

#define LPC_USB_REEP (*(volatile unsigned long *)0x2008C244)
#define LPC_USB_REEP_OFFSET 0x244
#define LPC_USB_REEP_EPR0_MASK 0x1
#define LPC_USB_REEP_EPR0 0x1
#define LPC_USB_REEP_EPR0_BIT 0
#define LPC_USB_REEP_EPR1_MASK 0x2
#define LPC_USB_REEP_EPR1 0x2
#define LPC_USB_REEP_EPR1_BIT 1
#define LPC_USB_REEP_EPR2_MASK 0x4
#define LPC_USB_REEP_EPR2 0x4
#define LPC_USB_REEP_EPR2_BIT 2
#define LPC_USB_REEP_EPR3_MASK 0x8
#define LPC_USB_REEP_EPR3 0x8
#define LPC_USB_REEP_EPR3_BIT 3
#define LPC_USB_REEP_EPR4_MASK 0x10
#define LPC_USB_REEP_EPR4 0x10
#define LPC_USB_REEP_EPR4_BIT 4
#define LPC_USB_REEP_EPR5_MASK 0x20
#define LPC_USB_REEP_EPR5 0x20
#define LPC_USB_REEP_EPR5_BIT 5
#define LPC_USB_REEP_EPR6_MASK 0x40
#define LPC_USB_REEP_EPR6 0x40
#define LPC_USB_REEP_EPR6_BIT 6
#define LPC_USB_REEP_EPR7_MASK 0x80
#define LPC_USB_REEP_EPR7 0x80
#define LPC_USB_REEP_EPR7_BIT 7
#define LPC_USB_REEP_EPR8_MASK 0x100
#define LPC_USB_REEP_EPR8 0x100
#define LPC_USB_REEP_EPR8_BIT 8
#define LPC_USB_REEP_EPR9_MASK 0x200
#define LPC_USB_REEP_EPR9 0x200
#define LPC_USB_REEP_EPR9_BIT 9
#define LPC_USB_REEP_EPR10_MASK 0x400
#define LPC_USB_REEP_EPR10 0x400
#define LPC_USB_REEP_EPR10_BIT 10
#define LPC_USB_REEP_EPR11_MASK 0x800
#define LPC_USB_REEP_EPR11 0x800
#define LPC_USB_REEP_EPR11_BIT 11
#define LPC_USB_REEP_EPR12_MASK 0x1000
#define LPC_USB_REEP_EPR12 0x1000
#define LPC_USB_REEP_EPR12_BIT 12
#define LPC_USB_REEP_EPR13_MASK 0x2000
#define LPC_USB_REEP_EPR13 0x2000
#define LPC_USB_REEP_EPR13_BIT 13
#define LPC_USB_REEP_EPR14_MASK 0x4000
#define LPC_USB_REEP_EPR14 0x4000
#define LPC_USB_REEP_EPR14_BIT 14
#define LPC_USB_REEP_EPR15_MASK 0x8000
#define LPC_USB_REEP_EPR15 0x8000
#define LPC_USB_REEP_EPR15_BIT 15
#define LPC_USB_REEP_EPR16_MASK 0x10000
#define LPC_USB_REEP_EPR16 0x10000
#define LPC_USB_REEP_EPR16_BIT 16
#define LPC_USB_REEP_EPR17_MASK 0x20000
#define LPC_USB_REEP_EPR17 0x20000
#define LPC_USB_REEP_EPR17_BIT 17
#define LPC_USB_REEP_EPR18_MASK 0x40000
#define LPC_USB_REEP_EPR18 0x40000
#define LPC_USB_REEP_EPR18_BIT 18
#define LPC_USB_REEP_EPR19_MASK 0x80000
#define LPC_USB_REEP_EPR19 0x80000
#define LPC_USB_REEP_EPR19_BIT 19
#define LPC_USB_REEP_EPR20_MASK 0x100000
#define LPC_USB_REEP_EPR20 0x100000
#define LPC_USB_REEP_EPR20_BIT 20
#define LPC_USB_REEP_EPR21_MASK 0x200000
#define LPC_USB_REEP_EPR21 0x200000
#define LPC_USB_REEP_EPR21_BIT 21
#define LPC_USB_REEP_EPR22_MASK 0x400000
#define LPC_USB_REEP_EPR22 0x400000
#define LPC_USB_REEP_EPR22_BIT 22
#define LPC_USB_REEP_EPR23_MASK 0x800000
#define LPC_USB_REEP_EPR23 0x800000
#define LPC_USB_REEP_EPR23_BIT 23
#define LPC_USB_REEP_EPR24_MASK 0x1000000
#define LPC_USB_REEP_EPR24 0x1000000
#define LPC_USB_REEP_EPR24_BIT 24
#define LPC_USB_REEP_EPR25_MASK 0x2000000
#define LPC_USB_REEP_EPR25 0x2000000
#define LPC_USB_REEP_EPR25_BIT 25
#define LPC_USB_REEP_EPR26_MASK 0x4000000
#define LPC_USB_REEP_EPR26 0x4000000
#define LPC_USB_REEP_EPR26_BIT 26
#define LPC_USB_REEP_EPR27_MASK 0x8000000
#define LPC_USB_REEP_EPR27 0x8000000
#define LPC_USB_REEP_EPR27_BIT 27
#define LPC_USB_REEP_EPR28_MASK 0x10000000
#define LPC_USB_REEP_EPR28 0x10000000
#define LPC_USB_REEP_EPR28_BIT 28
#define LPC_USB_REEP_EPR29_MASK 0x20000000
#define LPC_USB_REEP_EPR29 0x20000000
#define LPC_USB_REEP_EPR29_BIT 29
#define LPC_USB_REEP_EPR30_MASK 0x40000000
#define LPC_USB_REEP_EPR30 0x40000000
#define LPC_USB_REEP_EPR30_BIT 30
#define LPC_USB_REEP_EPR31_MASK 0x80000000
#define LPC_USB_REEP_EPR31 0x80000000
#define LPC_USB_REEP_EPR31_BIT 31

#define LPC_USB_EPIN (*(volatile unsigned long *)0x2008C248)
#define LPC_USB_EPIN_OFFSET 0x248
#define LPC_USB_EPIN_PHY_EP_MASK 0x1F
#define LPC_USB_EPIN_PHY_EP_BIT 0

#define LPC_USB_MAXPSIZE (*(volatile unsigned long *)0x2008C24C)
#define LPC_USB_MAXPSIZE_OFFSET 0x24C
#define LPC_USB_MAXPSIZE_MPS_MASK 0x3FF
#define LPC_USB_MAXPSIZE_MPS_BIT 0

#define LPC_USB_RXDATA (*(volatile unsigned long *)0x2008C218)
#define LPC_USB_RXDATA_OFFSET 0x218
#define LPC_USB_RXDATA_RX_DATA_MASK 0xFFFFFFFF
#define LPC_USB_RXDATA_RX_DATA_BIT 0

#define LPC_USB_RXPLEN (*(volatile unsigned long *)0x2008C0DC)
#define LPC_USB_RXPLEN_OFFSET 0xDC
#define LPC_USB_RXPLEN_PKT_LNGTH_MASK 0x3FF
#define LPC_USB_RXPLEN_PKT_LNGTH_BIT 0
#define LPC_USB_RXPLEN_DV_MASK 0x400
#define LPC_USB_RXPLEN_DV 0x400
#define LPC_USB_RXPLEN_DV_BIT 10
#define LPC_USB_RXPLEN_PKT_RDY_MASK 0x800
#define LPC_USB_RXPLEN_PKT_RDY 0x800
#define LPC_USB_RXPLEN_PKT_RDY_BIT 11

#define LPC_USB_TXDATA (*(volatile unsigned long *)0x2008C21C)
#define LPC_USB_TXDATA_OFFSET 0x21C
#define LPC_USB_TXDATA_TX_DATA_MASK 0xFFFFFFFF
#define LPC_USB_TXDATA_TX_DATA_BIT 0

#define LPC_USB_TXPLEN (*(volatile unsigned long *)0x2008C224)
#define LPC_USB_TXPLEN_OFFSET 0x224
#define LPC_USB_TXPLEN_PKT_LNGTH_MASK 0x3FF
#define LPC_USB_TXPLEN_PKT_LNGTH_BIT 0

#define LPC_USB_CTRL (*(volatile unsigned long *)0x2008C228)
#define LPC_USB_CTRL_OFFSET 0x228
#define LPC_USB_CTRL_RD_EN_MASK 0x1
#define LPC_USB_CTRL_RD_EN 0x1
#define LPC_USB_CTRL_RD_EN_BIT 0
#define LPC_USB_CTRL_WR_EN_MASK 0x2
#define LPC_USB_CTRL_WR_EN 0x2
#define LPC_USB_CTRL_WR_EN_BIT 1
#define LPC_USB_CTRL_LOG_ENDPOINT_MASK 0x3C
#define LPC_USB_CTRL_LOG_ENDPOINT_BIT 2

#define LPC_USB_CMDCODE (*(volatile unsigned long *)0x2008C210)
#define LPC_USB_CMDCODE_OFFSET 0x210
#define LPC_USB_CMDCODE_CMD_PHASE_MASK 0xFF00
#define LPC_USB_CMDCODE_CMD_PHASE_BIT 8
#define LPC_USB_CMDCODE_CMD_CODE_WDATA_MASK 0xFF0000
#define LPC_USB_CMDCODE_CMD_CODE_WDATA_BIT 16

#define LPC_USB_CMDDATA (*(volatile unsigned long *)0x2008C214)
#define LPC_USB_CMDDATA_OFFSET 0x214
#define LPC_USB_CMDDATA_CMD_RDATA_MASK 0xFF
#define LPC_USB_CMDDATA_CMD_RDATA_BIT 0

#define LPC_USB_DMARST (*(volatile unsigned long *)0x2008C250)
#define LPC_USB_DMARST_OFFSET 0x250
#define LPC_USB_DMARST_EPRST0_MASK 0x1
#define LPC_USB_DMARST_EPRST0 0x1
#define LPC_USB_DMARST_EPRST0_BIT 0
#define LPC_USB_DMARST_EPRST1_MASK 0x2
#define LPC_USB_DMARST_EPRST1 0x2
#define LPC_USB_DMARST_EPRST1_BIT 1
#define LPC_USB_DMARST_EPRST2_MASK 0x4
#define LPC_USB_DMARST_EPRST2 0x4
#define LPC_USB_DMARST_EPRST2_BIT 2
#define LPC_USB_DMARST_EPRST3_MASK 0x8
#define LPC_USB_DMARST_EPRST3 0x8
#define LPC_USB_DMARST_EPRST3_BIT 3
#define LPC_USB_DMARST_EPRST4_MASK 0x10
#define LPC_USB_DMARST_EPRST4 0x10
#define LPC_USB_DMARST_EPRST4_BIT 4
#define LPC_USB_DMARST_EPRST5_MASK 0x20
#define LPC_USB_DMARST_EPRST5 0x20
#define LPC_USB_DMARST_EPRST5_BIT 5
#define LPC_USB_DMARST_EPRST6_MASK 0x40
#define LPC_USB_DMARST_EPRST6 0x40
#define LPC_USB_DMARST_EPRST6_BIT 6
#define LPC_USB_DMARST_EPRST7_MASK 0x80
#define LPC_USB_DMARST_EPRST7 0x80
#define LPC_USB_DMARST_EPRST7_BIT 7
#define LPC_USB_DMARST_EPRST8_MASK 0x100
#define LPC_USB_DMARST_EPRST8 0x100
#define LPC_USB_DMARST_EPRST8_BIT 8
#define LPC_USB_DMARST_EPRST9_MASK 0x200
#define LPC_USB_DMARST_EPRST9 0x200
#define LPC_USB_DMARST_EPRST9_BIT 9
#define LPC_USB_DMARST_EPRST10_MASK 0x400
#define LPC_USB_DMARST_EPRST10 0x400
#define LPC_USB_DMARST_EPRST10_BIT 10
#define LPC_USB_DMARST_EPRST11_MASK 0x800
#define LPC_USB_DMARST_EPRST11 0x800
#define LPC_USB_DMARST_EPRST11_BIT 11
#define LPC_USB_DMARST_EPRST12_MASK 0x1000
#define LPC_USB_DMARST_EPRST12 0x1000
#define LPC_USB_DMARST_EPRST12_BIT 12
#define LPC_USB_DMARST_EPRST13_MASK 0x2000
#define LPC_USB_DMARST_EPRST13 0x2000
#define LPC_USB_DMARST_EPRST13_BIT 13
#define LPC_USB_DMARST_EPRST14_MASK 0x4000
#define LPC_USB_DMARST_EPRST14 0x4000
#define LPC_USB_DMARST_EPRST14_BIT 14
#define LPC_USB_DMARST_EPRST15_MASK 0x8000
#define LPC_USB_DMARST_EPRST15 0x8000
#define LPC_USB_DMARST_EPRST15_BIT 15
#define LPC_USB_DMARST_EPRST16_MASK 0x10000
#define LPC_USB_DMARST_EPRST16 0x10000
#define LPC_USB_DMARST_EPRST16_BIT 16
#define LPC_USB_DMARST_EPRST17_MASK 0x20000
#define LPC_USB_DMARST_EPRST17 0x20000
#define LPC_USB_DMARST_EPRST17_BIT 17
#define LPC_USB_DMARST_EPRST18_MASK 0x40000
#define LPC_USB_DMARST_EPRST18 0x40000
#define LPC_USB_DMARST_EPRST18_BIT 18
#define LPC_USB_DMARST_EPRST19_MASK 0x80000
#define LPC_USB_DMARST_EPRST19 0x80000
#define LPC_USB_DMARST_EPRST19_BIT 19
#define LPC_USB_DMARST_EPRST20_MASK 0x100000
#define LPC_USB_DMARST_EPRST20 0x100000
#define LPC_USB_DMARST_EPRST20_BIT 20
#define LPC_USB_DMARST_EPRST21_MASK 0x200000
#define LPC_USB_DMARST_EPRST21 0x200000
#define LPC_USB_DMARST_EPRST21_BIT 21
#define LPC_USB_DMARST_EPRST22_MASK 0x400000
#define LPC_USB_DMARST_EPRST22 0x400000
#define LPC_USB_DMARST_EPRST22_BIT 22
#define LPC_USB_DMARST_EPRST23_MASK 0x800000
#define LPC_USB_DMARST_EPRST23 0x800000
#define LPC_USB_DMARST_EPRST23_BIT 23
#define LPC_USB_DMARST_EPRST24_MASK 0x1000000
#define LPC_USB_DMARST_EPRST24 0x1000000
#define LPC_USB_DMARST_EPRST24_BIT 24
#define LPC_USB_DMARST_EPRST25_MASK 0x2000000
#define LPC_USB_DMARST_EPRST25 0x2000000
#define LPC_USB_DMARST_EPRST25_BIT 25
#define LPC_USB_DMARST_EPRST26_MASK 0x4000000
#define LPC_USB_DMARST_EPRST26 0x4000000
#define LPC_USB_DMARST_EPRST26_BIT 26
#define LPC_USB_DMARST_EPRST27_MASK 0x8000000
#define LPC_USB_DMARST_EPRST27 0x8000000
#define LPC_USB_DMARST_EPRST27_BIT 27
#define LPC_USB_DMARST_EPRST28_MASK 0x10000000
#define LPC_USB_DMARST_EPRST28 0x10000000
#define LPC_USB_DMARST_EPRST28_BIT 28
#define LPC_USB_DMARST_EPRST29_MASK 0x20000000
#define LPC_USB_DMARST_EPRST29 0x20000000
#define LPC_USB_DMARST_EPRST29_BIT 29
#define LPC_USB_DMARST_EPRST30_MASK 0x40000000
#define LPC_USB_DMARST_EPRST30 0x40000000
#define LPC_USB_DMARST_EPRST30_BIT 30
#define LPC_USB_DMARST_EPRST31_MASK 0x80000000
#define LPC_USB_DMARST_EPRST31 0x80000000
#define LPC_USB_DMARST_EPRST31_BIT 31

#define LPC_USB_DMARCLR (*(volatile unsigned long *)0x2008C254)
#define LPC_USB_DMARCLR_OFFSET 0x254
#define LPC_USB_DMARCLR_EPRCLR0_MASK 0x1
#define LPC_USB_DMARCLR_EPRCLR0 0x1
#define LPC_USB_DMARCLR_EPRCLR0_BIT 0
#define LPC_USB_DMARCLR_EPRCLR1_MASK 0x2
#define LPC_USB_DMARCLR_EPRCLR1 0x2
#define LPC_USB_DMARCLR_EPRCLR1_BIT 1
#define LPC_USB_DMARCLR_EPRCLR2_MASK 0x4
#define LPC_USB_DMARCLR_EPRCLR2 0x4
#define LPC_USB_DMARCLR_EPRCLR2_BIT 2
#define LPC_USB_DMARCLR_EPRCLR3_MASK 0x8
#define LPC_USB_DMARCLR_EPRCLR3 0x8
#define LPC_USB_DMARCLR_EPRCLR3_BIT 3
#define LPC_USB_DMARCLR_EPRCLR4_MASK 0x10
#define LPC_USB_DMARCLR_EPRCLR4 0x10
#define LPC_USB_DMARCLR_EPRCLR4_BIT 4
#define LPC_USB_DMARCLR_EPRCLR5_MASK 0x20
#define LPC_USB_DMARCLR_EPRCLR5 0x20
#define LPC_USB_DMARCLR_EPRCLR5_BIT 5
#define LPC_USB_DMARCLR_EPRCLR6_MASK 0x40
#define LPC_USB_DMARCLR_EPRCLR6 0x40
#define LPC_USB_DMARCLR_EPRCLR6_BIT 6
#define LPC_USB_DMARCLR_EPRCLR7_MASK 0x80
#define LPC_USB_DMARCLR_EPRCLR7 0x80
#define LPC_USB_DMARCLR_EPRCLR7_BIT 7
#define LPC_USB_DMARCLR_EPRCLR8_MASK 0x100
#define LPC_USB_DMARCLR_EPRCLR8 0x100
#define LPC_USB_DMARCLR_EPRCLR8_BIT 8
#define LPC_USB_DMARCLR_EPRCLR9_MASK 0x200
#define LPC_USB_DMARCLR_EPRCLR9 0x200
#define LPC_USB_DMARCLR_EPRCLR9_BIT 9
#define LPC_USB_DMARCLR_EPRCLR10_MASK 0x400
#define LPC_USB_DMARCLR_EPRCLR10 0x400
#define LPC_USB_DMARCLR_EPRCLR10_BIT 10
#define LPC_USB_DMARCLR_EPRCLR11_MASK 0x800
#define LPC_USB_DMARCLR_EPRCLR11 0x800
#define LPC_USB_DMARCLR_EPRCLR11_BIT 11
#define LPC_USB_DMARCLR_EPRCLR12_MASK 0x1000
#define LPC_USB_DMARCLR_EPRCLR12 0x1000
#define LPC_USB_DMARCLR_EPRCLR12_BIT 12
#define LPC_USB_DMARCLR_EPRCLR13_MASK 0x2000
#define LPC_USB_DMARCLR_EPRCLR13 0x2000
#define LPC_USB_DMARCLR_EPRCLR13_BIT 13
#define LPC_USB_DMARCLR_EPRCLR14_MASK 0x4000
#define LPC_USB_DMARCLR_EPRCLR14 0x4000
#define LPC_USB_DMARCLR_EPRCLR14_BIT 14
#define LPC_USB_DMARCLR_EPRCLR15_MASK 0x8000
#define LPC_USB_DMARCLR_EPRCLR15 0x8000
#define LPC_USB_DMARCLR_EPRCLR15_BIT 15
#define LPC_USB_DMARCLR_EPRCLR16_MASK 0x10000
#define LPC_USB_DMARCLR_EPRCLR16 0x10000
#define LPC_USB_DMARCLR_EPRCLR16_BIT 16
#define LPC_USB_DMARCLR_EPRCLR17_MASK 0x20000
#define LPC_USB_DMARCLR_EPRCLR17 0x20000
#define LPC_USB_DMARCLR_EPRCLR17_BIT 17
#define LPC_USB_DMARCLR_EPRCLR18_MASK 0x40000
#define LPC_USB_DMARCLR_EPRCLR18 0x40000
#define LPC_USB_DMARCLR_EPRCLR18_BIT 18
#define LPC_USB_DMARCLR_EPRCLR19_MASK 0x80000
#define LPC_USB_DMARCLR_EPRCLR19 0x80000
#define LPC_USB_DMARCLR_EPRCLR19_BIT 19
#define LPC_USB_DMARCLR_EPRCLR20_MASK 0x100000
#define LPC_USB_DMARCLR_EPRCLR20 0x100000
#define LPC_USB_DMARCLR_EPRCLR20_BIT 20
#define LPC_USB_DMARCLR_EPRCLR21_MASK 0x200000
#define LPC_USB_DMARCLR_EPRCLR21 0x200000
#define LPC_USB_DMARCLR_EPRCLR21_BIT 21
#define LPC_USB_DMARCLR_EPRCLR22_MASK 0x400000
#define LPC_USB_DMARCLR_EPRCLR22 0x400000
#define LPC_USB_DMARCLR_EPRCLR22_BIT 22
#define LPC_USB_DMARCLR_EPRCLR23_MASK 0x800000
#define LPC_USB_DMARCLR_EPRCLR23 0x800000
#define LPC_USB_DMARCLR_EPRCLR23_BIT 23
#define LPC_USB_DMARCLR_EPRCLR24_MASK 0x1000000
#define LPC_USB_DMARCLR_EPRCLR24 0x1000000
#define LPC_USB_DMARCLR_EPRCLR24_BIT 24
#define LPC_USB_DMARCLR_EPRCLR25_MASK 0x2000000
#define LPC_USB_DMARCLR_EPRCLR25 0x2000000
#define LPC_USB_DMARCLR_EPRCLR25_BIT 25
#define LPC_USB_DMARCLR_EPRCLR26_MASK 0x4000000
#define LPC_USB_DMARCLR_EPRCLR26 0x4000000
#define LPC_USB_DMARCLR_EPRCLR26_BIT 26
#define LPC_USB_DMARCLR_EPRCLR27_MASK 0x8000000
#define LPC_USB_DMARCLR_EPRCLR27 0x8000000
#define LPC_USB_DMARCLR_EPRCLR27_BIT 27
#define LPC_USB_DMARCLR_EPRCLR28_MASK 0x10000000
#define LPC_USB_DMARCLR_EPRCLR28 0x10000000
#define LPC_USB_DMARCLR_EPRCLR28_BIT 28
#define LPC_USB_DMARCLR_EPRCLR29_MASK 0x20000000
#define LPC_USB_DMARCLR_EPRCLR29 0x20000000
#define LPC_USB_DMARCLR_EPRCLR29_BIT 29
#define LPC_USB_DMARCLR_EPRCLR30_MASK 0x40000000
#define LPC_USB_DMARCLR_EPRCLR30 0x40000000
#define LPC_USB_DMARCLR_EPRCLR30_BIT 30
#define LPC_USB_DMARCLR_EPRCLR31_MASK 0x80000000
#define LPC_USB_DMARCLR_EPRCLR31 0x80000000
#define LPC_USB_DMARCLR_EPRCLR31_BIT 31

#define LPC_USB_DMARSET (*(volatile unsigned long *)0x2008C258)
#define LPC_USB_DMARSET_OFFSET 0x258
#define LPC_USB_DMARSET_EPRSET0_MASK 0x1
#define LPC_USB_DMARSET_EPRSET0 0x1
#define LPC_USB_DMARSET_EPRSET0_BIT 0
#define LPC_USB_DMARSET_EPRSET1_MASK 0x2
#define LPC_USB_DMARSET_EPRSET1 0x2
#define LPC_USB_DMARSET_EPRSET1_BIT 1
#define LPC_USB_DMARSET_EPRSET2_MASK 0x4
#define LPC_USB_DMARSET_EPRSET2 0x4
#define LPC_USB_DMARSET_EPRSET2_BIT 2
#define LPC_USB_DMARSET_EPRSET3_MASK 0x8
#define LPC_USB_DMARSET_EPRSET3 0x8
#define LPC_USB_DMARSET_EPRSET3_BIT 3
#define LPC_USB_DMARSET_EPRSET4_MASK 0x10
#define LPC_USB_DMARSET_EPRSET4 0x10
#define LPC_USB_DMARSET_EPRSET4_BIT 4
#define LPC_USB_DMARSET_EPRSET5_MASK 0x20
#define LPC_USB_DMARSET_EPRSET5 0x20
#define LPC_USB_DMARSET_EPRSET5_BIT 5
#define LPC_USB_DMARSET_EPRSET6_MASK 0x40
#define LPC_USB_DMARSET_EPRSET6 0x40
#define LPC_USB_DMARSET_EPRSET6_BIT 6
#define LPC_USB_DMARSET_EPRSET7_MASK 0x80
#define LPC_USB_DMARSET_EPRSET7 0x80
#define LPC_USB_DMARSET_EPRSET7_BIT 7
#define LPC_USB_DMARSET_EPRSET8_MASK 0x100
#define LPC_USB_DMARSET_EPRSET8 0x100
#define LPC_USB_DMARSET_EPRSET8_BIT 8
#define LPC_USB_DMARSET_EPRSET9_MASK 0x200
#define LPC_USB_DMARSET_EPRSET9 0x200
#define LPC_USB_DMARSET_EPRSET9_BIT 9
#define LPC_USB_DMARSET_EPRSET10_MASK 0x400
#define LPC_USB_DMARSET_EPRSET10 0x400
#define LPC_USB_DMARSET_EPRSET10_BIT 10
#define LPC_USB_DMARSET_EPRSET11_MASK 0x800
#define LPC_USB_DMARSET_EPRSET11 0x800
#define LPC_USB_DMARSET_EPRSET11_BIT 11
#define LPC_USB_DMARSET_EPRSET12_MASK 0x1000
#define LPC_USB_DMARSET_EPRSET12 0x1000
#define LPC_USB_DMARSET_EPRSET12_BIT 12
#define LPC_USB_DMARSET_EPRSET13_MASK 0x2000
#define LPC_USB_DMARSET_EPRSET13 0x2000
#define LPC_USB_DMARSET_EPRSET13_BIT 13
#define LPC_USB_DMARSET_EPRSET14_MASK 0x4000
#define LPC_USB_DMARSET_EPRSET14 0x4000
#define LPC_USB_DMARSET_EPRSET14_BIT 14
#define LPC_USB_DMARSET_EPRSET15_MASK 0x8000
#define LPC_USB_DMARSET_EPRSET15 0x8000
#define LPC_USB_DMARSET_EPRSET15_BIT 15
#define LPC_USB_DMARSET_EPRSET16_MASK 0x10000
#define LPC_USB_DMARSET_EPRSET16 0x10000
#define LPC_USB_DMARSET_EPRSET16_BIT 16
#define LPC_USB_DMARSET_EPRSET17_MASK 0x20000
#define LPC_USB_DMARSET_EPRSET17 0x20000
#define LPC_USB_DMARSET_EPRSET17_BIT 17
#define LPC_USB_DMARSET_EPRSET18_MASK 0x40000
#define LPC_USB_DMARSET_EPRSET18 0x40000
#define LPC_USB_DMARSET_EPRSET18_BIT 18
#define LPC_USB_DMARSET_EPRSET19_MASK 0x80000
#define LPC_USB_DMARSET_EPRSET19 0x80000
#define LPC_USB_DMARSET_EPRSET19_BIT 19
#define LPC_USB_DMARSET_EPRSET20_MASK 0x100000
#define LPC_USB_DMARSET_EPRSET20 0x100000
#define LPC_USB_DMARSET_EPRSET20_BIT 20
#define LPC_USB_DMARSET_EPRSET21_MASK 0x200000
#define LPC_USB_DMARSET_EPRSET21 0x200000
#define LPC_USB_DMARSET_EPRSET21_BIT 21
#define LPC_USB_DMARSET_EPRSET22_MASK 0x400000
#define LPC_USB_DMARSET_EPRSET22 0x400000
#define LPC_USB_DMARSET_EPRSET22_BIT 22
#define LPC_USB_DMARSET_EPRSET23_MASK 0x800000
#define LPC_USB_DMARSET_EPRSET23 0x800000
#define LPC_USB_DMARSET_EPRSET23_BIT 23
#define LPC_USB_DMARSET_EPRSET24_MASK 0x1000000
#define LPC_USB_DMARSET_EPRSET24 0x1000000
#define LPC_USB_DMARSET_EPRSET24_BIT 24
#define LPC_USB_DMARSET_EPRSET25_MASK 0x2000000
#define LPC_USB_DMARSET_EPRSET25 0x2000000
#define LPC_USB_DMARSET_EPRSET25_BIT 25
#define LPC_USB_DMARSET_EPRSET26_MASK 0x4000000
#define LPC_USB_DMARSET_EPRSET26 0x4000000
#define LPC_USB_DMARSET_EPRSET26_BIT 26
#define LPC_USB_DMARSET_EPRSET27_MASK 0x8000000
#define LPC_USB_DMARSET_EPRSET27 0x8000000
#define LPC_USB_DMARSET_EPRSET27_BIT 27
#define LPC_USB_DMARSET_EPRSET28_MASK 0x10000000
#define LPC_USB_DMARSET_EPRSET28 0x10000000
#define LPC_USB_DMARSET_EPRSET28_BIT 28
#define LPC_USB_DMARSET_EPRSET29_MASK 0x20000000
#define LPC_USB_DMARSET_EPRSET29 0x20000000
#define LPC_USB_DMARSET_EPRSET29_BIT 29
#define LPC_USB_DMARSET_EPRSET30_MASK 0x40000000
#define LPC_USB_DMARSET_EPRSET30 0x40000000
#define LPC_USB_DMARSET_EPRSET30_BIT 30
#define LPC_USB_DMARSET_EPRSET31_MASK 0x80000000
#define LPC_USB_DMARSET_EPRSET31 0x80000000
#define LPC_USB_DMARSET_EPRSET31_BIT 31

#define LPC_USB_UDCAH (*(volatile unsigned long *)0x2008C280)
#define LPC_USB_UDCAH_OFFSET 0x280
#define LPC_USB_UDCAH_UDCA_ADDR_MASK 0xFFFFFF80
#define LPC_USB_UDCAH_UDCA_ADDR_BIT 7

#define LPC_USB_EPDMAST (*(volatile unsigned long *)0x2008C284)
#define LPC_USB_EPDMAST_OFFSET 0x284
#define LPC_USB_EPDMAST_EP_DMA_ST0_MASK 0x1
#define LPC_USB_EPDMAST_EP_DMA_ST0 0x1
#define LPC_USB_EPDMAST_EP_DMA_ST0_BIT 0
#define LPC_USB_EPDMAST_EP_DMA_ST1_MASK 0x2
#define LPC_USB_EPDMAST_EP_DMA_ST1 0x2
#define LPC_USB_EPDMAST_EP_DMA_ST1_BIT 1
#define LPC_USB_EPDMAST_EP_DMA_ST2_MASK 0x4
#define LPC_USB_EPDMAST_EP_DMA_ST2 0x4
#define LPC_USB_EPDMAST_EP_DMA_ST2_BIT 2
#define LPC_USB_EPDMAST_EP_DMA_ST3_MASK 0x8
#define LPC_USB_EPDMAST_EP_DMA_ST3 0x8
#define LPC_USB_EPDMAST_EP_DMA_ST3_BIT 3
#define LPC_USB_EPDMAST_EP_DMA_ST4_MASK 0x10
#define LPC_USB_EPDMAST_EP_DMA_ST4 0x10
#define LPC_USB_EPDMAST_EP_DMA_ST4_BIT 4
#define LPC_USB_EPDMAST_EP_DMA_ST5_MASK 0x20
#define LPC_USB_EPDMAST_EP_DMA_ST5 0x20
#define LPC_USB_EPDMAST_EP_DMA_ST5_BIT 5
#define LPC_USB_EPDMAST_EP_DMA_ST6_MASK 0x40
#define LPC_USB_EPDMAST_EP_DMA_ST6 0x40
#define LPC_USB_EPDMAST_EP_DMA_ST6_BIT 6
#define LPC_USB_EPDMAST_EP_DMA_ST7_MASK 0x80
#define LPC_USB_EPDMAST_EP_DMA_ST7 0x80
#define LPC_USB_EPDMAST_EP_DMA_ST7_BIT 7
#define LPC_USB_EPDMAST_EP_DMA_ST8_MASK 0x100
#define LPC_USB_EPDMAST_EP_DMA_ST8 0x100
#define LPC_USB_EPDMAST_EP_DMA_ST8_BIT 8
#define LPC_USB_EPDMAST_EP_DMA_ST9_MASK 0x200
#define LPC_USB_EPDMAST_EP_DMA_ST9 0x200
#define LPC_USB_EPDMAST_EP_DMA_ST9_BIT 9
#define LPC_USB_EPDMAST_EP_DMA_ST10_MASK 0x400
#define LPC_USB_EPDMAST_EP_DMA_ST10 0x400
#define LPC_USB_EPDMAST_EP_DMA_ST10_BIT 10
#define LPC_USB_EPDMAST_EP_DMA_ST11_MASK 0x800
#define LPC_USB_EPDMAST_EP_DMA_ST11 0x800
#define LPC_USB_EPDMAST_EP_DMA_ST11_BIT 11
#define LPC_USB_EPDMAST_EP_DMA_ST12_MASK 0x1000
#define LPC_USB_EPDMAST_EP_DMA_ST12 0x1000
#define LPC_USB_EPDMAST_EP_DMA_ST12_BIT 12
#define LPC_USB_EPDMAST_EP_DMA_ST13_MASK 0x2000
#define LPC_USB_EPDMAST_EP_DMA_ST13 0x2000
#define LPC_USB_EPDMAST_EP_DMA_ST13_BIT 13
#define LPC_USB_EPDMAST_EP_DMA_ST14_MASK 0x4000
#define LPC_USB_EPDMAST_EP_DMA_ST14 0x4000
#define LPC_USB_EPDMAST_EP_DMA_ST14_BIT 14
#define LPC_USB_EPDMAST_EP_DMA_ST15_MASK 0x8000
#define LPC_USB_EPDMAST_EP_DMA_ST15 0x8000
#define LPC_USB_EPDMAST_EP_DMA_ST15_BIT 15
#define LPC_USB_EPDMAST_EP_DMA_ST16_MASK 0x10000
#define LPC_USB_EPDMAST_EP_DMA_ST16 0x10000
#define LPC_USB_EPDMAST_EP_DMA_ST16_BIT 16
#define LPC_USB_EPDMAST_EP_DMA_ST17_MASK 0x20000
#define LPC_USB_EPDMAST_EP_DMA_ST17 0x20000
#define LPC_USB_EPDMAST_EP_DMA_ST17_BIT 17
#define LPC_USB_EPDMAST_EP_DMA_ST18_MASK 0x40000
#define LPC_USB_EPDMAST_EP_DMA_ST18 0x40000
#define LPC_USB_EPDMAST_EP_DMA_ST18_BIT 18
#define LPC_USB_EPDMAST_EP_DMA_ST19_MASK 0x80000
#define LPC_USB_EPDMAST_EP_DMA_ST19 0x80000
#define LPC_USB_EPDMAST_EP_DMA_ST19_BIT 19
#define LPC_USB_EPDMAST_EP_DMA_ST20_MASK 0x100000
#define LPC_USB_EPDMAST_EP_DMA_ST20 0x100000
#define LPC_USB_EPDMAST_EP_DMA_ST20_BIT 20
#define LPC_USB_EPDMAST_EP_DMA_ST21_MASK 0x200000
#define LPC_USB_EPDMAST_EP_DMA_ST21 0x200000
#define LPC_USB_EPDMAST_EP_DMA_ST21_BIT 21
#define LPC_USB_EPDMAST_EP_DMA_ST22_MASK 0x400000
#define LPC_USB_EPDMAST_EP_DMA_ST22 0x400000
#define LPC_USB_EPDMAST_EP_DMA_ST22_BIT 22
#define LPC_USB_EPDMAST_EP_DMA_ST23_MASK 0x800000
#define LPC_USB_EPDMAST_EP_DMA_ST23 0x800000
#define LPC_USB_EPDMAST_EP_DMA_ST23_BIT 23
#define LPC_USB_EPDMAST_EP_DMA_ST24_MASK 0x1000000
#define LPC_USB_EPDMAST_EP_DMA_ST24 0x1000000
#define LPC_USB_EPDMAST_EP_DMA_ST24_BIT 24
#define LPC_USB_EPDMAST_EP_DMA_ST25_MASK 0x2000000
#define LPC_USB_EPDMAST_EP_DMA_ST25 0x2000000
#define LPC_USB_EPDMAST_EP_DMA_ST25_BIT 25
#define LPC_USB_EPDMAST_EP_DMA_ST26_MASK 0x4000000
#define LPC_USB_EPDMAST_EP_DMA_ST26 0x4000000
#define LPC_USB_EPDMAST_EP_DMA_ST26_BIT 26
#define LPC_USB_EPDMAST_EP_DMA_ST27_MASK 0x8000000
#define LPC_USB_EPDMAST_EP_DMA_ST27 0x8000000
#define LPC_USB_EPDMAST_EP_DMA_ST27_BIT 27
#define LPC_USB_EPDMAST_EP_DMA_ST28_MASK 0x10000000
#define LPC_USB_EPDMAST_EP_DMA_ST28 0x10000000
#define LPC_USB_EPDMAST_EP_DMA_ST28_BIT 28
#define LPC_USB_EPDMAST_EP_DMA_ST29_MASK 0x20000000
#define LPC_USB_EPDMAST_EP_DMA_ST29 0x20000000
#define LPC_USB_EPDMAST_EP_DMA_ST29_BIT 29
#define LPC_USB_EPDMAST_EP_DMA_ST30_MASK 0x40000000
#define LPC_USB_EPDMAST_EP_DMA_ST30 0x40000000
#define LPC_USB_EPDMAST_EP_DMA_ST30_BIT 30
#define LPC_USB_EPDMAST_EP_DMA_ST31_MASK 0x80000000
#define LPC_USB_EPDMAST_EP_DMA_ST31 0x80000000
#define LPC_USB_EPDMAST_EP_DMA_ST31_BIT 31

#define LPC_USB_EPDMAEN (*(volatile unsigned long *)0x2008C288)
#define LPC_USB_EPDMAEN_OFFSET 0x288
#define LPC_USB_EPDMAEN_EP_DMA_EN0_MASK 0x1
#define LPC_USB_EPDMAEN_EP_DMA_EN0 0x1
#define LPC_USB_EPDMAEN_EP_DMA_EN0_BIT 0
#define LPC_USB_EPDMAEN_EP_DMA_EN1_MASK 0x2
#define LPC_USB_EPDMAEN_EP_DMA_EN1 0x2
#define LPC_USB_EPDMAEN_EP_DMA_EN1_BIT 1
#define LPC_USB_EPDMAEN_EP_DMA_EN_MASK 0xFFFFFFFC
#define LPC_USB_EPDMAEN_EP_DMA_EN_BIT 2

#define LPC_USB_EPDMADIS (*(volatile unsigned long *)0x2008C28C)
#define LPC_USB_EPDMADIS_OFFSET 0x28C
#define LPC_USB_EPDMADIS_EP_DMA_DIS0_MASK 0x1
#define LPC_USB_EPDMADIS_EP_DMA_DIS0 0x1
#define LPC_USB_EPDMADIS_EP_DMA_DIS0_BIT 0
#define LPC_USB_EPDMADIS_EP_DMA_DIS1_MASK 0x2
#define LPC_USB_EPDMADIS_EP_DMA_DIS1 0x2
#define LPC_USB_EPDMADIS_EP_DMA_DIS1_BIT 1
#define LPC_USB_EPDMADIS_EP_DMA_DIS2_MASK 0x4
#define LPC_USB_EPDMADIS_EP_DMA_DIS2 0x4
#define LPC_USB_EPDMADIS_EP_DMA_DIS2_BIT 2
#define LPC_USB_EPDMADIS_EP_DMA_DIS3_MASK 0x8
#define LPC_USB_EPDMADIS_EP_DMA_DIS3 0x8
#define LPC_USB_EPDMADIS_EP_DMA_DIS3_BIT 3
#define LPC_USB_EPDMADIS_EP_DMA_DIS4_MASK 0x10
#define LPC_USB_EPDMADIS_EP_DMA_DIS4 0x10
#define LPC_USB_EPDMADIS_EP_DMA_DIS4_BIT 4
#define LPC_USB_EPDMADIS_EP_DMA_DIS5_MASK 0x20
#define LPC_USB_EPDMADIS_EP_DMA_DIS5 0x20
#define LPC_USB_EPDMADIS_EP_DMA_DIS5_BIT 5
#define LPC_USB_EPDMADIS_EP_DMA_DIS6_MASK 0x40
#define LPC_USB_EPDMADIS_EP_DMA_DIS6 0x40
#define LPC_USB_EPDMADIS_EP_DMA_DIS6_BIT 6
#define LPC_USB_EPDMADIS_EP_DMA_DIS7_MASK 0x80
#define LPC_USB_EPDMADIS_EP_DMA_DIS7 0x80
#define LPC_USB_EPDMADIS_EP_DMA_DIS7_BIT 7
#define LPC_USB_EPDMADIS_EP_DMA_DIS8_MASK 0x100
#define LPC_USB_EPDMADIS_EP_DMA_DIS8 0x100
#define LPC_USB_EPDMADIS_EP_DMA_DIS8_BIT 8
#define LPC_USB_EPDMADIS_EP_DMA_DIS9_MASK 0x200
#define LPC_USB_EPDMADIS_EP_DMA_DIS9 0x200
#define LPC_USB_EPDMADIS_EP_DMA_DIS9_BIT 9
#define LPC_USB_EPDMADIS_EP_DMA_DIS10_MASK 0x400
#define LPC_USB_EPDMADIS_EP_DMA_DIS10 0x400
#define LPC_USB_EPDMADIS_EP_DMA_DIS10_BIT 10
#define LPC_USB_EPDMADIS_EP_DMA_DIS11_MASK 0x800
#define LPC_USB_EPDMADIS_EP_DMA_DIS11 0x800
#define LPC_USB_EPDMADIS_EP_DMA_DIS11_BIT 11
#define LPC_USB_EPDMADIS_EP_DMA_DIS12_MASK 0x1000
#define LPC_USB_EPDMADIS_EP_DMA_DIS12 0x1000
#define LPC_USB_EPDMADIS_EP_DMA_DIS12_BIT 12
#define LPC_USB_EPDMADIS_EP_DMA_DIS13_MASK 0x2000
#define LPC_USB_EPDMADIS_EP_DMA_DIS13 0x2000
#define LPC_USB_EPDMADIS_EP_DMA_DIS13_BIT 13
#define LPC_USB_EPDMADIS_EP_DMA_DIS14_MASK 0x4000
#define LPC_USB_EPDMADIS_EP_DMA_DIS14 0x4000
#define LPC_USB_EPDMADIS_EP_DMA_DIS14_BIT 14
#define LPC_USB_EPDMADIS_EP_DMA_DIS15_MASK 0x8000
#define LPC_USB_EPDMADIS_EP_DMA_DIS15 0x8000
#define LPC_USB_EPDMADIS_EP_DMA_DIS15_BIT 15
#define LPC_USB_EPDMADIS_EP_DMA_DIS16_MASK 0x10000
#define LPC_USB_EPDMADIS_EP_DMA_DIS16 0x10000
#define LPC_USB_EPDMADIS_EP_DMA_DIS16_BIT 16
#define LPC_USB_EPDMADIS_EP_DMA_DIS17_MASK 0x20000
#define LPC_USB_EPDMADIS_EP_DMA_DIS17 0x20000
#define LPC_USB_EPDMADIS_EP_DMA_DIS17_BIT 17
#define LPC_USB_EPDMADIS_EP_DMA_DIS18_MASK 0x40000
#define LPC_USB_EPDMADIS_EP_DMA_DIS18 0x40000
#define LPC_USB_EPDMADIS_EP_DMA_DIS18_BIT 18
#define LPC_USB_EPDMADIS_EP_DMA_DIS19_MASK 0x80000
#define LPC_USB_EPDMADIS_EP_DMA_DIS19 0x80000
#define LPC_USB_EPDMADIS_EP_DMA_DIS19_BIT 19
#define LPC_USB_EPDMADIS_EP_DMA_DIS20_MASK 0x100000
#define LPC_USB_EPDMADIS_EP_DMA_DIS20 0x100000
#define LPC_USB_EPDMADIS_EP_DMA_DIS20_BIT 20
#define LPC_USB_EPDMADIS_EP_DMA_DIS21_MASK 0x200000
#define LPC_USB_EPDMADIS_EP_DMA_DIS21 0x200000
#define LPC_USB_EPDMADIS_EP_DMA_DIS21_BIT 21
#define LPC_USB_EPDMADIS_EP_DMA_DIS22_MASK 0x400000
#define LPC_USB_EPDMADIS_EP_DMA_DIS22 0x400000
#define LPC_USB_EPDMADIS_EP_DMA_DIS22_BIT 22
#define LPC_USB_EPDMADIS_EP_DMA_DIS23_MASK 0x800000
#define LPC_USB_EPDMADIS_EP_DMA_DIS23 0x800000
#define LPC_USB_EPDMADIS_EP_DMA_DIS23_BIT 23
#define LPC_USB_EPDMADIS_EP_DMA_DIS24_MASK 0x1000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS24 0x1000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS24_BIT 24
#define LPC_USB_EPDMADIS_EP_DMA_DIS25_MASK 0x2000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS25 0x2000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS25_BIT 25
#define LPC_USB_EPDMADIS_EP_DMA_DIS26_MASK 0x4000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS26 0x4000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS26_BIT 26
#define LPC_USB_EPDMADIS_EP_DMA_DIS27_MASK 0x8000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS27 0x8000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS27_BIT 27
#define LPC_USB_EPDMADIS_EP_DMA_DIS28_MASK 0x10000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS28 0x10000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS28_BIT 28
#define LPC_USB_EPDMADIS_EP_DMA_DIS29_MASK 0x20000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS29 0x20000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS29_BIT 29
#define LPC_USB_EPDMADIS_EP_DMA_DIS30_MASK 0x40000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS30 0x40000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS30_BIT 30
#define LPC_USB_EPDMADIS_EP_DMA_DIS31_MASK 0x80000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS31 0x80000000
#define LPC_USB_EPDMADIS_EP_DMA_DIS31_BIT 31

#define LPC_USB_DMAINTST (*(volatile unsigned long *)0x2008C290)
#define LPC_USB_DMAINTST_OFFSET 0x290
#define LPC_USB_DMAINTST_EOT_MASK 0x1
#define LPC_USB_DMAINTST_EOT 0x1
#define LPC_USB_DMAINTST_EOT_BIT 0
#define LPC_USB_DMAINTST_NDDR_MASK 0x2
#define LPC_USB_DMAINTST_NDDR 0x2
#define LPC_USB_DMAINTST_NDDR_BIT 1
#define LPC_USB_DMAINTST_ERR_MASK 0x4
#define LPC_USB_DMAINTST_ERR 0x4
#define LPC_USB_DMAINTST_ERR_BIT 2

#define LPC_USB_DMAINTEN (*(volatile unsigned long *)0x2008C294)
#define LPC_USB_DMAINTEN_OFFSET 0x294
#define LPC_USB_DMAINTEN_EOT_MASK 0x1
#define LPC_USB_DMAINTEN_EOT 0x1
#define LPC_USB_DMAINTEN_EOT_BIT 0
#define LPC_USB_DMAINTEN_NDDR_MASK 0x2
#define LPC_USB_DMAINTEN_NDDR 0x2
#define LPC_USB_DMAINTEN_NDDR_BIT 1
#define LPC_USB_DMAINTEN_ERR_MASK 0x4
#define LPC_USB_DMAINTEN_ERR 0x4
#define LPC_USB_DMAINTEN_ERR_BIT 2

#define LPC_USB_EOTINTST (*(volatile unsigned long *)0x2008C2A0)
#define LPC_USB_EOTINTST_OFFSET 0x2A0
#define LPC_USB_EOTINTST_EPTXINTST0_MASK 0x1
#define LPC_USB_EOTINTST_EPTXINTST0 0x1
#define LPC_USB_EOTINTST_EPTXINTST0_BIT 0
#define LPC_USB_EOTINTST_EPTXINTST1_MASK 0x2
#define LPC_USB_EOTINTST_EPTXINTST1 0x2
#define LPC_USB_EOTINTST_EPTXINTST1_BIT 1
#define LPC_USB_EOTINTST_EPTXINTST2_MASK 0x4
#define LPC_USB_EOTINTST_EPTXINTST2 0x4
#define LPC_USB_EOTINTST_EPTXINTST2_BIT 2
#define LPC_USB_EOTINTST_EPTXINTST3_MASK 0x8
#define LPC_USB_EOTINTST_EPTXINTST3 0x8
#define LPC_USB_EOTINTST_EPTXINTST3_BIT 3
#define LPC_USB_EOTINTST_EPTXINTST4_MASK 0x10
#define LPC_USB_EOTINTST_EPTXINTST4 0x10
#define LPC_USB_EOTINTST_EPTXINTST4_BIT 4
#define LPC_USB_EOTINTST_EPTXINTST5_MASK 0x20
#define LPC_USB_EOTINTST_EPTXINTST5 0x20
#define LPC_USB_EOTINTST_EPTXINTST5_BIT 5
#define LPC_USB_EOTINTST_EPTXINTST6_MASK 0x40
#define LPC_USB_EOTINTST_EPTXINTST6 0x40
#define LPC_USB_EOTINTST_EPTXINTST6_BIT 6
#define LPC_USB_EOTINTST_EPTXINTST7_MASK 0x80
#define LPC_USB_EOTINTST_EPTXINTST7 0x80
#define LPC_USB_EOTINTST_EPTXINTST7_BIT 7
#define LPC_USB_EOTINTST_EPTXINTST8_MASK 0x100
#define LPC_USB_EOTINTST_EPTXINTST8 0x100
#define LPC_USB_EOTINTST_EPTXINTST8_BIT 8
#define LPC_USB_EOTINTST_EPTXINTST9_MASK 0x200
#define LPC_USB_EOTINTST_EPTXINTST9 0x200
#define LPC_USB_EOTINTST_EPTXINTST9_BIT 9
#define LPC_USB_EOTINTST_EPTXINTST10_MASK 0x400
#define LPC_USB_EOTINTST_EPTXINTST10 0x400
#define LPC_USB_EOTINTST_EPTXINTST10_BIT 10
#define LPC_USB_EOTINTST_EPTXINTST11_MASK 0x800
#define LPC_USB_EOTINTST_EPTXINTST11 0x800
#define LPC_USB_EOTINTST_EPTXINTST11_BIT 11
#define LPC_USB_EOTINTST_EPTXINTST12_MASK 0x1000
#define LPC_USB_EOTINTST_EPTXINTST12 0x1000
#define LPC_USB_EOTINTST_EPTXINTST12_BIT 12
#define LPC_USB_EOTINTST_EPTXINTST13_MASK 0x2000
#define LPC_USB_EOTINTST_EPTXINTST13 0x2000
#define LPC_USB_EOTINTST_EPTXINTST13_BIT 13
#define LPC_USB_EOTINTST_EPTXINTST14_MASK 0x4000
#define LPC_USB_EOTINTST_EPTXINTST14 0x4000
#define LPC_USB_EOTINTST_EPTXINTST14_BIT 14
#define LPC_USB_EOTINTST_EPTXINTST15_MASK 0x8000
#define LPC_USB_EOTINTST_EPTXINTST15 0x8000
#define LPC_USB_EOTINTST_EPTXINTST15_BIT 15
#define LPC_USB_EOTINTST_EPTXINTST16_MASK 0x10000
#define LPC_USB_EOTINTST_EPTXINTST16 0x10000
#define LPC_USB_EOTINTST_EPTXINTST16_BIT 16
#define LPC_USB_EOTINTST_EPTXINTST17_MASK 0x20000
#define LPC_USB_EOTINTST_EPTXINTST17 0x20000
#define LPC_USB_EOTINTST_EPTXINTST17_BIT 17
#define LPC_USB_EOTINTST_EPTXINTST18_MASK 0x40000
#define LPC_USB_EOTINTST_EPTXINTST18 0x40000
#define LPC_USB_EOTINTST_EPTXINTST18_BIT 18
#define LPC_USB_EOTINTST_EPTXINTST19_MASK 0x80000
#define LPC_USB_EOTINTST_EPTXINTST19 0x80000
#define LPC_USB_EOTINTST_EPTXINTST19_BIT 19
#define LPC_USB_EOTINTST_EPTXINTST20_MASK 0x100000
#define LPC_USB_EOTINTST_EPTXINTST20 0x100000
#define LPC_USB_EOTINTST_EPTXINTST20_BIT 20
#define LPC_USB_EOTINTST_EPTXINTST21_MASK 0x200000
#define LPC_USB_EOTINTST_EPTXINTST21 0x200000
#define LPC_USB_EOTINTST_EPTXINTST21_BIT 21
#define LPC_USB_EOTINTST_EPTXINTST22_MASK 0x400000
#define LPC_USB_EOTINTST_EPTXINTST22 0x400000
#define LPC_USB_EOTINTST_EPTXINTST22_BIT 22
#define LPC_USB_EOTINTST_EPTXINTST23_MASK 0x800000
#define LPC_USB_EOTINTST_EPTXINTST23 0x800000
#define LPC_USB_EOTINTST_EPTXINTST23_BIT 23
#define LPC_USB_EOTINTST_EPTXINTST24_MASK 0x1000000
#define LPC_USB_EOTINTST_EPTXINTST24 0x1000000
#define LPC_USB_EOTINTST_EPTXINTST24_BIT 24
#define LPC_USB_EOTINTST_EPTXINTST25_MASK 0x2000000
#define LPC_USB_EOTINTST_EPTXINTST25 0x2000000
#define LPC_USB_EOTINTST_EPTXINTST25_BIT 25
#define LPC_USB_EOTINTST_EPTXINTST26_MASK 0x4000000
#define LPC_USB_EOTINTST_EPTXINTST26 0x4000000
#define LPC_USB_EOTINTST_EPTXINTST26_BIT 26
#define LPC_USB_EOTINTST_EPTXINTST27_MASK 0x8000000
#define LPC_USB_EOTINTST_EPTXINTST27 0x8000000
#define LPC_USB_EOTINTST_EPTXINTST27_BIT 27
#define LPC_USB_EOTINTST_EPTXINTST28_MASK 0x10000000
#define LPC_USB_EOTINTST_EPTXINTST28 0x10000000
#define LPC_USB_EOTINTST_EPTXINTST28_BIT 28
#define LPC_USB_EOTINTST_EPTXINTST29_MASK 0x20000000
#define LPC_USB_EOTINTST_EPTXINTST29 0x20000000
#define LPC_USB_EOTINTST_EPTXINTST29_BIT 29
#define LPC_USB_EOTINTST_EPTXINTST30_MASK 0x40000000
#define LPC_USB_EOTINTST_EPTXINTST30 0x40000000
#define LPC_USB_EOTINTST_EPTXINTST30_BIT 30
#define LPC_USB_EOTINTST_EPTXINTST31_MASK 0x80000000
#define LPC_USB_EOTINTST_EPTXINTST31 0x80000000
#define LPC_USB_EOTINTST_EPTXINTST31_BIT 31

#define LPC_USB_EOTINTCLR (*(volatile unsigned long *)0x2008C2A4)
#define LPC_USB_EOTINTCLR_OFFSET 0x2A4
#define LPC_USB_EOTINTCLR_EPTXINTCLR0_MASK 0x1
#define LPC_USB_EOTINTCLR_EPTXINTCLR0 0x1
#define LPC_USB_EOTINTCLR_EPTXINTCLR0_BIT 0
#define LPC_USB_EOTINTCLR_EPTXINTCLR1_MASK 0x2
#define LPC_USB_EOTINTCLR_EPTXINTCLR1 0x2
#define LPC_USB_EOTINTCLR_EPTXINTCLR1_BIT 1
#define LPC_USB_EOTINTCLR_EPTXINTCLR2_MASK 0x4
#define LPC_USB_EOTINTCLR_EPTXINTCLR2 0x4
#define LPC_USB_EOTINTCLR_EPTXINTCLR2_BIT 2
#define LPC_USB_EOTINTCLR_EPTXINTCLR3_MASK 0x8
#define LPC_USB_EOTINTCLR_EPTXINTCLR3 0x8
#define LPC_USB_EOTINTCLR_EPTXINTCLR3_BIT 3
#define LPC_USB_EOTINTCLR_EPTXINTCLR4_MASK 0x10
#define LPC_USB_EOTINTCLR_EPTXINTCLR4 0x10
#define LPC_USB_EOTINTCLR_EPTXINTCLR4_BIT 4
#define LPC_USB_EOTINTCLR_EPTXINTCLR5_MASK 0x20
#define LPC_USB_EOTINTCLR_EPTXINTCLR5 0x20
#define LPC_USB_EOTINTCLR_EPTXINTCLR5_BIT 5
#define LPC_USB_EOTINTCLR_EPTXINTCLR6_MASK 0x40
#define LPC_USB_EOTINTCLR_EPTXINTCLR6 0x40
#define LPC_USB_EOTINTCLR_EPTXINTCLR6_BIT 6
#define LPC_USB_EOTINTCLR_EPTXINTCLR7_MASK 0x80
#define LPC_USB_EOTINTCLR_EPTXINTCLR7 0x80
#define LPC_USB_EOTINTCLR_EPTXINTCLR7_BIT 7
#define LPC_USB_EOTINTCLR_EPTXINTCLR8_MASK 0x100
#define LPC_USB_EOTINTCLR_EPTXINTCLR8 0x100
#define LPC_USB_EOTINTCLR_EPTXINTCLR8_BIT 8
#define LPC_USB_EOTINTCLR_EPTXINTCLR9_MASK 0x200
#define LPC_USB_EOTINTCLR_EPTXINTCLR9 0x200
#define LPC_USB_EOTINTCLR_EPTXINTCLR9_BIT 9
#define LPC_USB_EOTINTCLR_EPTXINTCLR10_MASK 0x400
#define LPC_USB_EOTINTCLR_EPTXINTCLR10 0x400
#define LPC_USB_EOTINTCLR_EPTXINTCLR10_BIT 10
#define LPC_USB_EOTINTCLR_EPTXINTCLR11_MASK 0x800
#define LPC_USB_EOTINTCLR_EPTXINTCLR11 0x800
#define LPC_USB_EOTINTCLR_EPTXINTCLR11_BIT 11
#define LPC_USB_EOTINTCLR_EPTXINTCLR12_MASK 0x1000
#define LPC_USB_EOTINTCLR_EPTXINTCLR12 0x1000
#define LPC_USB_EOTINTCLR_EPTXINTCLR12_BIT 12
#define LPC_USB_EOTINTCLR_EPTXINTCLR13_MASK 0x2000
#define LPC_USB_EOTINTCLR_EPTXINTCLR13 0x2000
#define LPC_USB_EOTINTCLR_EPTXINTCLR13_BIT 13
#define LPC_USB_EOTINTCLR_EPTXINTCLR14_MASK 0x4000
#define LPC_USB_EOTINTCLR_EPTXINTCLR14 0x4000
#define LPC_USB_EOTINTCLR_EPTXINTCLR14_BIT 14
#define LPC_USB_EOTINTCLR_EPTXINTCLR15_MASK 0x8000
#define LPC_USB_EOTINTCLR_EPTXINTCLR15 0x8000
#define LPC_USB_EOTINTCLR_EPTXINTCLR15_BIT 15
#define LPC_USB_EOTINTCLR_EPTXINTCLR16_MASK 0x10000
#define LPC_USB_EOTINTCLR_EPTXINTCLR16 0x10000
#define LPC_USB_EOTINTCLR_EPTXINTCLR16_BIT 16
#define LPC_USB_EOTINTCLR_EPTXINTCLR17_MASK 0x20000
#define LPC_USB_EOTINTCLR_EPTXINTCLR17 0x20000
#define LPC_USB_EOTINTCLR_EPTXINTCLR17_BIT 17
#define LPC_USB_EOTINTCLR_EPTXINTCLR18_MASK 0x40000
#define LPC_USB_EOTINTCLR_EPTXINTCLR18 0x40000
#define LPC_USB_EOTINTCLR_EPTXINTCLR18_BIT 18
#define LPC_USB_EOTINTCLR_EPTXINTCLR19_MASK 0x80000
#define LPC_USB_EOTINTCLR_EPTXINTCLR19 0x80000
#define LPC_USB_EOTINTCLR_EPTXINTCLR19_BIT 19
#define LPC_USB_EOTINTCLR_EPTXINTCLR20_MASK 0x100000
#define LPC_USB_EOTINTCLR_EPTXINTCLR20 0x100000
#define LPC_USB_EOTINTCLR_EPTXINTCLR20_BIT 20
#define LPC_USB_EOTINTCLR_EPTXINTCLR21_MASK 0x200000
#define LPC_USB_EOTINTCLR_EPTXINTCLR21 0x200000
#define LPC_USB_EOTINTCLR_EPTXINTCLR21_BIT 21
#define LPC_USB_EOTINTCLR_EPTXINTCLR22_MASK 0x400000
#define LPC_USB_EOTINTCLR_EPTXINTCLR22 0x400000
#define LPC_USB_EOTINTCLR_EPTXINTCLR22_BIT 22
#define LPC_USB_EOTINTCLR_EPTXINTCLR23_MASK 0x800000
#define LPC_USB_EOTINTCLR_EPTXINTCLR23 0x800000
#define LPC_USB_EOTINTCLR_EPTXINTCLR23_BIT 23
#define LPC_USB_EOTINTCLR_EPTXINTCLR24_MASK 0x1000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR24 0x1000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR24_BIT 24
#define LPC_USB_EOTINTCLR_EPTXINTCLR25_MASK 0x2000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR25 0x2000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR25_BIT 25
#define LPC_USB_EOTINTCLR_EPTXINTCLR26_MASK 0x4000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR26 0x4000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR26_BIT 26
#define LPC_USB_EOTINTCLR_EPTXINTCLR27_MASK 0x8000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR27 0x8000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR27_BIT 27
#define LPC_USB_EOTINTCLR_EPTXINTCLR28_MASK 0x10000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR28 0x10000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR28_BIT 28
#define LPC_USB_EOTINTCLR_EPTXINTCLR29_MASK 0x20000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR29 0x20000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR29_BIT 29
#define LPC_USB_EOTINTCLR_EPTXINTCLR30_MASK 0x40000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR30 0x40000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR30_BIT 30
#define LPC_USB_EOTINTCLR_EPTXINTCLR31_MASK 0x80000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR31 0x80000000
#define LPC_USB_EOTINTCLR_EPTXINTCLR31_BIT 31

#define LPC_USB_EOTINTSET (*(volatile unsigned long *)0x2008C2A8)
#define LPC_USB_EOTINTSET_OFFSET 0x2A8
#define LPC_USB_EOTINTSET_EPTXINTSET0_MASK 0x1
#define LPC_USB_EOTINTSET_EPTXINTSET0 0x1
#define LPC_USB_EOTINTSET_EPTXINTSET0_BIT 0
#define LPC_USB_EOTINTSET_EPTXINTSET1_MASK 0x2
#define LPC_USB_EOTINTSET_EPTXINTSET1 0x2
#define LPC_USB_EOTINTSET_EPTXINTSET1_BIT 1
#define LPC_USB_EOTINTSET_EPTXINTSET2_MASK 0x4
#define LPC_USB_EOTINTSET_EPTXINTSET2 0x4
#define LPC_USB_EOTINTSET_EPTXINTSET2_BIT 2
#define LPC_USB_EOTINTSET_EPTXINTSET3_MASK 0x8
#define LPC_USB_EOTINTSET_EPTXINTSET3 0x8
#define LPC_USB_EOTINTSET_EPTXINTSET3_BIT 3
#define LPC_USB_EOTINTSET_EPTXINTSET4_MASK 0x10
#define LPC_USB_EOTINTSET_EPTXINTSET4 0x10
#define LPC_USB_EOTINTSET_EPTXINTSET4_BIT 4
#define LPC_USB_EOTINTSET_EPTXINTSET5_MASK 0x20
#define LPC_USB_EOTINTSET_EPTXINTSET5 0x20
#define LPC_USB_EOTINTSET_EPTXINTSET5_BIT 5
#define LPC_USB_EOTINTSET_EPTXINTSET6_MASK 0x40
#define LPC_USB_EOTINTSET_EPTXINTSET6 0x40
#define LPC_USB_EOTINTSET_EPTXINTSET6_BIT 6
#define LPC_USB_EOTINTSET_EPTXINTSET7_MASK 0x80
#define LPC_USB_EOTINTSET_EPTXINTSET7 0x80
#define LPC_USB_EOTINTSET_EPTXINTSET7_BIT 7
#define LPC_USB_EOTINTSET_EPTXINTSET8_MASK 0x100
#define LPC_USB_EOTINTSET_EPTXINTSET8 0x100
#define LPC_USB_EOTINTSET_EPTXINTSET8_BIT 8
#define LPC_USB_EOTINTSET_EPTXINTSET9_MASK 0x200
#define LPC_USB_EOTINTSET_EPTXINTSET9 0x200
#define LPC_USB_EOTINTSET_EPTXINTSET9_BIT 9
#define LPC_USB_EOTINTSET_EPTXINTSET10_MASK 0x400
#define LPC_USB_EOTINTSET_EPTXINTSET10 0x400
#define LPC_USB_EOTINTSET_EPTXINTSET10_BIT 10
#define LPC_USB_EOTINTSET_EPTXINTSET11_MASK 0x800
#define LPC_USB_EOTINTSET_EPTXINTSET11 0x800
#define LPC_USB_EOTINTSET_EPTXINTSET11_BIT 11
#define LPC_USB_EOTINTSET_EPTXINTSET12_MASK 0x1000
#define LPC_USB_EOTINTSET_EPTXINTSET12 0x1000
#define LPC_USB_EOTINTSET_EPTXINTSET12_BIT 12
#define LPC_USB_EOTINTSET_EPTXINTSET13_MASK 0x2000
#define LPC_USB_EOTINTSET_EPTXINTSET13 0x2000
#define LPC_USB_EOTINTSET_EPTXINTSET13_BIT 13
#define LPC_USB_EOTINTSET_EPTXINTSET14_MASK 0x4000
#define LPC_USB_EOTINTSET_EPTXINTSET14 0x4000
#define LPC_USB_EOTINTSET_EPTXINTSET14_BIT 14
#define LPC_USB_EOTINTSET_EPTXINTSET15_MASK 0x8000
#define LPC_USB_EOTINTSET_EPTXINTSET15 0x8000
#define LPC_USB_EOTINTSET_EPTXINTSET15_BIT 15
#define LPC_USB_EOTINTSET_EPTXINTSET16_MASK 0x10000
#define LPC_USB_EOTINTSET_EPTXINTSET16 0x10000
#define LPC_USB_EOTINTSET_EPTXINTSET16_BIT 16
#define LPC_USB_EOTINTSET_EPTXINTSET17_MASK 0x20000
#define LPC_USB_EOTINTSET_EPTXINTSET17 0x20000
#define LPC_USB_EOTINTSET_EPTXINTSET17_BIT 17
#define LPC_USB_EOTINTSET_EPTXINTSET18_MASK 0x40000
#define LPC_USB_EOTINTSET_EPTXINTSET18 0x40000
#define LPC_USB_EOTINTSET_EPTXINTSET18_BIT 18
#define LPC_USB_EOTINTSET_EPTXINTSET19_MASK 0x80000
#define LPC_USB_EOTINTSET_EPTXINTSET19 0x80000
#define LPC_USB_EOTINTSET_EPTXINTSET19_BIT 19
#define LPC_USB_EOTINTSET_EPTXINTSET20_MASK 0x100000
#define LPC_USB_EOTINTSET_EPTXINTSET20 0x100000
#define LPC_USB_EOTINTSET_EPTXINTSET20_BIT 20
#define LPC_USB_EOTINTSET_EPTXINTSET21_MASK 0x200000
#define LPC_USB_EOTINTSET_EPTXINTSET21 0x200000
#define LPC_USB_EOTINTSET_EPTXINTSET21_BIT 21
#define LPC_USB_EOTINTSET_EPTXINTSET22_MASK 0x400000
#define LPC_USB_EOTINTSET_EPTXINTSET22 0x400000
#define LPC_USB_EOTINTSET_EPTXINTSET22_BIT 22
#define LPC_USB_EOTINTSET_EPTXINTSET23_MASK 0x800000
#define LPC_USB_EOTINTSET_EPTXINTSET23 0x800000
#define LPC_USB_EOTINTSET_EPTXINTSET23_BIT 23
#define LPC_USB_EOTINTSET_EPTXINTSET24_MASK 0x1000000
#define LPC_USB_EOTINTSET_EPTXINTSET24 0x1000000
#define LPC_USB_EOTINTSET_EPTXINTSET24_BIT 24
#define LPC_USB_EOTINTSET_EPTXINTSET25_MASK 0x2000000
#define LPC_USB_EOTINTSET_EPTXINTSET25 0x2000000
#define LPC_USB_EOTINTSET_EPTXINTSET25_BIT 25
#define LPC_USB_EOTINTSET_EPTXINTSET26_MASK 0x4000000
#define LPC_USB_EOTINTSET_EPTXINTSET26 0x4000000
#define LPC_USB_EOTINTSET_EPTXINTSET26_BIT 26
#define LPC_USB_EOTINTSET_EPTXINTSET27_MASK 0x8000000
#define LPC_USB_EOTINTSET_EPTXINTSET27 0x8000000
#define LPC_USB_EOTINTSET_EPTXINTSET27_BIT 27
#define LPC_USB_EOTINTSET_EPTXINTSET28_MASK 0x10000000
#define LPC_USB_EOTINTSET_EPTXINTSET28 0x10000000
#define LPC_USB_EOTINTSET_EPTXINTSET28_BIT 28
#define LPC_USB_EOTINTSET_EPTXINTSET29_MASK 0x20000000
#define LPC_USB_EOTINTSET_EPTXINTSET29 0x20000000
#define LPC_USB_EOTINTSET_EPTXINTSET29_BIT 29
#define LPC_USB_EOTINTSET_EPTXINTSET30_MASK 0x40000000
#define LPC_USB_EOTINTSET_EPTXINTSET30 0x40000000
#define LPC_USB_EOTINTSET_EPTXINTSET30_BIT 30
#define LPC_USB_EOTINTSET_EPTXINTSET31_MASK 0x80000000
#define LPC_USB_EOTINTSET_EPTXINTSET31 0x80000000
#define LPC_USB_EOTINTSET_EPTXINTSET31_BIT 31

#define LPC_USB_NDDRINTST (*(volatile unsigned long *)0x2008C2AC)
#define LPC_USB_NDDRINTST_OFFSET 0x2AC
#define LPC_USB_NDDRINTST_EPNDDINTST0_MASK 0x1
#define LPC_USB_NDDRINTST_EPNDDINTST0 0x1
#define LPC_USB_NDDRINTST_EPNDDINTST0_BIT 0
#define LPC_USB_NDDRINTST_EPNDDINTST1_MASK 0x2
#define LPC_USB_NDDRINTST_EPNDDINTST1 0x2
#define LPC_USB_NDDRINTST_EPNDDINTST1_BIT 1
#define LPC_USB_NDDRINTST_EPNDDINTST2_MASK 0x4
#define LPC_USB_NDDRINTST_EPNDDINTST2 0x4
#define LPC_USB_NDDRINTST_EPNDDINTST2_BIT 2
#define LPC_USB_NDDRINTST_EPNDDINTST3_MASK 0x8
#define LPC_USB_NDDRINTST_EPNDDINTST3 0x8
#define LPC_USB_NDDRINTST_EPNDDINTST3_BIT 3
#define LPC_USB_NDDRINTST_EPNDDINTST4_MASK 0x10
#define LPC_USB_NDDRINTST_EPNDDINTST4 0x10
#define LPC_USB_NDDRINTST_EPNDDINTST4_BIT 4
#define LPC_USB_NDDRINTST_EPNDDINTST5_MASK 0x20
#define LPC_USB_NDDRINTST_EPNDDINTST5 0x20
#define LPC_USB_NDDRINTST_EPNDDINTST5_BIT 5
#define LPC_USB_NDDRINTST_EPNDDINTST6_MASK 0x40
#define LPC_USB_NDDRINTST_EPNDDINTST6 0x40
#define LPC_USB_NDDRINTST_EPNDDINTST6_BIT 6
#define LPC_USB_NDDRINTST_EPNDDINTST7_MASK 0x80
#define LPC_USB_NDDRINTST_EPNDDINTST7 0x80
#define LPC_USB_NDDRINTST_EPNDDINTST7_BIT 7
#define LPC_USB_NDDRINTST_EPNDDINTST8_MASK 0x100
#define LPC_USB_NDDRINTST_EPNDDINTST8 0x100
#define LPC_USB_NDDRINTST_EPNDDINTST8_BIT 8
#define LPC_USB_NDDRINTST_EPNDDINTST9_MASK 0x200
#define LPC_USB_NDDRINTST_EPNDDINTST9 0x200
#define LPC_USB_NDDRINTST_EPNDDINTST9_BIT 9
#define LPC_USB_NDDRINTST_EPNDDINTST10_MASK 0x400
#define LPC_USB_NDDRINTST_EPNDDINTST10 0x400
#define LPC_USB_NDDRINTST_EPNDDINTST10_BIT 10
#define LPC_USB_NDDRINTST_EPNDDINTST11_MASK 0x800
#define LPC_USB_NDDRINTST_EPNDDINTST11 0x800
#define LPC_USB_NDDRINTST_EPNDDINTST11_BIT 11
#define LPC_USB_NDDRINTST_EPNDDINTST12_MASK 0x1000
#define LPC_USB_NDDRINTST_EPNDDINTST12 0x1000
#define LPC_USB_NDDRINTST_EPNDDINTST12_BIT 12
#define LPC_USB_NDDRINTST_EPNDDINTST13_MASK 0x2000
#define LPC_USB_NDDRINTST_EPNDDINTST13 0x2000
#define LPC_USB_NDDRINTST_EPNDDINTST13_BIT 13
#define LPC_USB_NDDRINTST_EPNDDINTST14_MASK 0x4000
#define LPC_USB_NDDRINTST_EPNDDINTST14 0x4000
#define LPC_USB_NDDRINTST_EPNDDINTST14_BIT 14
#define LPC_USB_NDDRINTST_EPNDDINTST15_MASK 0x8000
#define LPC_USB_NDDRINTST_EPNDDINTST15 0x8000
#define LPC_USB_NDDRINTST_EPNDDINTST15_BIT 15
#define LPC_USB_NDDRINTST_EPNDDINTST16_MASK 0x10000
#define LPC_USB_NDDRINTST_EPNDDINTST16 0x10000
#define LPC_USB_NDDRINTST_EPNDDINTST16_BIT 16
#define LPC_USB_NDDRINTST_EPNDDINTST17_MASK 0x20000
#define LPC_USB_NDDRINTST_EPNDDINTST17 0x20000
#define LPC_USB_NDDRINTST_EPNDDINTST17_BIT 17
#define LPC_USB_NDDRINTST_EPNDDINTST18_MASK 0x40000
#define LPC_USB_NDDRINTST_EPNDDINTST18 0x40000
#define LPC_USB_NDDRINTST_EPNDDINTST18_BIT 18
#define LPC_USB_NDDRINTST_EPNDDINTST19_MASK 0x80000
#define LPC_USB_NDDRINTST_EPNDDINTST19 0x80000
#define LPC_USB_NDDRINTST_EPNDDINTST19_BIT 19
#define LPC_USB_NDDRINTST_EPNDDINTST20_MASK 0x100000
#define LPC_USB_NDDRINTST_EPNDDINTST20 0x100000
#define LPC_USB_NDDRINTST_EPNDDINTST20_BIT 20
#define LPC_USB_NDDRINTST_EPNDDINTST21_MASK 0x200000
#define LPC_USB_NDDRINTST_EPNDDINTST21 0x200000
#define LPC_USB_NDDRINTST_EPNDDINTST21_BIT 21
#define LPC_USB_NDDRINTST_EPNDDINTST22_MASK 0x400000
#define LPC_USB_NDDRINTST_EPNDDINTST22 0x400000
#define LPC_USB_NDDRINTST_EPNDDINTST22_BIT 22
#define LPC_USB_NDDRINTST_EPNDDINTST23_MASK 0x800000
#define LPC_USB_NDDRINTST_EPNDDINTST23 0x800000
#define LPC_USB_NDDRINTST_EPNDDINTST23_BIT 23
#define LPC_USB_NDDRINTST_EPNDDINTST24_MASK 0x1000000
#define LPC_USB_NDDRINTST_EPNDDINTST24 0x1000000
#define LPC_USB_NDDRINTST_EPNDDINTST24_BIT 24
#define LPC_USB_NDDRINTST_EPNDDINTST25_MASK 0x2000000
#define LPC_USB_NDDRINTST_EPNDDINTST25 0x2000000
#define LPC_USB_NDDRINTST_EPNDDINTST25_BIT 25
#define LPC_USB_NDDRINTST_EPNDDINTST26_MASK 0x4000000
#define LPC_USB_NDDRINTST_EPNDDINTST26 0x4000000
#define LPC_USB_NDDRINTST_EPNDDINTST26_BIT 26
#define LPC_USB_NDDRINTST_EPNDDINTST27_MASK 0x8000000
#define LPC_USB_NDDRINTST_EPNDDINTST27 0x8000000
#define LPC_USB_NDDRINTST_EPNDDINTST27_BIT 27
#define LPC_USB_NDDRINTST_EPNDDINTST28_MASK 0x10000000
#define LPC_USB_NDDRINTST_EPNDDINTST28 0x10000000
#define LPC_USB_NDDRINTST_EPNDDINTST28_BIT 28
#define LPC_USB_NDDRINTST_EPNDDINTST29_MASK 0x20000000
#define LPC_USB_NDDRINTST_EPNDDINTST29 0x20000000
#define LPC_USB_NDDRINTST_EPNDDINTST29_BIT 29
#define LPC_USB_NDDRINTST_EPNDDINTST30_MASK 0x40000000
#define LPC_USB_NDDRINTST_EPNDDINTST30 0x40000000
#define LPC_USB_NDDRINTST_EPNDDINTST30_BIT 30
#define LPC_USB_NDDRINTST_EPNDDINTST31_MASK 0x80000000
#define LPC_USB_NDDRINTST_EPNDDINTST31 0x80000000
#define LPC_USB_NDDRINTST_EPNDDINTST31_BIT 31

#define LPC_USB_NDDRINTCLR (*(volatile unsigned long *)0x2008C2B0)
#define LPC_USB_NDDRINTCLR_OFFSET 0x2B0
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR0_MASK 0x1
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR0 0x1
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR0_BIT 0
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR1_MASK 0x2
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR1 0x2
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR1_BIT 1
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR2_MASK 0x4
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR2 0x4
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR2_BIT 2
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR3_MASK 0x8
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR3 0x8
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR3_BIT 3
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR4_MASK 0x10
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR4 0x10
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR4_BIT 4
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR5_MASK 0x20
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR5 0x20
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR5_BIT 5
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR6_MASK 0x40
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR6 0x40
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR6_BIT 6
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR7_MASK 0x80
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR7 0x80
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR7_BIT 7
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR8_MASK 0x100
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR8 0x100
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR8_BIT 8
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR9_MASK 0x200
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR9 0x200
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR9_BIT 9
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR10_MASK 0x400
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR10 0x400
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR10_BIT 10
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR11_MASK 0x800
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR11 0x800
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR11_BIT 11
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR12_MASK 0x1000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR12 0x1000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR12_BIT 12
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR13_MASK 0x2000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR13 0x2000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR13_BIT 13
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR14_MASK 0x4000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR14 0x4000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR14_BIT 14
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR15_MASK 0x8000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR15 0x8000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR15_BIT 15
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR16_MASK 0x10000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR16 0x10000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR16_BIT 16
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR17_MASK 0x20000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR17 0x20000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR17_BIT 17
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR18_MASK 0x40000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR18 0x40000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR18_BIT 18
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR19_MASK 0x80000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR19 0x80000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR19_BIT 19
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR20_MASK 0x100000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR20 0x100000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR20_BIT 20
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR21_MASK 0x200000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR21 0x200000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR21_BIT 21
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR22_MASK 0x400000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR22 0x400000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR22_BIT 22
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR23_MASK 0x800000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR23 0x800000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR23_BIT 23
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR24_MASK 0x1000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR24 0x1000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR24_BIT 24
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR25_MASK 0x2000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR25 0x2000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR25_BIT 25
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR26_MASK 0x4000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR26 0x4000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR26_BIT 26
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR27_MASK 0x8000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR27 0x8000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR27_BIT 27
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR28_MASK 0x10000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR28 0x10000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR28_BIT 28
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR29_MASK 0x20000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR29 0x20000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR29_BIT 29
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR30_MASK 0x40000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR30 0x40000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR30_BIT 30
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR31_MASK 0x80000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR31 0x80000000
#define LPC_USB_NDDRINTCLR_EPNDDINTCLR31_BIT 31

#define LPC_USB_NDDRINTSET (*(volatile unsigned long *)0x2008C2B4)
#define LPC_USB_NDDRINTSET_OFFSET 0x2B4
#define LPC_USB_NDDRINTSET_EPNDDINTSET0_MASK 0x1
#define LPC_USB_NDDRINTSET_EPNDDINTSET0 0x1
#define LPC_USB_NDDRINTSET_EPNDDINTSET0_BIT 0
#define LPC_USB_NDDRINTSET_EPNDDINTSET1_MASK 0x2
#define LPC_USB_NDDRINTSET_EPNDDINTSET1 0x2
#define LPC_USB_NDDRINTSET_EPNDDINTSET1_BIT 1
#define LPC_USB_NDDRINTSET_EPNDDINTSET2_MASK 0x4
#define LPC_USB_NDDRINTSET_EPNDDINTSET2 0x4
#define LPC_USB_NDDRINTSET_EPNDDINTSET2_BIT 2
#define LPC_USB_NDDRINTSET_EPNDDINTSET3_MASK 0x8
#define LPC_USB_NDDRINTSET_EPNDDINTSET3 0x8
#define LPC_USB_NDDRINTSET_EPNDDINTSET3_BIT 3
#define LPC_USB_NDDRINTSET_EPNDDINTSET4_MASK 0x10
#define LPC_USB_NDDRINTSET_EPNDDINTSET4 0x10
#define LPC_USB_NDDRINTSET_EPNDDINTSET4_BIT 4
#define LPC_USB_NDDRINTSET_EPNDDINTSET5_MASK 0x20
#define LPC_USB_NDDRINTSET_EPNDDINTSET5 0x20
#define LPC_USB_NDDRINTSET_EPNDDINTSET5_BIT 5
#define LPC_USB_NDDRINTSET_EPNDDINTSET6_MASK 0x40
#define LPC_USB_NDDRINTSET_EPNDDINTSET6 0x40
#define LPC_USB_NDDRINTSET_EPNDDINTSET6_BIT 6
#define LPC_USB_NDDRINTSET_EPNDDINTSET7_MASK 0x80
#define LPC_USB_NDDRINTSET_EPNDDINTSET7 0x80
#define LPC_USB_NDDRINTSET_EPNDDINTSET7_BIT 7
#define LPC_USB_NDDRINTSET_EPNDDINTSET8_MASK 0x100
#define LPC_USB_NDDRINTSET_EPNDDINTSET8 0x100
#define LPC_USB_NDDRINTSET_EPNDDINTSET8_BIT 8
#define LPC_USB_NDDRINTSET_EPNDDINTSET9_MASK 0x200
#define LPC_USB_NDDRINTSET_EPNDDINTSET9 0x200
#define LPC_USB_NDDRINTSET_EPNDDINTSET9_BIT 9
#define LPC_USB_NDDRINTSET_EPNDDINTSET10_MASK 0x400
#define LPC_USB_NDDRINTSET_EPNDDINTSET10 0x400
#define LPC_USB_NDDRINTSET_EPNDDINTSET10_BIT 10
#define LPC_USB_NDDRINTSET_EPNDDINTSET11_MASK 0x800
#define LPC_USB_NDDRINTSET_EPNDDINTSET11 0x800
#define LPC_USB_NDDRINTSET_EPNDDINTSET11_BIT 11
#define LPC_USB_NDDRINTSET_EPNDDINTSET12_MASK 0x1000
#define LPC_USB_NDDRINTSET_EPNDDINTSET12 0x1000
#define LPC_USB_NDDRINTSET_EPNDDINTSET12_BIT 12
#define LPC_USB_NDDRINTSET_EPNDDINTSET13_MASK 0x2000
#define LPC_USB_NDDRINTSET_EPNDDINTSET13 0x2000
#define LPC_USB_NDDRINTSET_EPNDDINTSET13_BIT 13
#define LPC_USB_NDDRINTSET_EPNDDINTSET14_MASK 0x4000
#define LPC_USB_NDDRINTSET_EPNDDINTSET14 0x4000
#define LPC_USB_NDDRINTSET_EPNDDINTSET14_BIT 14
#define LPC_USB_NDDRINTSET_EPNDDINTSET15_MASK 0x8000
#define LPC_USB_NDDRINTSET_EPNDDINTSET15 0x8000
#define LPC_USB_NDDRINTSET_EPNDDINTSET15_BIT 15
#define LPC_USB_NDDRINTSET_EPNDDINTSET16_MASK 0x10000
#define LPC_USB_NDDRINTSET_EPNDDINTSET16 0x10000
#define LPC_USB_NDDRINTSET_EPNDDINTSET16_BIT 16
#define LPC_USB_NDDRINTSET_EPNDDINTSET17_MASK 0x20000
#define LPC_USB_NDDRINTSET_EPNDDINTSET17 0x20000
#define LPC_USB_NDDRINTSET_EPNDDINTSET17_BIT 17
#define LPC_USB_NDDRINTSET_EPNDDINTSET18_MASK 0x40000
#define LPC_USB_NDDRINTSET_EPNDDINTSET18 0x40000
#define LPC_USB_NDDRINTSET_EPNDDINTSET18_BIT 18
#define LPC_USB_NDDRINTSET_EPNDDINTSET19_MASK 0x80000
#define LPC_USB_NDDRINTSET_EPNDDINTSET19 0x80000
#define LPC_USB_NDDRINTSET_EPNDDINTSET19_BIT 19
#define LPC_USB_NDDRINTSET_EPNDDINTSET20_MASK 0x100000
#define LPC_USB_NDDRINTSET_EPNDDINTSET20 0x100000
#define LPC_USB_NDDRINTSET_EPNDDINTSET20_BIT 20
#define LPC_USB_NDDRINTSET_EPNDDINTSET21_MASK 0x200000
#define LPC_USB_NDDRINTSET_EPNDDINTSET21 0x200000
#define LPC_USB_NDDRINTSET_EPNDDINTSET21_BIT 21
#define LPC_USB_NDDRINTSET_EPNDDINTSET22_MASK 0x400000
#define LPC_USB_NDDRINTSET_EPNDDINTSET22 0x400000
#define LPC_USB_NDDRINTSET_EPNDDINTSET22_BIT 22
#define LPC_USB_NDDRINTSET_EPNDDINTSET23_MASK 0x800000
#define LPC_USB_NDDRINTSET_EPNDDINTSET23 0x800000
#define LPC_USB_NDDRINTSET_EPNDDINTSET23_BIT 23
#define LPC_USB_NDDRINTSET_EPNDDINTSET24_MASK 0x1000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET24 0x1000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET24_BIT 24
#define LPC_USB_NDDRINTSET_EPNDDINTSET25_MASK 0x2000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET25 0x2000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET25_BIT 25
#define LPC_USB_NDDRINTSET_EPNDDINTSET26_MASK 0x4000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET26 0x4000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET26_BIT 26
#define LPC_USB_NDDRINTSET_EPNDDINTSET27_MASK 0x8000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET27 0x8000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET27_BIT 27
#define LPC_USB_NDDRINTSET_EPNDDINTSET28_MASK 0x10000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET28 0x10000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET28_BIT 28
#define LPC_USB_NDDRINTSET_EPNDDINTSET29_MASK 0x20000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET29 0x20000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET29_BIT 29
#define LPC_USB_NDDRINTSET_EPNDDINTSET30_MASK 0x40000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET30 0x40000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET30_BIT 30
#define LPC_USB_NDDRINTSET_EPNDDINTSET31_MASK 0x80000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET31 0x80000000
#define LPC_USB_NDDRINTSET_EPNDDINTSET31_BIT 31

#define LPC_USB_SYSERRINTST (*(volatile unsigned long *)0x2008C2B8)
#define LPC_USB_SYSERRINTST_OFFSET 0x2B8
#define LPC_USB_SYSERRINTST_EPERRINTST0_MASK 0x1
#define LPC_USB_SYSERRINTST_EPERRINTST0 0x1
#define LPC_USB_SYSERRINTST_EPERRINTST0_BIT 0
#define LPC_USB_SYSERRINTST_EPERRINTST1_MASK 0x2
#define LPC_USB_SYSERRINTST_EPERRINTST1 0x2
#define LPC_USB_SYSERRINTST_EPERRINTST1_BIT 1
#define LPC_USB_SYSERRINTST_EPERRINTST2_MASK 0x4
#define LPC_USB_SYSERRINTST_EPERRINTST2 0x4
#define LPC_USB_SYSERRINTST_EPERRINTST2_BIT 2
#define LPC_USB_SYSERRINTST_EPERRINTST3_MASK 0x8
#define LPC_USB_SYSERRINTST_EPERRINTST3 0x8
#define LPC_USB_SYSERRINTST_EPERRINTST3_BIT 3
#define LPC_USB_SYSERRINTST_EPERRINTST4_MASK 0x10
#define LPC_USB_SYSERRINTST_EPERRINTST4 0x10
#define LPC_USB_SYSERRINTST_EPERRINTST4_BIT 4
#define LPC_USB_SYSERRINTST_EPERRINTST5_MASK 0x20
#define LPC_USB_SYSERRINTST_EPERRINTST5 0x20
#define LPC_USB_SYSERRINTST_EPERRINTST5_BIT 5
#define LPC_USB_SYSERRINTST_EPERRINTST6_MASK 0x40
#define LPC_USB_SYSERRINTST_EPERRINTST6 0x40
#define LPC_USB_SYSERRINTST_EPERRINTST6_BIT 6
#define LPC_USB_SYSERRINTST_EPERRINTST7_MASK 0x80
#define LPC_USB_SYSERRINTST_EPERRINTST7 0x80
#define LPC_USB_SYSERRINTST_EPERRINTST7_BIT 7
#define LPC_USB_SYSERRINTST_EPERRINTST8_MASK 0x100
#define LPC_USB_SYSERRINTST_EPERRINTST8 0x100
#define LPC_USB_SYSERRINTST_EPERRINTST8_BIT 8
#define LPC_USB_SYSERRINTST_EPERRINTST9_MASK 0x200
#define LPC_USB_SYSERRINTST_EPERRINTST9 0x200
#define LPC_USB_SYSERRINTST_EPERRINTST9_BIT 9
#define LPC_USB_SYSERRINTST_EPERRINTST10_MASK 0x400
#define LPC_USB_SYSERRINTST_EPERRINTST10 0x400
#define LPC_USB_SYSERRINTST_EPERRINTST10_BIT 10
#define LPC_USB_SYSERRINTST_EPERRINTST11_MASK 0x800
#define LPC_USB_SYSERRINTST_EPERRINTST11 0x800
#define LPC_USB_SYSERRINTST_EPERRINTST11_BIT 11
#define LPC_USB_SYSERRINTST_EPERRINTST12_MASK 0x1000
#define LPC_USB_SYSERRINTST_EPERRINTST12 0x1000
#define LPC_USB_SYSERRINTST_EPERRINTST12_BIT 12
#define LPC_USB_SYSERRINTST_EPERRINTST13_MASK 0x2000
#define LPC_USB_SYSERRINTST_EPERRINTST13 0x2000
#define LPC_USB_SYSERRINTST_EPERRINTST13_BIT 13
#define LPC_USB_SYSERRINTST_EPERRINTST14_MASK 0x4000
#define LPC_USB_SYSERRINTST_EPERRINTST14 0x4000
#define LPC_USB_SYSERRINTST_EPERRINTST14_BIT 14
#define LPC_USB_SYSERRINTST_EPERRINTST15_MASK 0x8000
#define LPC_USB_SYSERRINTST_EPERRINTST15 0x8000
#define LPC_USB_SYSERRINTST_EPERRINTST15_BIT 15
#define LPC_USB_SYSERRINTST_EPERRINTST16_MASK 0x10000
#define LPC_USB_SYSERRINTST_EPERRINTST16 0x10000
#define LPC_USB_SYSERRINTST_EPERRINTST16_BIT 16
#define LPC_USB_SYSERRINTST_EPERRINTST17_MASK 0x20000
#define LPC_USB_SYSERRINTST_EPERRINTST17 0x20000
#define LPC_USB_SYSERRINTST_EPERRINTST17_BIT 17
#define LPC_USB_SYSERRINTST_EPERRINTST18_MASK 0x40000
#define LPC_USB_SYSERRINTST_EPERRINTST18 0x40000
#define LPC_USB_SYSERRINTST_EPERRINTST18_BIT 18
#define LPC_USB_SYSERRINTST_EPERRINTST19_MASK 0x80000
#define LPC_USB_SYSERRINTST_EPERRINTST19 0x80000
#define LPC_USB_SYSERRINTST_EPERRINTST19_BIT 19
#define LPC_USB_SYSERRINTST_EPERRINTST20_MASK 0x100000
#define LPC_USB_SYSERRINTST_EPERRINTST20 0x100000
#define LPC_USB_SYSERRINTST_EPERRINTST20_BIT 20
#define LPC_USB_SYSERRINTST_EPERRINTST21_MASK 0x200000
#define LPC_USB_SYSERRINTST_EPERRINTST21 0x200000
#define LPC_USB_SYSERRINTST_EPERRINTST21_BIT 21
#define LPC_USB_SYSERRINTST_EPERRINTST22_MASK 0x400000
#define LPC_USB_SYSERRINTST_EPERRINTST22 0x400000
#define LPC_USB_SYSERRINTST_EPERRINTST22_BIT 22
#define LPC_USB_SYSERRINTST_EPERRINTST23_MASK 0x800000
#define LPC_USB_SYSERRINTST_EPERRINTST23 0x800000
#define LPC_USB_SYSERRINTST_EPERRINTST23_BIT 23
#define LPC_USB_SYSERRINTST_EPERRINTST24_MASK 0x1000000
#define LPC_USB_SYSERRINTST_EPERRINTST24 0x1000000
#define LPC_USB_SYSERRINTST_EPERRINTST24_BIT 24
#define LPC_USB_SYSERRINTST_EPERRINTST25_MASK 0x2000000
#define LPC_USB_SYSERRINTST_EPERRINTST25 0x2000000
#define LPC_USB_SYSERRINTST_EPERRINTST25_BIT 25
#define LPC_USB_SYSERRINTST_EPERRINTST26_MASK 0x4000000
#define LPC_USB_SYSERRINTST_EPERRINTST26 0x4000000
#define LPC_USB_SYSERRINTST_EPERRINTST26_BIT 26
#define LPC_USB_SYSERRINTST_EPERRINTST27_MASK 0x8000000
#define LPC_USB_SYSERRINTST_EPERRINTST27 0x8000000
#define LPC_USB_SYSERRINTST_EPERRINTST27_BIT 27
#define LPC_USB_SYSERRINTST_EPERRINTST28_MASK 0x10000000
#define LPC_USB_SYSERRINTST_EPERRINTST28 0x10000000
#define LPC_USB_SYSERRINTST_EPERRINTST28_BIT 28
#define LPC_USB_SYSERRINTST_EPERRINTST29_MASK 0x20000000
#define LPC_USB_SYSERRINTST_EPERRINTST29 0x20000000
#define LPC_USB_SYSERRINTST_EPERRINTST29_BIT 29
#define LPC_USB_SYSERRINTST_EPERRINTST30_MASK 0x40000000
#define LPC_USB_SYSERRINTST_EPERRINTST30 0x40000000
#define LPC_USB_SYSERRINTST_EPERRINTST30_BIT 30
#define LPC_USB_SYSERRINTST_EPERRINTST31_MASK 0x80000000
#define LPC_USB_SYSERRINTST_EPERRINTST31 0x80000000
#define LPC_USB_SYSERRINTST_EPERRINTST31_BIT 31

#define LPC_USB_SYSERRINTCLR (*(volatile unsigned long *)0x2008C2BC)
#define LPC_USB_SYSERRINTCLR_OFFSET 0x2BC
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR0_MASK 0x1
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR0 0x1
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR0_BIT 0
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR1_MASK 0x2
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR1 0x2
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR1_BIT 1
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR2_MASK 0x4
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR2 0x4
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR2_BIT 2
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR3_MASK 0x8
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR3 0x8
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR3_BIT 3
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR4_MASK 0x10
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR4 0x10
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR4_BIT 4
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR5_MASK 0x20
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR5 0x20
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR5_BIT 5
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR6_MASK 0x40
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR6 0x40
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR6_BIT 6
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR7_MASK 0x80
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR7 0x80
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR7_BIT 7
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR8_MASK 0x100
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR8 0x100
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR8_BIT 8
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR9_MASK 0x200
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR9 0x200
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR9_BIT 9
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR10_MASK 0x400
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR10 0x400
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR10_BIT 10
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR11_MASK 0x800
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR11 0x800
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR11_BIT 11
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR12_MASK 0x1000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR12 0x1000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR12_BIT 12
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR13_MASK 0x2000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR13 0x2000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR13_BIT 13
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR14_MASK 0x4000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR14 0x4000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR14_BIT 14
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR15_MASK 0x8000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR15 0x8000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR15_BIT 15
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR16_MASK 0x10000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR16 0x10000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR16_BIT 16
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR17_MASK 0x20000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR17 0x20000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR17_BIT 17
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR18_MASK 0x40000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR18 0x40000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR18_BIT 18
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR19_MASK 0x80000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR19 0x80000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR19_BIT 19
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR20_MASK 0x100000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR20 0x100000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR20_BIT 20
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR21_MASK 0x200000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR21 0x200000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR21_BIT 21
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR22_MASK 0x400000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR22 0x400000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR22_BIT 22
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR23_MASK 0x800000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR23 0x800000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR23_BIT 23
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR24_MASK 0x1000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR24 0x1000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR24_BIT 24
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR25_MASK 0x2000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR25 0x2000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR25_BIT 25
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR26_MASK 0x4000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR26 0x4000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR26_BIT 26
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR27_MASK 0x8000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR27 0x8000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR27_BIT 27
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR28_MASK 0x10000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR28 0x10000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR28_BIT 28
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR29_MASK 0x20000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR29 0x20000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR29_BIT 29
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR30_MASK 0x40000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR30 0x40000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR30_BIT 30
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR31_MASK 0x80000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR31 0x80000000
#define LPC_USB_SYSERRINTCLR_EPERRINTCLR31_BIT 31

#define LPC_USB_SYSERRINTSET (*(volatile unsigned long *)0x2008C2C0)
#define LPC_USB_SYSERRINTSET_OFFSET 0x2C0
#define LPC_USB_SYSERRINTSET_EPERRINTSET0_MASK 0x1
#define LPC_USB_SYSERRINTSET_EPERRINTSET0 0x1
#define LPC_USB_SYSERRINTSET_EPERRINTSET0_BIT 0
#define LPC_USB_SYSERRINTSET_EPERRINTSET1_MASK 0x2
#define LPC_USB_SYSERRINTSET_EPERRINTSET1 0x2
#define LPC_USB_SYSERRINTSET_EPERRINTSET1_BIT 1
#define LPC_USB_SYSERRINTSET_EPERRINTSET2_MASK 0x4
#define LPC_USB_SYSERRINTSET_EPERRINTSET2 0x4
#define LPC_USB_SYSERRINTSET_EPERRINTSET2_BIT 2
#define LPC_USB_SYSERRINTSET_EPERRINTSET3_MASK 0x8
#define LPC_USB_SYSERRINTSET_EPERRINTSET3 0x8
#define LPC_USB_SYSERRINTSET_EPERRINTSET3_BIT 3
#define LPC_USB_SYSERRINTSET_EPERRINTSET4_MASK 0x10
#define LPC_USB_SYSERRINTSET_EPERRINTSET4 0x10
#define LPC_USB_SYSERRINTSET_EPERRINTSET4_BIT 4
#define LPC_USB_SYSERRINTSET_EPERRINTSET5_MASK 0x20
#define LPC_USB_SYSERRINTSET_EPERRINTSET5 0x20
#define LPC_USB_SYSERRINTSET_EPERRINTSET5_BIT 5
#define LPC_USB_SYSERRINTSET_EPERRINTSET6_MASK 0x40
#define LPC_USB_SYSERRINTSET_EPERRINTSET6 0x40
#define LPC_USB_SYSERRINTSET_EPERRINTSET6_BIT 6
#define LPC_USB_SYSERRINTSET_EPERRINTSET7_MASK 0x80
#define LPC_USB_SYSERRINTSET_EPERRINTSET7 0x80
#define LPC_USB_SYSERRINTSET_EPERRINTSET7_BIT 7
#define LPC_USB_SYSERRINTSET_EPERRINTSET8_MASK 0x100
#define LPC_USB_SYSERRINTSET_EPERRINTSET8 0x100
#define LPC_USB_SYSERRINTSET_EPERRINTSET8_BIT 8
#define LPC_USB_SYSERRINTSET_EPERRINTSET9_MASK 0x200
#define LPC_USB_SYSERRINTSET_EPERRINTSET9 0x200
#define LPC_USB_SYSERRINTSET_EPERRINTSET9_BIT 9
#define LPC_USB_SYSERRINTSET_EPERRINTSET10_MASK 0x400
#define LPC_USB_SYSERRINTSET_EPERRINTSET10 0x400
#define LPC_USB_SYSERRINTSET_EPERRINTSET10_BIT 10
#define LPC_USB_SYSERRINTSET_EPERRINTSET11_MASK 0x800
#define LPC_USB_SYSERRINTSET_EPERRINTSET11 0x800
#define LPC_USB_SYSERRINTSET_EPERRINTSET11_BIT 11
#define LPC_USB_SYSERRINTSET_EPERRINTSET12_MASK 0x1000
#define LPC_USB_SYSERRINTSET_EPERRINTSET12 0x1000
#define LPC_USB_SYSERRINTSET_EPERRINTSET12_BIT 12
#define LPC_USB_SYSERRINTSET_EPERRINTSET13_MASK 0x2000
#define LPC_USB_SYSERRINTSET_EPERRINTSET13 0x2000
#define LPC_USB_SYSERRINTSET_EPERRINTSET13_BIT 13
#define LPC_USB_SYSERRINTSET_EPERRINTSET14_MASK 0x4000
#define LPC_USB_SYSERRINTSET_EPERRINTSET14 0x4000
#define LPC_USB_SYSERRINTSET_EPERRINTSET14_BIT 14
#define LPC_USB_SYSERRINTSET_EPERRINTSET15_MASK 0x8000
#define LPC_USB_SYSERRINTSET_EPERRINTSET15 0x8000
#define LPC_USB_SYSERRINTSET_EPERRINTSET15_BIT 15
#define LPC_USB_SYSERRINTSET_EPERRINTSET16_MASK 0x10000
#define LPC_USB_SYSERRINTSET_EPERRINTSET16 0x10000
#define LPC_USB_SYSERRINTSET_EPERRINTSET16_BIT 16
#define LPC_USB_SYSERRINTSET_EPERRINTSET17_MASK 0x20000
#define LPC_USB_SYSERRINTSET_EPERRINTSET17 0x20000
#define LPC_USB_SYSERRINTSET_EPERRINTSET17_BIT 17
#define LPC_USB_SYSERRINTSET_EPERRINTSET18_MASK 0x40000
#define LPC_USB_SYSERRINTSET_EPERRINTSET18 0x40000
#define LPC_USB_SYSERRINTSET_EPERRINTSET18_BIT 18
#define LPC_USB_SYSERRINTSET_EPERRINTSET19_MASK 0x80000
#define LPC_USB_SYSERRINTSET_EPERRINTSET19 0x80000
#define LPC_USB_SYSERRINTSET_EPERRINTSET19_BIT 19
#define LPC_USB_SYSERRINTSET_EPERRINTSET20_MASK 0x100000
#define LPC_USB_SYSERRINTSET_EPERRINTSET20 0x100000
#define LPC_USB_SYSERRINTSET_EPERRINTSET20_BIT 20
#define LPC_USB_SYSERRINTSET_EPERRINTSET21_MASK 0x200000
#define LPC_USB_SYSERRINTSET_EPERRINTSET21 0x200000
#define LPC_USB_SYSERRINTSET_EPERRINTSET21_BIT 21
#define LPC_USB_SYSERRINTSET_EPERRINTSET22_MASK 0x400000
#define LPC_USB_SYSERRINTSET_EPERRINTSET22 0x400000
#define LPC_USB_SYSERRINTSET_EPERRINTSET22_BIT 22
#define LPC_USB_SYSERRINTSET_EPERRINTSET23_MASK 0x800000
#define LPC_USB_SYSERRINTSET_EPERRINTSET23 0x800000
#define LPC_USB_SYSERRINTSET_EPERRINTSET23_BIT 23
#define LPC_USB_SYSERRINTSET_EPERRINTSET24_MASK 0x1000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET24 0x1000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET24_BIT 24
#define LPC_USB_SYSERRINTSET_EPERRINTSET25_MASK 0x2000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET25 0x2000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET25_BIT 25
#define LPC_USB_SYSERRINTSET_EPERRINTSET26_MASK 0x4000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET26 0x4000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET26_BIT 26
#define LPC_USB_SYSERRINTSET_EPERRINTSET27_MASK 0x8000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET27 0x8000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET27_BIT 27
#define LPC_USB_SYSERRINTSET_EPERRINTSET28_MASK 0x10000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET28 0x10000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET28_BIT 28
#define LPC_USB_SYSERRINTSET_EPERRINTSET29_MASK 0x20000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET29 0x20000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET29_BIT 29
#define LPC_USB_SYSERRINTSET_EPERRINTSET30_MASK 0x40000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET30 0x40000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET30_BIT 30
#define LPC_USB_SYSERRINTSET_EPERRINTSET31_MASK 0x80000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET31 0x80000000
#define LPC_USB_SYSERRINTSET_EPERRINTSET31_BIT 31

#define LPC_USB_I2C_RX (*(volatile unsigned long *)0x2008C300)
#define LPC_USB_I2C_RX_OFFSET 0x300
#define LPC_USB_I2C_RX_RX_DATA_MASK 0xFF
#define LPC_USB_I2C_RX_RX_DATA_BIT 0

#define LPC_USB_I2C_TX (*(volatile unsigned long *)0x2008C300)
#define LPC_USB_I2C_TX_OFFSET 0x300
#define LPC_USB_I2C_TX_TXDATA_MASK 0xFF
#define LPC_USB_I2C_TX_TXDATA_BIT 0
#define LPC_USB_I2C_TX_START_MASK 0x100
#define LPC_USB_I2C_TX_START 0x100
#define LPC_USB_I2C_TX_START_BIT 8
#define LPC_USB_I2C_TX_STOP_MASK 0x200
#define LPC_USB_I2C_TX_STOP 0x200
#define LPC_USB_I2C_TX_STOP_BIT 9

#define LPC_USB_I2C_STS (*(volatile unsigned long *)0x2008C304)
#define LPC_USB_I2C_STS_OFFSET 0x304
#define LPC_USB_I2C_STS_TDI_MASK 0x1
#define LPC_USB_I2C_STS_TDI 0x1
#define LPC_USB_I2C_STS_TDI_BIT 0
#define LPC_USB_I2C_STS_AFI_MASK 0x2
#define LPC_USB_I2C_STS_AFI 0x2
#define LPC_USB_I2C_STS_AFI_BIT 1
#define LPC_USB_I2C_STS_NAI_MASK 0x4
#define LPC_USB_I2C_STS_NAI 0x4
#define LPC_USB_I2C_STS_NAI_BIT 2
#define LPC_USB_I2C_STS_DRMI_MASK 0x8
#define LPC_USB_I2C_STS_DRMI 0x8
#define LPC_USB_I2C_STS_DRMI_BIT 3
#define LPC_USB_I2C_STS_DRSI_MASK 0x10
#define LPC_USB_I2C_STS_DRSI 0x10
#define LPC_USB_I2C_STS_DRSI_BIT 4
#define LPC_USB_I2C_STS_Active_MASK 0x20
#define LPC_USB_I2C_STS_Active 0x20
#define LPC_USB_I2C_STS_Active_BIT 5
#define LPC_USB_I2C_STS_SCL_MASK 0x40
#define LPC_USB_I2C_STS_SCL 0x40
#define LPC_USB_I2C_STS_SCL_BIT 6
#define LPC_USB_I2C_STS_SDA_MASK 0x80
#define LPC_USB_I2C_STS_SDA 0x80
#define LPC_USB_I2C_STS_SDA_BIT 7
#define LPC_USB_I2C_STS_RFF_MASK 0x100
#define LPC_USB_I2C_STS_RFF 0x100
#define LPC_USB_I2C_STS_RFF_BIT 8
#define LPC_USB_I2C_STS_RFE_MASK 0x200
#define LPC_USB_I2C_STS_RFE 0x200
#define LPC_USB_I2C_STS_RFE_BIT 9
#define LPC_USB_I2C_STS_TFF_MASK 0x400
#define LPC_USB_I2C_STS_TFF 0x400
#define LPC_USB_I2C_STS_TFF_BIT 10
#define LPC_USB_I2C_STS_TFE_MASK 0x800
#define LPC_USB_I2C_STS_TFE 0x800
#define LPC_USB_I2C_STS_TFE_BIT 11

#define LPC_USB_I2C_CTL (*(volatile unsigned long *)0x2008C308)
#define LPC_USB_I2C_CTL_OFFSET 0x308
#define LPC_USB_I2C_CTL_TDIE_MASK 0x1
#define LPC_USB_I2C_CTL_TDIE 0x1
#define LPC_USB_I2C_CTL_TDIE_BIT 0
#define LPC_USB_I2C_CTL_AFIE_MASK 0x2
#define LPC_USB_I2C_CTL_AFIE 0x2
#define LPC_USB_I2C_CTL_AFIE_BIT 1
#define LPC_USB_I2C_CTL_NAIE_MASK 0x4
#define LPC_USB_I2C_CTL_NAIE 0x4
#define LPC_USB_I2C_CTL_NAIE_BIT 2
#define LPC_USB_I2C_CTL_DRMIE_MASK 0x8
#define LPC_USB_I2C_CTL_DRMIE 0x8
#define LPC_USB_I2C_CTL_DRMIE_BIT 3
#define LPC_USB_I2C_CTL_DRSIE_MASK 0x10
#define LPC_USB_I2C_CTL_DRSIE 0x10
#define LPC_USB_I2C_CTL_DRSIE_BIT 4
#define LPC_USB_I2C_CTL_REFIE_MASK 0x20
#define LPC_USB_I2C_CTL_REFIE 0x20
#define LPC_USB_I2C_CTL_REFIE_BIT 5
#define LPC_USB_I2C_CTL_RFDAIE_MASK 0x40
#define LPC_USB_I2C_CTL_RFDAIE 0x40
#define LPC_USB_I2C_CTL_RFDAIE_BIT 6
#define LPC_USB_I2C_CTL_TFFIE_MASK 0x80
#define LPC_USB_I2C_CTL_TFFIE 0x80
#define LPC_USB_I2C_CTL_TFFIE_BIT 7
#define LPC_USB_I2C_CTL_SRST_MASK 0x100
#define LPC_USB_I2C_CTL_SRST 0x100
#define LPC_USB_I2C_CTL_SRST_BIT 8

#define LPC_USB_I2C_CLKHI (*(volatile unsigned long *)0x2008C30C)
#define LPC_USB_I2C_CLKHI_OFFSET 0x30C
#define LPC_USB_I2C_CLKHI_CDHI_MASK 0xFF
#define LPC_USB_I2C_CLKHI_CDHI_BIT 0

#define LPC_USB_I2C_CLKLO (*(volatile unsigned long *)0x2008C310)
#define LPC_USB_I2C_CLKLO_OFFSET 0x310
#define LPC_USB_I2C_CLKLO_CDLO_MASK 0xFF
#define LPC_USB_I2C_CLKLO_CDLO_BIT 0

#define LPC_USB_CLKCTRL (*(volatile unsigned long *)0x2008CFF4)
#define LPC_USB_CLKCTRL_OFFSET 0xFF4
#define LPC_USB_CLKCTRL_HOST_CLK_EN_MASK 0x1
#define LPC_USB_CLKCTRL_HOST_CLK_EN 0x1
#define LPC_USB_CLKCTRL_HOST_CLK_EN_BIT 0
#define LPC_USB_CLKCTRL_DEV_CLK_EN_MASK 0x2
#define LPC_USB_CLKCTRL_DEV_CLK_EN 0x2
#define LPC_USB_CLKCTRL_DEV_CLK_EN_BIT 1
#define LPC_USB_CLKCTRL_I2C_CLK_EN_MASK 0x4
#define LPC_USB_CLKCTRL_I2C_CLK_EN 0x4
#define LPC_USB_CLKCTRL_I2C_CLK_EN_BIT 2
#define LPC_USB_CLKCTRL_OTG_CLK_EN_MASK 0x8
#define LPC_USB_CLKCTRL_OTG_CLK_EN 0x8
#define LPC_USB_CLKCTRL_OTG_CLK_EN_BIT 3
#define LPC_USB_CLKCTRL_AHB_CLK_EN_MASK 0x10
#define LPC_USB_CLKCTRL_AHB_CLK_EN 0x10
#define LPC_USB_CLKCTRL_AHB_CLK_EN_BIT 4

#define LPC_USB_OTGClkSt (*(volatile unsigned long *)0x2008CFF8)
#define LPC_USB_OTGClkSt_OFFSET 0xFF8
#define LPC_USB_OTGClkSt_HOST_CLK_ON_MASK 0x1
#define LPC_USB_OTGClkSt_HOST_CLK_ON 0x1
#define LPC_USB_OTGClkSt_HOST_CLK_ON_BIT 0
#define LPC_USB_OTGClkSt_DEV_CLK_ON_MASK 0x2
#define LPC_USB_OTGClkSt_DEV_CLK_ON 0x2
#define LPC_USB_OTGClkSt_DEV_CLK_ON_BIT 1
#define LPC_USB_OTGClkSt_I2C_CLK_ON_MASK 0x4
#define LPC_USB_OTGClkSt_I2C_CLK_ON 0x4
#define LPC_USB_OTGClkSt_I2C_CLK_ON_BIT 2
#define LPC_USB_OTGClkSt_OTG_CLK_ON_MASK 0x8
#define LPC_USB_OTGClkSt_OTG_CLK_ON 0x8
#define LPC_USB_OTGClkSt_OTG_CLK_ON_BIT 3
#define LPC_USB_OTGClkSt_AHB_CLK_ON_MASK 0x10
#define LPC_USB_OTGClkSt_AHB_CLK_ON 0x10
#define LPC_USB_OTGClkSt_AHB_CLK_ON_BIT 4

#ifndef LPC_CRC_BASE_ADDRESS
#define LPC_CRC_BASE_ADDRESS 0x20090000
#endif

#define LPC_CRC_MODE (*(volatile unsigned long *)0x20090000)
#define LPC_CRC_MODE_OFFSET 0x0
#define LPC_CRC_MODE_CRC_POLY_MASK 0x3
#define LPC_CRC_MODE_CRC_POLY_BIT 0
#define LPC_CRC_MODE_BIT_RVS_WR_MASK 0x4
#define LPC_CRC_MODE_BIT_RVS_WR 0x4
#define LPC_CRC_MODE_BIT_RVS_WR_BIT 2
#define LPC_CRC_MODE_CMPL_WR_MASK 0x8
#define LPC_CRC_MODE_CMPL_WR 0x8
#define LPC_CRC_MODE_CMPL_WR_BIT 3
#define LPC_CRC_MODE_BIT_RVS_SUM_MASK 0x10
#define LPC_CRC_MODE_BIT_RVS_SUM 0x10
#define LPC_CRC_MODE_BIT_RVS_SUM_BIT 4
#define LPC_CRC_MODE_CMPL_SUM_MASK 0x20
#define LPC_CRC_MODE_CMPL_SUM 0x20
#define LPC_CRC_MODE_CMPL_SUM_BIT 5
#define LPC_CRC_MODE_Reserved_MASK 0xFFFFFFC0
#define LPC_CRC_MODE_Reserved_BIT 6

#define LPC_CRC_SEED (*(volatile unsigned long *)0x20090004)
#define LPC_CRC_SEED_OFFSET 0x4
#define LPC_CRC_SEED_CRC_SEED_MASK 0xFFFFFFFF
#define LPC_CRC_SEED_CRC_SEED_BIT 0

#define LPC_CRC_SUM (*(volatile unsigned long *)0x20090008)
#define LPC_CRC_SUM_OFFSET 0x8
#define LPC_CRC_SUM_CRC_SUM_MASK 0xFFFFFFFF
#define LPC_CRC_SUM_CRC_SUM_BIT 0

#define LPC_CRC_DATA (*(volatile unsigned long *)0x20090008)
#define LPC_CRC_DATA_OFFSET 0x8
#define LPC_CRC_DATA_CRC_WR_DATA_MASK 0xFFFFFFFF
#define LPC_CRC_DATA_CRC_WR_DATA_BIT 0

#ifndef LPC_GPIO_BASE_ADDRESS
#define LPC_GPIO_BASE_ADDRESS 0x20098000
#endif

#define LPC_GPIO_DIR0 (*(volatile unsigned long *)0x20098000)
#define LPC_GPIO_DIR0_OFFSET 0x0
#define LPC_GPIO_DIR0_PDIR0_MASK 0x1
#define LPC_GPIO_DIR0_PDIR0 0x1
#define LPC_GPIO_DIR0_PDIR0_BIT 0
#define LPC_GPIO_DIR0_PDIR1_MASK 0x2
#define LPC_GPIO_DIR0_PDIR1 0x2
#define LPC_GPIO_DIR0_PDIR1_BIT 1
#define LPC_GPIO_DIR0_PDIR2_MASK 0x4
#define LPC_GPIO_DIR0_PDIR2 0x4
#define LPC_GPIO_DIR0_PDIR2_BIT 2
#define LPC_GPIO_DIR0_PDIR3_MASK 0x8
#define LPC_GPIO_DIR0_PDIR3 0x8
#define LPC_GPIO_DIR0_PDIR3_BIT 3
#define LPC_GPIO_DIR0_PDIR4_MASK 0x10
#define LPC_GPIO_DIR0_PDIR4 0x10
#define LPC_GPIO_DIR0_PDIR4_BIT 4
#define LPC_GPIO_DIR0_PDIR5_MASK 0x20
#define LPC_GPIO_DIR0_PDIR5 0x20
#define LPC_GPIO_DIR0_PDIR5_BIT 5
#define LPC_GPIO_DIR0_PDIR6_MASK 0x40
#define LPC_GPIO_DIR0_PDIR6 0x40
#define LPC_GPIO_DIR0_PDIR6_BIT 6
#define LPC_GPIO_DIR0_PDIR7_MASK 0x80
#define LPC_GPIO_DIR0_PDIR7 0x80
#define LPC_GPIO_DIR0_PDIR7_BIT 7
#define LPC_GPIO_DIR0_PDIR8_MASK 0x100
#define LPC_GPIO_DIR0_PDIR8 0x100
#define LPC_GPIO_DIR0_PDIR8_BIT 8
#define LPC_GPIO_DIR0_PDIR9_MASK 0x200
#define LPC_GPIO_DIR0_PDIR9 0x200
#define LPC_GPIO_DIR0_PDIR9_BIT 9
#define LPC_GPIO_DIR0_PDIR10_MASK 0x400
#define LPC_GPIO_DIR0_PDIR10 0x400
#define LPC_GPIO_DIR0_PDIR10_BIT 10
#define LPC_GPIO_DIR0_PDIR11_MASK 0x800
#define LPC_GPIO_DIR0_PDIR11 0x800
#define LPC_GPIO_DIR0_PDIR11_BIT 11
#define LPC_GPIO_DIR0_PDIR12_MASK 0x1000
#define LPC_GPIO_DIR0_PDIR12 0x1000
#define LPC_GPIO_DIR0_PDIR12_BIT 12
#define LPC_GPIO_DIR0_PDIR13_MASK 0x2000
#define LPC_GPIO_DIR0_PDIR13 0x2000
#define LPC_GPIO_DIR0_PDIR13_BIT 13
#define LPC_GPIO_DIR0_PDIR14_MASK 0x4000
#define LPC_GPIO_DIR0_PDIR14 0x4000
#define LPC_GPIO_DIR0_PDIR14_BIT 14
#define LPC_GPIO_DIR0_PDIR15_MASK 0x8000
#define LPC_GPIO_DIR0_PDIR15 0x8000
#define LPC_GPIO_DIR0_PDIR15_BIT 15
#define LPC_GPIO_DIR0_PDIR16_MASK 0x10000
#define LPC_GPIO_DIR0_PDIR16 0x10000
#define LPC_GPIO_DIR0_PDIR16_BIT 16
#define LPC_GPIO_DIR0_PDIR17_MASK 0x20000
#define LPC_GPIO_DIR0_PDIR17 0x20000
#define LPC_GPIO_DIR0_PDIR17_BIT 17
#define LPC_GPIO_DIR0_PDIR18_MASK 0x40000
#define LPC_GPIO_DIR0_PDIR18 0x40000
#define LPC_GPIO_DIR0_PDIR18_BIT 18
#define LPC_GPIO_DIR0_PDIR19_MASK 0x80000
#define LPC_GPIO_DIR0_PDIR19 0x80000
#define LPC_GPIO_DIR0_PDIR19_BIT 19
#define LPC_GPIO_DIR0_PDIR20_MASK 0x100000
#define LPC_GPIO_DIR0_PDIR20 0x100000
#define LPC_GPIO_DIR0_PDIR20_BIT 20
#define LPC_GPIO_DIR0_PDIR21_MASK 0x200000
#define LPC_GPIO_DIR0_PDIR21 0x200000
#define LPC_GPIO_DIR0_PDIR21_BIT 21
#define LPC_GPIO_DIR0_PDIR22_MASK 0x400000
#define LPC_GPIO_DIR0_PDIR22 0x400000
#define LPC_GPIO_DIR0_PDIR22_BIT 22
#define LPC_GPIO_DIR0_PDIR23_MASK 0x800000
#define LPC_GPIO_DIR0_PDIR23 0x800000
#define LPC_GPIO_DIR0_PDIR23_BIT 23
#define LPC_GPIO_DIR0_PDIR24_MASK 0x1000000
#define LPC_GPIO_DIR0_PDIR24 0x1000000
#define LPC_GPIO_DIR0_PDIR24_BIT 24
#define LPC_GPIO_DIR0_PDIR25_MASK 0x2000000
#define LPC_GPIO_DIR0_PDIR25 0x2000000
#define LPC_GPIO_DIR0_PDIR25_BIT 25
#define LPC_GPIO_DIR0_PDIR26_MASK 0x4000000
#define LPC_GPIO_DIR0_PDIR26 0x4000000
#define LPC_GPIO_DIR0_PDIR26_BIT 26
#define LPC_GPIO_DIR0_PDIR27_MASK 0x8000000
#define LPC_GPIO_DIR0_PDIR27 0x8000000
#define LPC_GPIO_DIR0_PDIR27_BIT 27
#define LPC_GPIO_DIR0_PDIR28_MASK 0x10000000
#define LPC_GPIO_DIR0_PDIR28 0x10000000
#define LPC_GPIO_DIR0_PDIR28_BIT 28
#define LPC_GPIO_DIR0_PDIR29_MASK 0x20000000
#define LPC_GPIO_DIR0_PDIR29 0x20000000
#define LPC_GPIO_DIR0_PDIR29_BIT 29
#define LPC_GPIO_DIR0_PDIR30_MASK 0x40000000
#define LPC_GPIO_DIR0_PDIR30 0x40000000
#define LPC_GPIO_DIR0_PDIR30_BIT 30
#define LPC_GPIO_DIR0_PDIR31_MASK 0x80000000
#define LPC_GPIO_DIR0_PDIR31 0x80000000
#define LPC_GPIO_DIR0_PDIR31_BIT 31

#define LPC_GPIO_DIR1 (*(volatile unsigned long *)0x20098020)
#define LPC_GPIO_DIR1_OFFSET 0x20
#define LPC_GPIO_DIR1_PDIR0_MASK 0x1
#define LPC_GPIO_DIR1_PDIR0 0x1
#define LPC_GPIO_DIR1_PDIR0_BIT 0
#define LPC_GPIO_DIR1_PDIR1_MASK 0x2
#define LPC_GPIO_DIR1_PDIR1 0x2
#define LPC_GPIO_DIR1_PDIR1_BIT 1
#define LPC_GPIO_DIR1_PDIR2_MASK 0x4
#define LPC_GPIO_DIR1_PDIR2 0x4
#define LPC_GPIO_DIR1_PDIR2_BIT 2
#define LPC_GPIO_DIR1_PDIR3_MASK 0x8
#define LPC_GPIO_DIR1_PDIR3 0x8
#define LPC_GPIO_DIR1_PDIR3_BIT 3
#define LPC_GPIO_DIR1_PDIR4_MASK 0x10
#define LPC_GPIO_DIR1_PDIR4 0x10
#define LPC_GPIO_DIR1_PDIR4_BIT 4
#define LPC_GPIO_DIR1_PDIR5_MASK 0x20
#define LPC_GPIO_DIR1_PDIR5 0x20
#define LPC_GPIO_DIR1_PDIR5_BIT 5
#define LPC_GPIO_DIR1_PDIR6_MASK 0x40
#define LPC_GPIO_DIR1_PDIR6 0x40
#define LPC_GPIO_DIR1_PDIR6_BIT 6
#define LPC_GPIO_DIR1_PDIR7_MASK 0x80
#define LPC_GPIO_DIR1_PDIR7 0x80
#define LPC_GPIO_DIR1_PDIR7_BIT 7
#define LPC_GPIO_DIR1_PDIR8_MASK 0x100
#define LPC_GPIO_DIR1_PDIR8 0x100
#define LPC_GPIO_DIR1_PDIR8_BIT 8
#define LPC_GPIO_DIR1_PDIR9_MASK 0x200
#define LPC_GPIO_DIR1_PDIR9 0x200
#define LPC_GPIO_DIR1_PDIR9_BIT 9
#define LPC_GPIO_DIR1_PDIR10_MASK 0x400
#define LPC_GPIO_DIR1_PDIR10 0x400
#define LPC_GPIO_DIR1_PDIR10_BIT 10
#define LPC_GPIO_DIR1_PDIR11_MASK 0x800
#define LPC_GPIO_DIR1_PDIR11 0x800
#define LPC_GPIO_DIR1_PDIR11_BIT 11
#define LPC_GPIO_DIR1_PDIR12_MASK 0x1000
#define LPC_GPIO_DIR1_PDIR12 0x1000
#define LPC_GPIO_DIR1_PDIR12_BIT 12
#define LPC_GPIO_DIR1_PDIR13_MASK 0x2000
#define LPC_GPIO_DIR1_PDIR13 0x2000
#define LPC_GPIO_DIR1_PDIR13_BIT 13
#define LPC_GPIO_DIR1_PDIR14_MASK 0x4000
#define LPC_GPIO_DIR1_PDIR14 0x4000
#define LPC_GPIO_DIR1_PDIR14_BIT 14
#define LPC_GPIO_DIR1_PDIR15_MASK 0x8000
#define LPC_GPIO_DIR1_PDIR15 0x8000
#define LPC_GPIO_DIR1_PDIR15_BIT 15
#define LPC_GPIO_DIR1_PDIR16_MASK 0x10000
#define LPC_GPIO_DIR1_PDIR16 0x10000
#define LPC_GPIO_DIR1_PDIR16_BIT 16
#define LPC_GPIO_DIR1_PDIR17_MASK 0x20000
#define LPC_GPIO_DIR1_PDIR17 0x20000
#define LPC_GPIO_DIR1_PDIR17_BIT 17
#define LPC_GPIO_DIR1_PDIR18_MASK 0x40000
#define LPC_GPIO_DIR1_PDIR18 0x40000
#define LPC_GPIO_DIR1_PDIR18_BIT 18
#define LPC_GPIO_DIR1_PDIR19_MASK 0x80000
#define LPC_GPIO_DIR1_PDIR19 0x80000
#define LPC_GPIO_DIR1_PDIR19_BIT 19
#define LPC_GPIO_DIR1_PDIR20_MASK 0x100000
#define LPC_GPIO_DIR1_PDIR20 0x100000
#define LPC_GPIO_DIR1_PDIR20_BIT 20
#define LPC_GPIO_DIR1_PDIR21_MASK 0x200000
#define LPC_GPIO_DIR1_PDIR21 0x200000
#define LPC_GPIO_DIR1_PDIR21_BIT 21
#define LPC_GPIO_DIR1_PDIR22_MASK 0x400000
#define LPC_GPIO_DIR1_PDIR22 0x400000
#define LPC_GPIO_DIR1_PDIR22_BIT 22
#define LPC_GPIO_DIR1_PDIR23_MASK 0x800000
#define LPC_GPIO_DIR1_PDIR23 0x800000
#define LPC_GPIO_DIR1_PDIR23_BIT 23
#define LPC_GPIO_DIR1_PDIR24_MASK 0x1000000
#define LPC_GPIO_DIR1_PDIR24 0x1000000
#define LPC_GPIO_DIR1_PDIR24_BIT 24
#define LPC_GPIO_DIR1_PDIR25_MASK 0x2000000
#define LPC_GPIO_DIR1_PDIR25 0x2000000
#define LPC_GPIO_DIR1_PDIR25_BIT 25
#define LPC_GPIO_DIR1_PDIR26_MASK 0x4000000
#define LPC_GPIO_DIR1_PDIR26 0x4000000
#define LPC_GPIO_DIR1_PDIR26_BIT 26
#define LPC_GPIO_DIR1_PDIR27_MASK 0x8000000
#define LPC_GPIO_DIR1_PDIR27 0x8000000
#define LPC_GPIO_DIR1_PDIR27_BIT 27
#define LPC_GPIO_DIR1_PDIR28_MASK 0x10000000
#define LPC_GPIO_DIR1_PDIR28 0x10000000
#define LPC_GPIO_DIR1_PDIR28_BIT 28
#define LPC_GPIO_DIR1_PDIR29_MASK 0x20000000
#define LPC_GPIO_DIR1_PDIR29 0x20000000
#define LPC_GPIO_DIR1_PDIR29_BIT 29
#define LPC_GPIO_DIR1_PDIR30_MASK 0x40000000
#define LPC_GPIO_DIR1_PDIR30 0x40000000
#define LPC_GPIO_DIR1_PDIR30_BIT 30
#define LPC_GPIO_DIR1_PDIR31_MASK 0x80000000
#define LPC_GPIO_DIR1_PDIR31 0x80000000
#define LPC_GPIO_DIR1_PDIR31_BIT 31

#define LPC_GPIO_DIR2 (*(volatile unsigned long *)0x20098040)
#define LPC_GPIO_DIR2_OFFSET 0x40
#define LPC_GPIO_DIR2_PDIR0_MASK 0x1
#define LPC_GPIO_DIR2_PDIR0 0x1
#define LPC_GPIO_DIR2_PDIR0_BIT 0
#define LPC_GPIO_DIR2_PDIR1_MASK 0x2
#define LPC_GPIO_DIR2_PDIR1 0x2
#define LPC_GPIO_DIR2_PDIR1_BIT 1
#define LPC_GPIO_DIR2_PDIR2_MASK 0x4
#define LPC_GPIO_DIR2_PDIR2 0x4
#define LPC_GPIO_DIR2_PDIR2_BIT 2
#define LPC_GPIO_DIR2_PDIR3_MASK 0x8
#define LPC_GPIO_DIR2_PDIR3 0x8
#define LPC_GPIO_DIR2_PDIR3_BIT 3
#define LPC_GPIO_DIR2_PDIR4_MASK 0x10
#define LPC_GPIO_DIR2_PDIR4 0x10
#define LPC_GPIO_DIR2_PDIR4_BIT 4
#define LPC_GPIO_DIR2_PDIR5_MASK 0x20
#define LPC_GPIO_DIR2_PDIR5 0x20
#define LPC_GPIO_DIR2_PDIR5_BIT 5
#define LPC_GPIO_DIR2_PDIR6_MASK 0x40
#define LPC_GPIO_DIR2_PDIR6 0x40
#define LPC_GPIO_DIR2_PDIR6_BIT 6
#define LPC_GPIO_DIR2_PDIR7_MASK 0x80
#define LPC_GPIO_DIR2_PDIR7 0x80
#define LPC_GPIO_DIR2_PDIR7_BIT 7
#define LPC_GPIO_DIR2_PDIR8_MASK 0x100
#define LPC_GPIO_DIR2_PDIR8 0x100
#define LPC_GPIO_DIR2_PDIR8_BIT 8
#define LPC_GPIO_DIR2_PDIR9_MASK 0x200
#define LPC_GPIO_DIR2_PDIR9 0x200
#define LPC_GPIO_DIR2_PDIR9_BIT 9
#define LPC_GPIO_DIR2_PDIR10_MASK 0x400
#define LPC_GPIO_DIR2_PDIR10 0x400
#define LPC_GPIO_DIR2_PDIR10_BIT 10
#define LPC_GPIO_DIR2_PDIR11_MASK 0x800
#define LPC_GPIO_DIR2_PDIR11 0x800
#define LPC_GPIO_DIR2_PDIR11_BIT 11
#define LPC_GPIO_DIR2_PDIR12_MASK 0x1000
#define LPC_GPIO_DIR2_PDIR12 0x1000
#define LPC_GPIO_DIR2_PDIR12_BIT 12
#define LPC_GPIO_DIR2_PDIR13_MASK 0x2000
#define LPC_GPIO_DIR2_PDIR13 0x2000
#define LPC_GPIO_DIR2_PDIR13_BIT 13
#define LPC_GPIO_DIR2_PDIR14_MASK 0x4000
#define LPC_GPIO_DIR2_PDIR14 0x4000
#define LPC_GPIO_DIR2_PDIR14_BIT 14
#define LPC_GPIO_DIR2_PDIR15_MASK 0x8000
#define LPC_GPIO_DIR2_PDIR15 0x8000
#define LPC_GPIO_DIR2_PDIR15_BIT 15
#define LPC_GPIO_DIR2_PDIR16_MASK 0x10000
#define LPC_GPIO_DIR2_PDIR16 0x10000
#define LPC_GPIO_DIR2_PDIR16_BIT 16
#define LPC_GPIO_DIR2_PDIR17_MASK 0x20000
#define LPC_GPIO_DIR2_PDIR17 0x20000
#define LPC_GPIO_DIR2_PDIR17_BIT 17
#define LPC_GPIO_DIR2_PDIR18_MASK 0x40000
#define LPC_GPIO_DIR2_PDIR18 0x40000
#define LPC_GPIO_DIR2_PDIR18_BIT 18
#define LPC_GPIO_DIR2_PDIR19_MASK 0x80000
#define LPC_GPIO_DIR2_PDIR19 0x80000
#define LPC_GPIO_DIR2_PDIR19_BIT 19
#define LPC_GPIO_DIR2_PDIR20_MASK 0x100000
#define LPC_GPIO_DIR2_PDIR20 0x100000
#define LPC_GPIO_DIR2_PDIR20_BIT 20
#define LPC_GPIO_DIR2_PDIR21_MASK 0x200000
#define LPC_GPIO_DIR2_PDIR21 0x200000
#define LPC_GPIO_DIR2_PDIR21_BIT 21
#define LPC_GPIO_DIR2_PDIR22_MASK 0x400000
#define LPC_GPIO_DIR2_PDIR22 0x400000
#define LPC_GPIO_DIR2_PDIR22_BIT 22
#define LPC_GPIO_DIR2_PDIR23_MASK 0x800000
#define LPC_GPIO_DIR2_PDIR23 0x800000
#define LPC_GPIO_DIR2_PDIR23_BIT 23
#define LPC_GPIO_DIR2_PDIR24_MASK 0x1000000
#define LPC_GPIO_DIR2_PDIR24 0x1000000
#define LPC_GPIO_DIR2_PDIR24_BIT 24
#define LPC_GPIO_DIR2_PDIR25_MASK 0x2000000
#define LPC_GPIO_DIR2_PDIR25 0x2000000
#define LPC_GPIO_DIR2_PDIR25_BIT 25
#define LPC_GPIO_DIR2_PDIR26_MASK 0x4000000
#define LPC_GPIO_DIR2_PDIR26 0x4000000
#define LPC_GPIO_DIR2_PDIR26_BIT 26
#define LPC_GPIO_DIR2_PDIR27_MASK 0x8000000
#define LPC_GPIO_DIR2_PDIR27 0x8000000
#define LPC_GPIO_DIR2_PDIR27_BIT 27
#define LPC_GPIO_DIR2_PDIR28_MASK 0x10000000
#define LPC_GPIO_DIR2_PDIR28 0x10000000
#define LPC_GPIO_DIR2_PDIR28_BIT 28
#define LPC_GPIO_DIR2_PDIR29_MASK 0x20000000
#define LPC_GPIO_DIR2_PDIR29 0x20000000
#define LPC_GPIO_DIR2_PDIR29_BIT 29
#define LPC_GPIO_DIR2_PDIR30_MASK 0x40000000
#define LPC_GPIO_DIR2_PDIR30 0x40000000
#define LPC_GPIO_DIR2_PDIR30_BIT 30
#define LPC_GPIO_DIR2_PDIR31_MASK 0x80000000
#define LPC_GPIO_DIR2_PDIR31 0x80000000
#define LPC_GPIO_DIR2_PDIR31_BIT 31

#define LPC_GPIO_DIR3 (*(volatile unsigned long *)0x20098060)
#define LPC_GPIO_DIR3_OFFSET 0x60
#define LPC_GPIO_DIR3_PDIR0_MASK 0x1
#define LPC_GPIO_DIR3_PDIR0 0x1
#define LPC_GPIO_DIR3_PDIR0_BIT 0
#define LPC_GPIO_DIR3_PDIR1_MASK 0x2
#define LPC_GPIO_DIR3_PDIR1 0x2
#define LPC_GPIO_DIR3_PDIR1_BIT 1
#define LPC_GPIO_DIR3_PDIR2_MASK 0x4
#define LPC_GPIO_DIR3_PDIR2 0x4
#define LPC_GPIO_DIR3_PDIR2_BIT 2
#define LPC_GPIO_DIR3_PDIR3_MASK 0x8
#define LPC_GPIO_DIR3_PDIR3 0x8
#define LPC_GPIO_DIR3_PDIR3_BIT 3
#define LPC_GPIO_DIR3_PDIR4_MASK 0x10
#define LPC_GPIO_DIR3_PDIR4 0x10
#define LPC_GPIO_DIR3_PDIR4_BIT 4
#define LPC_GPIO_DIR3_PDIR5_MASK 0x20
#define LPC_GPIO_DIR3_PDIR5 0x20
#define LPC_GPIO_DIR3_PDIR5_BIT 5
#define LPC_GPIO_DIR3_PDIR6_MASK 0x40
#define LPC_GPIO_DIR3_PDIR6 0x40
#define LPC_GPIO_DIR3_PDIR6_BIT 6
#define LPC_GPIO_DIR3_PDIR7_MASK 0x80
#define LPC_GPIO_DIR3_PDIR7 0x80
#define LPC_GPIO_DIR3_PDIR7_BIT 7
#define LPC_GPIO_DIR3_PDIR8_MASK 0x100
#define LPC_GPIO_DIR3_PDIR8 0x100
#define LPC_GPIO_DIR3_PDIR8_BIT 8
#define LPC_GPIO_DIR3_PDIR9_MASK 0x200
#define LPC_GPIO_DIR3_PDIR9 0x200
#define LPC_GPIO_DIR3_PDIR9_BIT 9
#define LPC_GPIO_DIR3_PDIR10_MASK 0x400
#define LPC_GPIO_DIR3_PDIR10 0x400
#define LPC_GPIO_DIR3_PDIR10_BIT 10
#define LPC_GPIO_DIR3_PDIR11_MASK 0x800
#define LPC_GPIO_DIR3_PDIR11 0x800
#define LPC_GPIO_DIR3_PDIR11_BIT 11
#define LPC_GPIO_DIR3_PDIR12_MASK 0x1000
#define LPC_GPIO_DIR3_PDIR12 0x1000
#define LPC_GPIO_DIR3_PDIR12_BIT 12
#define LPC_GPIO_DIR3_PDIR13_MASK 0x2000
#define LPC_GPIO_DIR3_PDIR13 0x2000
#define LPC_GPIO_DIR3_PDIR13_BIT 13
#define LPC_GPIO_DIR3_PDIR14_MASK 0x4000
#define LPC_GPIO_DIR3_PDIR14 0x4000
#define LPC_GPIO_DIR3_PDIR14_BIT 14
#define LPC_GPIO_DIR3_PDIR15_MASK 0x8000
#define LPC_GPIO_DIR3_PDIR15 0x8000
#define LPC_GPIO_DIR3_PDIR15_BIT 15
#define LPC_GPIO_DIR3_PDIR16_MASK 0x10000
#define LPC_GPIO_DIR3_PDIR16 0x10000
#define LPC_GPIO_DIR3_PDIR16_BIT 16
#define LPC_GPIO_DIR3_PDIR17_MASK 0x20000
#define LPC_GPIO_DIR3_PDIR17 0x20000
#define LPC_GPIO_DIR3_PDIR17_BIT 17
#define LPC_GPIO_DIR3_PDIR18_MASK 0x40000
#define LPC_GPIO_DIR3_PDIR18 0x40000
#define LPC_GPIO_DIR3_PDIR18_BIT 18
#define LPC_GPIO_DIR3_PDIR19_MASK 0x80000
#define LPC_GPIO_DIR3_PDIR19 0x80000
#define LPC_GPIO_DIR3_PDIR19_BIT 19
#define LPC_GPIO_DIR3_PDIR20_MASK 0x100000
#define LPC_GPIO_DIR3_PDIR20 0x100000
#define LPC_GPIO_DIR3_PDIR20_BIT 20
#define LPC_GPIO_DIR3_PDIR21_MASK 0x200000
#define LPC_GPIO_DIR3_PDIR21 0x200000
#define LPC_GPIO_DIR3_PDIR21_BIT 21
#define LPC_GPIO_DIR3_PDIR22_MASK 0x400000
#define LPC_GPIO_DIR3_PDIR22 0x400000
#define LPC_GPIO_DIR3_PDIR22_BIT 22
#define LPC_GPIO_DIR3_PDIR23_MASK 0x800000
#define LPC_GPIO_DIR3_PDIR23 0x800000
#define LPC_GPIO_DIR3_PDIR23_BIT 23
#define LPC_GPIO_DIR3_PDIR24_MASK 0x1000000
#define LPC_GPIO_DIR3_PDIR24 0x1000000
#define LPC_GPIO_DIR3_PDIR24_BIT 24
#define LPC_GPIO_DIR3_PDIR25_MASK 0x2000000
#define LPC_GPIO_DIR3_PDIR25 0x2000000
#define LPC_GPIO_DIR3_PDIR25_BIT 25
#define LPC_GPIO_DIR3_PDIR26_MASK 0x4000000
#define LPC_GPIO_DIR3_PDIR26 0x4000000
#define LPC_GPIO_DIR3_PDIR26_BIT 26
#define LPC_GPIO_DIR3_PDIR27_MASK 0x8000000
#define LPC_GPIO_DIR3_PDIR27 0x8000000
#define LPC_GPIO_DIR3_PDIR27_BIT 27
#define LPC_GPIO_DIR3_PDIR28_MASK 0x10000000
#define LPC_GPIO_DIR3_PDIR28 0x10000000
#define LPC_GPIO_DIR3_PDIR28_BIT 28
#define LPC_GPIO_DIR3_PDIR29_MASK 0x20000000
#define LPC_GPIO_DIR3_PDIR29 0x20000000
#define LPC_GPIO_DIR3_PDIR29_BIT 29
#define LPC_GPIO_DIR3_PDIR30_MASK 0x40000000
#define LPC_GPIO_DIR3_PDIR30 0x40000000
#define LPC_GPIO_DIR3_PDIR30_BIT 30
#define LPC_GPIO_DIR3_PDIR31_MASK 0x80000000
#define LPC_GPIO_DIR3_PDIR31 0x80000000
#define LPC_GPIO_DIR3_PDIR31_BIT 31

#define LPC_GPIO_DIR4 (*(volatile unsigned long *)0x20098080)
#define LPC_GPIO_DIR4_OFFSET 0x80
#define LPC_GPIO_DIR4_PDIR0_MASK 0x1
#define LPC_GPIO_DIR4_PDIR0 0x1
#define LPC_GPIO_DIR4_PDIR0_BIT 0
#define LPC_GPIO_DIR4_PDIR1_MASK 0x2
#define LPC_GPIO_DIR4_PDIR1 0x2
#define LPC_GPIO_DIR4_PDIR1_BIT 1
#define LPC_GPIO_DIR4_PDIR2_MASK 0x4
#define LPC_GPIO_DIR4_PDIR2 0x4
#define LPC_GPIO_DIR4_PDIR2_BIT 2
#define LPC_GPIO_DIR4_PDIR3_MASK 0x8
#define LPC_GPIO_DIR4_PDIR3 0x8
#define LPC_GPIO_DIR4_PDIR3_BIT 3
#define LPC_GPIO_DIR4_PDIR4_MASK 0x10
#define LPC_GPIO_DIR4_PDIR4 0x10
#define LPC_GPIO_DIR4_PDIR4_BIT 4
#define LPC_GPIO_DIR4_PDIR5_MASK 0x20
#define LPC_GPIO_DIR4_PDIR5 0x20
#define LPC_GPIO_DIR4_PDIR5_BIT 5
#define LPC_GPIO_DIR4_PDIR6_MASK 0x40
#define LPC_GPIO_DIR4_PDIR6 0x40
#define LPC_GPIO_DIR4_PDIR6_BIT 6
#define LPC_GPIO_DIR4_PDIR7_MASK 0x80
#define LPC_GPIO_DIR4_PDIR7 0x80
#define LPC_GPIO_DIR4_PDIR7_BIT 7
#define LPC_GPIO_DIR4_PDIR8_MASK 0x100
#define LPC_GPIO_DIR4_PDIR8 0x100
#define LPC_GPIO_DIR4_PDIR8_BIT 8
#define LPC_GPIO_DIR4_PDIR9_MASK 0x200
#define LPC_GPIO_DIR4_PDIR9 0x200
#define LPC_GPIO_DIR4_PDIR9_BIT 9
#define LPC_GPIO_DIR4_PDIR10_MASK 0x400
#define LPC_GPIO_DIR4_PDIR10 0x400
#define LPC_GPIO_DIR4_PDIR10_BIT 10
#define LPC_GPIO_DIR4_PDIR11_MASK 0x800
#define LPC_GPIO_DIR4_PDIR11 0x800
#define LPC_GPIO_DIR4_PDIR11_BIT 11
#define LPC_GPIO_DIR4_PDIR12_MASK 0x1000
#define LPC_GPIO_DIR4_PDIR12 0x1000
#define LPC_GPIO_DIR4_PDIR12_BIT 12
#define LPC_GPIO_DIR4_PDIR13_MASK 0x2000
#define LPC_GPIO_DIR4_PDIR13 0x2000
#define LPC_GPIO_DIR4_PDIR13_BIT 13
#define LPC_GPIO_DIR4_PDIR14_MASK 0x4000
#define LPC_GPIO_DIR4_PDIR14 0x4000
#define LPC_GPIO_DIR4_PDIR14_BIT 14
#define LPC_GPIO_DIR4_PDIR15_MASK 0x8000
#define LPC_GPIO_DIR4_PDIR15 0x8000
#define LPC_GPIO_DIR4_PDIR15_BIT 15
#define LPC_GPIO_DIR4_PDIR16_MASK 0x10000
#define LPC_GPIO_DIR4_PDIR16 0x10000
#define LPC_GPIO_DIR4_PDIR16_BIT 16
#define LPC_GPIO_DIR4_PDIR17_MASK 0x20000
#define LPC_GPIO_DIR4_PDIR17 0x20000
#define LPC_GPIO_DIR4_PDIR17_BIT 17
#define LPC_GPIO_DIR4_PDIR18_MASK 0x40000
#define LPC_GPIO_DIR4_PDIR18 0x40000
#define LPC_GPIO_DIR4_PDIR18_BIT 18
#define LPC_GPIO_DIR4_PDIR19_MASK 0x80000
#define LPC_GPIO_DIR4_PDIR19 0x80000
#define LPC_GPIO_DIR4_PDIR19_BIT 19
#define LPC_GPIO_DIR4_PDIR20_MASK 0x100000
#define LPC_GPIO_DIR4_PDIR20 0x100000
#define LPC_GPIO_DIR4_PDIR20_BIT 20
#define LPC_GPIO_DIR4_PDIR21_MASK 0x200000
#define LPC_GPIO_DIR4_PDIR21 0x200000
#define LPC_GPIO_DIR4_PDIR21_BIT 21
#define LPC_GPIO_DIR4_PDIR22_MASK 0x400000
#define LPC_GPIO_DIR4_PDIR22 0x400000
#define LPC_GPIO_DIR4_PDIR22_BIT 22
#define LPC_GPIO_DIR4_PDIR23_MASK 0x800000
#define LPC_GPIO_DIR4_PDIR23 0x800000
#define LPC_GPIO_DIR4_PDIR23_BIT 23
#define LPC_GPIO_DIR4_PDIR24_MASK 0x1000000
#define LPC_GPIO_DIR4_PDIR24 0x1000000
#define LPC_GPIO_DIR4_PDIR24_BIT 24
#define LPC_GPIO_DIR4_PDIR25_MASK 0x2000000
#define LPC_GPIO_DIR4_PDIR25 0x2000000
#define LPC_GPIO_DIR4_PDIR25_BIT 25
#define LPC_GPIO_DIR4_PDIR26_MASK 0x4000000
#define LPC_GPIO_DIR4_PDIR26 0x4000000
#define LPC_GPIO_DIR4_PDIR26_BIT 26
#define LPC_GPIO_DIR4_PDIR27_MASK 0x8000000
#define LPC_GPIO_DIR4_PDIR27 0x8000000
#define LPC_GPIO_DIR4_PDIR27_BIT 27
#define LPC_GPIO_DIR4_PDIR28_MASK 0x10000000
#define LPC_GPIO_DIR4_PDIR28 0x10000000
#define LPC_GPIO_DIR4_PDIR28_BIT 28
#define LPC_GPIO_DIR4_PDIR29_MASK 0x20000000
#define LPC_GPIO_DIR4_PDIR29 0x20000000
#define LPC_GPIO_DIR4_PDIR29_BIT 29
#define LPC_GPIO_DIR4_PDIR30_MASK 0x40000000
#define LPC_GPIO_DIR4_PDIR30 0x40000000
#define LPC_GPIO_DIR4_PDIR30_BIT 30
#define LPC_GPIO_DIR4_PDIR31_MASK 0x80000000
#define LPC_GPIO_DIR4_PDIR31 0x80000000
#define LPC_GPIO_DIR4_PDIR31_BIT 31

#define LPC_GPIO_DIR5 (*(volatile unsigned long *)0x200980A0)
#define LPC_GPIO_DIR5_OFFSET 0xA0
#define LPC_GPIO_DIR5_PDIR0_MASK 0x1
#define LPC_GPIO_DIR5_PDIR0 0x1
#define LPC_GPIO_DIR5_PDIR0_BIT 0
#define LPC_GPIO_DIR5_PDIR1_MASK 0x2
#define LPC_GPIO_DIR5_PDIR1 0x2
#define LPC_GPIO_DIR5_PDIR1_BIT 1
#define LPC_GPIO_DIR5_PDIR2_MASK 0x4
#define LPC_GPIO_DIR5_PDIR2 0x4
#define LPC_GPIO_DIR5_PDIR2_BIT 2
#define LPC_GPIO_DIR5_PDIR3_MASK 0x8
#define LPC_GPIO_DIR5_PDIR3 0x8
#define LPC_GPIO_DIR5_PDIR3_BIT 3
#define LPC_GPIO_DIR5_PDIR4_MASK 0x10
#define LPC_GPIO_DIR5_PDIR4 0x10
#define LPC_GPIO_DIR5_PDIR4_BIT 4
#define LPC_GPIO_DIR5_PDIR5_MASK 0x20
#define LPC_GPIO_DIR5_PDIR5 0x20
#define LPC_GPIO_DIR5_PDIR5_BIT 5
#define LPC_GPIO_DIR5_PDIR6_MASK 0x40
#define LPC_GPIO_DIR5_PDIR6 0x40
#define LPC_GPIO_DIR5_PDIR6_BIT 6
#define LPC_GPIO_DIR5_PDIR7_MASK 0x80
#define LPC_GPIO_DIR5_PDIR7 0x80
#define LPC_GPIO_DIR5_PDIR7_BIT 7
#define LPC_GPIO_DIR5_PDIR8_MASK 0x100
#define LPC_GPIO_DIR5_PDIR8 0x100
#define LPC_GPIO_DIR5_PDIR8_BIT 8
#define LPC_GPIO_DIR5_PDIR9_MASK 0x200
#define LPC_GPIO_DIR5_PDIR9 0x200
#define LPC_GPIO_DIR5_PDIR9_BIT 9
#define LPC_GPIO_DIR5_PDIR10_MASK 0x400
#define LPC_GPIO_DIR5_PDIR10 0x400
#define LPC_GPIO_DIR5_PDIR10_BIT 10
#define LPC_GPIO_DIR5_PDIR11_MASK 0x800
#define LPC_GPIO_DIR5_PDIR11 0x800
#define LPC_GPIO_DIR5_PDIR11_BIT 11
#define LPC_GPIO_DIR5_PDIR12_MASK 0x1000
#define LPC_GPIO_DIR5_PDIR12 0x1000
#define LPC_GPIO_DIR5_PDIR12_BIT 12
#define LPC_GPIO_DIR5_PDIR13_MASK 0x2000
#define LPC_GPIO_DIR5_PDIR13 0x2000
#define LPC_GPIO_DIR5_PDIR13_BIT 13
#define LPC_GPIO_DIR5_PDIR14_MASK 0x4000
#define LPC_GPIO_DIR5_PDIR14 0x4000
#define LPC_GPIO_DIR5_PDIR14_BIT 14
#define LPC_GPIO_DIR5_PDIR15_MASK 0x8000
#define LPC_GPIO_DIR5_PDIR15 0x8000
#define LPC_GPIO_DIR5_PDIR15_BIT 15
#define LPC_GPIO_DIR5_PDIR16_MASK 0x10000
#define LPC_GPIO_DIR5_PDIR16 0x10000
#define LPC_GPIO_DIR5_PDIR16_BIT 16
#define LPC_GPIO_DIR5_PDIR17_MASK 0x20000
#define LPC_GPIO_DIR5_PDIR17 0x20000
#define LPC_GPIO_DIR5_PDIR17_BIT 17
#define LPC_GPIO_DIR5_PDIR18_MASK 0x40000
#define LPC_GPIO_DIR5_PDIR18 0x40000
#define LPC_GPIO_DIR5_PDIR18_BIT 18
#define LPC_GPIO_DIR5_PDIR19_MASK 0x80000
#define LPC_GPIO_DIR5_PDIR19 0x80000
#define LPC_GPIO_DIR5_PDIR19_BIT 19
#define LPC_GPIO_DIR5_PDIR20_MASK 0x100000
#define LPC_GPIO_DIR5_PDIR20 0x100000
#define LPC_GPIO_DIR5_PDIR20_BIT 20
#define LPC_GPIO_DIR5_PDIR21_MASK 0x200000
#define LPC_GPIO_DIR5_PDIR21 0x200000
#define LPC_GPIO_DIR5_PDIR21_BIT 21
#define LPC_GPIO_DIR5_PDIR22_MASK 0x400000
#define LPC_GPIO_DIR5_PDIR22 0x400000
#define LPC_GPIO_DIR5_PDIR22_BIT 22
#define LPC_GPIO_DIR5_PDIR23_MASK 0x800000
#define LPC_GPIO_DIR5_PDIR23 0x800000
#define LPC_GPIO_DIR5_PDIR23_BIT 23
#define LPC_GPIO_DIR5_PDIR24_MASK 0x1000000
#define LPC_GPIO_DIR5_PDIR24 0x1000000
#define LPC_GPIO_DIR5_PDIR24_BIT 24
#define LPC_GPIO_DIR5_PDIR25_MASK 0x2000000
#define LPC_GPIO_DIR5_PDIR25 0x2000000
#define LPC_GPIO_DIR5_PDIR25_BIT 25
#define LPC_GPIO_DIR5_PDIR26_MASK 0x4000000
#define LPC_GPIO_DIR5_PDIR26 0x4000000
#define LPC_GPIO_DIR5_PDIR26_BIT 26
#define LPC_GPIO_DIR5_PDIR27_MASK 0x8000000
#define LPC_GPIO_DIR5_PDIR27 0x8000000
#define LPC_GPIO_DIR5_PDIR27_BIT 27
#define LPC_GPIO_DIR5_PDIR28_MASK 0x10000000
#define LPC_GPIO_DIR5_PDIR28 0x10000000
#define LPC_GPIO_DIR5_PDIR28_BIT 28
#define LPC_GPIO_DIR5_PDIR29_MASK 0x20000000
#define LPC_GPIO_DIR5_PDIR29 0x20000000
#define LPC_GPIO_DIR5_PDIR29_BIT 29
#define LPC_GPIO_DIR5_PDIR30_MASK 0x40000000
#define LPC_GPIO_DIR5_PDIR30 0x40000000
#define LPC_GPIO_DIR5_PDIR30_BIT 30
#define LPC_GPIO_DIR5_PDIR31_MASK 0x80000000
#define LPC_GPIO_DIR5_PDIR31 0x80000000
#define LPC_GPIO_DIR5_PDIR31_BIT 31

#define LPC_GPIO_MASK0 (*(volatile unsigned long *)0x20098010)
#define LPC_GPIO_MASK0_OFFSET 0x10
#define LPC_GPIO_MASK0_PMASK0_MASK 0x1
#define LPC_GPIO_MASK0_PMASK0 0x1
#define LPC_GPIO_MASK0_PMASK0_BIT 0
#define LPC_GPIO_MASK0_PMASK1_MASK 0x2
#define LPC_GPIO_MASK0_PMASK1 0x2
#define LPC_GPIO_MASK0_PMASK1_BIT 1
#define LPC_GPIO_MASK0_PMASK2_MASK 0x4
#define LPC_GPIO_MASK0_PMASK2 0x4
#define LPC_GPIO_MASK0_PMASK2_BIT 2
#define LPC_GPIO_MASK0_PMASK3_MASK 0x8
#define LPC_GPIO_MASK0_PMASK3 0x8
#define LPC_GPIO_MASK0_PMASK3_BIT 3
#define LPC_GPIO_MASK0_PMASK4_MASK 0x10
#define LPC_GPIO_MASK0_PMASK4 0x10
#define LPC_GPIO_MASK0_PMASK4_BIT 4
#define LPC_GPIO_MASK0_PMASK5_MASK 0x20
#define LPC_GPIO_MASK0_PMASK5 0x20
#define LPC_GPIO_MASK0_PMASK5_BIT 5
#define LPC_GPIO_MASK0_PMASK6_MASK 0x40
#define LPC_GPIO_MASK0_PMASK6 0x40
#define LPC_GPIO_MASK0_PMASK6_BIT 6
#define LPC_GPIO_MASK0_PMASK7_MASK 0x80
#define LPC_GPIO_MASK0_PMASK7 0x80
#define LPC_GPIO_MASK0_PMASK7_BIT 7
#define LPC_GPIO_MASK0_PMASK8_MASK 0x100
#define LPC_GPIO_MASK0_PMASK8 0x100
#define LPC_GPIO_MASK0_PMASK8_BIT 8
#define LPC_GPIO_MASK0_PMASK9_MASK 0x200
#define LPC_GPIO_MASK0_PMASK9 0x200
#define LPC_GPIO_MASK0_PMASK9_BIT 9
#define LPC_GPIO_MASK0_PMASK10_MASK 0x400
#define LPC_GPIO_MASK0_PMASK10 0x400
#define LPC_GPIO_MASK0_PMASK10_BIT 10
#define LPC_GPIO_MASK0_PMASK11_MASK 0x800
#define LPC_GPIO_MASK0_PMASK11 0x800
#define LPC_GPIO_MASK0_PMASK11_BIT 11
#define LPC_GPIO_MASK0_PMASK12_MASK 0x1000
#define LPC_GPIO_MASK0_PMASK12 0x1000
#define LPC_GPIO_MASK0_PMASK12_BIT 12
#define LPC_GPIO_MASK0_PMASK13_MASK 0x2000
#define LPC_GPIO_MASK0_PMASK13 0x2000
#define LPC_GPIO_MASK0_PMASK13_BIT 13
#define LPC_GPIO_MASK0_PMASK14_MASK 0x4000
#define LPC_GPIO_MASK0_PMASK14 0x4000
#define LPC_GPIO_MASK0_PMASK14_BIT 14
#define LPC_GPIO_MASK0_PMASK15_MASK 0x8000
#define LPC_GPIO_MASK0_PMASK15 0x8000
#define LPC_GPIO_MASK0_PMASK15_BIT 15
#define LPC_GPIO_MASK0_PMASK16_MASK 0x10000
#define LPC_GPIO_MASK0_PMASK16 0x10000
#define LPC_GPIO_MASK0_PMASK16_BIT 16
#define LPC_GPIO_MASK0_PMASK17_MASK 0x20000
#define LPC_GPIO_MASK0_PMASK17 0x20000
#define LPC_GPIO_MASK0_PMASK17_BIT 17
#define LPC_GPIO_MASK0_PMASK18_MASK 0x40000
#define LPC_GPIO_MASK0_PMASK18 0x40000
#define LPC_GPIO_MASK0_PMASK18_BIT 18
#define LPC_GPIO_MASK0_PMASK19_MASK 0x80000
#define LPC_GPIO_MASK0_PMASK19 0x80000
#define LPC_GPIO_MASK0_PMASK19_BIT 19
#define LPC_GPIO_MASK0_PMASK20_MASK 0x100000
#define LPC_GPIO_MASK0_PMASK20 0x100000
#define LPC_GPIO_MASK0_PMASK20_BIT 20
#define LPC_GPIO_MASK0_PMASK21_MASK 0x200000
#define LPC_GPIO_MASK0_PMASK21 0x200000
#define LPC_GPIO_MASK0_PMASK21_BIT 21
#define LPC_GPIO_MASK0_PMASK22_MASK 0x400000
#define LPC_GPIO_MASK0_PMASK22 0x400000
#define LPC_GPIO_MASK0_PMASK22_BIT 22
#define LPC_GPIO_MASK0_PMASK23_MASK 0x800000
#define LPC_GPIO_MASK0_PMASK23 0x800000
#define LPC_GPIO_MASK0_PMASK23_BIT 23
#define LPC_GPIO_MASK0_PMASK24_MASK 0x1000000
#define LPC_GPIO_MASK0_PMASK24 0x1000000
#define LPC_GPIO_MASK0_PMASK24_BIT 24
#define LPC_GPIO_MASK0_PMASK25_MASK 0x2000000
#define LPC_GPIO_MASK0_PMASK25 0x2000000
#define LPC_GPIO_MASK0_PMASK25_BIT 25
#define LPC_GPIO_MASK0_PMASK26_MASK 0x4000000
#define LPC_GPIO_MASK0_PMASK26 0x4000000
#define LPC_GPIO_MASK0_PMASK26_BIT 26
#define LPC_GPIO_MASK0_PMASK27_MASK 0x8000000
#define LPC_GPIO_MASK0_PMASK27 0x8000000
#define LPC_GPIO_MASK0_PMASK27_BIT 27
#define LPC_GPIO_MASK0_PMASK28_MASK 0x10000000
#define LPC_GPIO_MASK0_PMASK28 0x10000000
#define LPC_GPIO_MASK0_PMASK28_BIT 28
#define LPC_GPIO_MASK0_PMASK29_MASK 0x20000000
#define LPC_GPIO_MASK0_PMASK29 0x20000000
#define LPC_GPIO_MASK0_PMASK29_BIT 29
#define LPC_GPIO_MASK0_PMASK30_MASK 0x40000000
#define LPC_GPIO_MASK0_PMASK30 0x40000000
#define LPC_GPIO_MASK0_PMASK30_BIT 30
#define LPC_GPIO_MASK0_PMASK31_MASK 0x80000000
#define LPC_GPIO_MASK0_PMASK31 0x80000000
#define LPC_GPIO_MASK0_PMASK31_BIT 31

#define LPC_GPIO_MASK1 (*(volatile unsigned long *)0x20098030)
#define LPC_GPIO_MASK1_OFFSET 0x30
#define LPC_GPIO_MASK1_PMASK0_MASK 0x1
#define LPC_GPIO_MASK1_PMASK0 0x1
#define LPC_GPIO_MASK1_PMASK0_BIT 0
#define LPC_GPIO_MASK1_PMASK1_MASK 0x2
#define LPC_GPIO_MASK1_PMASK1 0x2
#define LPC_GPIO_MASK1_PMASK1_BIT 1
#define LPC_GPIO_MASK1_PMASK2_MASK 0x4
#define LPC_GPIO_MASK1_PMASK2 0x4
#define LPC_GPIO_MASK1_PMASK2_BIT 2
#define LPC_GPIO_MASK1_PMASK3_MASK 0x8
#define LPC_GPIO_MASK1_PMASK3 0x8
#define LPC_GPIO_MASK1_PMASK3_BIT 3
#define LPC_GPIO_MASK1_PMASK4_MASK 0x10
#define LPC_GPIO_MASK1_PMASK4 0x10
#define LPC_GPIO_MASK1_PMASK4_BIT 4
#define LPC_GPIO_MASK1_PMASK5_MASK 0x20
#define LPC_GPIO_MASK1_PMASK5 0x20
#define LPC_GPIO_MASK1_PMASK5_BIT 5
#define LPC_GPIO_MASK1_PMASK6_MASK 0x40
#define LPC_GPIO_MASK1_PMASK6 0x40
#define LPC_GPIO_MASK1_PMASK6_BIT 6
#define LPC_GPIO_MASK1_PMASK7_MASK 0x80
#define LPC_GPIO_MASK1_PMASK7 0x80
#define LPC_GPIO_MASK1_PMASK7_BIT 7
#define LPC_GPIO_MASK1_PMASK8_MASK 0x100
#define LPC_GPIO_MASK1_PMASK8 0x100
#define LPC_GPIO_MASK1_PMASK8_BIT 8
#define LPC_GPIO_MASK1_PMASK9_MASK 0x200
#define LPC_GPIO_MASK1_PMASK9 0x200
#define LPC_GPIO_MASK1_PMASK9_BIT 9
#define LPC_GPIO_MASK1_PMASK10_MASK 0x400
#define LPC_GPIO_MASK1_PMASK10 0x400
#define LPC_GPIO_MASK1_PMASK10_BIT 10
#define LPC_GPIO_MASK1_PMASK11_MASK 0x800
#define LPC_GPIO_MASK1_PMASK11 0x800
#define LPC_GPIO_MASK1_PMASK11_BIT 11
#define LPC_GPIO_MASK1_PMASK12_MASK 0x1000
#define LPC_GPIO_MASK1_PMASK12 0x1000
#define LPC_GPIO_MASK1_PMASK12_BIT 12
#define LPC_GPIO_MASK1_PMASK13_MASK 0x2000
#define LPC_GPIO_MASK1_PMASK13 0x2000
#define LPC_GPIO_MASK1_PMASK13_BIT 13
#define LPC_GPIO_MASK1_PMASK14_MASK 0x4000
#define LPC_GPIO_MASK1_PMASK14 0x4000
#define LPC_GPIO_MASK1_PMASK14_BIT 14
#define LPC_GPIO_MASK1_PMASK15_MASK 0x8000
#define LPC_GPIO_MASK1_PMASK15 0x8000
#define LPC_GPIO_MASK1_PMASK15_BIT 15
#define LPC_GPIO_MASK1_PMASK16_MASK 0x10000
#define LPC_GPIO_MASK1_PMASK16 0x10000
#define LPC_GPIO_MASK1_PMASK16_BIT 16
#define LPC_GPIO_MASK1_PMASK17_MASK 0x20000
#define LPC_GPIO_MASK1_PMASK17 0x20000
#define LPC_GPIO_MASK1_PMASK17_BIT 17
#define LPC_GPIO_MASK1_PMASK18_MASK 0x40000
#define LPC_GPIO_MASK1_PMASK18 0x40000
#define LPC_GPIO_MASK1_PMASK18_BIT 18
#define LPC_GPIO_MASK1_PMASK19_MASK 0x80000
#define LPC_GPIO_MASK1_PMASK19 0x80000
#define LPC_GPIO_MASK1_PMASK19_BIT 19
#define LPC_GPIO_MASK1_PMASK20_MASK 0x100000
#define LPC_GPIO_MASK1_PMASK20 0x100000
#define LPC_GPIO_MASK1_PMASK20_BIT 20
#define LPC_GPIO_MASK1_PMASK21_MASK 0x200000
#define LPC_GPIO_MASK1_PMASK21 0x200000
#define LPC_GPIO_MASK1_PMASK21_BIT 21
#define LPC_GPIO_MASK1_PMASK22_MASK 0x400000
#define LPC_GPIO_MASK1_PMASK22 0x400000
#define LPC_GPIO_MASK1_PMASK22_BIT 22
#define LPC_GPIO_MASK1_PMASK23_MASK 0x800000
#define LPC_GPIO_MASK1_PMASK23 0x800000
#define LPC_GPIO_MASK1_PMASK23_BIT 23
#define LPC_GPIO_MASK1_PMASK24_MASK 0x1000000
#define LPC_GPIO_MASK1_PMASK24 0x1000000
#define LPC_GPIO_MASK1_PMASK24_BIT 24
#define LPC_GPIO_MASK1_PMASK25_MASK 0x2000000
#define LPC_GPIO_MASK1_PMASK25 0x2000000
#define LPC_GPIO_MASK1_PMASK25_BIT 25
#define LPC_GPIO_MASK1_PMASK26_MASK 0x4000000
#define LPC_GPIO_MASK1_PMASK26 0x4000000
#define LPC_GPIO_MASK1_PMASK26_BIT 26
#define LPC_GPIO_MASK1_PMASK27_MASK 0x8000000
#define LPC_GPIO_MASK1_PMASK27 0x8000000
#define LPC_GPIO_MASK1_PMASK27_BIT 27
#define LPC_GPIO_MASK1_PMASK28_MASK 0x10000000
#define LPC_GPIO_MASK1_PMASK28 0x10000000
#define LPC_GPIO_MASK1_PMASK28_BIT 28
#define LPC_GPIO_MASK1_PMASK29_MASK 0x20000000
#define LPC_GPIO_MASK1_PMASK29 0x20000000
#define LPC_GPIO_MASK1_PMASK29_BIT 29
#define LPC_GPIO_MASK1_PMASK30_MASK 0x40000000
#define LPC_GPIO_MASK1_PMASK30 0x40000000
#define LPC_GPIO_MASK1_PMASK30_BIT 30
#define LPC_GPIO_MASK1_PMASK31_MASK 0x80000000
#define LPC_GPIO_MASK1_PMASK31 0x80000000
#define LPC_GPIO_MASK1_PMASK31_BIT 31

#define LPC_GPIO_MASK2 (*(volatile unsigned long *)0x20098050)
#define LPC_GPIO_MASK2_OFFSET 0x50
#define LPC_GPIO_MASK2_PMASK0_MASK 0x1
#define LPC_GPIO_MASK2_PMASK0 0x1
#define LPC_GPIO_MASK2_PMASK0_BIT 0
#define LPC_GPIO_MASK2_PMASK1_MASK 0x2
#define LPC_GPIO_MASK2_PMASK1 0x2
#define LPC_GPIO_MASK2_PMASK1_BIT 1
#define LPC_GPIO_MASK2_PMASK2_MASK 0x4
#define LPC_GPIO_MASK2_PMASK2 0x4
#define LPC_GPIO_MASK2_PMASK2_BIT 2
#define LPC_GPIO_MASK2_PMASK3_MASK 0x8
#define LPC_GPIO_MASK2_PMASK3 0x8
#define LPC_GPIO_MASK2_PMASK3_BIT 3
#define LPC_GPIO_MASK2_PMASK4_MASK 0x10
#define LPC_GPIO_MASK2_PMASK4 0x10
#define LPC_GPIO_MASK2_PMASK4_BIT 4
#define LPC_GPIO_MASK2_PMASK5_MASK 0x20
#define LPC_GPIO_MASK2_PMASK5 0x20
#define LPC_GPIO_MASK2_PMASK5_BIT 5
#define LPC_GPIO_MASK2_PMASK6_MASK 0x40
#define LPC_GPIO_MASK2_PMASK6 0x40
#define LPC_GPIO_MASK2_PMASK6_BIT 6
#define LPC_GPIO_MASK2_PMASK7_MASK 0x80
#define LPC_GPIO_MASK2_PMASK7 0x80
#define LPC_GPIO_MASK2_PMASK7_BIT 7
#define LPC_GPIO_MASK2_PMASK8_MASK 0x100
#define LPC_GPIO_MASK2_PMASK8 0x100
#define LPC_GPIO_MASK2_PMASK8_BIT 8
#define LPC_GPIO_MASK2_PMASK9_MASK 0x200
#define LPC_GPIO_MASK2_PMASK9 0x200
#define LPC_GPIO_MASK2_PMASK9_BIT 9
#define LPC_GPIO_MASK2_PMASK10_MASK 0x400
#define LPC_GPIO_MASK2_PMASK10 0x400
#define LPC_GPIO_MASK2_PMASK10_BIT 10
#define LPC_GPIO_MASK2_PMASK11_MASK 0x800
#define LPC_GPIO_MASK2_PMASK11 0x800
#define LPC_GPIO_MASK2_PMASK11_BIT 11
#define LPC_GPIO_MASK2_PMASK12_MASK 0x1000
#define LPC_GPIO_MASK2_PMASK12 0x1000
#define LPC_GPIO_MASK2_PMASK12_BIT 12
#define LPC_GPIO_MASK2_PMASK13_MASK 0x2000
#define LPC_GPIO_MASK2_PMASK13 0x2000
#define LPC_GPIO_MASK2_PMASK13_BIT 13
#define LPC_GPIO_MASK2_PMASK14_MASK 0x4000
#define LPC_GPIO_MASK2_PMASK14 0x4000
#define LPC_GPIO_MASK2_PMASK14_BIT 14
#define LPC_GPIO_MASK2_PMASK15_MASK 0x8000
#define LPC_GPIO_MASK2_PMASK15 0x8000
#define LPC_GPIO_MASK2_PMASK15_BIT 15
#define LPC_GPIO_MASK2_PMASK16_MASK 0x10000
#define LPC_GPIO_MASK2_PMASK16 0x10000
#define LPC_GPIO_MASK2_PMASK16_BIT 16
#define LPC_GPIO_MASK2_PMASK17_MASK 0x20000
#define LPC_GPIO_MASK2_PMASK17 0x20000
#define LPC_GPIO_MASK2_PMASK17_BIT 17
#define LPC_GPIO_MASK2_PMASK18_MASK 0x40000
#define LPC_GPIO_MASK2_PMASK18 0x40000
#define LPC_GPIO_MASK2_PMASK18_BIT 18
#define LPC_GPIO_MASK2_PMASK19_MASK 0x80000
#define LPC_GPIO_MASK2_PMASK19 0x80000
#define LPC_GPIO_MASK2_PMASK19_BIT 19
#define LPC_GPIO_MASK2_PMASK20_MASK 0x100000
#define LPC_GPIO_MASK2_PMASK20 0x100000
#define LPC_GPIO_MASK2_PMASK20_BIT 20
#define LPC_GPIO_MASK2_PMASK21_MASK 0x200000
#define LPC_GPIO_MASK2_PMASK21 0x200000
#define LPC_GPIO_MASK2_PMASK21_BIT 21
#define LPC_GPIO_MASK2_PMASK22_MASK 0x400000
#define LPC_GPIO_MASK2_PMASK22 0x400000
#define LPC_GPIO_MASK2_PMASK22_BIT 22
#define LPC_GPIO_MASK2_PMASK23_MASK 0x800000
#define LPC_GPIO_MASK2_PMASK23 0x800000
#define LPC_GPIO_MASK2_PMASK23_BIT 23
#define LPC_GPIO_MASK2_PMASK24_MASK 0x1000000
#define LPC_GPIO_MASK2_PMASK24 0x1000000
#define LPC_GPIO_MASK2_PMASK24_BIT 24
#define LPC_GPIO_MASK2_PMASK25_MASK 0x2000000
#define LPC_GPIO_MASK2_PMASK25 0x2000000
#define LPC_GPIO_MASK2_PMASK25_BIT 25
#define LPC_GPIO_MASK2_PMASK26_MASK 0x4000000
#define LPC_GPIO_MASK2_PMASK26 0x4000000
#define LPC_GPIO_MASK2_PMASK26_BIT 26
#define LPC_GPIO_MASK2_PMASK27_MASK 0x8000000
#define LPC_GPIO_MASK2_PMASK27 0x8000000
#define LPC_GPIO_MASK2_PMASK27_BIT 27
#define LPC_GPIO_MASK2_PMASK28_MASK 0x10000000
#define LPC_GPIO_MASK2_PMASK28 0x10000000
#define LPC_GPIO_MASK2_PMASK28_BIT 28
#define LPC_GPIO_MASK2_PMASK29_MASK 0x20000000
#define LPC_GPIO_MASK2_PMASK29 0x20000000
#define LPC_GPIO_MASK2_PMASK29_BIT 29
#define LPC_GPIO_MASK2_PMASK30_MASK 0x40000000
#define LPC_GPIO_MASK2_PMASK30 0x40000000
#define LPC_GPIO_MASK2_PMASK30_BIT 30
#define LPC_GPIO_MASK2_PMASK31_MASK 0x80000000
#define LPC_GPIO_MASK2_PMASK31 0x80000000
#define LPC_GPIO_MASK2_PMASK31_BIT 31

#define LPC_GPIO_MASK3 (*(volatile unsigned long *)0x20098070)
#define LPC_GPIO_MASK3_OFFSET 0x70
#define LPC_GPIO_MASK3_PMASK0_MASK 0x1
#define LPC_GPIO_MASK3_PMASK0 0x1
#define LPC_GPIO_MASK3_PMASK0_BIT 0
#define LPC_GPIO_MASK3_PMASK1_MASK 0x2
#define LPC_GPIO_MASK3_PMASK1 0x2
#define LPC_GPIO_MASK3_PMASK1_BIT 1
#define LPC_GPIO_MASK3_PMASK2_MASK 0x4
#define LPC_GPIO_MASK3_PMASK2 0x4
#define LPC_GPIO_MASK3_PMASK2_BIT 2
#define LPC_GPIO_MASK3_PMASK3_MASK 0x8
#define LPC_GPIO_MASK3_PMASK3 0x8
#define LPC_GPIO_MASK3_PMASK3_BIT 3
#define LPC_GPIO_MASK3_PMASK4_MASK 0x10
#define LPC_GPIO_MASK3_PMASK4 0x10
#define LPC_GPIO_MASK3_PMASK4_BIT 4
#define LPC_GPIO_MASK3_PMASK5_MASK 0x20
#define LPC_GPIO_MASK3_PMASK5 0x20
#define LPC_GPIO_MASK3_PMASK5_BIT 5
#define LPC_GPIO_MASK3_PMASK6_MASK 0x40
#define LPC_GPIO_MASK3_PMASK6 0x40
#define LPC_GPIO_MASK3_PMASK6_BIT 6
#define LPC_GPIO_MASK3_PMASK7_MASK 0x80
#define LPC_GPIO_MASK3_PMASK7 0x80
#define LPC_GPIO_MASK3_PMASK7_BIT 7
#define LPC_GPIO_MASK3_PMASK8_MASK 0x100
#define LPC_GPIO_MASK3_PMASK8 0x100
#define LPC_GPIO_MASK3_PMASK8_BIT 8
#define LPC_GPIO_MASK3_PMASK9_MASK 0x200
#define LPC_GPIO_MASK3_PMASK9 0x200
#define LPC_GPIO_MASK3_PMASK9_BIT 9
#define LPC_GPIO_MASK3_PMASK10_MASK 0x400
#define LPC_GPIO_MASK3_PMASK10 0x400
#define LPC_GPIO_MASK3_PMASK10_BIT 10
#define LPC_GPIO_MASK3_PMASK11_MASK 0x800
#define LPC_GPIO_MASK3_PMASK11 0x800
#define LPC_GPIO_MASK3_PMASK11_BIT 11
#define LPC_GPIO_MASK3_PMASK12_MASK 0x1000
#define LPC_GPIO_MASK3_PMASK12 0x1000
#define LPC_GPIO_MASK3_PMASK12_BIT 12
#define LPC_GPIO_MASK3_PMASK13_MASK 0x2000
#define LPC_GPIO_MASK3_PMASK13 0x2000
#define LPC_GPIO_MASK3_PMASK13_BIT 13
#define LPC_GPIO_MASK3_PMASK14_MASK 0x4000
#define LPC_GPIO_MASK3_PMASK14 0x4000
#define LPC_GPIO_MASK3_PMASK14_BIT 14
#define LPC_GPIO_MASK3_PMASK15_MASK 0x8000
#define LPC_GPIO_MASK3_PMASK15 0x8000
#define LPC_GPIO_MASK3_PMASK15_BIT 15
#define LPC_GPIO_MASK3_PMASK16_MASK 0x10000
#define LPC_GPIO_MASK3_PMASK16 0x10000
#define LPC_GPIO_MASK3_PMASK16_BIT 16
#define LPC_GPIO_MASK3_PMASK17_MASK 0x20000
#define LPC_GPIO_MASK3_PMASK17 0x20000
#define LPC_GPIO_MASK3_PMASK17_BIT 17
#define LPC_GPIO_MASK3_PMASK18_MASK 0x40000
#define LPC_GPIO_MASK3_PMASK18 0x40000
#define LPC_GPIO_MASK3_PMASK18_BIT 18
#define LPC_GPIO_MASK3_PMASK19_MASK 0x80000
#define LPC_GPIO_MASK3_PMASK19 0x80000
#define LPC_GPIO_MASK3_PMASK19_BIT 19
#define LPC_GPIO_MASK3_PMASK20_MASK 0x100000
#define LPC_GPIO_MASK3_PMASK20 0x100000
#define LPC_GPIO_MASK3_PMASK20_BIT 20
#define LPC_GPIO_MASK3_PMASK21_MASK 0x200000
#define LPC_GPIO_MASK3_PMASK21 0x200000
#define LPC_GPIO_MASK3_PMASK21_BIT 21
#define LPC_GPIO_MASK3_PMASK22_MASK 0x400000
#define LPC_GPIO_MASK3_PMASK22 0x400000
#define LPC_GPIO_MASK3_PMASK22_BIT 22
#define LPC_GPIO_MASK3_PMASK23_MASK 0x800000
#define LPC_GPIO_MASK3_PMASK23 0x800000
#define LPC_GPIO_MASK3_PMASK23_BIT 23
#define LPC_GPIO_MASK3_PMASK24_MASK 0x1000000
#define LPC_GPIO_MASK3_PMASK24 0x1000000
#define LPC_GPIO_MASK3_PMASK24_BIT 24
#define LPC_GPIO_MASK3_PMASK25_MASK 0x2000000
#define LPC_GPIO_MASK3_PMASK25 0x2000000
#define LPC_GPIO_MASK3_PMASK25_BIT 25
#define LPC_GPIO_MASK3_PMASK26_MASK 0x4000000
#define LPC_GPIO_MASK3_PMASK26 0x4000000
#define LPC_GPIO_MASK3_PMASK26_BIT 26
#define LPC_GPIO_MASK3_PMASK27_MASK 0x8000000
#define LPC_GPIO_MASK3_PMASK27 0x8000000
#define LPC_GPIO_MASK3_PMASK27_BIT 27
#define LPC_GPIO_MASK3_PMASK28_MASK 0x10000000
#define LPC_GPIO_MASK3_PMASK28 0x10000000
#define LPC_GPIO_MASK3_PMASK28_BIT 28
#define LPC_GPIO_MASK3_PMASK29_MASK 0x20000000
#define LPC_GPIO_MASK3_PMASK29 0x20000000
#define LPC_GPIO_MASK3_PMASK29_BIT 29
#define LPC_GPIO_MASK3_PMASK30_MASK 0x40000000
#define LPC_GPIO_MASK3_PMASK30 0x40000000
#define LPC_GPIO_MASK3_PMASK30_BIT 30
#define LPC_GPIO_MASK3_PMASK31_MASK 0x80000000
#define LPC_GPIO_MASK3_PMASK31 0x80000000
#define LPC_GPIO_MASK3_PMASK31_BIT 31

#define LPC_GPIO_MASK4 (*(volatile unsigned long *)0x20098090)
#define LPC_GPIO_MASK4_OFFSET 0x90
#define LPC_GPIO_MASK4_PMASK0_MASK 0x1
#define LPC_GPIO_MASK4_PMASK0 0x1
#define LPC_GPIO_MASK4_PMASK0_BIT 0
#define LPC_GPIO_MASK4_PMASK1_MASK 0x2
#define LPC_GPIO_MASK4_PMASK1 0x2
#define LPC_GPIO_MASK4_PMASK1_BIT 1
#define LPC_GPIO_MASK4_PMASK2_MASK 0x4
#define LPC_GPIO_MASK4_PMASK2 0x4
#define LPC_GPIO_MASK4_PMASK2_BIT 2
#define LPC_GPIO_MASK4_PMASK3_MASK 0x8
#define LPC_GPIO_MASK4_PMASK3 0x8
#define LPC_GPIO_MASK4_PMASK3_BIT 3
#define LPC_GPIO_MASK4_PMASK4_MASK 0x10
#define LPC_GPIO_MASK4_PMASK4 0x10
#define LPC_GPIO_MASK4_PMASK4_BIT 4
#define LPC_GPIO_MASK4_PMASK5_MASK 0x20
#define LPC_GPIO_MASK4_PMASK5 0x20
#define LPC_GPIO_MASK4_PMASK5_BIT 5
#define LPC_GPIO_MASK4_PMASK6_MASK 0x40
#define LPC_GPIO_MASK4_PMASK6 0x40
#define LPC_GPIO_MASK4_PMASK6_BIT 6
#define LPC_GPIO_MASK4_PMASK7_MASK 0x80
#define LPC_GPIO_MASK4_PMASK7 0x80
#define LPC_GPIO_MASK4_PMASK7_BIT 7
#define LPC_GPIO_MASK4_PMASK8_MASK 0x100
#define LPC_GPIO_MASK4_PMASK8 0x100
#define LPC_GPIO_MASK4_PMASK8_BIT 8
#define LPC_GPIO_MASK4_PMASK9_MASK 0x200
#define LPC_GPIO_MASK4_PMASK9 0x200
#define LPC_GPIO_MASK4_PMASK9_BIT 9
#define LPC_GPIO_MASK4_PMASK10_MASK 0x400
#define LPC_GPIO_MASK4_PMASK10 0x400
#define LPC_GPIO_MASK4_PMASK10_BIT 10
#define LPC_GPIO_MASK4_PMASK11_MASK 0x800
#define LPC_GPIO_MASK4_PMASK11 0x800
#define LPC_GPIO_MASK4_PMASK11_BIT 11
#define LPC_GPIO_MASK4_PMASK12_MASK 0x1000
#define LPC_GPIO_MASK4_PMASK12 0x1000
#define LPC_GPIO_MASK4_PMASK12_BIT 12
#define LPC_GPIO_MASK4_PMASK13_MASK 0x2000
#define LPC_GPIO_MASK4_PMASK13 0x2000
#define LPC_GPIO_MASK4_PMASK13_BIT 13
#define LPC_GPIO_MASK4_PMASK14_MASK 0x4000
#define LPC_GPIO_MASK4_PMASK14 0x4000
#define LPC_GPIO_MASK4_PMASK14_BIT 14
#define LPC_GPIO_MASK4_PMASK15_MASK 0x8000
#define LPC_GPIO_MASK4_PMASK15 0x8000
#define LPC_GPIO_MASK4_PMASK15_BIT 15
#define LPC_GPIO_MASK4_PMASK16_MASK 0x10000
#define LPC_GPIO_MASK4_PMASK16 0x10000
#define LPC_GPIO_MASK4_PMASK16_BIT 16
#define LPC_GPIO_MASK4_PMASK17_MASK 0x20000
#define LPC_GPIO_MASK4_PMASK17 0x20000
#define LPC_GPIO_MASK4_PMASK17_BIT 17
#define LPC_GPIO_MASK4_PMASK18_MASK 0x40000
#define LPC_GPIO_MASK4_PMASK18 0x40000
#define LPC_GPIO_MASK4_PMASK18_BIT 18
#define LPC_GPIO_MASK4_PMASK19_MASK 0x80000
#define LPC_GPIO_MASK4_PMASK19 0x80000
#define LPC_GPIO_MASK4_PMASK19_BIT 19
#define LPC_GPIO_MASK4_PMASK20_MASK 0x100000
#define LPC_GPIO_MASK4_PMASK20 0x100000
#define LPC_GPIO_MASK4_PMASK20_BIT 20
#define LPC_GPIO_MASK4_PMASK21_MASK 0x200000
#define LPC_GPIO_MASK4_PMASK21 0x200000
#define LPC_GPIO_MASK4_PMASK21_BIT 21
#define LPC_GPIO_MASK4_PMASK22_MASK 0x400000
#define LPC_GPIO_MASK4_PMASK22 0x400000
#define LPC_GPIO_MASK4_PMASK22_BIT 22
#define LPC_GPIO_MASK4_PMASK23_MASK 0x800000
#define LPC_GPIO_MASK4_PMASK23 0x800000
#define LPC_GPIO_MASK4_PMASK23_BIT 23
#define LPC_GPIO_MASK4_PMASK24_MASK 0x1000000
#define LPC_GPIO_MASK4_PMASK24 0x1000000
#define LPC_GPIO_MASK4_PMASK24_BIT 24
#define LPC_GPIO_MASK4_PMASK25_MASK 0x2000000
#define LPC_GPIO_MASK4_PMASK25 0x2000000
#define LPC_GPIO_MASK4_PMASK25_BIT 25
#define LPC_GPIO_MASK4_PMASK26_MASK 0x4000000
#define LPC_GPIO_MASK4_PMASK26 0x4000000
#define LPC_GPIO_MASK4_PMASK26_BIT 26
#define LPC_GPIO_MASK4_PMASK27_MASK 0x8000000
#define LPC_GPIO_MASK4_PMASK27 0x8000000
#define LPC_GPIO_MASK4_PMASK27_BIT 27
#define LPC_GPIO_MASK4_PMASK28_MASK 0x10000000
#define LPC_GPIO_MASK4_PMASK28 0x10000000
#define LPC_GPIO_MASK4_PMASK28_BIT 28
#define LPC_GPIO_MASK4_PMASK29_MASK 0x20000000
#define LPC_GPIO_MASK4_PMASK29 0x20000000
#define LPC_GPIO_MASK4_PMASK29_BIT 29
#define LPC_GPIO_MASK4_PMASK30_MASK 0x40000000
#define LPC_GPIO_MASK4_PMASK30 0x40000000
#define LPC_GPIO_MASK4_PMASK30_BIT 30
#define LPC_GPIO_MASK4_PMASK31_MASK 0x80000000
#define LPC_GPIO_MASK4_PMASK31 0x80000000
#define LPC_GPIO_MASK4_PMASK31_BIT 31

#define LPC_GPIO_MASK5 (*(volatile unsigned long *)0x200980B0)
#define LPC_GPIO_MASK5_OFFSET 0xB0
#define LPC_GPIO_MASK5_PMASK0_MASK 0x1
#define LPC_GPIO_MASK5_PMASK0 0x1
#define LPC_GPIO_MASK5_PMASK0_BIT 0
#define LPC_GPIO_MASK5_PMASK1_MASK 0x2
#define LPC_GPIO_MASK5_PMASK1 0x2
#define LPC_GPIO_MASK5_PMASK1_BIT 1
#define LPC_GPIO_MASK5_PMASK2_MASK 0x4
#define LPC_GPIO_MASK5_PMASK2 0x4
#define LPC_GPIO_MASK5_PMASK2_BIT 2
#define LPC_GPIO_MASK5_PMASK3_MASK 0x8
#define LPC_GPIO_MASK5_PMASK3 0x8
#define LPC_GPIO_MASK5_PMASK3_BIT 3
#define LPC_GPIO_MASK5_PMASK4_MASK 0x10
#define LPC_GPIO_MASK5_PMASK4 0x10
#define LPC_GPIO_MASK5_PMASK4_BIT 4
#define LPC_GPIO_MASK5_PMASK5_MASK 0x20
#define LPC_GPIO_MASK5_PMASK5 0x20
#define LPC_GPIO_MASK5_PMASK5_BIT 5
#define LPC_GPIO_MASK5_PMASK6_MASK 0x40
#define LPC_GPIO_MASK5_PMASK6 0x40
#define LPC_GPIO_MASK5_PMASK6_BIT 6
#define LPC_GPIO_MASK5_PMASK7_MASK 0x80
#define LPC_GPIO_MASK5_PMASK7 0x80
#define LPC_GPIO_MASK5_PMASK7_BIT 7
#define LPC_GPIO_MASK5_PMASK8_MASK 0x100
#define LPC_GPIO_MASK5_PMASK8 0x100
#define LPC_GPIO_MASK5_PMASK8_BIT 8
#define LPC_GPIO_MASK5_PMASK9_MASK 0x200
#define LPC_GPIO_MASK5_PMASK9 0x200
#define LPC_GPIO_MASK5_PMASK9_BIT 9
#define LPC_GPIO_MASK5_PMASK10_MASK 0x400
#define LPC_GPIO_MASK5_PMASK10 0x400
#define LPC_GPIO_MASK5_PMASK10_BIT 10
#define LPC_GPIO_MASK5_PMASK11_MASK 0x800
#define LPC_GPIO_MASK5_PMASK11 0x800
#define LPC_GPIO_MASK5_PMASK11_BIT 11
#define LPC_GPIO_MASK5_PMASK12_MASK 0x1000
#define LPC_GPIO_MASK5_PMASK12 0x1000
#define LPC_GPIO_MASK5_PMASK12_BIT 12
#define LPC_GPIO_MASK5_PMASK13_MASK 0x2000
#define LPC_GPIO_MASK5_PMASK13 0x2000
#define LPC_GPIO_MASK5_PMASK13_BIT 13
#define LPC_GPIO_MASK5_PMASK14_MASK 0x4000
#define LPC_GPIO_MASK5_PMASK14 0x4000
#define LPC_GPIO_MASK5_PMASK14_BIT 14
#define LPC_GPIO_MASK5_PMASK15_MASK 0x8000
#define LPC_GPIO_MASK5_PMASK15 0x8000
#define LPC_GPIO_MASK5_PMASK15_BIT 15
#define LPC_GPIO_MASK5_PMASK16_MASK 0x10000
#define LPC_GPIO_MASK5_PMASK16 0x10000
#define LPC_GPIO_MASK5_PMASK16_BIT 16
#define LPC_GPIO_MASK5_PMASK17_MASK 0x20000
#define LPC_GPIO_MASK5_PMASK17 0x20000
#define LPC_GPIO_MASK5_PMASK17_BIT 17
#define LPC_GPIO_MASK5_PMASK18_MASK 0x40000
#define LPC_GPIO_MASK5_PMASK18 0x40000
#define LPC_GPIO_MASK5_PMASK18_BIT 18
#define LPC_GPIO_MASK5_PMASK19_MASK 0x80000
#define LPC_GPIO_MASK5_PMASK19 0x80000
#define LPC_GPIO_MASK5_PMASK19_BIT 19
#define LPC_GPIO_MASK5_PMASK20_MASK 0x100000
#define LPC_GPIO_MASK5_PMASK20 0x100000
#define LPC_GPIO_MASK5_PMASK20_BIT 20
#define LPC_GPIO_MASK5_PMASK21_MASK 0x200000
#define LPC_GPIO_MASK5_PMASK21 0x200000
#define LPC_GPIO_MASK5_PMASK21_BIT 21
#define LPC_GPIO_MASK5_PMASK22_MASK 0x400000
#define LPC_GPIO_MASK5_PMASK22 0x400000
#define LPC_GPIO_MASK5_PMASK22_BIT 22
#define LPC_GPIO_MASK5_PMASK23_MASK 0x800000
#define LPC_GPIO_MASK5_PMASK23 0x800000
#define LPC_GPIO_MASK5_PMASK23_BIT 23
#define LPC_GPIO_MASK5_PMASK24_MASK 0x1000000
#define LPC_GPIO_MASK5_PMASK24 0x1000000
#define LPC_GPIO_MASK5_PMASK24_BIT 24
#define LPC_GPIO_MASK5_PMASK25_MASK 0x2000000
#define LPC_GPIO_MASK5_PMASK25 0x2000000
#define LPC_GPIO_MASK5_PMASK25_BIT 25
#define LPC_GPIO_MASK5_PMASK26_MASK 0x4000000
#define LPC_GPIO_MASK5_PMASK26 0x4000000
#define LPC_GPIO_MASK5_PMASK26_BIT 26
#define LPC_GPIO_MASK5_PMASK27_MASK 0x8000000
#define LPC_GPIO_MASK5_PMASK27 0x8000000
#define LPC_GPIO_MASK5_PMASK27_BIT 27
#define LPC_GPIO_MASK5_PMASK28_MASK 0x10000000
#define LPC_GPIO_MASK5_PMASK28 0x10000000
#define LPC_GPIO_MASK5_PMASK28_BIT 28
#define LPC_GPIO_MASK5_PMASK29_MASK 0x20000000
#define LPC_GPIO_MASK5_PMASK29 0x20000000
#define LPC_GPIO_MASK5_PMASK29_BIT 29
#define LPC_GPIO_MASK5_PMASK30_MASK 0x40000000
#define LPC_GPIO_MASK5_PMASK30 0x40000000
#define LPC_GPIO_MASK5_PMASK30_BIT 30
#define LPC_GPIO_MASK5_PMASK31_MASK 0x80000000
#define LPC_GPIO_MASK5_PMASK31 0x80000000
#define LPC_GPIO_MASK5_PMASK31_BIT 31

#define LPC_GPIO_PIN0 (*(volatile unsigned long *)0x20098014)
#define LPC_GPIO_PIN0_OFFSET 0x14
#define LPC_GPIO_PIN0_VAL0_MASK 0x1
#define LPC_GPIO_PIN0_VAL0 0x1
#define LPC_GPIO_PIN0_VAL0_BIT 0
#define LPC_GPIO_PIN0_VAL1_MASK 0x2
#define LPC_GPIO_PIN0_VAL1 0x2
#define LPC_GPIO_PIN0_VAL1_BIT 1
#define LPC_GPIO_PIN0_VAL2_MASK 0x4
#define LPC_GPIO_PIN0_VAL2 0x4
#define LPC_GPIO_PIN0_VAL2_BIT 2
#define LPC_GPIO_PIN0_VAL3_MASK 0x8
#define LPC_GPIO_PIN0_VAL3 0x8
#define LPC_GPIO_PIN0_VAL3_BIT 3
#define LPC_GPIO_PIN0_VAL4_MASK 0x10
#define LPC_GPIO_PIN0_VAL4 0x10
#define LPC_GPIO_PIN0_VAL4_BIT 4
#define LPC_GPIO_PIN0_VAL5_MASK 0x20
#define LPC_GPIO_PIN0_VAL5 0x20
#define LPC_GPIO_PIN0_VAL5_BIT 5
#define LPC_GPIO_PIN0_VAL6_MASK 0x40
#define LPC_GPIO_PIN0_VAL6 0x40
#define LPC_GPIO_PIN0_VAL6_BIT 6
#define LPC_GPIO_PIN0_VAL7_MASK 0x80
#define LPC_GPIO_PIN0_VAL7 0x80
#define LPC_GPIO_PIN0_VAL7_BIT 7
#define LPC_GPIO_PIN0_VAL8_MASK 0x100
#define LPC_GPIO_PIN0_VAL8 0x100
#define LPC_GPIO_PIN0_VAL8_BIT 8
#define LPC_GPIO_PIN0_VAL9_MASK 0x200
#define LPC_GPIO_PIN0_VAL9 0x200
#define LPC_GPIO_PIN0_VAL9_BIT 9
#define LPC_GPIO_PIN0_VAL10_MASK 0x400
#define LPC_GPIO_PIN0_VAL10 0x400
#define LPC_GPIO_PIN0_VAL10_BIT 10
#define LPC_GPIO_PIN0_VAL11_MASK 0x800
#define LPC_GPIO_PIN0_VAL11 0x800
#define LPC_GPIO_PIN0_VAL11_BIT 11
#define LPC_GPIO_PIN0_VAL12_MASK 0x1000
#define LPC_GPIO_PIN0_VAL12 0x1000
#define LPC_GPIO_PIN0_VAL12_BIT 12
#define LPC_GPIO_PIN0_VAL13_MASK 0x2000
#define LPC_GPIO_PIN0_VAL13 0x2000
#define LPC_GPIO_PIN0_VAL13_BIT 13
#define LPC_GPIO_PIN0_VAL14_MASK 0x4000
#define LPC_GPIO_PIN0_VAL14 0x4000
#define LPC_GPIO_PIN0_VAL14_BIT 14
#define LPC_GPIO_PIN0_VAL15_MASK 0x8000
#define LPC_GPIO_PIN0_VAL15 0x8000
#define LPC_GPIO_PIN0_VAL15_BIT 15
#define LPC_GPIO_PIN0_VAL16_MASK 0x10000
#define LPC_GPIO_PIN0_VAL16 0x10000
#define LPC_GPIO_PIN0_VAL16_BIT 16
#define LPC_GPIO_PIN0_VAL17_MASK 0x20000
#define LPC_GPIO_PIN0_VAL17 0x20000
#define LPC_GPIO_PIN0_VAL17_BIT 17
#define LPC_GPIO_PIN0_VAL18_MASK 0x40000
#define LPC_GPIO_PIN0_VAL18 0x40000
#define LPC_GPIO_PIN0_VAL18_BIT 18
#define LPC_GPIO_PIN0_VAL19_MASK 0x80000
#define LPC_GPIO_PIN0_VAL19 0x80000
#define LPC_GPIO_PIN0_VAL19_BIT 19
#define LPC_GPIO_PIN0_VAL20_MASK 0x100000
#define LPC_GPIO_PIN0_VAL20 0x100000
#define LPC_GPIO_PIN0_VAL20_BIT 20
#define LPC_GPIO_PIN0_VAL21_MASK 0x200000
#define LPC_GPIO_PIN0_VAL21 0x200000
#define LPC_GPIO_PIN0_VAL21_BIT 21
#define LPC_GPIO_PIN0_VAL22_MASK 0x400000
#define LPC_GPIO_PIN0_VAL22 0x400000
#define LPC_GPIO_PIN0_VAL22_BIT 22
#define LPC_GPIO_PIN0_VAL23_MASK 0x800000
#define LPC_GPIO_PIN0_VAL23 0x800000
#define LPC_GPIO_PIN0_VAL23_BIT 23
#define LPC_GPIO_PIN0_VAL24_MASK 0x1000000
#define LPC_GPIO_PIN0_VAL24 0x1000000
#define LPC_GPIO_PIN0_VAL24_BIT 24
#define LPC_GPIO_PIN0_VAL25_MASK 0x2000000
#define LPC_GPIO_PIN0_VAL25 0x2000000
#define LPC_GPIO_PIN0_VAL25_BIT 25
#define LPC_GPIO_PIN0_VAL26_MASK 0x4000000
#define LPC_GPIO_PIN0_VAL26 0x4000000
#define LPC_GPIO_PIN0_VAL26_BIT 26
#define LPC_GPIO_PIN0_VAL27_MASK 0x8000000
#define LPC_GPIO_PIN0_VAL27 0x8000000
#define LPC_GPIO_PIN0_VAL27_BIT 27
#define LPC_GPIO_PIN0_VAL28_MASK 0x10000000
#define LPC_GPIO_PIN0_VAL28 0x10000000
#define LPC_GPIO_PIN0_VAL28_BIT 28
#define LPC_GPIO_PIN0_VAL29_MASK 0x20000000
#define LPC_GPIO_PIN0_VAL29 0x20000000
#define LPC_GPIO_PIN0_VAL29_BIT 29
#define LPC_GPIO_PIN0_VAL30_MASK 0x40000000
#define LPC_GPIO_PIN0_VAL30 0x40000000
#define LPC_GPIO_PIN0_VAL30_BIT 30
#define LPC_GPIO_PIN0_VAL31_MASK 0x80000000
#define LPC_GPIO_PIN0_VAL31 0x80000000
#define LPC_GPIO_PIN0_VAL31_BIT 31

#define LPC_GPIO_PIN1 (*(volatile unsigned long *)0x20098034)
#define LPC_GPIO_PIN1_OFFSET 0x34
#define LPC_GPIO_PIN1_VAL0_MASK 0x1
#define LPC_GPIO_PIN1_VAL0 0x1
#define LPC_GPIO_PIN1_VAL0_BIT 0
#define LPC_GPIO_PIN1_VAL1_MASK 0x2
#define LPC_GPIO_PIN1_VAL1 0x2
#define LPC_GPIO_PIN1_VAL1_BIT 1
#define LPC_GPIO_PIN1_VAL2_MASK 0x4
#define LPC_GPIO_PIN1_VAL2 0x4
#define LPC_GPIO_PIN1_VAL2_BIT 2
#define LPC_GPIO_PIN1_VAL3_MASK 0x8
#define LPC_GPIO_PIN1_VAL3 0x8
#define LPC_GPIO_PIN1_VAL3_BIT 3
#define LPC_GPIO_PIN1_VAL4_MASK 0x10
#define LPC_GPIO_PIN1_VAL4 0x10
#define LPC_GPIO_PIN1_VAL4_BIT 4
#define LPC_GPIO_PIN1_VAL5_MASK 0x20
#define LPC_GPIO_PIN1_VAL5 0x20
#define LPC_GPIO_PIN1_VAL5_BIT 5
#define LPC_GPIO_PIN1_VAL6_MASK 0x40
#define LPC_GPIO_PIN1_VAL6 0x40
#define LPC_GPIO_PIN1_VAL6_BIT 6
#define LPC_GPIO_PIN1_VAL7_MASK 0x80
#define LPC_GPIO_PIN1_VAL7 0x80
#define LPC_GPIO_PIN1_VAL7_BIT 7
#define LPC_GPIO_PIN1_VAL8_MASK 0x100
#define LPC_GPIO_PIN1_VAL8 0x100
#define LPC_GPIO_PIN1_VAL8_BIT 8
#define LPC_GPIO_PIN1_VAL9_MASK 0x200
#define LPC_GPIO_PIN1_VAL9 0x200
#define LPC_GPIO_PIN1_VAL9_BIT 9
#define LPC_GPIO_PIN1_VAL10_MASK 0x400
#define LPC_GPIO_PIN1_VAL10 0x400
#define LPC_GPIO_PIN1_VAL10_BIT 10
#define LPC_GPIO_PIN1_VAL11_MASK 0x800
#define LPC_GPIO_PIN1_VAL11 0x800
#define LPC_GPIO_PIN1_VAL11_BIT 11
#define LPC_GPIO_PIN1_VAL12_MASK 0x1000
#define LPC_GPIO_PIN1_VAL12 0x1000
#define LPC_GPIO_PIN1_VAL12_BIT 12
#define LPC_GPIO_PIN1_VAL13_MASK 0x2000
#define LPC_GPIO_PIN1_VAL13 0x2000
#define LPC_GPIO_PIN1_VAL13_BIT 13
#define LPC_GPIO_PIN1_VAL14_MASK 0x4000
#define LPC_GPIO_PIN1_VAL14 0x4000
#define LPC_GPIO_PIN1_VAL14_BIT 14
#define LPC_GPIO_PIN1_VAL15_MASK 0x8000
#define LPC_GPIO_PIN1_VAL15 0x8000
#define LPC_GPIO_PIN1_VAL15_BIT 15
#define LPC_GPIO_PIN1_VAL16_MASK 0x10000
#define LPC_GPIO_PIN1_VAL16 0x10000
#define LPC_GPIO_PIN1_VAL16_BIT 16
#define LPC_GPIO_PIN1_VAL17_MASK 0x20000
#define LPC_GPIO_PIN1_VAL17 0x20000
#define LPC_GPIO_PIN1_VAL17_BIT 17
#define LPC_GPIO_PIN1_VAL18_MASK 0x40000
#define LPC_GPIO_PIN1_VAL18 0x40000
#define LPC_GPIO_PIN1_VAL18_BIT 18
#define LPC_GPIO_PIN1_VAL19_MASK 0x80000
#define LPC_GPIO_PIN1_VAL19 0x80000
#define LPC_GPIO_PIN1_VAL19_BIT 19
#define LPC_GPIO_PIN1_VAL20_MASK 0x100000
#define LPC_GPIO_PIN1_VAL20 0x100000
#define LPC_GPIO_PIN1_VAL20_BIT 20
#define LPC_GPIO_PIN1_VAL21_MASK 0x200000
#define LPC_GPIO_PIN1_VAL21 0x200000
#define LPC_GPIO_PIN1_VAL21_BIT 21
#define LPC_GPIO_PIN1_VAL22_MASK 0x400000
#define LPC_GPIO_PIN1_VAL22 0x400000
#define LPC_GPIO_PIN1_VAL22_BIT 22
#define LPC_GPIO_PIN1_VAL23_MASK 0x800000
#define LPC_GPIO_PIN1_VAL23 0x800000
#define LPC_GPIO_PIN1_VAL23_BIT 23
#define LPC_GPIO_PIN1_VAL24_MASK 0x1000000
#define LPC_GPIO_PIN1_VAL24 0x1000000
#define LPC_GPIO_PIN1_VAL24_BIT 24
#define LPC_GPIO_PIN1_VAL25_MASK 0x2000000
#define LPC_GPIO_PIN1_VAL25 0x2000000
#define LPC_GPIO_PIN1_VAL25_BIT 25
#define LPC_GPIO_PIN1_VAL26_MASK 0x4000000
#define LPC_GPIO_PIN1_VAL26 0x4000000
#define LPC_GPIO_PIN1_VAL26_BIT 26
#define LPC_GPIO_PIN1_VAL27_MASK 0x8000000
#define LPC_GPIO_PIN1_VAL27 0x8000000
#define LPC_GPIO_PIN1_VAL27_BIT 27
#define LPC_GPIO_PIN1_VAL28_MASK 0x10000000
#define LPC_GPIO_PIN1_VAL28 0x10000000
#define LPC_GPIO_PIN1_VAL28_BIT 28
#define LPC_GPIO_PIN1_VAL29_MASK 0x20000000
#define LPC_GPIO_PIN1_VAL29 0x20000000
#define LPC_GPIO_PIN1_VAL29_BIT 29
#define LPC_GPIO_PIN1_VAL30_MASK 0x40000000
#define LPC_GPIO_PIN1_VAL30 0x40000000
#define LPC_GPIO_PIN1_VAL30_BIT 30
#define LPC_GPIO_PIN1_VAL31_MASK 0x80000000
#define LPC_GPIO_PIN1_VAL31 0x80000000
#define LPC_GPIO_PIN1_VAL31_BIT 31

#define LPC_GPIO_PIN2 (*(volatile unsigned long *)0x20098054)
#define LPC_GPIO_PIN2_OFFSET 0x54
#define LPC_GPIO_PIN2_VAL0_MASK 0x1
#define LPC_GPIO_PIN2_VAL0 0x1
#define LPC_GPIO_PIN2_VAL0_BIT 0
#define LPC_GPIO_PIN2_VAL1_MASK 0x2
#define LPC_GPIO_PIN2_VAL1 0x2
#define LPC_GPIO_PIN2_VAL1_BIT 1
#define LPC_GPIO_PIN2_VAL2_MASK 0x4
#define LPC_GPIO_PIN2_VAL2 0x4
#define LPC_GPIO_PIN2_VAL2_BIT 2
#define LPC_GPIO_PIN2_VAL3_MASK 0x8
#define LPC_GPIO_PIN2_VAL3 0x8
#define LPC_GPIO_PIN2_VAL3_BIT 3
#define LPC_GPIO_PIN2_VAL4_MASK 0x10
#define LPC_GPIO_PIN2_VAL4 0x10
#define LPC_GPIO_PIN2_VAL4_BIT 4
#define LPC_GPIO_PIN2_VAL5_MASK 0x20
#define LPC_GPIO_PIN2_VAL5 0x20
#define LPC_GPIO_PIN2_VAL5_BIT 5
#define LPC_GPIO_PIN2_VAL6_MASK 0x40
#define LPC_GPIO_PIN2_VAL6 0x40
#define LPC_GPIO_PIN2_VAL6_BIT 6
#define LPC_GPIO_PIN2_VAL7_MASK 0x80
#define LPC_GPIO_PIN2_VAL7 0x80
#define LPC_GPIO_PIN2_VAL7_BIT 7
#define LPC_GPIO_PIN2_VAL8_MASK 0x100
#define LPC_GPIO_PIN2_VAL8 0x100
#define LPC_GPIO_PIN2_VAL8_BIT 8
#define LPC_GPIO_PIN2_VAL9_MASK 0x200
#define LPC_GPIO_PIN2_VAL9 0x200
#define LPC_GPIO_PIN2_VAL9_BIT 9
#define LPC_GPIO_PIN2_VAL10_MASK 0x400
#define LPC_GPIO_PIN2_VAL10 0x400
#define LPC_GPIO_PIN2_VAL10_BIT 10
#define LPC_GPIO_PIN2_VAL11_MASK 0x800
#define LPC_GPIO_PIN2_VAL11 0x800
#define LPC_GPIO_PIN2_VAL11_BIT 11
#define LPC_GPIO_PIN2_VAL12_MASK 0x1000
#define LPC_GPIO_PIN2_VAL12 0x1000
#define LPC_GPIO_PIN2_VAL12_BIT 12
#define LPC_GPIO_PIN2_VAL13_MASK 0x2000
#define LPC_GPIO_PIN2_VAL13 0x2000
#define LPC_GPIO_PIN2_VAL13_BIT 13
#define LPC_GPIO_PIN2_VAL14_MASK 0x4000
#define LPC_GPIO_PIN2_VAL14 0x4000
#define LPC_GPIO_PIN2_VAL14_BIT 14
#define LPC_GPIO_PIN2_VAL15_MASK 0x8000
#define LPC_GPIO_PIN2_VAL15 0x8000
#define LPC_GPIO_PIN2_VAL15_BIT 15
#define LPC_GPIO_PIN2_VAL16_MASK 0x10000
#define LPC_GPIO_PIN2_VAL16 0x10000
#define LPC_GPIO_PIN2_VAL16_BIT 16
#define LPC_GPIO_PIN2_VAL17_MASK 0x20000
#define LPC_GPIO_PIN2_VAL17 0x20000
#define LPC_GPIO_PIN2_VAL17_BIT 17
#define LPC_GPIO_PIN2_VAL18_MASK 0x40000
#define LPC_GPIO_PIN2_VAL18 0x40000
#define LPC_GPIO_PIN2_VAL18_BIT 18
#define LPC_GPIO_PIN2_VAL19_MASK 0x80000
#define LPC_GPIO_PIN2_VAL19 0x80000
#define LPC_GPIO_PIN2_VAL19_BIT 19
#define LPC_GPIO_PIN2_VAL20_MASK 0x100000
#define LPC_GPIO_PIN2_VAL20 0x100000
#define LPC_GPIO_PIN2_VAL20_BIT 20
#define LPC_GPIO_PIN2_VAL21_MASK 0x200000
#define LPC_GPIO_PIN2_VAL21 0x200000
#define LPC_GPIO_PIN2_VAL21_BIT 21
#define LPC_GPIO_PIN2_VAL22_MASK 0x400000
#define LPC_GPIO_PIN2_VAL22 0x400000
#define LPC_GPIO_PIN2_VAL22_BIT 22
#define LPC_GPIO_PIN2_VAL23_MASK 0x800000
#define LPC_GPIO_PIN2_VAL23 0x800000
#define LPC_GPIO_PIN2_VAL23_BIT 23
#define LPC_GPIO_PIN2_VAL24_MASK 0x1000000
#define LPC_GPIO_PIN2_VAL24 0x1000000
#define LPC_GPIO_PIN2_VAL24_BIT 24
#define LPC_GPIO_PIN2_VAL25_MASK 0x2000000
#define LPC_GPIO_PIN2_VAL25 0x2000000
#define LPC_GPIO_PIN2_VAL25_BIT 25
#define LPC_GPIO_PIN2_VAL26_MASK 0x4000000
#define LPC_GPIO_PIN2_VAL26 0x4000000
#define LPC_GPIO_PIN2_VAL26_BIT 26
#define LPC_GPIO_PIN2_VAL27_MASK 0x8000000
#define LPC_GPIO_PIN2_VAL27 0x8000000
#define LPC_GPIO_PIN2_VAL27_BIT 27
#define LPC_GPIO_PIN2_VAL28_MASK 0x10000000
#define LPC_GPIO_PIN2_VAL28 0x10000000
#define LPC_GPIO_PIN2_VAL28_BIT 28
#define LPC_GPIO_PIN2_VAL29_MASK 0x20000000
#define LPC_GPIO_PIN2_VAL29 0x20000000
#define LPC_GPIO_PIN2_VAL29_BIT 29
#define LPC_GPIO_PIN2_VAL30_MASK 0x40000000
#define LPC_GPIO_PIN2_VAL30 0x40000000
#define LPC_GPIO_PIN2_VAL30_BIT 30
#define LPC_GPIO_PIN2_VAL31_MASK 0x80000000
#define LPC_GPIO_PIN2_VAL31 0x80000000
#define LPC_GPIO_PIN2_VAL31_BIT 31

#define LPC_GPIO_PIN3 (*(volatile unsigned long *)0x20098074)
#define LPC_GPIO_PIN3_OFFSET 0x74
#define LPC_GPIO_PIN3_VAL0_MASK 0x1
#define LPC_GPIO_PIN3_VAL0 0x1
#define LPC_GPIO_PIN3_VAL0_BIT 0
#define LPC_GPIO_PIN3_VAL1_MASK 0x2
#define LPC_GPIO_PIN3_VAL1 0x2
#define LPC_GPIO_PIN3_VAL1_BIT 1
#define LPC_GPIO_PIN3_VAL2_MASK 0x4
#define LPC_GPIO_PIN3_VAL2 0x4
#define LPC_GPIO_PIN3_VAL2_BIT 2
#define LPC_GPIO_PIN3_VAL3_MASK 0x8
#define LPC_GPIO_PIN3_VAL3 0x8
#define LPC_GPIO_PIN3_VAL3_BIT 3
#define LPC_GPIO_PIN3_VAL4_MASK 0x10
#define LPC_GPIO_PIN3_VAL4 0x10
#define LPC_GPIO_PIN3_VAL4_BIT 4
#define LPC_GPIO_PIN3_VAL5_MASK 0x20
#define LPC_GPIO_PIN3_VAL5 0x20
#define LPC_GPIO_PIN3_VAL5_BIT 5
#define LPC_GPIO_PIN3_VAL6_MASK 0x40
#define LPC_GPIO_PIN3_VAL6 0x40
#define LPC_GPIO_PIN3_VAL6_BIT 6
#define LPC_GPIO_PIN3_VAL7_MASK 0x80
#define LPC_GPIO_PIN3_VAL7 0x80
#define LPC_GPIO_PIN3_VAL7_BIT 7
#define LPC_GPIO_PIN3_VAL8_MASK 0x100
#define LPC_GPIO_PIN3_VAL8 0x100
#define LPC_GPIO_PIN3_VAL8_BIT 8
#define LPC_GPIO_PIN3_VAL9_MASK 0x200
#define LPC_GPIO_PIN3_VAL9 0x200
#define LPC_GPIO_PIN3_VAL9_BIT 9
#define LPC_GPIO_PIN3_VAL10_MASK 0x400
#define LPC_GPIO_PIN3_VAL10 0x400
#define LPC_GPIO_PIN3_VAL10_BIT 10
#define LPC_GPIO_PIN3_VAL11_MASK 0x800
#define LPC_GPIO_PIN3_VAL11 0x800
#define LPC_GPIO_PIN3_VAL11_BIT 11
#define LPC_GPIO_PIN3_VAL12_MASK 0x1000
#define LPC_GPIO_PIN3_VAL12 0x1000
#define LPC_GPIO_PIN3_VAL12_BIT 12
#define LPC_GPIO_PIN3_VAL13_MASK 0x2000
#define LPC_GPIO_PIN3_VAL13 0x2000
#define LPC_GPIO_PIN3_VAL13_BIT 13
#define LPC_GPIO_PIN3_VAL14_MASK 0x4000
#define LPC_GPIO_PIN3_VAL14 0x4000
#define LPC_GPIO_PIN3_VAL14_BIT 14
#define LPC_GPIO_PIN3_VAL15_MASK 0x8000
#define LPC_GPIO_PIN3_VAL15 0x8000
#define LPC_GPIO_PIN3_VAL15_BIT 15
#define LPC_GPIO_PIN3_VAL16_MASK 0x10000
#define LPC_GPIO_PIN3_VAL16 0x10000
#define LPC_GPIO_PIN3_VAL16_BIT 16
#define LPC_GPIO_PIN3_VAL17_MASK 0x20000
#define LPC_GPIO_PIN3_VAL17 0x20000
#define LPC_GPIO_PIN3_VAL17_BIT 17
#define LPC_GPIO_PIN3_VAL18_MASK 0x40000
#define LPC_GPIO_PIN3_VAL18 0x40000
#define LPC_GPIO_PIN3_VAL18_BIT 18
#define LPC_GPIO_PIN3_VAL19_MASK 0x80000
#define LPC_GPIO_PIN3_VAL19 0x80000
#define LPC_GPIO_PIN3_VAL19_BIT 19
#define LPC_GPIO_PIN3_VAL20_MASK 0x100000
#define LPC_GPIO_PIN3_VAL20 0x100000
#define LPC_GPIO_PIN3_VAL20_BIT 20
#define LPC_GPIO_PIN3_VAL21_MASK 0x200000
#define LPC_GPIO_PIN3_VAL21 0x200000
#define LPC_GPIO_PIN3_VAL21_BIT 21
#define LPC_GPIO_PIN3_VAL22_MASK 0x400000
#define LPC_GPIO_PIN3_VAL22 0x400000
#define LPC_GPIO_PIN3_VAL22_BIT 22
#define LPC_GPIO_PIN3_VAL23_MASK 0x800000
#define LPC_GPIO_PIN3_VAL23 0x800000
#define LPC_GPIO_PIN3_VAL23_BIT 23
#define LPC_GPIO_PIN3_VAL24_MASK 0x1000000
#define LPC_GPIO_PIN3_VAL24 0x1000000
#define LPC_GPIO_PIN3_VAL24_BIT 24
#define LPC_GPIO_PIN3_VAL25_MASK 0x2000000
#define LPC_GPIO_PIN3_VAL25 0x2000000
#define LPC_GPIO_PIN3_VAL25_BIT 25
#define LPC_GPIO_PIN3_VAL26_MASK 0x4000000
#define LPC_GPIO_PIN3_VAL26 0x4000000
#define LPC_GPIO_PIN3_VAL26_BIT 26
#define LPC_GPIO_PIN3_VAL27_MASK 0x8000000
#define LPC_GPIO_PIN3_VAL27 0x8000000
#define LPC_GPIO_PIN3_VAL27_BIT 27
#define LPC_GPIO_PIN3_VAL28_MASK 0x10000000
#define LPC_GPIO_PIN3_VAL28 0x10000000
#define LPC_GPIO_PIN3_VAL28_BIT 28
#define LPC_GPIO_PIN3_VAL29_MASK 0x20000000
#define LPC_GPIO_PIN3_VAL29 0x20000000
#define LPC_GPIO_PIN3_VAL29_BIT 29
#define LPC_GPIO_PIN3_VAL30_MASK 0x40000000
#define LPC_GPIO_PIN3_VAL30 0x40000000
#define LPC_GPIO_PIN3_VAL30_BIT 30
#define LPC_GPIO_PIN3_VAL31_MASK 0x80000000
#define LPC_GPIO_PIN3_VAL31 0x80000000
#define LPC_GPIO_PIN3_VAL31_BIT 31

#define LPC_GPIO_PIN4 (*(volatile unsigned long *)0x20098094)
#define LPC_GPIO_PIN4_OFFSET 0x94
#define LPC_GPIO_PIN4_VAL0_MASK 0x1
#define LPC_GPIO_PIN4_VAL0 0x1
#define LPC_GPIO_PIN4_VAL0_BIT 0
#define LPC_GPIO_PIN4_VAL1_MASK 0x2
#define LPC_GPIO_PIN4_VAL1 0x2
#define LPC_GPIO_PIN4_VAL1_BIT 1
#define LPC_GPIO_PIN4_VAL2_MASK 0x4
#define LPC_GPIO_PIN4_VAL2 0x4
#define LPC_GPIO_PIN4_VAL2_BIT 2
#define LPC_GPIO_PIN4_VAL3_MASK 0x8
#define LPC_GPIO_PIN4_VAL3 0x8
#define LPC_GPIO_PIN4_VAL3_BIT 3
#define LPC_GPIO_PIN4_VAL4_MASK 0x10
#define LPC_GPIO_PIN4_VAL4 0x10
#define LPC_GPIO_PIN4_VAL4_BIT 4
#define LPC_GPIO_PIN4_VAL5_MASK 0x20
#define LPC_GPIO_PIN4_VAL5 0x20
#define LPC_GPIO_PIN4_VAL5_BIT 5
#define LPC_GPIO_PIN4_VAL6_MASK 0x40
#define LPC_GPIO_PIN4_VAL6 0x40
#define LPC_GPIO_PIN4_VAL6_BIT 6
#define LPC_GPIO_PIN4_VAL7_MASK 0x80
#define LPC_GPIO_PIN4_VAL7 0x80
#define LPC_GPIO_PIN4_VAL7_BIT 7
#define LPC_GPIO_PIN4_VAL8_MASK 0x100
#define LPC_GPIO_PIN4_VAL8 0x100
#define LPC_GPIO_PIN4_VAL8_BIT 8
#define LPC_GPIO_PIN4_VAL9_MASK 0x200
#define LPC_GPIO_PIN4_VAL9 0x200
#define LPC_GPIO_PIN4_VAL9_BIT 9
#define LPC_GPIO_PIN4_VAL10_MASK 0x400
#define LPC_GPIO_PIN4_VAL10 0x400
#define LPC_GPIO_PIN4_VAL10_BIT 10
#define LPC_GPIO_PIN4_VAL11_MASK 0x800
#define LPC_GPIO_PIN4_VAL11 0x800
#define LPC_GPIO_PIN4_VAL11_BIT 11
#define LPC_GPIO_PIN4_VAL12_MASK 0x1000
#define LPC_GPIO_PIN4_VAL12 0x1000
#define LPC_GPIO_PIN4_VAL12_BIT 12
#define LPC_GPIO_PIN4_VAL13_MASK 0x2000
#define LPC_GPIO_PIN4_VAL13 0x2000
#define LPC_GPIO_PIN4_VAL13_BIT 13
#define LPC_GPIO_PIN4_VAL14_MASK 0x4000
#define LPC_GPIO_PIN4_VAL14 0x4000
#define LPC_GPIO_PIN4_VAL14_BIT 14
#define LPC_GPIO_PIN4_VAL15_MASK 0x8000
#define LPC_GPIO_PIN4_VAL15 0x8000
#define LPC_GPIO_PIN4_VAL15_BIT 15
#define LPC_GPIO_PIN4_VAL16_MASK 0x10000
#define LPC_GPIO_PIN4_VAL16 0x10000
#define LPC_GPIO_PIN4_VAL16_BIT 16
#define LPC_GPIO_PIN4_VAL17_MASK 0x20000
#define LPC_GPIO_PIN4_VAL17 0x20000
#define LPC_GPIO_PIN4_VAL17_BIT 17
#define LPC_GPIO_PIN4_VAL18_MASK 0x40000
#define LPC_GPIO_PIN4_VAL18 0x40000
#define LPC_GPIO_PIN4_VAL18_BIT 18
#define LPC_GPIO_PIN4_VAL19_MASK 0x80000
#define LPC_GPIO_PIN4_VAL19 0x80000
#define LPC_GPIO_PIN4_VAL19_BIT 19
#define LPC_GPIO_PIN4_VAL20_MASK 0x100000
#define LPC_GPIO_PIN4_VAL20 0x100000
#define LPC_GPIO_PIN4_VAL20_BIT 20
#define LPC_GPIO_PIN4_VAL21_MASK 0x200000
#define LPC_GPIO_PIN4_VAL21 0x200000
#define LPC_GPIO_PIN4_VAL21_BIT 21
#define LPC_GPIO_PIN4_VAL22_MASK 0x400000
#define LPC_GPIO_PIN4_VAL22 0x400000
#define LPC_GPIO_PIN4_VAL22_BIT 22
#define LPC_GPIO_PIN4_VAL23_MASK 0x800000
#define LPC_GPIO_PIN4_VAL23 0x800000
#define LPC_GPIO_PIN4_VAL23_BIT 23
#define LPC_GPIO_PIN4_VAL24_MASK 0x1000000
#define LPC_GPIO_PIN4_VAL24 0x1000000
#define LPC_GPIO_PIN4_VAL24_BIT 24
#define LPC_GPIO_PIN4_VAL25_MASK 0x2000000
#define LPC_GPIO_PIN4_VAL25 0x2000000
#define LPC_GPIO_PIN4_VAL25_BIT 25
#define LPC_GPIO_PIN4_VAL26_MASK 0x4000000
#define LPC_GPIO_PIN4_VAL26 0x4000000
#define LPC_GPIO_PIN4_VAL26_BIT 26
#define LPC_GPIO_PIN4_VAL27_MASK 0x8000000
#define LPC_GPIO_PIN4_VAL27 0x8000000
#define LPC_GPIO_PIN4_VAL27_BIT 27
#define LPC_GPIO_PIN4_VAL28_MASK 0x10000000
#define LPC_GPIO_PIN4_VAL28 0x10000000
#define LPC_GPIO_PIN4_VAL28_BIT 28
#define LPC_GPIO_PIN4_VAL29_MASK 0x20000000
#define LPC_GPIO_PIN4_VAL29 0x20000000
#define LPC_GPIO_PIN4_VAL29_BIT 29
#define LPC_GPIO_PIN4_VAL30_MASK 0x40000000
#define LPC_GPIO_PIN4_VAL30 0x40000000
#define LPC_GPIO_PIN4_VAL30_BIT 30
#define LPC_GPIO_PIN4_VAL31_MASK 0x80000000
#define LPC_GPIO_PIN4_VAL31 0x80000000
#define LPC_GPIO_PIN4_VAL31_BIT 31

#define LPC_GPIO_PIN5 (*(volatile unsigned long *)0x200980B4)
#define LPC_GPIO_PIN5_OFFSET 0xB4
#define LPC_GPIO_PIN5_VAL0_MASK 0x1
#define LPC_GPIO_PIN5_VAL0 0x1
#define LPC_GPIO_PIN5_VAL0_BIT 0
#define LPC_GPIO_PIN5_VAL1_MASK 0x2
#define LPC_GPIO_PIN5_VAL1 0x2
#define LPC_GPIO_PIN5_VAL1_BIT 1
#define LPC_GPIO_PIN5_VAL2_MASK 0x4
#define LPC_GPIO_PIN5_VAL2 0x4
#define LPC_GPIO_PIN5_VAL2_BIT 2
#define LPC_GPIO_PIN5_VAL3_MASK 0x8
#define LPC_GPIO_PIN5_VAL3 0x8
#define LPC_GPIO_PIN5_VAL3_BIT 3
#define LPC_GPIO_PIN5_VAL4_MASK 0x10
#define LPC_GPIO_PIN5_VAL4 0x10
#define LPC_GPIO_PIN5_VAL4_BIT 4
#define LPC_GPIO_PIN5_VAL5_MASK 0x20
#define LPC_GPIO_PIN5_VAL5 0x20
#define LPC_GPIO_PIN5_VAL5_BIT 5
#define LPC_GPIO_PIN5_VAL6_MASK 0x40
#define LPC_GPIO_PIN5_VAL6 0x40
#define LPC_GPIO_PIN5_VAL6_BIT 6
#define LPC_GPIO_PIN5_VAL7_MASK 0x80
#define LPC_GPIO_PIN5_VAL7 0x80
#define LPC_GPIO_PIN5_VAL7_BIT 7
#define LPC_GPIO_PIN5_VAL8_MASK 0x100
#define LPC_GPIO_PIN5_VAL8 0x100
#define LPC_GPIO_PIN5_VAL8_BIT 8
#define LPC_GPIO_PIN5_VAL9_MASK 0x200
#define LPC_GPIO_PIN5_VAL9 0x200
#define LPC_GPIO_PIN5_VAL9_BIT 9
#define LPC_GPIO_PIN5_VAL10_MASK 0x400
#define LPC_GPIO_PIN5_VAL10 0x400
#define LPC_GPIO_PIN5_VAL10_BIT 10
#define LPC_GPIO_PIN5_VAL11_MASK 0x800
#define LPC_GPIO_PIN5_VAL11 0x800
#define LPC_GPIO_PIN5_VAL11_BIT 11
#define LPC_GPIO_PIN5_VAL12_MASK 0x1000
#define LPC_GPIO_PIN5_VAL12 0x1000
#define LPC_GPIO_PIN5_VAL12_BIT 12
#define LPC_GPIO_PIN5_VAL13_MASK 0x2000
#define LPC_GPIO_PIN5_VAL13 0x2000
#define LPC_GPIO_PIN5_VAL13_BIT 13
#define LPC_GPIO_PIN5_VAL14_MASK 0x4000
#define LPC_GPIO_PIN5_VAL14 0x4000
#define LPC_GPIO_PIN5_VAL14_BIT 14
#define LPC_GPIO_PIN5_VAL15_MASK 0x8000
#define LPC_GPIO_PIN5_VAL15 0x8000
#define LPC_GPIO_PIN5_VAL15_BIT 15
#define LPC_GPIO_PIN5_VAL16_MASK 0x10000
#define LPC_GPIO_PIN5_VAL16 0x10000
#define LPC_GPIO_PIN5_VAL16_BIT 16
#define LPC_GPIO_PIN5_VAL17_MASK 0x20000
#define LPC_GPIO_PIN5_VAL17 0x20000
#define LPC_GPIO_PIN5_VAL17_BIT 17
#define LPC_GPIO_PIN5_VAL18_MASK 0x40000
#define LPC_GPIO_PIN5_VAL18 0x40000
#define LPC_GPIO_PIN5_VAL18_BIT 18
#define LPC_GPIO_PIN5_VAL19_MASK 0x80000
#define LPC_GPIO_PIN5_VAL19 0x80000
#define LPC_GPIO_PIN5_VAL19_BIT 19
#define LPC_GPIO_PIN5_VAL20_MASK 0x100000
#define LPC_GPIO_PIN5_VAL20 0x100000
#define LPC_GPIO_PIN5_VAL20_BIT 20
#define LPC_GPIO_PIN5_VAL21_MASK 0x200000
#define LPC_GPIO_PIN5_VAL21 0x200000
#define LPC_GPIO_PIN5_VAL21_BIT 21
#define LPC_GPIO_PIN5_VAL22_MASK 0x400000
#define LPC_GPIO_PIN5_VAL22 0x400000
#define LPC_GPIO_PIN5_VAL22_BIT 22
#define LPC_GPIO_PIN5_VAL23_MASK 0x800000
#define LPC_GPIO_PIN5_VAL23 0x800000
#define LPC_GPIO_PIN5_VAL23_BIT 23
#define LPC_GPIO_PIN5_VAL24_MASK 0x1000000
#define LPC_GPIO_PIN5_VAL24 0x1000000
#define LPC_GPIO_PIN5_VAL24_BIT 24
#define LPC_GPIO_PIN5_VAL25_MASK 0x2000000
#define LPC_GPIO_PIN5_VAL25 0x2000000
#define LPC_GPIO_PIN5_VAL25_BIT 25
#define LPC_GPIO_PIN5_VAL26_MASK 0x4000000
#define LPC_GPIO_PIN5_VAL26 0x4000000
#define LPC_GPIO_PIN5_VAL26_BIT 26
#define LPC_GPIO_PIN5_VAL27_MASK 0x8000000
#define LPC_GPIO_PIN5_VAL27 0x8000000
#define LPC_GPIO_PIN5_VAL27_BIT 27
#define LPC_GPIO_PIN5_VAL28_MASK 0x10000000
#define LPC_GPIO_PIN5_VAL28 0x10000000
#define LPC_GPIO_PIN5_VAL28_BIT 28
#define LPC_GPIO_PIN5_VAL29_MASK 0x20000000
#define LPC_GPIO_PIN5_VAL29 0x20000000
#define LPC_GPIO_PIN5_VAL29_BIT 29
#define LPC_GPIO_PIN5_VAL30_MASK 0x40000000
#define LPC_GPIO_PIN5_VAL30 0x40000000
#define LPC_GPIO_PIN5_VAL30_BIT 30
#define LPC_GPIO_PIN5_VAL31_MASK 0x80000000
#define LPC_GPIO_PIN5_VAL31 0x80000000
#define LPC_GPIO_PIN5_VAL31_BIT 31

#define LPC_GPIO_SET0 (*(volatile unsigned long *)0x20098018)
#define LPC_GPIO_SET0_OFFSET 0x18
#define LPC_GPIO_SET0_PSET0_MASK 0x1
#define LPC_GPIO_SET0_PSET0 0x1
#define LPC_GPIO_SET0_PSET0_BIT 0
#define LPC_GPIO_SET0_PSET1_MASK 0x2
#define LPC_GPIO_SET0_PSET1 0x2
#define LPC_GPIO_SET0_PSET1_BIT 1
#define LPC_GPIO_SET0_PSET2_MASK 0x4
#define LPC_GPIO_SET0_PSET2 0x4
#define LPC_GPIO_SET0_PSET2_BIT 2
#define LPC_GPIO_SET0_PSET3_MASK 0x8
#define LPC_GPIO_SET0_PSET3 0x8
#define LPC_GPIO_SET0_PSET3_BIT 3
#define LPC_GPIO_SET0_PSET4_MASK 0x10
#define LPC_GPIO_SET0_PSET4 0x10
#define LPC_GPIO_SET0_PSET4_BIT 4
#define LPC_GPIO_SET0_PSET5_MASK 0x20
#define LPC_GPIO_SET0_PSET5 0x20
#define LPC_GPIO_SET0_PSET5_BIT 5
#define LPC_GPIO_SET0_PSET6_MASK 0x40
#define LPC_GPIO_SET0_PSET6 0x40
#define LPC_GPIO_SET0_PSET6_BIT 6
#define LPC_GPIO_SET0_PSET7_MASK 0x80
#define LPC_GPIO_SET0_PSET7 0x80
#define LPC_GPIO_SET0_PSET7_BIT 7
#define LPC_GPIO_SET0_PSET8_MASK 0x100
#define LPC_GPIO_SET0_PSET8 0x100
#define LPC_GPIO_SET0_PSET8_BIT 8
#define LPC_GPIO_SET0_PSET9_MASK 0x200
#define LPC_GPIO_SET0_PSET9 0x200
#define LPC_GPIO_SET0_PSET9_BIT 9
#define LPC_GPIO_SET0_PSET10_MASK 0x400
#define LPC_GPIO_SET0_PSET10 0x400
#define LPC_GPIO_SET0_PSET10_BIT 10
#define LPC_GPIO_SET0_PSET11_MASK 0x800
#define LPC_GPIO_SET0_PSET11 0x800
#define LPC_GPIO_SET0_PSET11_BIT 11
#define LPC_GPIO_SET0_PSET12_MASK 0x1000
#define LPC_GPIO_SET0_PSET12 0x1000
#define LPC_GPIO_SET0_PSET12_BIT 12
#define LPC_GPIO_SET0_PSET13_MASK 0x2000
#define LPC_GPIO_SET0_PSET13 0x2000
#define LPC_GPIO_SET0_PSET13_BIT 13
#define LPC_GPIO_SET0_PSET14_MASK 0x4000
#define LPC_GPIO_SET0_PSET14 0x4000
#define LPC_GPIO_SET0_PSET14_BIT 14
#define LPC_GPIO_SET0_PSET15_MASK 0x8000
#define LPC_GPIO_SET0_PSET15 0x8000
#define LPC_GPIO_SET0_PSET15_BIT 15
#define LPC_GPIO_SET0_PSET16_MASK 0x10000
#define LPC_GPIO_SET0_PSET16 0x10000
#define LPC_GPIO_SET0_PSET16_BIT 16
#define LPC_GPIO_SET0_PSET17_MASK 0x20000
#define LPC_GPIO_SET0_PSET17 0x20000
#define LPC_GPIO_SET0_PSET17_BIT 17
#define LPC_GPIO_SET0_PSET18_MASK 0x40000
#define LPC_GPIO_SET0_PSET18 0x40000
#define LPC_GPIO_SET0_PSET18_BIT 18
#define LPC_GPIO_SET0_PSET19_MASK 0x80000
#define LPC_GPIO_SET0_PSET19 0x80000
#define LPC_GPIO_SET0_PSET19_BIT 19
#define LPC_GPIO_SET0_PSET20_MASK 0x100000
#define LPC_GPIO_SET0_PSET20 0x100000
#define LPC_GPIO_SET0_PSET20_BIT 20
#define LPC_GPIO_SET0_PSET21_MASK 0x200000
#define LPC_GPIO_SET0_PSET21 0x200000
#define LPC_GPIO_SET0_PSET21_BIT 21
#define LPC_GPIO_SET0_PSET22_MASK 0x400000
#define LPC_GPIO_SET0_PSET22 0x400000
#define LPC_GPIO_SET0_PSET22_BIT 22
#define LPC_GPIO_SET0_PSET23_MASK 0x800000
#define LPC_GPIO_SET0_PSET23 0x800000
#define LPC_GPIO_SET0_PSET23_BIT 23
#define LPC_GPIO_SET0_PSET24_MASK 0x1000000
#define LPC_GPIO_SET0_PSET24 0x1000000
#define LPC_GPIO_SET0_PSET24_BIT 24
#define LPC_GPIO_SET0_PSET25_MASK 0x2000000
#define LPC_GPIO_SET0_PSET25 0x2000000
#define LPC_GPIO_SET0_PSET25_BIT 25
#define LPC_GPIO_SET0_PSET26_MASK 0x4000000
#define LPC_GPIO_SET0_PSET26 0x4000000
#define LPC_GPIO_SET0_PSET26_BIT 26
#define LPC_GPIO_SET0_PSET27_MASK 0x8000000
#define LPC_GPIO_SET0_PSET27 0x8000000
#define LPC_GPIO_SET0_PSET27_BIT 27
#define LPC_GPIO_SET0_PSET28_MASK 0x10000000
#define LPC_GPIO_SET0_PSET28 0x10000000
#define LPC_GPIO_SET0_PSET28_BIT 28
#define LPC_GPIO_SET0_PSET29_MASK 0x20000000
#define LPC_GPIO_SET0_PSET29 0x20000000
#define LPC_GPIO_SET0_PSET29_BIT 29
#define LPC_GPIO_SET0_PSET30_MASK 0x40000000
#define LPC_GPIO_SET0_PSET30 0x40000000
#define LPC_GPIO_SET0_PSET30_BIT 30
#define LPC_GPIO_SET0_PSET31_MASK 0x80000000
#define LPC_GPIO_SET0_PSET31 0x80000000
#define LPC_GPIO_SET0_PSET31_BIT 31

#define LPC_GPIO_SET1 (*(volatile unsigned long *)0x20098038)
#define LPC_GPIO_SET1_OFFSET 0x38
#define LPC_GPIO_SET1_PSET0_MASK 0x1
#define LPC_GPIO_SET1_PSET0 0x1
#define LPC_GPIO_SET1_PSET0_BIT 0
#define LPC_GPIO_SET1_PSET1_MASK 0x2
#define LPC_GPIO_SET1_PSET1 0x2
#define LPC_GPIO_SET1_PSET1_BIT 1
#define LPC_GPIO_SET1_PSET2_MASK 0x4
#define LPC_GPIO_SET1_PSET2 0x4
#define LPC_GPIO_SET1_PSET2_BIT 2
#define LPC_GPIO_SET1_PSET3_MASK 0x8
#define LPC_GPIO_SET1_PSET3 0x8
#define LPC_GPIO_SET1_PSET3_BIT 3
#define LPC_GPIO_SET1_PSET4_MASK 0x10
#define LPC_GPIO_SET1_PSET4 0x10
#define LPC_GPIO_SET1_PSET4_BIT 4
#define LPC_GPIO_SET1_PSET5_MASK 0x20
#define LPC_GPIO_SET1_PSET5 0x20
#define LPC_GPIO_SET1_PSET5_BIT 5
#define LPC_GPIO_SET1_PSET6_MASK 0x40
#define LPC_GPIO_SET1_PSET6 0x40
#define LPC_GPIO_SET1_PSET6_BIT 6
#define LPC_GPIO_SET1_PSET7_MASK 0x80
#define LPC_GPIO_SET1_PSET7 0x80
#define LPC_GPIO_SET1_PSET7_BIT 7
#define LPC_GPIO_SET1_PSET8_MASK 0x100
#define LPC_GPIO_SET1_PSET8 0x100
#define LPC_GPIO_SET1_PSET8_BIT 8
#define LPC_GPIO_SET1_PSET9_MASK 0x200
#define LPC_GPIO_SET1_PSET9 0x200
#define LPC_GPIO_SET1_PSET9_BIT 9
#define LPC_GPIO_SET1_PSET10_MASK 0x400
#define LPC_GPIO_SET1_PSET10 0x400
#define LPC_GPIO_SET1_PSET10_BIT 10
#define LPC_GPIO_SET1_PSET11_MASK 0x800
#define LPC_GPIO_SET1_PSET11 0x800
#define LPC_GPIO_SET1_PSET11_BIT 11
#define LPC_GPIO_SET1_PSET12_MASK 0x1000
#define LPC_GPIO_SET1_PSET12 0x1000
#define LPC_GPIO_SET1_PSET12_BIT 12
#define LPC_GPIO_SET1_PSET13_MASK 0x2000
#define LPC_GPIO_SET1_PSET13 0x2000
#define LPC_GPIO_SET1_PSET13_BIT 13
#define LPC_GPIO_SET1_PSET14_MASK 0x4000
#define LPC_GPIO_SET1_PSET14 0x4000
#define LPC_GPIO_SET1_PSET14_BIT 14
#define LPC_GPIO_SET1_PSET15_MASK 0x8000
#define LPC_GPIO_SET1_PSET15 0x8000
#define LPC_GPIO_SET1_PSET15_BIT 15
#define LPC_GPIO_SET1_PSET16_MASK 0x10000
#define LPC_GPIO_SET1_PSET16 0x10000
#define LPC_GPIO_SET1_PSET16_BIT 16
#define LPC_GPIO_SET1_PSET17_MASK 0x20000
#define LPC_GPIO_SET1_PSET17 0x20000
#define LPC_GPIO_SET1_PSET17_BIT 17
#define LPC_GPIO_SET1_PSET18_MASK 0x40000
#define LPC_GPIO_SET1_PSET18 0x40000
#define LPC_GPIO_SET1_PSET18_BIT 18
#define LPC_GPIO_SET1_PSET19_MASK 0x80000
#define LPC_GPIO_SET1_PSET19 0x80000
#define LPC_GPIO_SET1_PSET19_BIT 19
#define LPC_GPIO_SET1_PSET20_MASK 0x100000
#define LPC_GPIO_SET1_PSET20 0x100000
#define LPC_GPIO_SET1_PSET20_BIT 20
#define LPC_GPIO_SET1_PSET21_MASK 0x200000
#define LPC_GPIO_SET1_PSET21 0x200000
#define LPC_GPIO_SET1_PSET21_BIT 21
#define LPC_GPIO_SET1_PSET22_MASK 0x400000
#define LPC_GPIO_SET1_PSET22 0x400000
#define LPC_GPIO_SET1_PSET22_BIT 22
#define LPC_GPIO_SET1_PSET23_MASK 0x800000
#define LPC_GPIO_SET1_PSET23 0x800000
#define LPC_GPIO_SET1_PSET23_BIT 23
#define LPC_GPIO_SET1_PSET24_MASK 0x1000000
#define LPC_GPIO_SET1_PSET24 0x1000000
#define LPC_GPIO_SET1_PSET24_BIT 24
#define LPC_GPIO_SET1_PSET25_MASK 0x2000000
#define LPC_GPIO_SET1_PSET25 0x2000000
#define LPC_GPIO_SET1_PSET25_BIT 25
#define LPC_GPIO_SET1_PSET26_MASK 0x4000000
#define LPC_GPIO_SET1_PSET26 0x4000000
#define LPC_GPIO_SET1_PSET26_BIT 26
#define LPC_GPIO_SET1_PSET27_MASK 0x8000000
#define LPC_GPIO_SET1_PSET27 0x8000000
#define LPC_GPIO_SET1_PSET27_BIT 27
#define LPC_GPIO_SET1_PSET28_MASK 0x10000000
#define LPC_GPIO_SET1_PSET28 0x10000000
#define LPC_GPIO_SET1_PSET28_BIT 28
#define LPC_GPIO_SET1_PSET29_MASK 0x20000000
#define LPC_GPIO_SET1_PSET29 0x20000000
#define LPC_GPIO_SET1_PSET29_BIT 29
#define LPC_GPIO_SET1_PSET30_MASK 0x40000000
#define LPC_GPIO_SET1_PSET30 0x40000000
#define LPC_GPIO_SET1_PSET30_BIT 30
#define LPC_GPIO_SET1_PSET31_MASK 0x80000000
#define LPC_GPIO_SET1_PSET31 0x80000000
#define LPC_GPIO_SET1_PSET31_BIT 31

#define LPC_GPIO_SET2 (*(volatile unsigned long *)0x20098058)
#define LPC_GPIO_SET2_OFFSET 0x58
#define LPC_GPIO_SET2_PSET0_MASK 0x1
#define LPC_GPIO_SET2_PSET0 0x1
#define LPC_GPIO_SET2_PSET0_BIT 0
#define LPC_GPIO_SET2_PSET1_MASK 0x2
#define LPC_GPIO_SET2_PSET1 0x2
#define LPC_GPIO_SET2_PSET1_BIT 1
#define LPC_GPIO_SET2_PSET2_MASK 0x4
#define LPC_GPIO_SET2_PSET2 0x4
#define LPC_GPIO_SET2_PSET2_BIT 2
#define LPC_GPIO_SET2_PSET3_MASK 0x8
#define LPC_GPIO_SET2_PSET3 0x8
#define LPC_GPIO_SET2_PSET3_BIT 3
#define LPC_GPIO_SET2_PSET4_MASK 0x10
#define LPC_GPIO_SET2_PSET4 0x10
#define LPC_GPIO_SET2_PSET4_BIT 4
#define LPC_GPIO_SET2_PSET5_MASK 0x20
#define LPC_GPIO_SET2_PSET5 0x20
#define LPC_GPIO_SET2_PSET5_BIT 5
#define LPC_GPIO_SET2_PSET6_MASK 0x40
#define LPC_GPIO_SET2_PSET6 0x40
#define LPC_GPIO_SET2_PSET6_BIT 6
#define LPC_GPIO_SET2_PSET7_MASK 0x80
#define LPC_GPIO_SET2_PSET7 0x80
#define LPC_GPIO_SET2_PSET7_BIT 7
#define LPC_GPIO_SET2_PSET8_MASK 0x100
#define LPC_GPIO_SET2_PSET8 0x100
#define LPC_GPIO_SET2_PSET8_BIT 8
#define LPC_GPIO_SET2_PSET9_MASK 0x200
#define LPC_GPIO_SET2_PSET9 0x200
#define LPC_GPIO_SET2_PSET9_BIT 9
#define LPC_GPIO_SET2_PSET10_MASK 0x400
#define LPC_GPIO_SET2_PSET10 0x400
#define LPC_GPIO_SET2_PSET10_BIT 10
#define LPC_GPIO_SET2_PSET11_MASK 0x800
#define LPC_GPIO_SET2_PSET11 0x800
#define LPC_GPIO_SET2_PSET11_BIT 11
#define LPC_GPIO_SET2_PSET12_MASK 0x1000
#define LPC_GPIO_SET2_PSET12 0x1000
#define LPC_GPIO_SET2_PSET12_BIT 12
#define LPC_GPIO_SET2_PSET13_MASK 0x2000
#define LPC_GPIO_SET2_PSET13 0x2000
#define LPC_GPIO_SET2_PSET13_BIT 13
#define LPC_GPIO_SET2_PSET14_MASK 0x4000
#define LPC_GPIO_SET2_PSET14 0x4000
#define LPC_GPIO_SET2_PSET14_BIT 14
#define LPC_GPIO_SET2_PSET15_MASK 0x8000
#define LPC_GPIO_SET2_PSET15 0x8000
#define LPC_GPIO_SET2_PSET15_BIT 15
#define LPC_GPIO_SET2_PSET16_MASK 0x10000
#define LPC_GPIO_SET2_PSET16 0x10000
#define LPC_GPIO_SET2_PSET16_BIT 16
#define LPC_GPIO_SET2_PSET17_MASK 0x20000
#define LPC_GPIO_SET2_PSET17 0x20000
#define LPC_GPIO_SET2_PSET17_BIT 17
#define LPC_GPIO_SET2_PSET18_MASK 0x40000
#define LPC_GPIO_SET2_PSET18 0x40000
#define LPC_GPIO_SET2_PSET18_BIT 18
#define LPC_GPIO_SET2_PSET19_MASK 0x80000
#define LPC_GPIO_SET2_PSET19 0x80000
#define LPC_GPIO_SET2_PSET19_BIT 19
#define LPC_GPIO_SET2_PSET20_MASK 0x100000
#define LPC_GPIO_SET2_PSET20 0x100000
#define LPC_GPIO_SET2_PSET20_BIT 20
#define LPC_GPIO_SET2_PSET21_MASK 0x200000
#define LPC_GPIO_SET2_PSET21 0x200000
#define LPC_GPIO_SET2_PSET21_BIT 21
#define LPC_GPIO_SET2_PSET22_MASK 0x400000
#define LPC_GPIO_SET2_PSET22 0x400000
#define LPC_GPIO_SET2_PSET22_BIT 22
#define LPC_GPIO_SET2_PSET23_MASK 0x800000
#define LPC_GPIO_SET2_PSET23 0x800000
#define LPC_GPIO_SET2_PSET23_BIT 23
#define LPC_GPIO_SET2_PSET24_MASK 0x1000000
#define LPC_GPIO_SET2_PSET24 0x1000000
#define LPC_GPIO_SET2_PSET24_BIT 24
#define LPC_GPIO_SET2_PSET25_MASK 0x2000000
#define LPC_GPIO_SET2_PSET25 0x2000000
#define LPC_GPIO_SET2_PSET25_BIT 25
#define LPC_GPIO_SET2_PSET26_MASK 0x4000000
#define LPC_GPIO_SET2_PSET26 0x4000000
#define LPC_GPIO_SET2_PSET26_BIT 26
#define LPC_GPIO_SET2_PSET27_MASK 0x8000000
#define LPC_GPIO_SET2_PSET27 0x8000000
#define LPC_GPIO_SET2_PSET27_BIT 27
#define LPC_GPIO_SET2_PSET28_MASK 0x10000000
#define LPC_GPIO_SET2_PSET28 0x10000000
#define LPC_GPIO_SET2_PSET28_BIT 28
#define LPC_GPIO_SET2_PSET29_MASK 0x20000000
#define LPC_GPIO_SET2_PSET29 0x20000000
#define LPC_GPIO_SET2_PSET29_BIT 29
#define LPC_GPIO_SET2_PSET30_MASK 0x40000000
#define LPC_GPIO_SET2_PSET30 0x40000000
#define LPC_GPIO_SET2_PSET30_BIT 30
#define LPC_GPIO_SET2_PSET31_MASK 0x80000000
#define LPC_GPIO_SET2_PSET31 0x80000000
#define LPC_GPIO_SET2_PSET31_BIT 31

#define LPC_GPIO_SET3 (*(volatile unsigned long *)0x20098078)
#define LPC_GPIO_SET3_OFFSET 0x78
#define LPC_GPIO_SET3_PSET0_MASK 0x1
#define LPC_GPIO_SET3_PSET0 0x1
#define LPC_GPIO_SET3_PSET0_BIT 0
#define LPC_GPIO_SET3_PSET1_MASK 0x2
#define LPC_GPIO_SET3_PSET1 0x2
#define LPC_GPIO_SET3_PSET1_BIT 1
#define LPC_GPIO_SET3_PSET2_MASK 0x4
#define LPC_GPIO_SET3_PSET2 0x4
#define LPC_GPIO_SET3_PSET2_BIT 2
#define LPC_GPIO_SET3_PSET3_MASK 0x8
#define LPC_GPIO_SET3_PSET3 0x8
#define LPC_GPIO_SET3_PSET3_BIT 3
#define LPC_GPIO_SET3_PSET4_MASK 0x10
#define LPC_GPIO_SET3_PSET4 0x10
#define LPC_GPIO_SET3_PSET4_BIT 4
#define LPC_GPIO_SET3_PSET5_MASK 0x20
#define LPC_GPIO_SET3_PSET5 0x20
#define LPC_GPIO_SET3_PSET5_BIT 5
#define LPC_GPIO_SET3_PSET6_MASK 0x40
#define LPC_GPIO_SET3_PSET6 0x40
#define LPC_GPIO_SET3_PSET6_BIT 6
#define LPC_GPIO_SET3_PSET7_MASK 0x80
#define LPC_GPIO_SET3_PSET7 0x80
#define LPC_GPIO_SET3_PSET7_BIT 7
#define LPC_GPIO_SET3_PSET8_MASK 0x100
#define LPC_GPIO_SET3_PSET8 0x100
#define LPC_GPIO_SET3_PSET8_BIT 8
#define LPC_GPIO_SET3_PSET9_MASK 0x200
#define LPC_GPIO_SET3_PSET9 0x200
#define LPC_GPIO_SET3_PSET9_BIT 9
#define LPC_GPIO_SET3_PSET10_MASK 0x400
#define LPC_GPIO_SET3_PSET10 0x400
#define LPC_GPIO_SET3_PSET10_BIT 10
#define LPC_GPIO_SET3_PSET11_MASK 0x800
#define LPC_GPIO_SET3_PSET11 0x800
#define LPC_GPIO_SET3_PSET11_BIT 11
#define LPC_GPIO_SET3_PSET12_MASK 0x1000
#define LPC_GPIO_SET3_PSET12 0x1000
#define LPC_GPIO_SET3_PSET12_BIT 12
#define LPC_GPIO_SET3_PSET13_MASK 0x2000
#define LPC_GPIO_SET3_PSET13 0x2000
#define LPC_GPIO_SET3_PSET13_BIT 13
#define LPC_GPIO_SET3_PSET14_MASK 0x4000
#define LPC_GPIO_SET3_PSET14 0x4000
#define LPC_GPIO_SET3_PSET14_BIT 14
#define LPC_GPIO_SET3_PSET15_MASK 0x8000
#define LPC_GPIO_SET3_PSET15 0x8000
#define LPC_GPIO_SET3_PSET15_BIT 15
#define LPC_GPIO_SET3_PSET16_MASK 0x10000
#define LPC_GPIO_SET3_PSET16 0x10000
#define LPC_GPIO_SET3_PSET16_BIT 16
#define LPC_GPIO_SET3_PSET17_MASK 0x20000
#define LPC_GPIO_SET3_PSET17 0x20000
#define LPC_GPIO_SET3_PSET17_BIT 17
#define LPC_GPIO_SET3_PSET18_MASK 0x40000
#define LPC_GPIO_SET3_PSET18 0x40000
#define LPC_GPIO_SET3_PSET18_BIT 18
#define LPC_GPIO_SET3_PSET19_MASK 0x80000
#define LPC_GPIO_SET3_PSET19 0x80000
#define LPC_GPIO_SET3_PSET19_BIT 19
#define LPC_GPIO_SET3_PSET20_MASK 0x100000
#define LPC_GPIO_SET3_PSET20 0x100000
#define LPC_GPIO_SET3_PSET20_BIT 20
#define LPC_GPIO_SET3_PSET21_MASK 0x200000
#define LPC_GPIO_SET3_PSET21 0x200000
#define LPC_GPIO_SET3_PSET21_BIT 21
#define LPC_GPIO_SET3_PSET22_MASK 0x400000
#define LPC_GPIO_SET3_PSET22 0x400000
#define LPC_GPIO_SET3_PSET22_BIT 22
#define LPC_GPIO_SET3_PSET23_MASK 0x800000
#define LPC_GPIO_SET3_PSET23 0x800000
#define LPC_GPIO_SET3_PSET23_BIT 23
#define LPC_GPIO_SET3_PSET24_MASK 0x1000000
#define LPC_GPIO_SET3_PSET24 0x1000000
#define LPC_GPIO_SET3_PSET24_BIT 24
#define LPC_GPIO_SET3_PSET25_MASK 0x2000000
#define LPC_GPIO_SET3_PSET25 0x2000000
#define LPC_GPIO_SET3_PSET25_BIT 25
#define LPC_GPIO_SET3_PSET26_MASK 0x4000000
#define LPC_GPIO_SET3_PSET26 0x4000000
#define LPC_GPIO_SET3_PSET26_BIT 26
#define LPC_GPIO_SET3_PSET27_MASK 0x8000000
#define LPC_GPIO_SET3_PSET27 0x8000000
#define LPC_GPIO_SET3_PSET27_BIT 27
#define LPC_GPIO_SET3_PSET28_MASK 0x10000000
#define LPC_GPIO_SET3_PSET28 0x10000000
#define LPC_GPIO_SET3_PSET28_BIT 28
#define LPC_GPIO_SET3_PSET29_MASK 0x20000000
#define LPC_GPIO_SET3_PSET29 0x20000000
#define LPC_GPIO_SET3_PSET29_BIT 29
#define LPC_GPIO_SET3_PSET30_MASK 0x40000000
#define LPC_GPIO_SET3_PSET30 0x40000000
#define LPC_GPIO_SET3_PSET30_BIT 30
#define LPC_GPIO_SET3_PSET31_MASK 0x80000000
#define LPC_GPIO_SET3_PSET31 0x80000000
#define LPC_GPIO_SET3_PSET31_BIT 31

#define LPC_GPIO_SET4 (*(volatile unsigned long *)0x20098098)
#define LPC_GPIO_SET4_OFFSET 0x98
#define LPC_GPIO_SET4_PSET0_MASK 0x1
#define LPC_GPIO_SET4_PSET0 0x1
#define LPC_GPIO_SET4_PSET0_BIT 0
#define LPC_GPIO_SET4_PSET1_MASK 0x2
#define LPC_GPIO_SET4_PSET1 0x2
#define LPC_GPIO_SET4_PSET1_BIT 1
#define LPC_GPIO_SET4_PSET2_MASK 0x4
#define LPC_GPIO_SET4_PSET2 0x4
#define LPC_GPIO_SET4_PSET2_BIT 2
#define LPC_GPIO_SET4_PSET3_MASK 0x8
#define LPC_GPIO_SET4_PSET3 0x8
#define LPC_GPIO_SET4_PSET3_BIT 3
#define LPC_GPIO_SET4_PSET4_MASK 0x10
#define LPC_GPIO_SET4_PSET4 0x10
#define LPC_GPIO_SET4_PSET4_BIT 4
#define LPC_GPIO_SET4_PSET5_MASK 0x20
#define LPC_GPIO_SET4_PSET5 0x20
#define LPC_GPIO_SET4_PSET5_BIT 5
#define LPC_GPIO_SET4_PSET6_MASK 0x40
#define LPC_GPIO_SET4_PSET6 0x40
#define LPC_GPIO_SET4_PSET6_BIT 6
#define LPC_GPIO_SET4_PSET7_MASK 0x80
#define LPC_GPIO_SET4_PSET7 0x80
#define LPC_GPIO_SET4_PSET7_BIT 7
#define LPC_GPIO_SET4_PSET8_MASK 0x100
#define LPC_GPIO_SET4_PSET8 0x100
#define LPC_GPIO_SET4_PSET8_BIT 8
#define LPC_GPIO_SET4_PSET9_MASK 0x200
#define LPC_GPIO_SET4_PSET9 0x200
#define LPC_GPIO_SET4_PSET9_BIT 9
#define LPC_GPIO_SET4_PSET10_MASK 0x400
#define LPC_GPIO_SET4_PSET10 0x400
#define LPC_GPIO_SET4_PSET10_BIT 10
#define LPC_GPIO_SET4_PSET11_MASK 0x800
#define LPC_GPIO_SET4_PSET11 0x800
#define LPC_GPIO_SET4_PSET11_BIT 11
#define LPC_GPIO_SET4_PSET12_MASK 0x1000
#define LPC_GPIO_SET4_PSET12 0x1000
#define LPC_GPIO_SET4_PSET12_BIT 12
#define LPC_GPIO_SET4_PSET13_MASK 0x2000
#define LPC_GPIO_SET4_PSET13 0x2000
#define LPC_GPIO_SET4_PSET13_BIT 13
#define LPC_GPIO_SET4_PSET14_MASK 0x4000
#define LPC_GPIO_SET4_PSET14 0x4000
#define LPC_GPIO_SET4_PSET14_BIT 14
#define LPC_GPIO_SET4_PSET15_MASK 0x8000
#define LPC_GPIO_SET4_PSET15 0x8000
#define LPC_GPIO_SET4_PSET15_BIT 15
#define LPC_GPIO_SET4_PSET16_MASK 0x10000
#define LPC_GPIO_SET4_PSET16 0x10000
#define LPC_GPIO_SET4_PSET16_BIT 16
#define LPC_GPIO_SET4_PSET17_MASK 0x20000
#define LPC_GPIO_SET4_PSET17 0x20000
#define LPC_GPIO_SET4_PSET17_BIT 17
#define LPC_GPIO_SET4_PSET18_MASK 0x40000
#define LPC_GPIO_SET4_PSET18 0x40000
#define LPC_GPIO_SET4_PSET18_BIT 18
#define LPC_GPIO_SET4_PSET19_MASK 0x80000
#define LPC_GPIO_SET4_PSET19 0x80000
#define LPC_GPIO_SET4_PSET19_BIT 19
#define LPC_GPIO_SET4_PSET20_MASK 0x100000
#define LPC_GPIO_SET4_PSET20 0x100000
#define LPC_GPIO_SET4_PSET20_BIT 20
#define LPC_GPIO_SET4_PSET21_MASK 0x200000
#define LPC_GPIO_SET4_PSET21 0x200000
#define LPC_GPIO_SET4_PSET21_BIT 21
#define LPC_GPIO_SET4_PSET22_MASK 0x400000
#define LPC_GPIO_SET4_PSET22 0x400000
#define LPC_GPIO_SET4_PSET22_BIT 22
#define LPC_GPIO_SET4_PSET23_MASK 0x800000
#define LPC_GPIO_SET4_PSET23 0x800000
#define LPC_GPIO_SET4_PSET23_BIT 23
#define LPC_GPIO_SET4_PSET24_MASK 0x1000000
#define LPC_GPIO_SET4_PSET24 0x1000000
#define LPC_GPIO_SET4_PSET24_BIT 24
#define LPC_GPIO_SET4_PSET25_MASK 0x2000000
#define LPC_GPIO_SET4_PSET25 0x2000000
#define LPC_GPIO_SET4_PSET25_BIT 25
#define LPC_GPIO_SET4_PSET26_MASK 0x4000000
#define LPC_GPIO_SET4_PSET26 0x4000000
#define LPC_GPIO_SET4_PSET26_BIT 26
#define LPC_GPIO_SET4_PSET27_MASK 0x8000000
#define LPC_GPIO_SET4_PSET27 0x8000000
#define LPC_GPIO_SET4_PSET27_BIT 27
#define LPC_GPIO_SET4_PSET28_MASK 0x10000000
#define LPC_GPIO_SET4_PSET28 0x10000000
#define LPC_GPIO_SET4_PSET28_BIT 28
#define LPC_GPIO_SET4_PSET29_MASK 0x20000000
#define LPC_GPIO_SET4_PSET29 0x20000000
#define LPC_GPIO_SET4_PSET29_BIT 29
#define LPC_GPIO_SET4_PSET30_MASK 0x40000000
#define LPC_GPIO_SET4_PSET30 0x40000000
#define LPC_GPIO_SET4_PSET30_BIT 30
#define LPC_GPIO_SET4_PSET31_MASK 0x80000000
#define LPC_GPIO_SET4_PSET31 0x80000000
#define LPC_GPIO_SET4_PSET31_BIT 31

#define LPC_GPIO_SET5 (*(volatile unsigned long *)0x200980B8)
#define LPC_GPIO_SET5_OFFSET 0xB8
#define LPC_GPIO_SET5_PSET0_MASK 0x1
#define LPC_GPIO_SET5_PSET0 0x1
#define LPC_GPIO_SET5_PSET0_BIT 0
#define LPC_GPIO_SET5_PSET1_MASK 0x2
#define LPC_GPIO_SET5_PSET1 0x2
#define LPC_GPIO_SET5_PSET1_BIT 1
#define LPC_GPIO_SET5_PSET2_MASK 0x4
#define LPC_GPIO_SET5_PSET2 0x4
#define LPC_GPIO_SET5_PSET2_BIT 2
#define LPC_GPIO_SET5_PSET3_MASK 0x8
#define LPC_GPIO_SET5_PSET3 0x8
#define LPC_GPIO_SET5_PSET3_BIT 3
#define LPC_GPIO_SET5_PSET4_MASK 0x10
#define LPC_GPIO_SET5_PSET4 0x10
#define LPC_GPIO_SET5_PSET4_BIT 4
#define LPC_GPIO_SET5_PSET5_MASK 0x20
#define LPC_GPIO_SET5_PSET5 0x20
#define LPC_GPIO_SET5_PSET5_BIT 5
#define LPC_GPIO_SET5_PSET6_MASK 0x40
#define LPC_GPIO_SET5_PSET6 0x40
#define LPC_GPIO_SET5_PSET6_BIT 6
#define LPC_GPIO_SET5_PSET7_MASK 0x80
#define LPC_GPIO_SET5_PSET7 0x80
#define LPC_GPIO_SET5_PSET7_BIT 7
#define LPC_GPIO_SET5_PSET8_MASK 0x100
#define LPC_GPIO_SET5_PSET8 0x100
#define LPC_GPIO_SET5_PSET8_BIT 8
#define LPC_GPIO_SET5_PSET9_MASK 0x200
#define LPC_GPIO_SET5_PSET9 0x200
#define LPC_GPIO_SET5_PSET9_BIT 9
#define LPC_GPIO_SET5_PSET10_MASK 0x400
#define LPC_GPIO_SET5_PSET10 0x400
#define LPC_GPIO_SET5_PSET10_BIT 10
#define LPC_GPIO_SET5_PSET11_MASK 0x800
#define LPC_GPIO_SET5_PSET11 0x800
#define LPC_GPIO_SET5_PSET11_BIT 11
#define LPC_GPIO_SET5_PSET12_MASK 0x1000
#define LPC_GPIO_SET5_PSET12 0x1000
#define LPC_GPIO_SET5_PSET12_BIT 12
#define LPC_GPIO_SET5_PSET13_MASK 0x2000
#define LPC_GPIO_SET5_PSET13 0x2000
#define LPC_GPIO_SET5_PSET13_BIT 13
#define LPC_GPIO_SET5_PSET14_MASK 0x4000
#define LPC_GPIO_SET5_PSET14 0x4000
#define LPC_GPIO_SET5_PSET14_BIT 14
#define LPC_GPIO_SET5_PSET15_MASK 0x8000
#define LPC_GPIO_SET5_PSET15 0x8000
#define LPC_GPIO_SET5_PSET15_BIT 15
#define LPC_GPIO_SET5_PSET16_MASK 0x10000
#define LPC_GPIO_SET5_PSET16 0x10000
#define LPC_GPIO_SET5_PSET16_BIT 16
#define LPC_GPIO_SET5_PSET17_MASK 0x20000
#define LPC_GPIO_SET5_PSET17 0x20000
#define LPC_GPIO_SET5_PSET17_BIT 17
#define LPC_GPIO_SET5_PSET18_MASK 0x40000
#define LPC_GPIO_SET5_PSET18 0x40000
#define LPC_GPIO_SET5_PSET18_BIT 18
#define LPC_GPIO_SET5_PSET19_MASK 0x80000
#define LPC_GPIO_SET5_PSET19 0x80000
#define LPC_GPIO_SET5_PSET19_BIT 19
#define LPC_GPIO_SET5_PSET20_MASK 0x100000
#define LPC_GPIO_SET5_PSET20 0x100000
#define LPC_GPIO_SET5_PSET20_BIT 20
#define LPC_GPIO_SET5_PSET21_MASK 0x200000
#define LPC_GPIO_SET5_PSET21 0x200000
#define LPC_GPIO_SET5_PSET21_BIT 21
#define LPC_GPIO_SET5_PSET22_MASK 0x400000
#define LPC_GPIO_SET5_PSET22 0x400000
#define LPC_GPIO_SET5_PSET22_BIT 22
#define LPC_GPIO_SET5_PSET23_MASK 0x800000
#define LPC_GPIO_SET5_PSET23 0x800000
#define LPC_GPIO_SET5_PSET23_BIT 23
#define LPC_GPIO_SET5_PSET24_MASK 0x1000000
#define LPC_GPIO_SET5_PSET24 0x1000000
#define LPC_GPIO_SET5_PSET24_BIT 24
#define LPC_GPIO_SET5_PSET25_MASK 0x2000000
#define LPC_GPIO_SET5_PSET25 0x2000000
#define LPC_GPIO_SET5_PSET25_BIT 25
#define LPC_GPIO_SET5_PSET26_MASK 0x4000000
#define LPC_GPIO_SET5_PSET26 0x4000000
#define LPC_GPIO_SET5_PSET26_BIT 26
#define LPC_GPIO_SET5_PSET27_MASK 0x8000000
#define LPC_GPIO_SET5_PSET27 0x8000000
#define LPC_GPIO_SET5_PSET27_BIT 27
#define LPC_GPIO_SET5_PSET28_MASK 0x10000000
#define LPC_GPIO_SET5_PSET28 0x10000000
#define LPC_GPIO_SET5_PSET28_BIT 28
#define LPC_GPIO_SET5_PSET29_MASK 0x20000000
#define LPC_GPIO_SET5_PSET29 0x20000000
#define LPC_GPIO_SET5_PSET29_BIT 29
#define LPC_GPIO_SET5_PSET30_MASK 0x40000000
#define LPC_GPIO_SET5_PSET30 0x40000000
#define LPC_GPIO_SET5_PSET30_BIT 30
#define LPC_GPIO_SET5_PSET31_MASK 0x80000000
#define LPC_GPIO_SET5_PSET31 0x80000000
#define LPC_GPIO_SET5_PSET31_BIT 31

#define LPC_GPIO_CLR0 (*(volatile unsigned long *)0x2009801C)
#define LPC_GPIO_CLR0_OFFSET 0x1C
#define LPC_GPIO_CLR0_PCLR0_MASK 0x1
#define LPC_GPIO_CLR0_PCLR0 0x1
#define LPC_GPIO_CLR0_PCLR0_BIT 0
#define LPC_GPIO_CLR0_PCLR1_MASK 0x2
#define LPC_GPIO_CLR0_PCLR1 0x2
#define LPC_GPIO_CLR0_PCLR1_BIT 1
#define LPC_GPIO_CLR0_PCLR2_MASK 0x4
#define LPC_GPIO_CLR0_PCLR2 0x4
#define LPC_GPIO_CLR0_PCLR2_BIT 2
#define LPC_GPIO_CLR0_PCLR3_MASK 0x8
#define LPC_GPIO_CLR0_PCLR3 0x8
#define LPC_GPIO_CLR0_PCLR3_BIT 3
#define LPC_GPIO_CLR0_PCLR4_MASK 0x10
#define LPC_GPIO_CLR0_PCLR4 0x10
#define LPC_GPIO_CLR0_PCLR4_BIT 4
#define LPC_GPIO_CLR0_PCLR5_MASK 0x20
#define LPC_GPIO_CLR0_PCLR5 0x20
#define LPC_GPIO_CLR0_PCLR5_BIT 5
#define LPC_GPIO_CLR0_PCLR6_MASK 0x40
#define LPC_GPIO_CLR0_PCLR6 0x40
#define LPC_GPIO_CLR0_PCLR6_BIT 6
#define LPC_GPIO_CLR0_PCLR7_MASK 0x80
#define LPC_GPIO_CLR0_PCLR7 0x80
#define LPC_GPIO_CLR0_PCLR7_BIT 7
#define LPC_GPIO_CLR0_PCLR8_MASK 0x100
#define LPC_GPIO_CLR0_PCLR8 0x100
#define LPC_GPIO_CLR0_PCLR8_BIT 8
#define LPC_GPIO_CLR0_PCLR9_MASK 0x200
#define LPC_GPIO_CLR0_PCLR9 0x200
#define LPC_GPIO_CLR0_PCLR9_BIT 9
#define LPC_GPIO_CLR0_PCLR10_MASK 0x400
#define LPC_GPIO_CLR0_PCLR10 0x400
#define LPC_GPIO_CLR0_PCLR10_BIT 10
#define LPC_GPIO_CLR0_PCLR11_MASK 0x800
#define LPC_GPIO_CLR0_PCLR11 0x800
#define LPC_GPIO_CLR0_PCLR11_BIT 11
#define LPC_GPIO_CLR0_PCLR12_MASK 0x1000
#define LPC_GPIO_CLR0_PCLR12 0x1000
#define LPC_GPIO_CLR0_PCLR12_BIT 12
#define LPC_GPIO_CLR0_PCLR13_MASK 0x2000
#define LPC_GPIO_CLR0_PCLR13 0x2000
#define LPC_GPIO_CLR0_PCLR13_BIT 13
#define LPC_GPIO_CLR0_PCLR14_MASK 0x4000
#define LPC_GPIO_CLR0_PCLR14 0x4000
#define LPC_GPIO_CLR0_PCLR14_BIT 14
#define LPC_GPIO_CLR0_PCLR15_MASK 0x8000
#define LPC_GPIO_CLR0_PCLR15 0x8000
#define LPC_GPIO_CLR0_PCLR15_BIT 15
#define LPC_GPIO_CLR0_PCLR16_MASK 0x10000
#define LPC_GPIO_CLR0_PCLR16 0x10000
#define LPC_GPIO_CLR0_PCLR16_BIT 16
#define LPC_GPIO_CLR0_PCLR17_MASK 0x20000
#define LPC_GPIO_CLR0_PCLR17 0x20000
#define LPC_GPIO_CLR0_PCLR17_BIT 17
#define LPC_GPIO_CLR0_PCLR18_MASK 0x40000
#define LPC_GPIO_CLR0_PCLR18 0x40000
#define LPC_GPIO_CLR0_PCLR18_BIT 18
#define LPC_GPIO_CLR0_PCLR19_MASK 0x80000
#define LPC_GPIO_CLR0_PCLR19 0x80000
#define LPC_GPIO_CLR0_PCLR19_BIT 19
#define LPC_GPIO_CLR0_PCLR20_MASK 0x100000
#define LPC_GPIO_CLR0_PCLR20 0x100000
#define LPC_GPIO_CLR0_PCLR20_BIT 20
#define LPC_GPIO_CLR0_PCLR21_MASK 0x200000
#define LPC_GPIO_CLR0_PCLR21 0x200000
#define LPC_GPIO_CLR0_PCLR21_BIT 21
#define LPC_GPIO_CLR0_PCLR22_MASK 0x400000
#define LPC_GPIO_CLR0_PCLR22 0x400000
#define LPC_GPIO_CLR0_PCLR22_BIT 22
#define LPC_GPIO_CLR0_PCLR23_MASK 0x800000
#define LPC_GPIO_CLR0_PCLR23 0x800000
#define LPC_GPIO_CLR0_PCLR23_BIT 23
#define LPC_GPIO_CLR0_PCLR24_MASK 0x1000000
#define LPC_GPIO_CLR0_PCLR24 0x1000000
#define LPC_GPIO_CLR0_PCLR24_BIT 24
#define LPC_GPIO_CLR0_PCLR25_MASK 0x2000000
#define LPC_GPIO_CLR0_PCLR25 0x2000000
#define LPC_GPIO_CLR0_PCLR25_BIT 25
#define LPC_GPIO_CLR0_PCLR26_MASK 0x4000000
#define LPC_GPIO_CLR0_PCLR26 0x4000000
#define LPC_GPIO_CLR0_PCLR26_BIT 26
#define LPC_GPIO_CLR0_PCLR27_MASK 0x8000000
#define LPC_GPIO_CLR0_PCLR27 0x8000000
#define LPC_GPIO_CLR0_PCLR27_BIT 27
#define LPC_GPIO_CLR0_PCLR28_MASK 0x10000000
#define LPC_GPIO_CLR0_PCLR28 0x10000000
#define LPC_GPIO_CLR0_PCLR28_BIT 28
#define LPC_GPIO_CLR0_PCLR29_MASK 0x20000000
#define LPC_GPIO_CLR0_PCLR29 0x20000000
#define LPC_GPIO_CLR0_PCLR29_BIT 29
#define LPC_GPIO_CLR0_PCLR30_MASK 0x40000000
#define LPC_GPIO_CLR0_PCLR30 0x40000000
#define LPC_GPIO_CLR0_PCLR30_BIT 30
#define LPC_GPIO_CLR0_PCLR31_MASK 0x80000000
#define LPC_GPIO_CLR0_PCLR31 0x80000000
#define LPC_GPIO_CLR0_PCLR31_BIT 31

#define LPC_GPIO_CLR1 (*(volatile unsigned long *)0x2009803C)
#define LPC_GPIO_CLR1_OFFSET 0x3C
#define LPC_GPIO_CLR1_PCLR0_MASK 0x1
#define LPC_GPIO_CLR1_PCLR0 0x1
#define LPC_GPIO_CLR1_PCLR0_BIT 0
#define LPC_GPIO_CLR1_PCLR1_MASK 0x2
#define LPC_GPIO_CLR1_PCLR1 0x2
#define LPC_GPIO_CLR1_PCLR1_BIT 1
#define LPC_GPIO_CLR1_PCLR2_MASK 0x4
#define LPC_GPIO_CLR1_PCLR2 0x4
#define LPC_GPIO_CLR1_PCLR2_BIT 2
#define LPC_GPIO_CLR1_PCLR3_MASK 0x8
#define LPC_GPIO_CLR1_PCLR3 0x8
#define LPC_GPIO_CLR1_PCLR3_BIT 3
#define LPC_GPIO_CLR1_PCLR4_MASK 0x10
#define LPC_GPIO_CLR1_PCLR4 0x10
#define LPC_GPIO_CLR1_PCLR4_BIT 4
#define LPC_GPIO_CLR1_PCLR5_MASK 0x20
#define LPC_GPIO_CLR1_PCLR5 0x20
#define LPC_GPIO_CLR1_PCLR5_BIT 5
#define LPC_GPIO_CLR1_PCLR6_MASK 0x40
#define LPC_GPIO_CLR1_PCLR6 0x40
#define LPC_GPIO_CLR1_PCLR6_BIT 6
#define LPC_GPIO_CLR1_PCLR7_MASK 0x80
#define LPC_GPIO_CLR1_PCLR7 0x80
#define LPC_GPIO_CLR1_PCLR7_BIT 7
#define LPC_GPIO_CLR1_PCLR8_MASK 0x100
#define LPC_GPIO_CLR1_PCLR8 0x100
#define LPC_GPIO_CLR1_PCLR8_BIT 8
#define LPC_GPIO_CLR1_PCLR9_MASK 0x200
#define LPC_GPIO_CLR1_PCLR9 0x200
#define LPC_GPIO_CLR1_PCLR9_BIT 9
#define LPC_GPIO_CLR1_PCLR10_MASK 0x400
#define LPC_GPIO_CLR1_PCLR10 0x400
#define LPC_GPIO_CLR1_PCLR10_BIT 10
#define LPC_GPIO_CLR1_PCLR11_MASK 0x800
#define LPC_GPIO_CLR1_PCLR11 0x800
#define LPC_GPIO_CLR1_PCLR11_BIT 11
#define LPC_GPIO_CLR1_PCLR12_MASK 0x1000
#define LPC_GPIO_CLR1_PCLR12 0x1000
#define LPC_GPIO_CLR1_PCLR12_BIT 12
#define LPC_GPIO_CLR1_PCLR13_MASK 0x2000
#define LPC_GPIO_CLR1_PCLR13 0x2000
#define LPC_GPIO_CLR1_PCLR13_BIT 13
#define LPC_GPIO_CLR1_PCLR14_MASK 0x4000
#define LPC_GPIO_CLR1_PCLR14 0x4000
#define LPC_GPIO_CLR1_PCLR14_BIT 14
#define LPC_GPIO_CLR1_PCLR15_MASK 0x8000
#define LPC_GPIO_CLR1_PCLR15 0x8000
#define LPC_GPIO_CLR1_PCLR15_BIT 15
#define LPC_GPIO_CLR1_PCLR16_MASK 0x10000
#define LPC_GPIO_CLR1_PCLR16 0x10000
#define LPC_GPIO_CLR1_PCLR16_BIT 16
#define LPC_GPIO_CLR1_PCLR17_MASK 0x20000
#define LPC_GPIO_CLR1_PCLR17 0x20000
#define LPC_GPIO_CLR1_PCLR17_BIT 17
#define LPC_GPIO_CLR1_PCLR18_MASK 0x40000
#define LPC_GPIO_CLR1_PCLR18 0x40000
#define LPC_GPIO_CLR1_PCLR18_BIT 18
#define LPC_GPIO_CLR1_PCLR19_MASK 0x80000
#define LPC_GPIO_CLR1_PCLR19 0x80000
#define LPC_GPIO_CLR1_PCLR19_BIT 19
#define LPC_GPIO_CLR1_PCLR20_MASK 0x100000
#define LPC_GPIO_CLR1_PCLR20 0x100000
#define LPC_GPIO_CLR1_PCLR20_BIT 20
#define LPC_GPIO_CLR1_PCLR21_MASK 0x200000
#define LPC_GPIO_CLR1_PCLR21 0x200000
#define LPC_GPIO_CLR1_PCLR21_BIT 21
#define LPC_GPIO_CLR1_PCLR22_MASK 0x400000
#define LPC_GPIO_CLR1_PCLR22 0x400000
#define LPC_GPIO_CLR1_PCLR22_BIT 22
#define LPC_GPIO_CLR1_PCLR23_MASK 0x800000
#define LPC_GPIO_CLR1_PCLR23 0x800000
#define LPC_GPIO_CLR1_PCLR23_BIT 23
#define LPC_GPIO_CLR1_PCLR24_MASK 0x1000000
#define LPC_GPIO_CLR1_PCLR24 0x1000000
#define LPC_GPIO_CLR1_PCLR24_BIT 24
#define LPC_GPIO_CLR1_PCLR25_MASK 0x2000000
#define LPC_GPIO_CLR1_PCLR25 0x2000000
#define LPC_GPIO_CLR1_PCLR25_BIT 25
#define LPC_GPIO_CLR1_PCLR26_MASK 0x4000000
#define LPC_GPIO_CLR1_PCLR26 0x4000000
#define LPC_GPIO_CLR1_PCLR26_BIT 26
#define LPC_GPIO_CLR1_PCLR27_MASK 0x8000000
#define LPC_GPIO_CLR1_PCLR27 0x8000000
#define LPC_GPIO_CLR1_PCLR27_BIT 27
#define LPC_GPIO_CLR1_PCLR28_MASK 0x10000000
#define LPC_GPIO_CLR1_PCLR28 0x10000000
#define LPC_GPIO_CLR1_PCLR28_BIT 28
#define LPC_GPIO_CLR1_PCLR29_MASK 0x20000000
#define LPC_GPIO_CLR1_PCLR29 0x20000000
#define LPC_GPIO_CLR1_PCLR29_BIT 29
#define LPC_GPIO_CLR1_PCLR30_MASK 0x40000000
#define LPC_GPIO_CLR1_PCLR30 0x40000000
#define LPC_GPIO_CLR1_PCLR30_BIT 30
#define LPC_GPIO_CLR1_PCLR31_MASK 0x80000000
#define LPC_GPIO_CLR1_PCLR31 0x80000000
#define LPC_GPIO_CLR1_PCLR31_BIT 31

#define LPC_GPIO_CLR2 (*(volatile unsigned long *)0x2009805C)
#define LPC_GPIO_CLR2_OFFSET 0x5C
#define LPC_GPIO_CLR2_PCLR0_MASK 0x1
#define LPC_GPIO_CLR2_PCLR0 0x1
#define LPC_GPIO_CLR2_PCLR0_BIT 0
#define LPC_GPIO_CLR2_PCLR1_MASK 0x2
#define LPC_GPIO_CLR2_PCLR1 0x2
#define LPC_GPIO_CLR2_PCLR1_BIT 1
#define LPC_GPIO_CLR2_PCLR2_MASK 0x4
#define LPC_GPIO_CLR2_PCLR2 0x4
#define LPC_GPIO_CLR2_PCLR2_BIT 2
#define LPC_GPIO_CLR2_PCLR3_MASK 0x8
#define LPC_GPIO_CLR2_PCLR3 0x8
#define LPC_GPIO_CLR2_PCLR3_BIT 3
#define LPC_GPIO_CLR2_PCLR4_MASK 0x10
#define LPC_GPIO_CLR2_PCLR4 0x10
#define LPC_GPIO_CLR2_PCLR4_BIT 4
#define LPC_GPIO_CLR2_PCLR5_MASK 0x20
#define LPC_GPIO_CLR2_PCLR5 0x20
#define LPC_GPIO_CLR2_PCLR5_BIT 5
#define LPC_GPIO_CLR2_PCLR6_MASK 0x40
#define LPC_GPIO_CLR2_PCLR6 0x40
#define LPC_GPIO_CLR2_PCLR6_BIT 6
#define LPC_GPIO_CLR2_PCLR7_MASK 0x80
#define LPC_GPIO_CLR2_PCLR7 0x80
#define LPC_GPIO_CLR2_PCLR7_BIT 7
#define LPC_GPIO_CLR2_PCLR8_MASK 0x100
#define LPC_GPIO_CLR2_PCLR8 0x100
#define LPC_GPIO_CLR2_PCLR8_BIT 8
#define LPC_GPIO_CLR2_PCLR9_MASK 0x200
#define LPC_GPIO_CLR2_PCLR9 0x200
#define LPC_GPIO_CLR2_PCLR9_BIT 9
#define LPC_GPIO_CLR2_PCLR10_MASK 0x400
#define LPC_GPIO_CLR2_PCLR10 0x400
#define LPC_GPIO_CLR2_PCLR10_BIT 10
#define LPC_GPIO_CLR2_PCLR11_MASK 0x800
#define LPC_GPIO_CLR2_PCLR11 0x800
#define LPC_GPIO_CLR2_PCLR11_BIT 11
#define LPC_GPIO_CLR2_PCLR12_MASK 0x1000
#define LPC_GPIO_CLR2_PCLR12 0x1000
#define LPC_GPIO_CLR2_PCLR12_BIT 12
#define LPC_GPIO_CLR2_PCLR13_MASK 0x2000
#define LPC_GPIO_CLR2_PCLR13 0x2000
#define LPC_GPIO_CLR2_PCLR13_BIT 13
#define LPC_GPIO_CLR2_PCLR14_MASK 0x4000
#define LPC_GPIO_CLR2_PCLR14 0x4000
#define LPC_GPIO_CLR2_PCLR14_BIT 14
#define LPC_GPIO_CLR2_PCLR15_MASK 0x8000
#define LPC_GPIO_CLR2_PCLR15 0x8000
#define LPC_GPIO_CLR2_PCLR15_BIT 15
#define LPC_GPIO_CLR2_PCLR16_MASK 0x10000
#define LPC_GPIO_CLR2_PCLR16 0x10000
#define LPC_GPIO_CLR2_PCLR16_BIT 16
#define LPC_GPIO_CLR2_PCLR17_MASK 0x20000
#define LPC_GPIO_CLR2_PCLR17 0x20000
#define LPC_GPIO_CLR2_PCLR17_BIT 17
#define LPC_GPIO_CLR2_PCLR18_MASK 0x40000
#define LPC_GPIO_CLR2_PCLR18 0x40000
#define LPC_GPIO_CLR2_PCLR18_BIT 18
#define LPC_GPIO_CLR2_PCLR19_MASK 0x80000
#define LPC_GPIO_CLR2_PCLR19 0x80000
#define LPC_GPIO_CLR2_PCLR19_BIT 19
#define LPC_GPIO_CLR2_PCLR20_MASK 0x100000
#define LPC_GPIO_CLR2_PCLR20 0x100000
#define LPC_GPIO_CLR2_PCLR20_BIT 20
#define LPC_GPIO_CLR2_PCLR21_MASK 0x200000
#define LPC_GPIO_CLR2_PCLR21 0x200000
#define LPC_GPIO_CLR2_PCLR21_BIT 21
#define LPC_GPIO_CLR2_PCLR22_MASK 0x400000
#define LPC_GPIO_CLR2_PCLR22 0x400000
#define LPC_GPIO_CLR2_PCLR22_BIT 22
#define LPC_GPIO_CLR2_PCLR23_MASK 0x800000
#define LPC_GPIO_CLR2_PCLR23 0x800000
#define LPC_GPIO_CLR2_PCLR23_BIT 23
#define LPC_GPIO_CLR2_PCLR24_MASK 0x1000000
#define LPC_GPIO_CLR2_PCLR24 0x1000000
#define LPC_GPIO_CLR2_PCLR24_BIT 24
#define LPC_GPIO_CLR2_PCLR25_MASK 0x2000000
#define LPC_GPIO_CLR2_PCLR25 0x2000000
#define LPC_GPIO_CLR2_PCLR25_BIT 25
#define LPC_GPIO_CLR2_PCLR26_MASK 0x4000000
#define LPC_GPIO_CLR2_PCLR26 0x4000000
#define LPC_GPIO_CLR2_PCLR26_BIT 26
#define LPC_GPIO_CLR2_PCLR27_MASK 0x8000000
#define LPC_GPIO_CLR2_PCLR27 0x8000000
#define LPC_GPIO_CLR2_PCLR27_BIT 27
#define LPC_GPIO_CLR2_PCLR28_MASK 0x10000000
#define LPC_GPIO_CLR2_PCLR28 0x10000000
#define LPC_GPIO_CLR2_PCLR28_BIT 28
#define LPC_GPIO_CLR2_PCLR29_MASK 0x20000000
#define LPC_GPIO_CLR2_PCLR29 0x20000000
#define LPC_GPIO_CLR2_PCLR29_BIT 29
#define LPC_GPIO_CLR2_PCLR30_MASK 0x40000000
#define LPC_GPIO_CLR2_PCLR30 0x40000000
#define LPC_GPIO_CLR2_PCLR30_BIT 30
#define LPC_GPIO_CLR2_PCLR31_MASK 0x80000000
#define LPC_GPIO_CLR2_PCLR31 0x80000000
#define LPC_GPIO_CLR2_PCLR31_BIT 31

#define LPC_GPIO_CLR3 (*(volatile unsigned long *)0x2009807C)
#define LPC_GPIO_CLR3_OFFSET 0x7C
#define LPC_GPIO_CLR3_PCLR0_MASK 0x1
#define LPC_GPIO_CLR3_PCLR0 0x1
#define LPC_GPIO_CLR3_PCLR0_BIT 0
#define LPC_GPIO_CLR3_PCLR1_MASK 0x2
#define LPC_GPIO_CLR3_PCLR1 0x2
#define LPC_GPIO_CLR3_PCLR1_BIT 1
#define LPC_GPIO_CLR3_PCLR2_MASK 0x4
#define LPC_GPIO_CLR3_PCLR2 0x4
#define LPC_GPIO_CLR3_PCLR2_BIT 2
#define LPC_GPIO_CLR3_PCLR3_MASK 0x8
#define LPC_GPIO_CLR3_PCLR3 0x8
#define LPC_GPIO_CLR3_PCLR3_BIT 3
#define LPC_GPIO_CLR3_PCLR4_MASK 0x10
#define LPC_GPIO_CLR3_PCLR4 0x10
#define LPC_GPIO_CLR3_PCLR4_BIT 4
#define LPC_GPIO_CLR3_PCLR5_MASK 0x20
#define LPC_GPIO_CLR3_PCLR5 0x20
#define LPC_GPIO_CLR3_PCLR5_BIT 5
#define LPC_GPIO_CLR3_PCLR6_MASK 0x40
#define LPC_GPIO_CLR3_PCLR6 0x40
#define LPC_GPIO_CLR3_PCLR6_BIT 6
#define LPC_GPIO_CLR3_PCLR7_MASK 0x80
#define LPC_GPIO_CLR3_PCLR7 0x80
#define LPC_GPIO_CLR3_PCLR7_BIT 7
#define LPC_GPIO_CLR3_PCLR8_MASK 0x100
#define LPC_GPIO_CLR3_PCLR8 0x100
#define LPC_GPIO_CLR3_PCLR8_BIT 8
#define LPC_GPIO_CLR3_PCLR9_MASK 0x200
#define LPC_GPIO_CLR3_PCLR9 0x200
#define LPC_GPIO_CLR3_PCLR9_BIT 9
#define LPC_GPIO_CLR3_PCLR10_MASK 0x400
#define LPC_GPIO_CLR3_PCLR10 0x400
#define LPC_GPIO_CLR3_PCLR10_BIT 10
#define LPC_GPIO_CLR3_PCLR11_MASK 0x800
#define LPC_GPIO_CLR3_PCLR11 0x800
#define LPC_GPIO_CLR3_PCLR11_BIT 11
#define LPC_GPIO_CLR3_PCLR12_MASK 0x1000
#define LPC_GPIO_CLR3_PCLR12 0x1000
#define LPC_GPIO_CLR3_PCLR12_BIT 12
#define LPC_GPIO_CLR3_PCLR13_MASK 0x2000
#define LPC_GPIO_CLR3_PCLR13 0x2000
#define LPC_GPIO_CLR3_PCLR13_BIT 13
#define LPC_GPIO_CLR3_PCLR14_MASK 0x4000
#define LPC_GPIO_CLR3_PCLR14 0x4000
#define LPC_GPIO_CLR3_PCLR14_BIT 14
#define LPC_GPIO_CLR3_PCLR15_MASK 0x8000
#define LPC_GPIO_CLR3_PCLR15 0x8000
#define LPC_GPIO_CLR3_PCLR15_BIT 15
#define LPC_GPIO_CLR3_PCLR16_MASK 0x10000
#define LPC_GPIO_CLR3_PCLR16 0x10000
#define LPC_GPIO_CLR3_PCLR16_BIT 16
#define LPC_GPIO_CLR3_PCLR17_MASK 0x20000
#define LPC_GPIO_CLR3_PCLR17 0x20000
#define LPC_GPIO_CLR3_PCLR17_BIT 17
#define LPC_GPIO_CLR3_PCLR18_MASK 0x40000
#define LPC_GPIO_CLR3_PCLR18 0x40000
#define LPC_GPIO_CLR3_PCLR18_BIT 18
#define LPC_GPIO_CLR3_PCLR19_MASK 0x80000
#define LPC_GPIO_CLR3_PCLR19 0x80000
#define LPC_GPIO_CLR3_PCLR19_BIT 19
#define LPC_GPIO_CLR3_PCLR20_MASK 0x100000
#define LPC_GPIO_CLR3_PCLR20 0x100000
#define LPC_GPIO_CLR3_PCLR20_BIT 20
#define LPC_GPIO_CLR3_PCLR21_MASK 0x200000
#define LPC_GPIO_CLR3_PCLR21 0x200000
#define LPC_GPIO_CLR3_PCLR21_BIT 21
#define LPC_GPIO_CLR3_PCLR22_MASK 0x400000
#define LPC_GPIO_CLR3_PCLR22 0x400000
#define LPC_GPIO_CLR3_PCLR22_BIT 22
#define LPC_GPIO_CLR3_PCLR23_MASK 0x800000
#define LPC_GPIO_CLR3_PCLR23 0x800000
#define LPC_GPIO_CLR3_PCLR23_BIT 23
#define LPC_GPIO_CLR3_PCLR24_MASK 0x1000000
#define LPC_GPIO_CLR3_PCLR24 0x1000000
#define LPC_GPIO_CLR3_PCLR24_BIT 24
#define LPC_GPIO_CLR3_PCLR25_MASK 0x2000000
#define LPC_GPIO_CLR3_PCLR25 0x2000000
#define LPC_GPIO_CLR3_PCLR25_BIT 25
#define LPC_GPIO_CLR3_PCLR26_MASK 0x4000000
#define LPC_GPIO_CLR3_PCLR26 0x4000000
#define LPC_GPIO_CLR3_PCLR26_BIT 26
#define LPC_GPIO_CLR3_PCLR27_MASK 0x8000000
#define LPC_GPIO_CLR3_PCLR27 0x8000000
#define LPC_GPIO_CLR3_PCLR27_BIT 27
#define LPC_GPIO_CLR3_PCLR28_MASK 0x10000000
#define LPC_GPIO_CLR3_PCLR28 0x10000000
#define LPC_GPIO_CLR3_PCLR28_BIT 28
#define LPC_GPIO_CLR3_PCLR29_MASK 0x20000000
#define LPC_GPIO_CLR3_PCLR29 0x20000000
#define LPC_GPIO_CLR3_PCLR29_BIT 29
#define LPC_GPIO_CLR3_PCLR30_MASK 0x40000000
#define LPC_GPIO_CLR3_PCLR30 0x40000000
#define LPC_GPIO_CLR3_PCLR30_BIT 30
#define LPC_GPIO_CLR3_PCLR31_MASK 0x80000000
#define LPC_GPIO_CLR3_PCLR31 0x80000000
#define LPC_GPIO_CLR3_PCLR31_BIT 31

#define LPC_GPIO_CLR4 (*(volatile unsigned long *)0x2009809C)
#define LPC_GPIO_CLR4_OFFSET 0x9C
#define LPC_GPIO_CLR4_PCLR0_MASK 0x1
#define LPC_GPIO_CLR4_PCLR0 0x1
#define LPC_GPIO_CLR4_PCLR0_BIT 0
#define LPC_GPIO_CLR4_PCLR1_MASK 0x2
#define LPC_GPIO_CLR4_PCLR1 0x2
#define LPC_GPIO_CLR4_PCLR1_BIT 1
#define LPC_GPIO_CLR4_PCLR2_MASK 0x4
#define LPC_GPIO_CLR4_PCLR2 0x4
#define LPC_GPIO_CLR4_PCLR2_BIT 2
#define LPC_GPIO_CLR4_PCLR3_MASK 0x8
#define LPC_GPIO_CLR4_PCLR3 0x8
#define LPC_GPIO_CLR4_PCLR3_BIT 3
#define LPC_GPIO_CLR4_PCLR4_MASK 0x10
#define LPC_GPIO_CLR4_PCLR4 0x10
#define LPC_GPIO_CLR4_PCLR4_BIT 4
#define LPC_GPIO_CLR4_PCLR5_MASK 0x20
#define LPC_GPIO_CLR4_PCLR5 0x20
#define LPC_GPIO_CLR4_PCLR5_BIT 5
#define LPC_GPIO_CLR4_PCLR6_MASK 0x40
#define LPC_GPIO_CLR4_PCLR6 0x40
#define LPC_GPIO_CLR4_PCLR6_BIT 6
#define LPC_GPIO_CLR4_PCLR7_MASK 0x80
#define LPC_GPIO_CLR4_PCLR7 0x80
#define LPC_GPIO_CLR4_PCLR7_BIT 7
#define LPC_GPIO_CLR4_PCLR8_MASK 0x100
#define LPC_GPIO_CLR4_PCLR8 0x100
#define LPC_GPIO_CLR4_PCLR8_BIT 8
#define LPC_GPIO_CLR4_PCLR9_MASK 0x200
#define LPC_GPIO_CLR4_PCLR9 0x200
#define LPC_GPIO_CLR4_PCLR9_BIT 9
#define LPC_GPIO_CLR4_PCLR10_MASK 0x400
#define LPC_GPIO_CLR4_PCLR10 0x400
#define LPC_GPIO_CLR4_PCLR10_BIT 10
#define LPC_GPIO_CLR4_PCLR11_MASK 0x800
#define LPC_GPIO_CLR4_PCLR11 0x800
#define LPC_GPIO_CLR4_PCLR11_BIT 11
#define LPC_GPIO_CLR4_PCLR12_MASK 0x1000
#define LPC_GPIO_CLR4_PCLR12 0x1000
#define LPC_GPIO_CLR4_PCLR12_BIT 12
#define LPC_GPIO_CLR4_PCLR13_MASK 0x2000
#define LPC_GPIO_CLR4_PCLR13 0x2000
#define LPC_GPIO_CLR4_PCLR13_BIT 13
#define LPC_GPIO_CLR4_PCLR14_MASK 0x4000
#define LPC_GPIO_CLR4_PCLR14 0x4000
#define LPC_GPIO_CLR4_PCLR14_BIT 14
#define LPC_GPIO_CLR4_PCLR15_MASK 0x8000
#define LPC_GPIO_CLR4_PCLR15 0x8000
#define LPC_GPIO_CLR4_PCLR15_BIT 15
#define LPC_GPIO_CLR4_PCLR16_MASK 0x10000
#define LPC_GPIO_CLR4_PCLR16 0x10000
#define LPC_GPIO_CLR4_PCLR16_BIT 16
#define LPC_GPIO_CLR4_PCLR17_MASK 0x20000
#define LPC_GPIO_CLR4_PCLR17 0x20000
#define LPC_GPIO_CLR4_PCLR17_BIT 17
#define LPC_GPIO_CLR4_PCLR18_MASK 0x40000
#define LPC_GPIO_CLR4_PCLR18 0x40000
#define LPC_GPIO_CLR4_PCLR18_BIT 18
#define LPC_GPIO_CLR4_PCLR19_MASK 0x80000
#define LPC_GPIO_CLR4_PCLR19 0x80000
#define LPC_GPIO_CLR4_PCLR19_BIT 19
#define LPC_GPIO_CLR4_PCLR20_MASK 0x100000
#define LPC_GPIO_CLR4_PCLR20 0x100000
#define LPC_GPIO_CLR4_PCLR20_BIT 20
#define LPC_GPIO_CLR4_PCLR21_MASK 0x200000
#define LPC_GPIO_CLR4_PCLR21 0x200000
#define LPC_GPIO_CLR4_PCLR21_BIT 21
#define LPC_GPIO_CLR4_PCLR22_MASK 0x400000
#define LPC_GPIO_CLR4_PCLR22 0x400000
#define LPC_GPIO_CLR4_PCLR22_BIT 22
#define LPC_GPIO_CLR4_PCLR23_MASK 0x800000
#define LPC_GPIO_CLR4_PCLR23 0x800000
#define LPC_GPIO_CLR4_PCLR23_BIT 23
#define LPC_GPIO_CLR4_PCLR24_MASK 0x1000000
#define LPC_GPIO_CLR4_PCLR24 0x1000000
#define LPC_GPIO_CLR4_PCLR24_BIT 24
#define LPC_GPIO_CLR4_PCLR25_MASK 0x2000000
#define LPC_GPIO_CLR4_PCLR25 0x2000000
#define LPC_GPIO_CLR4_PCLR25_BIT 25
#define LPC_GPIO_CLR4_PCLR26_MASK 0x4000000
#define LPC_GPIO_CLR4_PCLR26 0x4000000
#define LPC_GPIO_CLR4_PCLR26_BIT 26
#define LPC_GPIO_CLR4_PCLR27_MASK 0x8000000
#define LPC_GPIO_CLR4_PCLR27 0x8000000
#define LPC_GPIO_CLR4_PCLR27_BIT 27
#define LPC_GPIO_CLR4_PCLR28_MASK 0x10000000
#define LPC_GPIO_CLR4_PCLR28 0x10000000
#define LPC_GPIO_CLR4_PCLR28_BIT 28
#define LPC_GPIO_CLR4_PCLR29_MASK 0x20000000
#define LPC_GPIO_CLR4_PCLR29 0x20000000
#define LPC_GPIO_CLR4_PCLR29_BIT 29
#define LPC_GPIO_CLR4_PCLR30_MASK 0x40000000
#define LPC_GPIO_CLR4_PCLR30 0x40000000
#define LPC_GPIO_CLR4_PCLR30_BIT 30
#define LPC_GPIO_CLR4_PCLR31_MASK 0x80000000
#define LPC_GPIO_CLR4_PCLR31 0x80000000
#define LPC_GPIO_CLR4_PCLR31_BIT 31

#define LPC_GPIO_CLR5 (*(volatile unsigned long *)0x200980BC)
#define LPC_GPIO_CLR5_OFFSET 0xBC
#define LPC_GPIO_CLR5_PCLR0_MASK 0x1
#define LPC_GPIO_CLR5_PCLR0 0x1
#define LPC_GPIO_CLR5_PCLR0_BIT 0
#define LPC_GPIO_CLR5_PCLR1_MASK 0x2
#define LPC_GPIO_CLR5_PCLR1 0x2
#define LPC_GPIO_CLR5_PCLR1_BIT 1
#define LPC_GPIO_CLR5_PCLR2_MASK 0x4
#define LPC_GPIO_CLR5_PCLR2 0x4
#define LPC_GPIO_CLR5_PCLR2_BIT 2
#define LPC_GPIO_CLR5_PCLR3_MASK 0x8
#define LPC_GPIO_CLR5_PCLR3 0x8
#define LPC_GPIO_CLR5_PCLR3_BIT 3
#define LPC_GPIO_CLR5_PCLR4_MASK 0x10
#define LPC_GPIO_CLR5_PCLR4 0x10
#define LPC_GPIO_CLR5_PCLR4_BIT 4
#define LPC_GPIO_CLR5_PCLR5_MASK 0x20
#define LPC_GPIO_CLR5_PCLR5 0x20
#define LPC_GPIO_CLR5_PCLR5_BIT 5
#define LPC_GPIO_CLR5_PCLR6_MASK 0x40
#define LPC_GPIO_CLR5_PCLR6 0x40
#define LPC_GPIO_CLR5_PCLR6_BIT 6
#define LPC_GPIO_CLR5_PCLR7_MASK 0x80
#define LPC_GPIO_CLR5_PCLR7 0x80
#define LPC_GPIO_CLR5_PCLR7_BIT 7
#define LPC_GPIO_CLR5_PCLR8_MASK 0x100
#define LPC_GPIO_CLR5_PCLR8 0x100
#define LPC_GPIO_CLR5_PCLR8_BIT 8
#define LPC_GPIO_CLR5_PCLR9_MASK 0x200
#define LPC_GPIO_CLR5_PCLR9 0x200
#define LPC_GPIO_CLR5_PCLR9_BIT 9
#define LPC_GPIO_CLR5_PCLR10_MASK 0x400
#define LPC_GPIO_CLR5_PCLR10 0x400
#define LPC_GPIO_CLR5_PCLR10_BIT 10
#define LPC_GPIO_CLR5_PCLR11_MASK 0x800
#define LPC_GPIO_CLR5_PCLR11 0x800
#define LPC_GPIO_CLR5_PCLR11_BIT 11
#define LPC_GPIO_CLR5_PCLR12_MASK 0x1000
#define LPC_GPIO_CLR5_PCLR12 0x1000
#define LPC_GPIO_CLR5_PCLR12_BIT 12
#define LPC_GPIO_CLR5_PCLR13_MASK 0x2000
#define LPC_GPIO_CLR5_PCLR13 0x2000
#define LPC_GPIO_CLR5_PCLR13_BIT 13
#define LPC_GPIO_CLR5_PCLR14_MASK 0x4000
#define LPC_GPIO_CLR5_PCLR14 0x4000
#define LPC_GPIO_CLR5_PCLR14_BIT 14
#define LPC_GPIO_CLR5_PCLR15_MASK 0x8000
#define LPC_GPIO_CLR5_PCLR15 0x8000
#define LPC_GPIO_CLR5_PCLR15_BIT 15
#define LPC_GPIO_CLR5_PCLR16_MASK 0x10000
#define LPC_GPIO_CLR5_PCLR16 0x10000
#define LPC_GPIO_CLR5_PCLR16_BIT 16
#define LPC_GPIO_CLR5_PCLR17_MASK 0x20000
#define LPC_GPIO_CLR5_PCLR17 0x20000
#define LPC_GPIO_CLR5_PCLR17_BIT 17
#define LPC_GPIO_CLR5_PCLR18_MASK 0x40000
#define LPC_GPIO_CLR5_PCLR18 0x40000
#define LPC_GPIO_CLR5_PCLR18_BIT 18
#define LPC_GPIO_CLR5_PCLR19_MASK 0x80000
#define LPC_GPIO_CLR5_PCLR19 0x80000
#define LPC_GPIO_CLR5_PCLR19_BIT 19
#define LPC_GPIO_CLR5_PCLR20_MASK 0x100000
#define LPC_GPIO_CLR5_PCLR20 0x100000
#define LPC_GPIO_CLR5_PCLR20_BIT 20
#define LPC_GPIO_CLR5_PCLR21_MASK 0x200000
#define LPC_GPIO_CLR5_PCLR21 0x200000
#define LPC_GPIO_CLR5_PCLR21_BIT 21
#define LPC_GPIO_CLR5_PCLR22_MASK 0x400000
#define LPC_GPIO_CLR5_PCLR22 0x400000
#define LPC_GPIO_CLR5_PCLR22_BIT 22
#define LPC_GPIO_CLR5_PCLR23_MASK 0x800000
#define LPC_GPIO_CLR5_PCLR23 0x800000
#define LPC_GPIO_CLR5_PCLR23_BIT 23
#define LPC_GPIO_CLR5_PCLR24_MASK 0x1000000
#define LPC_GPIO_CLR5_PCLR24 0x1000000
#define LPC_GPIO_CLR5_PCLR24_BIT 24
#define LPC_GPIO_CLR5_PCLR25_MASK 0x2000000
#define LPC_GPIO_CLR5_PCLR25 0x2000000
#define LPC_GPIO_CLR5_PCLR25_BIT 25
#define LPC_GPIO_CLR5_PCLR26_MASK 0x4000000
#define LPC_GPIO_CLR5_PCLR26 0x4000000
#define LPC_GPIO_CLR5_PCLR26_BIT 26
#define LPC_GPIO_CLR5_PCLR27_MASK 0x8000000
#define LPC_GPIO_CLR5_PCLR27 0x8000000
#define LPC_GPIO_CLR5_PCLR27_BIT 27
#define LPC_GPIO_CLR5_PCLR28_MASK 0x10000000
#define LPC_GPIO_CLR5_PCLR28 0x10000000
#define LPC_GPIO_CLR5_PCLR28_BIT 28
#define LPC_GPIO_CLR5_PCLR29_MASK 0x20000000
#define LPC_GPIO_CLR5_PCLR29 0x20000000
#define LPC_GPIO_CLR5_PCLR29_BIT 29
#define LPC_GPIO_CLR5_PCLR30_MASK 0x40000000
#define LPC_GPIO_CLR5_PCLR30 0x40000000
#define LPC_GPIO_CLR5_PCLR30_BIT 30
#define LPC_GPIO_CLR5_PCLR31_MASK 0x80000000
#define LPC_GPIO_CLR5_PCLR31 0x80000000
#define LPC_GPIO_CLR5_PCLR31_BIT 31

#ifndef LPC_EMC_BASE_ADDRESS
#define LPC_EMC_BASE_ADDRESS 0x2009C000
#endif

#define LPC_EMC_CONTROL (*(volatile unsigned long *)0x2009C000)
#define LPC_EMC_CONTROL_OFFSET 0x0
#define LPC_EMC_CONTROL_E_MASK 0x1
#define LPC_EMC_CONTROL_E 0x1
#define LPC_EMC_CONTROL_E_BIT 0
#define LPC_EMC_CONTROL_M_MASK 0x2
#define LPC_EMC_CONTROL_M 0x2
#define LPC_EMC_CONTROL_M_BIT 1
#define LPC_EMC_CONTROL_L_MASK 0x4
#define LPC_EMC_CONTROL_L 0x4
#define LPC_EMC_CONTROL_L_BIT 2

#define LPC_EMC_STATUS (*(volatile unsigned long *)0x2009C004)
#define LPC_EMC_STATUS_OFFSET 0x4
#define LPC_EMC_STATUS_B_MASK 0x1
#define LPC_EMC_STATUS_B 0x1
#define LPC_EMC_STATUS_B_BIT 0
#define LPC_EMC_STATUS_S_MASK 0x2
#define LPC_EMC_STATUS_S 0x2
#define LPC_EMC_STATUS_S_BIT 1
#define LPC_EMC_STATUS_SA_MASK 0x4
#define LPC_EMC_STATUS_SA 0x4
#define LPC_EMC_STATUS_SA_BIT 2

#define LPC_EMC_CONFIG (*(volatile unsigned long *)0x2009C008)
#define LPC_EMC_CONFIG_OFFSET 0x8
#define LPC_EMC_CONFIG_EM_MASK 0x1
#define LPC_EMC_CONFIG_EM 0x1
#define LPC_EMC_CONFIG_EM_BIT 0
#define LPC_EMC_CONFIG_CLKR_MASK 0x100
#define LPC_EMC_CONFIG_CLKR 0x100
#define LPC_EMC_CONFIG_CLKR_BIT 8

#define LPC_EMC_DYNAMICCONTROL (*(volatile unsigned long *)0x2009C020)
#define LPC_EMC_DYNAMICCONTROL_OFFSET 0x20
#define LPC_EMC_DYNAMICCONTROL_CE_MASK 0x1
#define LPC_EMC_DYNAMICCONTROL_CE 0x1
#define LPC_EMC_DYNAMICCONTROL_CE_BIT 0
#define LPC_EMC_DYNAMICCONTROL_CS_MASK 0x2
#define LPC_EMC_DYNAMICCONTROL_CS 0x2
#define LPC_EMC_DYNAMICCONTROL_CS_BIT 1
#define LPC_EMC_DYNAMICCONTROL_SR_MASK 0x4
#define LPC_EMC_DYNAMICCONTROL_SR 0x4
#define LPC_EMC_DYNAMICCONTROL_SR_BIT 2
#define LPC_EMC_DYNAMICCONTROL_MMC_MASK 0x20
#define LPC_EMC_DYNAMICCONTROL_MMC 0x20
#define LPC_EMC_DYNAMICCONTROL_MMC_BIT 5
#define LPC_EMC_DYNAMICCONTROL_I_MASK 0x180
#define LPC_EMC_DYNAMICCONTROL_I_BIT 7

#define LPC_EMC_DYNAMICREFRESH (*(volatile unsigned long *)0x2009C024)
#define LPC_EMC_DYNAMICREFRESH_OFFSET 0x24
#define LPC_EMC_DYNAMICREFRESH_REFRESH_MASK 0x7FF
#define LPC_EMC_DYNAMICREFRESH_REFRESH_BIT 0

#define LPC_EMC_DYNAMICREADCONFIG (*(volatile unsigned long *)0x2009C028)
#define LPC_EMC_DYNAMICREADCONFIG_OFFSET 0x28
#define LPC_EMC_DYNAMICREADCONFIG_RD_MASK 0x3
#define LPC_EMC_DYNAMICREADCONFIG_RD_BIT 0

#define LPC_EMC_DYNAMICRP (*(volatile unsigned long *)0x2009C030)
#define LPC_EMC_DYNAMICRP_OFFSET 0x30
#define LPC_EMC_DYNAMICRP_TRP_MASK 0xF
#define LPC_EMC_DYNAMICRP_TRP_BIT 0

#define LPC_EMC_DYNAMICRAS (*(volatile unsigned long *)0x2009C034)
#define LPC_EMC_DYNAMICRAS_OFFSET 0x34
#define LPC_EMC_DYNAMICRAS_TRAS_MASK 0xF
#define LPC_EMC_DYNAMICRAS_TRAS_BIT 0

#define LPC_EMC_DYNAMICSREX (*(volatile unsigned long *)0x2009C038)
#define LPC_EMC_DYNAMICSREX_OFFSET 0x38
#define LPC_EMC_DYNAMICSREX_TSREX_MASK 0xF
#define LPC_EMC_DYNAMICSREX_TSREX_BIT 0

#define LPC_EMC_DYNAMICAPR (*(volatile unsigned long *)0x2009C03C)
#define LPC_EMC_DYNAMICAPR_OFFSET 0x3C
#define LPC_EMC_DYNAMICAPR_TAPR_MASK 0xF
#define LPC_EMC_DYNAMICAPR_TAPR_BIT 0

#define LPC_EMC_DYNAMICDAL (*(volatile unsigned long *)0x2009C040)
#define LPC_EMC_DYNAMICDAL_OFFSET 0x40
#define LPC_EMC_DYNAMICDAL_TDAL_MASK 0xF
#define LPC_EMC_DYNAMICDAL_TDAL_BIT 0

#define LPC_EMC_DYNAMICWR (*(volatile unsigned long *)0x2009C044)
#define LPC_EMC_DYNAMICWR_OFFSET 0x44
#define LPC_EMC_DYNAMICWR_TWR_MASK 0xF
#define LPC_EMC_DYNAMICWR_TWR_BIT 0

#define LPC_EMC_DYNAMICRC (*(volatile unsigned long *)0x2009C048)
#define LPC_EMC_DYNAMICRC_OFFSET 0x48
#define LPC_EMC_DYNAMICRC_TRC_MASK 0x1F
#define LPC_EMC_DYNAMICRC_TRC_BIT 0

#define LPC_EMC_DYNAMICRFC (*(volatile unsigned long *)0x2009C04C)
#define LPC_EMC_DYNAMICRFC_OFFSET 0x4C
#define LPC_EMC_DYNAMICRFC_TRFC_MASK 0x1F
#define LPC_EMC_DYNAMICRFC_TRFC_BIT 0

#define LPC_EMC_DYNAMICXSR (*(volatile unsigned long *)0x2009C050)
#define LPC_EMC_DYNAMICXSR_OFFSET 0x50
#define LPC_EMC_DYNAMICXSR_TXSR_MASK 0x1F
#define LPC_EMC_DYNAMICXSR_TXSR_BIT 0

#define LPC_EMC_DYNAMICRRD (*(volatile unsigned long *)0x2009C054)
#define LPC_EMC_DYNAMICRRD_OFFSET 0x54
#define LPC_EMC_DYNAMICRRD_TRRD_MASK 0xF
#define LPC_EMC_DYNAMICRRD_TRRD_BIT 0

#define LPC_EMC_DYNAMICMRD (*(volatile unsigned long *)0x2009C058)
#define LPC_EMC_DYNAMICMRD_OFFSET 0x58
#define LPC_EMC_DYNAMICMRD_TMRD_MASK 0xF
#define LPC_EMC_DYNAMICMRD_TMRD_BIT 0

#define LPC_EMC_STATICEXTENDEDWAIT (*(volatile unsigned long *)0x2009C080)
#define LPC_EMC_STATICEXTENDEDWAIT_OFFSET 0x80
#define LPC_EMC_STATICEXTENDEDWAIT_EXTENDEDWAIT_MASK 0x3FF
#define LPC_EMC_STATICEXTENDEDWAIT_EXTENDEDWAIT_BIT 0

#define LPC_EMC_DYNAMICCONFIG0 (*(volatile unsigned long *)0x2009C100)
#define LPC_EMC_DYNAMICCONFIG0_OFFSET 0x100
#define LPC_EMC_DYNAMICCONFIG0_MD_MASK 0x18
#define LPC_EMC_DYNAMICCONFIG0_MD_BIT 3
#define LPC_EMC_DYNAMICCONFIG0_AM0_MASK 0x1F80
#define LPC_EMC_DYNAMICCONFIG0_AM0_BIT 7
#define LPC_EMC_DYNAMICCONFIG0_AM1_MASK 0x4000
#define LPC_EMC_DYNAMICCONFIG0_AM1 0x4000
#define LPC_EMC_DYNAMICCONFIG0_AM1_BIT 14
#define LPC_EMC_DYNAMICCONFIG0_B_MASK 0x80000
#define LPC_EMC_DYNAMICCONFIG0_B 0x80000
#define LPC_EMC_DYNAMICCONFIG0_B_BIT 19
#define LPC_EMC_DYNAMICCONFIG0_P_MASK 0x100000
#define LPC_EMC_DYNAMICCONFIG0_P 0x100000
#define LPC_EMC_DYNAMICCONFIG0_P_BIT 20

#define LPC_EMC_DYNAMICCONFIG1 (*(volatile unsigned long *)0x2009C120)
#define LPC_EMC_DYNAMICCONFIG1_OFFSET 0x120
#define LPC_EMC_DYNAMICCONFIG1_MD_MASK 0x18
#define LPC_EMC_DYNAMICCONFIG1_MD_BIT 3
#define LPC_EMC_DYNAMICCONFIG1_AM0_MASK 0x1F80
#define LPC_EMC_DYNAMICCONFIG1_AM0_BIT 7
#define LPC_EMC_DYNAMICCONFIG1_AM1_MASK 0x4000
#define LPC_EMC_DYNAMICCONFIG1_AM1 0x4000
#define LPC_EMC_DYNAMICCONFIG1_AM1_BIT 14
#define LPC_EMC_DYNAMICCONFIG1_B_MASK 0x80000
#define LPC_EMC_DYNAMICCONFIG1_B 0x80000
#define LPC_EMC_DYNAMICCONFIG1_B_BIT 19
#define LPC_EMC_DYNAMICCONFIG1_P_MASK 0x100000
#define LPC_EMC_DYNAMICCONFIG1_P 0x100000
#define LPC_EMC_DYNAMICCONFIG1_P_BIT 20

#define LPC_EMC_DYNAMICCONFIG2 (*(volatile unsigned long *)0x2009C140)
#define LPC_EMC_DYNAMICCONFIG2_OFFSET 0x140
#define LPC_EMC_DYNAMICCONFIG2_MD_MASK 0x18
#define LPC_EMC_DYNAMICCONFIG2_MD_BIT 3
#define LPC_EMC_DYNAMICCONFIG2_AM0_MASK 0x1F80
#define LPC_EMC_DYNAMICCONFIG2_AM0_BIT 7
#define LPC_EMC_DYNAMICCONFIG2_AM1_MASK 0x4000
#define LPC_EMC_DYNAMICCONFIG2_AM1 0x4000
#define LPC_EMC_DYNAMICCONFIG2_AM1_BIT 14
#define LPC_EMC_DYNAMICCONFIG2_B_MASK 0x80000
#define LPC_EMC_DYNAMICCONFIG2_B 0x80000
#define LPC_EMC_DYNAMICCONFIG2_B_BIT 19
#define LPC_EMC_DYNAMICCONFIG2_P_MASK 0x100000
#define LPC_EMC_DYNAMICCONFIG2_P 0x100000
#define LPC_EMC_DYNAMICCONFIG2_P_BIT 20

#define LPC_EMC_DYNAMICCONFIG3 (*(volatile unsigned long *)0x2009C160)
#define LPC_EMC_DYNAMICCONFIG3_OFFSET 0x160
#define LPC_EMC_DYNAMICCONFIG3_MD_MASK 0x18
#define LPC_EMC_DYNAMICCONFIG3_MD_BIT 3
#define LPC_EMC_DYNAMICCONFIG3_AM0_MASK 0x1F80
#define LPC_EMC_DYNAMICCONFIG3_AM0_BIT 7
#define LPC_EMC_DYNAMICCONFIG3_AM1_MASK 0x4000
#define LPC_EMC_DYNAMICCONFIG3_AM1 0x4000
#define LPC_EMC_DYNAMICCONFIG3_AM1_BIT 14
#define LPC_EMC_DYNAMICCONFIG3_B_MASK 0x80000
#define LPC_EMC_DYNAMICCONFIG3_B 0x80000
#define LPC_EMC_DYNAMICCONFIG3_B_BIT 19
#define LPC_EMC_DYNAMICCONFIG3_P_MASK 0x100000
#define LPC_EMC_DYNAMICCONFIG3_P 0x100000
#define LPC_EMC_DYNAMICCONFIG3_P_BIT 20

#define LPC_EMC_DYNAMICRASCAS0 (*(volatile unsigned long *)0x2009C104)
#define LPC_EMC_DYNAMICRASCAS0_OFFSET 0x104
#define LPC_EMC_DYNAMICRASCAS0_RAS_MASK 0x3
#define LPC_EMC_DYNAMICRASCAS0_RAS_BIT 0
#define LPC_EMC_DYNAMICRASCAS0_CAS_MASK 0x300
#define LPC_EMC_DYNAMICRASCAS0_CAS_BIT 8

#define LPC_EMC_DYNAMICRASCAS1 (*(volatile unsigned long *)0x2009C124)
#define LPC_EMC_DYNAMICRASCAS1_OFFSET 0x124
#define LPC_EMC_DYNAMICRASCAS1_RAS_MASK 0x3
#define LPC_EMC_DYNAMICRASCAS1_RAS_BIT 0
#define LPC_EMC_DYNAMICRASCAS1_CAS_MASK 0x300
#define LPC_EMC_DYNAMICRASCAS1_CAS_BIT 8

#define LPC_EMC_DYNAMICRASCAS2 (*(volatile unsigned long *)0x2009C144)
#define LPC_EMC_DYNAMICRASCAS2_OFFSET 0x144
#define LPC_EMC_DYNAMICRASCAS2_RAS_MASK 0x3
#define LPC_EMC_DYNAMICRASCAS2_RAS_BIT 0
#define LPC_EMC_DYNAMICRASCAS2_CAS_MASK 0x300
#define LPC_EMC_DYNAMICRASCAS2_CAS_BIT 8

#define LPC_EMC_DYNAMICRASCAS3 (*(volatile unsigned long *)0x2009C164)
#define LPC_EMC_DYNAMICRASCAS3_OFFSET 0x164
#define LPC_EMC_DYNAMICRASCAS3_RAS_MASK 0x3
#define LPC_EMC_DYNAMICRASCAS3_RAS_BIT 0
#define LPC_EMC_DYNAMICRASCAS3_CAS_MASK 0x300
#define LPC_EMC_DYNAMICRASCAS3_CAS_BIT 8

#define LPC_EMC_STATICCONFIG0 (*(volatile unsigned long *)0x2009C200)
#define LPC_EMC_STATICCONFIG0_OFFSET 0x200
#define LPC_EMC_STATICCONFIG0_MW_MASK 0x3
#define LPC_EMC_STATICCONFIG0_MW_BIT 0
#define LPC_EMC_STATICCONFIG0_PM_MASK 0x8
#define LPC_EMC_STATICCONFIG0_PM 0x8
#define LPC_EMC_STATICCONFIG0_PM_BIT 3
#define LPC_EMC_STATICCONFIG0_PC_MASK 0x40
#define LPC_EMC_STATICCONFIG0_PC 0x40
#define LPC_EMC_STATICCONFIG0_PC_BIT 6
#define LPC_EMC_STATICCONFIG0_PB_MASK 0x80
#define LPC_EMC_STATICCONFIG0_PB 0x80
#define LPC_EMC_STATICCONFIG0_PB_BIT 7
#define LPC_EMC_STATICCONFIG0_EW_MASK 0x100
#define LPC_EMC_STATICCONFIG0_EW 0x100
#define LPC_EMC_STATICCONFIG0_EW_BIT 8
#define LPC_EMC_STATICCONFIG0_B_MASK 0x80000
#define LPC_EMC_STATICCONFIG0_B 0x80000
#define LPC_EMC_STATICCONFIG0_B_BIT 19
#define LPC_EMC_STATICCONFIG0_P_MASK 0x100000
#define LPC_EMC_STATICCONFIG0_P 0x100000
#define LPC_EMC_STATICCONFIG0_P_BIT 20

#define LPC_EMC_STATICCONFIG1 (*(volatile unsigned long *)0x2009C220)
#define LPC_EMC_STATICCONFIG1_OFFSET 0x220
#define LPC_EMC_STATICCONFIG1_MW_MASK 0x3
#define LPC_EMC_STATICCONFIG1_MW_BIT 0
#define LPC_EMC_STATICCONFIG1_PM_MASK 0x8
#define LPC_EMC_STATICCONFIG1_PM 0x8
#define LPC_EMC_STATICCONFIG1_PM_BIT 3
#define LPC_EMC_STATICCONFIG1_PC_MASK 0x40
#define LPC_EMC_STATICCONFIG1_PC 0x40
#define LPC_EMC_STATICCONFIG1_PC_BIT 6
#define LPC_EMC_STATICCONFIG1_PB_MASK 0x80
#define LPC_EMC_STATICCONFIG1_PB 0x80
#define LPC_EMC_STATICCONFIG1_PB_BIT 7
#define LPC_EMC_STATICCONFIG1_EW_MASK 0x100
#define LPC_EMC_STATICCONFIG1_EW 0x100
#define LPC_EMC_STATICCONFIG1_EW_BIT 8
#define LPC_EMC_STATICCONFIG1_B_MASK 0x80000
#define LPC_EMC_STATICCONFIG1_B 0x80000
#define LPC_EMC_STATICCONFIG1_B_BIT 19
#define LPC_EMC_STATICCONFIG1_P_MASK 0x100000
#define LPC_EMC_STATICCONFIG1_P 0x100000
#define LPC_EMC_STATICCONFIG1_P_BIT 20

#define LPC_EMC_STATICCONFIG2 (*(volatile unsigned long *)0x2009C240)
#define LPC_EMC_STATICCONFIG2_OFFSET 0x240
#define LPC_EMC_STATICCONFIG2_MW_MASK 0x3
#define LPC_EMC_STATICCONFIG2_MW_BIT 0
#define LPC_EMC_STATICCONFIG2_PM_MASK 0x8
#define LPC_EMC_STATICCONFIG2_PM 0x8
#define LPC_EMC_STATICCONFIG2_PM_BIT 3
#define LPC_EMC_STATICCONFIG2_PC_MASK 0x40
#define LPC_EMC_STATICCONFIG2_PC 0x40
#define LPC_EMC_STATICCONFIG2_PC_BIT 6
#define LPC_EMC_STATICCONFIG2_PB_MASK 0x80
#define LPC_EMC_STATICCONFIG2_PB 0x80
#define LPC_EMC_STATICCONFIG2_PB_BIT 7
#define LPC_EMC_STATICCONFIG2_EW_MASK 0x100
#define LPC_EMC_STATICCONFIG2_EW 0x100
#define LPC_EMC_STATICCONFIG2_EW_BIT 8
#define LPC_EMC_STATICCONFIG2_B_MASK 0x80000
#define LPC_EMC_STATICCONFIG2_B 0x80000
#define LPC_EMC_STATICCONFIG2_B_BIT 19
#define LPC_EMC_STATICCONFIG2_P_MASK 0x100000
#define LPC_EMC_STATICCONFIG2_P 0x100000
#define LPC_EMC_STATICCONFIG2_P_BIT 20

#define LPC_EMC_STATICCONFIG3 (*(volatile unsigned long *)0x2009C260)
#define LPC_EMC_STATICCONFIG3_OFFSET 0x260
#define LPC_EMC_STATICCONFIG3_MW_MASK 0x3
#define LPC_EMC_STATICCONFIG3_MW_BIT 0
#define LPC_EMC_STATICCONFIG3_PM_MASK 0x8
#define LPC_EMC_STATICCONFIG3_PM 0x8
#define LPC_EMC_STATICCONFIG3_PM_BIT 3
#define LPC_EMC_STATICCONFIG3_PC_MASK 0x40
#define LPC_EMC_STATICCONFIG3_PC 0x40
#define LPC_EMC_STATICCONFIG3_PC_BIT 6
#define LPC_EMC_STATICCONFIG3_PB_MASK 0x80
#define LPC_EMC_STATICCONFIG3_PB 0x80
#define LPC_EMC_STATICCONFIG3_PB_BIT 7
#define LPC_EMC_STATICCONFIG3_EW_MASK 0x100
#define LPC_EMC_STATICCONFIG3_EW 0x100
#define LPC_EMC_STATICCONFIG3_EW_BIT 8
#define LPC_EMC_STATICCONFIG3_B_MASK 0x80000
#define LPC_EMC_STATICCONFIG3_B 0x80000
#define LPC_EMC_STATICCONFIG3_B_BIT 19
#define LPC_EMC_STATICCONFIG3_P_MASK 0x100000
#define LPC_EMC_STATICCONFIG3_P 0x100000
#define LPC_EMC_STATICCONFIG3_P_BIT 20

#define LPC_EMC_STATICWAITWEN0 (*(volatile unsigned long *)0x2009C204)
#define LPC_EMC_STATICWAITWEN0_OFFSET 0x204
#define LPC_EMC_STATICWAITWEN0_WAITWEN_MASK 0xF
#define LPC_EMC_STATICWAITWEN0_WAITWEN_BIT 0

#define LPC_EMC_STATICWAITWEN1 (*(volatile unsigned long *)0x2009C224)
#define LPC_EMC_STATICWAITWEN1_OFFSET 0x224
#define LPC_EMC_STATICWAITWEN1_WAITWEN_MASK 0xF
#define LPC_EMC_STATICWAITWEN1_WAITWEN_BIT 0

#define LPC_EMC_STATICWAITWEN2 (*(volatile unsigned long *)0x2009C244)
#define LPC_EMC_STATICWAITWEN2_OFFSET 0x244
#define LPC_EMC_STATICWAITWEN2_WAITWEN_MASK 0xF
#define LPC_EMC_STATICWAITWEN2_WAITWEN_BIT 0

#define LPC_EMC_STATICWAITWEN3 (*(volatile unsigned long *)0x2009C264)
#define LPC_EMC_STATICWAITWEN3_OFFSET 0x264
#define LPC_EMC_STATICWAITWEN3_WAITWEN_MASK 0xF
#define LPC_EMC_STATICWAITWEN3_WAITWEN_BIT 0

#define LPC_EMC_STATICWAITOEN0 (*(volatile unsigned long *)0x2009C208)
#define LPC_EMC_STATICWAITOEN0_OFFSET 0x208
#define LPC_EMC_STATICWAITOEN0_WAITOEN_MASK 0xF
#define LPC_EMC_STATICWAITOEN0_WAITOEN_BIT 0

#define LPC_EMC_STATICWAITOEN1 (*(volatile unsigned long *)0x2009C228)
#define LPC_EMC_STATICWAITOEN1_OFFSET 0x228
#define LPC_EMC_STATICWAITOEN1_WAITOEN_MASK 0xF
#define LPC_EMC_STATICWAITOEN1_WAITOEN_BIT 0

#define LPC_EMC_STATICWAITOEN2 (*(volatile unsigned long *)0x2009C248)
#define LPC_EMC_STATICWAITOEN2_OFFSET 0x248
#define LPC_EMC_STATICWAITOEN2_WAITOEN_MASK 0xF
#define LPC_EMC_STATICWAITOEN2_WAITOEN_BIT 0

#define LPC_EMC_STATICWAITOEN3 (*(volatile unsigned long *)0x2009C268)
#define LPC_EMC_STATICWAITOEN3_OFFSET 0x268
#define LPC_EMC_STATICWAITOEN3_WAITOEN_MASK 0xF
#define LPC_EMC_STATICWAITOEN3_WAITOEN_BIT 0

#define LPC_EMC_STATICWAITRD0 (*(volatile unsigned long *)0x2009C20C)
#define LPC_EMC_STATICWAITRD0_OFFSET 0x20C
#define LPC_EMC_STATICWAITRD0_WAITRD_MASK 0x1F
#define LPC_EMC_STATICWAITRD0_WAITRD_BIT 0

#define LPC_EMC_STATICWAITRD1 (*(volatile unsigned long *)0x2009C22C)
#define LPC_EMC_STATICWAITRD1_OFFSET 0x22C
#define LPC_EMC_STATICWAITRD1_WAITRD_MASK 0x1F
#define LPC_EMC_STATICWAITRD1_WAITRD_BIT 0

#define LPC_EMC_STATICWAITRD2 (*(volatile unsigned long *)0x2009C24C)
#define LPC_EMC_STATICWAITRD2_OFFSET 0x24C
#define LPC_EMC_STATICWAITRD2_WAITRD_MASK 0x1F
#define LPC_EMC_STATICWAITRD2_WAITRD_BIT 0

#define LPC_EMC_STATICWAITRD3 (*(volatile unsigned long *)0x2009C26C)
#define LPC_EMC_STATICWAITRD3_OFFSET 0x26C
#define LPC_EMC_STATICWAITRD3_WAITRD_MASK 0x1F
#define LPC_EMC_STATICWAITRD3_WAITRD_BIT 0

#define LPC_EMC_STATICWAITPAGE0 (*(volatile unsigned long *)0x2009C210)
#define LPC_EMC_STATICWAITPAGE0_OFFSET 0x210
#define LPC_EMC_STATICWAITPAGE0_WAITPAGE_MASK 0x1F
#define LPC_EMC_STATICWAITPAGE0_WAITPAGE_BIT 0

#define LPC_EMC_STATICWAITPAGE1 (*(volatile unsigned long *)0x2009C230)
#define LPC_EMC_STATICWAITPAGE1_OFFSET 0x230
#define LPC_EMC_STATICWAITPAGE1_WAITPAGE_MASK 0x1F
#define LPC_EMC_STATICWAITPAGE1_WAITPAGE_BIT 0

#define LPC_EMC_STATICWAITPAGE2 (*(volatile unsigned long *)0x2009C250)
#define LPC_EMC_STATICWAITPAGE2_OFFSET 0x250
#define LPC_EMC_STATICWAITPAGE2_WAITPAGE_MASK 0x1F
#define LPC_EMC_STATICWAITPAGE2_WAITPAGE_BIT 0

#define LPC_EMC_STATICWAITPAGE3 (*(volatile unsigned long *)0x2009C270)
#define LPC_EMC_STATICWAITPAGE3_OFFSET 0x270
#define LPC_EMC_STATICWAITPAGE3_WAITPAGE_MASK 0x1F
#define LPC_EMC_STATICWAITPAGE3_WAITPAGE_BIT 0

#define LPC_EMC_STATICWAITWR0 (*(volatile unsigned long *)0x2009C214)
#define LPC_EMC_STATICWAITWR0_OFFSET 0x214
#define LPC_EMC_STATICWAITWR0_WAITWR_MASK 0x1F
#define LPC_EMC_STATICWAITWR0_WAITWR_BIT 0

#define LPC_EMC_STATICWAITWR1 (*(volatile unsigned long *)0x2009C234)
#define LPC_EMC_STATICWAITWR1_OFFSET 0x234
#define LPC_EMC_STATICWAITWR1_WAITWR_MASK 0x1F
#define LPC_EMC_STATICWAITWR1_WAITWR_BIT 0

#define LPC_EMC_STATICWAITWR2 (*(volatile unsigned long *)0x2009C254)
#define LPC_EMC_STATICWAITWR2_OFFSET 0x254
#define LPC_EMC_STATICWAITWR2_WAITWR_MASK 0x1F
#define LPC_EMC_STATICWAITWR2_WAITWR_BIT 0

#define LPC_EMC_STATICWAITWR3 (*(volatile unsigned long *)0x2009C274)
#define LPC_EMC_STATICWAITWR3_OFFSET 0x274
#define LPC_EMC_STATICWAITWR3_WAITWR_MASK 0x1F
#define LPC_EMC_STATICWAITWR3_WAITWR_BIT 0

#define LPC_EMC_STATICWAITTURN0 (*(volatile unsigned long *)0x2009C218)
#define LPC_EMC_STATICWAITTURN0_OFFSET 0x218
#define LPC_EMC_STATICWAITTURN0_WAITTURN_MASK 0xF
#define LPC_EMC_STATICWAITTURN0_WAITTURN_BIT 0

#define LPC_EMC_STATICWAITTURN1 (*(volatile unsigned long *)0x2009C238)
#define LPC_EMC_STATICWAITTURN1_OFFSET 0x238
#define LPC_EMC_STATICWAITTURN1_WAITTURN_MASK 0xF
#define LPC_EMC_STATICWAITTURN1_WAITTURN_BIT 0

#define LPC_EMC_STATICWAITTURN2 (*(volatile unsigned long *)0x2009C258)
#define LPC_EMC_STATICWAITTURN2_OFFSET 0x258
#define LPC_EMC_STATICWAITTURN2_WAITTURN_MASK 0xF
#define LPC_EMC_STATICWAITTURN2_WAITTURN_BIT 0

#define LPC_EMC_STATICWAITTURN3 (*(volatile unsigned long *)0x2009C278)
#define LPC_EMC_STATICWAITTURN3_OFFSET 0x278
#define LPC_EMC_STATICWAITTURN3_WAITTURN_MASK 0xF
#define LPC_EMC_STATICWAITTURN3_WAITTURN_BIT 0

#ifndef LPC_WWDT_BASE_ADDRESS
#define LPC_WWDT_BASE_ADDRESS 0x40000000
#endif

#define LPC_WWDT_MOD (*(volatile unsigned long *)0x40000000)
#define LPC_WWDT_MOD_OFFSET 0x0
#define LPC_WWDT_MOD_WDEN_MASK 0x1
#define LPC_WWDT_MOD_WDEN 0x1
#define LPC_WWDT_MOD_WDEN_BIT 0
#define LPC_WWDT_MOD_WDRESET_MASK 0x2
#define LPC_WWDT_MOD_WDRESET 0x2
#define LPC_WWDT_MOD_WDRESET_BIT 1
#define LPC_WWDT_MOD_WDTOF_MASK 0x4
#define LPC_WWDT_MOD_WDTOF 0x4
#define LPC_WWDT_MOD_WDTOF_BIT 2
#define LPC_WWDT_MOD_WDINT_MASK 0x8
#define LPC_WWDT_MOD_WDINT 0x8
#define LPC_WWDT_MOD_WDINT_BIT 3
#define LPC_WWDT_MOD_WDPROTECT_MASK 0x10
#define LPC_WWDT_MOD_WDPROTECT 0x10
#define LPC_WWDT_MOD_WDPROTECT_BIT 4

#define LPC_WWDT_TC (*(volatile unsigned long *)0x40000004)
#define LPC_WWDT_TC_OFFSET 0x4
#define LPC_WWDT_TC_Count_MASK 0xFFFFFF
#define LPC_WWDT_TC_Count_BIT 0

#define LPC_WWDT_FEED (*(volatile unsigned long *)0x40000008)
#define LPC_WWDT_FEED_OFFSET 0x8
#define LPC_WWDT_FEED_Feed_MASK 0xFF
#define LPC_WWDT_FEED_Feed_BIT 0

#define LPC_WWDT_TV (*(volatile unsigned long *)0x4000000C)
#define LPC_WWDT_TV_OFFSET 0xC
#define LPC_WWDT_TV_Count_MASK 0xFFFFFF
#define LPC_WWDT_TV_Count_BIT 0

#define LPC_WWDT_WARNINT (*(volatile unsigned long *)0x40000014)
#define LPC_WWDT_WARNINT_OFFSET 0x14
#define LPC_WWDT_WARNINT_WARNINT_MASK 0x3FF
#define LPC_WWDT_WARNINT_WARNINT_BIT 0

#define LPC_WWDT_WINDOW (*(volatile unsigned long *)0x40000018)
#define LPC_WWDT_WINDOW_OFFSET 0x18
#define LPC_WWDT_WINDOW_WINDOW_MASK 0xFFFFFF
#define LPC_WWDT_WINDOW_WINDOW_BIT 0

#ifndef LPC_TIMER0_BASE_ADDRESS
#define LPC_TIMER0_BASE_ADDRESS 0x40004000
#endif

#define LPC_TIMER0_IR (*(volatile unsigned long *)0x40004000)
#define LPC_TIMER0_IR_OFFSET 0x0
#define LPC_TIMER0_IR_MR0INT_MASK 0x1
#define LPC_TIMER0_IR_MR0INT 0x1
#define LPC_TIMER0_IR_MR0INT_BIT 0
#define LPC_TIMER0_IR_MR1INT_MASK 0x2
#define LPC_TIMER0_IR_MR1INT 0x2
#define LPC_TIMER0_IR_MR1INT_BIT 1
#define LPC_TIMER0_IR_MR2INT_MASK 0x4
#define LPC_TIMER0_IR_MR2INT 0x4
#define LPC_TIMER0_IR_MR2INT_BIT 2
#define LPC_TIMER0_IR_MR3INT_MASK 0x8
#define LPC_TIMER0_IR_MR3INT 0x8
#define LPC_TIMER0_IR_MR3INT_BIT 3
#define LPC_TIMER0_IR_CR0INT_MASK 0x10
#define LPC_TIMER0_IR_CR0INT 0x10
#define LPC_TIMER0_IR_CR0INT_BIT 4
#define LPC_TIMER0_IR_CR1INT_MASK 0x20
#define LPC_TIMER0_IR_CR1INT 0x20
#define LPC_TIMER0_IR_CR1INT_BIT 5

#define LPC_TIMER0_TCR (*(volatile unsigned long *)0x40004004)
#define LPC_TIMER0_TCR_OFFSET 0x4
#define LPC_TIMER0_TCR_CEN_MASK 0x1
#define LPC_TIMER0_TCR_CEN 0x1
#define LPC_TIMER0_TCR_CEN_BIT 0
#define LPC_TIMER0_TCR_CRST_MASK 0x2
#define LPC_TIMER0_TCR_CRST 0x2
#define LPC_TIMER0_TCR_CRST_BIT 1

#define LPC_TIMER0_TC (*(volatile unsigned long *)0x40004008)
#define LPC_TIMER0_TC_OFFSET 0x8
#define LPC_TIMER0_TC_TC_MASK 0xFFFFFFFF
#define LPC_TIMER0_TC_TC_BIT 0

#define LPC_TIMER0_PR (*(volatile unsigned long *)0x4000400C)
#define LPC_TIMER0_PR_OFFSET 0xC
#define LPC_TIMER0_PR_PM_MASK 0xFFFFFFFF
#define LPC_TIMER0_PR_PM_BIT 0

#define LPC_TIMER0_PC (*(volatile unsigned long *)0x40004010)
#define LPC_TIMER0_PC_OFFSET 0x10
#define LPC_TIMER0_PC_PC_MASK 0xFFFFFFFF
#define LPC_TIMER0_PC_PC_BIT 0

#define LPC_TIMER0_MCR (*(volatile unsigned long *)0x40004014)
#define LPC_TIMER0_MCR_OFFSET 0x14
#define LPC_TIMER0_MCR_MR0I_MASK 0x1
#define LPC_TIMER0_MCR_MR0I 0x1
#define LPC_TIMER0_MCR_MR0I_BIT 0
#define LPC_TIMER0_MCR_MR0R_MASK 0x2
#define LPC_TIMER0_MCR_MR0R 0x2
#define LPC_TIMER0_MCR_MR0R_BIT 1
#define LPC_TIMER0_MCR_MR0S_MASK 0x4
#define LPC_TIMER0_MCR_MR0S 0x4
#define LPC_TIMER0_MCR_MR0S_BIT 2
#define LPC_TIMER0_MCR_MR1I_MASK 0x8
#define LPC_TIMER0_MCR_MR1I 0x8
#define LPC_TIMER0_MCR_MR1I_BIT 3
#define LPC_TIMER0_MCR_MR1R_MASK 0x10
#define LPC_TIMER0_MCR_MR1R 0x10
#define LPC_TIMER0_MCR_MR1R_BIT 4
#define LPC_TIMER0_MCR_MR1S_MASK 0x20
#define LPC_TIMER0_MCR_MR1S 0x20
#define LPC_TIMER0_MCR_MR1S_BIT 5
#define LPC_TIMER0_MCR_MR2I_MASK 0x40
#define LPC_TIMER0_MCR_MR2I 0x40
#define LPC_TIMER0_MCR_MR2I_BIT 6
#define LPC_TIMER0_MCR_MR2R_MASK 0x80
#define LPC_TIMER0_MCR_MR2R 0x80
#define LPC_TIMER0_MCR_MR2R_BIT 7
#define LPC_TIMER0_MCR_MR2S_MASK 0x100
#define LPC_TIMER0_MCR_MR2S 0x100
#define LPC_TIMER0_MCR_MR2S_BIT 8
#define LPC_TIMER0_MCR_MR3I_MASK 0x200
#define LPC_TIMER0_MCR_MR3I 0x200
#define LPC_TIMER0_MCR_MR3I_BIT 9
#define LPC_TIMER0_MCR_MR3R_MASK 0x400
#define LPC_TIMER0_MCR_MR3R 0x400
#define LPC_TIMER0_MCR_MR3R_BIT 10
#define LPC_TIMER0_MCR_MR3S_MASK 0x800
#define LPC_TIMER0_MCR_MR3S 0x800
#define LPC_TIMER0_MCR_MR3S_BIT 11

#define LPC_TIMER0_MR0 (*(volatile unsigned long *)0x40004018)
#define LPC_TIMER0_MR0_OFFSET 0x18
#define LPC_TIMER0_MR0_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER0_MR0_MATCH_BIT 0

#define LPC_TIMER0_MR1 (*(volatile unsigned long *)0x4000401C)
#define LPC_TIMER0_MR1_OFFSET 0x1C
#define LPC_TIMER0_MR1_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER0_MR1_MATCH_BIT 0

#define LPC_TIMER0_MR2 (*(volatile unsigned long *)0x40004020)
#define LPC_TIMER0_MR2_OFFSET 0x20
#define LPC_TIMER0_MR2_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER0_MR2_MATCH_BIT 0

#define LPC_TIMER0_MR3 (*(volatile unsigned long *)0x40004024)
#define LPC_TIMER0_MR3_OFFSET 0x24
#define LPC_TIMER0_MR3_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER0_MR3_MATCH_BIT 0

#define LPC_TIMER0_CCR (*(volatile unsigned long *)0x40004028)
#define LPC_TIMER0_CCR_OFFSET 0x28
#define LPC_TIMER0_CCR_CAP0RE_MASK 0x1
#define LPC_TIMER0_CCR_CAP0RE 0x1
#define LPC_TIMER0_CCR_CAP0RE_BIT 0
#define LPC_TIMER0_CCR_CAP0FE_MASK 0x2
#define LPC_TIMER0_CCR_CAP0FE 0x2
#define LPC_TIMER0_CCR_CAP0FE_BIT 1
#define LPC_TIMER0_CCR_CAP0I_MASK 0x4
#define LPC_TIMER0_CCR_CAP0I 0x4
#define LPC_TIMER0_CCR_CAP0I_BIT 2
#define LPC_TIMER0_CCR_CAP1RE_MASK 0x8
#define LPC_TIMER0_CCR_CAP1RE 0x8
#define LPC_TIMER0_CCR_CAP1RE_BIT 3
#define LPC_TIMER0_CCR_CAP1FE_MASK 0x10
#define LPC_TIMER0_CCR_CAP1FE 0x10
#define LPC_TIMER0_CCR_CAP1FE_BIT 4
#define LPC_TIMER0_CCR_CAP1I_MASK 0x20
#define LPC_TIMER0_CCR_CAP1I 0x20
#define LPC_TIMER0_CCR_CAP1I_BIT 5

#define LPC_TIMER0_CR0 (*(volatile unsigned long *)0x4000402C)
#define LPC_TIMER0_CR0_OFFSET 0x2C
#define LPC_TIMER0_CR0_CAP_MASK 0xFFFFFFFF
#define LPC_TIMER0_CR0_CAP_BIT 0

#define LPC_TIMER0_CR1 (*(volatile unsigned long *)0x40004030)
#define LPC_TIMER0_CR1_OFFSET 0x30
#define LPC_TIMER0_CR1_CAP_MASK 0xFFFFFFFF
#define LPC_TIMER0_CR1_CAP_BIT 0

#define LPC_TIMER0_EMR (*(volatile unsigned long *)0x4000403C)
#define LPC_TIMER0_EMR_OFFSET 0x3C
#define LPC_TIMER0_EMR_EM0_MASK 0x1
#define LPC_TIMER0_EMR_EM0 0x1
#define LPC_TIMER0_EMR_EM0_BIT 0
#define LPC_TIMER0_EMR_EM1_MASK 0x2
#define LPC_TIMER0_EMR_EM1 0x2
#define LPC_TIMER0_EMR_EM1_BIT 1
#define LPC_TIMER0_EMR_EM2_MASK 0x4
#define LPC_TIMER0_EMR_EM2 0x4
#define LPC_TIMER0_EMR_EM2_BIT 2
#define LPC_TIMER0_EMR_EM3_MASK 0x8
#define LPC_TIMER0_EMR_EM3 0x8
#define LPC_TIMER0_EMR_EM3_BIT 3
#define LPC_TIMER0_EMR_EMC0_MASK 0x30
#define LPC_TIMER0_EMR_EMC0_BIT 4
#define LPC_TIMER0_EMR_EMC1_MASK 0xC0
#define LPC_TIMER0_EMR_EMC1_BIT 6
#define LPC_TIMER0_EMR_EMC2_MASK 0x300
#define LPC_TIMER0_EMR_EMC2_BIT 8
#define LPC_TIMER0_EMR_EMC3_MASK 0xC00
#define LPC_TIMER0_EMR_EMC3_BIT 10

#define LPC_TIMER0_CTCR (*(volatile unsigned long *)0x40004070)
#define LPC_TIMER0_CTCR_OFFSET 0x70
#define LPC_TIMER0_CTCR_CTMODE_MASK 0x3
#define LPC_TIMER0_CTCR_CTMODE_BIT 0
#define LPC_TIMER0_CTCR_CINSEL_MASK 0xC
#define LPC_TIMER0_CTCR_CINSEL_BIT 2

#ifndef LPC_TIMER1_BASE_ADDRESS
#define LPC_TIMER1_BASE_ADDRESS 0x40008000
#endif

#define LPC_TIMER1_IR (*(volatile unsigned long *)0x40008000)
#define LPC_TIMER1_IR_OFFSET 0x0
#define LPC_TIMER1_IR_MR0INT_MASK 0x1
#define LPC_TIMER1_IR_MR0INT 0x1
#define LPC_TIMER1_IR_MR0INT_BIT 0
#define LPC_TIMER1_IR_MR1INT_MASK 0x2
#define LPC_TIMER1_IR_MR1INT 0x2
#define LPC_TIMER1_IR_MR1INT_BIT 1
#define LPC_TIMER1_IR_MR2INT_MASK 0x4
#define LPC_TIMER1_IR_MR2INT 0x4
#define LPC_TIMER1_IR_MR2INT_BIT 2
#define LPC_TIMER1_IR_MR3INT_MASK 0x8
#define LPC_TIMER1_IR_MR3INT 0x8
#define LPC_TIMER1_IR_MR3INT_BIT 3
#define LPC_TIMER1_IR_CR0INT_MASK 0x10
#define LPC_TIMER1_IR_CR0INT 0x10
#define LPC_TIMER1_IR_CR0INT_BIT 4
#define LPC_TIMER1_IR_CR1INT_MASK 0x20
#define LPC_TIMER1_IR_CR1INT 0x20
#define LPC_TIMER1_IR_CR1INT_BIT 5

#define LPC_TIMER1_TCR (*(volatile unsigned long *)0x40008004)
#define LPC_TIMER1_TCR_OFFSET 0x4
#define LPC_TIMER1_TCR_CEN_MASK 0x1
#define LPC_TIMER1_TCR_CEN 0x1
#define LPC_TIMER1_TCR_CEN_BIT 0
#define LPC_TIMER1_TCR_CRST_MASK 0x2
#define LPC_TIMER1_TCR_CRST 0x2
#define LPC_TIMER1_TCR_CRST_BIT 1

#define LPC_TIMER1_TC (*(volatile unsigned long *)0x40008008)
#define LPC_TIMER1_TC_OFFSET 0x8
#define LPC_TIMER1_TC_TC_MASK 0xFFFFFFFF
#define LPC_TIMER1_TC_TC_BIT 0

#define LPC_TIMER1_PR (*(volatile unsigned long *)0x4000800C)
#define LPC_TIMER1_PR_OFFSET 0xC
#define LPC_TIMER1_PR_PM_MASK 0xFFFFFFFF
#define LPC_TIMER1_PR_PM_BIT 0

#define LPC_TIMER1_PC (*(volatile unsigned long *)0x40008010)
#define LPC_TIMER1_PC_OFFSET 0x10
#define LPC_TIMER1_PC_PC_MASK 0xFFFFFFFF
#define LPC_TIMER1_PC_PC_BIT 0

#define LPC_TIMER1_MCR (*(volatile unsigned long *)0x40008014)
#define LPC_TIMER1_MCR_OFFSET 0x14
#define LPC_TIMER1_MCR_MR0I_MASK 0x1
#define LPC_TIMER1_MCR_MR0I 0x1
#define LPC_TIMER1_MCR_MR0I_BIT 0
#define LPC_TIMER1_MCR_MR0R_MASK 0x2
#define LPC_TIMER1_MCR_MR0R 0x2
#define LPC_TIMER1_MCR_MR0R_BIT 1
#define LPC_TIMER1_MCR_MR0S_MASK 0x4
#define LPC_TIMER1_MCR_MR0S 0x4
#define LPC_TIMER1_MCR_MR0S_BIT 2
#define LPC_TIMER1_MCR_MR1I_MASK 0x8
#define LPC_TIMER1_MCR_MR1I 0x8
#define LPC_TIMER1_MCR_MR1I_BIT 3
#define LPC_TIMER1_MCR_MR1R_MASK 0x10
#define LPC_TIMER1_MCR_MR1R 0x10
#define LPC_TIMER1_MCR_MR1R_BIT 4
#define LPC_TIMER1_MCR_MR1S_MASK 0x20
#define LPC_TIMER1_MCR_MR1S 0x20
#define LPC_TIMER1_MCR_MR1S_BIT 5
#define LPC_TIMER1_MCR_MR2I_MASK 0x40
#define LPC_TIMER1_MCR_MR2I 0x40
#define LPC_TIMER1_MCR_MR2I_BIT 6
#define LPC_TIMER1_MCR_MR2R_MASK 0x80
#define LPC_TIMER1_MCR_MR2R 0x80
#define LPC_TIMER1_MCR_MR2R_BIT 7
#define LPC_TIMER1_MCR_MR2S_MASK 0x100
#define LPC_TIMER1_MCR_MR2S 0x100
#define LPC_TIMER1_MCR_MR2S_BIT 8
#define LPC_TIMER1_MCR_MR3I_MASK 0x200
#define LPC_TIMER1_MCR_MR3I 0x200
#define LPC_TIMER1_MCR_MR3I_BIT 9
#define LPC_TIMER1_MCR_MR3R_MASK 0x400
#define LPC_TIMER1_MCR_MR3R 0x400
#define LPC_TIMER1_MCR_MR3R_BIT 10
#define LPC_TIMER1_MCR_MR3S_MASK 0x800
#define LPC_TIMER1_MCR_MR3S 0x800
#define LPC_TIMER1_MCR_MR3S_BIT 11

#define LPC_TIMER1_MR0 (*(volatile unsigned long *)0x40008018)
#define LPC_TIMER1_MR0_OFFSET 0x18
#define LPC_TIMER1_MR0_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER1_MR0_MATCH_BIT 0

#define LPC_TIMER1_MR1 (*(volatile unsigned long *)0x4000801C)
#define LPC_TIMER1_MR1_OFFSET 0x1C
#define LPC_TIMER1_MR1_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER1_MR1_MATCH_BIT 0

#define LPC_TIMER1_MR2 (*(volatile unsigned long *)0x40008020)
#define LPC_TIMER1_MR2_OFFSET 0x20
#define LPC_TIMER1_MR2_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER1_MR2_MATCH_BIT 0

#define LPC_TIMER1_MR3 (*(volatile unsigned long *)0x40008024)
#define LPC_TIMER1_MR3_OFFSET 0x24
#define LPC_TIMER1_MR3_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER1_MR3_MATCH_BIT 0

#define LPC_TIMER1_CCR (*(volatile unsigned long *)0x40008028)
#define LPC_TIMER1_CCR_OFFSET 0x28
#define LPC_TIMER1_CCR_CAP0RE_MASK 0x1
#define LPC_TIMER1_CCR_CAP0RE 0x1
#define LPC_TIMER1_CCR_CAP0RE_BIT 0
#define LPC_TIMER1_CCR_CAP0FE_MASK 0x2
#define LPC_TIMER1_CCR_CAP0FE 0x2
#define LPC_TIMER1_CCR_CAP0FE_BIT 1
#define LPC_TIMER1_CCR_CAP0I_MASK 0x4
#define LPC_TIMER1_CCR_CAP0I 0x4
#define LPC_TIMER1_CCR_CAP0I_BIT 2
#define LPC_TIMER1_CCR_CAP1RE_MASK 0x8
#define LPC_TIMER1_CCR_CAP1RE 0x8
#define LPC_TIMER1_CCR_CAP1RE_BIT 3
#define LPC_TIMER1_CCR_CAP1FE_MASK 0x10
#define LPC_TIMER1_CCR_CAP1FE 0x10
#define LPC_TIMER1_CCR_CAP1FE_BIT 4
#define LPC_TIMER1_CCR_CAP1I_MASK 0x20
#define LPC_TIMER1_CCR_CAP1I 0x20
#define LPC_TIMER1_CCR_CAP1I_BIT 5

#define LPC_TIMER1_CR0 (*(volatile unsigned long *)0x4000802C)
#define LPC_TIMER1_CR0_OFFSET 0x2C
#define LPC_TIMER1_CR0_CAP_MASK 0xFFFFFFFF
#define LPC_TIMER1_CR0_CAP_BIT 0

#define LPC_TIMER1_CR1 (*(volatile unsigned long *)0x40008030)
#define LPC_TIMER1_CR1_OFFSET 0x30
#define LPC_TIMER1_CR1_CAP_MASK 0xFFFFFFFF
#define LPC_TIMER1_CR1_CAP_BIT 0

#define LPC_TIMER1_EMR (*(volatile unsigned long *)0x4000803C)
#define LPC_TIMER1_EMR_OFFSET 0x3C
#define LPC_TIMER1_EMR_EM0_MASK 0x1
#define LPC_TIMER1_EMR_EM0 0x1
#define LPC_TIMER1_EMR_EM0_BIT 0
#define LPC_TIMER1_EMR_EM1_MASK 0x2
#define LPC_TIMER1_EMR_EM1 0x2
#define LPC_TIMER1_EMR_EM1_BIT 1
#define LPC_TIMER1_EMR_EM2_MASK 0x4
#define LPC_TIMER1_EMR_EM2 0x4
#define LPC_TIMER1_EMR_EM2_BIT 2
#define LPC_TIMER1_EMR_EM3_MASK 0x8
#define LPC_TIMER1_EMR_EM3 0x8
#define LPC_TIMER1_EMR_EM3_BIT 3
#define LPC_TIMER1_EMR_EMC0_MASK 0x30
#define LPC_TIMER1_EMR_EMC0_BIT 4
#define LPC_TIMER1_EMR_EMC1_MASK 0xC0
#define LPC_TIMER1_EMR_EMC1_BIT 6
#define LPC_TIMER1_EMR_EMC2_MASK 0x300
#define LPC_TIMER1_EMR_EMC2_BIT 8
#define LPC_TIMER1_EMR_EMC3_MASK 0xC00
#define LPC_TIMER1_EMR_EMC3_BIT 10

#define LPC_TIMER1_CTCR (*(volatile unsigned long *)0x40008070)
#define LPC_TIMER1_CTCR_OFFSET 0x70
#define LPC_TIMER1_CTCR_CTMODE_MASK 0x3
#define LPC_TIMER1_CTCR_CTMODE_BIT 0
#define LPC_TIMER1_CTCR_CINSEL_MASK 0xC
#define LPC_TIMER1_CTCR_CINSEL_BIT 2

#ifndef LPC_UART0_BASE_ADDRESS
#define LPC_UART0_BASE_ADDRESS 0x4000C000
#endif

#define LPC_UART0_RBR (*(volatile unsigned long *)0x4000C000)
#define LPC_UART0_RBR_OFFSET 0x0
#define LPC_UART0_RBR_RBR_MASK 0xFF
#define LPC_UART0_RBR_RBR_BIT 0

#define LPC_UART0_THR (*(volatile unsigned long *)0x4000C000)
#define LPC_UART0_THR_OFFSET 0x0
#define LPC_UART0_THR_THR_MASK 0xFF
#define LPC_UART0_THR_THR_BIT 0

#define LPC_UART0_DLL (*(volatile unsigned long *)0x4000C000)
#define LPC_UART0_DLL_OFFSET 0x0
#define LPC_UART0_DLL_DLLSB_MASK 0xFF
#define LPC_UART0_DLL_DLLSB_BIT 0

#define LPC_UART0_DLM (*(volatile unsigned long *)0x4000C004)
#define LPC_UART0_DLM_OFFSET 0x4
#define LPC_UART0_DLM_DLMSB_MASK 0xFF
#define LPC_UART0_DLM_DLMSB_BIT 0

#define LPC_UART0_IER (*(volatile unsigned long *)0x4000C004)
#define LPC_UART0_IER_OFFSET 0x4
#define LPC_UART0_IER_RBRIE_MASK 0x1
#define LPC_UART0_IER_RBRIE 0x1
#define LPC_UART0_IER_RBRIE_BIT 0
#define LPC_UART0_IER_THREIE_MASK 0x2
#define LPC_UART0_IER_THREIE 0x2
#define LPC_UART0_IER_THREIE_BIT 1
#define LPC_UART0_IER_RXIE_MASK 0x4
#define LPC_UART0_IER_RXIE 0x4
#define LPC_UART0_IER_RXIE_BIT 2
#define LPC_UART0_IER_ABEOINTEN_MASK 0x100
#define LPC_UART0_IER_ABEOINTEN 0x100
#define LPC_UART0_IER_ABEOINTEN_BIT 8
#define LPC_UART0_IER_ABTOINTEN_MASK 0x200
#define LPC_UART0_IER_ABTOINTEN 0x200
#define LPC_UART0_IER_ABTOINTEN_BIT 9

#define LPC_UART0_IIR (*(volatile unsigned long *)0x4000C008)
#define LPC_UART0_IIR_OFFSET 0x8
#define LPC_UART0_IIR_INTSTATUS_MASK 0x1
#define LPC_UART0_IIR_INTSTATUS 0x1
#define LPC_UART0_IIR_INTSTATUS_BIT 0
#define LPC_UART0_IIR_INTID_MASK 0xE
#define LPC_UART0_IIR_INTID_BIT 1
#define LPC_UART0_IIR_FIFOENABLE_MASK 0xC0
#define LPC_UART0_IIR_FIFOENABLE_BIT 6
#define LPC_UART0_IIR_ABEOINT_MASK 0x100
#define LPC_UART0_IIR_ABEOINT 0x100
#define LPC_UART0_IIR_ABEOINT_BIT 8
#define LPC_UART0_IIR_ABTOINT_MASK 0x200
#define LPC_UART0_IIR_ABTOINT 0x200
#define LPC_UART0_IIR_ABTOINT_BIT 9

#define LPC_UART0_FCR (*(volatile unsigned long *)0x4000C008)
#define LPC_UART0_FCR_OFFSET 0x8
#define LPC_UART0_FCR_FIFOEN_MASK 0x1
#define LPC_UART0_FCR_FIFOEN 0x1
#define LPC_UART0_FCR_FIFOEN_BIT 0
#define LPC_UART0_FCR_RXFIFORES_MASK 0x2
#define LPC_UART0_FCR_RXFIFORES 0x2
#define LPC_UART0_FCR_RXFIFORES_BIT 1
#define LPC_UART0_FCR_TXFIFORES_MASK 0x4
#define LPC_UART0_FCR_TXFIFORES 0x4
#define LPC_UART0_FCR_TXFIFORES_BIT 2
#define LPC_UART0_FCR_DMAMODE_MASK 0x8
#define LPC_UART0_FCR_DMAMODE 0x8
#define LPC_UART0_FCR_DMAMODE_BIT 3
#define LPC_UART0_FCR_RXTRIGLVL_MASK 0xC0
#define LPC_UART0_FCR_RXTRIGLVL_BIT 6

#define LPC_UART0_LCR (*(volatile unsigned long *)0x4000C00C)
#define LPC_UART0_LCR_OFFSET 0xC
#define LPC_UART0_LCR_WLS_MASK 0x3
#define LPC_UART0_LCR_WLS_BIT 0
#define LPC_UART0_LCR_SBS_MASK 0x4
#define LPC_UART0_LCR_SBS 0x4
#define LPC_UART0_LCR_SBS_BIT 2
#define LPC_UART0_LCR_PE_MASK 0x8
#define LPC_UART0_LCR_PE 0x8
#define LPC_UART0_LCR_PE_BIT 3
#define LPC_UART0_LCR_PS_MASK 0x30
#define LPC_UART0_LCR_PS_BIT 4
#define LPC_UART0_LCR_BC_MASK 0x40
#define LPC_UART0_LCR_BC 0x40
#define LPC_UART0_LCR_BC_BIT 6
#define LPC_UART0_LCR_DLAB_MASK 0x80
#define LPC_UART0_LCR_DLAB 0x80
#define LPC_UART0_LCR_DLAB_BIT 7

#define LPC_UART0_LSR (*(volatile unsigned long *)0x4000C014)
#define LPC_UART0_LSR_OFFSET 0x14
#define LPC_UART0_LSR_RDR_MASK 0x1
#define LPC_UART0_LSR_RDR 0x1
#define LPC_UART0_LSR_RDR_BIT 0
#define LPC_UART0_LSR_OE_MASK 0x2
#define LPC_UART0_LSR_OE 0x2
#define LPC_UART0_LSR_OE_BIT 1
#define LPC_UART0_LSR_PE_MASK 0x4
#define LPC_UART0_LSR_PE 0x4
#define LPC_UART0_LSR_PE_BIT 2
#define LPC_UART0_LSR_FE_MASK 0x8
#define LPC_UART0_LSR_FE 0x8
#define LPC_UART0_LSR_FE_BIT 3
#define LPC_UART0_LSR_BI_MASK 0x10
#define LPC_UART0_LSR_BI 0x10
#define LPC_UART0_LSR_BI_BIT 4
#define LPC_UART0_LSR_THRE_MASK 0x20
#define LPC_UART0_LSR_THRE 0x20
#define LPC_UART0_LSR_THRE_BIT 5
#define LPC_UART0_LSR_TEMT_MASK 0x40
#define LPC_UART0_LSR_TEMT 0x40
#define LPC_UART0_LSR_TEMT_BIT 6
#define LPC_UART0_LSR_RXFE_MASK 0x80
#define LPC_UART0_LSR_RXFE 0x80
#define LPC_UART0_LSR_RXFE_BIT 7

#define LPC_UART0_SCR (*(volatile unsigned long *)0x4000C01C)
#define LPC_UART0_SCR_OFFSET 0x1C
#define LPC_UART0_SCR_PAD_MASK 0xFF
#define LPC_UART0_SCR_PAD_BIT 0

#define LPC_UART0_ACR (*(volatile unsigned long *)0x4000C020)
#define LPC_UART0_ACR_OFFSET 0x20
#define LPC_UART0_ACR_START_MASK 0x1
#define LPC_UART0_ACR_START 0x1
#define LPC_UART0_ACR_START_BIT 0
#define LPC_UART0_ACR_MODE_MASK 0x2
#define LPC_UART0_ACR_MODE 0x2
#define LPC_UART0_ACR_MODE_BIT 1
#define LPC_UART0_ACR_AUTORESTART_MASK 0x4
#define LPC_UART0_ACR_AUTORESTART 0x4
#define LPC_UART0_ACR_AUTORESTART_BIT 2
#define LPC_UART0_ACR_ABEOINTCLR_MASK 0x100
#define LPC_UART0_ACR_ABEOINTCLR 0x100
#define LPC_UART0_ACR_ABEOINTCLR_BIT 8
#define LPC_UART0_ACR_ABTOINTCLR_MASK 0x200
#define LPC_UART0_ACR_ABTOINTCLR 0x200
#define LPC_UART0_ACR_ABTOINTCLR_BIT 9

#define LPC_UART0_FDR (*(volatile unsigned long *)0x4000C028)
#define LPC_UART0_FDR_OFFSET 0x28
#define LPC_UART0_FDR_DIVADDVAL_MASK 0xF
#define LPC_UART0_FDR_DIVADDVAL_BIT 0
#define LPC_UART0_FDR_MULVAL_MASK 0xF0
#define LPC_UART0_FDR_MULVAL_BIT 4

#define LPC_UART0_TER (*(volatile unsigned long *)0x4000C030)
#define LPC_UART0_TER_OFFSET 0x30
#define LPC_UART0_TER_TXEN_MASK 0x80
#define LPC_UART0_TER_TXEN 0x80
#define LPC_UART0_TER_TXEN_BIT 7

#define LPC_UART0_RS485CTRL (*(volatile unsigned long *)0x4000C04C)
#define LPC_UART0_RS485CTRL_OFFSET 0x4C
#define LPC_UART0_RS485CTRL_NMMEN_MASK 0x1
#define LPC_UART0_RS485CTRL_NMMEN 0x1
#define LPC_UART0_RS485CTRL_NMMEN_BIT 0
#define LPC_UART0_RS485CTRL_RXDIS_MASK 0x2
#define LPC_UART0_RS485CTRL_RXDIS 0x2
#define LPC_UART0_RS485CTRL_RXDIS_BIT 1
#define LPC_UART0_RS485CTRL_AADEN_MASK 0x4
#define LPC_UART0_RS485CTRL_AADEN 0x4
#define LPC_UART0_RS485CTRL_AADEN_BIT 2
#define LPC_UART0_RS485CTRL_DCTRL_MASK 0x10
#define LPC_UART0_RS485CTRL_DCTRL 0x10
#define LPC_UART0_RS485CTRL_DCTRL_BIT 4
#define LPC_UART0_RS485CTRL_OINV_MASK 0x20
#define LPC_UART0_RS485CTRL_OINV 0x20
#define LPC_UART0_RS485CTRL_OINV_BIT 5

#define LPC_UART0_RS485ADRMATCH (*(volatile unsigned long *)0x4000C050)
#define LPC_UART0_RS485ADRMATCH_OFFSET 0x50
#define LPC_UART0_RS485ADRMATCH_ADRMATCH_MASK 0xFF
#define LPC_UART0_RS485ADRMATCH_ADRMATCH_BIT 0

#define LPC_UART0_RS485DLY (*(volatile unsigned long *)0x4000C054)
#define LPC_UART0_RS485DLY_OFFSET 0x54
#define LPC_UART0_RS485DLY_DLY_MASK 0xFF
#define LPC_UART0_RS485DLY_DLY_BIT 0

#ifndef LPC_UART1_BASE_ADDRESS
#define LPC_UART1_BASE_ADDRESS 0x40010000
#endif

#define LPC_UART1_RBR (*(volatile unsigned long *)0x40010000)
#define LPC_UART1_RBR_OFFSET 0x0
#define LPC_UART1_RBR_RBR_MASK 0xFF
#define LPC_UART1_RBR_RBR_BIT 0

#define LPC_UART1_THR (*(volatile unsigned long *)0x40010000)
#define LPC_UART1_THR_OFFSET 0x0
#define LPC_UART1_THR_THR_MASK 0xFF
#define LPC_UART1_THR_THR_BIT 0

#define LPC_UART1_DLL (*(volatile unsigned long *)0x40010000)
#define LPC_UART1_DLL_OFFSET 0x0
#define LPC_UART1_DLL_DLLSB_MASK 0xFF
#define LPC_UART1_DLL_DLLSB_BIT 0

#define LPC_UART1_DLM (*(volatile unsigned long *)0x40010004)
#define LPC_UART1_DLM_OFFSET 0x4
#define LPC_UART1_DLM_DLMSB_MASK 0xFF
#define LPC_UART1_DLM_DLMSB_BIT 0

#define LPC_UART1_IER (*(volatile unsigned long *)0x40010004)
#define LPC_UART1_IER_OFFSET 0x4
#define LPC_UART1_IER_RBRIE_MASK 0x1
#define LPC_UART1_IER_RBRIE 0x1
#define LPC_UART1_IER_RBRIE_BIT 0
#define LPC_UART1_IER_THREIE_MASK 0x2
#define LPC_UART1_IER_THREIE 0x2
#define LPC_UART1_IER_THREIE_BIT 1
#define LPC_UART1_IER_RXIE_MASK 0x4
#define LPC_UART1_IER_RXIE 0x4
#define LPC_UART1_IER_RXIE_BIT 2
#define LPC_UART1_IER_MSIE_MASK 0x8
#define LPC_UART1_IER_MSIE 0x8
#define LPC_UART1_IER_MSIE_BIT 3
#define LPC_UART1_IER_CTSIE_MASK 0x80
#define LPC_UART1_IER_CTSIE 0x80
#define LPC_UART1_IER_CTSIE_BIT 7
#define LPC_UART1_IER_ABEOIE_MASK 0x100
#define LPC_UART1_IER_ABEOIE 0x100
#define LPC_UART1_IER_ABEOIE_BIT 8
#define LPC_UART1_IER_ABTOIE_MASK 0x200
#define LPC_UART1_IER_ABTOIE 0x200
#define LPC_UART1_IER_ABTOIE_BIT 9

#define LPC_UART1_IIR (*(volatile unsigned long *)0x40010008)
#define LPC_UART1_IIR_OFFSET 0x8
#define LPC_UART1_IIR_INTSTATUS_MASK 0x1
#define LPC_UART1_IIR_INTSTATUS 0x1
#define LPC_UART1_IIR_INTSTATUS_BIT 0
#define LPC_UART1_IIR_INTID_MASK 0xE
#define LPC_UART1_IIR_INTID_BIT 1
#define LPC_UART1_IIR_FIFOENABLE_MASK 0xC0
#define LPC_UART1_IIR_FIFOENABLE_BIT 6
#define LPC_UART1_IIR_ABEOINT_MASK 0x100
#define LPC_UART1_IIR_ABEOINT 0x100
#define LPC_UART1_IIR_ABEOINT_BIT 8
#define LPC_UART1_IIR_ABTOINT_MASK 0x200
#define LPC_UART1_IIR_ABTOINT 0x200
#define LPC_UART1_IIR_ABTOINT_BIT 9

#define LPC_UART1_FCR (*(volatile unsigned long *)0x40010008)
#define LPC_UART1_FCR_OFFSET 0x8
#define LPC_UART1_FCR_FIFOEN_MASK 0x1
#define LPC_UART1_FCR_FIFOEN 0x1
#define LPC_UART1_FCR_FIFOEN_BIT 0
#define LPC_UART1_FCR_RXFIFORES_MASK 0x2
#define LPC_UART1_FCR_RXFIFORES 0x2
#define LPC_UART1_FCR_RXFIFORES_BIT 1
#define LPC_UART1_FCR_TXFIFORES_MASK 0x4
#define LPC_UART1_FCR_TXFIFORES 0x4
#define LPC_UART1_FCR_TXFIFORES_BIT 2
#define LPC_UART1_FCR_DMAMODE_MASK 0x8
#define LPC_UART1_FCR_DMAMODE 0x8
#define LPC_UART1_FCR_DMAMODE_BIT 3
#define LPC_UART1_FCR_RXTRIGLVL_MASK 0xC0
#define LPC_UART1_FCR_RXTRIGLVL_BIT 6

#define LPC_UART1_LCR (*(volatile unsigned long *)0x4001000C)
#define LPC_UART1_LCR_OFFSET 0xC
#define LPC_UART1_LCR_WLS_MASK 0x3
#define LPC_UART1_LCR_WLS_BIT 0
#define LPC_UART1_LCR_SBS_MASK 0x4
#define LPC_UART1_LCR_SBS 0x4
#define LPC_UART1_LCR_SBS_BIT 2
#define LPC_UART1_LCR_PE_MASK 0x8
#define LPC_UART1_LCR_PE 0x8
#define LPC_UART1_LCR_PE_BIT 3
#define LPC_UART1_LCR_PS_MASK 0x30
#define LPC_UART1_LCR_PS_BIT 4
#define LPC_UART1_LCR_BC_MASK 0x40
#define LPC_UART1_LCR_BC 0x40
#define LPC_UART1_LCR_BC_BIT 6
#define LPC_UART1_LCR_DLAB_MASK 0x80
#define LPC_UART1_LCR_DLAB 0x80
#define LPC_UART1_LCR_DLAB_BIT 7

#define LPC_UART1_MCR (*(volatile unsigned long *)0x40010010)
#define LPC_UART1_MCR_OFFSET 0x10
#define LPC_UART1_MCR_DTRCTRL_MASK 0x1
#define LPC_UART1_MCR_DTRCTRL 0x1
#define LPC_UART1_MCR_DTRCTRL_BIT 0
#define LPC_UART1_MCR_RTSCTRL_MASK 0x2
#define LPC_UART1_MCR_RTSCTRL 0x2
#define LPC_UART1_MCR_RTSCTRL_BIT 1
#define LPC_UART1_MCR_LMS_MASK 0x10
#define LPC_UART1_MCR_LMS 0x10
#define LPC_UART1_MCR_LMS_BIT 4
#define LPC_UART1_MCR_RTSEN_MASK 0x40
#define LPC_UART1_MCR_RTSEN 0x40
#define LPC_UART1_MCR_RTSEN_BIT 6
#define LPC_UART1_MCR_CTSEN_MASK 0x80
#define LPC_UART1_MCR_CTSEN 0x80
#define LPC_UART1_MCR_CTSEN_BIT 7

#define LPC_UART1_LSR (*(volatile unsigned long *)0x40010014)
#define LPC_UART1_LSR_OFFSET 0x14
#define LPC_UART1_LSR_RDR_MASK 0x1
#define LPC_UART1_LSR_RDR 0x1
#define LPC_UART1_LSR_RDR_BIT 0
#define LPC_UART1_LSR_OE_MASK 0x2
#define LPC_UART1_LSR_OE 0x2
#define LPC_UART1_LSR_OE_BIT 1
#define LPC_UART1_LSR_PE_MASK 0x4
#define LPC_UART1_LSR_PE 0x4
#define LPC_UART1_LSR_PE_BIT 2
#define LPC_UART1_LSR_FE_MASK 0x8
#define LPC_UART1_LSR_FE 0x8
#define LPC_UART1_LSR_FE_BIT 3
#define LPC_UART1_LSR_BI_MASK 0x10
#define LPC_UART1_LSR_BI 0x10
#define LPC_UART1_LSR_BI_BIT 4
#define LPC_UART1_LSR_THRE_MASK 0x20
#define LPC_UART1_LSR_THRE 0x20
#define LPC_UART1_LSR_THRE_BIT 5
#define LPC_UART1_LSR_TEMT_MASK 0x40
#define LPC_UART1_LSR_TEMT 0x40
#define LPC_UART1_LSR_TEMT_BIT 6
#define LPC_UART1_LSR_RXFE_MASK 0x80
#define LPC_UART1_LSR_RXFE 0x80
#define LPC_UART1_LSR_RXFE_BIT 7

#define LPC_UART1_MSR (*(volatile unsigned long *)0x40010018)
#define LPC_UART1_MSR_OFFSET 0x18
#define LPC_UART1_MSR_DCTS_MASK 0x1
#define LPC_UART1_MSR_DCTS 0x1
#define LPC_UART1_MSR_DCTS_BIT 0
#define LPC_UART1_MSR_DDSR_MASK 0x2
#define LPC_UART1_MSR_DDSR 0x2
#define LPC_UART1_MSR_DDSR_BIT 1
#define LPC_UART1_MSR_TERI_MASK 0x4
#define LPC_UART1_MSR_TERI 0x4
#define LPC_UART1_MSR_TERI_BIT 2
#define LPC_UART1_MSR_DDCD_MASK 0x8
#define LPC_UART1_MSR_DDCD 0x8
#define LPC_UART1_MSR_DDCD_BIT 3
#define LPC_UART1_MSR_CTS_MASK 0x10
#define LPC_UART1_MSR_CTS 0x10
#define LPC_UART1_MSR_CTS_BIT 4
#define LPC_UART1_MSR_DSR_MASK 0x20
#define LPC_UART1_MSR_DSR 0x20
#define LPC_UART1_MSR_DSR_BIT 5
#define LPC_UART1_MSR_RI_MASK 0x40
#define LPC_UART1_MSR_RI 0x40
#define LPC_UART1_MSR_RI_BIT 6
#define LPC_UART1_MSR_DCD_MASK 0x80
#define LPC_UART1_MSR_DCD 0x80
#define LPC_UART1_MSR_DCD_BIT 7

#define LPC_UART1_SCR (*(volatile unsigned long *)0x4001001C)
#define LPC_UART1_SCR_OFFSET 0x1C
#define LPC_UART1_SCR_Pad_MASK 0xFF
#define LPC_UART1_SCR_Pad_BIT 0

#define LPC_UART1_ACR (*(volatile unsigned long *)0x40010020)
#define LPC_UART1_ACR_OFFSET 0x20
#define LPC_UART1_ACR_START_MASK 0x1
#define LPC_UART1_ACR_START 0x1
#define LPC_UART1_ACR_START_BIT 0
#define LPC_UART1_ACR_MODE_MASK 0x2
#define LPC_UART1_ACR_MODE 0x2
#define LPC_UART1_ACR_MODE_BIT 1
#define LPC_UART1_ACR_AUTORESTART_MASK 0x4
#define LPC_UART1_ACR_AUTORESTART 0x4
#define LPC_UART1_ACR_AUTORESTART_BIT 2
#define LPC_UART1_ACR_ABEOINTCLR_MASK 0x100
#define LPC_UART1_ACR_ABEOINTCLR 0x100
#define LPC_UART1_ACR_ABEOINTCLR_BIT 8
#define LPC_UART1_ACR_ABTOINTCLR_MASK 0x200
#define LPC_UART1_ACR_ABTOINTCLR 0x200
#define LPC_UART1_ACR_ABTOINTCLR_BIT 9

#define LPC_UART1_FDR (*(volatile unsigned long *)0x40010028)
#define LPC_UART1_FDR_OFFSET 0x28
#define LPC_UART1_FDR_DIVADDVAL_MASK 0xF
#define LPC_UART1_FDR_DIVADDVAL_BIT 0
#define LPC_UART1_FDR_MULVAL_MASK 0xF0
#define LPC_UART1_FDR_MULVAL_BIT 4

#define LPC_UART1_TER (*(volatile unsigned long *)0x40010030)
#define LPC_UART1_TER_OFFSET 0x30
#define LPC_UART1_TER_TXEN_MASK 0x80
#define LPC_UART1_TER_TXEN 0x80
#define LPC_UART1_TER_TXEN_BIT 7

#define LPC_UART1_RS485CTRL (*(volatile unsigned long *)0x4001004C)
#define LPC_UART1_RS485CTRL_OFFSET 0x4C
#define LPC_UART1_RS485CTRL_NMMEN_MASK 0x1
#define LPC_UART1_RS485CTRL_NMMEN 0x1
#define LPC_UART1_RS485CTRL_NMMEN_BIT 0
#define LPC_UART1_RS485CTRL_RXDIS_MASK 0x2
#define LPC_UART1_RS485CTRL_RXDIS 0x2
#define LPC_UART1_RS485CTRL_RXDIS_BIT 1
#define LPC_UART1_RS485CTRL_AADEN_MASK 0x4
#define LPC_UART1_RS485CTRL_AADEN 0x4
#define LPC_UART1_RS485CTRL_AADEN_BIT 2
#define LPC_UART1_RS485CTRL_SEL_MASK 0x8
#define LPC_UART1_RS485CTRL_SEL 0x8
#define LPC_UART1_RS485CTRL_SEL_BIT 3
#define LPC_UART1_RS485CTRL_DCTRL_MASK 0x10
#define LPC_UART1_RS485CTRL_DCTRL 0x10
#define LPC_UART1_RS485CTRL_DCTRL_BIT 4
#define LPC_UART1_RS485CTRL_OINV_MASK 0x20
#define LPC_UART1_RS485CTRL_OINV 0x20
#define LPC_UART1_RS485CTRL_OINV_BIT 5

#define LPC_UART1_RS485ADRMATCH (*(volatile unsigned long *)0x40010050)
#define LPC_UART1_RS485ADRMATCH_OFFSET 0x50
#define LPC_UART1_RS485ADRMATCH_ADRMATCH_MASK 0xFF
#define LPC_UART1_RS485ADRMATCH_ADRMATCH_BIT 0

#define LPC_UART1_RS485DLY (*(volatile unsigned long *)0x40010054)
#define LPC_UART1_RS485DLY_OFFSET 0x54
#define LPC_UART1_RS485DLY_DLY_MASK 0xFF
#define LPC_UART1_RS485DLY_DLY_BIT 0

#ifndef LPC_PWM0_BASE_ADDRESS
#define LPC_PWM0_BASE_ADDRESS 0x40014000
#endif

#define LPC_PWM0_IR (*(volatile unsigned long *)0x40014000)
#define LPC_PWM0_IR_OFFSET 0x0
#define LPC_PWM0_IR_PWMMR0INT_MASK 0x1
#define LPC_PWM0_IR_PWMMR0INT 0x1
#define LPC_PWM0_IR_PWMMR0INT_BIT 0
#define LPC_PWM0_IR_PWMMR1INT_MASK 0x2
#define LPC_PWM0_IR_PWMMR1INT 0x2
#define LPC_PWM0_IR_PWMMR1INT_BIT 1
#define LPC_PWM0_IR_PWMMR2INT_MASK 0x4
#define LPC_PWM0_IR_PWMMR2INT 0x4
#define LPC_PWM0_IR_PWMMR2INT_BIT 2
#define LPC_PWM0_IR_PWMMR3INT_MASK 0x8
#define LPC_PWM0_IR_PWMMR3INT 0x8
#define LPC_PWM0_IR_PWMMR3INT_BIT 3
#define LPC_PWM0_IR_PWMCAP0INT_MASK 0x10
#define LPC_PWM0_IR_PWMCAP0INT 0x10
#define LPC_PWM0_IR_PWMCAP0INT_BIT 4
#define LPC_PWM0_IR_PWMCAP1INT_MASK 0x20
#define LPC_PWM0_IR_PWMCAP1INT 0x20
#define LPC_PWM0_IR_PWMCAP1INT_BIT 5
#define LPC_PWM0_IR_PWMMR4INT_MASK 0x100
#define LPC_PWM0_IR_PWMMR4INT 0x100
#define LPC_PWM0_IR_PWMMR4INT_BIT 8
#define LPC_PWM0_IR_PWMMR5INT_MASK 0x200
#define LPC_PWM0_IR_PWMMR5INT 0x200
#define LPC_PWM0_IR_PWMMR5INT_BIT 9
#define LPC_PWM0_IR_PWMMR6INT_MASK 0x400
#define LPC_PWM0_IR_PWMMR6INT 0x400
#define LPC_PWM0_IR_PWMMR6INT_BIT 10

#define LPC_PWM0_TCR (*(volatile unsigned long *)0x40014004)
#define LPC_PWM0_TCR_OFFSET 0x4
#define LPC_PWM0_TCR_CE_MASK 0x1
#define LPC_PWM0_TCR_CE 0x1
#define LPC_PWM0_TCR_CE_BIT 0
#define LPC_PWM0_TCR_CR_MASK 0x2
#define LPC_PWM0_TCR_CR 0x2
#define LPC_PWM0_TCR_CR_BIT 1
#define LPC_PWM0_TCR_PWMEN_MASK 0x8
#define LPC_PWM0_TCR_PWMEN 0x8
#define LPC_PWM0_TCR_PWMEN_BIT 3
#define LPC_PWM0_TCR_MDIS_MASK 0x10
#define LPC_PWM0_TCR_MDIS 0x10
#define LPC_PWM0_TCR_MDIS_BIT 4

#define LPC_PWM0_TC (*(volatile unsigned long *)0x40014008)
#define LPC_PWM0_TC_OFFSET 0x8
#define LPC_PWM0_TC_TC_MASK 0xFFFFFFFF
#define LPC_PWM0_TC_TC_BIT 0

#define LPC_PWM0_PR (*(volatile unsigned long *)0x4001400C)
#define LPC_PWM0_PR_OFFSET 0xC
#define LPC_PWM0_PR_PM_MASK 0xFFFFFFFF
#define LPC_PWM0_PR_PM_BIT 0

#define LPC_PWM0_PC (*(volatile unsigned long *)0x40014010)
#define LPC_PWM0_PC_OFFSET 0x10
#define LPC_PWM0_PC_PC_MASK 0xFFFFFFFF
#define LPC_PWM0_PC_PC_BIT 0

#define LPC_PWM0_MCR (*(volatile unsigned long *)0x40014014)
#define LPC_PWM0_MCR_OFFSET 0x14
#define LPC_PWM0_MCR_PWMMR0I_MASK 0x1
#define LPC_PWM0_MCR_PWMMR0I 0x1
#define LPC_PWM0_MCR_PWMMR0I_BIT 0
#define LPC_PWM0_MCR_PWMMR0R_MASK 0x2
#define LPC_PWM0_MCR_PWMMR0R 0x2
#define LPC_PWM0_MCR_PWMMR0R_BIT 1
#define LPC_PWM0_MCR_PWMMR0S_MASK 0x4
#define LPC_PWM0_MCR_PWMMR0S 0x4
#define LPC_PWM0_MCR_PWMMR0S_BIT 2
#define LPC_PWM0_MCR_PWMMR1I_MASK 0x8
#define LPC_PWM0_MCR_PWMMR1I 0x8
#define LPC_PWM0_MCR_PWMMR1I_BIT 3
#define LPC_PWM0_MCR_PWMMR1R_MASK 0x10
#define LPC_PWM0_MCR_PWMMR1R 0x10
#define LPC_PWM0_MCR_PWMMR1R_BIT 4
#define LPC_PWM0_MCR_PWMMR1S_MASK 0x20
#define LPC_PWM0_MCR_PWMMR1S 0x20
#define LPC_PWM0_MCR_PWMMR1S_BIT 5
#define LPC_PWM0_MCR_PWMMR2I_MASK 0x40
#define LPC_PWM0_MCR_PWMMR2I 0x40
#define LPC_PWM0_MCR_PWMMR2I_BIT 6
#define LPC_PWM0_MCR_PWMMR2R_MASK 0x80
#define LPC_PWM0_MCR_PWMMR2R 0x80
#define LPC_PWM0_MCR_PWMMR2R_BIT 7
#define LPC_PWM0_MCR_PWMMR2S_MASK 0x100
#define LPC_PWM0_MCR_PWMMR2S 0x100
#define LPC_PWM0_MCR_PWMMR2S_BIT 8
#define LPC_PWM0_MCR_PWMMR3I_MASK 0x200
#define LPC_PWM0_MCR_PWMMR3I 0x200
#define LPC_PWM0_MCR_PWMMR3I_BIT 9
#define LPC_PWM0_MCR_PWMMR3R_MASK 0x400
#define LPC_PWM0_MCR_PWMMR3R 0x400
#define LPC_PWM0_MCR_PWMMR3R_BIT 10
#define LPC_PWM0_MCR_PWMMR3S_MASK 0x800
#define LPC_PWM0_MCR_PWMMR3S 0x800
#define LPC_PWM0_MCR_PWMMR3S_BIT 11
#define LPC_PWM0_MCR_PWMMR4I_MASK 0x1000
#define LPC_PWM0_MCR_PWMMR4I 0x1000
#define LPC_PWM0_MCR_PWMMR4I_BIT 12
#define LPC_PWM0_MCR_PWMMR4R_MASK 0x2000
#define LPC_PWM0_MCR_PWMMR4R 0x2000
#define LPC_PWM0_MCR_PWMMR4R_BIT 13
#define LPC_PWM0_MCR_PWMMR4S_MASK 0x4000
#define LPC_PWM0_MCR_PWMMR4S 0x4000
#define LPC_PWM0_MCR_PWMMR4S_BIT 14
#define LPC_PWM0_MCR_PWMMR5I_MASK 0x8000
#define LPC_PWM0_MCR_PWMMR5I 0x8000
#define LPC_PWM0_MCR_PWMMR5I_BIT 15
#define LPC_PWM0_MCR_PWMMR5R_MASK 0x10000
#define LPC_PWM0_MCR_PWMMR5R 0x10000
#define LPC_PWM0_MCR_PWMMR5R_BIT 16
#define LPC_PWM0_MCR_PWMMR5S_MASK 0x20000
#define LPC_PWM0_MCR_PWMMR5S 0x20000
#define LPC_PWM0_MCR_PWMMR5S_BIT 17
#define LPC_PWM0_MCR_PWMMR6I_MASK 0x40000
#define LPC_PWM0_MCR_PWMMR6I 0x40000
#define LPC_PWM0_MCR_PWMMR6I_BIT 18
#define LPC_PWM0_MCR_PWMMR6R_MASK 0x80000
#define LPC_PWM0_MCR_PWMMR6R 0x80000
#define LPC_PWM0_MCR_PWMMR6R_BIT 19
#define LPC_PWM0_MCR_PWMMR6S_MASK 0x100000
#define LPC_PWM0_MCR_PWMMR6S 0x100000
#define LPC_PWM0_MCR_PWMMR6S_BIT 20

#define LPC_PWM0_MR0 (*(volatile unsigned long *)0x40014018)
#define LPC_PWM0_MR0_OFFSET 0x18
#define LPC_PWM0_MR0_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM0_MR0_MATCH_BIT 0

#define LPC_PWM0_MR1 (*(volatile unsigned long *)0x4001401C)
#define LPC_PWM0_MR1_OFFSET 0x1C
#define LPC_PWM0_MR1_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM0_MR1_MATCH_BIT 0

#define LPC_PWM0_MR2 (*(volatile unsigned long *)0x40014020)
#define LPC_PWM0_MR2_OFFSET 0x20
#define LPC_PWM0_MR2_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM0_MR2_MATCH_BIT 0

#define LPC_PWM0_MR3 (*(volatile unsigned long *)0x40014024)
#define LPC_PWM0_MR3_OFFSET 0x24
#define LPC_PWM0_MR3_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM0_MR3_MATCH_BIT 0

#define LPC_PWM0_CCR (*(volatile unsigned long *)0x40014028)
#define LPC_PWM0_CCR_OFFSET 0x28
#define LPC_PWM0_CCR_CAP0_R_MASK 0x1
#define LPC_PWM0_CCR_CAP0_R 0x1
#define LPC_PWM0_CCR_CAP0_R_BIT 0
#define LPC_PWM0_CCR_CAP0_F_MASK 0x2
#define LPC_PWM0_CCR_CAP0_F 0x2
#define LPC_PWM0_CCR_CAP0_F_BIT 1
#define LPC_PWM0_CCR_CAP0_I_MASK 0x4
#define LPC_PWM0_CCR_CAP0_I 0x4
#define LPC_PWM0_CCR_CAP0_I_BIT 2
#define LPC_PWM0_CCR_CAP1_R_MASK 0x8
#define LPC_PWM0_CCR_CAP1_R 0x8
#define LPC_PWM0_CCR_CAP1_R_BIT 3
#define LPC_PWM0_CCR_CAP1_F_MASK 0x10
#define LPC_PWM0_CCR_CAP1_F 0x10
#define LPC_PWM0_CCR_CAP1_F_BIT 4
#define LPC_PWM0_CCR_CAP1_I_MASK 0x20
#define LPC_PWM0_CCR_CAP1_I 0x20
#define LPC_PWM0_CCR_CAP1_I_BIT 5

#define LPC_PWM0_CR0 (*(volatile unsigned long *)0x4001402C)
#define LPC_PWM0_CR0_OFFSET 0x2C
#define LPC_PWM0_CR0_PWMSEL2_MASK 0x4
#define LPC_PWM0_CR0_PWMSEL2 0x4
#define LPC_PWM0_CR0_PWMSEL2_BIT 2
#define LPC_PWM0_CR0_PWMSEL3_MASK 0x8
#define LPC_PWM0_CR0_PWMSEL3 0x8
#define LPC_PWM0_CR0_PWMSEL3_BIT 3
#define LPC_PWM0_CR0_PWMSEL4_MASK 0x10
#define LPC_PWM0_CR0_PWMSEL4 0x10
#define LPC_PWM0_CR0_PWMSEL4_BIT 4
#define LPC_PWM0_CR0_PWMSEL5_MASK 0x20
#define LPC_PWM0_CR0_PWMSEL5 0x20
#define LPC_PWM0_CR0_PWMSEL5_BIT 5
#define LPC_PWM0_CR0_PWMSEL6_MASK 0x40
#define LPC_PWM0_CR0_PWMSEL6 0x40
#define LPC_PWM0_CR0_PWMSEL6_BIT 6
#define LPC_PWM0_CR0_PWMENA1_MASK 0x200
#define LPC_PWM0_CR0_PWMENA1 0x200
#define LPC_PWM0_CR0_PWMENA1_BIT 9
#define LPC_PWM0_CR0_PWMENA2_MASK 0x400
#define LPC_PWM0_CR0_PWMENA2 0x400
#define LPC_PWM0_CR0_PWMENA2_BIT 10
#define LPC_PWM0_CR0_PWMENA3_MASK 0x800
#define LPC_PWM0_CR0_PWMENA3 0x800
#define LPC_PWM0_CR0_PWMENA3_BIT 11
#define LPC_PWM0_CR0_PWMENA4_MASK 0x1000
#define LPC_PWM0_CR0_PWMENA4 0x1000
#define LPC_PWM0_CR0_PWMENA4_BIT 12
#define LPC_PWM0_CR0_PWMENA5_MASK 0x2000
#define LPC_PWM0_CR0_PWMENA5 0x2000
#define LPC_PWM0_CR0_PWMENA5_BIT 13
#define LPC_PWM0_CR0_PWMENA6_MASK 0x4000
#define LPC_PWM0_CR0_PWMENA6 0x4000
#define LPC_PWM0_CR0_PWMENA6_BIT 14

#define LPC_PWM0_CR1 (*(volatile unsigned long *)0x40014030)
#define LPC_PWM0_CR1_OFFSET 0x30
#define LPC_PWM0_CR1_PWMSEL2_MASK 0x4
#define LPC_PWM0_CR1_PWMSEL2 0x4
#define LPC_PWM0_CR1_PWMSEL2_BIT 2
#define LPC_PWM0_CR1_PWMSEL3_MASK 0x8
#define LPC_PWM0_CR1_PWMSEL3 0x8
#define LPC_PWM0_CR1_PWMSEL3_BIT 3
#define LPC_PWM0_CR1_PWMSEL4_MASK 0x10
#define LPC_PWM0_CR1_PWMSEL4 0x10
#define LPC_PWM0_CR1_PWMSEL4_BIT 4
#define LPC_PWM0_CR1_PWMSEL5_MASK 0x20
#define LPC_PWM0_CR1_PWMSEL5 0x20
#define LPC_PWM0_CR1_PWMSEL5_BIT 5
#define LPC_PWM0_CR1_PWMSEL6_MASK 0x40
#define LPC_PWM0_CR1_PWMSEL6 0x40
#define LPC_PWM0_CR1_PWMSEL6_BIT 6
#define LPC_PWM0_CR1_PWMENA1_MASK 0x200
#define LPC_PWM0_CR1_PWMENA1 0x200
#define LPC_PWM0_CR1_PWMENA1_BIT 9
#define LPC_PWM0_CR1_PWMENA2_MASK 0x400
#define LPC_PWM0_CR1_PWMENA2 0x400
#define LPC_PWM0_CR1_PWMENA2_BIT 10
#define LPC_PWM0_CR1_PWMENA3_MASK 0x800
#define LPC_PWM0_CR1_PWMENA3 0x800
#define LPC_PWM0_CR1_PWMENA3_BIT 11
#define LPC_PWM0_CR1_PWMENA4_MASK 0x1000
#define LPC_PWM0_CR1_PWMENA4 0x1000
#define LPC_PWM0_CR1_PWMENA4_BIT 12
#define LPC_PWM0_CR1_PWMENA5_MASK 0x2000
#define LPC_PWM0_CR1_PWMENA5 0x2000
#define LPC_PWM0_CR1_PWMENA5_BIT 13
#define LPC_PWM0_CR1_PWMENA6_MASK 0x4000
#define LPC_PWM0_CR1_PWMENA6 0x4000
#define LPC_PWM0_CR1_PWMENA6_BIT 14

#define LPC_PWM0_MR4 (*(volatile unsigned long *)0x40014040)
#define LPC_PWM0_MR4_OFFSET 0x40
#define LPC_PWM0_MR4_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM0_MR4_MATCH_BIT 0

#define LPC_PWM0_MR5 (*(volatile unsigned long *)0x40014044)
#define LPC_PWM0_MR5_OFFSET 0x44
#define LPC_PWM0_MR5_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM0_MR5_MATCH_BIT 0

#define LPC_PWM0_MR6 (*(volatile unsigned long *)0x40014048)
#define LPC_PWM0_MR6_OFFSET 0x48
#define LPC_PWM0_MR6_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM0_MR6_MATCH_BIT 0

#define LPC_PWM0_PCR (*(volatile unsigned long *)0x4001404C)
#define LPC_PWM0_PCR_OFFSET 0x4C
#define LPC_PWM0_PCR_PWMSEL2_MASK 0x4
#define LPC_PWM0_PCR_PWMSEL2 0x4
#define LPC_PWM0_PCR_PWMSEL2_BIT 2
#define LPC_PWM0_PCR_PWMSEL3_MASK 0x8
#define LPC_PWM0_PCR_PWMSEL3 0x8
#define LPC_PWM0_PCR_PWMSEL3_BIT 3
#define LPC_PWM0_PCR_PWMSEL4_MASK 0x10
#define LPC_PWM0_PCR_PWMSEL4 0x10
#define LPC_PWM0_PCR_PWMSEL4_BIT 4
#define LPC_PWM0_PCR_PWMSEL5_MASK 0x20
#define LPC_PWM0_PCR_PWMSEL5 0x20
#define LPC_PWM0_PCR_PWMSEL5_BIT 5
#define LPC_PWM0_PCR_PWMSEL6_MASK 0x40
#define LPC_PWM0_PCR_PWMSEL6 0x40
#define LPC_PWM0_PCR_PWMSEL6_BIT 6
#define LPC_PWM0_PCR_PWMENA1_MASK 0x200
#define LPC_PWM0_PCR_PWMENA1 0x200
#define LPC_PWM0_PCR_PWMENA1_BIT 9
#define LPC_PWM0_PCR_PWMENA2_MASK 0x400
#define LPC_PWM0_PCR_PWMENA2 0x400
#define LPC_PWM0_PCR_PWMENA2_BIT 10
#define LPC_PWM0_PCR_PWMENA3_MASK 0x800
#define LPC_PWM0_PCR_PWMENA3 0x800
#define LPC_PWM0_PCR_PWMENA3_BIT 11
#define LPC_PWM0_PCR_PWMENA4_MASK 0x1000
#define LPC_PWM0_PCR_PWMENA4 0x1000
#define LPC_PWM0_PCR_PWMENA4_BIT 12
#define LPC_PWM0_PCR_PWMENA5_MASK 0x2000
#define LPC_PWM0_PCR_PWMENA5 0x2000
#define LPC_PWM0_PCR_PWMENA5_BIT 13
#define LPC_PWM0_PCR_PWMENA6_MASK 0x4000
#define LPC_PWM0_PCR_PWMENA6 0x4000
#define LPC_PWM0_PCR_PWMENA6_BIT 14

#define LPC_PWM0_LER (*(volatile unsigned long *)0x40014050)
#define LPC_PWM0_LER_OFFSET 0x50
#define LPC_PWM0_LER_MAT0LATCHEN_MASK 0x1
#define LPC_PWM0_LER_MAT0LATCHEN 0x1
#define LPC_PWM0_LER_MAT0LATCHEN_BIT 0
#define LPC_PWM0_LER_MAT1LATCHEN_MASK 0x2
#define LPC_PWM0_LER_MAT1LATCHEN 0x2
#define LPC_PWM0_LER_MAT1LATCHEN_BIT 1
#define LPC_PWM0_LER_MAT2LATCHEN_MASK 0x4
#define LPC_PWM0_LER_MAT2LATCHEN 0x4
#define LPC_PWM0_LER_MAT2LATCHEN_BIT 2
#define LPC_PWM0_LER_MAT3LATCHEN_MASK 0x8
#define LPC_PWM0_LER_MAT3LATCHEN 0x8
#define LPC_PWM0_LER_MAT3LATCHEN_BIT 3
#define LPC_PWM0_LER_MAT4LATCHEN_MASK 0x10
#define LPC_PWM0_LER_MAT4LATCHEN 0x10
#define LPC_PWM0_LER_MAT4LATCHEN_BIT 4
#define LPC_PWM0_LER_MAT5LATCHEN_MASK 0x20
#define LPC_PWM0_LER_MAT5LATCHEN 0x20
#define LPC_PWM0_LER_MAT5LATCHEN_BIT 5
#define LPC_PWM0_LER_MAT6LATCHEN_MASK 0x40
#define LPC_PWM0_LER_MAT6LATCHEN 0x40
#define LPC_PWM0_LER_MAT6LATCHEN_BIT 6

#define LPC_PWM0_CTCR (*(volatile unsigned long *)0x40014070)
#define LPC_PWM0_CTCR_OFFSET 0x70
#define LPC_PWM0_CTCR_MOD_MASK 0x3
#define LPC_PWM0_CTCR_MOD_BIT 0
#define LPC_PWM0_CTCR_CIS_MASK 0xC
#define LPC_PWM0_CTCR_CIS_BIT 2

#ifndef LPC_PWM1_BASE_ADDRESS
#define LPC_PWM1_BASE_ADDRESS 0x40018000
#endif

#define LPC_PWM1_IR (*(volatile unsigned long *)0x40018000)
#define LPC_PWM1_IR_OFFSET 0x0
#define LPC_PWM1_IR_PWMMR0INT_MASK 0x1
#define LPC_PWM1_IR_PWMMR0INT 0x1
#define LPC_PWM1_IR_PWMMR0INT_BIT 0
#define LPC_PWM1_IR_PWMMR1INT_MASK 0x2
#define LPC_PWM1_IR_PWMMR1INT 0x2
#define LPC_PWM1_IR_PWMMR1INT_BIT 1
#define LPC_PWM1_IR_PWMMR2INT_MASK 0x4
#define LPC_PWM1_IR_PWMMR2INT 0x4
#define LPC_PWM1_IR_PWMMR2INT_BIT 2
#define LPC_PWM1_IR_PWMMR3INT_MASK 0x8
#define LPC_PWM1_IR_PWMMR3INT 0x8
#define LPC_PWM1_IR_PWMMR3INT_BIT 3
#define LPC_PWM1_IR_PWMCAP0INT_MASK 0x10
#define LPC_PWM1_IR_PWMCAP0INT 0x10
#define LPC_PWM1_IR_PWMCAP0INT_BIT 4
#define LPC_PWM1_IR_PWMCAP1INT_MASK 0x20
#define LPC_PWM1_IR_PWMCAP1INT 0x20
#define LPC_PWM1_IR_PWMCAP1INT_BIT 5
#define LPC_PWM1_IR_PWMMR4INT_MASK 0x100
#define LPC_PWM1_IR_PWMMR4INT 0x100
#define LPC_PWM1_IR_PWMMR4INT_BIT 8
#define LPC_PWM1_IR_PWMMR5INT_MASK 0x200
#define LPC_PWM1_IR_PWMMR5INT 0x200
#define LPC_PWM1_IR_PWMMR5INT_BIT 9
#define LPC_PWM1_IR_PWMMR6INT_MASK 0x400
#define LPC_PWM1_IR_PWMMR6INT 0x400
#define LPC_PWM1_IR_PWMMR6INT_BIT 10

#define LPC_PWM1_TCR (*(volatile unsigned long *)0x40018004)
#define LPC_PWM1_TCR_OFFSET 0x4
#define LPC_PWM1_TCR_CE_MASK 0x1
#define LPC_PWM1_TCR_CE 0x1
#define LPC_PWM1_TCR_CE_BIT 0
#define LPC_PWM1_TCR_CR_MASK 0x2
#define LPC_PWM1_TCR_CR 0x2
#define LPC_PWM1_TCR_CR_BIT 1
#define LPC_PWM1_TCR_PWMEN_MASK 0x8
#define LPC_PWM1_TCR_PWMEN 0x8
#define LPC_PWM1_TCR_PWMEN_BIT 3
#define LPC_PWM1_TCR_MDIS_MASK 0x10
#define LPC_PWM1_TCR_MDIS 0x10
#define LPC_PWM1_TCR_MDIS_BIT 4

#define LPC_PWM1_TC (*(volatile unsigned long *)0x40018008)
#define LPC_PWM1_TC_OFFSET 0x8
#define LPC_PWM1_TC_TC_MASK 0xFFFFFFFF
#define LPC_PWM1_TC_TC_BIT 0

#define LPC_PWM1_PR (*(volatile unsigned long *)0x4001800C)
#define LPC_PWM1_PR_OFFSET 0xC
#define LPC_PWM1_PR_PM_MASK 0xFFFFFFFF
#define LPC_PWM1_PR_PM_BIT 0

#define LPC_PWM1_PC (*(volatile unsigned long *)0x40018010)
#define LPC_PWM1_PC_OFFSET 0x10
#define LPC_PWM1_PC_PC_MASK 0xFFFFFFFF
#define LPC_PWM1_PC_PC_BIT 0

#define LPC_PWM1_MCR (*(volatile unsigned long *)0x40018014)
#define LPC_PWM1_MCR_OFFSET 0x14
#define LPC_PWM1_MCR_PWMMR0I_MASK 0x1
#define LPC_PWM1_MCR_PWMMR0I 0x1
#define LPC_PWM1_MCR_PWMMR0I_BIT 0
#define LPC_PWM1_MCR_PWMMR0R_MASK 0x2
#define LPC_PWM1_MCR_PWMMR0R 0x2
#define LPC_PWM1_MCR_PWMMR0R_BIT 1
#define LPC_PWM1_MCR_PWMMR0S_MASK 0x4
#define LPC_PWM1_MCR_PWMMR0S 0x4
#define LPC_PWM1_MCR_PWMMR0S_BIT 2
#define LPC_PWM1_MCR_PWMMR1I_MASK 0x8
#define LPC_PWM1_MCR_PWMMR1I 0x8
#define LPC_PWM1_MCR_PWMMR1I_BIT 3
#define LPC_PWM1_MCR_PWMMR1R_MASK 0x10
#define LPC_PWM1_MCR_PWMMR1R 0x10
#define LPC_PWM1_MCR_PWMMR1R_BIT 4
#define LPC_PWM1_MCR_PWMMR1S_MASK 0x20
#define LPC_PWM1_MCR_PWMMR1S 0x20
#define LPC_PWM1_MCR_PWMMR1S_BIT 5
#define LPC_PWM1_MCR_PWMMR2I_MASK 0x40
#define LPC_PWM1_MCR_PWMMR2I 0x40
#define LPC_PWM1_MCR_PWMMR2I_BIT 6
#define LPC_PWM1_MCR_PWMMR2R_MASK 0x80
#define LPC_PWM1_MCR_PWMMR2R 0x80
#define LPC_PWM1_MCR_PWMMR2R_BIT 7
#define LPC_PWM1_MCR_PWMMR2S_MASK 0x100
#define LPC_PWM1_MCR_PWMMR2S 0x100
#define LPC_PWM1_MCR_PWMMR2S_BIT 8
#define LPC_PWM1_MCR_PWMMR3I_MASK 0x200
#define LPC_PWM1_MCR_PWMMR3I 0x200
#define LPC_PWM1_MCR_PWMMR3I_BIT 9
#define LPC_PWM1_MCR_PWMMR3R_MASK 0x400
#define LPC_PWM1_MCR_PWMMR3R 0x400
#define LPC_PWM1_MCR_PWMMR3R_BIT 10
#define LPC_PWM1_MCR_PWMMR3S_MASK 0x800
#define LPC_PWM1_MCR_PWMMR3S 0x800
#define LPC_PWM1_MCR_PWMMR3S_BIT 11
#define LPC_PWM1_MCR_PWMMR4I_MASK 0x1000
#define LPC_PWM1_MCR_PWMMR4I 0x1000
#define LPC_PWM1_MCR_PWMMR4I_BIT 12
#define LPC_PWM1_MCR_PWMMR4R_MASK 0x2000
#define LPC_PWM1_MCR_PWMMR4R 0x2000
#define LPC_PWM1_MCR_PWMMR4R_BIT 13
#define LPC_PWM1_MCR_PWMMR4S_MASK 0x4000
#define LPC_PWM1_MCR_PWMMR4S 0x4000
#define LPC_PWM1_MCR_PWMMR4S_BIT 14
#define LPC_PWM1_MCR_PWMMR5I_MASK 0x8000
#define LPC_PWM1_MCR_PWMMR5I 0x8000
#define LPC_PWM1_MCR_PWMMR5I_BIT 15
#define LPC_PWM1_MCR_PWMMR5R_MASK 0x10000
#define LPC_PWM1_MCR_PWMMR5R 0x10000
#define LPC_PWM1_MCR_PWMMR5R_BIT 16
#define LPC_PWM1_MCR_PWMMR5S_MASK 0x20000
#define LPC_PWM1_MCR_PWMMR5S 0x20000
#define LPC_PWM1_MCR_PWMMR5S_BIT 17
#define LPC_PWM1_MCR_PWMMR6I_MASK 0x40000
#define LPC_PWM1_MCR_PWMMR6I 0x40000
#define LPC_PWM1_MCR_PWMMR6I_BIT 18
#define LPC_PWM1_MCR_PWMMR6R_MASK 0x80000
#define LPC_PWM1_MCR_PWMMR6R 0x80000
#define LPC_PWM1_MCR_PWMMR6R_BIT 19
#define LPC_PWM1_MCR_PWMMR6S_MASK 0x100000
#define LPC_PWM1_MCR_PWMMR6S 0x100000
#define LPC_PWM1_MCR_PWMMR6S_BIT 20

#define LPC_PWM1_MR0 (*(volatile unsigned long *)0x40018018)
#define LPC_PWM1_MR0_OFFSET 0x18
#define LPC_PWM1_MR0_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM1_MR0_MATCH_BIT 0

#define LPC_PWM1_MR1 (*(volatile unsigned long *)0x4001801C)
#define LPC_PWM1_MR1_OFFSET 0x1C
#define LPC_PWM1_MR1_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM1_MR1_MATCH_BIT 0

#define LPC_PWM1_MR2 (*(volatile unsigned long *)0x40018020)
#define LPC_PWM1_MR2_OFFSET 0x20
#define LPC_PWM1_MR2_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM1_MR2_MATCH_BIT 0

#define LPC_PWM1_MR3 (*(volatile unsigned long *)0x40018024)
#define LPC_PWM1_MR3_OFFSET 0x24
#define LPC_PWM1_MR3_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM1_MR3_MATCH_BIT 0

#define LPC_PWM1_CCR (*(volatile unsigned long *)0x40018028)
#define LPC_PWM1_CCR_OFFSET 0x28
#define LPC_PWM1_CCR_CAP0_R_MASK 0x1
#define LPC_PWM1_CCR_CAP0_R 0x1
#define LPC_PWM1_CCR_CAP0_R_BIT 0
#define LPC_PWM1_CCR_CAP0_F_MASK 0x2
#define LPC_PWM1_CCR_CAP0_F 0x2
#define LPC_PWM1_CCR_CAP0_F_BIT 1
#define LPC_PWM1_CCR_CAP0_I_MASK 0x4
#define LPC_PWM1_CCR_CAP0_I 0x4
#define LPC_PWM1_CCR_CAP0_I_BIT 2
#define LPC_PWM1_CCR_CAP1_R_MASK 0x8
#define LPC_PWM1_CCR_CAP1_R 0x8
#define LPC_PWM1_CCR_CAP1_R_BIT 3
#define LPC_PWM1_CCR_CAP1_F_MASK 0x10
#define LPC_PWM1_CCR_CAP1_F 0x10
#define LPC_PWM1_CCR_CAP1_F_BIT 4
#define LPC_PWM1_CCR_CAP1_I_MASK 0x20
#define LPC_PWM1_CCR_CAP1_I 0x20
#define LPC_PWM1_CCR_CAP1_I_BIT 5

#define LPC_PWM1_CR0 (*(volatile unsigned long *)0x4001802C)
#define LPC_PWM1_CR0_OFFSET 0x2C
#define LPC_PWM1_CR0_PWMSEL2_MASK 0x4
#define LPC_PWM1_CR0_PWMSEL2 0x4
#define LPC_PWM1_CR0_PWMSEL2_BIT 2
#define LPC_PWM1_CR0_PWMSEL3_MASK 0x8
#define LPC_PWM1_CR0_PWMSEL3 0x8
#define LPC_PWM1_CR0_PWMSEL3_BIT 3
#define LPC_PWM1_CR0_PWMSEL4_MASK 0x10
#define LPC_PWM1_CR0_PWMSEL4 0x10
#define LPC_PWM1_CR0_PWMSEL4_BIT 4
#define LPC_PWM1_CR0_PWMSEL5_MASK 0x20
#define LPC_PWM1_CR0_PWMSEL5 0x20
#define LPC_PWM1_CR0_PWMSEL5_BIT 5
#define LPC_PWM1_CR0_PWMSEL6_MASK 0x40
#define LPC_PWM1_CR0_PWMSEL6 0x40
#define LPC_PWM1_CR0_PWMSEL6_BIT 6
#define LPC_PWM1_CR0_PWMENA1_MASK 0x200
#define LPC_PWM1_CR0_PWMENA1 0x200
#define LPC_PWM1_CR0_PWMENA1_BIT 9
#define LPC_PWM1_CR0_PWMENA2_MASK 0x400
#define LPC_PWM1_CR0_PWMENA2 0x400
#define LPC_PWM1_CR0_PWMENA2_BIT 10
#define LPC_PWM1_CR0_PWMENA3_MASK 0x800
#define LPC_PWM1_CR0_PWMENA3 0x800
#define LPC_PWM1_CR0_PWMENA3_BIT 11
#define LPC_PWM1_CR0_PWMENA4_MASK 0x1000
#define LPC_PWM1_CR0_PWMENA4 0x1000
#define LPC_PWM1_CR0_PWMENA4_BIT 12
#define LPC_PWM1_CR0_PWMENA5_MASK 0x2000
#define LPC_PWM1_CR0_PWMENA5 0x2000
#define LPC_PWM1_CR0_PWMENA5_BIT 13
#define LPC_PWM1_CR0_PWMENA6_MASK 0x4000
#define LPC_PWM1_CR0_PWMENA6 0x4000
#define LPC_PWM1_CR0_PWMENA6_BIT 14

#define LPC_PWM1_CR1 (*(volatile unsigned long *)0x40018030)
#define LPC_PWM1_CR1_OFFSET 0x30
#define LPC_PWM1_CR1_PWMSEL2_MASK 0x4
#define LPC_PWM1_CR1_PWMSEL2 0x4
#define LPC_PWM1_CR1_PWMSEL2_BIT 2
#define LPC_PWM1_CR1_PWMSEL3_MASK 0x8
#define LPC_PWM1_CR1_PWMSEL3 0x8
#define LPC_PWM1_CR1_PWMSEL3_BIT 3
#define LPC_PWM1_CR1_PWMSEL4_MASK 0x10
#define LPC_PWM1_CR1_PWMSEL4 0x10
#define LPC_PWM1_CR1_PWMSEL4_BIT 4
#define LPC_PWM1_CR1_PWMSEL5_MASK 0x20
#define LPC_PWM1_CR1_PWMSEL5 0x20
#define LPC_PWM1_CR1_PWMSEL5_BIT 5
#define LPC_PWM1_CR1_PWMSEL6_MASK 0x40
#define LPC_PWM1_CR1_PWMSEL6 0x40
#define LPC_PWM1_CR1_PWMSEL6_BIT 6
#define LPC_PWM1_CR1_PWMENA1_MASK 0x200
#define LPC_PWM1_CR1_PWMENA1 0x200
#define LPC_PWM1_CR1_PWMENA1_BIT 9
#define LPC_PWM1_CR1_PWMENA2_MASK 0x400
#define LPC_PWM1_CR1_PWMENA2 0x400
#define LPC_PWM1_CR1_PWMENA2_BIT 10
#define LPC_PWM1_CR1_PWMENA3_MASK 0x800
#define LPC_PWM1_CR1_PWMENA3 0x800
#define LPC_PWM1_CR1_PWMENA3_BIT 11
#define LPC_PWM1_CR1_PWMENA4_MASK 0x1000
#define LPC_PWM1_CR1_PWMENA4 0x1000
#define LPC_PWM1_CR1_PWMENA4_BIT 12
#define LPC_PWM1_CR1_PWMENA5_MASK 0x2000
#define LPC_PWM1_CR1_PWMENA5 0x2000
#define LPC_PWM1_CR1_PWMENA5_BIT 13
#define LPC_PWM1_CR1_PWMENA6_MASK 0x4000
#define LPC_PWM1_CR1_PWMENA6 0x4000
#define LPC_PWM1_CR1_PWMENA6_BIT 14

#define LPC_PWM1_MR4 (*(volatile unsigned long *)0x40018040)
#define LPC_PWM1_MR4_OFFSET 0x40
#define LPC_PWM1_MR4_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM1_MR4_MATCH_BIT 0

#define LPC_PWM1_MR5 (*(volatile unsigned long *)0x40018044)
#define LPC_PWM1_MR5_OFFSET 0x44
#define LPC_PWM1_MR5_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM1_MR5_MATCH_BIT 0

#define LPC_PWM1_MR6 (*(volatile unsigned long *)0x40018048)
#define LPC_PWM1_MR6_OFFSET 0x48
#define LPC_PWM1_MR6_MATCH_MASK 0xFFFFFFFF
#define LPC_PWM1_MR6_MATCH_BIT 0

#define LPC_PWM1_PCR (*(volatile unsigned long *)0x4001804C)
#define LPC_PWM1_PCR_OFFSET 0x4C
#define LPC_PWM1_PCR_PWMSEL2_MASK 0x4
#define LPC_PWM1_PCR_PWMSEL2 0x4
#define LPC_PWM1_PCR_PWMSEL2_BIT 2
#define LPC_PWM1_PCR_PWMSEL3_MASK 0x8
#define LPC_PWM1_PCR_PWMSEL3 0x8
#define LPC_PWM1_PCR_PWMSEL3_BIT 3
#define LPC_PWM1_PCR_PWMSEL4_MASK 0x10
#define LPC_PWM1_PCR_PWMSEL4 0x10
#define LPC_PWM1_PCR_PWMSEL4_BIT 4
#define LPC_PWM1_PCR_PWMSEL5_MASK 0x20
#define LPC_PWM1_PCR_PWMSEL5 0x20
#define LPC_PWM1_PCR_PWMSEL5_BIT 5
#define LPC_PWM1_PCR_PWMSEL6_MASK 0x40
#define LPC_PWM1_PCR_PWMSEL6 0x40
#define LPC_PWM1_PCR_PWMSEL6_BIT 6
#define LPC_PWM1_PCR_PWMENA1_MASK 0x200
#define LPC_PWM1_PCR_PWMENA1 0x200
#define LPC_PWM1_PCR_PWMENA1_BIT 9
#define LPC_PWM1_PCR_PWMENA2_MASK 0x400
#define LPC_PWM1_PCR_PWMENA2 0x400
#define LPC_PWM1_PCR_PWMENA2_BIT 10
#define LPC_PWM1_PCR_PWMENA3_MASK 0x800
#define LPC_PWM1_PCR_PWMENA3 0x800
#define LPC_PWM1_PCR_PWMENA3_BIT 11
#define LPC_PWM1_PCR_PWMENA4_MASK 0x1000
#define LPC_PWM1_PCR_PWMENA4 0x1000
#define LPC_PWM1_PCR_PWMENA4_BIT 12
#define LPC_PWM1_PCR_PWMENA5_MASK 0x2000
#define LPC_PWM1_PCR_PWMENA5 0x2000
#define LPC_PWM1_PCR_PWMENA5_BIT 13
#define LPC_PWM1_PCR_PWMENA6_MASK 0x4000
#define LPC_PWM1_PCR_PWMENA6 0x4000
#define LPC_PWM1_PCR_PWMENA6_BIT 14

#define LPC_PWM1_LER (*(volatile unsigned long *)0x40018050)
#define LPC_PWM1_LER_OFFSET 0x50
#define LPC_PWM1_LER_MAT0LATCHEN_MASK 0x1
#define LPC_PWM1_LER_MAT0LATCHEN 0x1
#define LPC_PWM1_LER_MAT0LATCHEN_BIT 0
#define LPC_PWM1_LER_MAT1LATCHEN_MASK 0x2
#define LPC_PWM1_LER_MAT1LATCHEN 0x2
#define LPC_PWM1_LER_MAT1LATCHEN_BIT 1
#define LPC_PWM1_LER_MAT2LATCHEN_MASK 0x4
#define LPC_PWM1_LER_MAT2LATCHEN 0x4
#define LPC_PWM1_LER_MAT2LATCHEN_BIT 2
#define LPC_PWM1_LER_MAT3LATCHEN_MASK 0x8
#define LPC_PWM1_LER_MAT3LATCHEN 0x8
#define LPC_PWM1_LER_MAT3LATCHEN_BIT 3
#define LPC_PWM1_LER_MAT4LATCHEN_MASK 0x10
#define LPC_PWM1_LER_MAT4LATCHEN 0x10
#define LPC_PWM1_LER_MAT4LATCHEN_BIT 4
#define LPC_PWM1_LER_MAT5LATCHEN_MASK 0x20
#define LPC_PWM1_LER_MAT5LATCHEN 0x20
#define LPC_PWM1_LER_MAT5LATCHEN_BIT 5
#define LPC_PWM1_LER_MAT6LATCHEN_MASK 0x40
#define LPC_PWM1_LER_MAT6LATCHEN 0x40
#define LPC_PWM1_LER_MAT6LATCHEN_BIT 6

#define LPC_PWM1_CTCR (*(volatile unsigned long *)0x40018070)
#define LPC_PWM1_CTCR_OFFSET 0x70
#define LPC_PWM1_CTCR_MOD_MASK 0x3
#define LPC_PWM1_CTCR_MOD_BIT 0
#define LPC_PWM1_CTCR_CIS_MASK 0xC
#define LPC_PWM1_CTCR_CIS_BIT 2

#ifndef LPC_I2C0_BASE_ADDRESS
#define LPC_I2C0_BASE_ADDRESS 0x4001C000
#endif

#define LPC_I2C0_CONSET (*(volatile unsigned long *)0x4001C000)
#define LPC_I2C0_CONSET_OFFSET 0x0
#define LPC_I2C0_CONSET_AA_MASK 0x4
#define LPC_I2C0_CONSET_AA 0x4
#define LPC_I2C0_CONSET_AA_BIT 2
#define LPC_I2C0_CONSET_SI_MASK 0x8
#define LPC_I2C0_CONSET_SI 0x8
#define LPC_I2C0_CONSET_SI_BIT 3
#define LPC_I2C0_CONSET_STO_MASK 0x10
#define LPC_I2C0_CONSET_STO 0x10
#define LPC_I2C0_CONSET_STO_BIT 4
#define LPC_I2C0_CONSET_STA_MASK 0x20
#define LPC_I2C0_CONSET_STA 0x20
#define LPC_I2C0_CONSET_STA_BIT 5
#define LPC_I2C0_CONSET_I2EN_MASK 0x40
#define LPC_I2C0_CONSET_I2EN 0x40
#define LPC_I2C0_CONSET_I2EN_BIT 6

#define LPC_I2C0_STAT (*(volatile unsigned long *)0x4001C004)
#define LPC_I2C0_STAT_OFFSET 0x4
#define LPC_I2C0_STAT_Status_MASK 0xF8
#define LPC_I2C0_STAT_Status_BIT 3

#define LPC_I2C0_DAT (*(volatile unsigned long *)0x4001C008)
#define LPC_I2C0_DAT_OFFSET 0x8
#define LPC_I2C0_DAT_Data_MASK 0xFF
#define LPC_I2C0_DAT_Data_BIT 0

#define LPC_I2C0_ADR0 (*(volatile unsigned long *)0x4001C00C)
#define LPC_I2C0_ADR0_OFFSET 0xC
#define LPC_I2C0_ADR0_GC_MASK 0x1
#define LPC_I2C0_ADR0_GC 0x1
#define LPC_I2C0_ADR0_GC_BIT 0
#define LPC_I2C0_ADR0_Address_MASK 0xFE
#define LPC_I2C0_ADR0_Address_BIT 1

#define LPC_I2C0_SCLH (*(volatile unsigned long *)0x4001C010)
#define LPC_I2C0_SCLH_OFFSET 0x10
#define LPC_I2C0_SCLH_SCLH_MASK 0xFFFF
#define LPC_I2C0_SCLH_SCLH_BIT 0

#define LPC_I2C0_SCLL (*(volatile unsigned long *)0x4001C014)
#define LPC_I2C0_SCLL_OFFSET 0x14
#define LPC_I2C0_SCLL_SCLL_MASK 0xFFFF
#define LPC_I2C0_SCLL_SCLL_BIT 0

#define LPC_I2C0_CONCLR (*(volatile unsigned long *)0x4001C018)
#define LPC_I2C0_CONCLR_OFFSET 0x18
#define LPC_I2C0_CONCLR_AAC_MASK 0x4
#define LPC_I2C0_CONCLR_AAC 0x4
#define LPC_I2C0_CONCLR_AAC_BIT 2
#define LPC_I2C0_CONCLR_SIC_MASK 0x8
#define LPC_I2C0_CONCLR_SIC 0x8
#define LPC_I2C0_CONCLR_SIC_BIT 3
#define LPC_I2C0_CONCLR_STAC_MASK 0x20
#define LPC_I2C0_CONCLR_STAC 0x20
#define LPC_I2C0_CONCLR_STAC_BIT 5
#define LPC_I2C0_CONCLR_I2ENC_MASK 0x40
#define LPC_I2C0_CONCLR_I2ENC 0x40
#define LPC_I2C0_CONCLR_I2ENC_BIT 6

#define LPC_I2C0_MMCTRL (*(volatile unsigned long *)0x4001C01C)
#define LPC_I2C0_MMCTRL_OFFSET 0x1C
#define LPC_I2C0_MMCTRL_MM_ENA_MASK 0x1
#define LPC_I2C0_MMCTRL_MM_ENA 0x1
#define LPC_I2C0_MMCTRL_MM_ENA_BIT 0
#define LPC_I2C0_MMCTRL_ENA_SCL_MASK 0x2
#define LPC_I2C0_MMCTRL_ENA_SCL 0x2
#define LPC_I2C0_MMCTRL_ENA_SCL_BIT 1
#define LPC_I2C0_MMCTRL_MATCH_ALL_MASK 0x4
#define LPC_I2C0_MMCTRL_MATCH_ALL 0x4
#define LPC_I2C0_MMCTRL_MATCH_ALL_BIT 2

#define LPC_I2C0_ADR1 (*(volatile unsigned long *)0x4001C020)
#define LPC_I2C0_ADR1_OFFSET 0x20
#define LPC_I2C0_ADR1_GC_MASK 0x1
#define LPC_I2C0_ADR1_GC 0x1
#define LPC_I2C0_ADR1_GC_BIT 0
#define LPC_I2C0_ADR1_Address_MASK 0xFE
#define LPC_I2C0_ADR1_Address_BIT 1

#define LPC_I2C0_ADR2 (*(volatile unsigned long *)0x4001C024)
#define LPC_I2C0_ADR2_OFFSET 0x24
#define LPC_I2C0_ADR2_GC_MASK 0x1
#define LPC_I2C0_ADR2_GC 0x1
#define LPC_I2C0_ADR2_GC_BIT 0
#define LPC_I2C0_ADR2_Address_MASK 0xFE
#define LPC_I2C0_ADR2_Address_BIT 1

#define LPC_I2C0_ADR3 (*(volatile unsigned long *)0x4001C028)
#define LPC_I2C0_ADR3_OFFSET 0x28
#define LPC_I2C0_ADR3_GC_MASK 0x1
#define LPC_I2C0_ADR3_GC 0x1
#define LPC_I2C0_ADR3_GC_BIT 0
#define LPC_I2C0_ADR3_Address_MASK 0xFE
#define LPC_I2C0_ADR3_Address_BIT 1

#define LPC_I2C0_DATA_BUFFER (*(volatile unsigned long *)0x4001C02C)
#define LPC_I2C0_DATA_BUFFER_OFFSET 0x2C
#define LPC_I2C0_DATA_BUFFER_Data_MASK 0xFF
#define LPC_I2C0_DATA_BUFFER_Data_BIT 0

#define LPC_I2C0_MASK0 (*(volatile unsigned long *)0x4001C030)
#define LPC_I2C0_MASK0_OFFSET 0x30
#define LPC_I2C0_MASK0_MASK_MASK 0xFE
#define LPC_I2C0_MASK0_MASK_BIT 1

#define LPC_I2C0_MASK1 (*(volatile unsigned long *)0x4001C034)
#define LPC_I2C0_MASK1_OFFSET 0x34
#define LPC_I2C0_MASK1_MASK_MASK 0xFE
#define LPC_I2C0_MASK1_MASK_BIT 1

#define LPC_I2C0_MASK2 (*(volatile unsigned long *)0x4001C038)
#define LPC_I2C0_MASK2_OFFSET 0x38
#define LPC_I2C0_MASK2_MASK_MASK 0xFE
#define LPC_I2C0_MASK2_MASK_BIT 1

#define LPC_I2C0_MASK3 (*(volatile unsigned long *)0x4001C03C)
#define LPC_I2C0_MASK3_OFFSET 0x3C
#define LPC_I2C0_MASK3_MASK_MASK 0xFE
#define LPC_I2C0_MASK3_MASK_BIT 1

#ifndef LPC_COMPARATOR_BASE_ADDRESS
#define LPC_COMPARATOR_BASE_ADDRESS 0x40020000
#endif

#define LPC_COMPARATOR_CTRL (*(volatile unsigned long *)0x40020000)
#define LPC_COMPARATOR_CTRL_OFFSET 0x0
#define LPC_COMPARATOR_CTRL_CMP_PD_IREF_MASK 0x3
#define LPC_COMPARATOR_CTRL_CMP_PD_IREF_BIT 0
#define LPC_COMPARATOR_CTRL_CMP_PD_VBG_MASK 0xC
#define LPC_COMPARATOR_CTRL_CMP_PD_VBG_BIT 2
#define LPC_COMPARATOR_CTRL_CMP_VTEMP_MASK 0x30
#define LPC_COMPARATOR_CTRL_CMP_VTEMP_BIT 4
#define LPC_COMPARATOR_CTRL_CMP_TEMPSEN_MASK 0xC0
#define LPC_COMPARATOR_CTRL_CMP_TEMPSEN_BIT 6
#define LPC_COMPARATOR_CTRL_CMP_ROSCCTL_MASK 0x100
#define LPC_COMPARATOR_CTRL_CMP_ROSCCTL 0x100
#define LPC_COMPARATOR_CTRL_CMP_ROSCCTL_BIT 8
#define LPC_COMPARATOR_CTRL_CMP_EXT_RESET_MASK 0x200
#define LPC_COMPARATOR_CTRL_CMP_EXT_RESET 0x200
#define LPC_COMPARATOR_CTRL_CMP_EXT_RESET_BIT 9
#define LPC_COMPARATOR_CTRL_CMP_T0CAP2_MASK 0x1000
#define LPC_COMPARATOR_CTRL_CMP_T0CAP2 0x1000
#define LPC_COMPARATOR_CTRL_CMP_T0CAP2_BIT 12
#define LPC_COMPARATOR_CTRL_CMP_T0CAP3_MASK 0x2000
#define LPC_COMPARATOR_CTRL_CMP_T0CAP3 0x2000
#define LPC_COMPARATOR_CTRL_CMP_T0CAP3_BIT 13
#define LPC_COMPARATOR_CTRL_CMP_T1CAP2_MASK 0x4000
#define LPC_COMPARATOR_CTRL_CMP_T1CAP2 0x4000
#define LPC_COMPARATOR_CTRL_CMP_T1CAP2_BIT 14
#define LPC_COMPARATOR_CTRL_CMP_T1CAP3_MASK 0x8000
#define LPC_COMPARATOR_CTRL_CMP_T1CAP3 0x8000
#define LPC_COMPARATOR_CTRL_CMP_T1CAP3_BIT 15

#define LPC_COMPARATOR_CTRL0 (*(volatile unsigned long *)0x40020004)
#define LPC_COMPARATOR_CTRL0_OFFSET 0x4
#define LPC_COMPARATOR_CTRL0_CMP0_EN_MASK 0x3
#define LPC_COMPARATOR_CTRL0_CMP0_EN_BIT 0
#define LPC_COMPARATOR_CTRL0_CMP0_OE_MASK 0x4
#define LPC_COMPARATOR_CTRL0_CMP0_OE 0x4
#define LPC_COMPARATOR_CTRL0_CMP0_OE_BIT 2
#define LPC_COMPARATOR_CTRL0_CMP0_STAT_MASK 0x8
#define LPC_COMPARATOR_CTRL0_CMP0_STAT 0x8
#define LPC_COMPARATOR_CTRL0_CMP0_STAT_BIT 3
#define LPC_COMPARATOR_CTRL0_CMP0_VM_MASK 0x70
#define LPC_COMPARATOR_CTRL0_CMP0_VM_BIT 4
#define LPC_COMPARATOR_CTRL0_CMP0_VP_MASK 0x700
#define LPC_COMPARATOR_CTRL0_CMP0_VP_BIT 8
#define LPC_COMPARATOR_CTRL0_CMP0_SYNC_MASK 0x1000
#define LPC_COMPARATOR_CTRL0_CMP0_SYNC 0x1000
#define LPC_COMPARATOR_CTRL0_CMP0_SYNC_BIT 12
#define LPC_COMPARATOR_CTRL0_CMP0_HYS_MASK 0x6000
#define LPC_COMPARATOR_CTRL0_CMP0_HYS_BIT 13
#define LPC_COMPARATOR_CTRL0_CMP0_INTPOL_MASK 0x8000
#define LPC_COMPARATOR_CTRL0_CMP0_INTPOL 0x8000
#define LPC_COMPARATOR_CTRL0_CMP0_INTPOL_BIT 15
#define LPC_COMPARATOR_CTRL0_CMP0_INTTYPE_MASK 0x10000
#define LPC_COMPARATOR_CTRL0_CMP0_INTTYPE 0x10000
#define LPC_COMPARATOR_CTRL0_CMP0_INTTYPE_BIT 16
#define LPC_COMPARATOR_CTRL0_CMP0_INTEDGE_MASK 0x60000
#define LPC_COMPARATOR_CTRL0_CMP0_INTEDGE_BIT 17
#define LPC_COMPARATOR_CTRL0_CMP0_INTFLAG_MASK 0x80000
#define LPC_COMPARATOR_CTRL0_CMP0_INTFLAG 0x80000
#define LPC_COMPARATOR_CTRL0_CMP0_INTFLAG_BIT 19
#define LPC_COMPARATOR_CTRL0_CMP0_VLADEN_MASK 0x300000
#define LPC_COMPARATOR_CTRL0_CMP0_VLADEN_BIT 20
#define LPC_COMPARATOR_CTRL0_CMP0_VLADREF_MASK 0x400000
#define LPC_COMPARATOR_CTRL0_CMP0_VLADREF 0x400000
#define LPC_COMPARATOR_CTRL0_CMP0_VLADREF_BIT 22
#define LPC_COMPARATOR_CTRL0_CMP0_VSEL_MASK 0x1F000000
#define LPC_COMPARATOR_CTRL0_CMP0_VSEL_BIT 24

#define LPC_COMPARATOR_CTRL1 (*(volatile unsigned long *)0x40020008)
#define LPC_COMPARATOR_CTRL1_OFFSET 0x8
#define LPC_COMPARATOR_CTRL1_CMP1_EN_MASK 0x3
#define LPC_COMPARATOR_CTRL1_CMP1_EN_BIT 0
#define LPC_COMPARATOR_CTRL1_CMP1_OE_MASK 0x4
#define LPC_COMPARATOR_CTRL1_CMP1_OE 0x4
#define LPC_COMPARATOR_CTRL1_CMP1_OE_BIT 2
#define LPC_COMPARATOR_CTRL1_CMP1_STAT_MASK 0x8
#define LPC_COMPARATOR_CTRL1_CMP1_STAT 0x8
#define LPC_COMPARATOR_CTRL1_CMP1_STAT_BIT 3
#define LPC_COMPARATOR_CTRL1_CMP1_VM_MASK 0x70
#define LPC_COMPARATOR_CTRL1_CMP1_VM_BIT 4
#define LPC_COMPARATOR_CTRL1_CMP1_VP_MASK 0x700
#define LPC_COMPARATOR_CTRL1_CMP1_VP_BIT 8
#define LPC_COMPARATOR_CTRL1_CMP1_SYNC_MASK 0x1000
#define LPC_COMPARATOR_CTRL1_CMP1_SYNC 0x1000
#define LPC_COMPARATOR_CTRL1_CMP1_SYNC_BIT 12
#define LPC_COMPARATOR_CTRL1_CMP1_HYS_MASK 0x6000
#define LPC_COMPARATOR_CTRL1_CMP1_HYS_BIT 13
#define LPC_COMPARATOR_CTRL1_CMP1_INTPOL_MASK 0x8000
#define LPC_COMPARATOR_CTRL1_CMP1_INTPOL 0x8000
#define LPC_COMPARATOR_CTRL1_CMP1_INTPOL_BIT 15
#define LPC_COMPARATOR_CTRL1_CMP1_INTTYPE_MASK 0x10000
#define LPC_COMPARATOR_CTRL1_CMP1_INTTYPE 0x10000
#define LPC_COMPARATOR_CTRL1_CMP1_INTTYPE_BIT 16
#define LPC_COMPARATOR_CTRL1_CMP1_INTEDGE_MASK 0x60000
#define LPC_COMPARATOR_CTRL1_CMP1_INTEDGE_BIT 17
#define LPC_COMPARATOR_CTRL1_CMP1_INTFLAG_MASK 0x80000
#define LPC_COMPARATOR_CTRL1_CMP1_INTFLAG 0x80000
#define LPC_COMPARATOR_CTRL1_CMP1_INTFLAG_BIT 19
#define LPC_COMPARATOR_CTRL1_CMP1_VLADEN_MASK 0x300000
#define LPC_COMPARATOR_CTRL1_CMP1_VLADEN_BIT 20
#define LPC_COMPARATOR_CTRL1_CMP1_VLADREF_MASK 0x400000
#define LPC_COMPARATOR_CTRL1_CMP1_VLADREF 0x400000
#define LPC_COMPARATOR_CTRL1_CMP1_VLADREF_BIT 22
#define LPC_COMPARATOR_CTRL1_CMP1_VSel_MASK 0x1F000000
#define LPC_COMPARATOR_CTRL1_CMP1_VSel_BIT 24

#ifndef LPC_RTC_BASE_ADDRESS
#define LPC_RTC_BASE_ADDRESS 0x40024000
#endif

#define LPC_RTC_ILR (*(volatile unsigned long *)0x40024000)
#define LPC_RTC_ILR_OFFSET 0x0
#define LPC_RTC_ILR_RTCCIF_MASK 0x1
#define LPC_RTC_ILR_RTCCIF 0x1
#define LPC_RTC_ILR_RTCCIF_BIT 0
#define LPC_RTC_ILR_RTCALF_MASK 0x2
#define LPC_RTC_ILR_RTCALF 0x2
#define LPC_RTC_ILR_RTCALF_BIT 1

#define LPC_RTC_CCR (*(volatile unsigned long *)0x40024008)
#define LPC_RTC_CCR_OFFSET 0x8
#define LPC_RTC_CCR_CLKEN_MASK 0x1
#define LPC_RTC_CCR_CLKEN 0x1
#define LPC_RTC_CCR_CLKEN_BIT 0
#define LPC_RTC_CCR_CTCRST_MASK 0x2
#define LPC_RTC_CCR_CTCRST 0x2
#define LPC_RTC_CCR_CTCRST_BIT 1
#define LPC_RTC_CCR_CCALEN_MASK 0x10
#define LPC_RTC_CCR_CCALEN 0x10
#define LPC_RTC_CCR_CCALEN_BIT 4

#define LPC_RTC_CIIR (*(volatile unsigned long *)0x4002400C)
#define LPC_RTC_CIIR_OFFSET 0xC
#define LPC_RTC_CIIR_IMSEC_MASK 0x1
#define LPC_RTC_CIIR_IMSEC 0x1
#define LPC_RTC_CIIR_IMSEC_BIT 0
#define LPC_RTC_CIIR_IMMIN_MASK 0x2
#define LPC_RTC_CIIR_IMMIN 0x2
#define LPC_RTC_CIIR_IMMIN_BIT 1
#define LPC_RTC_CIIR_IMHOUR_MASK 0x4
#define LPC_RTC_CIIR_IMHOUR 0x4
#define LPC_RTC_CIIR_IMHOUR_BIT 2
#define LPC_RTC_CIIR_IMDOM_MASK 0x8
#define LPC_RTC_CIIR_IMDOM 0x8
#define LPC_RTC_CIIR_IMDOM_BIT 3
#define LPC_RTC_CIIR_IMDOW_MASK 0x10
#define LPC_RTC_CIIR_IMDOW 0x10
#define LPC_RTC_CIIR_IMDOW_BIT 4
#define LPC_RTC_CIIR_IMDOY_MASK 0x20
#define LPC_RTC_CIIR_IMDOY 0x20
#define LPC_RTC_CIIR_IMDOY_BIT 5
#define LPC_RTC_CIIR_IMMON_MASK 0x40
#define LPC_RTC_CIIR_IMMON 0x40
#define LPC_RTC_CIIR_IMMON_BIT 6
#define LPC_RTC_CIIR_IMYEAR_MASK 0x80
#define LPC_RTC_CIIR_IMYEAR 0x80
#define LPC_RTC_CIIR_IMYEAR_BIT 7

#define LPC_RTC_AMR (*(volatile unsigned long *)0x40024010)
#define LPC_RTC_AMR_OFFSET 0x10
#define LPC_RTC_AMR_AMRSEC_MASK 0x1
#define LPC_RTC_AMR_AMRSEC 0x1
#define LPC_RTC_AMR_AMRSEC_BIT 0
#define LPC_RTC_AMR_AMRMIN_MASK 0x2
#define LPC_RTC_AMR_AMRMIN 0x2
#define LPC_RTC_AMR_AMRMIN_BIT 1
#define LPC_RTC_AMR_AMRHOUR_MASK 0x4
#define LPC_RTC_AMR_AMRHOUR 0x4
#define LPC_RTC_AMR_AMRHOUR_BIT 2
#define LPC_RTC_AMR_AMRDOM_MASK 0x8
#define LPC_RTC_AMR_AMRDOM 0x8
#define LPC_RTC_AMR_AMRDOM_BIT 3
#define LPC_RTC_AMR_AMRDOW_MASK 0x10
#define LPC_RTC_AMR_AMRDOW 0x10
#define LPC_RTC_AMR_AMRDOW_BIT 4
#define LPC_RTC_AMR_AMRDOY_MASK 0x20
#define LPC_RTC_AMR_AMRDOY 0x20
#define LPC_RTC_AMR_AMRDOY_BIT 5
#define LPC_RTC_AMR_AMRMON_MASK 0x40
#define LPC_RTC_AMR_AMRMON 0x40
#define LPC_RTC_AMR_AMRMON_BIT 6
#define LPC_RTC_AMR_AMRYEAR_MASK 0x80
#define LPC_RTC_AMR_AMRYEAR 0x80
#define LPC_RTC_AMR_AMRYEAR_BIT 7

#define LPC_RTC_CTIME0 (*(volatile unsigned long *)0x40024014)
#define LPC_RTC_CTIME0_OFFSET 0x14
#define LPC_RTC_CTIME0_SECONDS_MASK 0x3F
#define LPC_RTC_CTIME0_SECONDS_BIT 0
#define LPC_RTC_CTIME0_MINUTES_MASK 0x3F00
#define LPC_RTC_CTIME0_MINUTES_BIT 8
#define LPC_RTC_CTIME0_HOURS_MASK 0x1F0000
#define LPC_RTC_CTIME0_HOURS_BIT 16
#define LPC_RTC_CTIME0_DOW_MASK 0x7000000
#define LPC_RTC_CTIME0_DOW_BIT 24

#define LPC_RTC_CTIME1 (*(volatile unsigned long *)0x40024018)
#define LPC_RTC_CTIME1_OFFSET 0x18
#define LPC_RTC_CTIME1_DOM_MASK 0x1F
#define LPC_RTC_CTIME1_DOM_BIT 0
#define LPC_RTC_CTIME1_MONTH_MASK 0xF00
#define LPC_RTC_CTIME1_MONTH_BIT 8
#define LPC_RTC_CTIME1_YEAR_MASK 0xFFF0000
#define LPC_RTC_CTIME1_YEAR_BIT 16

#define LPC_RTC_CTIME2 (*(volatile unsigned long *)0x4002401C)
#define LPC_RTC_CTIME2_OFFSET 0x1C
#define LPC_RTC_CTIME2_DOY_MASK 0xFFF
#define LPC_RTC_CTIME2_DOY_BIT 0

#define LPC_RTC_SEC (*(volatile unsigned long *)0x40024020)
#define LPC_RTC_SEC_OFFSET 0x20
#define LPC_RTC_SEC_SECONDS_MASK 0x3F
#define LPC_RTC_SEC_SECONDS_BIT 0

#define LPC_RTC_MIN (*(volatile unsigned long *)0x40024024)
#define LPC_RTC_MIN_OFFSET 0x24
#define LPC_RTC_MIN_MINUTES_MASK 0x3F
#define LPC_RTC_MIN_MINUTES_BIT 0

#define LPC_RTC_HRS (*(volatile unsigned long *)0x40024028)
#define LPC_RTC_HRS_OFFSET 0x28
#define LPC_RTC_HRS_HOURS_MASK 0x1F
#define LPC_RTC_HRS_HOURS_BIT 0

#define LPC_RTC_DOM (*(volatile unsigned long *)0x4002402C)
#define LPC_RTC_DOM_OFFSET 0x2C
#define LPC_RTC_DOM_DOM_MASK 0x1F
#define LPC_RTC_DOM_DOM_BIT 0

#define LPC_RTC_DOW (*(volatile unsigned long *)0x40024030)
#define LPC_RTC_DOW_OFFSET 0x30
#define LPC_RTC_DOW_DOW_MASK 0x7
#define LPC_RTC_DOW_DOW_BIT 0

#define LPC_RTC_DOY (*(volatile unsigned long *)0x40024034)
#define LPC_RTC_DOY_OFFSET 0x34
#define LPC_RTC_DOY_DOY_MASK 0x1FF
#define LPC_RTC_DOY_DOY_BIT 0

#define LPC_RTC_MONTH (*(volatile unsigned long *)0x40024038)
#define LPC_RTC_MONTH_OFFSET 0x38
#define LPC_RTC_MONTH_MONTH_MASK 0xF
#define LPC_RTC_MONTH_MONTH_BIT 0

#define LPC_RTC_YEAR (*(volatile unsigned long *)0x4002403C)
#define LPC_RTC_YEAR_OFFSET 0x3C
#define LPC_RTC_YEAR_YEAR_MASK 0xFFF
#define LPC_RTC_YEAR_YEAR_BIT 0

#define LPC_RTC_CALIBRATION (*(volatile unsigned long *)0x40024040)
#define LPC_RTC_CALIBRATION_OFFSET 0x40
#define LPC_RTC_CALIBRATION_CALVAL_MASK 0x1FFFF
#define LPC_RTC_CALIBRATION_CALVAL_BIT 0
#define LPC_RTC_CALIBRATION_CALDIR_MASK 0x20000
#define LPC_RTC_CALIBRATION_CALDIR 0x20000
#define LPC_RTC_CALIBRATION_CALDIR_BIT 17

#define LPC_RTC_GPREG0 (*(volatile unsigned long *)0x40024044)
#define LPC_RTC_GPREG0_OFFSET 0x44
#define LPC_RTC_GPREG0_GP_MASK 0xFFFFFFFF
#define LPC_RTC_GPREG0_GP_BIT 0

#define LPC_RTC_GPREG1 (*(volatile unsigned long *)0x40024048)
#define LPC_RTC_GPREG1_OFFSET 0x48
#define LPC_RTC_GPREG1_GP_MASK 0xFFFFFFFF
#define LPC_RTC_GPREG1_GP_BIT 0

#define LPC_RTC_GPREG2 (*(volatile unsigned long *)0x4002404C)
#define LPC_RTC_GPREG2_OFFSET 0x4C
#define LPC_RTC_GPREG2_GP_MASK 0xFFFFFFFF
#define LPC_RTC_GPREG2_GP_BIT 0

#define LPC_RTC_GPREG3 (*(volatile unsigned long *)0x40024050)
#define LPC_RTC_GPREG3_OFFSET 0x50
#define LPC_RTC_GPREG3_GP_MASK 0xFFFFFFFF
#define LPC_RTC_GPREG3_GP_BIT 0

#define LPC_RTC_GPREG4 (*(volatile unsigned long *)0x40024054)
#define LPC_RTC_GPREG4_OFFSET 0x54
#define LPC_RTC_GPREG4_GP_MASK 0xFFFFFFFF
#define LPC_RTC_GPREG4_GP_BIT 0

#define LPC_RTC_RTC_AUX (*(volatile unsigned long *)0x4002405C)
#define LPC_RTC_RTC_AUX_OFFSET 0x5C
#define LPC_RTC_RTC_AUX_RTC_OSCF_MASK 0x10
#define LPC_RTC_RTC_AUX_RTC_OSCF 0x10
#define LPC_RTC_RTC_AUX_RTC_OSCF_BIT 4
#define LPC_RTC_RTC_AUX_RTC_PDOUT_MASK 0x40
#define LPC_RTC_RTC_AUX_RTC_PDOUT 0x40
#define LPC_RTC_RTC_AUX_RTC_PDOUT_BIT 6

#define LPC_RTC_RTC_AUXEN (*(volatile unsigned long *)0x40024058)
#define LPC_RTC_RTC_AUXEN_OFFSET 0x58
#define LPC_RTC_RTC_AUXEN_RTC_OSCFEN_MASK 0x10
#define LPC_RTC_RTC_AUXEN_RTC_OSCFEN 0x10
#define LPC_RTC_RTC_AUXEN_RTC_OSCFEN_BIT 4

#define LPC_RTC_ASEC (*(volatile unsigned long *)0x40024060)
#define LPC_RTC_ASEC_OFFSET 0x60
#define LPC_RTC_ASEC_SECONDS_MASK 0x3F
#define LPC_RTC_ASEC_SECONDS_BIT 0

#define LPC_RTC_AMIN (*(volatile unsigned long *)0x40024064)
#define LPC_RTC_AMIN_OFFSET 0x64
#define LPC_RTC_AMIN_MINUTES_MASK 0x3F
#define LPC_RTC_AMIN_MINUTES_BIT 0

#define LPC_RTC_AHRS (*(volatile unsigned long *)0x40024068)
#define LPC_RTC_AHRS_OFFSET 0x68
#define LPC_RTC_AHRS_HOURS_MASK 0x1F
#define LPC_RTC_AHRS_HOURS_BIT 0

#define LPC_RTC_ADOM (*(volatile unsigned long *)0x4002406C)
#define LPC_RTC_ADOM_OFFSET 0x6C
#define LPC_RTC_ADOM_DOM_MASK 0x1F
#define LPC_RTC_ADOM_DOM_BIT 0

#define LPC_RTC_ADOW (*(volatile unsigned long *)0x40024070)
#define LPC_RTC_ADOW_OFFSET 0x70
#define LPC_RTC_ADOW_DOW_MASK 0x7
#define LPC_RTC_ADOW_DOW_BIT 0

#define LPC_RTC_ADOY (*(volatile unsigned long *)0x40024074)
#define LPC_RTC_ADOY_OFFSET 0x74
#define LPC_RTC_ADOY_DOY_MASK 0x1FF
#define LPC_RTC_ADOY_DOY_BIT 0

#define LPC_RTC_AMON (*(volatile unsigned long *)0x40024078)
#define LPC_RTC_AMON_OFFSET 0x78
#define LPC_RTC_AMON_MONTH_MASK 0xF
#define LPC_RTC_AMON_MONTH_BIT 0

#define LPC_RTC_AYRS (*(volatile unsigned long *)0x4002407C)
#define LPC_RTC_AYRS_OFFSET 0x7C
#define LPC_RTC_AYRS_YEAR_MASK 0xFFF
#define LPC_RTC_AYRS_YEAR_BIT 0

#define LPC_RTC_ERCONTROL (*(volatile unsigned long *)0x40024084)
#define LPC_RTC_ERCONTROL_OFFSET 0x84
#define LPC_RTC_ERCONTROL_INTWAKE_EN0_MASK 0x1
#define LPC_RTC_ERCONTROL_INTWAKE_EN0 0x1
#define LPC_RTC_ERCONTROL_INTWAKE_EN0_BIT 0
#define LPC_RTC_ERCONTROL_GPCLEAR_EN0_MASK 0x2
#define LPC_RTC_ERCONTROL_GPCLEAR_EN0 0x2
#define LPC_RTC_ERCONTROL_GPCLEAR_EN0_BIT 1
#define LPC_RTC_ERCONTROL_POL0_MASK 0x4
#define LPC_RTC_ERCONTROL_POL0 0x4
#define LPC_RTC_ERCONTROL_POL0_BIT 2
#define LPC_RTC_ERCONTROL_EV0_INPUT_EN_MASK 0x8
#define LPC_RTC_ERCONTROL_EV0_INPUT_EN 0x8
#define LPC_RTC_ERCONTROL_EV0_INPUT_EN_BIT 3
#define LPC_RTC_ERCONTROL_INTWAKE_EN1_MASK 0x400
#define LPC_RTC_ERCONTROL_INTWAKE_EN1 0x400
#define LPC_RTC_ERCONTROL_INTWAKE_EN1_BIT 10
#define LPC_RTC_ERCONTROL_GPCLEAR_EN1_MASK 0x800
#define LPC_RTC_ERCONTROL_GPCLEAR_EN1 0x800
#define LPC_RTC_ERCONTROL_GPCLEAR_EN1_BIT 11
#define LPC_RTC_ERCONTROL_POL1_MASK 0x1000
#define LPC_RTC_ERCONTROL_POL1 0x1000
#define LPC_RTC_ERCONTROL_POL1_BIT 12
#define LPC_RTC_ERCONTROL_EV1_INPUT_EN_MASK 0x2000
#define LPC_RTC_ERCONTROL_EV1_INPUT_EN 0x2000
#define LPC_RTC_ERCONTROL_EV1_INPUT_EN_BIT 13
#define LPC_RTC_ERCONTROL_INTWAKE_EN2_MASK 0x100000
#define LPC_RTC_ERCONTROL_INTWAKE_EN2 0x100000
#define LPC_RTC_ERCONTROL_INTWAKE_EN2_BIT 20
#define LPC_RTC_ERCONTROL_GPCLEAR_EN2_MASK 0x200000
#define LPC_RTC_ERCONTROL_GPCLEAR_EN2 0x200000
#define LPC_RTC_ERCONTROL_GPCLEAR_EN2_BIT 21
#define LPC_RTC_ERCONTROL_POL2_MASK 0x400000
#define LPC_RTC_ERCONTROL_POL2 0x400000
#define LPC_RTC_ERCONTROL_POL2_BIT 22
#define LPC_RTC_ERCONTROL_EV2_INPUT_EN_MASK 0x800000
#define LPC_RTC_ERCONTROL_EV2_INPUT_EN 0x800000
#define LPC_RTC_ERCONTROL_EV2_INPUT_EN_BIT 23
#define LPC_RTC_ERCONTROL_ERMODE_MASK 0xC0000000
#define LPC_RTC_ERCONTROL_ERMODE_BIT 30

#define LPC_RTC_ERSTATUS (*(volatile unsigned long *)0x40024080)
#define LPC_RTC_ERSTATUS_OFFSET 0x80
#define LPC_RTC_ERSTATUS_EV0_MASK 0x1
#define LPC_RTC_ERSTATUS_EV0 0x1
#define LPC_RTC_ERSTATUS_EV0_BIT 0
#define LPC_RTC_ERSTATUS_EV1_MASK 0x2
#define LPC_RTC_ERSTATUS_EV1 0x2
#define LPC_RTC_ERSTATUS_EV1_BIT 1
#define LPC_RTC_ERSTATUS_EV2_MASK 0x4
#define LPC_RTC_ERSTATUS_EV2 0x4
#define LPC_RTC_ERSTATUS_EV2_BIT 2
#define LPC_RTC_ERSTATUS_GP_CLEARED_MASK 0x8
#define LPC_RTC_ERSTATUS_GP_CLEARED 0x8
#define LPC_RTC_ERSTATUS_GP_CLEARED_BIT 3
#define LPC_RTC_ERSTATUS_WAKEUP_MASK 0x80000000
#define LPC_RTC_ERSTATUS_WAKEUP 0x80000000
#define LPC_RTC_ERSTATUS_WAKEUP_BIT 31

#define LPC_RTC_ERCOUNTERS (*(volatile unsigned long *)0x40024088)
#define LPC_RTC_ERCOUNTERS_OFFSET 0x88
#define LPC_RTC_ERCOUNTERS_COUNTER0_MASK 0x7
#define LPC_RTC_ERCOUNTERS_COUNTER0_BIT 0
#define LPC_RTC_ERCOUNTERS_COUNTER1_MASK 0x700
#define LPC_RTC_ERCOUNTERS_COUNTER1_BIT 8
#define LPC_RTC_ERCOUNTERS_COUNTER2_MASK 0x70000
#define LPC_RTC_ERCOUNTERS_COUNTER2_BIT 16

#define LPC_RTC_ERFIRSTSTAMP0 (*(volatile unsigned long *)0x40024090)
#define LPC_RTC_ERFIRSTSTAMP0_OFFSET 0x90
#define LPC_RTC_ERFIRSTSTAMP0_SEC_MASK 0x3F
#define LPC_RTC_ERFIRSTSTAMP0_SEC_BIT 0
#define LPC_RTC_ERFIRSTSTAMP0_MIN_MASK 0xFC0
#define LPC_RTC_ERFIRSTSTAMP0_MIN_BIT 6
#define LPC_RTC_ERFIRSTSTAMP0_HOUR_MASK 0x1F000
#define LPC_RTC_ERFIRSTSTAMP0_HOUR_BIT 12
#define LPC_RTC_ERFIRSTSTAMP0_DOY_MASK 0x3FE0000
#define LPC_RTC_ERFIRSTSTAMP0_DOY_BIT 17

#define LPC_RTC_ERFIRSTSTAMP1 (*(volatile unsigned long *)0x40024094)
#define LPC_RTC_ERFIRSTSTAMP1_OFFSET 0x94
#define LPC_RTC_ERFIRSTSTAMP1_SEC_MASK 0x3F
#define LPC_RTC_ERFIRSTSTAMP1_SEC_BIT 0
#define LPC_RTC_ERFIRSTSTAMP1_MIN_MASK 0xFC0
#define LPC_RTC_ERFIRSTSTAMP1_MIN_BIT 6
#define LPC_RTC_ERFIRSTSTAMP1_HOUR_MASK 0x1F000
#define LPC_RTC_ERFIRSTSTAMP1_HOUR_BIT 12
#define LPC_RTC_ERFIRSTSTAMP1_DOY_MASK 0x3FE0000
#define LPC_RTC_ERFIRSTSTAMP1_DOY_BIT 17

#define LPC_RTC_ERFIRSTSTAMP2 (*(volatile unsigned long *)0x40024098)
#define LPC_RTC_ERFIRSTSTAMP2_OFFSET 0x98
#define LPC_RTC_ERFIRSTSTAMP2_SEC_MASK 0x3F
#define LPC_RTC_ERFIRSTSTAMP2_SEC_BIT 0
#define LPC_RTC_ERFIRSTSTAMP2_MIN_MASK 0xFC0
#define LPC_RTC_ERFIRSTSTAMP2_MIN_BIT 6
#define LPC_RTC_ERFIRSTSTAMP2_HOUR_MASK 0x1F000
#define LPC_RTC_ERFIRSTSTAMP2_HOUR_BIT 12
#define LPC_RTC_ERFIRSTSTAMP2_DOY_MASK 0x3FE0000
#define LPC_RTC_ERFIRSTSTAMP2_DOY_BIT 17

#define LPC_RTC_ERLASTSTAMP0 (*(volatile unsigned long *)0x400240A0)
#define LPC_RTC_ERLASTSTAMP0_OFFSET 0xA0
#define LPC_RTC_ERLASTSTAMP0_SEC_MASK 0x3F
#define LPC_RTC_ERLASTSTAMP0_SEC_BIT 0
#define LPC_RTC_ERLASTSTAMP0_MIN_MASK 0xFC0
#define LPC_RTC_ERLASTSTAMP0_MIN_BIT 6
#define LPC_RTC_ERLASTSTAMP0_HOUR_MASK 0x1F000
#define LPC_RTC_ERLASTSTAMP0_HOUR_BIT 12
#define LPC_RTC_ERLASTSTAMP0_DOY_MASK 0x3FE0000
#define LPC_RTC_ERLASTSTAMP0_DOY_BIT 17

#define LPC_RTC_ERLASTSTAMP1 (*(volatile unsigned long *)0x400240A4)
#define LPC_RTC_ERLASTSTAMP1_OFFSET 0xA4
#define LPC_RTC_ERLASTSTAMP1_SEC_MASK 0x3F
#define LPC_RTC_ERLASTSTAMP1_SEC_BIT 0
#define LPC_RTC_ERLASTSTAMP1_MIN_MASK 0xFC0
#define LPC_RTC_ERLASTSTAMP1_MIN_BIT 6
#define LPC_RTC_ERLASTSTAMP1_HOUR_MASK 0x1F000
#define LPC_RTC_ERLASTSTAMP1_HOUR_BIT 12
#define LPC_RTC_ERLASTSTAMP1_DOY_MASK 0x3FE0000
#define LPC_RTC_ERLASTSTAMP1_DOY_BIT 17

#define LPC_RTC_ERLASTSTAMP2 (*(volatile unsigned long *)0x400240A8)
#define LPC_RTC_ERLASTSTAMP2_OFFSET 0xA8
#define LPC_RTC_ERLASTSTAMP2_SEC_MASK 0x3F
#define LPC_RTC_ERLASTSTAMP2_SEC_BIT 0
#define LPC_RTC_ERLASTSTAMP2_MIN_MASK 0xFC0
#define LPC_RTC_ERLASTSTAMP2_MIN_BIT 6
#define LPC_RTC_ERLASTSTAMP2_HOUR_MASK 0x1F000
#define LPC_RTC_ERLASTSTAMP2_HOUR_BIT 12
#define LPC_RTC_ERLASTSTAMP2_DOY_MASK 0x3FE0000
#define LPC_RTC_ERLASTSTAMP2_DOY_BIT 17

#ifndef LPC_GPIOINT_BASE_ADDRESS
#define LPC_GPIOINT_BASE_ADDRESS 0x40028080
#endif

#define LPC_GPIOINT_STATUS (*(volatile unsigned long *)0x40028080)
#define LPC_GPIOINT_STATUS_OFFSET 0x0
#define LPC_GPIOINT_STATUS_P0Int_MASK 0x1
#define LPC_GPIOINT_STATUS_P0Int 0x1
#define LPC_GPIOINT_STATUS_P0Int_BIT 0
#define LPC_GPIOINT_STATUS_P2Int_MASK 0x4
#define LPC_GPIOINT_STATUS_P2Int 0x4
#define LPC_GPIOINT_STATUS_P2Int_BIT 2

#define LPC_GPIOINT_STATR0 (*(volatile unsigned long *)0x40028084)
#define LPC_GPIOINT_STATR0_OFFSET 0x4
#define LPC_GPIOINT_STATR0_P0_0REI_MASK 0x1
#define LPC_GPIOINT_STATR0_P0_0REI 0x1
#define LPC_GPIOINT_STATR0_P0_0REI_BIT 0
#define LPC_GPIOINT_STATR0_P0_1REI_MASK 0x2
#define LPC_GPIOINT_STATR0_P0_1REI 0x2
#define LPC_GPIOINT_STATR0_P0_1REI_BIT 1
#define LPC_GPIOINT_STATR0_P0_2REI_MASK 0x4
#define LPC_GPIOINT_STATR0_P0_2REI 0x4
#define LPC_GPIOINT_STATR0_P0_2REI_BIT 2
#define LPC_GPIOINT_STATR0_P0_3REI_MASK 0x8
#define LPC_GPIOINT_STATR0_P0_3REI 0x8
#define LPC_GPIOINT_STATR0_P0_3REI_BIT 3
#define LPC_GPIOINT_STATR0_P0_4REI_MASK 0x10
#define LPC_GPIOINT_STATR0_P0_4REI 0x10
#define LPC_GPIOINT_STATR0_P0_4REI_BIT 4
#define LPC_GPIOINT_STATR0_P0_5REI_MASK 0x20
#define LPC_GPIOINT_STATR0_P0_5REI 0x20
#define LPC_GPIOINT_STATR0_P0_5REI_BIT 5
#define LPC_GPIOINT_STATR0_P0_6REI_MASK 0x40
#define LPC_GPIOINT_STATR0_P0_6REI 0x40
#define LPC_GPIOINT_STATR0_P0_6REI_BIT 6
#define LPC_GPIOINT_STATR0_P0_7REI_MASK 0x80
#define LPC_GPIOINT_STATR0_P0_7REI 0x80
#define LPC_GPIOINT_STATR0_P0_7REI_BIT 7
#define LPC_GPIOINT_STATR0_P0_8REI_MASK 0x100
#define LPC_GPIOINT_STATR0_P0_8REI 0x100
#define LPC_GPIOINT_STATR0_P0_8REI_BIT 8
#define LPC_GPIOINT_STATR0_P0_9REI_MASK 0x200
#define LPC_GPIOINT_STATR0_P0_9REI 0x200
#define LPC_GPIOINT_STATR0_P0_9REI_BIT 9
#define LPC_GPIOINT_STATR0_P0_10REI_MASK 0x400
#define LPC_GPIOINT_STATR0_P0_10REI 0x400
#define LPC_GPIOINT_STATR0_P0_10REI_BIT 10
#define LPC_GPIOINT_STATR0_P0_11REI_MASK 0x800
#define LPC_GPIOINT_STATR0_P0_11REI 0x800
#define LPC_GPIOINT_STATR0_P0_11REI_BIT 11
#define LPC_GPIOINT_STATR0_P0_12REI_MASK 0x1000
#define LPC_GPIOINT_STATR0_P0_12REI 0x1000
#define LPC_GPIOINT_STATR0_P0_12REI_BIT 12
#define LPC_GPIOINT_STATR0_P0_13REI_MASK 0x2000
#define LPC_GPIOINT_STATR0_P0_13REI 0x2000
#define LPC_GPIOINT_STATR0_P0_13REI_BIT 13
#define LPC_GPIOINT_STATR0_P0_14REI_MASK 0x4000
#define LPC_GPIOINT_STATR0_P0_14REI 0x4000
#define LPC_GPIOINT_STATR0_P0_14REI_BIT 14
#define LPC_GPIOINT_STATR0_P0_15REI_MASK 0x8000
#define LPC_GPIOINT_STATR0_P0_15REI 0x8000
#define LPC_GPIOINT_STATR0_P0_15REI_BIT 15
#define LPC_GPIOINT_STATR0_P0_16REI_MASK 0x10000
#define LPC_GPIOINT_STATR0_P0_16REI 0x10000
#define LPC_GPIOINT_STATR0_P0_16REI_BIT 16
#define LPC_GPIOINT_STATR0_P0_17REI_MASK 0x20000
#define LPC_GPIOINT_STATR0_P0_17REI 0x20000
#define LPC_GPIOINT_STATR0_P0_17REI_BIT 17
#define LPC_GPIOINT_STATR0_P0_18REI_MASK 0x40000
#define LPC_GPIOINT_STATR0_P0_18REI 0x40000
#define LPC_GPIOINT_STATR0_P0_18REI_BIT 18
#define LPC_GPIOINT_STATR0_P0_19REI_MASK 0x80000
#define LPC_GPIOINT_STATR0_P0_19REI 0x80000
#define LPC_GPIOINT_STATR0_P0_19REI_BIT 19
#define LPC_GPIOINT_STATR0_P0_20REI_MASK 0x100000
#define LPC_GPIOINT_STATR0_P0_20REI 0x100000
#define LPC_GPIOINT_STATR0_P0_20REI_BIT 20
#define LPC_GPIOINT_STATR0_P0_21REI_MASK 0x200000
#define LPC_GPIOINT_STATR0_P0_21REI 0x200000
#define LPC_GPIOINT_STATR0_P0_21REI_BIT 21
#define LPC_GPIOINT_STATR0_P0_22REI_MASK 0x400000
#define LPC_GPIOINT_STATR0_P0_22REI 0x400000
#define LPC_GPIOINT_STATR0_P0_22REI_BIT 22
#define LPC_GPIOINT_STATR0_P0_23REI_MASK 0x800000
#define LPC_GPIOINT_STATR0_P0_23REI 0x800000
#define LPC_GPIOINT_STATR0_P0_23REI_BIT 23
#define LPC_GPIOINT_STATR0_P0_24REI_MASK 0x1000000
#define LPC_GPIOINT_STATR0_P0_24REI 0x1000000
#define LPC_GPIOINT_STATR0_P0_24REI_BIT 24
#define LPC_GPIOINT_STATR0_P0_25REI_MASK 0x2000000
#define LPC_GPIOINT_STATR0_P0_25REI 0x2000000
#define LPC_GPIOINT_STATR0_P0_25REI_BIT 25
#define LPC_GPIOINT_STATR0_P0_26REI_MASK 0x4000000
#define LPC_GPIOINT_STATR0_P0_26REI 0x4000000
#define LPC_GPIOINT_STATR0_P0_26REI_BIT 26
#define LPC_GPIOINT_STATR0_P0_27REI_MASK 0x8000000
#define LPC_GPIOINT_STATR0_P0_27REI 0x8000000
#define LPC_GPIOINT_STATR0_P0_27REI_BIT 27
#define LPC_GPIOINT_STATR0_P0_28REI_MASK 0x10000000
#define LPC_GPIOINT_STATR0_P0_28REI 0x10000000
#define LPC_GPIOINT_STATR0_P0_28REI_BIT 28
#define LPC_GPIOINT_STATR0_P0_29REI_MASK 0x20000000
#define LPC_GPIOINT_STATR0_P0_29REI 0x20000000
#define LPC_GPIOINT_STATR0_P0_29REI_BIT 29
#define LPC_GPIOINT_STATR0_P0_30REI_MASK 0x40000000
#define LPC_GPIOINT_STATR0_P0_30REI 0x40000000
#define LPC_GPIOINT_STATR0_P0_30REI_BIT 30
#define LPC_GPIOINT_STATR0_P0_31REI_MASK 0x80000000
#define LPC_GPIOINT_STATR0_P0_31REI 0x80000000
#define LPC_GPIOINT_STATR0_P0_31REI_BIT 31

#define LPC_GPIOINT_STATF0 (*(volatile unsigned long *)0x40028088)
#define LPC_GPIOINT_STATF0_OFFSET 0x8
#define LPC_GPIOINT_STATF0_P0_0FEI_MASK 0x1
#define LPC_GPIOINT_STATF0_P0_0FEI 0x1
#define LPC_GPIOINT_STATF0_P0_0FEI_BIT 0
#define LPC_GPIOINT_STATF0_P0_1FEI_MASK 0x2
#define LPC_GPIOINT_STATF0_P0_1FEI 0x2
#define LPC_GPIOINT_STATF0_P0_1FEI_BIT 1
#define LPC_GPIOINT_STATF0_P0_2FEI_MASK 0x4
#define LPC_GPIOINT_STATF0_P0_2FEI 0x4
#define LPC_GPIOINT_STATF0_P0_2FEI_BIT 2
#define LPC_GPIOINT_STATF0_P0_3FEI_MASK 0x8
#define LPC_GPIOINT_STATF0_P0_3FEI 0x8
#define LPC_GPIOINT_STATF0_P0_3FEI_BIT 3
#define LPC_GPIOINT_STATF0_P0_4FEI_MASK 0x10
#define LPC_GPIOINT_STATF0_P0_4FEI 0x10
#define LPC_GPIOINT_STATF0_P0_4FEI_BIT 4
#define LPC_GPIOINT_STATF0_P0_5FEI_MASK 0x20
#define LPC_GPIOINT_STATF0_P0_5FEI 0x20
#define LPC_GPIOINT_STATF0_P0_5FEI_BIT 5
#define LPC_GPIOINT_STATF0_P0_6FEI_MASK 0x40
#define LPC_GPIOINT_STATF0_P0_6FEI 0x40
#define LPC_GPIOINT_STATF0_P0_6FEI_BIT 6
#define LPC_GPIOINT_STATF0_P0_7FEI_MASK 0x80
#define LPC_GPIOINT_STATF0_P0_7FEI 0x80
#define LPC_GPIOINT_STATF0_P0_7FEI_BIT 7
#define LPC_GPIOINT_STATF0_P0_8FEI_MASK 0x100
#define LPC_GPIOINT_STATF0_P0_8FEI 0x100
#define LPC_GPIOINT_STATF0_P0_8FEI_BIT 8
#define LPC_GPIOINT_STATF0_P0_9FEI_MASK 0x200
#define LPC_GPIOINT_STATF0_P0_9FEI 0x200
#define LPC_GPIOINT_STATF0_P0_9FEI_BIT 9
#define LPC_GPIOINT_STATF0_P0_10FEI_MASK 0x400
#define LPC_GPIOINT_STATF0_P0_10FEI 0x400
#define LPC_GPIOINT_STATF0_P0_10FEI_BIT 10
#define LPC_GPIOINT_STATF0_P0_11FEI_MASK 0x800
#define LPC_GPIOINT_STATF0_P0_11FEI 0x800
#define LPC_GPIOINT_STATF0_P0_11FEI_BIT 11
#define LPC_GPIOINT_STATF0_P0_12FEI_MASK 0x1000
#define LPC_GPIOINT_STATF0_P0_12FEI 0x1000
#define LPC_GPIOINT_STATF0_P0_12FEI_BIT 12
#define LPC_GPIOINT_STATF0_P0_13FEI_MASK 0x2000
#define LPC_GPIOINT_STATF0_P0_13FEI 0x2000
#define LPC_GPIOINT_STATF0_P0_13FEI_BIT 13
#define LPC_GPIOINT_STATF0_P0_14FEI_MASK 0x4000
#define LPC_GPIOINT_STATF0_P0_14FEI 0x4000
#define LPC_GPIOINT_STATF0_P0_14FEI_BIT 14
#define LPC_GPIOINT_STATF0_P0_15FEI_MASK 0x8000
#define LPC_GPIOINT_STATF0_P0_15FEI 0x8000
#define LPC_GPIOINT_STATF0_P0_15FEI_BIT 15
#define LPC_GPIOINT_STATF0_P0_16FEI_MASK 0x10000
#define LPC_GPIOINT_STATF0_P0_16FEI 0x10000
#define LPC_GPIOINT_STATF0_P0_16FEI_BIT 16
#define LPC_GPIOINT_STATF0_P0_17FEI_MASK 0x20000
#define LPC_GPIOINT_STATF0_P0_17FEI 0x20000
#define LPC_GPIOINT_STATF0_P0_17FEI_BIT 17
#define LPC_GPIOINT_STATF0_P0_18FEI_MASK 0x40000
#define LPC_GPIOINT_STATF0_P0_18FEI 0x40000
#define LPC_GPIOINT_STATF0_P0_18FEI_BIT 18
#define LPC_GPIOINT_STATF0_P0_19FEI_MASK 0x80000
#define LPC_GPIOINT_STATF0_P0_19FEI 0x80000
#define LPC_GPIOINT_STATF0_P0_19FEI_BIT 19
#define LPC_GPIOINT_STATF0_P0_20FEI_MASK 0x100000
#define LPC_GPIOINT_STATF0_P0_20FEI 0x100000
#define LPC_GPIOINT_STATF0_P0_20FEI_BIT 20
#define LPC_GPIOINT_STATF0_P0_21FEI_MASK 0x200000
#define LPC_GPIOINT_STATF0_P0_21FEI 0x200000
#define LPC_GPIOINT_STATF0_P0_21FEI_BIT 21
#define LPC_GPIOINT_STATF0_P0_22FEI_MASK 0x400000
#define LPC_GPIOINT_STATF0_P0_22FEI 0x400000
#define LPC_GPIOINT_STATF0_P0_22FEI_BIT 22
#define LPC_GPIOINT_STATF0_P0_23FEI_MASK 0x800000
#define LPC_GPIOINT_STATF0_P0_23FEI 0x800000
#define LPC_GPIOINT_STATF0_P0_23FEI_BIT 23
#define LPC_GPIOINT_STATF0_P0_24FEI_MASK 0x1000000
#define LPC_GPIOINT_STATF0_P0_24FEI 0x1000000
#define LPC_GPIOINT_STATF0_P0_24FEI_BIT 24
#define LPC_GPIOINT_STATF0_P0_25FEI_MASK 0x2000000
#define LPC_GPIOINT_STATF0_P0_25FEI 0x2000000
#define LPC_GPIOINT_STATF0_P0_25FEI_BIT 25
#define LPC_GPIOINT_STATF0_P0_26FEI_MASK 0x4000000
#define LPC_GPIOINT_STATF0_P0_26FEI 0x4000000
#define LPC_GPIOINT_STATF0_P0_26FEI_BIT 26
#define LPC_GPIOINT_STATF0_P0_27FEI_MASK 0x8000000
#define LPC_GPIOINT_STATF0_P0_27FEI 0x8000000
#define LPC_GPIOINT_STATF0_P0_27FEI_BIT 27
#define LPC_GPIOINT_STATF0_P0_28FEI_MASK 0x10000000
#define LPC_GPIOINT_STATF0_P0_28FEI 0x10000000
#define LPC_GPIOINT_STATF0_P0_28FEI_BIT 28
#define LPC_GPIOINT_STATF0_P0_29FEI_MASK 0x20000000
#define LPC_GPIOINT_STATF0_P0_29FEI 0x20000000
#define LPC_GPIOINT_STATF0_P0_29FEI_BIT 29
#define LPC_GPIOINT_STATF0_P0_30FEI_MASK 0x40000000
#define LPC_GPIOINT_STATF0_P0_30FEI 0x40000000
#define LPC_GPIOINT_STATF0_P0_30FEI_BIT 30
#define LPC_GPIOINT_STATF0_P0_31FEI_MASK 0x80000000
#define LPC_GPIOINT_STATF0_P0_31FEI 0x80000000
#define LPC_GPIOINT_STATF0_P0_31FEI_BIT 31

#define LPC_GPIOINT_CLR0 (*(volatile unsigned long *)0x4002808C)
#define LPC_GPIOINT_CLR0_OFFSET 0xC
#define LPC_GPIOINT_CLR0_P0_0CI_MASK 0x1
#define LPC_GPIOINT_CLR0_P0_0CI 0x1
#define LPC_GPIOINT_CLR0_P0_0CI_BIT 0
#define LPC_GPIOINT_CLR0_P0_1CI_MASK 0x2
#define LPC_GPIOINT_CLR0_P0_1CI 0x2
#define LPC_GPIOINT_CLR0_P0_1CI_BIT 1
#define LPC_GPIOINT_CLR0_P0_2CI_MASK 0x4
#define LPC_GPIOINT_CLR0_P0_2CI 0x4
#define LPC_GPIOINT_CLR0_P0_2CI_BIT 2
#define LPC_GPIOINT_CLR0_P0_3CI_MASK 0x8
#define LPC_GPIOINT_CLR0_P0_3CI 0x8
#define LPC_GPIOINT_CLR0_P0_3CI_BIT 3
#define LPC_GPIOINT_CLR0_P0_4CI_MASK 0x10
#define LPC_GPIOINT_CLR0_P0_4CI 0x10
#define LPC_GPIOINT_CLR0_P0_4CI_BIT 4
#define LPC_GPIOINT_CLR0_P0_5CI_MASK 0x20
#define LPC_GPIOINT_CLR0_P0_5CI 0x20
#define LPC_GPIOINT_CLR0_P0_5CI_BIT 5
#define LPC_GPIOINT_CLR0_P0_6CI_MASK 0x40
#define LPC_GPIOINT_CLR0_P0_6CI 0x40
#define LPC_GPIOINT_CLR0_P0_6CI_BIT 6
#define LPC_GPIOINT_CLR0_P0_7CI_MASK 0x80
#define LPC_GPIOINT_CLR0_P0_7CI 0x80
#define LPC_GPIOINT_CLR0_P0_7CI_BIT 7
#define LPC_GPIOINT_CLR0_P0_8CI_MASK 0x100
#define LPC_GPIOINT_CLR0_P0_8CI 0x100
#define LPC_GPIOINT_CLR0_P0_8CI_BIT 8
#define LPC_GPIOINT_CLR0_P0_9CI_MASK 0x200
#define LPC_GPIOINT_CLR0_P0_9CI 0x200
#define LPC_GPIOINT_CLR0_P0_9CI_BIT 9
#define LPC_GPIOINT_CLR0_P0_10CI_MASK 0x400
#define LPC_GPIOINT_CLR0_P0_10CI 0x400
#define LPC_GPIOINT_CLR0_P0_10CI_BIT 10
#define LPC_GPIOINT_CLR0_P0_11CI_MASK 0x800
#define LPC_GPIOINT_CLR0_P0_11CI 0x800
#define LPC_GPIOINT_CLR0_P0_11CI_BIT 11
#define LPC_GPIOINT_CLR0_P0_12CI_MASK 0x1000
#define LPC_GPIOINT_CLR0_P0_12CI 0x1000
#define LPC_GPIOINT_CLR0_P0_12CI_BIT 12
#define LPC_GPIOINT_CLR0_P0_13CI_MASK 0x2000
#define LPC_GPIOINT_CLR0_P0_13CI 0x2000
#define LPC_GPIOINT_CLR0_P0_13CI_BIT 13
#define LPC_GPIOINT_CLR0_P0_14CI_MASK 0x4000
#define LPC_GPIOINT_CLR0_P0_14CI 0x4000
#define LPC_GPIOINT_CLR0_P0_14CI_BIT 14
#define LPC_GPIOINT_CLR0_P0_15CI_MASK 0x8000
#define LPC_GPIOINT_CLR0_P0_15CI 0x8000
#define LPC_GPIOINT_CLR0_P0_15CI_BIT 15
#define LPC_GPIOINT_CLR0_P0_16CI_MASK 0x10000
#define LPC_GPIOINT_CLR0_P0_16CI 0x10000
#define LPC_GPIOINT_CLR0_P0_16CI_BIT 16
#define LPC_GPIOINT_CLR0_P0_17CI_MASK 0x20000
#define LPC_GPIOINT_CLR0_P0_17CI 0x20000
#define LPC_GPIOINT_CLR0_P0_17CI_BIT 17
#define LPC_GPIOINT_CLR0_P0_18CI_MASK 0x40000
#define LPC_GPIOINT_CLR0_P0_18CI 0x40000
#define LPC_GPIOINT_CLR0_P0_18CI_BIT 18
#define LPC_GPIOINT_CLR0_P0_19CI_MASK 0x80000
#define LPC_GPIOINT_CLR0_P0_19CI 0x80000
#define LPC_GPIOINT_CLR0_P0_19CI_BIT 19
#define LPC_GPIOINT_CLR0_P0_20CI_MASK 0x100000
#define LPC_GPIOINT_CLR0_P0_20CI 0x100000
#define LPC_GPIOINT_CLR0_P0_20CI_BIT 20
#define LPC_GPIOINT_CLR0_P0_21CI_MASK 0x200000
#define LPC_GPIOINT_CLR0_P0_21CI 0x200000
#define LPC_GPIOINT_CLR0_P0_21CI_BIT 21
#define LPC_GPIOINT_CLR0_P0_22CI_MASK 0x400000
#define LPC_GPIOINT_CLR0_P0_22CI 0x400000
#define LPC_GPIOINT_CLR0_P0_22CI_BIT 22
#define LPC_GPIOINT_CLR0_P0_23CI_MASK 0x800000
#define LPC_GPIOINT_CLR0_P0_23CI 0x800000
#define LPC_GPIOINT_CLR0_P0_23CI_BIT 23
#define LPC_GPIOINT_CLR0_P0_24CI_MASK 0x1000000
#define LPC_GPIOINT_CLR0_P0_24CI 0x1000000
#define LPC_GPIOINT_CLR0_P0_24CI_BIT 24
#define LPC_GPIOINT_CLR0_P0_25CI_MASK 0x2000000
#define LPC_GPIOINT_CLR0_P0_25CI 0x2000000
#define LPC_GPIOINT_CLR0_P0_25CI_BIT 25
#define LPC_GPIOINT_CLR0_P0_26CI_MASK 0x4000000
#define LPC_GPIOINT_CLR0_P0_26CI 0x4000000
#define LPC_GPIOINT_CLR0_P0_26CI_BIT 26
#define LPC_GPIOINT_CLR0_P0_27CI_MASK 0x8000000
#define LPC_GPIOINT_CLR0_P0_27CI 0x8000000
#define LPC_GPIOINT_CLR0_P0_27CI_BIT 27
#define LPC_GPIOINT_CLR0_P0_28CI_MASK 0x10000000
#define LPC_GPIOINT_CLR0_P0_28CI 0x10000000
#define LPC_GPIOINT_CLR0_P0_28CI_BIT 28
#define LPC_GPIOINT_CLR0_P0_29CI_MASK 0x20000000
#define LPC_GPIOINT_CLR0_P0_29CI 0x20000000
#define LPC_GPIOINT_CLR0_P0_29CI_BIT 29
#define LPC_GPIOINT_CLR0_P0_30CI_MASK 0x40000000
#define LPC_GPIOINT_CLR0_P0_30CI 0x40000000
#define LPC_GPIOINT_CLR0_P0_30CI_BIT 30
#define LPC_GPIOINT_CLR0_P0_31CI_MASK 0x80000000
#define LPC_GPIOINT_CLR0_P0_31CI 0x80000000
#define LPC_GPIOINT_CLR0_P0_31CI_BIT 31

#define LPC_GPIOINT_ENR0 (*(volatile unsigned long *)0x40028090)
#define LPC_GPIOINT_ENR0_OFFSET 0x10
#define LPC_GPIOINT_ENR0_P0_0ER_MASK 0x1
#define LPC_GPIOINT_ENR0_P0_0ER 0x1
#define LPC_GPIOINT_ENR0_P0_0ER_BIT 0
#define LPC_GPIOINT_ENR0_P0_1ER_MASK 0x2
#define LPC_GPIOINT_ENR0_P0_1ER 0x2
#define LPC_GPIOINT_ENR0_P0_1ER_BIT 1
#define LPC_GPIOINT_ENR0_P0_2ER_MASK 0x4
#define LPC_GPIOINT_ENR0_P0_2ER 0x4
#define LPC_GPIOINT_ENR0_P0_2ER_BIT 2
#define LPC_GPIOINT_ENR0_P0_3ER_MASK 0x8
#define LPC_GPIOINT_ENR0_P0_3ER 0x8
#define LPC_GPIOINT_ENR0_P0_3ER_BIT 3
#define LPC_GPIOINT_ENR0_P0_4ER_MASK 0x10
#define LPC_GPIOINT_ENR0_P0_4ER 0x10
#define LPC_GPIOINT_ENR0_P0_4ER_BIT 4
#define LPC_GPIOINT_ENR0_P0_5ER_MASK 0x20
#define LPC_GPIOINT_ENR0_P0_5ER 0x20
#define LPC_GPIOINT_ENR0_P0_5ER_BIT 5
#define LPC_GPIOINT_ENR0_P0_6ER_MASK 0x40
#define LPC_GPIOINT_ENR0_P0_6ER 0x40
#define LPC_GPIOINT_ENR0_P0_6ER_BIT 6
#define LPC_GPIOINT_ENR0_P0_7ER_MASK 0x80
#define LPC_GPIOINT_ENR0_P0_7ER 0x80
#define LPC_GPIOINT_ENR0_P0_7ER_BIT 7
#define LPC_GPIOINT_ENR0_P0_8ER_MASK 0x100
#define LPC_GPIOINT_ENR0_P0_8ER 0x100
#define LPC_GPIOINT_ENR0_P0_8ER_BIT 8
#define LPC_GPIOINT_ENR0_P0_9ER_MASK 0x200
#define LPC_GPIOINT_ENR0_P0_9ER 0x200
#define LPC_GPIOINT_ENR0_P0_9ER_BIT 9
#define LPC_GPIOINT_ENR0_P0_10ER_MASK 0x400
#define LPC_GPIOINT_ENR0_P0_10ER 0x400
#define LPC_GPIOINT_ENR0_P0_10ER_BIT 10
#define LPC_GPIOINT_ENR0_P0_11ER_MASK 0x800
#define LPC_GPIOINT_ENR0_P0_11ER 0x800
#define LPC_GPIOINT_ENR0_P0_11ER_BIT 11
#define LPC_GPIOINT_ENR0_P0_12ER_MASK 0x1000
#define LPC_GPIOINT_ENR0_P0_12ER 0x1000
#define LPC_GPIOINT_ENR0_P0_12ER_BIT 12
#define LPC_GPIOINT_ENR0_P0_13ER_MASK 0x2000
#define LPC_GPIOINT_ENR0_P0_13ER 0x2000
#define LPC_GPIOINT_ENR0_P0_13ER_BIT 13
#define LPC_GPIOINT_ENR0_P0_14ER_MASK 0x4000
#define LPC_GPIOINT_ENR0_P0_14ER 0x4000
#define LPC_GPIOINT_ENR0_P0_14ER_BIT 14
#define LPC_GPIOINT_ENR0_P0_15ER_MASK 0x8000
#define LPC_GPIOINT_ENR0_P0_15ER 0x8000
#define LPC_GPIOINT_ENR0_P0_15ER_BIT 15
#define LPC_GPIOINT_ENR0_P0_16ER_MASK 0x10000
#define LPC_GPIOINT_ENR0_P0_16ER 0x10000
#define LPC_GPIOINT_ENR0_P0_16ER_BIT 16
#define LPC_GPIOINT_ENR0_P0_17ER_MASK 0x20000
#define LPC_GPIOINT_ENR0_P0_17ER 0x20000
#define LPC_GPIOINT_ENR0_P0_17ER_BIT 17
#define LPC_GPIOINT_ENR0_P0_18ER_MASK 0x40000
#define LPC_GPIOINT_ENR0_P0_18ER 0x40000
#define LPC_GPIOINT_ENR0_P0_18ER_BIT 18
#define LPC_GPIOINT_ENR0_P0_19ER_MASK 0x80000
#define LPC_GPIOINT_ENR0_P0_19ER 0x80000
#define LPC_GPIOINT_ENR0_P0_19ER_BIT 19
#define LPC_GPIOINT_ENR0_P0_20ER_MASK 0x100000
#define LPC_GPIOINT_ENR0_P0_20ER 0x100000
#define LPC_GPIOINT_ENR0_P0_20ER_BIT 20
#define LPC_GPIOINT_ENR0_P0_21ER_MASK 0x200000
#define LPC_GPIOINT_ENR0_P0_21ER 0x200000
#define LPC_GPIOINT_ENR0_P0_21ER_BIT 21
#define LPC_GPIOINT_ENR0_P0_22ER_MASK 0x400000
#define LPC_GPIOINT_ENR0_P0_22ER 0x400000
#define LPC_GPIOINT_ENR0_P0_22ER_BIT 22
#define LPC_GPIOINT_ENR0_P0_23ER_MASK 0x800000
#define LPC_GPIOINT_ENR0_P0_23ER 0x800000
#define LPC_GPIOINT_ENR0_P0_23ER_BIT 23
#define LPC_GPIOINT_ENR0_P0_24ER_MASK 0x1000000
#define LPC_GPIOINT_ENR0_P0_24ER 0x1000000
#define LPC_GPIOINT_ENR0_P0_24ER_BIT 24
#define LPC_GPIOINT_ENR0_P0_25ER_MASK 0x2000000
#define LPC_GPIOINT_ENR0_P0_25ER 0x2000000
#define LPC_GPIOINT_ENR0_P0_25ER_BIT 25
#define LPC_GPIOINT_ENR0_P0_26ER_MASK 0x4000000
#define LPC_GPIOINT_ENR0_P0_26ER 0x4000000
#define LPC_GPIOINT_ENR0_P0_26ER_BIT 26
#define LPC_GPIOINT_ENR0_P0_27ER_MASK 0x8000000
#define LPC_GPIOINT_ENR0_P0_27ER 0x8000000
#define LPC_GPIOINT_ENR0_P0_27ER_BIT 27
#define LPC_GPIOINT_ENR0_P0_28ER_MASK 0x10000000
#define LPC_GPIOINT_ENR0_P0_28ER 0x10000000
#define LPC_GPIOINT_ENR0_P0_28ER_BIT 28
#define LPC_GPIOINT_ENR0_P0_29ER_MASK 0x20000000
#define LPC_GPIOINT_ENR0_P0_29ER 0x20000000
#define LPC_GPIOINT_ENR0_P0_29ER_BIT 29
#define LPC_GPIOINT_ENR0_P0_30ER_MASK 0x40000000
#define LPC_GPIOINT_ENR0_P0_30ER 0x40000000
#define LPC_GPIOINT_ENR0_P0_30ER_BIT 30
#define LPC_GPIOINT_ENR0_P0_31ER_MASK 0x80000000
#define LPC_GPIOINT_ENR0_P0_31ER 0x80000000
#define LPC_GPIOINT_ENR0_P0_31ER_BIT 31

#define LPC_GPIOINT_ENF0 (*(volatile unsigned long *)0x40028094)
#define LPC_GPIOINT_ENF0_OFFSET 0x14
#define LPC_GPIOINT_ENF0_P0_0EF_MASK 0x1
#define LPC_GPIOINT_ENF0_P0_0EF 0x1
#define LPC_GPIOINT_ENF0_P0_0EF_BIT 0
#define LPC_GPIOINT_ENF0_P0_1EF_MASK 0x2
#define LPC_GPIOINT_ENF0_P0_1EF 0x2
#define LPC_GPIOINT_ENF0_P0_1EF_BIT 1
#define LPC_GPIOINT_ENF0_P0_2EF_MASK 0x4
#define LPC_GPIOINT_ENF0_P0_2EF 0x4
#define LPC_GPIOINT_ENF0_P0_2EF_BIT 2
#define LPC_GPIOINT_ENF0_P0_3EF_MASK 0x8
#define LPC_GPIOINT_ENF0_P0_3EF 0x8
#define LPC_GPIOINT_ENF0_P0_3EF_BIT 3
#define LPC_GPIOINT_ENF0_P0_4EF_MASK 0x10
#define LPC_GPIOINT_ENF0_P0_4EF 0x10
#define LPC_GPIOINT_ENF0_P0_4EF_BIT 4
#define LPC_GPIOINT_ENF0_P0_5EF_MASK 0x20
#define LPC_GPIOINT_ENF0_P0_5EF 0x20
#define LPC_GPIOINT_ENF0_P0_5EF_BIT 5
#define LPC_GPIOINT_ENF0_P0_6EF_MASK 0x40
#define LPC_GPIOINT_ENF0_P0_6EF 0x40
#define LPC_GPIOINT_ENF0_P0_6EF_BIT 6
#define LPC_GPIOINT_ENF0_P0_7EF_MASK 0x80
#define LPC_GPIOINT_ENF0_P0_7EF 0x80
#define LPC_GPIOINT_ENF0_P0_7EF_BIT 7
#define LPC_GPIOINT_ENF0_P0_8EF_MASK 0x100
#define LPC_GPIOINT_ENF0_P0_8EF 0x100
#define LPC_GPIOINT_ENF0_P0_8EF_BIT 8
#define LPC_GPIOINT_ENF0_P0_9EF_MASK 0x200
#define LPC_GPIOINT_ENF0_P0_9EF 0x200
#define LPC_GPIOINT_ENF0_P0_9EF_BIT 9
#define LPC_GPIOINT_ENF0_P0_10EF_MASK 0x400
#define LPC_GPIOINT_ENF0_P0_10EF 0x400
#define LPC_GPIOINT_ENF0_P0_10EF_BIT 10
#define LPC_GPIOINT_ENF0_P0_11EF_MASK 0x800
#define LPC_GPIOINT_ENF0_P0_11EF 0x800
#define LPC_GPIOINT_ENF0_P0_11EF_BIT 11
#define LPC_GPIOINT_ENF0_P0_12EF_MASK 0x1000
#define LPC_GPIOINT_ENF0_P0_12EF 0x1000
#define LPC_GPIOINT_ENF0_P0_12EF_BIT 12
#define LPC_GPIOINT_ENF0_P0_13EF_MASK 0x2000
#define LPC_GPIOINT_ENF0_P0_13EF 0x2000
#define LPC_GPIOINT_ENF0_P0_13EF_BIT 13
#define LPC_GPIOINT_ENF0_P0_14EF_MASK 0x4000
#define LPC_GPIOINT_ENF0_P0_14EF 0x4000
#define LPC_GPIOINT_ENF0_P0_14EF_BIT 14
#define LPC_GPIOINT_ENF0_P0_15EF_MASK 0x8000
#define LPC_GPIOINT_ENF0_P0_15EF 0x8000
#define LPC_GPIOINT_ENF0_P0_15EF_BIT 15
#define LPC_GPIOINT_ENF0_P0_16EF_MASK 0x10000
#define LPC_GPIOINT_ENF0_P0_16EF 0x10000
#define LPC_GPIOINT_ENF0_P0_16EF_BIT 16
#define LPC_GPIOINT_ENF0_P0_17EF_MASK 0x20000
#define LPC_GPIOINT_ENF0_P0_17EF 0x20000
#define LPC_GPIOINT_ENF0_P0_17EF_BIT 17
#define LPC_GPIOINT_ENF0_P0_18EF_MASK 0x40000
#define LPC_GPIOINT_ENF0_P0_18EF 0x40000
#define LPC_GPIOINT_ENF0_P0_18EF_BIT 18
#define LPC_GPIOINT_ENF0_P0_19EF_MASK 0x80000
#define LPC_GPIOINT_ENF0_P0_19EF 0x80000
#define LPC_GPIOINT_ENF0_P0_19EF_BIT 19
#define LPC_GPIOINT_ENF0_P0_20EF_MASK 0x100000
#define LPC_GPIOINT_ENF0_P0_20EF 0x100000
#define LPC_GPIOINT_ENF0_P0_20EF_BIT 20
#define LPC_GPIOINT_ENF0_P0_21EF_MASK 0x200000
#define LPC_GPIOINT_ENF0_P0_21EF 0x200000
#define LPC_GPIOINT_ENF0_P0_21EF_BIT 21
#define LPC_GPIOINT_ENF0_P0_22EF_MASK 0x400000
#define LPC_GPIOINT_ENF0_P0_22EF 0x400000
#define LPC_GPIOINT_ENF0_P0_22EF_BIT 22
#define LPC_GPIOINT_ENF0_P0_23EF_MASK 0x800000
#define LPC_GPIOINT_ENF0_P0_23EF 0x800000
#define LPC_GPIOINT_ENF0_P0_23EF_BIT 23
#define LPC_GPIOINT_ENF0_P0_24EF_MASK 0x1000000
#define LPC_GPIOINT_ENF0_P0_24EF 0x1000000
#define LPC_GPIOINT_ENF0_P0_24EF_BIT 24
#define LPC_GPIOINT_ENF0_P0_25EF_MASK 0x2000000
#define LPC_GPIOINT_ENF0_P0_25EF 0x2000000
#define LPC_GPIOINT_ENF0_P0_25EF_BIT 25
#define LPC_GPIOINT_ENF0_P0_26EF_MASK 0x4000000
#define LPC_GPIOINT_ENF0_P0_26EF 0x4000000
#define LPC_GPIOINT_ENF0_P0_26EF_BIT 26
#define LPC_GPIOINT_ENF0_P0_27EF_MASK 0x8000000
#define LPC_GPIOINT_ENF0_P0_27EF 0x8000000
#define LPC_GPIOINT_ENF0_P0_27EF_BIT 27
#define LPC_GPIOINT_ENF0_P0_28EF_MASK 0x10000000
#define LPC_GPIOINT_ENF0_P0_28EF 0x10000000
#define LPC_GPIOINT_ENF0_P0_28EF_BIT 28
#define LPC_GPIOINT_ENF0_P0_29EF_MASK 0x20000000
#define LPC_GPIOINT_ENF0_P0_29EF 0x20000000
#define LPC_GPIOINT_ENF0_P0_29EF_BIT 29
#define LPC_GPIOINT_ENF0_P0_30EF_MASK 0x40000000
#define LPC_GPIOINT_ENF0_P0_30EF 0x40000000
#define LPC_GPIOINT_ENF0_P0_30EF_BIT 30
#define LPC_GPIOINT_ENF0_P0_31EF_MASK 0x80000000
#define LPC_GPIOINT_ENF0_P0_31EF 0x80000000
#define LPC_GPIOINT_ENF0_P0_31EF_BIT 31

#define LPC_GPIOINT_STATR2 (*(volatile unsigned long *)0x400280A4)
#define LPC_GPIOINT_STATR2_OFFSET 0x24
#define LPC_GPIOINT_STATR2_P2_0REI_MASK 0x1
#define LPC_GPIOINT_STATR2_P2_0REI 0x1
#define LPC_GPIOINT_STATR2_P2_0REI_BIT 0
#define LPC_GPIOINT_STATR2_P2_1REI_MASK 0x2
#define LPC_GPIOINT_STATR2_P2_1REI 0x2
#define LPC_GPIOINT_STATR2_P2_1REI_BIT 1
#define LPC_GPIOINT_STATR2_P2_2REI_MASK 0x4
#define LPC_GPIOINT_STATR2_P2_2REI 0x4
#define LPC_GPIOINT_STATR2_P2_2REI_BIT 2
#define LPC_GPIOINT_STATR2_P2_3REI_MASK 0x8
#define LPC_GPIOINT_STATR2_P2_3REI 0x8
#define LPC_GPIOINT_STATR2_P2_3REI_BIT 3
#define LPC_GPIOINT_STATR2_P2_4REI_MASK 0x10
#define LPC_GPIOINT_STATR2_P2_4REI 0x10
#define LPC_GPIOINT_STATR2_P2_4REI_BIT 4
#define LPC_GPIOINT_STATR2_P2_5REI_MASK 0x20
#define LPC_GPIOINT_STATR2_P2_5REI 0x20
#define LPC_GPIOINT_STATR2_P2_5REI_BIT 5
#define LPC_GPIOINT_STATR2_P2_6REI_MASK 0x40
#define LPC_GPIOINT_STATR2_P2_6REI 0x40
#define LPC_GPIOINT_STATR2_P2_6REI_BIT 6
#define LPC_GPIOINT_STATR2_P2_7REI_MASK 0x80
#define LPC_GPIOINT_STATR2_P2_7REI 0x80
#define LPC_GPIOINT_STATR2_P2_7REI_BIT 7
#define LPC_GPIOINT_STATR2_P2_8REI_MASK 0x100
#define LPC_GPIOINT_STATR2_P2_8REI 0x100
#define LPC_GPIOINT_STATR2_P2_8REI_BIT 8
#define LPC_GPIOINT_STATR2_P2_9REI_MASK 0x200
#define LPC_GPIOINT_STATR2_P2_9REI 0x200
#define LPC_GPIOINT_STATR2_P2_9REI_BIT 9
#define LPC_GPIOINT_STATR2_P2_10REI_MASK 0x400
#define LPC_GPIOINT_STATR2_P2_10REI 0x400
#define LPC_GPIOINT_STATR2_P2_10REI_BIT 10
#define LPC_GPIOINT_STATR2_P2_11REI_MASK 0x800
#define LPC_GPIOINT_STATR2_P2_11REI 0x800
#define LPC_GPIOINT_STATR2_P2_11REI_BIT 11
#define LPC_GPIOINT_STATR2_P2_12REI_MASK 0x1000
#define LPC_GPIOINT_STATR2_P2_12REI 0x1000
#define LPC_GPIOINT_STATR2_P2_12REI_BIT 12
#define LPC_GPIOINT_STATR2_P2_13REI_MASK 0x2000
#define LPC_GPIOINT_STATR2_P2_13REI 0x2000
#define LPC_GPIOINT_STATR2_P2_13REI_BIT 13
#define LPC_GPIOINT_STATR2_P2_14REI_MASK 0x4000
#define LPC_GPIOINT_STATR2_P2_14REI 0x4000
#define LPC_GPIOINT_STATR2_P2_14REI_BIT 14
#define LPC_GPIOINT_STATR2_P2_15REI_MASK 0x8000
#define LPC_GPIOINT_STATR2_P2_15REI 0x8000
#define LPC_GPIOINT_STATR2_P2_15REI_BIT 15
#define LPC_GPIOINT_STATR2_P2_16REI_MASK 0x10000
#define LPC_GPIOINT_STATR2_P2_16REI 0x10000
#define LPC_GPIOINT_STATR2_P2_16REI_BIT 16
#define LPC_GPIOINT_STATR2_P2_17REI_MASK 0x20000
#define LPC_GPIOINT_STATR2_P2_17REI 0x20000
#define LPC_GPIOINT_STATR2_P2_17REI_BIT 17
#define LPC_GPIOINT_STATR2_P2_18REI_MASK 0x40000
#define LPC_GPIOINT_STATR2_P2_18REI 0x40000
#define LPC_GPIOINT_STATR2_P2_18REI_BIT 18
#define LPC_GPIOINT_STATR2_P2_19REI_MASK 0x80000
#define LPC_GPIOINT_STATR2_P2_19REI 0x80000
#define LPC_GPIOINT_STATR2_P2_19REI_BIT 19
#define LPC_GPIOINT_STATR2_P2_20REI_MASK 0x100000
#define LPC_GPIOINT_STATR2_P2_20REI 0x100000
#define LPC_GPIOINT_STATR2_P2_20REI_BIT 20
#define LPC_GPIOINT_STATR2_P2_21REI_MASK 0x200000
#define LPC_GPIOINT_STATR2_P2_21REI 0x200000
#define LPC_GPIOINT_STATR2_P2_21REI_BIT 21
#define LPC_GPIOINT_STATR2_P2_22REI_MASK 0x400000
#define LPC_GPIOINT_STATR2_P2_22REI 0x400000
#define LPC_GPIOINT_STATR2_P2_22REI_BIT 22
#define LPC_GPIOINT_STATR2_P2_23REI_MASK 0x800000
#define LPC_GPIOINT_STATR2_P2_23REI 0x800000
#define LPC_GPIOINT_STATR2_P2_23REI_BIT 23
#define LPC_GPIOINT_STATR2_P2_24REI_MASK 0x1000000
#define LPC_GPIOINT_STATR2_P2_24REI 0x1000000
#define LPC_GPIOINT_STATR2_P2_24REI_BIT 24
#define LPC_GPIOINT_STATR2_P2_25REI_MASK 0x2000000
#define LPC_GPIOINT_STATR2_P2_25REI 0x2000000
#define LPC_GPIOINT_STATR2_P2_25REI_BIT 25
#define LPC_GPIOINT_STATR2_P2_26REI_MASK 0x4000000
#define LPC_GPIOINT_STATR2_P2_26REI 0x4000000
#define LPC_GPIOINT_STATR2_P2_26REI_BIT 26
#define LPC_GPIOINT_STATR2_P2_27REI_MASK 0x8000000
#define LPC_GPIOINT_STATR2_P2_27REI 0x8000000
#define LPC_GPIOINT_STATR2_P2_27REI_BIT 27
#define LPC_GPIOINT_STATR2_P2_28REI_MASK 0x10000000
#define LPC_GPIOINT_STATR2_P2_28REI 0x10000000
#define LPC_GPIOINT_STATR2_P2_28REI_BIT 28
#define LPC_GPIOINT_STATR2_P2_29REI_MASK 0x20000000
#define LPC_GPIOINT_STATR2_P2_29REI 0x20000000
#define LPC_GPIOINT_STATR2_P2_29REI_BIT 29
#define LPC_GPIOINT_STATR2_P2_30REI_MASK 0x40000000
#define LPC_GPIOINT_STATR2_P2_30REI 0x40000000
#define LPC_GPIOINT_STATR2_P2_30REI_BIT 30
#define LPC_GPIOINT_STATR2_P2_31REI_MASK 0x80000000
#define LPC_GPIOINT_STATR2_P2_31REI 0x80000000
#define LPC_GPIOINT_STATR2_P2_31REI_BIT 31

#define LPC_GPIOINT_STATF2 (*(volatile unsigned long *)0x400280A8)
#define LPC_GPIOINT_STATF2_OFFSET 0x28
#define LPC_GPIOINT_STATF2_P2_0FEI_MASK 0x1
#define LPC_GPIOINT_STATF2_P2_0FEI 0x1
#define LPC_GPIOINT_STATF2_P2_0FEI_BIT 0
#define LPC_GPIOINT_STATF2_P2_1FEI_MASK 0x2
#define LPC_GPIOINT_STATF2_P2_1FEI 0x2
#define LPC_GPIOINT_STATF2_P2_1FEI_BIT 1
#define LPC_GPIOINT_STATF2_P2_2FEI_MASK 0x4
#define LPC_GPIOINT_STATF2_P2_2FEI 0x4
#define LPC_GPIOINT_STATF2_P2_2FEI_BIT 2
#define LPC_GPIOINT_STATF2_P2_3FEI_MASK 0x8
#define LPC_GPIOINT_STATF2_P2_3FEI 0x8
#define LPC_GPIOINT_STATF2_P2_3FEI_BIT 3
#define LPC_GPIOINT_STATF2_P2_4FEI_MASK 0x10
#define LPC_GPIOINT_STATF2_P2_4FEI 0x10
#define LPC_GPIOINT_STATF2_P2_4FEI_BIT 4
#define LPC_GPIOINT_STATF2_P2_5FEI_MASK 0x20
#define LPC_GPIOINT_STATF2_P2_5FEI 0x20
#define LPC_GPIOINT_STATF2_P2_5FEI_BIT 5
#define LPC_GPIOINT_STATF2_P2_6FEI_MASK 0x40
#define LPC_GPIOINT_STATF2_P2_6FEI 0x40
#define LPC_GPIOINT_STATF2_P2_6FEI_BIT 6
#define LPC_GPIOINT_STATF2_P2_7FEI_MASK 0x80
#define LPC_GPIOINT_STATF2_P2_7FEI 0x80
#define LPC_GPIOINT_STATF2_P2_7FEI_BIT 7
#define LPC_GPIOINT_STATF2_P2_8FEI_MASK 0x100
#define LPC_GPIOINT_STATF2_P2_8FEI 0x100
#define LPC_GPIOINT_STATF2_P2_8FEI_BIT 8
#define LPC_GPIOINT_STATF2_P2_9FEI_MASK 0x200
#define LPC_GPIOINT_STATF2_P2_9FEI 0x200
#define LPC_GPIOINT_STATF2_P2_9FEI_BIT 9
#define LPC_GPIOINT_STATF2_P2_10FEI_MASK 0x400
#define LPC_GPIOINT_STATF2_P2_10FEI 0x400
#define LPC_GPIOINT_STATF2_P2_10FEI_BIT 10
#define LPC_GPIOINT_STATF2_P2_11FEI_MASK 0x800
#define LPC_GPIOINT_STATF2_P2_11FEI 0x800
#define LPC_GPIOINT_STATF2_P2_11FEI_BIT 11
#define LPC_GPIOINT_STATF2_P2_12FEI_MASK 0x1000
#define LPC_GPIOINT_STATF2_P2_12FEI 0x1000
#define LPC_GPIOINT_STATF2_P2_12FEI_BIT 12
#define LPC_GPIOINT_STATF2_P2_13FEI_MASK 0x2000
#define LPC_GPIOINT_STATF2_P2_13FEI 0x2000
#define LPC_GPIOINT_STATF2_P2_13FEI_BIT 13
#define LPC_GPIOINT_STATF2_P2_14FEI_MASK 0x4000
#define LPC_GPIOINT_STATF2_P2_14FEI 0x4000
#define LPC_GPIOINT_STATF2_P2_14FEI_BIT 14
#define LPC_GPIOINT_STATF2_P2_15FEI_MASK 0x8000
#define LPC_GPIOINT_STATF2_P2_15FEI 0x8000
#define LPC_GPIOINT_STATF2_P2_15FEI_BIT 15
#define LPC_GPIOINT_STATF2_P2_16FEI_MASK 0x10000
#define LPC_GPIOINT_STATF2_P2_16FEI 0x10000
#define LPC_GPIOINT_STATF2_P2_16FEI_BIT 16
#define LPC_GPIOINT_STATF2_P2_17FEI_MASK 0x20000
#define LPC_GPIOINT_STATF2_P2_17FEI 0x20000
#define LPC_GPIOINT_STATF2_P2_17FEI_BIT 17
#define LPC_GPIOINT_STATF2_P2_18FEI_MASK 0x40000
#define LPC_GPIOINT_STATF2_P2_18FEI 0x40000
#define LPC_GPIOINT_STATF2_P2_18FEI_BIT 18
#define LPC_GPIOINT_STATF2_P2_19FEI_MASK 0x80000
#define LPC_GPIOINT_STATF2_P2_19FEI 0x80000
#define LPC_GPIOINT_STATF2_P2_19FEI_BIT 19
#define LPC_GPIOINT_STATF2_P2_20FEI_MASK 0x100000
#define LPC_GPIOINT_STATF2_P2_20FEI 0x100000
#define LPC_GPIOINT_STATF2_P2_20FEI_BIT 20
#define LPC_GPIOINT_STATF2_P2_21FEI_MASK 0x200000
#define LPC_GPIOINT_STATF2_P2_21FEI 0x200000
#define LPC_GPIOINT_STATF2_P2_21FEI_BIT 21
#define LPC_GPIOINT_STATF2_P2_22FEI_MASK 0x400000
#define LPC_GPIOINT_STATF2_P2_22FEI 0x400000
#define LPC_GPIOINT_STATF2_P2_22FEI_BIT 22
#define LPC_GPIOINT_STATF2_P2_23FEI_MASK 0x800000
#define LPC_GPIOINT_STATF2_P2_23FEI 0x800000
#define LPC_GPIOINT_STATF2_P2_23FEI_BIT 23
#define LPC_GPIOINT_STATF2_P2_24FEI_MASK 0x1000000
#define LPC_GPIOINT_STATF2_P2_24FEI 0x1000000
#define LPC_GPIOINT_STATF2_P2_24FEI_BIT 24
#define LPC_GPIOINT_STATF2_P2_25FEI_MASK 0x2000000
#define LPC_GPIOINT_STATF2_P2_25FEI 0x2000000
#define LPC_GPIOINT_STATF2_P2_25FEI_BIT 25
#define LPC_GPIOINT_STATF2_P2_26FEI_MASK 0x4000000
#define LPC_GPIOINT_STATF2_P2_26FEI 0x4000000
#define LPC_GPIOINT_STATF2_P2_26FEI_BIT 26
#define LPC_GPIOINT_STATF2_P2_27FEI_MASK 0x8000000
#define LPC_GPIOINT_STATF2_P2_27FEI 0x8000000
#define LPC_GPIOINT_STATF2_P2_27FEI_BIT 27
#define LPC_GPIOINT_STATF2_P2_28FEI_MASK 0x10000000
#define LPC_GPIOINT_STATF2_P2_28FEI 0x10000000
#define LPC_GPIOINT_STATF2_P2_28FEI_BIT 28
#define LPC_GPIOINT_STATF2_P2_29FEI_MASK 0x20000000
#define LPC_GPIOINT_STATF2_P2_29FEI 0x20000000
#define LPC_GPIOINT_STATF2_P2_29FEI_BIT 29
#define LPC_GPIOINT_STATF2_P2_30FEI_MASK 0x40000000
#define LPC_GPIOINT_STATF2_P2_30FEI 0x40000000
#define LPC_GPIOINT_STATF2_P2_30FEI_BIT 30
#define LPC_GPIOINT_STATF2_P2_31FEI_MASK 0x80000000
#define LPC_GPIOINT_STATF2_P2_31FEI 0x80000000
#define LPC_GPIOINT_STATF2_P2_31FEI_BIT 31

#define LPC_GPIOINT_CLR2 (*(volatile unsigned long *)0x400280AC)
#define LPC_GPIOINT_CLR2_OFFSET 0x2C
#define LPC_GPIOINT_CLR2_P2_0CI_MASK 0x1
#define LPC_GPIOINT_CLR2_P2_0CI 0x1
#define LPC_GPIOINT_CLR2_P2_0CI_BIT 0
#define LPC_GPIOINT_CLR2_P2_1CI_MASK 0x2
#define LPC_GPIOINT_CLR2_P2_1CI 0x2
#define LPC_GPIOINT_CLR2_P2_1CI_BIT 1
#define LPC_GPIOINT_CLR2_P2_2CI_MASK 0x4
#define LPC_GPIOINT_CLR2_P2_2CI 0x4
#define LPC_GPIOINT_CLR2_P2_2CI_BIT 2
#define LPC_GPIOINT_CLR2_P2_3CI_MASK 0x8
#define LPC_GPIOINT_CLR2_P2_3CI 0x8
#define LPC_GPIOINT_CLR2_P2_3CI_BIT 3
#define LPC_GPIOINT_CLR2_P2_4CI_MASK 0x10
#define LPC_GPIOINT_CLR2_P2_4CI 0x10
#define LPC_GPIOINT_CLR2_P2_4CI_BIT 4
#define LPC_GPIOINT_CLR2_P2_5CI_MASK 0x20
#define LPC_GPIOINT_CLR2_P2_5CI 0x20
#define LPC_GPIOINT_CLR2_P2_5CI_BIT 5
#define LPC_GPIOINT_CLR2_P2_6CI_MASK 0x40
#define LPC_GPIOINT_CLR2_P2_6CI 0x40
#define LPC_GPIOINT_CLR2_P2_6CI_BIT 6
#define LPC_GPIOINT_CLR2_P2_7CI_MASK 0x80
#define LPC_GPIOINT_CLR2_P2_7CI 0x80
#define LPC_GPIOINT_CLR2_P2_7CI_BIT 7
#define LPC_GPIOINT_CLR2_P2_8CI_MASK 0x100
#define LPC_GPIOINT_CLR2_P2_8CI 0x100
#define LPC_GPIOINT_CLR2_P2_8CI_BIT 8
#define LPC_GPIOINT_CLR2_P2_9CI_MASK 0x200
#define LPC_GPIOINT_CLR2_P2_9CI 0x200
#define LPC_GPIOINT_CLR2_P2_9CI_BIT 9
#define LPC_GPIOINT_CLR2_P2_10CI_MASK 0x400
#define LPC_GPIOINT_CLR2_P2_10CI 0x400
#define LPC_GPIOINT_CLR2_P2_10CI_BIT 10
#define LPC_GPIOINT_CLR2_P2_11CI_MASK 0x800
#define LPC_GPIOINT_CLR2_P2_11CI 0x800
#define LPC_GPIOINT_CLR2_P2_11CI_BIT 11
#define LPC_GPIOINT_CLR2_P2_12CI_MASK 0x1000
#define LPC_GPIOINT_CLR2_P2_12CI 0x1000
#define LPC_GPIOINT_CLR2_P2_12CI_BIT 12
#define LPC_GPIOINT_CLR2_P2_13CI_MASK 0x2000
#define LPC_GPIOINT_CLR2_P2_13CI 0x2000
#define LPC_GPIOINT_CLR2_P2_13CI_BIT 13
#define LPC_GPIOINT_CLR2_P2_14CI_MASK 0x4000
#define LPC_GPIOINT_CLR2_P2_14CI 0x4000
#define LPC_GPIOINT_CLR2_P2_14CI_BIT 14
#define LPC_GPIOINT_CLR2_P2_15CI_MASK 0x8000
#define LPC_GPIOINT_CLR2_P2_15CI 0x8000
#define LPC_GPIOINT_CLR2_P2_15CI_BIT 15
#define LPC_GPIOINT_CLR2_P2_16CI_MASK 0x10000
#define LPC_GPIOINT_CLR2_P2_16CI 0x10000
#define LPC_GPIOINT_CLR2_P2_16CI_BIT 16
#define LPC_GPIOINT_CLR2_P2_17CI_MASK 0x20000
#define LPC_GPIOINT_CLR2_P2_17CI 0x20000
#define LPC_GPIOINT_CLR2_P2_17CI_BIT 17
#define LPC_GPIOINT_CLR2_P2_18CI_MASK 0x40000
#define LPC_GPIOINT_CLR2_P2_18CI 0x40000
#define LPC_GPIOINT_CLR2_P2_18CI_BIT 18
#define LPC_GPIOINT_CLR2_P2_19CI_MASK 0x80000
#define LPC_GPIOINT_CLR2_P2_19CI 0x80000
#define LPC_GPIOINT_CLR2_P2_19CI_BIT 19
#define LPC_GPIOINT_CLR2_P2_20CI_MASK 0x100000
#define LPC_GPIOINT_CLR2_P2_20CI 0x100000
#define LPC_GPIOINT_CLR2_P2_20CI_BIT 20
#define LPC_GPIOINT_CLR2_P2_21CI_MASK 0x200000
#define LPC_GPIOINT_CLR2_P2_21CI 0x200000
#define LPC_GPIOINT_CLR2_P2_21CI_BIT 21
#define LPC_GPIOINT_CLR2_P2_22CI_MASK 0x400000
#define LPC_GPIOINT_CLR2_P2_22CI 0x400000
#define LPC_GPIOINT_CLR2_P2_22CI_BIT 22
#define LPC_GPIOINT_CLR2_P2_23CI_MASK 0x800000
#define LPC_GPIOINT_CLR2_P2_23CI 0x800000
#define LPC_GPIOINT_CLR2_P2_23CI_BIT 23
#define LPC_GPIOINT_CLR2_P2_24CI_MASK 0x1000000
#define LPC_GPIOINT_CLR2_P2_24CI 0x1000000
#define LPC_GPIOINT_CLR2_P2_24CI_BIT 24
#define LPC_GPIOINT_CLR2_P2_25CI_MASK 0x2000000
#define LPC_GPIOINT_CLR2_P2_25CI 0x2000000
#define LPC_GPIOINT_CLR2_P2_25CI_BIT 25
#define LPC_GPIOINT_CLR2_P2_26CI_MASK 0x4000000
#define LPC_GPIOINT_CLR2_P2_26CI 0x4000000
#define LPC_GPIOINT_CLR2_P2_26CI_BIT 26
#define LPC_GPIOINT_CLR2_P2_27CI_MASK 0x8000000
#define LPC_GPIOINT_CLR2_P2_27CI 0x8000000
#define LPC_GPIOINT_CLR2_P2_27CI_BIT 27
#define LPC_GPIOINT_CLR2_P2_28CI_MASK 0x10000000
#define LPC_GPIOINT_CLR2_P2_28CI 0x10000000
#define LPC_GPIOINT_CLR2_P2_28CI_BIT 28
#define LPC_GPIOINT_CLR2_P2_29CI_MASK 0x20000000
#define LPC_GPIOINT_CLR2_P2_29CI 0x20000000
#define LPC_GPIOINT_CLR2_P2_29CI_BIT 29
#define LPC_GPIOINT_CLR2_P2_30CI_MASK 0x40000000
#define LPC_GPIOINT_CLR2_P2_30CI 0x40000000
#define LPC_GPIOINT_CLR2_P2_30CI_BIT 30
#define LPC_GPIOINT_CLR2_P2_31CI_MASK 0x80000000
#define LPC_GPIOINT_CLR2_P2_31CI 0x80000000
#define LPC_GPIOINT_CLR2_P2_31CI_BIT 31

#define LPC_GPIOINT_ENR2 (*(volatile unsigned long *)0x400280B0)
#define LPC_GPIOINT_ENR2_OFFSET 0x30
#define LPC_GPIOINT_ENR2_P2_0ER_MASK 0x1
#define LPC_GPIOINT_ENR2_P2_0ER 0x1
#define LPC_GPIOINT_ENR2_P2_0ER_BIT 0
#define LPC_GPIOINT_ENR2_P2_1ER_MASK 0x2
#define LPC_GPIOINT_ENR2_P2_1ER 0x2
#define LPC_GPIOINT_ENR2_P2_1ER_BIT 1
#define LPC_GPIOINT_ENR2_P2_2ER_MASK 0x4
#define LPC_GPIOINT_ENR2_P2_2ER 0x4
#define LPC_GPIOINT_ENR2_P2_2ER_BIT 2
#define LPC_GPIOINT_ENR2_P2_3ER_MASK 0x8
#define LPC_GPIOINT_ENR2_P2_3ER 0x8
#define LPC_GPIOINT_ENR2_P2_3ER_BIT 3
#define LPC_GPIOINT_ENR2_P2_4ER_MASK 0x10
#define LPC_GPIOINT_ENR2_P2_4ER 0x10
#define LPC_GPIOINT_ENR2_P2_4ER_BIT 4
#define LPC_GPIOINT_ENR2_P2_5ER_MASK 0x20
#define LPC_GPIOINT_ENR2_P2_5ER 0x20
#define LPC_GPIOINT_ENR2_P2_5ER_BIT 5
#define LPC_GPIOINT_ENR2_P2_6ER_MASK 0x40
#define LPC_GPIOINT_ENR2_P2_6ER 0x40
#define LPC_GPIOINT_ENR2_P2_6ER_BIT 6
#define LPC_GPIOINT_ENR2_P2_7ER_MASK 0x80
#define LPC_GPIOINT_ENR2_P2_7ER 0x80
#define LPC_GPIOINT_ENR2_P2_7ER_BIT 7
#define LPC_GPIOINT_ENR2_P2_8ER_MASK 0x100
#define LPC_GPIOINT_ENR2_P2_8ER 0x100
#define LPC_GPIOINT_ENR2_P2_8ER_BIT 8
#define LPC_GPIOINT_ENR2_P2_9ER_MASK 0x200
#define LPC_GPIOINT_ENR2_P2_9ER 0x200
#define LPC_GPIOINT_ENR2_P2_9ER_BIT 9
#define LPC_GPIOINT_ENR2_P2_10ER_MASK 0x400
#define LPC_GPIOINT_ENR2_P2_10ER 0x400
#define LPC_GPIOINT_ENR2_P2_10ER_BIT 10
#define LPC_GPIOINT_ENR2_P2_11ER_MASK 0x800
#define LPC_GPIOINT_ENR2_P2_11ER 0x800
#define LPC_GPIOINT_ENR2_P2_11ER_BIT 11
#define LPC_GPIOINT_ENR2_P2_12ER_MASK 0x1000
#define LPC_GPIOINT_ENR2_P2_12ER 0x1000
#define LPC_GPIOINT_ENR2_P2_12ER_BIT 12
#define LPC_GPIOINT_ENR2_P2_13ER_MASK 0x2000
#define LPC_GPIOINT_ENR2_P2_13ER 0x2000
#define LPC_GPIOINT_ENR2_P2_13ER_BIT 13
#define LPC_GPIOINT_ENR2_P2_14ER_MASK 0x4000
#define LPC_GPIOINT_ENR2_P2_14ER 0x4000
#define LPC_GPIOINT_ENR2_P2_14ER_BIT 14
#define LPC_GPIOINT_ENR2_P2_15ER_MASK 0x8000
#define LPC_GPIOINT_ENR2_P2_15ER 0x8000
#define LPC_GPIOINT_ENR2_P2_15ER_BIT 15
#define LPC_GPIOINT_ENR2_P2_16ER_MASK 0x10000
#define LPC_GPIOINT_ENR2_P2_16ER 0x10000
#define LPC_GPIOINT_ENR2_P2_16ER_BIT 16
#define LPC_GPIOINT_ENR2_P2_17ER_MASK 0x20000
#define LPC_GPIOINT_ENR2_P2_17ER 0x20000
#define LPC_GPIOINT_ENR2_P2_17ER_BIT 17
#define LPC_GPIOINT_ENR2_P2_18ER_MASK 0x40000
#define LPC_GPIOINT_ENR2_P2_18ER 0x40000
#define LPC_GPIOINT_ENR2_P2_18ER_BIT 18
#define LPC_GPIOINT_ENR2_P2_19ER_MASK 0x80000
#define LPC_GPIOINT_ENR2_P2_19ER 0x80000
#define LPC_GPIOINT_ENR2_P2_19ER_BIT 19
#define LPC_GPIOINT_ENR2_P2_20ER_MASK 0x100000
#define LPC_GPIOINT_ENR2_P2_20ER 0x100000
#define LPC_GPIOINT_ENR2_P2_20ER_BIT 20
#define LPC_GPIOINT_ENR2_P2_21ER_MASK 0x200000
#define LPC_GPIOINT_ENR2_P2_21ER 0x200000
#define LPC_GPIOINT_ENR2_P2_21ER_BIT 21
#define LPC_GPIOINT_ENR2_P2_22ER_MASK 0x400000
#define LPC_GPIOINT_ENR2_P2_22ER 0x400000
#define LPC_GPIOINT_ENR2_P2_22ER_BIT 22
#define LPC_GPIOINT_ENR2_P2_23ER_MASK 0x800000
#define LPC_GPIOINT_ENR2_P2_23ER 0x800000
#define LPC_GPIOINT_ENR2_P2_23ER_BIT 23
#define LPC_GPIOINT_ENR2_P2_24ER_MASK 0x1000000
#define LPC_GPIOINT_ENR2_P2_24ER 0x1000000
#define LPC_GPIOINT_ENR2_P2_24ER_BIT 24
#define LPC_GPIOINT_ENR2_P2_25ER_MASK 0x2000000
#define LPC_GPIOINT_ENR2_P2_25ER 0x2000000
#define LPC_GPIOINT_ENR2_P2_25ER_BIT 25
#define LPC_GPIOINT_ENR2_P2_26ER_MASK 0x4000000
#define LPC_GPIOINT_ENR2_P2_26ER 0x4000000
#define LPC_GPIOINT_ENR2_P2_26ER_BIT 26
#define LPC_GPIOINT_ENR2_P2_27ER_MASK 0x8000000
#define LPC_GPIOINT_ENR2_P2_27ER 0x8000000
#define LPC_GPIOINT_ENR2_P2_27ER_BIT 27
#define LPC_GPIOINT_ENR2_P2_28ER_MASK 0x10000000
#define LPC_GPIOINT_ENR2_P2_28ER 0x10000000
#define LPC_GPIOINT_ENR2_P2_28ER_BIT 28
#define LPC_GPIOINT_ENR2_P2_29ER_MASK 0x20000000
#define LPC_GPIOINT_ENR2_P2_29ER 0x20000000
#define LPC_GPIOINT_ENR2_P2_29ER_BIT 29
#define LPC_GPIOINT_ENR2_P2_30ER_MASK 0x40000000
#define LPC_GPIOINT_ENR2_P2_30ER 0x40000000
#define LPC_GPIOINT_ENR2_P2_30ER_BIT 30
#define LPC_GPIOINT_ENR2_P2_31ER_MASK 0x80000000
#define LPC_GPIOINT_ENR2_P2_31ER 0x80000000
#define LPC_GPIOINT_ENR2_P2_31ER_BIT 31

#define LPC_GPIOINT_ENF2 (*(volatile unsigned long *)0x400280B4)
#define LPC_GPIOINT_ENF2_OFFSET 0x34
#define LPC_GPIOINT_ENF2_P2_0EF_MASK 0x1
#define LPC_GPIOINT_ENF2_P2_0EF 0x1
#define LPC_GPIOINT_ENF2_P2_0EF_BIT 0
#define LPC_GPIOINT_ENF2_P2_1EF_MASK 0x2
#define LPC_GPIOINT_ENF2_P2_1EF 0x2
#define LPC_GPIOINT_ENF2_P2_1EF_BIT 1
#define LPC_GPIOINT_ENF2_P2_2EF_MASK 0x4
#define LPC_GPIOINT_ENF2_P2_2EF 0x4
#define LPC_GPIOINT_ENF2_P2_2EF_BIT 2
#define LPC_GPIOINT_ENF2_P2_3EF_MASK 0x8
#define LPC_GPIOINT_ENF2_P2_3EF 0x8
#define LPC_GPIOINT_ENF2_P2_3EF_BIT 3
#define LPC_GPIOINT_ENF2_P2_4EF_MASK 0x10
#define LPC_GPIOINT_ENF2_P2_4EF 0x10
#define LPC_GPIOINT_ENF2_P2_4EF_BIT 4
#define LPC_GPIOINT_ENF2_P2_5EF_MASK 0x20
#define LPC_GPIOINT_ENF2_P2_5EF 0x20
#define LPC_GPIOINT_ENF2_P2_5EF_BIT 5
#define LPC_GPIOINT_ENF2_P2_6EF_MASK 0x40
#define LPC_GPIOINT_ENF2_P2_6EF 0x40
#define LPC_GPIOINT_ENF2_P2_6EF_BIT 6
#define LPC_GPIOINT_ENF2_P2_7EF_MASK 0x80
#define LPC_GPIOINT_ENF2_P2_7EF 0x80
#define LPC_GPIOINT_ENF2_P2_7EF_BIT 7
#define LPC_GPIOINT_ENF2_P2_8EF_MASK 0x100
#define LPC_GPIOINT_ENF2_P2_8EF 0x100
#define LPC_GPIOINT_ENF2_P2_8EF_BIT 8
#define LPC_GPIOINT_ENF2_P2_9EF_MASK 0x200
#define LPC_GPIOINT_ENF2_P2_9EF 0x200
#define LPC_GPIOINT_ENF2_P2_9EF_BIT 9
#define LPC_GPIOINT_ENF2_P2_10EF_MASK 0x400
#define LPC_GPIOINT_ENF2_P2_10EF 0x400
#define LPC_GPIOINT_ENF2_P2_10EF_BIT 10
#define LPC_GPIOINT_ENF2_P2_11EF_MASK 0x800
#define LPC_GPIOINT_ENF2_P2_11EF 0x800
#define LPC_GPIOINT_ENF2_P2_11EF_BIT 11
#define LPC_GPIOINT_ENF2_P2_12EF_MASK 0x1000
#define LPC_GPIOINT_ENF2_P2_12EF 0x1000
#define LPC_GPIOINT_ENF2_P2_12EF_BIT 12
#define LPC_GPIOINT_ENF2_P2_13EF_MASK 0x2000
#define LPC_GPIOINT_ENF2_P2_13EF 0x2000
#define LPC_GPIOINT_ENF2_P2_13EF_BIT 13
#define LPC_GPIOINT_ENF2_P2_14EF_MASK 0x4000
#define LPC_GPIOINT_ENF2_P2_14EF 0x4000
#define LPC_GPIOINT_ENF2_P2_14EF_BIT 14
#define LPC_GPIOINT_ENF2_P2_15EF_MASK 0x8000
#define LPC_GPIOINT_ENF2_P2_15EF 0x8000
#define LPC_GPIOINT_ENF2_P2_15EF_BIT 15
#define LPC_GPIOINT_ENF2_P2_16EF_MASK 0x10000
#define LPC_GPIOINT_ENF2_P2_16EF 0x10000
#define LPC_GPIOINT_ENF2_P2_16EF_BIT 16
#define LPC_GPIOINT_ENF2_P2_17EF_MASK 0x20000
#define LPC_GPIOINT_ENF2_P2_17EF 0x20000
#define LPC_GPIOINT_ENF2_P2_17EF_BIT 17
#define LPC_GPIOINT_ENF2_P2_18EF_MASK 0x40000
#define LPC_GPIOINT_ENF2_P2_18EF 0x40000
#define LPC_GPIOINT_ENF2_P2_18EF_BIT 18
#define LPC_GPIOINT_ENF2_P2_19EF_MASK 0x80000
#define LPC_GPIOINT_ENF2_P2_19EF 0x80000
#define LPC_GPIOINT_ENF2_P2_19EF_BIT 19
#define LPC_GPIOINT_ENF2_P2_20EF_MASK 0x100000
#define LPC_GPIOINT_ENF2_P2_20EF 0x100000
#define LPC_GPIOINT_ENF2_P2_20EF_BIT 20
#define LPC_GPIOINT_ENF2_P2_21EF_MASK 0x200000
#define LPC_GPIOINT_ENF2_P2_21EF 0x200000
#define LPC_GPIOINT_ENF2_P2_21EF_BIT 21
#define LPC_GPIOINT_ENF2_P2_22EF_MASK 0x400000
#define LPC_GPIOINT_ENF2_P2_22EF 0x400000
#define LPC_GPIOINT_ENF2_P2_22EF_BIT 22
#define LPC_GPIOINT_ENF2_P2_23EF_MASK 0x800000
#define LPC_GPIOINT_ENF2_P2_23EF 0x800000
#define LPC_GPIOINT_ENF2_P2_23EF_BIT 23
#define LPC_GPIOINT_ENF2_P2_24EF_MASK 0x1000000
#define LPC_GPIOINT_ENF2_P2_24EF 0x1000000
#define LPC_GPIOINT_ENF2_P2_24EF_BIT 24
#define LPC_GPIOINT_ENF2_P2_25EF_MASK 0x2000000
#define LPC_GPIOINT_ENF2_P2_25EF 0x2000000
#define LPC_GPIOINT_ENF2_P2_25EF_BIT 25
#define LPC_GPIOINT_ENF2_P2_26EF_MASK 0x4000000
#define LPC_GPIOINT_ENF2_P2_26EF 0x4000000
#define LPC_GPIOINT_ENF2_P2_26EF_BIT 26
#define LPC_GPIOINT_ENF2_P2_27EF_MASK 0x8000000
#define LPC_GPIOINT_ENF2_P2_27EF 0x8000000
#define LPC_GPIOINT_ENF2_P2_27EF_BIT 27
#define LPC_GPIOINT_ENF2_P2_28EF_MASK 0x10000000
#define LPC_GPIOINT_ENF2_P2_28EF 0x10000000
#define LPC_GPIOINT_ENF2_P2_28EF_BIT 28
#define LPC_GPIOINT_ENF2_P2_29EF_MASK 0x20000000
#define LPC_GPIOINT_ENF2_P2_29EF 0x20000000
#define LPC_GPIOINT_ENF2_P2_29EF_BIT 29
#define LPC_GPIOINT_ENF2_P2_30EF_MASK 0x40000000
#define LPC_GPIOINT_ENF2_P2_30EF 0x40000000
#define LPC_GPIOINT_ENF2_P2_30EF_BIT 30
#define LPC_GPIOINT_ENF2_P2_31EF_MASK 0x80000000
#define LPC_GPIOINT_ENF2_P2_31EF 0x80000000
#define LPC_GPIOINT_ENF2_P2_31EF_BIT 31

#ifndef LPC_IOCON_BASE_ADDRESS
#define LPC_IOCON_BASE_ADDRESS 0x4002C000
#endif

#define LPC_IOCON_P0_0 (*(volatile unsigned long *)0x4002C000)
#define LPC_IOCON_P0_0_OFFSET 0x0
#define LPC_IOCON_P0_0_FUNC_MASK 0x7
#define LPC_IOCON_P0_0_FUNC_BIT 0
#define LPC_IOCON_P0_0_MODE_MASK 0x18
#define LPC_IOCON_P0_0_MODE_BIT 3
#define LPC_IOCON_P0_0_HYS_MASK 0x20
#define LPC_IOCON_P0_0_HYS 0x20
#define LPC_IOCON_P0_0_HYS_BIT 5
#define LPC_IOCON_P0_0_INV_MASK 0x40
#define LPC_IOCON_P0_0_INV 0x40
#define LPC_IOCON_P0_0_INV_BIT 6
#define LPC_IOCON_P0_0_SLEW_MASK 0x200
#define LPC_IOCON_P0_0_SLEW 0x200
#define LPC_IOCON_P0_0_SLEW_BIT 9
#define LPC_IOCON_P0_0_OD_MASK 0x400
#define LPC_IOCON_P0_0_OD 0x400
#define LPC_IOCON_P0_0_OD_BIT 10

#define LPC_IOCON_P0_1 (*(volatile unsigned long *)0x4002C004)
#define LPC_IOCON_P0_1_OFFSET 0x4
#define LPC_IOCON_P0_1_FUNC_MASK 0x7
#define LPC_IOCON_P0_1_FUNC_BIT 0
#define LPC_IOCON_P0_1_MODE_MASK 0x18
#define LPC_IOCON_P0_1_MODE_BIT 3
#define LPC_IOCON_P0_1_HYS_MASK 0x20
#define LPC_IOCON_P0_1_HYS 0x20
#define LPC_IOCON_P0_1_HYS_BIT 5
#define LPC_IOCON_P0_1_INV_MASK 0x40
#define LPC_IOCON_P0_1_INV 0x40
#define LPC_IOCON_P0_1_INV_BIT 6
#define LPC_IOCON_P0_1_SLEW_MASK 0x200
#define LPC_IOCON_P0_1_SLEW 0x200
#define LPC_IOCON_P0_1_SLEW_BIT 9
#define LPC_IOCON_P0_1_OD_MASK 0x400
#define LPC_IOCON_P0_1_OD 0x400
#define LPC_IOCON_P0_1_OD_BIT 10

#define LPC_IOCON_P0_2 (*(volatile unsigned long *)0x4002C008)
#define LPC_IOCON_P0_2_OFFSET 0x8
#define LPC_IOCON_P0_2_FUNC_MASK 0x7
#define LPC_IOCON_P0_2_FUNC_BIT 0
#define LPC_IOCON_P0_2_MODE_MASK 0x18
#define LPC_IOCON_P0_2_MODE_BIT 3
#define LPC_IOCON_P0_2_HYS_MASK 0x20
#define LPC_IOCON_P0_2_HYS 0x20
#define LPC_IOCON_P0_2_HYS_BIT 5
#define LPC_IOCON_P0_2_INV_MASK 0x40
#define LPC_IOCON_P0_2_INV 0x40
#define LPC_IOCON_P0_2_INV_BIT 6
#define LPC_IOCON_P0_2_SLEW_MASK 0x200
#define LPC_IOCON_P0_2_SLEW 0x200
#define LPC_IOCON_P0_2_SLEW_BIT 9
#define LPC_IOCON_P0_2_OD_MASK 0x400
#define LPC_IOCON_P0_2_OD 0x400
#define LPC_IOCON_P0_2_OD_BIT 10

#define LPC_IOCON_P0_3 (*(volatile unsigned long *)0x4002C00C)
#define LPC_IOCON_P0_3_OFFSET 0xC
#define LPC_IOCON_P0_3_FUNC_MASK 0x7
#define LPC_IOCON_P0_3_FUNC_BIT 0
#define LPC_IOCON_P0_3_MODE_MASK 0x18
#define LPC_IOCON_P0_3_MODE_BIT 3
#define LPC_IOCON_P0_3_HYS_MASK 0x20
#define LPC_IOCON_P0_3_HYS 0x20
#define LPC_IOCON_P0_3_HYS_BIT 5
#define LPC_IOCON_P0_3_INV_MASK 0x40
#define LPC_IOCON_P0_3_INV 0x40
#define LPC_IOCON_P0_3_INV_BIT 6
#define LPC_IOCON_P0_3_SLEW_MASK 0x200
#define LPC_IOCON_P0_3_SLEW 0x200
#define LPC_IOCON_P0_3_SLEW_BIT 9
#define LPC_IOCON_P0_3_OD_MASK 0x400
#define LPC_IOCON_P0_3_OD 0x400
#define LPC_IOCON_P0_3_OD_BIT 10

#define LPC_IOCON_P0_4 (*(volatile unsigned long *)0x4002C010)
#define LPC_IOCON_P0_4_OFFSET 0x10
#define LPC_IOCON_P0_4_FUNC_MASK 0x7
#define LPC_IOCON_P0_4_FUNC_BIT 0
#define LPC_IOCON_P0_4_MODE_MASK 0x18
#define LPC_IOCON_P0_4_MODE_BIT 3
#define LPC_IOCON_P0_4_HYS_MASK 0x20
#define LPC_IOCON_P0_4_HYS 0x20
#define LPC_IOCON_P0_4_HYS_BIT 5
#define LPC_IOCON_P0_4_INV_MASK 0x40
#define LPC_IOCON_P0_4_INV 0x40
#define LPC_IOCON_P0_4_INV_BIT 6
#define LPC_IOCON_P0_4_SLEW_MASK 0x200
#define LPC_IOCON_P0_4_SLEW 0x200
#define LPC_IOCON_P0_4_SLEW_BIT 9
#define LPC_IOCON_P0_4_OD_MASK 0x400
#define LPC_IOCON_P0_4_OD 0x400
#define LPC_IOCON_P0_4_OD_BIT 10

#define LPC_IOCON_P0_5 (*(volatile unsigned long *)0x4002C014)
#define LPC_IOCON_P0_5_OFFSET 0x14
#define LPC_IOCON_P0_5_FUNC_MASK 0x7
#define LPC_IOCON_P0_5_FUNC_BIT 0
#define LPC_IOCON_P0_5_MODE_MASK 0x18
#define LPC_IOCON_P0_5_MODE_BIT 3
#define LPC_IOCON_P0_5_HYS_MASK 0x20
#define LPC_IOCON_P0_5_HYS 0x20
#define LPC_IOCON_P0_5_HYS_BIT 5
#define LPC_IOCON_P0_5_INV_MASK 0x40
#define LPC_IOCON_P0_5_INV 0x40
#define LPC_IOCON_P0_5_INV_BIT 6
#define LPC_IOCON_P0_5_SLEW_MASK 0x200
#define LPC_IOCON_P0_5_SLEW 0x200
#define LPC_IOCON_P0_5_SLEW_BIT 9
#define LPC_IOCON_P0_5_OD_MASK 0x400
#define LPC_IOCON_P0_5_OD 0x400
#define LPC_IOCON_P0_5_OD_BIT 10

#define LPC_IOCON_P0_6 (*(volatile unsigned long *)0x4002C018)
#define LPC_IOCON_P0_6_OFFSET 0x18
#define LPC_IOCON_P0_6_FUNC_MASK 0x7
#define LPC_IOCON_P0_6_FUNC_BIT 0
#define LPC_IOCON_P0_6_MODE_MASK 0x18
#define LPC_IOCON_P0_6_MODE_BIT 3
#define LPC_IOCON_P0_6_HYS_MASK 0x20
#define LPC_IOCON_P0_6_HYS 0x20
#define LPC_IOCON_P0_6_HYS_BIT 5
#define LPC_IOCON_P0_6_INV_MASK 0x40
#define LPC_IOCON_P0_6_INV 0x40
#define LPC_IOCON_P0_6_INV_BIT 6
#define LPC_IOCON_P0_6_SLEW_MASK 0x200
#define LPC_IOCON_P0_6_SLEW 0x200
#define LPC_IOCON_P0_6_SLEW_BIT 9
#define LPC_IOCON_P0_6_OD_MASK 0x400
#define LPC_IOCON_P0_6_OD 0x400
#define LPC_IOCON_P0_6_OD_BIT 10

#define LPC_IOCON_P0_7 (*(volatile unsigned long *)0x4002C01C)
#define LPC_IOCON_P0_7_OFFSET 0x1C
#define LPC_IOCON_P0_7_FUNC_MASK 0x7
#define LPC_IOCON_P0_7_FUNC_BIT 0
#define LPC_IOCON_P0_7_MODE_MASK 0x18
#define LPC_IOCON_P0_7_MODE_BIT 3
#define LPC_IOCON_P0_7_HYS_MASK 0x20
#define LPC_IOCON_P0_7_HYS 0x20
#define LPC_IOCON_P0_7_HYS_BIT 5
#define LPC_IOCON_P0_7_INV_MASK 0x40
#define LPC_IOCON_P0_7_INV 0x40
#define LPC_IOCON_P0_7_INV_BIT 6
#define LPC_IOCON_P0_7_FILTER_MASK 0x100
#define LPC_IOCON_P0_7_FILTER 0x100
#define LPC_IOCON_P0_7_FILTER_BIT 8
#define LPC_IOCON_P0_7_SLEW_MASK 0x200
#define LPC_IOCON_P0_7_SLEW 0x200
#define LPC_IOCON_P0_7_SLEW_BIT 9
#define LPC_IOCON_P0_7_OD_MASK 0x400
#define LPC_IOCON_P0_7_OD 0x400
#define LPC_IOCON_P0_7_OD_BIT 10

#define LPC_IOCON_P0_8 (*(volatile unsigned long *)0x4002C020)
#define LPC_IOCON_P0_8_OFFSET 0x20
#define LPC_IOCON_P0_8_FUNC_MASK 0x7
#define LPC_IOCON_P0_8_FUNC_BIT 0
#define LPC_IOCON_P0_8_MODE_MASK 0x18
#define LPC_IOCON_P0_8_MODE_BIT 3
#define LPC_IOCON_P0_8_HYS_MASK 0x20
#define LPC_IOCON_P0_8_HYS 0x20
#define LPC_IOCON_P0_8_HYS_BIT 5
#define LPC_IOCON_P0_8_INV_MASK 0x40
#define LPC_IOCON_P0_8_INV 0x40
#define LPC_IOCON_P0_8_INV_BIT 6
#define LPC_IOCON_P0_8_FILTER_MASK 0x100
#define LPC_IOCON_P0_8_FILTER 0x100
#define LPC_IOCON_P0_8_FILTER_BIT 8
#define LPC_IOCON_P0_8_SLEW_MASK 0x200
#define LPC_IOCON_P0_8_SLEW 0x200
#define LPC_IOCON_P0_8_SLEW_BIT 9
#define LPC_IOCON_P0_8_OD_MASK 0x400
#define LPC_IOCON_P0_8_OD 0x400
#define LPC_IOCON_P0_8_OD_BIT 10

#define LPC_IOCON_P0_9 (*(volatile unsigned long *)0x4002C024)
#define LPC_IOCON_P0_9_OFFSET 0x24
#define LPC_IOCON_P0_9_FUNC_MASK 0x7
#define LPC_IOCON_P0_9_FUNC_BIT 0
#define LPC_IOCON_P0_9_MODE_MASK 0x18
#define LPC_IOCON_P0_9_MODE_BIT 3
#define LPC_IOCON_P0_9_HYS_MASK 0x20
#define LPC_IOCON_P0_9_HYS 0x20
#define LPC_IOCON_P0_9_HYS_BIT 5
#define LPC_IOCON_P0_9_INV_MASK 0x40
#define LPC_IOCON_P0_9_INV 0x40
#define LPC_IOCON_P0_9_INV_BIT 6
#define LPC_IOCON_P0_9_FILTER_MASK 0x100
#define LPC_IOCON_P0_9_FILTER 0x100
#define LPC_IOCON_P0_9_FILTER_BIT 8
#define LPC_IOCON_P0_9_SLEW_MASK 0x200
#define LPC_IOCON_P0_9_SLEW 0x200
#define LPC_IOCON_P0_9_SLEW_BIT 9
#define LPC_IOCON_P0_9_OD_MASK 0x400
#define LPC_IOCON_P0_9_OD 0x400
#define LPC_IOCON_P0_9_OD_BIT 10

#define LPC_IOCON_P0_10 (*(volatile unsigned long *)0x4002C028)
#define LPC_IOCON_P0_10_OFFSET 0x28
#define LPC_IOCON_P0_10_FUNC_MASK 0x7
#define LPC_IOCON_P0_10_FUNC_BIT 0
#define LPC_IOCON_P0_10_MODE_MASK 0x18
#define LPC_IOCON_P0_10_MODE_BIT 3
#define LPC_IOCON_P0_10_HYS_MASK 0x20
#define LPC_IOCON_P0_10_HYS 0x20
#define LPC_IOCON_P0_10_HYS_BIT 5
#define LPC_IOCON_P0_10_INV_MASK 0x40
#define LPC_IOCON_P0_10_INV 0x40
#define LPC_IOCON_P0_10_INV_BIT 6
#define LPC_IOCON_P0_10_SLEW_MASK 0x200
#define LPC_IOCON_P0_10_SLEW 0x200
#define LPC_IOCON_P0_10_SLEW_BIT 9
#define LPC_IOCON_P0_10_OD_MASK 0x400
#define LPC_IOCON_P0_10_OD 0x400
#define LPC_IOCON_P0_10_OD_BIT 10

#define LPC_IOCON_P0_11 (*(volatile unsigned long *)0x4002C02C)
#define LPC_IOCON_P0_11_OFFSET 0x2C
#define LPC_IOCON_P0_11_FUNC_MASK 0x7
#define LPC_IOCON_P0_11_FUNC_BIT 0
#define LPC_IOCON_P0_11_MODE_MASK 0x18
#define LPC_IOCON_P0_11_MODE_BIT 3
#define LPC_IOCON_P0_11_HYS_MASK 0x20
#define LPC_IOCON_P0_11_HYS 0x20
#define LPC_IOCON_P0_11_HYS_BIT 5
#define LPC_IOCON_P0_11_INV_MASK 0x40
#define LPC_IOCON_P0_11_INV 0x40
#define LPC_IOCON_P0_11_INV_BIT 6
#define LPC_IOCON_P0_11_SLEW_MASK 0x200
#define LPC_IOCON_P0_11_SLEW 0x200
#define LPC_IOCON_P0_11_SLEW_BIT 9
#define LPC_IOCON_P0_11_OD_MASK 0x400
#define LPC_IOCON_P0_11_OD 0x400
#define LPC_IOCON_P0_11_OD_BIT 10

#define LPC_IOCON_P0_12 (*(volatile unsigned long *)0x4002C030)
#define LPC_IOCON_P0_12_OFFSET 0x30
#define LPC_IOCON_P0_12_FUNC_MASK 0x7
#define LPC_IOCON_P0_12_FUNC_BIT 0

#define LPC_IOCON_P0_13 (*(volatile unsigned long *)0x4002C034)
#define LPC_IOCON_P0_13_OFFSET 0x34
#define LPC_IOCON_P0_13_FUNC_MASK 0x7
#define LPC_IOCON_P0_13_FUNC_BIT 0

#define LPC_IOCON_P0_14 (*(volatile unsigned long *)0x4002C038)
#define LPC_IOCON_P0_14_OFFSET 0x38
#define LPC_IOCON_P0_14_FUNC_MASK 0x7
#define LPC_IOCON_P0_14_FUNC_BIT 0
#define LPC_IOCON_P0_14_MODE_MASK 0x18
#define LPC_IOCON_P0_14_MODE_BIT 3
#define LPC_IOCON_P0_14_HYS_MASK 0x20
#define LPC_IOCON_P0_14_HYS 0x20
#define LPC_IOCON_P0_14_HYS_BIT 5
#define LPC_IOCON_P0_14_INV_MASK 0x40
#define LPC_IOCON_P0_14_INV 0x40
#define LPC_IOCON_P0_14_INV_BIT 6
#define LPC_IOCON_P0_14_SLEW_MASK 0x200
#define LPC_IOCON_P0_14_SLEW 0x200
#define LPC_IOCON_P0_14_SLEW_BIT 9
#define LPC_IOCON_P0_14_OD_MASK 0x400
#define LPC_IOCON_P0_14_OD 0x400
#define LPC_IOCON_P0_14_OD_BIT 10

#define LPC_IOCON_P0_15 (*(volatile unsigned long *)0x4002C03C)
#define LPC_IOCON_P0_15_OFFSET 0x3C
#define LPC_IOCON_P0_15_FUNC_MASK 0x7
#define LPC_IOCON_P0_15_FUNC_BIT 0
#define LPC_IOCON_P0_15_MODE_MASK 0x18
#define LPC_IOCON_P0_15_MODE_BIT 3
#define LPC_IOCON_P0_15_HYS_MASK 0x20
#define LPC_IOCON_P0_15_HYS 0x20
#define LPC_IOCON_P0_15_HYS_BIT 5
#define LPC_IOCON_P0_15_INV_MASK 0x40
#define LPC_IOCON_P0_15_INV 0x40
#define LPC_IOCON_P0_15_INV_BIT 6
#define LPC_IOCON_P0_15_SLEW_MASK 0x200
#define LPC_IOCON_P0_15_SLEW 0x200
#define LPC_IOCON_P0_15_SLEW_BIT 9
#define LPC_IOCON_P0_15_OD_MASK 0x400
#define LPC_IOCON_P0_15_OD 0x400
#define LPC_IOCON_P0_15_OD_BIT 10

#define LPC_IOCON_P0_16 (*(volatile unsigned long *)0x4002C040)
#define LPC_IOCON_P0_16_OFFSET 0x40
#define LPC_IOCON_P0_16_FUNC_MASK 0x7
#define LPC_IOCON_P0_16_FUNC_BIT 0
#define LPC_IOCON_P0_16_MODE_MASK 0x18
#define LPC_IOCON_P0_16_MODE_BIT 3
#define LPC_IOCON_P0_16_HYS_MASK 0x20
#define LPC_IOCON_P0_16_HYS 0x20
#define LPC_IOCON_P0_16_HYS_BIT 5
#define LPC_IOCON_P0_16_INV_MASK 0x40
#define LPC_IOCON_P0_16_INV 0x40
#define LPC_IOCON_P0_16_INV_BIT 6
#define LPC_IOCON_P0_16_SLEW_MASK 0x200
#define LPC_IOCON_P0_16_SLEW 0x200
#define LPC_IOCON_P0_16_SLEW_BIT 9
#define LPC_IOCON_P0_16_OD_MASK 0x400
#define LPC_IOCON_P0_16_OD 0x400
#define LPC_IOCON_P0_16_OD_BIT 10

#define LPC_IOCON_P0_17 (*(volatile unsigned long *)0x4002C044)
#define LPC_IOCON_P0_17_OFFSET 0x44
#define LPC_IOCON_P0_17_FUNC_MASK 0x7
#define LPC_IOCON_P0_17_FUNC_BIT 0
#define LPC_IOCON_P0_17_MODE_MASK 0x18
#define LPC_IOCON_P0_17_MODE_BIT 3
#define LPC_IOCON_P0_17_HYS_MASK 0x20
#define LPC_IOCON_P0_17_HYS 0x20
#define LPC_IOCON_P0_17_HYS_BIT 5
#define LPC_IOCON_P0_17_INV_MASK 0x40
#define LPC_IOCON_P0_17_INV 0x40
#define LPC_IOCON_P0_17_INV_BIT 6
#define LPC_IOCON_P0_17_SLEW_MASK 0x200
#define LPC_IOCON_P0_17_SLEW 0x200
#define LPC_IOCON_P0_17_SLEW_BIT 9
#define LPC_IOCON_P0_17_OD_MASK 0x400
#define LPC_IOCON_P0_17_OD 0x400
#define LPC_IOCON_P0_17_OD_BIT 10

#define LPC_IOCON_P0_18 (*(volatile unsigned long *)0x4002C048)
#define LPC_IOCON_P0_18_OFFSET 0x48
#define LPC_IOCON_P0_18_FUNC_MASK 0x7
#define LPC_IOCON_P0_18_FUNC_BIT 0
#define LPC_IOCON_P0_18_MODE_MASK 0x18
#define LPC_IOCON_P0_18_MODE_BIT 3
#define LPC_IOCON_P0_18_HYS_MASK 0x20
#define LPC_IOCON_P0_18_HYS 0x20
#define LPC_IOCON_P0_18_HYS_BIT 5
#define LPC_IOCON_P0_18_INV_MASK 0x40
#define LPC_IOCON_P0_18_INV 0x40
#define LPC_IOCON_P0_18_INV_BIT 6
#define LPC_IOCON_P0_18_SLEW_MASK 0x200
#define LPC_IOCON_P0_18_SLEW 0x200
#define LPC_IOCON_P0_18_SLEW_BIT 9
#define LPC_IOCON_P0_18_OD_MASK 0x400
#define LPC_IOCON_P0_18_OD 0x400
#define LPC_IOCON_P0_18_OD_BIT 10

#define LPC_IOCON_P0_19 (*(volatile unsigned long *)0x4002C04C)
#define LPC_IOCON_P0_19_OFFSET 0x4C
#define LPC_IOCON_P0_19_FUNC_MASK 0x7
#define LPC_IOCON_P0_19_FUNC_BIT 0
#define LPC_IOCON_P0_19_MODE_MASK 0x18
#define LPC_IOCON_P0_19_MODE_BIT 3
#define LPC_IOCON_P0_19_HYS_MASK 0x20
#define LPC_IOCON_P0_19_HYS 0x20
#define LPC_IOCON_P0_19_HYS_BIT 5
#define LPC_IOCON_P0_19_INV_MASK 0x40
#define LPC_IOCON_P0_19_INV 0x40
#define LPC_IOCON_P0_19_INV_BIT 6
#define LPC_IOCON_P0_19_SLEW_MASK 0x200
#define LPC_IOCON_P0_19_SLEW 0x200
#define LPC_IOCON_P0_19_SLEW_BIT 9
#define LPC_IOCON_P0_19_OD_MASK 0x400
#define LPC_IOCON_P0_19_OD 0x400
#define LPC_IOCON_P0_19_OD_BIT 10

#define LPC_IOCON_P0_20 (*(volatile unsigned long *)0x4002C050)
#define LPC_IOCON_P0_20_OFFSET 0x50
#define LPC_IOCON_P0_20_FUNC_MASK 0x7
#define LPC_IOCON_P0_20_FUNC_BIT 0
#define LPC_IOCON_P0_20_MODE_MASK 0x18
#define LPC_IOCON_P0_20_MODE_BIT 3
#define LPC_IOCON_P0_20_HYS_MASK 0x20
#define LPC_IOCON_P0_20_HYS 0x20
#define LPC_IOCON_P0_20_HYS_BIT 5
#define LPC_IOCON_P0_20_INV_MASK 0x40
#define LPC_IOCON_P0_20_INV 0x40
#define LPC_IOCON_P0_20_INV_BIT 6
#define LPC_IOCON_P0_20_SLEW_MASK 0x200
#define LPC_IOCON_P0_20_SLEW 0x200
#define LPC_IOCON_P0_20_SLEW_BIT 9
#define LPC_IOCON_P0_20_OD_MASK 0x400
#define LPC_IOCON_P0_20_OD 0x400
#define LPC_IOCON_P0_20_OD_BIT 10

#define LPC_IOCON_P0_21 (*(volatile unsigned long *)0x4002C054)
#define LPC_IOCON_P0_21_OFFSET 0x54
#define LPC_IOCON_P0_21_FUNC_MASK 0x7
#define LPC_IOCON_P0_21_FUNC_BIT 0
#define LPC_IOCON_P0_21_MODE_MASK 0x18
#define LPC_IOCON_P0_21_MODE_BIT 3
#define LPC_IOCON_P0_21_HYS_MASK 0x20
#define LPC_IOCON_P0_21_HYS 0x20
#define LPC_IOCON_P0_21_HYS_BIT 5
#define LPC_IOCON_P0_21_INV_MASK 0x40
#define LPC_IOCON_P0_21_INV 0x40
#define LPC_IOCON_P0_21_INV_BIT 6
#define LPC_IOCON_P0_21_SLEW_MASK 0x200
#define LPC_IOCON_P0_21_SLEW 0x200
#define LPC_IOCON_P0_21_SLEW_BIT 9
#define LPC_IOCON_P0_21_OD_MASK 0x400
#define LPC_IOCON_P0_21_OD 0x400
#define LPC_IOCON_P0_21_OD_BIT 10

#define LPC_IOCON_P0_22 (*(volatile unsigned long *)0x4002C058)
#define LPC_IOCON_P0_22_OFFSET 0x58
#define LPC_IOCON_P0_22_FUNC_MASK 0x7
#define LPC_IOCON_P0_22_FUNC_BIT 0
#define LPC_IOCON_P0_22_MODE_MASK 0x18
#define LPC_IOCON_P0_22_MODE_BIT 3
#define LPC_IOCON_P0_22_HYS_MASK 0x20
#define LPC_IOCON_P0_22_HYS 0x20
#define LPC_IOCON_P0_22_HYS_BIT 5
#define LPC_IOCON_P0_22_INV_MASK 0x40
#define LPC_IOCON_P0_22_INV 0x40
#define LPC_IOCON_P0_22_INV_BIT 6
#define LPC_IOCON_P0_22_ADMODE_MASK 0x80
#define LPC_IOCON_P0_22_ADMODE 0x80
#define LPC_IOCON_P0_22_ADMODE_BIT 7
#define LPC_IOCON_P0_22_FILTR_MASK 0x100
#define LPC_IOCON_P0_22_FILTR 0x100
#define LPC_IOCON_P0_22_FILTR_BIT 8
#define LPC_IOCON_P0_22_OD_MASK 0x400
#define LPC_IOCON_P0_22_OD 0x400
#define LPC_IOCON_P0_22_OD_BIT 10

#define LPC_IOCON_P0_23 (*(volatile unsigned long *)0x4002C05C)
#define LPC_IOCON_P0_23_OFFSET 0x5C
#define LPC_IOCON_P0_23_FUNC_MASK 0x7
#define LPC_IOCON_P0_23_FUNC_BIT 0

#define LPC_IOCON_P0_24 (*(volatile unsigned long *)0x4002C060)
#define LPC_IOCON_P0_24_OFFSET 0x60
#define LPC_IOCON_P0_24_FUNC_MASK 0x7
#define LPC_IOCON_P0_24_FUNC_BIT 0

#define LPC_IOCON_P0_25 (*(volatile unsigned long *)0x4002C064)
#define LPC_IOCON_P0_25_OFFSET 0x64
#define LPC_IOCON_P0_25_FUNC_MASK 0x7
#define LPC_IOCON_P0_25_FUNC_BIT 0

#define LPC_IOCON_P0_26 (*(volatile unsigned long *)0x4002C068)
#define LPC_IOCON_P0_26_OFFSET 0x68
#define LPC_IOCON_P0_26_FUNC_MASK 0x7
#define LPC_IOCON_P0_26_FUNC_BIT 0
#define LPC_IOCON_P0_26_MODE_MASK 0x18
#define LPC_IOCON_P0_26_MODE_BIT 3
#define LPC_IOCON_P0_26_HYS_MASK 0x20
#define LPC_IOCON_P0_26_HYS 0x20
#define LPC_IOCON_P0_26_HYS_BIT 5
#define LPC_IOCON_P0_26_INV_MASK 0x40
#define LPC_IOCON_P0_26_INV 0x40
#define LPC_IOCON_P0_26_INV_BIT 6
#define LPC_IOCON_P0_26_ADMODE_MASK 0x80
#define LPC_IOCON_P0_26_ADMODE 0x80
#define LPC_IOCON_P0_26_ADMODE_BIT 7
#define LPC_IOCON_P0_26_FILTR_MASK 0x100
#define LPC_IOCON_P0_26_FILTR 0x100
#define LPC_IOCON_P0_26_FILTR_BIT 8
#define LPC_IOCON_P0_26_OD_MASK 0x400
#define LPC_IOCON_P0_26_OD 0x400
#define LPC_IOCON_P0_26_OD_BIT 10
#define LPC_IOCON_P0_26_DACEN_MASK 0x10000
#define LPC_IOCON_P0_26_DACEN 0x10000
#define LPC_IOCON_P0_26_DACEN_BIT 16

#define LPC_IOCON_P0_27 (*(volatile unsigned long *)0x4002C06C)
#define LPC_IOCON_P0_27_OFFSET 0x6C
#define LPC_IOCON_P0_27_FUNC_MASK 0x7
#define LPC_IOCON_P0_27_FUNC_BIT 0
#define LPC_IOCON_P0_27_INV_MASK 0x40
#define LPC_IOCON_P0_27_INV 0x40
#define LPC_IOCON_P0_27_INV_BIT 6
#define LPC_IOCON_P0_27_HS_MASK 0x100
#define LPC_IOCON_P0_27_HS 0x100
#define LPC_IOCON_P0_27_HS_BIT 8
#define LPC_IOCON_P0_27_HIDRIVE_MASK 0x200
#define LPC_IOCON_P0_27_HIDRIVE 0x200
#define LPC_IOCON_P0_27_HIDRIVE_BIT 9

#define LPC_IOCON_P0_28 (*(volatile unsigned long *)0x4002C070)
#define LPC_IOCON_P0_28_OFFSET 0x70
#define LPC_IOCON_P0_28_FUNC_MASK 0x7
#define LPC_IOCON_P0_28_FUNC_BIT 0
#define LPC_IOCON_P0_28_INV_MASK 0x40
#define LPC_IOCON_P0_28_INV 0x40
#define LPC_IOCON_P0_28_INV_BIT 6
#define LPC_IOCON_P0_28_HS_MASK 0x100
#define LPC_IOCON_P0_28_HS 0x100
#define LPC_IOCON_P0_28_HS_BIT 8
#define LPC_IOCON_P0_28_HIDRIVE_MASK 0x200
#define LPC_IOCON_P0_28_HIDRIVE 0x200
#define LPC_IOCON_P0_28_HIDRIVE_BIT 9

#define LPC_IOCON_P0_29 (*(volatile unsigned long *)0x4002C074)
#define LPC_IOCON_P0_29_OFFSET 0x74
#define LPC_IOCON_P0_29_FUNC_MASK 0x7
#define LPC_IOCON_P0_29_FUNC_BIT 0

#define LPC_IOCON_P0_30 (*(volatile unsigned long *)0x4002C078)
#define LPC_IOCON_P0_30_OFFSET 0x78
#define LPC_IOCON_P0_30_FUNC_MASK 0x7
#define LPC_IOCON_P0_30_FUNC_BIT 0

#define LPC_IOCON_P0_31 (*(volatile unsigned long *)0x4002C07C)
#define LPC_IOCON_P0_31_OFFSET 0x7C
#define LPC_IOCON_P0_31_FUNC_MASK 0x7
#define LPC_IOCON_P0_31_FUNC_BIT 0

#define LPC_IOCON_P1_0 (*(volatile unsigned long *)0x4002C080)
#define LPC_IOCON_P1_0_OFFSET 0x80
#define LPC_IOCON_P1_0_FUNC_MASK 0x7
#define LPC_IOCON_P1_0_FUNC_BIT 0
#define LPC_IOCON_P1_0_MODE_MASK 0x18
#define LPC_IOCON_P1_0_MODE_BIT 3
#define LPC_IOCON_P1_0_HYS_MASK 0x20
#define LPC_IOCON_P1_0_HYS 0x20
#define LPC_IOCON_P1_0_HYS_BIT 5
#define LPC_IOCON_P1_0_INV_MASK 0x40
#define LPC_IOCON_P1_0_INV 0x40
#define LPC_IOCON_P1_0_INV_BIT 6
#define LPC_IOCON_P1_0_SLEW_MASK 0x200
#define LPC_IOCON_P1_0_SLEW 0x200
#define LPC_IOCON_P1_0_SLEW_BIT 9
#define LPC_IOCON_P1_0_OD_MASK 0x400
#define LPC_IOCON_P1_0_OD 0x400
#define LPC_IOCON_P1_0_OD_BIT 10

#define LPC_IOCON_P1_1 (*(volatile unsigned long *)0x4002C084)
#define LPC_IOCON_P1_1_OFFSET 0x84
#define LPC_IOCON_P1_1_FUNC_MASK 0x7
#define LPC_IOCON_P1_1_FUNC_BIT 0
#define LPC_IOCON_P1_1_MODE_MASK 0x18
#define LPC_IOCON_P1_1_MODE_BIT 3
#define LPC_IOCON_P1_1_HYS_MASK 0x20
#define LPC_IOCON_P1_1_HYS 0x20
#define LPC_IOCON_P1_1_HYS_BIT 5
#define LPC_IOCON_P1_1_INV_MASK 0x40
#define LPC_IOCON_P1_1_INV 0x40
#define LPC_IOCON_P1_1_INV_BIT 6
#define LPC_IOCON_P1_1_SLEW_MASK 0x200
#define LPC_IOCON_P1_1_SLEW 0x200
#define LPC_IOCON_P1_1_SLEW_BIT 9
#define LPC_IOCON_P1_1_OD_MASK 0x400
#define LPC_IOCON_P1_1_OD 0x400
#define LPC_IOCON_P1_1_OD_BIT 10

#define LPC_IOCON_P1_2 (*(volatile unsigned long *)0x4002C088)
#define LPC_IOCON_P1_2_OFFSET 0x88
#define LPC_IOCON_P1_2_FUNC_MASK 0x7
#define LPC_IOCON_P1_2_FUNC_BIT 0
#define LPC_IOCON_P1_2_MODE_MASK 0x18
#define LPC_IOCON_P1_2_MODE_BIT 3
#define LPC_IOCON_P1_2_HYS_MASK 0x20
#define LPC_IOCON_P1_2_HYS 0x20
#define LPC_IOCON_P1_2_HYS_BIT 5
#define LPC_IOCON_P1_2_INV_MASK 0x40
#define LPC_IOCON_P1_2_INV 0x40
#define LPC_IOCON_P1_2_INV_BIT 6
#define LPC_IOCON_P1_2_SLEW_MASK 0x200
#define LPC_IOCON_P1_2_SLEW 0x200
#define LPC_IOCON_P1_2_SLEW_BIT 9
#define LPC_IOCON_P1_2_OD_MASK 0x400
#define LPC_IOCON_P1_2_OD 0x400
#define LPC_IOCON_P1_2_OD_BIT 10

#define LPC_IOCON_P1_3 (*(volatile unsigned long *)0x4002C08C)
#define LPC_IOCON_P1_3_OFFSET 0x8C
#define LPC_IOCON_P1_3_FUNC_MASK 0x7
#define LPC_IOCON_P1_3_FUNC_BIT 0
#define LPC_IOCON_P1_3_MODE_MASK 0x18
#define LPC_IOCON_P1_3_MODE_BIT 3
#define LPC_IOCON_P1_3_HYS_MASK 0x20
#define LPC_IOCON_P1_3_HYS 0x20
#define LPC_IOCON_P1_3_HYS_BIT 5
#define LPC_IOCON_P1_3_INV_MASK 0x40
#define LPC_IOCON_P1_3_INV 0x40
#define LPC_IOCON_P1_3_INV_BIT 6
#define LPC_IOCON_P1_3_SLEW_MASK 0x200
#define LPC_IOCON_P1_3_SLEW 0x200
#define LPC_IOCON_P1_3_SLEW_BIT 9
#define LPC_IOCON_P1_3_OD_MASK 0x400
#define LPC_IOCON_P1_3_OD 0x400
#define LPC_IOCON_P1_3_OD_BIT 10

#define LPC_IOCON_P1_4 (*(volatile unsigned long *)0x4002C090)
#define LPC_IOCON_P1_4_OFFSET 0x90
#define LPC_IOCON_P1_4_FUNC_MASK 0x7
#define LPC_IOCON_P1_4_FUNC_BIT 0
#define LPC_IOCON_P1_4_MODE_MASK 0x18
#define LPC_IOCON_P1_4_MODE_BIT 3
#define LPC_IOCON_P1_4_HYS_MASK 0x20
#define LPC_IOCON_P1_4_HYS 0x20
#define LPC_IOCON_P1_4_HYS_BIT 5
#define LPC_IOCON_P1_4_INV_MASK 0x40
#define LPC_IOCON_P1_4_INV 0x40
#define LPC_IOCON_P1_4_INV_BIT 6
#define LPC_IOCON_P1_4_SLEW_MASK 0x200
#define LPC_IOCON_P1_4_SLEW 0x200
#define LPC_IOCON_P1_4_SLEW_BIT 9
#define LPC_IOCON_P1_4_OD_MASK 0x400
#define LPC_IOCON_P1_4_OD 0x400
#define LPC_IOCON_P1_4_OD_BIT 10

#define LPC_IOCON_P1_5 (*(volatile unsigned long *)0x4002C094)
#define LPC_IOCON_P1_5_OFFSET 0x94
#define LPC_IOCON_P1_5_FUNC_MASK 0x7
#define LPC_IOCON_P1_5_FUNC_BIT 0
#define LPC_IOCON_P1_5_MODE_MASK 0x18
#define LPC_IOCON_P1_5_MODE_BIT 3
#define LPC_IOCON_P1_5_HYS_MASK 0x20
#define LPC_IOCON_P1_5_HYS 0x20
#define LPC_IOCON_P1_5_HYS_BIT 5
#define LPC_IOCON_P1_5_INV_MASK 0x40
#define LPC_IOCON_P1_5_INV 0x40
#define LPC_IOCON_P1_5_INV_BIT 6
#define LPC_IOCON_P1_5_SLEW_MASK 0x200
#define LPC_IOCON_P1_5_SLEW 0x200
#define LPC_IOCON_P1_5_SLEW_BIT 9
#define LPC_IOCON_P1_5_OD_MASK 0x400
#define LPC_IOCON_P1_5_OD 0x400
#define LPC_IOCON_P1_5_OD_BIT 10

#define LPC_IOCON_P1_6 (*(volatile unsigned long *)0x4002C098)
#define LPC_IOCON_P1_6_OFFSET 0x98
#define LPC_IOCON_P1_6_FUNC_MASK 0x7
#define LPC_IOCON_P1_6_FUNC_BIT 0
#define LPC_IOCON_P1_6_MODE_MASK 0x18
#define LPC_IOCON_P1_6_MODE_BIT 3
#define LPC_IOCON_P1_6_HYS_MASK 0x20
#define LPC_IOCON_P1_6_HYS 0x20
#define LPC_IOCON_P1_6_HYS_BIT 5
#define LPC_IOCON_P1_6_INV_MASK 0x40
#define LPC_IOCON_P1_6_INV 0x40
#define LPC_IOCON_P1_6_INV_BIT 6
#define LPC_IOCON_P1_6_SLEW_MASK 0x200
#define LPC_IOCON_P1_6_SLEW 0x200
#define LPC_IOCON_P1_6_SLEW_BIT 9
#define LPC_IOCON_P1_6_OD_MASK 0x400
#define LPC_IOCON_P1_6_OD 0x400
#define LPC_IOCON_P1_6_OD_BIT 10

#define LPC_IOCON_P1_7 (*(volatile unsigned long *)0x4002C09C)
#define LPC_IOCON_P1_7_OFFSET 0x9C
#define LPC_IOCON_P1_7_FUNC_MASK 0x7
#define LPC_IOCON_P1_7_FUNC_BIT 0
#define LPC_IOCON_P1_7_MODE_MASK 0x18
#define LPC_IOCON_P1_7_MODE_BIT 3
#define LPC_IOCON_P1_7_HYS_MASK 0x20
#define LPC_IOCON_P1_7_HYS 0x20
#define LPC_IOCON_P1_7_HYS_BIT 5
#define LPC_IOCON_P1_7_INV_MASK 0x40
#define LPC_IOCON_P1_7_INV 0x40
#define LPC_IOCON_P1_7_INV_BIT 6
#define LPC_IOCON_P1_7_SLEW_MASK 0x200
#define LPC_IOCON_P1_7_SLEW 0x200
#define LPC_IOCON_P1_7_SLEW_BIT 9
#define LPC_IOCON_P1_7_OD_MASK 0x400
#define LPC_IOCON_P1_7_OD 0x400
#define LPC_IOCON_P1_7_OD_BIT 10

#define LPC_IOCON_P1_8 (*(volatile unsigned long *)0x4002C0A0)
#define LPC_IOCON_P1_8_OFFSET 0xA0
#define LPC_IOCON_P1_8_FUNC_MASK 0x7
#define LPC_IOCON_P1_8_FUNC_BIT 0
#define LPC_IOCON_P1_8_MODE_MASK 0x18
#define LPC_IOCON_P1_8_MODE_BIT 3
#define LPC_IOCON_P1_8_HYS_MASK 0x20
#define LPC_IOCON_P1_8_HYS 0x20
#define LPC_IOCON_P1_8_HYS_BIT 5
#define LPC_IOCON_P1_8_INV_MASK 0x40
#define LPC_IOCON_P1_8_INV 0x40
#define LPC_IOCON_P1_8_INV_BIT 6
#define LPC_IOCON_P1_8_SLEW_MASK 0x200
#define LPC_IOCON_P1_8_SLEW 0x200
#define LPC_IOCON_P1_8_SLEW_BIT 9
#define LPC_IOCON_P1_8_OD_MASK 0x400
#define LPC_IOCON_P1_8_OD 0x400
#define LPC_IOCON_P1_8_OD_BIT 10

#define LPC_IOCON_P1_9 (*(volatile unsigned long *)0x4002C0A4)
#define LPC_IOCON_P1_9_OFFSET 0xA4
#define LPC_IOCON_P1_9_FUNC_MASK 0x7
#define LPC_IOCON_P1_9_FUNC_BIT 0
#define LPC_IOCON_P1_9_MODE_MASK 0x18
#define LPC_IOCON_P1_9_MODE_BIT 3
#define LPC_IOCON_P1_9_HYS_MASK 0x20
#define LPC_IOCON_P1_9_HYS 0x20
#define LPC_IOCON_P1_9_HYS_BIT 5
#define LPC_IOCON_P1_9_INV_MASK 0x40
#define LPC_IOCON_P1_9_INV 0x40
#define LPC_IOCON_P1_9_INV_BIT 6
#define LPC_IOCON_P1_9_SLEW_MASK 0x200
#define LPC_IOCON_P1_9_SLEW 0x200
#define LPC_IOCON_P1_9_SLEW_BIT 9
#define LPC_IOCON_P1_9_OD_MASK 0x400
#define LPC_IOCON_P1_9_OD 0x400
#define LPC_IOCON_P1_9_OD_BIT 10

#define LPC_IOCON_P1_10 (*(volatile unsigned long *)0x4002C0A8)
#define LPC_IOCON_P1_10_OFFSET 0xA8
#define LPC_IOCON_P1_10_FUNC_MASK 0x7
#define LPC_IOCON_P1_10_FUNC_BIT 0
#define LPC_IOCON_P1_10_MODE_MASK 0x18
#define LPC_IOCON_P1_10_MODE_BIT 3
#define LPC_IOCON_P1_10_HYS_MASK 0x20
#define LPC_IOCON_P1_10_HYS 0x20
#define LPC_IOCON_P1_10_HYS_BIT 5
#define LPC_IOCON_P1_10_INV_MASK 0x40
#define LPC_IOCON_P1_10_INV 0x40
#define LPC_IOCON_P1_10_INV_BIT 6
#define LPC_IOCON_P1_10_SLEW_MASK 0x200
#define LPC_IOCON_P1_10_SLEW 0x200
#define LPC_IOCON_P1_10_SLEW_BIT 9
#define LPC_IOCON_P1_10_OD_MASK 0x400
#define LPC_IOCON_P1_10_OD 0x400
#define LPC_IOCON_P1_10_OD_BIT 10

#define LPC_IOCON_P1_11 (*(volatile unsigned long *)0x4002C0AC)
#define LPC_IOCON_P1_11_OFFSET 0xAC
#define LPC_IOCON_P1_11_FUNC_MASK 0x7
#define LPC_IOCON_P1_11_FUNC_BIT 0
#define LPC_IOCON_P1_11_MODE_MASK 0x18
#define LPC_IOCON_P1_11_MODE_BIT 3
#define LPC_IOCON_P1_11_HYS_MASK 0x20
#define LPC_IOCON_P1_11_HYS 0x20
#define LPC_IOCON_P1_11_HYS_BIT 5
#define LPC_IOCON_P1_11_INV_MASK 0x40
#define LPC_IOCON_P1_11_INV 0x40
#define LPC_IOCON_P1_11_INV_BIT 6
#define LPC_IOCON_P1_11_SLEW_MASK 0x200
#define LPC_IOCON_P1_11_SLEW 0x200
#define LPC_IOCON_P1_11_SLEW_BIT 9
#define LPC_IOCON_P1_11_OD_MASK 0x400
#define LPC_IOCON_P1_11_OD 0x400
#define LPC_IOCON_P1_11_OD_BIT 10

#define LPC_IOCON_P1_12 (*(volatile unsigned long *)0x4002C0B0)
#define LPC_IOCON_P1_12_OFFSET 0xB0
#define LPC_IOCON_P1_12_FUNC_MASK 0x7
#define LPC_IOCON_P1_12_FUNC_BIT 0
#define LPC_IOCON_P1_12_MODE_MASK 0x18
#define LPC_IOCON_P1_12_MODE_BIT 3
#define LPC_IOCON_P1_12_HYS_MASK 0x20
#define LPC_IOCON_P1_12_HYS 0x20
#define LPC_IOCON_P1_12_HYS_BIT 5
#define LPC_IOCON_P1_12_INV_MASK 0x40
#define LPC_IOCON_P1_12_INV 0x40
#define LPC_IOCON_P1_12_INV_BIT 6
#define LPC_IOCON_P1_12_SLEW_MASK 0x200
#define LPC_IOCON_P1_12_SLEW 0x200
#define LPC_IOCON_P1_12_SLEW_BIT 9
#define LPC_IOCON_P1_12_OD_MASK 0x400
#define LPC_IOCON_P1_12_OD 0x400
#define LPC_IOCON_P1_12_OD_BIT 10

#define LPC_IOCON_P1_13 (*(volatile unsigned long *)0x4002C0B4)
#define LPC_IOCON_P1_13_OFFSET 0xB4
#define LPC_IOCON_P1_13_FUNC_MASK 0x7
#define LPC_IOCON_P1_13_FUNC_BIT 0
#define LPC_IOCON_P1_13_MODE_MASK 0x18
#define LPC_IOCON_P1_13_MODE_BIT 3
#define LPC_IOCON_P1_13_HYS_MASK 0x20
#define LPC_IOCON_P1_13_HYS 0x20
#define LPC_IOCON_P1_13_HYS_BIT 5
#define LPC_IOCON_P1_13_INV_MASK 0x40
#define LPC_IOCON_P1_13_INV 0x40
#define LPC_IOCON_P1_13_INV_BIT 6
#define LPC_IOCON_P1_13_SLEW_MASK 0x200
#define LPC_IOCON_P1_13_SLEW 0x200
#define LPC_IOCON_P1_13_SLEW_BIT 9
#define LPC_IOCON_P1_13_OD_MASK 0x400
#define LPC_IOCON_P1_13_OD 0x400
#define LPC_IOCON_P1_13_OD_BIT 10

#define LPC_IOCON_P1_14 (*(volatile unsigned long *)0x4002C0B8)
#define LPC_IOCON_P1_14_OFFSET 0xB8
#define LPC_IOCON_P1_14_FUNC_MASK 0x7
#define LPC_IOCON_P1_14_FUNC_BIT 0
#define LPC_IOCON_P1_14_MODE_MASK 0x18
#define LPC_IOCON_P1_14_MODE_BIT 3
#define LPC_IOCON_P1_14_HYS_MASK 0x20
#define LPC_IOCON_P1_14_HYS 0x20
#define LPC_IOCON_P1_14_HYS_BIT 5
#define LPC_IOCON_P1_14_INV_MASK 0x40
#define LPC_IOCON_P1_14_INV 0x40
#define LPC_IOCON_P1_14_INV_BIT 6
#define LPC_IOCON_P1_14_SLEW_MASK 0x200
#define LPC_IOCON_P1_14_SLEW 0x200
#define LPC_IOCON_P1_14_SLEW_BIT 9
#define LPC_IOCON_P1_14_OD_MASK 0x400
#define LPC_IOCON_P1_14_OD 0x400
#define LPC_IOCON_P1_14_OD_BIT 10

#define LPC_IOCON_P1_15 (*(volatile unsigned long *)0x4002C0BC)
#define LPC_IOCON_P1_15_OFFSET 0xBC
#define LPC_IOCON_P1_15_FUNC_MASK 0x7
#define LPC_IOCON_P1_15_FUNC_BIT 0
#define LPC_IOCON_P1_15_MODE_MASK 0x18
#define LPC_IOCON_P1_15_MODE_BIT 3
#define LPC_IOCON_P1_15_HYS_MASK 0x20
#define LPC_IOCON_P1_15_HYS 0x20
#define LPC_IOCON_P1_15_HYS_BIT 5
#define LPC_IOCON_P1_15_INV_MASK 0x40
#define LPC_IOCON_P1_15_INV 0x40
#define LPC_IOCON_P1_15_INV_BIT 6
#define LPC_IOCON_P1_15_SLEW_MASK 0x200
#define LPC_IOCON_P1_15_SLEW 0x200
#define LPC_IOCON_P1_15_SLEW_BIT 9
#define LPC_IOCON_P1_15_OD_MASK 0x400
#define LPC_IOCON_P1_15_OD 0x400
#define LPC_IOCON_P1_15_OD_BIT 10

#define LPC_IOCON_P1_16 (*(volatile unsigned long *)0x4002C0C0)
#define LPC_IOCON_P1_16_OFFSET 0xC0
#define LPC_IOCON_P1_16_FUNC_MASK 0x7
#define LPC_IOCON_P1_16_FUNC_BIT 0
#define LPC_IOCON_P1_16_MODE_MASK 0x18
#define LPC_IOCON_P1_16_MODE_BIT 3
#define LPC_IOCON_P1_16_HYS_MASK 0x20
#define LPC_IOCON_P1_16_HYS 0x20
#define LPC_IOCON_P1_16_HYS_BIT 5
#define LPC_IOCON_P1_16_INV_MASK 0x40
#define LPC_IOCON_P1_16_INV 0x40
#define LPC_IOCON_P1_16_INV_BIT 6
#define LPC_IOCON_P1_16_SLEW_MASK 0x200
#define LPC_IOCON_P1_16_SLEW 0x200
#define LPC_IOCON_P1_16_SLEW_BIT 9
#define LPC_IOCON_P1_16_OD_MASK 0x400
#define LPC_IOCON_P1_16_OD 0x400
#define LPC_IOCON_P1_16_OD_BIT 10

#define LPC_IOCON_P1_17 (*(volatile unsigned long *)0x4002C0C4)
#define LPC_IOCON_P1_17_OFFSET 0xC4
#define LPC_IOCON_P1_17_FUNC_MASK 0x7
#define LPC_IOCON_P1_17_FUNC_BIT 0
#define LPC_IOCON_P1_17_MODE_MASK 0x18
#define LPC_IOCON_P1_17_MODE_BIT 3
#define LPC_IOCON_P1_17_HYS_MASK 0x20
#define LPC_IOCON_P1_17_HYS 0x20
#define LPC_IOCON_P1_17_HYS_BIT 5
#define LPC_IOCON_P1_17_INV_MASK 0x40
#define LPC_IOCON_P1_17_INV 0x40
#define LPC_IOCON_P1_17_INV_BIT 6
#define LPC_IOCON_P1_17_SLEW_MASK 0x200
#define LPC_IOCON_P1_17_SLEW 0x200
#define LPC_IOCON_P1_17_SLEW_BIT 9
#define LPC_IOCON_P1_17_OD_MASK 0x400
#define LPC_IOCON_P1_17_OD 0x400
#define LPC_IOCON_P1_17_OD_BIT 10

#define LPC_IOCON_P1_18 (*(volatile unsigned long *)0x4002C0C8)
#define LPC_IOCON_P1_18_OFFSET 0xC8
#define LPC_IOCON_P1_18_FUNC_MASK 0x7
#define LPC_IOCON_P1_18_FUNC_BIT 0
#define LPC_IOCON_P1_18_MODE_MASK 0x18
#define LPC_IOCON_P1_18_MODE_BIT 3
#define LPC_IOCON_P1_18_HYS_MASK 0x20
#define LPC_IOCON_P1_18_HYS 0x20
#define LPC_IOCON_P1_18_HYS_BIT 5
#define LPC_IOCON_P1_18_INV_MASK 0x40
#define LPC_IOCON_P1_18_INV 0x40
#define LPC_IOCON_P1_18_INV_BIT 6
#define LPC_IOCON_P1_18_SLEW_MASK 0x200
#define LPC_IOCON_P1_18_SLEW 0x200
#define LPC_IOCON_P1_18_SLEW_BIT 9
#define LPC_IOCON_P1_18_OD_MASK 0x400
#define LPC_IOCON_P1_18_OD 0x400
#define LPC_IOCON_P1_18_OD_BIT 10

#define LPC_IOCON_P1_19 (*(volatile unsigned long *)0x4002C0CC)
#define LPC_IOCON_P1_19_OFFSET 0xCC
#define LPC_IOCON_P1_19_FUNC_MASK 0x7
#define LPC_IOCON_P1_19_FUNC_BIT 0
#define LPC_IOCON_P1_19_MODE_MASK 0x18
#define LPC_IOCON_P1_19_MODE_BIT 3
#define LPC_IOCON_P1_19_HYS_MASK 0x20
#define LPC_IOCON_P1_19_HYS 0x20
#define LPC_IOCON_P1_19_HYS_BIT 5
#define LPC_IOCON_P1_19_INV_MASK 0x40
#define LPC_IOCON_P1_19_INV 0x40
#define LPC_IOCON_P1_19_INV_BIT 6
#define LPC_IOCON_P1_19_SLEW_MASK 0x200
#define LPC_IOCON_P1_19_SLEW 0x200
#define LPC_IOCON_P1_19_SLEW_BIT 9
#define LPC_IOCON_P1_19_OD_MASK 0x400
#define LPC_IOCON_P1_19_OD 0x400
#define LPC_IOCON_P1_19_OD_BIT 10

#define LPC_IOCON_P1_20 (*(volatile unsigned long *)0x4002C0D0)
#define LPC_IOCON_P1_20_OFFSET 0xD0
#define LPC_IOCON_P1_20_FUNC_MASK 0x7
#define LPC_IOCON_P1_20_FUNC_BIT 0
#define LPC_IOCON_P1_20_MODE_MASK 0x18
#define LPC_IOCON_P1_20_MODE_BIT 3
#define LPC_IOCON_P1_20_HYS_MASK 0x20
#define LPC_IOCON_P1_20_HYS 0x20
#define LPC_IOCON_P1_20_HYS_BIT 5
#define LPC_IOCON_P1_20_INV_MASK 0x40
#define LPC_IOCON_P1_20_INV 0x40
#define LPC_IOCON_P1_20_INV_BIT 6
#define LPC_IOCON_P1_20_SLEW_MASK 0x200
#define LPC_IOCON_P1_20_SLEW 0x200
#define LPC_IOCON_P1_20_SLEW_BIT 9
#define LPC_IOCON_P1_20_OD_MASK 0x400
#define LPC_IOCON_P1_20_OD 0x400
#define LPC_IOCON_P1_20_OD_BIT 10

#define LPC_IOCON_P1_21 (*(volatile unsigned long *)0x4002C0D4)
#define LPC_IOCON_P1_21_OFFSET 0xD4
#define LPC_IOCON_P1_21_FUNC_MASK 0x7
#define LPC_IOCON_P1_21_FUNC_BIT 0
#define LPC_IOCON_P1_21_MODE_MASK 0x18
#define LPC_IOCON_P1_21_MODE_BIT 3
#define LPC_IOCON_P1_21_HYS_MASK 0x20
#define LPC_IOCON_P1_21_HYS 0x20
#define LPC_IOCON_P1_21_HYS_BIT 5
#define LPC_IOCON_P1_21_INV_MASK 0x40
#define LPC_IOCON_P1_21_INV 0x40
#define LPC_IOCON_P1_21_INV_BIT 6
#define LPC_IOCON_P1_21_SLEW_MASK 0x200
#define LPC_IOCON_P1_21_SLEW 0x200
#define LPC_IOCON_P1_21_SLEW_BIT 9
#define LPC_IOCON_P1_21_OD_MASK 0x400
#define LPC_IOCON_P1_21_OD 0x400
#define LPC_IOCON_P1_21_OD_BIT 10

#define LPC_IOCON_P1_22 (*(volatile unsigned long *)0x4002C0D8)
#define LPC_IOCON_P1_22_OFFSET 0xD8
#define LPC_IOCON_P1_22_FUNC_MASK 0x7
#define LPC_IOCON_P1_22_FUNC_BIT 0
#define LPC_IOCON_P1_22_MODE_MASK 0x18
#define LPC_IOCON_P1_22_MODE_BIT 3
#define LPC_IOCON_P1_22_HYS_MASK 0x20
#define LPC_IOCON_P1_22_HYS 0x20
#define LPC_IOCON_P1_22_HYS_BIT 5
#define LPC_IOCON_P1_22_INV_MASK 0x40
#define LPC_IOCON_P1_22_INV 0x40
#define LPC_IOCON_P1_22_INV_BIT 6
#define LPC_IOCON_P1_22_SLEW_MASK 0x200
#define LPC_IOCON_P1_22_SLEW 0x200
#define LPC_IOCON_P1_22_SLEW_BIT 9
#define LPC_IOCON_P1_22_OD_MASK 0x400
#define LPC_IOCON_P1_22_OD 0x400
#define LPC_IOCON_P1_22_OD_BIT 10

#define LPC_IOCON_P1_23 (*(volatile unsigned long *)0x4002C0DC)
#define LPC_IOCON_P1_23_OFFSET 0xDC
#define LPC_IOCON_P1_23_FUNC_MASK 0x7
#define LPC_IOCON_P1_23_FUNC_BIT 0
#define LPC_IOCON_P1_23_MODE_MASK 0x18
#define LPC_IOCON_P1_23_MODE_BIT 3
#define LPC_IOCON_P1_23_HYS_MASK 0x20
#define LPC_IOCON_P1_23_HYS 0x20
#define LPC_IOCON_P1_23_HYS_BIT 5
#define LPC_IOCON_P1_23_INV_MASK 0x40
#define LPC_IOCON_P1_23_INV 0x40
#define LPC_IOCON_P1_23_INV_BIT 6
#define LPC_IOCON_P1_23_SLEW_MASK 0x200
#define LPC_IOCON_P1_23_SLEW 0x200
#define LPC_IOCON_P1_23_SLEW_BIT 9
#define LPC_IOCON_P1_23_OD_MASK 0x400
#define LPC_IOCON_P1_23_OD 0x400
#define LPC_IOCON_P1_23_OD_BIT 10

#define LPC_IOCON_P1_24 (*(volatile unsigned long *)0x4002C0E0)
#define LPC_IOCON_P1_24_OFFSET 0xE0
#define LPC_IOCON_P1_24_FUNC_MASK 0x7
#define LPC_IOCON_P1_24_FUNC_BIT 0
#define LPC_IOCON_P1_24_MODE_MASK 0x18
#define LPC_IOCON_P1_24_MODE_BIT 3
#define LPC_IOCON_P1_24_HYS_MASK 0x20
#define LPC_IOCON_P1_24_HYS 0x20
#define LPC_IOCON_P1_24_HYS_BIT 5
#define LPC_IOCON_P1_24_INV_MASK 0x40
#define LPC_IOCON_P1_24_INV 0x40
#define LPC_IOCON_P1_24_INV_BIT 6
#define LPC_IOCON_P1_24_SLEW_MASK 0x200
#define LPC_IOCON_P1_24_SLEW 0x200
#define LPC_IOCON_P1_24_SLEW_BIT 9
#define LPC_IOCON_P1_24_OD_MASK 0x400
#define LPC_IOCON_P1_24_OD 0x400
#define LPC_IOCON_P1_24_OD_BIT 10

#define LPC_IOCON_P1_25 (*(volatile unsigned long *)0x4002C0E4)
#define LPC_IOCON_P1_25_OFFSET 0xE4
#define LPC_IOCON_P1_25_FUNC_MASK 0x7
#define LPC_IOCON_P1_25_FUNC_BIT 0
#define LPC_IOCON_P1_25_MODE_MASK 0x18
#define LPC_IOCON_P1_25_MODE_BIT 3
#define LPC_IOCON_P1_25_HYS_MASK 0x20
#define LPC_IOCON_P1_25_HYS 0x20
#define LPC_IOCON_P1_25_HYS_BIT 5
#define LPC_IOCON_P1_25_INV_MASK 0x40
#define LPC_IOCON_P1_25_INV 0x40
#define LPC_IOCON_P1_25_INV_BIT 6
#define LPC_IOCON_P1_25_SLEW_MASK 0x200
#define LPC_IOCON_P1_25_SLEW 0x200
#define LPC_IOCON_P1_25_SLEW_BIT 9
#define LPC_IOCON_P1_25_OD_MASK 0x400
#define LPC_IOCON_P1_25_OD 0x400
#define LPC_IOCON_P1_25_OD_BIT 10

#define LPC_IOCON_P1_26 (*(volatile unsigned long *)0x4002C0E8)
#define LPC_IOCON_P1_26_OFFSET 0xE8
#define LPC_IOCON_P1_26_FUNC_MASK 0x7
#define LPC_IOCON_P1_26_FUNC_BIT 0
#define LPC_IOCON_P1_26_MODE_MASK 0x18
#define LPC_IOCON_P1_26_MODE_BIT 3
#define LPC_IOCON_P1_26_HYS_MASK 0x20
#define LPC_IOCON_P1_26_HYS 0x20
#define LPC_IOCON_P1_26_HYS_BIT 5
#define LPC_IOCON_P1_26_INV_MASK 0x40
#define LPC_IOCON_P1_26_INV 0x40
#define LPC_IOCON_P1_26_INV_BIT 6
#define LPC_IOCON_P1_26_SLEW_MASK 0x200
#define LPC_IOCON_P1_26_SLEW 0x200
#define LPC_IOCON_P1_26_SLEW_BIT 9
#define LPC_IOCON_P1_26_OD_MASK 0x400
#define LPC_IOCON_P1_26_OD 0x400
#define LPC_IOCON_P1_26_OD_BIT 10

#define LPC_IOCON_P1_27 (*(volatile unsigned long *)0x4002C0EC)
#define LPC_IOCON_P1_27_OFFSET 0xEC
#define LPC_IOCON_P1_27_FUNC_MASK 0x7
#define LPC_IOCON_P1_27_FUNC_BIT 0
#define LPC_IOCON_P1_27_MODE_MASK 0x18
#define LPC_IOCON_P1_27_MODE_BIT 3
#define LPC_IOCON_P1_27_HYS_MASK 0x20
#define LPC_IOCON_P1_27_HYS 0x20
#define LPC_IOCON_P1_27_HYS_BIT 5
#define LPC_IOCON_P1_27_INV_MASK 0x40
#define LPC_IOCON_P1_27_INV 0x40
#define LPC_IOCON_P1_27_INV_BIT 6
#define LPC_IOCON_P1_27_SLEW_MASK 0x200
#define LPC_IOCON_P1_27_SLEW 0x200
#define LPC_IOCON_P1_27_SLEW_BIT 9
#define LPC_IOCON_P1_27_OD_MASK 0x400
#define LPC_IOCON_P1_27_OD 0x400
#define LPC_IOCON_P1_27_OD_BIT 10

#define LPC_IOCON_P1_28 (*(volatile unsigned long *)0x4002C0F0)
#define LPC_IOCON_P1_28_OFFSET 0xF0
#define LPC_IOCON_P1_28_FUNC_MASK 0x7
#define LPC_IOCON_P1_28_FUNC_BIT 0
#define LPC_IOCON_P1_28_MODE_MASK 0x18
#define LPC_IOCON_P1_28_MODE_BIT 3
#define LPC_IOCON_P1_28_HYS_MASK 0x20
#define LPC_IOCON_P1_28_HYS 0x20
#define LPC_IOCON_P1_28_HYS_BIT 5
#define LPC_IOCON_P1_28_INV_MASK 0x40
#define LPC_IOCON_P1_28_INV 0x40
#define LPC_IOCON_P1_28_INV_BIT 6
#define LPC_IOCON_P1_28_SLEW_MASK 0x200
#define LPC_IOCON_P1_28_SLEW 0x200
#define LPC_IOCON_P1_28_SLEW_BIT 9
#define LPC_IOCON_P1_28_OD_MASK 0x400
#define LPC_IOCON_P1_28_OD 0x400
#define LPC_IOCON_P1_28_OD_BIT 10

#define LPC_IOCON_P1_29 (*(volatile unsigned long *)0x4002C0F4)
#define LPC_IOCON_P1_29_OFFSET 0xF4
#define LPC_IOCON_P1_29_FUNC_MASK 0x7
#define LPC_IOCON_P1_29_FUNC_BIT 0
#define LPC_IOCON_P1_29_MODE_MASK 0x18
#define LPC_IOCON_P1_29_MODE_BIT 3
#define LPC_IOCON_P1_29_HYS_MASK 0x20
#define LPC_IOCON_P1_29_HYS 0x20
#define LPC_IOCON_P1_29_HYS_BIT 5
#define LPC_IOCON_P1_29_INV_MASK 0x40
#define LPC_IOCON_P1_29_INV 0x40
#define LPC_IOCON_P1_29_INV_BIT 6
#define LPC_IOCON_P1_29_SLEW_MASK 0x200
#define LPC_IOCON_P1_29_SLEW 0x200
#define LPC_IOCON_P1_29_SLEW_BIT 9
#define LPC_IOCON_P1_29_OD_MASK 0x400
#define LPC_IOCON_P1_29_OD 0x400
#define LPC_IOCON_P1_29_OD_BIT 10

#define LPC_IOCON_P1_30 (*(volatile unsigned long *)0x4002C0F8)
#define LPC_IOCON_P1_30_OFFSET 0xF8
#define LPC_IOCON_P1_30_FUNC_MASK 0x7
#define LPC_IOCON_P1_30_FUNC_BIT 0

#define LPC_IOCON_P1_31 (*(volatile unsigned long *)0x4002C0FC)
#define LPC_IOCON_P1_31_OFFSET 0xFC
#define LPC_IOCON_P1_31_FUNC_MASK 0x7
#define LPC_IOCON_P1_31_FUNC_BIT 0

#define LPC_IOCON_P2_0 (*(volatile unsigned long *)0x4002C100)
#define LPC_IOCON_P2_0_OFFSET 0x100
#define LPC_IOCON_P2_0_FUNC_MASK 0x7
#define LPC_IOCON_P2_0_FUNC_BIT 0
#define LPC_IOCON_P2_0_MODE_MASK 0x18
#define LPC_IOCON_P2_0_MODE_BIT 3
#define LPC_IOCON_P2_0_HYS_MASK 0x20
#define LPC_IOCON_P2_0_HYS 0x20
#define LPC_IOCON_P2_0_HYS_BIT 5
#define LPC_IOCON_P2_0_INV_MASK 0x40
#define LPC_IOCON_P2_0_INV 0x40
#define LPC_IOCON_P2_0_INV_BIT 6
#define LPC_IOCON_P2_0_SLEW_MASK 0x200
#define LPC_IOCON_P2_0_SLEW 0x200
#define LPC_IOCON_P2_0_SLEW_BIT 9
#define LPC_IOCON_P2_0_OD_MASK 0x400
#define LPC_IOCON_P2_0_OD 0x400
#define LPC_IOCON_P2_0_OD_BIT 10

#define LPC_IOCON_P2_1 (*(volatile unsigned long *)0x4002C104)
#define LPC_IOCON_P2_1_OFFSET 0x104
#define LPC_IOCON_P2_1_FUNC_MASK 0x7
#define LPC_IOCON_P2_1_FUNC_BIT 0
#define LPC_IOCON_P2_1_MODE_MASK 0x18
#define LPC_IOCON_P2_1_MODE_BIT 3
#define LPC_IOCON_P2_1_HYS_MASK 0x20
#define LPC_IOCON_P2_1_HYS 0x20
#define LPC_IOCON_P2_1_HYS_BIT 5
#define LPC_IOCON_P2_1_INV_MASK 0x40
#define LPC_IOCON_P2_1_INV 0x40
#define LPC_IOCON_P2_1_INV_BIT 6
#define LPC_IOCON_P2_1_SLEW_MASK 0x200
#define LPC_IOCON_P2_1_SLEW 0x200
#define LPC_IOCON_P2_1_SLEW_BIT 9
#define LPC_IOCON_P2_1_OD_MASK 0x400
#define LPC_IOCON_P2_1_OD 0x400
#define LPC_IOCON_P2_1_OD_BIT 10

#define LPC_IOCON_P2_2 (*(volatile unsigned long *)0x4002C108)
#define LPC_IOCON_P2_2_OFFSET 0x108
#define LPC_IOCON_P2_2_FUNC_MASK 0x7
#define LPC_IOCON_P2_2_FUNC_BIT 0
#define LPC_IOCON_P2_2_MODE_MASK 0x18
#define LPC_IOCON_P2_2_MODE_BIT 3
#define LPC_IOCON_P2_2_HYS_MASK 0x20
#define LPC_IOCON_P2_2_HYS 0x20
#define LPC_IOCON_P2_2_HYS_BIT 5
#define LPC_IOCON_P2_2_INV_MASK 0x40
#define LPC_IOCON_P2_2_INV 0x40
#define LPC_IOCON_P2_2_INV_BIT 6
#define LPC_IOCON_P2_2_SLEW_MASK 0x200
#define LPC_IOCON_P2_2_SLEW 0x200
#define LPC_IOCON_P2_2_SLEW_BIT 9
#define LPC_IOCON_P2_2_OD_MASK 0x400
#define LPC_IOCON_P2_2_OD 0x400
#define LPC_IOCON_P2_2_OD_BIT 10

#define LPC_IOCON_P2_3 (*(volatile unsigned long *)0x4002C10C)
#define LPC_IOCON_P2_3_OFFSET 0x10C
#define LPC_IOCON_P2_3_FUNC_MASK 0x7
#define LPC_IOCON_P2_3_FUNC_BIT 0
#define LPC_IOCON_P2_3_MODE_MASK 0x18
#define LPC_IOCON_P2_3_MODE_BIT 3
#define LPC_IOCON_P2_3_HYS_MASK 0x20
#define LPC_IOCON_P2_3_HYS 0x20
#define LPC_IOCON_P2_3_HYS_BIT 5
#define LPC_IOCON_P2_3_INV_MASK 0x40
#define LPC_IOCON_P2_3_INV 0x40
#define LPC_IOCON_P2_3_INV_BIT 6
#define LPC_IOCON_P2_3_SLEW_MASK 0x200
#define LPC_IOCON_P2_3_SLEW 0x200
#define LPC_IOCON_P2_3_SLEW_BIT 9
#define LPC_IOCON_P2_3_OD_MASK 0x400
#define LPC_IOCON_P2_3_OD 0x400
#define LPC_IOCON_P2_3_OD_BIT 10

#define LPC_IOCON_P2_4 (*(volatile unsigned long *)0x4002C110)
#define LPC_IOCON_P2_4_OFFSET 0x110
#define LPC_IOCON_P2_4_FUNC_MASK 0x7
#define LPC_IOCON_P2_4_FUNC_BIT 0
#define LPC_IOCON_P2_4_MODE_MASK 0x18
#define LPC_IOCON_P2_4_MODE_BIT 3
#define LPC_IOCON_P2_4_HYS_MASK 0x20
#define LPC_IOCON_P2_4_HYS 0x20
#define LPC_IOCON_P2_4_HYS_BIT 5
#define LPC_IOCON_P2_4_INV_MASK 0x40
#define LPC_IOCON_P2_4_INV 0x40
#define LPC_IOCON_P2_4_INV_BIT 6
#define LPC_IOCON_P2_4_SLEW_MASK 0x200
#define LPC_IOCON_P2_4_SLEW 0x200
#define LPC_IOCON_P2_4_SLEW_BIT 9
#define LPC_IOCON_P2_4_OD_MASK 0x400
#define LPC_IOCON_P2_4_OD 0x400
#define LPC_IOCON_P2_4_OD_BIT 10

#define LPC_IOCON_P2_5 (*(volatile unsigned long *)0x4002C114)
#define LPC_IOCON_P2_5_OFFSET 0x114
#define LPC_IOCON_P2_5_FUNC_MASK 0x7
#define LPC_IOCON_P2_5_FUNC_BIT 0
#define LPC_IOCON_P2_5_MODE_MASK 0x18
#define LPC_IOCON_P2_5_MODE_BIT 3
#define LPC_IOCON_P2_5_HYS_MASK 0x20
#define LPC_IOCON_P2_5_HYS 0x20
#define LPC_IOCON_P2_5_HYS_BIT 5
#define LPC_IOCON_P2_5_INV_MASK 0x40
#define LPC_IOCON_P2_5_INV 0x40
#define LPC_IOCON_P2_5_INV_BIT 6
#define LPC_IOCON_P2_5_SLEW_MASK 0x200
#define LPC_IOCON_P2_5_SLEW 0x200
#define LPC_IOCON_P2_5_SLEW_BIT 9
#define LPC_IOCON_P2_5_OD_MASK 0x400
#define LPC_IOCON_P2_5_OD 0x400
#define LPC_IOCON_P2_5_OD_BIT 10

#define LPC_IOCON_P2_6 (*(volatile unsigned long *)0x4002C118)
#define LPC_IOCON_P2_6_OFFSET 0x118
#define LPC_IOCON_P2_6_FUNC_MASK 0x7
#define LPC_IOCON_P2_6_FUNC_BIT 0
#define LPC_IOCON_P2_6_MODE_MASK 0x18
#define LPC_IOCON_P2_6_MODE_BIT 3
#define LPC_IOCON_P2_6_HYS_MASK 0x20
#define LPC_IOCON_P2_6_HYS 0x20
#define LPC_IOCON_P2_6_HYS_BIT 5
#define LPC_IOCON_P2_6_INV_MASK 0x40
#define LPC_IOCON_P2_6_INV 0x40
#define LPC_IOCON_P2_6_INV_BIT 6
#define LPC_IOCON_P2_6_SLEW_MASK 0x200
#define LPC_IOCON_P2_6_SLEW 0x200
#define LPC_IOCON_P2_6_SLEW_BIT 9
#define LPC_IOCON_P2_6_OD_MASK 0x400
#define LPC_IOCON_P2_6_OD 0x400
#define LPC_IOCON_P2_6_OD_BIT 10

#define LPC_IOCON_P2_7 (*(volatile unsigned long *)0x4002C11C)
#define LPC_IOCON_P2_7_OFFSET 0x11C
#define LPC_IOCON_P2_7_FUNC_MASK 0x7
#define LPC_IOCON_P2_7_FUNC_BIT 0
#define LPC_IOCON_P2_7_MODE_MASK 0x18
#define LPC_IOCON_P2_7_MODE_BIT 3
#define LPC_IOCON_P2_7_HYS_MASK 0x20
#define LPC_IOCON_P2_7_HYS 0x20
#define LPC_IOCON_P2_7_HYS_BIT 5
#define LPC_IOCON_P2_7_INV_MASK 0x40
#define LPC_IOCON_P2_7_INV 0x40
#define LPC_IOCON_P2_7_INV_BIT 6
#define LPC_IOCON_P2_7_SLEW_MASK 0x200
#define LPC_IOCON_P2_7_SLEW 0x200
#define LPC_IOCON_P2_7_SLEW_BIT 9
#define LPC_IOCON_P2_7_OD_MASK 0x400
#define LPC_IOCON_P2_7_OD 0x400
#define LPC_IOCON_P2_7_OD_BIT 10

#define LPC_IOCON_P2_8 (*(volatile unsigned long *)0x4002C120)
#define LPC_IOCON_P2_8_OFFSET 0x120
#define LPC_IOCON_P2_8_FUNC_MASK 0x7
#define LPC_IOCON_P2_8_FUNC_BIT 0
#define LPC_IOCON_P2_8_MODE_MASK 0x18
#define LPC_IOCON_P2_8_MODE_BIT 3
#define LPC_IOCON_P2_8_HYS_MASK 0x20
#define LPC_IOCON_P2_8_HYS 0x20
#define LPC_IOCON_P2_8_HYS_BIT 5
#define LPC_IOCON_P2_8_INV_MASK 0x40
#define LPC_IOCON_P2_8_INV 0x40
#define LPC_IOCON_P2_8_INV_BIT 6
#define LPC_IOCON_P2_8_SLEW_MASK 0x200
#define LPC_IOCON_P2_8_SLEW 0x200
#define LPC_IOCON_P2_8_SLEW_BIT 9
#define LPC_IOCON_P2_8_OD_MASK 0x400
#define LPC_IOCON_P2_8_OD 0x400
#define LPC_IOCON_P2_8_OD_BIT 10

#define LPC_IOCON_P2_9 (*(volatile unsigned long *)0x4002C124)
#define LPC_IOCON_P2_9_OFFSET 0x124
#define LPC_IOCON_P2_9_FUNC_MASK 0x7
#define LPC_IOCON_P2_9_FUNC_BIT 0
#define LPC_IOCON_P2_9_MODE_MASK 0x18
#define LPC_IOCON_P2_9_MODE_BIT 3
#define LPC_IOCON_P2_9_HYS_MASK 0x20
#define LPC_IOCON_P2_9_HYS 0x20
#define LPC_IOCON_P2_9_HYS_BIT 5
#define LPC_IOCON_P2_9_INV_MASK 0x40
#define LPC_IOCON_P2_9_INV 0x40
#define LPC_IOCON_P2_9_INV_BIT 6
#define LPC_IOCON_P2_9_SLEW_MASK 0x200
#define LPC_IOCON_P2_9_SLEW 0x200
#define LPC_IOCON_P2_9_SLEW_BIT 9
#define LPC_IOCON_P2_9_OD_MASK 0x400
#define LPC_IOCON_P2_9_OD 0x400
#define LPC_IOCON_P2_9_OD_BIT 10

#define LPC_IOCON_P2_10 (*(volatile unsigned long *)0x4002C128)
#define LPC_IOCON_P2_10_OFFSET 0x128
#define LPC_IOCON_P2_10_FUNC_MASK 0x7
#define LPC_IOCON_P2_10_FUNC_BIT 0

#define LPC_IOCON_P2_11 (*(volatile unsigned long *)0x4002C12C)
#define LPC_IOCON_P2_11_OFFSET 0x12C
#define LPC_IOCON_P2_11_FUNC_MASK 0x7
#define LPC_IOCON_P2_11_FUNC_BIT 0

#define LPC_IOCON_P2_12 (*(volatile unsigned long *)0x4002C130)
#define LPC_IOCON_P2_12_OFFSET 0x130
#define LPC_IOCON_P2_12_FUNC_MASK 0x7
#define LPC_IOCON_P2_12_FUNC_BIT 0

#define LPC_IOCON_P2_13 (*(volatile unsigned long *)0x4002C134)
#define LPC_IOCON_P2_13_OFFSET 0x134
#define LPC_IOCON_P2_13_FUNC_MASK 0x7
#define LPC_IOCON_P2_13_FUNC_BIT 0

#define LPC_IOCON_P2_14 (*(volatile unsigned long *)0x4002C138)
#define LPC_IOCON_P2_14_OFFSET 0x138
#define LPC_IOCON_P2_14_FUNC_MASK 0x7
#define LPC_IOCON_P2_14_FUNC_BIT 0
#define LPC_IOCON_P2_14_MODE_MASK 0x18
#define LPC_IOCON_P2_14_MODE_BIT 3
#define LPC_IOCON_P2_14_HYS_MASK 0x20
#define LPC_IOCON_P2_14_HYS 0x20
#define LPC_IOCON_P2_14_HYS_BIT 5
#define LPC_IOCON_P2_14_INV_MASK 0x40
#define LPC_IOCON_P2_14_INV 0x40
#define LPC_IOCON_P2_14_INV_BIT 6
#define LPC_IOCON_P2_14_SLEW_MASK 0x200
#define LPC_IOCON_P2_14_SLEW 0x200
#define LPC_IOCON_P2_14_SLEW_BIT 9
#define LPC_IOCON_P2_14_OD_MASK 0x400
#define LPC_IOCON_P2_14_OD 0x400
#define LPC_IOCON_P2_14_OD_BIT 10

#define LPC_IOCON_P2_15 (*(volatile unsigned long *)0x4002C13C)
#define LPC_IOCON_P2_15_OFFSET 0x13C
#define LPC_IOCON_P2_15_FUNC_MASK 0x7
#define LPC_IOCON_P2_15_FUNC_BIT 0
#define LPC_IOCON_P2_15_MODE_MASK 0x18
#define LPC_IOCON_P2_15_MODE_BIT 3
#define LPC_IOCON_P2_15_HYS_MASK 0x20
#define LPC_IOCON_P2_15_HYS 0x20
#define LPC_IOCON_P2_15_HYS_BIT 5
#define LPC_IOCON_P2_15_INV_MASK 0x40
#define LPC_IOCON_P2_15_INV 0x40
#define LPC_IOCON_P2_15_INV_BIT 6
#define LPC_IOCON_P2_15_SLEW_MASK 0x200
#define LPC_IOCON_P2_15_SLEW 0x200
#define LPC_IOCON_P2_15_SLEW_BIT 9
#define LPC_IOCON_P2_15_OD_MASK 0x400
#define LPC_IOCON_P2_15_OD 0x400
#define LPC_IOCON_P2_15_OD_BIT 10

#define LPC_IOCON_P2_16 (*(volatile unsigned long *)0x4002C140)
#define LPC_IOCON_P2_16_OFFSET 0x140
#define LPC_IOCON_P2_16_FUNC_MASK 0x7
#define LPC_IOCON_P2_16_FUNC_BIT 0
#define LPC_IOCON_P2_16_MODE_MASK 0x18
#define LPC_IOCON_P2_16_MODE_BIT 3
#define LPC_IOCON_P2_16_HYS_MASK 0x20
#define LPC_IOCON_P2_16_HYS 0x20
#define LPC_IOCON_P2_16_HYS_BIT 5
#define LPC_IOCON_P2_16_INV_MASK 0x40
#define LPC_IOCON_P2_16_INV 0x40
#define LPC_IOCON_P2_16_INV_BIT 6
#define LPC_IOCON_P2_16_SLEW_MASK 0x200
#define LPC_IOCON_P2_16_SLEW 0x200
#define LPC_IOCON_P2_16_SLEW_BIT 9
#define LPC_IOCON_P2_16_OD_MASK 0x400
#define LPC_IOCON_P2_16_OD 0x400
#define LPC_IOCON_P2_16_OD_BIT 10

#define LPC_IOCON_P2_17 (*(volatile unsigned long *)0x4002C144)
#define LPC_IOCON_P2_17_OFFSET 0x144
#define LPC_IOCON_P2_17_FUNC_MASK 0x7
#define LPC_IOCON_P2_17_FUNC_BIT 0
#define LPC_IOCON_P2_17_MODE_MASK 0x18
#define LPC_IOCON_P2_17_MODE_BIT 3
#define LPC_IOCON_P2_17_HYS_MASK 0x20
#define LPC_IOCON_P2_17_HYS 0x20
#define LPC_IOCON_P2_17_HYS_BIT 5
#define LPC_IOCON_P2_17_INV_MASK 0x40
#define LPC_IOCON_P2_17_INV 0x40
#define LPC_IOCON_P2_17_INV_BIT 6
#define LPC_IOCON_P2_17_SLEW_MASK 0x200
#define LPC_IOCON_P2_17_SLEW 0x200
#define LPC_IOCON_P2_17_SLEW_BIT 9
#define LPC_IOCON_P2_17_OD_MASK 0x400
#define LPC_IOCON_P2_17_OD 0x400
#define LPC_IOCON_P2_17_OD_BIT 10

#define LPC_IOCON_P2_18 (*(volatile unsigned long *)0x4002C148)
#define LPC_IOCON_P2_18_OFFSET 0x148
#define LPC_IOCON_P2_18_FUNC_MASK 0x7
#define LPC_IOCON_P2_18_FUNC_BIT 0
#define LPC_IOCON_P2_18_MODE_MASK 0x18
#define LPC_IOCON_P2_18_MODE_BIT 3
#define LPC_IOCON_P2_18_HYS_MASK 0x20
#define LPC_IOCON_P2_18_HYS 0x20
#define LPC_IOCON_P2_18_HYS_BIT 5
#define LPC_IOCON_P2_18_INV_MASK 0x40
#define LPC_IOCON_P2_18_INV 0x40
#define LPC_IOCON_P2_18_INV_BIT 6
#define LPC_IOCON_P2_18_ADMODE_MASK 0x80
#define LPC_IOCON_P2_18_ADMODE 0x80
#define LPC_IOCON_P2_18_ADMODE_BIT 7
#define LPC_IOCON_P2_18_FILTR_MASK 0x100
#define LPC_IOCON_P2_18_FILTR 0x100
#define LPC_IOCON_P2_18_FILTR_BIT 8
#define LPC_IOCON_P2_18_OD_MASK 0x400
#define LPC_IOCON_P2_18_OD 0x400
#define LPC_IOCON_P2_18_OD_BIT 10

#define LPC_IOCON_P2_19 (*(volatile unsigned long *)0x4002C14C)
#define LPC_IOCON_P2_19_OFFSET 0x14C
#define LPC_IOCON_P2_19_FUNC_MASK 0x7
#define LPC_IOCON_P2_19_FUNC_BIT 0
#define LPC_IOCON_P2_19_MODE_MASK 0x18
#define LPC_IOCON_P2_19_MODE_BIT 3
#define LPC_IOCON_P2_19_HYS_MASK 0x20
#define LPC_IOCON_P2_19_HYS 0x20
#define LPC_IOCON_P2_19_HYS_BIT 5
#define LPC_IOCON_P2_19_INV_MASK 0x40
#define LPC_IOCON_P2_19_INV 0x40
#define LPC_IOCON_P2_19_INV_BIT 6
#define LPC_IOCON_P2_19_ADMODE_MASK 0x80
#define LPC_IOCON_P2_19_ADMODE 0x80
#define LPC_IOCON_P2_19_ADMODE_BIT 7
#define LPC_IOCON_P2_19_FILTR_MASK 0x100
#define LPC_IOCON_P2_19_FILTR 0x100
#define LPC_IOCON_P2_19_FILTR_BIT 8
#define LPC_IOCON_P2_19_OD_MASK 0x400
#define LPC_IOCON_P2_19_OD 0x400
#define LPC_IOCON_P2_19_OD_BIT 10

#define LPC_IOCON_P2_20 (*(volatile unsigned long *)0x4002C150)
#define LPC_IOCON_P2_20_OFFSET 0x150
#define LPC_IOCON_P2_20_FUNC_MASK 0x7
#define LPC_IOCON_P2_20_FUNC_BIT 0
#define LPC_IOCON_P2_20_MODE_MASK 0x18
#define LPC_IOCON_P2_20_MODE_BIT 3
#define LPC_IOCON_P2_20_HYS_MASK 0x20
#define LPC_IOCON_P2_20_HYS 0x20
#define LPC_IOCON_P2_20_HYS_BIT 5
#define LPC_IOCON_P2_20_INV_MASK 0x40
#define LPC_IOCON_P2_20_INV 0x40
#define LPC_IOCON_P2_20_INV_BIT 6
#define LPC_IOCON_P2_20_SLEW_MASK 0x200
#define LPC_IOCON_P2_20_SLEW 0x200
#define LPC_IOCON_P2_20_SLEW_BIT 9
#define LPC_IOCON_P2_20_OD_MASK 0x400
#define LPC_IOCON_P2_20_OD 0x400
#define LPC_IOCON_P2_20_OD_BIT 10

#define LPC_IOCON_P2_21 (*(volatile unsigned long *)0x4002C154)
#define LPC_IOCON_P2_21_OFFSET 0x154
#define LPC_IOCON_P2_21_FUNC_MASK 0x7
#define LPC_IOCON_P2_21_FUNC_BIT 0
#define LPC_IOCON_P2_21_MODE_MASK 0x18
#define LPC_IOCON_P2_21_MODE_BIT 3
#define LPC_IOCON_P2_21_HYS_MASK 0x20
#define LPC_IOCON_P2_21_HYS 0x20
#define LPC_IOCON_P2_21_HYS_BIT 5
#define LPC_IOCON_P2_21_INV_MASK 0x40
#define LPC_IOCON_P2_21_INV 0x40
#define LPC_IOCON_P2_21_INV_BIT 6
#define LPC_IOCON_P2_21_SLEW_MASK 0x200
#define LPC_IOCON_P2_21_SLEW 0x200
#define LPC_IOCON_P2_21_SLEW_BIT 9
#define LPC_IOCON_P2_21_OD_MASK 0x400
#define LPC_IOCON_P2_21_OD 0x400
#define LPC_IOCON_P2_21_OD_BIT 10

#define LPC_IOCON_P2_22 (*(volatile unsigned long *)0x4002C158)
#define LPC_IOCON_P2_22_OFFSET 0x158
#define LPC_IOCON_P2_22_FUNC_MASK 0x7
#define LPC_IOCON_P2_22_FUNC_BIT 0
#define LPC_IOCON_P2_22_MODE_MASK 0x18
#define LPC_IOCON_P2_22_MODE_BIT 3
#define LPC_IOCON_P2_22_HYS_MASK 0x20
#define LPC_IOCON_P2_22_HYS 0x20
#define LPC_IOCON_P2_22_HYS_BIT 5
#define LPC_IOCON_P2_22_INV_MASK 0x40
#define LPC_IOCON_P2_22_INV 0x40
#define LPC_IOCON_P2_22_INV_BIT 6
#define LPC_IOCON_P2_22_SLEW_MASK 0x200
#define LPC_IOCON_P2_22_SLEW 0x200
#define LPC_IOCON_P2_22_SLEW_BIT 9
#define LPC_IOCON_P2_22_OD_MASK 0x400
#define LPC_IOCON_P2_22_OD 0x400
#define LPC_IOCON_P2_22_OD_BIT 10

#define LPC_IOCON_P2_23 (*(volatile unsigned long *)0x4002C15C)
#define LPC_IOCON_P2_23_OFFSET 0x15C
#define LPC_IOCON_P2_23_FUNC_MASK 0x7
#define LPC_IOCON_P2_23_FUNC_BIT 0
#define LPC_IOCON_P2_23_MODE_MASK 0x18
#define LPC_IOCON_P2_23_MODE_BIT 3
#define LPC_IOCON_P2_23_HYS_MASK 0x20
#define LPC_IOCON_P2_23_HYS 0x20
#define LPC_IOCON_P2_23_HYS_BIT 5
#define LPC_IOCON_P2_23_INV_MASK 0x40
#define LPC_IOCON_P2_23_INV 0x40
#define LPC_IOCON_P2_23_INV_BIT 6
#define LPC_IOCON_P2_23_SLEW_MASK 0x200
#define LPC_IOCON_P2_23_SLEW 0x200
#define LPC_IOCON_P2_23_SLEW_BIT 9
#define LPC_IOCON_P2_23_OD_MASK 0x400
#define LPC_IOCON_P2_23_OD 0x400
#define LPC_IOCON_P2_23_OD_BIT 10

#define LPC_IOCON_P2_24 (*(volatile unsigned long *)0x4002C160)
#define LPC_IOCON_P2_24_OFFSET 0x160
#define LPC_IOCON_P2_24_FUNC_MASK 0x7
#define LPC_IOCON_P2_24_FUNC_BIT 0
#define LPC_IOCON_P2_24_MODE_MASK 0x18
#define LPC_IOCON_P2_24_MODE_BIT 3
#define LPC_IOCON_P2_24_HYS_MASK 0x20
#define LPC_IOCON_P2_24_HYS 0x20
#define LPC_IOCON_P2_24_HYS_BIT 5
#define LPC_IOCON_P2_24_INV_MASK 0x40
#define LPC_IOCON_P2_24_INV 0x40
#define LPC_IOCON_P2_24_INV_BIT 6
#define LPC_IOCON_P2_24_SLEW_MASK 0x200
#define LPC_IOCON_P2_24_SLEW 0x200
#define LPC_IOCON_P2_24_SLEW_BIT 9
#define LPC_IOCON_P2_24_OD_MASK 0x400
#define LPC_IOCON_P2_24_OD 0x400
#define LPC_IOCON_P2_24_OD_BIT 10

#define LPC_IOCON_P2_25 (*(volatile unsigned long *)0x4002C164)
#define LPC_IOCON_P2_25_OFFSET 0x164
#define LPC_IOCON_P2_25_FUNC_MASK 0x7
#define LPC_IOCON_P2_25_FUNC_BIT 0
#define LPC_IOCON_P2_25_MODE_MASK 0x18
#define LPC_IOCON_P2_25_MODE_BIT 3
#define LPC_IOCON_P2_25_HYS_MASK 0x20
#define LPC_IOCON_P2_25_HYS 0x20
#define LPC_IOCON_P2_25_HYS_BIT 5
#define LPC_IOCON_P2_25_INV_MASK 0x40
#define LPC_IOCON_P2_25_INV 0x40
#define LPC_IOCON_P2_25_INV_BIT 6
#define LPC_IOCON_P2_25_SLEW_MASK 0x200
#define LPC_IOCON_P2_25_SLEW 0x200
#define LPC_IOCON_P2_25_SLEW_BIT 9
#define LPC_IOCON_P2_25_OD_MASK 0x400
#define LPC_IOCON_P2_25_OD 0x400
#define LPC_IOCON_P2_25_OD_BIT 10

#define LPC_IOCON_P2_26 (*(volatile unsigned long *)0x4002C168)
#define LPC_IOCON_P2_26_OFFSET 0x168
#define LPC_IOCON_P2_26_FUNC_MASK 0x7
#define LPC_IOCON_P2_26_FUNC_BIT 0
#define LPC_IOCON_P2_26_MODE_MASK 0x18
#define LPC_IOCON_P2_26_MODE_BIT 3
#define LPC_IOCON_P2_26_HYS_MASK 0x20
#define LPC_IOCON_P2_26_HYS 0x20
#define LPC_IOCON_P2_26_HYS_BIT 5
#define LPC_IOCON_P2_26_INV_MASK 0x40
#define LPC_IOCON_P2_26_INV 0x40
#define LPC_IOCON_P2_26_INV_BIT 6
#define LPC_IOCON_P2_26_SLEW_MASK 0x200
#define LPC_IOCON_P2_26_SLEW 0x200
#define LPC_IOCON_P2_26_SLEW_BIT 9
#define LPC_IOCON_P2_26_OD_MASK 0x400
#define LPC_IOCON_P2_26_OD 0x400
#define LPC_IOCON_P2_26_OD_BIT 10

#define LPC_IOCON_P2_27 (*(volatile unsigned long *)0x4002C16C)
#define LPC_IOCON_P2_27_OFFSET 0x16C
#define LPC_IOCON_P2_27_FUNC_MASK 0x7
#define LPC_IOCON_P2_27_FUNC_BIT 0
#define LPC_IOCON_P2_27_MODE_MASK 0x18
#define LPC_IOCON_P2_27_MODE_BIT 3
#define LPC_IOCON_P2_27_HYS_MASK 0x20
#define LPC_IOCON_P2_27_HYS 0x20
#define LPC_IOCON_P2_27_HYS_BIT 5
#define LPC_IOCON_P2_27_INV_MASK 0x40
#define LPC_IOCON_P2_27_INV 0x40
#define LPC_IOCON_P2_27_INV_BIT 6
#define LPC_IOCON_P2_27_SLEW_MASK 0x200
#define LPC_IOCON_P2_27_SLEW 0x200
#define LPC_IOCON_P2_27_SLEW_BIT 9
#define LPC_IOCON_P2_27_OD_MASK 0x400
#define LPC_IOCON_P2_27_OD 0x400
#define LPC_IOCON_P2_27_OD_BIT 10

#define LPC_IOCON_P2_28 (*(volatile unsigned long *)0x4002C170)
#define LPC_IOCON_P2_28_OFFSET 0x170
#define LPC_IOCON_P2_28_FUNC_MASK 0x7
#define LPC_IOCON_P2_28_FUNC_BIT 0
#define LPC_IOCON_P2_28_MODE_MASK 0x18
#define LPC_IOCON_P2_28_MODE_BIT 3
#define LPC_IOCON_P2_28_HYS_MASK 0x20
#define LPC_IOCON_P2_28_HYS 0x20
#define LPC_IOCON_P2_28_HYS_BIT 5
#define LPC_IOCON_P2_28_INV_MASK 0x40
#define LPC_IOCON_P2_28_INV 0x40
#define LPC_IOCON_P2_28_INV_BIT 6
#define LPC_IOCON_P2_28_SLEW_MASK 0x200
#define LPC_IOCON_P2_28_SLEW 0x200
#define LPC_IOCON_P2_28_SLEW_BIT 9
#define LPC_IOCON_P2_28_OD_MASK 0x400
#define LPC_IOCON_P2_28_OD 0x400
#define LPC_IOCON_P2_28_OD_BIT 10

#define LPC_IOCON_P2_29 (*(volatile unsigned long *)0x4002C174)
#define LPC_IOCON_P2_29_OFFSET 0x174
#define LPC_IOCON_P2_29_FUNC_MASK 0x7
#define LPC_IOCON_P2_29_FUNC_BIT 0
#define LPC_IOCON_P2_29_MODE_MASK 0x18
#define LPC_IOCON_P2_29_MODE_BIT 3
#define LPC_IOCON_P2_29_HYS_MASK 0x20
#define LPC_IOCON_P2_29_HYS 0x20
#define LPC_IOCON_P2_29_HYS_BIT 5
#define LPC_IOCON_P2_29_INV_MASK 0x40
#define LPC_IOCON_P2_29_INV 0x40
#define LPC_IOCON_P2_29_INV_BIT 6
#define LPC_IOCON_P2_29_SLEW_MASK 0x200
#define LPC_IOCON_P2_29_SLEW 0x200
#define LPC_IOCON_P2_29_SLEW_BIT 9
#define LPC_IOCON_P2_29_OD_MASK 0x400
#define LPC_IOCON_P2_29_OD 0x400
#define LPC_IOCON_P2_29_OD_BIT 10

#define LPC_IOCON_P2_30 (*(volatile unsigned long *)0x4002C178)
#define LPC_IOCON_P2_30_OFFSET 0x178
#define LPC_IOCON_P2_30_FUNC_MASK 0x7
#define LPC_IOCON_P2_30_FUNC_BIT 0
#define LPC_IOCON_P2_30_MODE_MASK 0x18
#define LPC_IOCON_P2_30_MODE_BIT 3
#define LPC_IOCON_P2_30_HYS_MASK 0x20
#define LPC_IOCON_P2_30_HYS 0x20
#define LPC_IOCON_P2_30_HYS_BIT 5
#define LPC_IOCON_P2_30_INV_MASK 0x40
#define LPC_IOCON_P2_30_INV 0x40
#define LPC_IOCON_P2_30_INV_BIT 6
#define LPC_IOCON_P2_30_SLEW_MASK 0x200
#define LPC_IOCON_P2_30_SLEW 0x200
#define LPC_IOCON_P2_30_SLEW_BIT 9
#define LPC_IOCON_P2_30_OD_MASK 0x400
#define LPC_IOCON_P2_30_OD 0x400
#define LPC_IOCON_P2_30_OD_BIT 10

#define LPC_IOCON_P2_31 (*(volatile unsigned long *)0x4002C17C)
#define LPC_IOCON_P2_31_OFFSET 0x17C
#define LPC_IOCON_P2_31_FUNC_MASK 0x7
#define LPC_IOCON_P2_31_FUNC_BIT 0
#define LPC_IOCON_P2_31_MODE_MASK 0x18
#define LPC_IOCON_P2_31_MODE_BIT 3
#define LPC_IOCON_P2_31_HYS_MASK 0x20
#define LPC_IOCON_P2_31_HYS 0x20
#define LPC_IOCON_P2_31_HYS_BIT 5
#define LPC_IOCON_P2_31_INV_MASK 0x40
#define LPC_IOCON_P2_31_INV 0x40
#define LPC_IOCON_P2_31_INV_BIT 6
#define LPC_IOCON_P2_31_SLEW_MASK 0x200
#define LPC_IOCON_P2_31_SLEW 0x200
#define LPC_IOCON_P2_31_SLEW_BIT 9
#define LPC_IOCON_P2_31_OD_MASK 0x400
#define LPC_IOCON_P2_31_OD 0x400
#define LPC_IOCON_P2_31_OD_BIT 10

#define LPC_IOCON_P3_0 (*(volatile unsigned long *)0x4002C180)
#define LPC_IOCON_P3_0_OFFSET 0x180
#define LPC_IOCON_P3_0_FUNC_MASK 0x7
#define LPC_IOCON_P3_0_FUNC_BIT 0
#define LPC_IOCON_P3_0_MODE_MASK 0x18
#define LPC_IOCON_P3_0_MODE_BIT 3
#define LPC_IOCON_P3_0_HYS_MASK 0x20
#define LPC_IOCON_P3_0_HYS 0x20
#define LPC_IOCON_P3_0_HYS_BIT 5
#define LPC_IOCON_P3_0_INV_MASK 0x40
#define LPC_IOCON_P3_0_INV 0x40
#define LPC_IOCON_P3_0_INV_BIT 6
#define LPC_IOCON_P3_0_SLEW_MASK 0x200
#define LPC_IOCON_P3_0_SLEW 0x200
#define LPC_IOCON_P3_0_SLEW_BIT 9
#define LPC_IOCON_P3_0_OD_MASK 0x400
#define LPC_IOCON_P3_0_OD 0x400
#define LPC_IOCON_P3_0_OD_BIT 10

#define LPC_IOCON_P3_1 (*(volatile unsigned long *)0x4002C184)
#define LPC_IOCON_P3_1_OFFSET 0x184
#define LPC_IOCON_P3_1_FUNC_MASK 0x7
#define LPC_IOCON_P3_1_FUNC_BIT 0
#define LPC_IOCON_P3_1_MODE_MASK 0x18
#define LPC_IOCON_P3_1_MODE_BIT 3
#define LPC_IOCON_P3_1_HYS_MASK 0x20
#define LPC_IOCON_P3_1_HYS 0x20
#define LPC_IOCON_P3_1_HYS_BIT 5
#define LPC_IOCON_P3_1_INV_MASK 0x40
#define LPC_IOCON_P3_1_INV 0x40
#define LPC_IOCON_P3_1_INV_BIT 6
#define LPC_IOCON_P3_1_SLEW_MASK 0x200
#define LPC_IOCON_P3_1_SLEW 0x200
#define LPC_IOCON_P3_1_SLEW_BIT 9
#define LPC_IOCON_P3_1_OD_MASK 0x400
#define LPC_IOCON_P3_1_OD 0x400
#define LPC_IOCON_P3_1_OD_BIT 10

#define LPC_IOCON_P3_2 (*(volatile unsigned long *)0x4002C188)
#define LPC_IOCON_P3_2_OFFSET 0x188
#define LPC_IOCON_P3_2_FUNC_MASK 0x7
#define LPC_IOCON_P3_2_FUNC_BIT 0
#define LPC_IOCON_P3_2_MODE_MASK 0x18
#define LPC_IOCON_P3_2_MODE_BIT 3
#define LPC_IOCON_P3_2_HYS_MASK 0x20
#define LPC_IOCON_P3_2_HYS 0x20
#define LPC_IOCON_P3_2_HYS_BIT 5
#define LPC_IOCON_P3_2_INV_MASK 0x40
#define LPC_IOCON_P3_2_INV 0x40
#define LPC_IOCON_P3_2_INV_BIT 6
#define LPC_IOCON_P3_2_SLEW_MASK 0x200
#define LPC_IOCON_P3_2_SLEW 0x200
#define LPC_IOCON_P3_2_SLEW_BIT 9
#define LPC_IOCON_P3_2_OD_MASK 0x400
#define LPC_IOCON_P3_2_OD 0x400
#define LPC_IOCON_P3_2_OD_BIT 10

#define LPC_IOCON_P3_3 (*(volatile unsigned long *)0x4002C18C)
#define LPC_IOCON_P3_3_OFFSET 0x18C
#define LPC_IOCON_P3_3_FUNC_MASK 0x7
#define LPC_IOCON_P3_3_FUNC_BIT 0
#define LPC_IOCON_P3_3_MODE_MASK 0x18
#define LPC_IOCON_P3_3_MODE_BIT 3
#define LPC_IOCON_P3_3_HYS_MASK 0x20
#define LPC_IOCON_P3_3_HYS 0x20
#define LPC_IOCON_P3_3_HYS_BIT 5
#define LPC_IOCON_P3_3_INV_MASK 0x40
#define LPC_IOCON_P3_3_INV 0x40
#define LPC_IOCON_P3_3_INV_BIT 6
#define LPC_IOCON_P3_3_SLEW_MASK 0x200
#define LPC_IOCON_P3_3_SLEW 0x200
#define LPC_IOCON_P3_3_SLEW_BIT 9
#define LPC_IOCON_P3_3_OD_MASK 0x400
#define LPC_IOCON_P3_3_OD 0x400
#define LPC_IOCON_P3_3_OD_BIT 10

#define LPC_IOCON_P3_4 (*(volatile unsigned long *)0x4002C190)
#define LPC_IOCON_P3_4_OFFSET 0x190
#define LPC_IOCON_P3_4_FUNC_MASK 0x7
#define LPC_IOCON_P3_4_FUNC_BIT 0
#define LPC_IOCON_P3_4_MODE_MASK 0x18
#define LPC_IOCON_P3_4_MODE_BIT 3
#define LPC_IOCON_P3_4_HYS_MASK 0x20
#define LPC_IOCON_P3_4_HYS 0x20
#define LPC_IOCON_P3_4_HYS_BIT 5
#define LPC_IOCON_P3_4_INV_MASK 0x40
#define LPC_IOCON_P3_4_INV 0x40
#define LPC_IOCON_P3_4_INV_BIT 6
#define LPC_IOCON_P3_4_SLEW_MASK 0x200
#define LPC_IOCON_P3_4_SLEW 0x200
#define LPC_IOCON_P3_4_SLEW_BIT 9
#define LPC_IOCON_P3_4_OD_MASK 0x400
#define LPC_IOCON_P3_4_OD 0x400
#define LPC_IOCON_P3_4_OD_BIT 10

#define LPC_IOCON_P3_5 (*(volatile unsigned long *)0x4002C194)
#define LPC_IOCON_P3_5_OFFSET 0x194
#define LPC_IOCON_P3_5_FUNC_MASK 0x7
#define LPC_IOCON_P3_5_FUNC_BIT 0
#define LPC_IOCON_P3_5_MODE_MASK 0x18
#define LPC_IOCON_P3_5_MODE_BIT 3
#define LPC_IOCON_P3_5_HYS_MASK 0x20
#define LPC_IOCON_P3_5_HYS 0x20
#define LPC_IOCON_P3_5_HYS_BIT 5
#define LPC_IOCON_P3_5_INV_MASK 0x40
#define LPC_IOCON_P3_5_INV 0x40
#define LPC_IOCON_P3_5_INV_BIT 6
#define LPC_IOCON_P3_5_SLEW_MASK 0x200
#define LPC_IOCON_P3_5_SLEW 0x200
#define LPC_IOCON_P3_5_SLEW_BIT 9
#define LPC_IOCON_P3_5_OD_MASK 0x400
#define LPC_IOCON_P3_5_OD 0x400
#define LPC_IOCON_P3_5_OD_BIT 10

#define LPC_IOCON_P3_6 (*(volatile unsigned long *)0x4002C198)
#define LPC_IOCON_P3_6_OFFSET 0x198
#define LPC_IOCON_P3_6_FUNC_MASK 0x7
#define LPC_IOCON_P3_6_FUNC_BIT 0
#define LPC_IOCON_P3_6_MODE_MASK 0x18
#define LPC_IOCON_P3_6_MODE_BIT 3
#define LPC_IOCON_P3_6_HYS_MASK 0x20
#define LPC_IOCON_P3_6_HYS 0x20
#define LPC_IOCON_P3_6_HYS_BIT 5
#define LPC_IOCON_P3_6_INV_MASK 0x40
#define LPC_IOCON_P3_6_INV 0x40
#define LPC_IOCON_P3_6_INV_BIT 6
#define LPC_IOCON_P3_6_SLEW_MASK 0x200
#define LPC_IOCON_P3_6_SLEW 0x200
#define LPC_IOCON_P3_6_SLEW_BIT 9
#define LPC_IOCON_P3_6_OD_MASK 0x400
#define LPC_IOCON_P3_6_OD 0x400
#define LPC_IOCON_P3_6_OD_BIT 10

#define LPC_IOCON_P3_7 (*(volatile unsigned long *)0x4002C19C)
#define LPC_IOCON_P3_7_OFFSET 0x19C
#define LPC_IOCON_P3_7_FUNC_MASK 0x7
#define LPC_IOCON_P3_7_FUNC_BIT 0
#define LPC_IOCON_P3_7_MODE_MASK 0x18
#define LPC_IOCON_P3_7_MODE_BIT 3
#define LPC_IOCON_P3_7_HYS_MASK 0x20
#define LPC_IOCON_P3_7_HYS 0x20
#define LPC_IOCON_P3_7_HYS_BIT 5
#define LPC_IOCON_P3_7_INV_MASK 0x40
#define LPC_IOCON_P3_7_INV 0x40
#define LPC_IOCON_P3_7_INV_BIT 6
#define LPC_IOCON_P3_7_SLEW_MASK 0x200
#define LPC_IOCON_P3_7_SLEW 0x200
#define LPC_IOCON_P3_7_SLEW_BIT 9
#define LPC_IOCON_P3_7_OD_MASK 0x400
#define LPC_IOCON_P3_7_OD 0x400
#define LPC_IOCON_P3_7_OD_BIT 10

#define LPC_IOCON_P3_8 (*(volatile unsigned long *)0x4002C1A0)
#define LPC_IOCON_P3_8_OFFSET 0x1A0
#define LPC_IOCON_P3_8_FUNC_MASK 0x7
#define LPC_IOCON_P3_8_FUNC_BIT 0
#define LPC_IOCON_P3_8_MODE_MASK 0x18
#define LPC_IOCON_P3_8_MODE_BIT 3
#define LPC_IOCON_P3_8_HYS_MASK 0x20
#define LPC_IOCON_P3_8_HYS 0x20
#define LPC_IOCON_P3_8_HYS_BIT 5
#define LPC_IOCON_P3_8_INV_MASK 0x40
#define LPC_IOCON_P3_8_INV 0x40
#define LPC_IOCON_P3_8_INV_BIT 6
#define LPC_IOCON_P3_8_SLEW_MASK 0x200
#define LPC_IOCON_P3_8_SLEW 0x200
#define LPC_IOCON_P3_8_SLEW_BIT 9
#define LPC_IOCON_P3_8_OD_MASK 0x400
#define LPC_IOCON_P3_8_OD 0x400
#define LPC_IOCON_P3_8_OD_BIT 10

#define LPC_IOCON_P3_9 (*(volatile unsigned long *)0x4002C1A4)
#define LPC_IOCON_P3_9_OFFSET 0x1A4
#define LPC_IOCON_P3_9_FUNC_MASK 0x7
#define LPC_IOCON_P3_9_FUNC_BIT 0
#define LPC_IOCON_P3_9_MODE_MASK 0x18
#define LPC_IOCON_P3_9_MODE_BIT 3
#define LPC_IOCON_P3_9_HYS_MASK 0x20
#define LPC_IOCON_P3_9_HYS 0x20
#define LPC_IOCON_P3_9_HYS_BIT 5
#define LPC_IOCON_P3_9_INV_MASK 0x40
#define LPC_IOCON_P3_9_INV 0x40
#define LPC_IOCON_P3_9_INV_BIT 6
#define LPC_IOCON_P3_9_SLEW_MASK 0x200
#define LPC_IOCON_P3_9_SLEW 0x200
#define LPC_IOCON_P3_9_SLEW_BIT 9
#define LPC_IOCON_P3_9_OD_MASK 0x400
#define LPC_IOCON_P3_9_OD 0x400
#define LPC_IOCON_P3_9_OD_BIT 10

#define LPC_IOCON_P3_10 (*(volatile unsigned long *)0x4002C1A8)
#define LPC_IOCON_P3_10_OFFSET 0x1A8
#define LPC_IOCON_P3_10_FUNC_MASK 0x7
#define LPC_IOCON_P3_10_FUNC_BIT 0
#define LPC_IOCON_P3_10_MODE_MASK 0x18
#define LPC_IOCON_P3_10_MODE_BIT 3
#define LPC_IOCON_P3_10_HYS_MASK 0x20
#define LPC_IOCON_P3_10_HYS 0x20
#define LPC_IOCON_P3_10_HYS_BIT 5
#define LPC_IOCON_P3_10_INV_MASK 0x40
#define LPC_IOCON_P3_10_INV 0x40
#define LPC_IOCON_P3_10_INV_BIT 6
#define LPC_IOCON_P3_10_SLEW_MASK 0x200
#define LPC_IOCON_P3_10_SLEW 0x200
#define LPC_IOCON_P3_10_SLEW_BIT 9
#define LPC_IOCON_P3_10_OD_MASK 0x400
#define LPC_IOCON_P3_10_OD 0x400
#define LPC_IOCON_P3_10_OD_BIT 10

#define LPC_IOCON_P3_11 (*(volatile unsigned long *)0x4002C1AC)
#define LPC_IOCON_P3_11_OFFSET 0x1AC
#define LPC_IOCON_P3_11_FUNC_MASK 0x7
#define LPC_IOCON_P3_11_FUNC_BIT 0
#define LPC_IOCON_P3_11_MODE_MASK 0x18
#define LPC_IOCON_P3_11_MODE_BIT 3
#define LPC_IOCON_P3_11_HYS_MASK 0x20
#define LPC_IOCON_P3_11_HYS 0x20
#define LPC_IOCON_P3_11_HYS_BIT 5
#define LPC_IOCON_P3_11_INV_MASK 0x40
#define LPC_IOCON_P3_11_INV 0x40
#define LPC_IOCON_P3_11_INV_BIT 6
#define LPC_IOCON_P3_11_SLEW_MASK 0x200
#define LPC_IOCON_P3_11_SLEW 0x200
#define LPC_IOCON_P3_11_SLEW_BIT 9
#define LPC_IOCON_P3_11_OD_MASK 0x400
#define LPC_IOCON_P3_11_OD 0x400
#define LPC_IOCON_P3_11_OD_BIT 10

#define LPC_IOCON_P3_12 (*(volatile unsigned long *)0x4002C1B0)
#define LPC_IOCON_P3_12_OFFSET 0x1B0
#define LPC_IOCON_P3_12_FUNC_MASK 0x7
#define LPC_IOCON_P3_12_FUNC_BIT 0
#define LPC_IOCON_P3_12_MODE_MASK 0x18
#define LPC_IOCON_P3_12_MODE_BIT 3
#define LPC_IOCON_P3_12_HYS_MASK 0x20
#define LPC_IOCON_P3_12_HYS 0x20
#define LPC_IOCON_P3_12_HYS_BIT 5
#define LPC_IOCON_P3_12_INV_MASK 0x40
#define LPC_IOCON_P3_12_INV 0x40
#define LPC_IOCON_P3_12_INV_BIT 6
#define LPC_IOCON_P3_12_SLEW_MASK 0x200
#define LPC_IOCON_P3_12_SLEW 0x200
#define LPC_IOCON_P3_12_SLEW_BIT 9
#define LPC_IOCON_P3_12_OD_MASK 0x400
#define LPC_IOCON_P3_12_OD 0x400
#define LPC_IOCON_P3_12_OD_BIT 10

#define LPC_IOCON_P3_13 (*(volatile unsigned long *)0x4002C1B4)
#define LPC_IOCON_P3_13_OFFSET 0x1B4
#define LPC_IOCON_P3_13_FUNC_MASK 0x7
#define LPC_IOCON_P3_13_FUNC_BIT 0
#define LPC_IOCON_P3_13_MODE_MASK 0x18
#define LPC_IOCON_P3_13_MODE_BIT 3
#define LPC_IOCON_P3_13_HYS_MASK 0x20
#define LPC_IOCON_P3_13_HYS 0x20
#define LPC_IOCON_P3_13_HYS_BIT 5
#define LPC_IOCON_P3_13_INV_MASK 0x40
#define LPC_IOCON_P3_13_INV 0x40
#define LPC_IOCON_P3_13_INV_BIT 6
#define LPC_IOCON_P3_13_SLEW_MASK 0x200
#define LPC_IOCON_P3_13_SLEW 0x200
#define LPC_IOCON_P3_13_SLEW_BIT 9
#define LPC_IOCON_P3_13_OD_MASK 0x400
#define LPC_IOCON_P3_13_OD 0x400
#define LPC_IOCON_P3_13_OD_BIT 10

#define LPC_IOCON_P3_14 (*(volatile unsigned long *)0x4002C1B8)
#define LPC_IOCON_P3_14_OFFSET 0x1B8
#define LPC_IOCON_P3_14_FUNC_MASK 0x7
#define LPC_IOCON_P3_14_FUNC_BIT 0
#define LPC_IOCON_P3_14_MODE_MASK 0x18
#define LPC_IOCON_P3_14_MODE_BIT 3
#define LPC_IOCON_P3_14_HYS_MASK 0x20
#define LPC_IOCON_P3_14_HYS 0x20
#define LPC_IOCON_P3_14_HYS_BIT 5
#define LPC_IOCON_P3_14_INV_MASK 0x40
#define LPC_IOCON_P3_14_INV 0x40
#define LPC_IOCON_P3_14_INV_BIT 6
#define LPC_IOCON_P3_14_SLEW_MASK 0x200
#define LPC_IOCON_P3_14_SLEW 0x200
#define LPC_IOCON_P3_14_SLEW_BIT 9
#define LPC_IOCON_P3_14_OD_MASK 0x400
#define LPC_IOCON_P3_14_OD 0x400
#define LPC_IOCON_P3_14_OD_BIT 10

#define LPC_IOCON_P3_15 (*(volatile unsigned long *)0x4002C1BC)
#define LPC_IOCON_P3_15_OFFSET 0x1BC
#define LPC_IOCON_P3_15_FUNC_MASK 0x7
#define LPC_IOCON_P3_15_FUNC_BIT 0
#define LPC_IOCON_P3_15_MODE_MASK 0x18
#define LPC_IOCON_P3_15_MODE_BIT 3
#define LPC_IOCON_P3_15_HYS_MASK 0x20
#define LPC_IOCON_P3_15_HYS 0x20
#define LPC_IOCON_P3_15_HYS_BIT 5
#define LPC_IOCON_P3_15_INV_MASK 0x40
#define LPC_IOCON_P3_15_INV 0x40
#define LPC_IOCON_P3_15_INV_BIT 6
#define LPC_IOCON_P3_15_SLEW_MASK 0x200
#define LPC_IOCON_P3_15_SLEW 0x200
#define LPC_IOCON_P3_15_SLEW_BIT 9
#define LPC_IOCON_P3_15_OD_MASK 0x400
#define LPC_IOCON_P3_15_OD 0x400
#define LPC_IOCON_P3_15_OD_BIT 10

#define LPC_IOCON_P3_16 (*(volatile unsigned long *)0x4002C1C0)
#define LPC_IOCON_P3_16_OFFSET 0x1C0
#define LPC_IOCON_P3_16_FUNC_MASK 0x7
#define LPC_IOCON_P3_16_FUNC_BIT 0
#define LPC_IOCON_P3_16_MODE_MASK 0x18
#define LPC_IOCON_P3_16_MODE_BIT 3
#define LPC_IOCON_P3_16_HYS_MASK 0x20
#define LPC_IOCON_P3_16_HYS 0x20
#define LPC_IOCON_P3_16_HYS_BIT 5
#define LPC_IOCON_P3_16_INV_MASK 0x40
#define LPC_IOCON_P3_16_INV 0x40
#define LPC_IOCON_P3_16_INV_BIT 6
#define LPC_IOCON_P3_16_SLEW_MASK 0x200
#define LPC_IOCON_P3_16_SLEW 0x200
#define LPC_IOCON_P3_16_SLEW_BIT 9
#define LPC_IOCON_P3_16_OD_MASK 0x400
#define LPC_IOCON_P3_16_OD 0x400
#define LPC_IOCON_P3_16_OD_BIT 10

#define LPC_IOCON_P3_17 (*(volatile unsigned long *)0x4002C1C4)
#define LPC_IOCON_P3_17_OFFSET 0x1C4
#define LPC_IOCON_P3_17_FUNC_MASK 0x7
#define LPC_IOCON_P3_17_FUNC_BIT 0
#define LPC_IOCON_P3_17_MODE_MASK 0x18
#define LPC_IOCON_P3_17_MODE_BIT 3
#define LPC_IOCON_P3_17_HYS_MASK 0x20
#define LPC_IOCON_P3_17_HYS 0x20
#define LPC_IOCON_P3_17_HYS_BIT 5
#define LPC_IOCON_P3_17_INV_MASK 0x40
#define LPC_IOCON_P3_17_INV 0x40
#define LPC_IOCON_P3_17_INV_BIT 6
#define LPC_IOCON_P3_17_SLEW_MASK 0x200
#define LPC_IOCON_P3_17_SLEW 0x200
#define LPC_IOCON_P3_17_SLEW_BIT 9
#define LPC_IOCON_P3_17_OD_MASK 0x400
#define LPC_IOCON_P3_17_OD 0x400
#define LPC_IOCON_P3_17_OD_BIT 10

#define LPC_IOCON_P3_18 (*(volatile unsigned long *)0x4002C1C8)
#define LPC_IOCON_P3_18_OFFSET 0x1C8
#define LPC_IOCON_P3_18_FUNC_MASK 0x7
#define LPC_IOCON_P3_18_FUNC_BIT 0
#define LPC_IOCON_P3_18_MODE_MASK 0x18
#define LPC_IOCON_P3_18_MODE_BIT 3
#define LPC_IOCON_P3_18_HYS_MASK 0x20
#define LPC_IOCON_P3_18_HYS 0x20
#define LPC_IOCON_P3_18_HYS_BIT 5
#define LPC_IOCON_P3_18_INV_MASK 0x40
#define LPC_IOCON_P3_18_INV 0x40
#define LPC_IOCON_P3_18_INV_BIT 6
#define LPC_IOCON_P3_18_SLEW_MASK 0x200
#define LPC_IOCON_P3_18_SLEW 0x200
#define LPC_IOCON_P3_18_SLEW_BIT 9
#define LPC_IOCON_P3_18_OD_MASK 0x400
#define LPC_IOCON_P3_18_OD 0x400
#define LPC_IOCON_P3_18_OD_BIT 10

#define LPC_IOCON_P3_19 (*(volatile unsigned long *)0x4002C1CC)
#define LPC_IOCON_P3_19_OFFSET 0x1CC
#define LPC_IOCON_P3_19_FUNC_MASK 0x7
#define LPC_IOCON_P3_19_FUNC_BIT 0
#define LPC_IOCON_P3_19_MODE_MASK 0x18
#define LPC_IOCON_P3_19_MODE_BIT 3
#define LPC_IOCON_P3_19_HYS_MASK 0x20
#define LPC_IOCON_P3_19_HYS 0x20
#define LPC_IOCON_P3_19_HYS_BIT 5
#define LPC_IOCON_P3_19_INV_MASK 0x40
#define LPC_IOCON_P3_19_INV 0x40
#define LPC_IOCON_P3_19_INV_BIT 6
#define LPC_IOCON_P3_19_SLEW_MASK 0x200
#define LPC_IOCON_P3_19_SLEW 0x200
#define LPC_IOCON_P3_19_SLEW_BIT 9
#define LPC_IOCON_P3_19_OD_MASK 0x400
#define LPC_IOCON_P3_19_OD 0x400
#define LPC_IOCON_P3_19_OD_BIT 10

#define LPC_IOCON_P3_20 (*(volatile unsigned long *)0x4002C1D0)
#define LPC_IOCON_P3_20_OFFSET 0x1D0
#define LPC_IOCON_P3_20_FUNC_MASK 0x7
#define LPC_IOCON_P3_20_FUNC_BIT 0
#define LPC_IOCON_P3_20_MODE_MASK 0x18
#define LPC_IOCON_P3_20_MODE_BIT 3
#define LPC_IOCON_P3_20_HYS_MASK 0x20
#define LPC_IOCON_P3_20_HYS 0x20
#define LPC_IOCON_P3_20_HYS_BIT 5
#define LPC_IOCON_P3_20_INV_MASK 0x40
#define LPC_IOCON_P3_20_INV 0x40
#define LPC_IOCON_P3_20_INV_BIT 6
#define LPC_IOCON_P3_20_SLEW_MASK 0x200
#define LPC_IOCON_P3_20_SLEW 0x200
#define LPC_IOCON_P3_20_SLEW_BIT 9
#define LPC_IOCON_P3_20_OD_MASK 0x400
#define LPC_IOCON_P3_20_OD 0x400
#define LPC_IOCON_P3_20_OD_BIT 10

#define LPC_IOCON_P3_21 (*(volatile unsigned long *)0x4002C1D4)
#define LPC_IOCON_P3_21_OFFSET 0x1D4
#define LPC_IOCON_P3_21_FUNC_MASK 0x7
#define LPC_IOCON_P3_21_FUNC_BIT 0
#define LPC_IOCON_P3_21_MODE_MASK 0x18
#define LPC_IOCON_P3_21_MODE_BIT 3
#define LPC_IOCON_P3_21_HYS_MASK 0x20
#define LPC_IOCON_P3_21_HYS 0x20
#define LPC_IOCON_P3_21_HYS_BIT 5
#define LPC_IOCON_P3_21_INV_MASK 0x40
#define LPC_IOCON_P3_21_INV 0x40
#define LPC_IOCON_P3_21_INV_BIT 6
#define LPC_IOCON_P3_21_SLEW_MASK 0x200
#define LPC_IOCON_P3_21_SLEW 0x200
#define LPC_IOCON_P3_21_SLEW_BIT 9
#define LPC_IOCON_P3_21_OD_MASK 0x400
#define LPC_IOCON_P3_21_OD 0x400
#define LPC_IOCON_P3_21_OD_BIT 10

#define LPC_IOCON_P3_22 (*(volatile unsigned long *)0x4002C1D8)
#define LPC_IOCON_P3_22_OFFSET 0x1D8
#define LPC_IOCON_P3_22_FUNC_MASK 0x7
#define LPC_IOCON_P3_22_FUNC_BIT 0
#define LPC_IOCON_P3_22_MODE_MASK 0x18
#define LPC_IOCON_P3_22_MODE_BIT 3
#define LPC_IOCON_P3_22_HYS_MASK 0x20
#define LPC_IOCON_P3_22_HYS 0x20
#define LPC_IOCON_P3_22_HYS_BIT 5
#define LPC_IOCON_P3_22_INV_MASK 0x40
#define LPC_IOCON_P3_22_INV 0x40
#define LPC_IOCON_P3_22_INV_BIT 6
#define LPC_IOCON_P3_22_SLEW_MASK 0x200
#define LPC_IOCON_P3_22_SLEW 0x200
#define LPC_IOCON_P3_22_SLEW_BIT 9
#define LPC_IOCON_P3_22_OD_MASK 0x400
#define LPC_IOCON_P3_22_OD 0x400
#define LPC_IOCON_P3_22_OD_BIT 10

#define LPC_IOCON_P3_23 (*(volatile unsigned long *)0x4002C1DC)
#define LPC_IOCON_P3_23_OFFSET 0x1DC
#define LPC_IOCON_P3_23_FUNC_MASK 0x7
#define LPC_IOCON_P3_23_FUNC_BIT 0
#define LPC_IOCON_P3_23_MODE_MASK 0x18
#define LPC_IOCON_P3_23_MODE_BIT 3
#define LPC_IOCON_P3_23_HYS_MASK 0x20
#define LPC_IOCON_P3_23_HYS 0x20
#define LPC_IOCON_P3_23_HYS_BIT 5
#define LPC_IOCON_P3_23_INV_MASK 0x40
#define LPC_IOCON_P3_23_INV 0x40
#define LPC_IOCON_P3_23_INV_BIT 6
#define LPC_IOCON_P3_23_SLEW_MASK 0x200
#define LPC_IOCON_P3_23_SLEW 0x200
#define LPC_IOCON_P3_23_SLEW_BIT 9
#define LPC_IOCON_P3_23_OD_MASK 0x400
#define LPC_IOCON_P3_23_OD 0x400
#define LPC_IOCON_P3_23_OD_BIT 10

#define LPC_IOCON_P3_24 (*(volatile unsigned long *)0x4002C1E0)
#define LPC_IOCON_P3_24_OFFSET 0x1E0
#define LPC_IOCON_P3_24_FUNC_MASK 0x7
#define LPC_IOCON_P3_24_FUNC_BIT 0
#define LPC_IOCON_P3_24_MODE_MASK 0x18
#define LPC_IOCON_P3_24_MODE_BIT 3
#define LPC_IOCON_P3_24_HYS_MASK 0x20
#define LPC_IOCON_P3_24_HYS 0x20
#define LPC_IOCON_P3_24_HYS_BIT 5
#define LPC_IOCON_P3_24_INV_MASK 0x40
#define LPC_IOCON_P3_24_INV 0x40
#define LPC_IOCON_P3_24_INV_BIT 6
#define LPC_IOCON_P3_24_SLEW_MASK 0x200
#define LPC_IOCON_P3_24_SLEW 0x200
#define LPC_IOCON_P3_24_SLEW_BIT 9
#define LPC_IOCON_P3_24_OD_MASK 0x400
#define LPC_IOCON_P3_24_OD 0x400
#define LPC_IOCON_P3_24_OD_BIT 10

#define LPC_IOCON_P3_25 (*(volatile unsigned long *)0x4002C1E4)
#define LPC_IOCON_P3_25_OFFSET 0x1E4
#define LPC_IOCON_P3_25_FUNC_MASK 0x7
#define LPC_IOCON_P3_25_FUNC_BIT 0
#define LPC_IOCON_P3_25_MODE_MASK 0x18
#define LPC_IOCON_P3_25_MODE_BIT 3
#define LPC_IOCON_P3_25_HYS_MASK 0x20
#define LPC_IOCON_P3_25_HYS 0x20
#define LPC_IOCON_P3_25_HYS_BIT 5
#define LPC_IOCON_P3_25_INV_MASK 0x40
#define LPC_IOCON_P3_25_INV 0x40
#define LPC_IOCON_P3_25_INV_BIT 6
#define LPC_IOCON_P3_25_SLEW_MASK 0x200
#define LPC_IOCON_P3_25_SLEW 0x200
#define LPC_IOCON_P3_25_SLEW_BIT 9
#define LPC_IOCON_P3_25_OD_MASK 0x400
#define LPC_IOCON_P3_25_OD 0x400
#define LPC_IOCON_P3_25_OD_BIT 10

#define LPC_IOCON_P3_26 (*(volatile unsigned long *)0x4002C1E8)
#define LPC_IOCON_P3_26_OFFSET 0x1E8
#define LPC_IOCON_P3_26_FUNC_MASK 0x7
#define LPC_IOCON_P3_26_FUNC_BIT 0
#define LPC_IOCON_P3_26_MODE_MASK 0x18
#define LPC_IOCON_P3_26_MODE_BIT 3
#define LPC_IOCON_P3_26_HYS_MASK 0x20
#define LPC_IOCON_P3_26_HYS 0x20
#define LPC_IOCON_P3_26_HYS_BIT 5
#define LPC_IOCON_P3_26_INV_MASK 0x40
#define LPC_IOCON_P3_26_INV 0x40
#define LPC_IOCON_P3_26_INV_BIT 6
#define LPC_IOCON_P3_26_SLEW_MASK 0x200
#define LPC_IOCON_P3_26_SLEW 0x200
#define LPC_IOCON_P3_26_SLEW_BIT 9
#define LPC_IOCON_P3_26_OD_MASK 0x400
#define LPC_IOCON_P3_26_OD 0x400
#define LPC_IOCON_P3_26_OD_BIT 10

#define LPC_IOCON_P3_27 (*(volatile unsigned long *)0x4002C1EC)
#define LPC_IOCON_P3_27_OFFSET 0x1EC
#define LPC_IOCON_P3_27_FUNC_MASK 0x7
#define LPC_IOCON_P3_27_FUNC_BIT 0
#define LPC_IOCON_P3_27_MODE_MASK 0x18
#define LPC_IOCON_P3_27_MODE_BIT 3
#define LPC_IOCON_P3_27_HYS_MASK 0x20
#define LPC_IOCON_P3_27_HYS 0x20
#define LPC_IOCON_P3_27_HYS_BIT 5
#define LPC_IOCON_P3_27_INV_MASK 0x40
#define LPC_IOCON_P3_27_INV 0x40
#define LPC_IOCON_P3_27_INV_BIT 6
#define LPC_IOCON_P3_27_SLEW_MASK 0x200
#define LPC_IOCON_P3_27_SLEW 0x200
#define LPC_IOCON_P3_27_SLEW_BIT 9
#define LPC_IOCON_P3_27_OD_MASK 0x400
#define LPC_IOCON_P3_27_OD 0x400
#define LPC_IOCON_P3_27_OD_BIT 10

#define LPC_IOCON_P3_28 (*(volatile unsigned long *)0x4002C1F0)
#define LPC_IOCON_P3_28_OFFSET 0x1F0
#define LPC_IOCON_P3_28_FUNC_MASK 0x7
#define LPC_IOCON_P3_28_FUNC_BIT 0
#define LPC_IOCON_P3_28_MODE_MASK 0x18
#define LPC_IOCON_P3_28_MODE_BIT 3
#define LPC_IOCON_P3_28_HYS_MASK 0x20
#define LPC_IOCON_P3_28_HYS 0x20
#define LPC_IOCON_P3_28_HYS_BIT 5
#define LPC_IOCON_P3_28_INV_MASK 0x40
#define LPC_IOCON_P3_28_INV 0x40
#define LPC_IOCON_P3_28_INV_BIT 6
#define LPC_IOCON_P3_28_SLEW_MASK 0x200
#define LPC_IOCON_P3_28_SLEW 0x200
#define LPC_IOCON_P3_28_SLEW_BIT 9
#define LPC_IOCON_P3_28_OD_MASK 0x400
#define LPC_IOCON_P3_28_OD 0x400
#define LPC_IOCON_P3_28_OD_BIT 10

#define LPC_IOCON_P3_29 (*(volatile unsigned long *)0x4002C1F4)
#define LPC_IOCON_P3_29_OFFSET 0x1F4
#define LPC_IOCON_P3_29_FUNC_MASK 0x7
#define LPC_IOCON_P3_29_FUNC_BIT 0
#define LPC_IOCON_P3_29_MODE_MASK 0x18
#define LPC_IOCON_P3_29_MODE_BIT 3
#define LPC_IOCON_P3_29_HYS_MASK 0x20
#define LPC_IOCON_P3_29_HYS 0x20
#define LPC_IOCON_P3_29_HYS_BIT 5
#define LPC_IOCON_P3_29_INV_MASK 0x40
#define LPC_IOCON_P3_29_INV 0x40
#define LPC_IOCON_P3_29_INV_BIT 6
#define LPC_IOCON_P3_29_SLEW_MASK 0x200
#define LPC_IOCON_P3_29_SLEW 0x200
#define LPC_IOCON_P3_29_SLEW_BIT 9
#define LPC_IOCON_P3_29_OD_MASK 0x400
#define LPC_IOCON_P3_29_OD 0x400
#define LPC_IOCON_P3_29_OD_BIT 10

#define LPC_IOCON_P3_30 (*(volatile unsigned long *)0x4002C1F8)
#define LPC_IOCON_P3_30_OFFSET 0x1F8
#define LPC_IOCON_P3_30_FUNC_MASK 0x7
#define LPC_IOCON_P3_30_FUNC_BIT 0
#define LPC_IOCON_P3_30_MODE_MASK 0x18
#define LPC_IOCON_P3_30_MODE_BIT 3
#define LPC_IOCON_P3_30_HYS_MASK 0x20
#define LPC_IOCON_P3_30_HYS 0x20
#define LPC_IOCON_P3_30_HYS_BIT 5
#define LPC_IOCON_P3_30_INV_MASK 0x40
#define LPC_IOCON_P3_30_INV 0x40
#define LPC_IOCON_P3_30_INV_BIT 6
#define LPC_IOCON_P3_30_SLEW_MASK 0x200
#define LPC_IOCON_P3_30_SLEW 0x200
#define LPC_IOCON_P3_30_SLEW_BIT 9
#define LPC_IOCON_P3_30_OD_MASK 0x400
#define LPC_IOCON_P3_30_OD 0x400
#define LPC_IOCON_P3_30_OD_BIT 10

#define LPC_IOCON_P3_31 (*(volatile unsigned long *)0x4002C1FC)
#define LPC_IOCON_P3_31_OFFSET 0x1FC
#define LPC_IOCON_P3_31_FUNC_MASK 0x7
#define LPC_IOCON_P3_31_FUNC_BIT 0
#define LPC_IOCON_P3_31_MODE_MASK 0x18
#define LPC_IOCON_P3_31_MODE_BIT 3
#define LPC_IOCON_P3_31_HYS_MASK 0x20
#define LPC_IOCON_P3_31_HYS 0x20
#define LPC_IOCON_P3_31_HYS_BIT 5
#define LPC_IOCON_P3_31_INV_MASK 0x40
#define LPC_IOCON_P3_31_INV 0x40
#define LPC_IOCON_P3_31_INV_BIT 6
#define LPC_IOCON_P3_31_SLEW_MASK 0x200
#define LPC_IOCON_P3_31_SLEW 0x200
#define LPC_IOCON_P3_31_SLEW_BIT 9
#define LPC_IOCON_P3_31_OD_MASK 0x400
#define LPC_IOCON_P3_31_OD 0x400
#define LPC_IOCON_P3_31_OD_BIT 10

#define LPC_IOCON_P4_0 (*(volatile unsigned long *)0x4002C200)
#define LPC_IOCON_P4_0_OFFSET 0x200
#define LPC_IOCON_P4_0_FUNC_MASK 0x7
#define LPC_IOCON_P4_0_FUNC_BIT 0
#define LPC_IOCON_P4_0_MODE_MASK 0x18
#define LPC_IOCON_P4_0_MODE_BIT 3
#define LPC_IOCON_P4_0_HYS_MASK 0x20
#define LPC_IOCON_P4_0_HYS 0x20
#define LPC_IOCON_P4_0_HYS_BIT 5
#define LPC_IOCON_P4_0_INV_MASK 0x40
#define LPC_IOCON_P4_0_INV 0x40
#define LPC_IOCON_P4_0_INV_BIT 6
#define LPC_IOCON_P4_0_SLEW_MASK 0x200
#define LPC_IOCON_P4_0_SLEW 0x200
#define LPC_IOCON_P4_0_SLEW_BIT 9
#define LPC_IOCON_P4_0_OD_MASK 0x400
#define LPC_IOCON_P4_0_OD 0x400
#define LPC_IOCON_P4_0_OD_BIT 10

#define LPC_IOCON_P4_1 (*(volatile unsigned long *)0x4002C204)
#define LPC_IOCON_P4_1_OFFSET 0x204
#define LPC_IOCON_P4_1_FUNC_MASK 0x7
#define LPC_IOCON_P4_1_FUNC_BIT 0
#define LPC_IOCON_P4_1_MODE_MASK 0x18
#define LPC_IOCON_P4_1_MODE_BIT 3
#define LPC_IOCON_P4_1_HYS_MASK 0x20
#define LPC_IOCON_P4_1_HYS 0x20
#define LPC_IOCON_P4_1_HYS_BIT 5
#define LPC_IOCON_P4_1_INV_MASK 0x40
#define LPC_IOCON_P4_1_INV 0x40
#define LPC_IOCON_P4_1_INV_BIT 6
#define LPC_IOCON_P4_1_SLEW_MASK 0x200
#define LPC_IOCON_P4_1_SLEW 0x200
#define LPC_IOCON_P4_1_SLEW_BIT 9
#define LPC_IOCON_P4_1_OD_MASK 0x400
#define LPC_IOCON_P4_1_OD 0x400
#define LPC_IOCON_P4_1_OD_BIT 10

#define LPC_IOCON_P4_2 (*(volatile unsigned long *)0x4002C208)
#define LPC_IOCON_P4_2_OFFSET 0x208
#define LPC_IOCON_P4_2_FUNC_MASK 0x7
#define LPC_IOCON_P4_2_FUNC_BIT 0
#define LPC_IOCON_P4_2_MODE_MASK 0x18
#define LPC_IOCON_P4_2_MODE_BIT 3
#define LPC_IOCON_P4_2_HYS_MASK 0x20
#define LPC_IOCON_P4_2_HYS 0x20
#define LPC_IOCON_P4_2_HYS_BIT 5
#define LPC_IOCON_P4_2_INV_MASK 0x40
#define LPC_IOCON_P4_2_INV 0x40
#define LPC_IOCON_P4_2_INV_BIT 6
#define LPC_IOCON_P4_2_SLEW_MASK 0x200
#define LPC_IOCON_P4_2_SLEW 0x200
#define LPC_IOCON_P4_2_SLEW_BIT 9
#define LPC_IOCON_P4_2_OD_MASK 0x400
#define LPC_IOCON_P4_2_OD 0x400
#define LPC_IOCON_P4_2_OD_BIT 10

#define LPC_IOCON_P4_3 (*(volatile unsigned long *)0x4002C20C)
#define LPC_IOCON_P4_3_OFFSET 0x20C
#define LPC_IOCON_P4_3_FUNC_MASK 0x7
#define LPC_IOCON_P4_3_FUNC_BIT 0
#define LPC_IOCON_P4_3_MODE_MASK 0x18
#define LPC_IOCON_P4_3_MODE_BIT 3
#define LPC_IOCON_P4_3_HYS_MASK 0x20
#define LPC_IOCON_P4_3_HYS 0x20
#define LPC_IOCON_P4_3_HYS_BIT 5
#define LPC_IOCON_P4_3_INV_MASK 0x40
#define LPC_IOCON_P4_3_INV 0x40
#define LPC_IOCON_P4_3_INV_BIT 6
#define LPC_IOCON_P4_3_SLEW_MASK 0x200
#define LPC_IOCON_P4_3_SLEW 0x200
#define LPC_IOCON_P4_3_SLEW_BIT 9
#define LPC_IOCON_P4_3_OD_MASK 0x400
#define LPC_IOCON_P4_3_OD 0x400
#define LPC_IOCON_P4_3_OD_BIT 10

#define LPC_IOCON_P4_4 (*(volatile unsigned long *)0x4002C210)
#define LPC_IOCON_P4_4_OFFSET 0x210
#define LPC_IOCON_P4_4_FUNC_MASK 0x7
#define LPC_IOCON_P4_4_FUNC_BIT 0
#define LPC_IOCON_P4_4_MODE_MASK 0x18
#define LPC_IOCON_P4_4_MODE_BIT 3
#define LPC_IOCON_P4_4_HYS_MASK 0x20
#define LPC_IOCON_P4_4_HYS 0x20
#define LPC_IOCON_P4_4_HYS_BIT 5
#define LPC_IOCON_P4_4_INV_MASK 0x40
#define LPC_IOCON_P4_4_INV 0x40
#define LPC_IOCON_P4_4_INV_BIT 6
#define LPC_IOCON_P4_4_SLEW_MASK 0x200
#define LPC_IOCON_P4_4_SLEW 0x200
#define LPC_IOCON_P4_4_SLEW_BIT 9
#define LPC_IOCON_P4_4_OD_MASK 0x400
#define LPC_IOCON_P4_4_OD 0x400
#define LPC_IOCON_P4_4_OD_BIT 10

#define LPC_IOCON_P4_5 (*(volatile unsigned long *)0x4002C214)
#define LPC_IOCON_P4_5_OFFSET 0x214
#define LPC_IOCON_P4_5_FUNC_MASK 0x7
#define LPC_IOCON_P4_5_FUNC_BIT 0
#define LPC_IOCON_P4_5_MODE_MASK 0x18
#define LPC_IOCON_P4_5_MODE_BIT 3
#define LPC_IOCON_P4_5_HYS_MASK 0x20
#define LPC_IOCON_P4_5_HYS 0x20
#define LPC_IOCON_P4_5_HYS_BIT 5
#define LPC_IOCON_P4_5_INV_MASK 0x40
#define LPC_IOCON_P4_5_INV 0x40
#define LPC_IOCON_P4_5_INV_BIT 6
#define LPC_IOCON_P4_5_SLEW_MASK 0x200
#define LPC_IOCON_P4_5_SLEW 0x200
#define LPC_IOCON_P4_5_SLEW_BIT 9
#define LPC_IOCON_P4_5_OD_MASK 0x400
#define LPC_IOCON_P4_5_OD 0x400
#define LPC_IOCON_P4_5_OD_BIT 10

#define LPC_IOCON_P4_6 (*(volatile unsigned long *)0x4002C218)
#define LPC_IOCON_P4_6_OFFSET 0x218
#define LPC_IOCON_P4_6_FUNC_MASK 0x7
#define LPC_IOCON_P4_6_FUNC_BIT 0
#define LPC_IOCON_P4_6_MODE_MASK 0x18
#define LPC_IOCON_P4_6_MODE_BIT 3
#define LPC_IOCON_P4_6_HYS_MASK 0x20
#define LPC_IOCON_P4_6_HYS 0x20
#define LPC_IOCON_P4_6_HYS_BIT 5
#define LPC_IOCON_P4_6_INV_MASK 0x40
#define LPC_IOCON_P4_6_INV 0x40
#define LPC_IOCON_P4_6_INV_BIT 6
#define LPC_IOCON_P4_6_SLEW_MASK 0x200
#define LPC_IOCON_P4_6_SLEW 0x200
#define LPC_IOCON_P4_6_SLEW_BIT 9
#define LPC_IOCON_P4_6_OD_MASK 0x400
#define LPC_IOCON_P4_6_OD 0x400
#define LPC_IOCON_P4_6_OD_BIT 10

#define LPC_IOCON_P4_7 (*(volatile unsigned long *)0x4002C21C)
#define LPC_IOCON_P4_7_OFFSET 0x21C
#define LPC_IOCON_P4_7_FUNC_MASK 0x7
#define LPC_IOCON_P4_7_FUNC_BIT 0
#define LPC_IOCON_P4_7_MODE_MASK 0x18
#define LPC_IOCON_P4_7_MODE_BIT 3
#define LPC_IOCON_P4_7_HYS_MASK 0x20
#define LPC_IOCON_P4_7_HYS 0x20
#define LPC_IOCON_P4_7_HYS_BIT 5
#define LPC_IOCON_P4_7_INV_MASK 0x40
#define LPC_IOCON_P4_7_INV 0x40
#define LPC_IOCON_P4_7_INV_BIT 6
#define LPC_IOCON_P4_7_SLEW_MASK 0x200
#define LPC_IOCON_P4_7_SLEW 0x200
#define LPC_IOCON_P4_7_SLEW_BIT 9
#define LPC_IOCON_P4_7_OD_MASK 0x400
#define LPC_IOCON_P4_7_OD 0x400
#define LPC_IOCON_P4_7_OD_BIT 10

#define LPC_IOCON_P4_8 (*(volatile unsigned long *)0x4002C220)
#define LPC_IOCON_P4_8_OFFSET 0x220
#define LPC_IOCON_P4_8_FUNC_MASK 0x7
#define LPC_IOCON_P4_8_FUNC_BIT 0
#define LPC_IOCON_P4_8_MODE_MASK 0x18
#define LPC_IOCON_P4_8_MODE_BIT 3
#define LPC_IOCON_P4_8_HYS_MASK 0x20
#define LPC_IOCON_P4_8_HYS 0x20
#define LPC_IOCON_P4_8_HYS_BIT 5
#define LPC_IOCON_P4_8_INV_MASK 0x40
#define LPC_IOCON_P4_8_INV 0x40
#define LPC_IOCON_P4_8_INV_BIT 6
#define LPC_IOCON_P4_8_SLEW_MASK 0x200
#define LPC_IOCON_P4_8_SLEW 0x200
#define LPC_IOCON_P4_8_SLEW_BIT 9
#define LPC_IOCON_P4_8_OD_MASK 0x400
#define LPC_IOCON_P4_8_OD 0x400
#define LPC_IOCON_P4_8_OD_BIT 10

#define LPC_IOCON_P4_9 (*(volatile unsigned long *)0x4002C224)
#define LPC_IOCON_P4_9_OFFSET 0x224
#define LPC_IOCON_P4_9_FUNC_MASK 0x7
#define LPC_IOCON_P4_9_FUNC_BIT 0
#define LPC_IOCON_P4_9_MODE_MASK 0x18
#define LPC_IOCON_P4_9_MODE_BIT 3
#define LPC_IOCON_P4_9_HYS_MASK 0x20
#define LPC_IOCON_P4_9_HYS 0x20
#define LPC_IOCON_P4_9_HYS_BIT 5
#define LPC_IOCON_P4_9_INV_MASK 0x40
#define LPC_IOCON_P4_9_INV 0x40
#define LPC_IOCON_P4_9_INV_BIT 6
#define LPC_IOCON_P4_9_SLEW_MASK 0x200
#define LPC_IOCON_P4_9_SLEW 0x200
#define LPC_IOCON_P4_9_SLEW_BIT 9
#define LPC_IOCON_P4_9_OD_MASK 0x400
#define LPC_IOCON_P4_9_OD 0x400
#define LPC_IOCON_P4_9_OD_BIT 10

#define LPC_IOCON_P4_10 (*(volatile unsigned long *)0x4002C228)
#define LPC_IOCON_P4_10_OFFSET 0x228
#define LPC_IOCON_P4_10_FUNC_MASK 0x7
#define LPC_IOCON_P4_10_FUNC_BIT 0
#define LPC_IOCON_P4_10_MODE_MASK 0x18
#define LPC_IOCON_P4_10_MODE_BIT 3
#define LPC_IOCON_P4_10_HYS_MASK 0x20
#define LPC_IOCON_P4_10_HYS 0x20
#define LPC_IOCON_P4_10_HYS_BIT 5
#define LPC_IOCON_P4_10_INV_MASK 0x40
#define LPC_IOCON_P4_10_INV 0x40
#define LPC_IOCON_P4_10_INV_BIT 6
#define LPC_IOCON_P4_10_SLEW_MASK 0x200
#define LPC_IOCON_P4_10_SLEW 0x200
#define LPC_IOCON_P4_10_SLEW_BIT 9
#define LPC_IOCON_P4_10_OD_MASK 0x400
#define LPC_IOCON_P4_10_OD 0x400
#define LPC_IOCON_P4_10_OD_BIT 10

#define LPC_IOCON_P4_11 (*(volatile unsigned long *)0x4002C22C)
#define LPC_IOCON_P4_11_OFFSET 0x22C
#define LPC_IOCON_P4_11_FUNC_MASK 0x7
#define LPC_IOCON_P4_11_FUNC_BIT 0
#define LPC_IOCON_P4_11_MODE_MASK 0x18
#define LPC_IOCON_P4_11_MODE_BIT 3
#define LPC_IOCON_P4_11_HYS_MASK 0x20
#define LPC_IOCON_P4_11_HYS 0x20
#define LPC_IOCON_P4_11_HYS_BIT 5
#define LPC_IOCON_P4_11_INV_MASK 0x40
#define LPC_IOCON_P4_11_INV 0x40
#define LPC_IOCON_P4_11_INV_BIT 6
#define LPC_IOCON_P4_11_SLEW_MASK 0x200
#define LPC_IOCON_P4_11_SLEW 0x200
#define LPC_IOCON_P4_11_SLEW_BIT 9
#define LPC_IOCON_P4_11_OD_MASK 0x400
#define LPC_IOCON_P4_11_OD 0x400
#define LPC_IOCON_P4_11_OD_BIT 10

#define LPC_IOCON_P4_12 (*(volatile unsigned long *)0x4002C230)
#define LPC_IOCON_P4_12_OFFSET 0x230
#define LPC_IOCON_P4_12_FUNC_MASK 0x7
#define LPC_IOCON_P4_12_FUNC_BIT 0
#define LPC_IOCON_P4_12_MODE_MASK 0x18
#define LPC_IOCON_P4_12_MODE_BIT 3
#define LPC_IOCON_P4_12_HYS_MASK 0x20
#define LPC_IOCON_P4_12_HYS 0x20
#define LPC_IOCON_P4_12_HYS_BIT 5
#define LPC_IOCON_P4_12_INV_MASK 0x40
#define LPC_IOCON_P4_12_INV 0x40
#define LPC_IOCON_P4_12_INV_BIT 6
#define LPC_IOCON_P4_12_SLEW_MASK 0x200
#define LPC_IOCON_P4_12_SLEW 0x200
#define LPC_IOCON_P4_12_SLEW_BIT 9
#define LPC_IOCON_P4_12_OD_MASK 0x400
#define LPC_IOCON_P4_12_OD 0x400
#define LPC_IOCON_P4_12_OD_BIT 10

#define LPC_IOCON_P4_13 (*(volatile unsigned long *)0x4002C234)
#define LPC_IOCON_P4_13_OFFSET 0x234
#define LPC_IOCON_P4_13_FUNC_MASK 0x7
#define LPC_IOCON_P4_13_FUNC_BIT 0
#define LPC_IOCON_P4_13_MODE_MASK 0x18
#define LPC_IOCON_P4_13_MODE_BIT 3
#define LPC_IOCON_P4_13_HYS_MASK 0x20
#define LPC_IOCON_P4_13_HYS 0x20
#define LPC_IOCON_P4_13_HYS_BIT 5
#define LPC_IOCON_P4_13_INV_MASK 0x40
#define LPC_IOCON_P4_13_INV 0x40
#define LPC_IOCON_P4_13_INV_BIT 6
#define LPC_IOCON_P4_13_SLEW_MASK 0x200
#define LPC_IOCON_P4_13_SLEW 0x200
#define LPC_IOCON_P4_13_SLEW_BIT 9
#define LPC_IOCON_P4_13_OD_MASK 0x400
#define LPC_IOCON_P4_13_OD 0x400
#define LPC_IOCON_P4_13_OD_BIT 10

#define LPC_IOCON_P4_14 (*(volatile unsigned long *)0x4002C238)
#define LPC_IOCON_P4_14_OFFSET 0x238
#define LPC_IOCON_P4_14_FUNC_MASK 0x7
#define LPC_IOCON_P4_14_FUNC_BIT 0
#define LPC_IOCON_P4_14_MODE_MASK 0x18
#define LPC_IOCON_P4_14_MODE_BIT 3
#define LPC_IOCON_P4_14_HYS_MASK 0x20
#define LPC_IOCON_P4_14_HYS 0x20
#define LPC_IOCON_P4_14_HYS_BIT 5
#define LPC_IOCON_P4_14_INV_MASK 0x40
#define LPC_IOCON_P4_14_INV 0x40
#define LPC_IOCON_P4_14_INV_BIT 6
#define LPC_IOCON_P4_14_SLEW_MASK 0x200
#define LPC_IOCON_P4_14_SLEW 0x200
#define LPC_IOCON_P4_14_SLEW_BIT 9
#define LPC_IOCON_P4_14_OD_MASK 0x400
#define LPC_IOCON_P4_14_OD 0x400
#define LPC_IOCON_P4_14_OD_BIT 10

#define LPC_IOCON_P4_15 (*(volatile unsigned long *)0x4002C23C)
#define LPC_IOCON_P4_15_OFFSET 0x23C
#define LPC_IOCON_P4_15_FUNC_MASK 0x7
#define LPC_IOCON_P4_15_FUNC_BIT 0
#define LPC_IOCON_P4_15_MODE_MASK 0x18
#define LPC_IOCON_P4_15_MODE_BIT 3
#define LPC_IOCON_P4_15_HYS_MASK 0x20
#define LPC_IOCON_P4_15_HYS 0x20
#define LPC_IOCON_P4_15_HYS_BIT 5
#define LPC_IOCON_P4_15_INV_MASK 0x40
#define LPC_IOCON_P4_15_INV 0x40
#define LPC_IOCON_P4_15_INV_BIT 6
#define LPC_IOCON_P4_15_SLEW_MASK 0x200
#define LPC_IOCON_P4_15_SLEW 0x200
#define LPC_IOCON_P4_15_SLEW_BIT 9
#define LPC_IOCON_P4_15_OD_MASK 0x400
#define LPC_IOCON_P4_15_OD 0x400
#define LPC_IOCON_P4_15_OD_BIT 10

#define LPC_IOCON_P4_16 (*(volatile unsigned long *)0x4002C240)
#define LPC_IOCON_P4_16_OFFSET 0x240
#define LPC_IOCON_P4_16_FUNC_MASK 0x7
#define LPC_IOCON_P4_16_FUNC_BIT 0
#define LPC_IOCON_P4_16_MODE_MASK 0x18
#define LPC_IOCON_P4_16_MODE_BIT 3
#define LPC_IOCON_P4_16_HYS_MASK 0x20
#define LPC_IOCON_P4_16_HYS 0x20
#define LPC_IOCON_P4_16_HYS_BIT 5
#define LPC_IOCON_P4_16_INV_MASK 0x40
#define LPC_IOCON_P4_16_INV 0x40
#define LPC_IOCON_P4_16_INV_BIT 6
#define LPC_IOCON_P4_16_SLEW_MASK 0x200
#define LPC_IOCON_P4_16_SLEW 0x200
#define LPC_IOCON_P4_16_SLEW_BIT 9
#define LPC_IOCON_P4_16_OD_MASK 0x400
#define LPC_IOCON_P4_16_OD 0x400
#define LPC_IOCON_P4_16_OD_BIT 10

#define LPC_IOCON_P4_17 (*(volatile unsigned long *)0x4002C244)
#define LPC_IOCON_P4_17_OFFSET 0x244
#define LPC_IOCON_P4_17_FUNC_MASK 0x7
#define LPC_IOCON_P4_17_FUNC_BIT 0
#define LPC_IOCON_P4_17_MODE_MASK 0x18
#define LPC_IOCON_P4_17_MODE_BIT 3
#define LPC_IOCON_P4_17_HYS_MASK 0x20
#define LPC_IOCON_P4_17_HYS 0x20
#define LPC_IOCON_P4_17_HYS_BIT 5
#define LPC_IOCON_P4_17_INV_MASK 0x40
#define LPC_IOCON_P4_17_INV 0x40
#define LPC_IOCON_P4_17_INV_BIT 6
#define LPC_IOCON_P4_17_SLEW_MASK 0x200
#define LPC_IOCON_P4_17_SLEW 0x200
#define LPC_IOCON_P4_17_SLEW_BIT 9
#define LPC_IOCON_P4_17_OD_MASK 0x400
#define LPC_IOCON_P4_17_OD 0x400
#define LPC_IOCON_P4_17_OD_BIT 10

#define LPC_IOCON_P4_18 (*(volatile unsigned long *)0x4002C248)
#define LPC_IOCON_P4_18_OFFSET 0x248
#define LPC_IOCON_P4_18_FUNC_MASK 0x7
#define LPC_IOCON_P4_18_FUNC_BIT 0
#define LPC_IOCON_P4_18_MODE_MASK 0x18
#define LPC_IOCON_P4_18_MODE_BIT 3
#define LPC_IOCON_P4_18_HYS_MASK 0x20
#define LPC_IOCON_P4_18_HYS 0x20
#define LPC_IOCON_P4_18_HYS_BIT 5
#define LPC_IOCON_P4_18_INV_MASK 0x40
#define LPC_IOCON_P4_18_INV 0x40
#define LPC_IOCON_P4_18_INV_BIT 6
#define LPC_IOCON_P4_18_SLEW_MASK 0x200
#define LPC_IOCON_P4_18_SLEW 0x200
#define LPC_IOCON_P4_18_SLEW_BIT 9
#define LPC_IOCON_P4_18_OD_MASK 0x400
#define LPC_IOCON_P4_18_OD 0x400
#define LPC_IOCON_P4_18_OD_BIT 10

#define LPC_IOCON_P4_19 (*(volatile unsigned long *)0x4002C24C)
#define LPC_IOCON_P4_19_OFFSET 0x24C
#define LPC_IOCON_P4_19_FUNC_MASK 0x7
#define LPC_IOCON_P4_19_FUNC_BIT 0
#define LPC_IOCON_P4_19_MODE_MASK 0x18
#define LPC_IOCON_P4_19_MODE_BIT 3
#define LPC_IOCON_P4_19_HYS_MASK 0x20
#define LPC_IOCON_P4_19_HYS 0x20
#define LPC_IOCON_P4_19_HYS_BIT 5
#define LPC_IOCON_P4_19_INV_MASK 0x40
#define LPC_IOCON_P4_19_INV 0x40
#define LPC_IOCON_P4_19_INV_BIT 6
#define LPC_IOCON_P4_19_SLEW_MASK 0x200
#define LPC_IOCON_P4_19_SLEW 0x200
#define LPC_IOCON_P4_19_SLEW_BIT 9
#define LPC_IOCON_P4_19_OD_MASK 0x400
#define LPC_IOCON_P4_19_OD 0x400
#define LPC_IOCON_P4_19_OD_BIT 10

#define LPC_IOCON_P4_20 (*(volatile unsigned long *)0x4002C250)
#define LPC_IOCON_P4_20_OFFSET 0x250
#define LPC_IOCON_P4_20_FUNC_MASK 0x7
#define LPC_IOCON_P4_20_FUNC_BIT 0
#define LPC_IOCON_P4_20_MODE_MASK 0x18
#define LPC_IOCON_P4_20_MODE_BIT 3
#define LPC_IOCON_P4_20_HYS_MASK 0x20
#define LPC_IOCON_P4_20_HYS 0x20
#define LPC_IOCON_P4_20_HYS_BIT 5
#define LPC_IOCON_P4_20_INV_MASK 0x40
#define LPC_IOCON_P4_20_INV 0x40
#define LPC_IOCON_P4_20_INV_BIT 6
#define LPC_IOCON_P4_20_SLEW_MASK 0x200
#define LPC_IOCON_P4_20_SLEW 0x200
#define LPC_IOCON_P4_20_SLEW_BIT 9
#define LPC_IOCON_P4_20_OD_MASK 0x400
#define LPC_IOCON_P4_20_OD 0x400
#define LPC_IOCON_P4_20_OD_BIT 10

#define LPC_IOCON_P4_21 (*(volatile unsigned long *)0x4002C254)
#define LPC_IOCON_P4_21_OFFSET 0x254
#define LPC_IOCON_P4_21_FUNC_MASK 0x7
#define LPC_IOCON_P4_21_FUNC_BIT 0
#define LPC_IOCON_P4_21_MODE_MASK 0x18
#define LPC_IOCON_P4_21_MODE_BIT 3
#define LPC_IOCON_P4_21_HYS_MASK 0x20
#define LPC_IOCON_P4_21_HYS 0x20
#define LPC_IOCON_P4_21_HYS_BIT 5
#define LPC_IOCON_P4_21_INV_MASK 0x40
#define LPC_IOCON_P4_21_INV 0x40
#define LPC_IOCON_P4_21_INV_BIT 6
#define LPC_IOCON_P4_21_SLEW_MASK 0x200
#define LPC_IOCON_P4_21_SLEW 0x200
#define LPC_IOCON_P4_21_SLEW_BIT 9
#define LPC_IOCON_P4_21_OD_MASK 0x400
#define LPC_IOCON_P4_21_OD 0x400
#define LPC_IOCON_P4_21_OD_BIT 10

#define LPC_IOCON_P4_22 (*(volatile unsigned long *)0x4002C258)
#define LPC_IOCON_P4_22_OFFSET 0x258
#define LPC_IOCON_P4_22_FUNC_MASK 0x7
#define LPC_IOCON_P4_22_FUNC_BIT 0
#define LPC_IOCON_P4_22_MODE_MASK 0x18
#define LPC_IOCON_P4_22_MODE_BIT 3
#define LPC_IOCON_P4_22_HYS_MASK 0x20
#define LPC_IOCON_P4_22_HYS 0x20
#define LPC_IOCON_P4_22_HYS_BIT 5
#define LPC_IOCON_P4_22_INV_MASK 0x40
#define LPC_IOCON_P4_22_INV 0x40
#define LPC_IOCON_P4_22_INV_BIT 6
#define LPC_IOCON_P4_22_SLEW_MASK 0x200
#define LPC_IOCON_P4_22_SLEW 0x200
#define LPC_IOCON_P4_22_SLEW_BIT 9
#define LPC_IOCON_P4_22_OD_MASK 0x400
#define LPC_IOCON_P4_22_OD 0x400
#define LPC_IOCON_P4_22_OD_BIT 10

#define LPC_IOCON_P4_23 (*(volatile unsigned long *)0x4002C25C)
#define LPC_IOCON_P4_23_OFFSET 0x25C
#define LPC_IOCON_P4_23_FUNC_MASK 0x7
#define LPC_IOCON_P4_23_FUNC_BIT 0
#define LPC_IOCON_P4_23_MODE_MASK 0x18
#define LPC_IOCON_P4_23_MODE_BIT 3
#define LPC_IOCON_P4_23_HYS_MASK 0x20
#define LPC_IOCON_P4_23_HYS 0x20
#define LPC_IOCON_P4_23_HYS_BIT 5
#define LPC_IOCON_P4_23_INV_MASK 0x40
#define LPC_IOCON_P4_23_INV 0x40
#define LPC_IOCON_P4_23_INV_BIT 6
#define LPC_IOCON_P4_23_SLEW_MASK 0x200
#define LPC_IOCON_P4_23_SLEW 0x200
#define LPC_IOCON_P4_23_SLEW_BIT 9
#define LPC_IOCON_P4_23_OD_MASK 0x400
#define LPC_IOCON_P4_23_OD 0x400
#define LPC_IOCON_P4_23_OD_BIT 10

#define LPC_IOCON_P4_24 (*(volatile unsigned long *)0x4002C260)
#define LPC_IOCON_P4_24_OFFSET 0x260
#define LPC_IOCON_P4_24_FUNC_MASK 0x7
#define LPC_IOCON_P4_24_FUNC_BIT 0
#define LPC_IOCON_P4_24_MODE_MASK 0x18
#define LPC_IOCON_P4_24_MODE_BIT 3
#define LPC_IOCON_P4_24_HYS_MASK 0x20
#define LPC_IOCON_P4_24_HYS 0x20
#define LPC_IOCON_P4_24_HYS_BIT 5
#define LPC_IOCON_P4_24_INV_MASK 0x40
#define LPC_IOCON_P4_24_INV 0x40
#define LPC_IOCON_P4_24_INV_BIT 6
#define LPC_IOCON_P4_24_SLEW_MASK 0x200
#define LPC_IOCON_P4_24_SLEW 0x200
#define LPC_IOCON_P4_24_SLEW_BIT 9
#define LPC_IOCON_P4_24_OD_MASK 0x400
#define LPC_IOCON_P4_24_OD 0x400
#define LPC_IOCON_P4_24_OD_BIT 10

#define LPC_IOCON_P4_25 (*(volatile unsigned long *)0x4002C264)
#define LPC_IOCON_P4_25_OFFSET 0x264
#define LPC_IOCON_P4_25_FUNC_MASK 0x7
#define LPC_IOCON_P4_25_FUNC_BIT 0
#define LPC_IOCON_P4_25_MODE_MASK 0x18
#define LPC_IOCON_P4_25_MODE_BIT 3
#define LPC_IOCON_P4_25_HYS_MASK 0x20
#define LPC_IOCON_P4_25_HYS 0x20
#define LPC_IOCON_P4_25_HYS_BIT 5
#define LPC_IOCON_P4_25_INV_MASK 0x40
#define LPC_IOCON_P4_25_INV 0x40
#define LPC_IOCON_P4_25_INV_BIT 6
#define LPC_IOCON_P4_25_SLEW_MASK 0x200
#define LPC_IOCON_P4_25_SLEW 0x200
#define LPC_IOCON_P4_25_SLEW_BIT 9
#define LPC_IOCON_P4_25_OD_MASK 0x400
#define LPC_IOCON_P4_25_OD 0x400
#define LPC_IOCON_P4_25_OD_BIT 10

#define LPC_IOCON_P4_26 (*(volatile unsigned long *)0x4002C268)
#define LPC_IOCON_P4_26_OFFSET 0x268
#define LPC_IOCON_P4_26_FUNC_MASK 0x7
#define LPC_IOCON_P4_26_FUNC_BIT 0
#define LPC_IOCON_P4_26_MODE_MASK 0x18
#define LPC_IOCON_P4_26_MODE_BIT 3
#define LPC_IOCON_P4_26_HYS_MASK 0x20
#define LPC_IOCON_P4_26_HYS 0x20
#define LPC_IOCON_P4_26_HYS_BIT 5
#define LPC_IOCON_P4_26_INV_MASK 0x40
#define LPC_IOCON_P4_26_INV 0x40
#define LPC_IOCON_P4_26_INV_BIT 6
#define LPC_IOCON_P4_26_SLEW_MASK 0x200
#define LPC_IOCON_P4_26_SLEW 0x200
#define LPC_IOCON_P4_26_SLEW_BIT 9
#define LPC_IOCON_P4_26_OD_MASK 0x400
#define LPC_IOCON_P4_26_OD 0x400
#define LPC_IOCON_P4_26_OD_BIT 10

#define LPC_IOCON_P4_27 (*(volatile unsigned long *)0x4002C26C)
#define LPC_IOCON_P4_27_OFFSET 0x26C
#define LPC_IOCON_P4_27_FUNC_MASK 0x7
#define LPC_IOCON_P4_27_FUNC_BIT 0
#define LPC_IOCON_P4_27_MODE_MASK 0x18
#define LPC_IOCON_P4_27_MODE_BIT 3
#define LPC_IOCON_P4_27_HYS_MASK 0x20
#define LPC_IOCON_P4_27_HYS 0x20
#define LPC_IOCON_P4_27_HYS_BIT 5
#define LPC_IOCON_P4_27_INV_MASK 0x40
#define LPC_IOCON_P4_27_INV 0x40
#define LPC_IOCON_P4_27_INV_BIT 6
#define LPC_IOCON_P4_27_SLEW_MASK 0x200
#define LPC_IOCON_P4_27_SLEW 0x200
#define LPC_IOCON_P4_27_SLEW_BIT 9
#define LPC_IOCON_P4_27_OD_MASK 0x400
#define LPC_IOCON_P4_27_OD 0x400
#define LPC_IOCON_P4_27_OD_BIT 10

#define LPC_IOCON_P4_28 (*(volatile unsigned long *)0x4002C270)
#define LPC_IOCON_P4_28_OFFSET 0x270
#define LPC_IOCON_P4_28_FUNC_MASK 0x7
#define LPC_IOCON_P4_28_FUNC_BIT 0
#define LPC_IOCON_P4_28_MODE_MASK 0x18
#define LPC_IOCON_P4_28_MODE_BIT 3
#define LPC_IOCON_P4_28_HYS_MASK 0x20
#define LPC_IOCON_P4_28_HYS 0x20
#define LPC_IOCON_P4_28_HYS_BIT 5
#define LPC_IOCON_P4_28_INV_MASK 0x40
#define LPC_IOCON_P4_28_INV 0x40
#define LPC_IOCON_P4_28_INV_BIT 6
#define LPC_IOCON_P4_28_SLEW_MASK 0x200
#define LPC_IOCON_P4_28_SLEW 0x200
#define LPC_IOCON_P4_28_SLEW_BIT 9
#define LPC_IOCON_P4_28_OD_MASK 0x400
#define LPC_IOCON_P4_28_OD 0x400
#define LPC_IOCON_P4_28_OD_BIT 10

#define LPC_IOCON_P4_29 (*(volatile unsigned long *)0x4002C274)
#define LPC_IOCON_P4_29_OFFSET 0x274
#define LPC_IOCON_P4_29_FUNC_MASK 0x7
#define LPC_IOCON_P4_29_FUNC_BIT 0
#define LPC_IOCON_P4_29_MODE_MASK 0x18
#define LPC_IOCON_P4_29_MODE_BIT 3
#define LPC_IOCON_P4_29_HYS_MASK 0x20
#define LPC_IOCON_P4_29_HYS 0x20
#define LPC_IOCON_P4_29_HYS_BIT 5
#define LPC_IOCON_P4_29_INV_MASK 0x40
#define LPC_IOCON_P4_29_INV 0x40
#define LPC_IOCON_P4_29_INV_BIT 6
#define LPC_IOCON_P4_29_SLEW_MASK 0x200
#define LPC_IOCON_P4_29_SLEW 0x200
#define LPC_IOCON_P4_29_SLEW_BIT 9
#define LPC_IOCON_P4_29_OD_MASK 0x400
#define LPC_IOCON_P4_29_OD 0x400
#define LPC_IOCON_P4_29_OD_BIT 10

#define LPC_IOCON_P4_30 (*(volatile unsigned long *)0x4002C278)
#define LPC_IOCON_P4_30_OFFSET 0x278
#define LPC_IOCON_P4_30_FUNC_MASK 0x7
#define LPC_IOCON_P4_30_FUNC_BIT 0
#define LPC_IOCON_P4_30_MODE_MASK 0x18
#define LPC_IOCON_P4_30_MODE_BIT 3
#define LPC_IOCON_P4_30_HYS_MASK 0x20
#define LPC_IOCON_P4_30_HYS 0x20
#define LPC_IOCON_P4_30_HYS_BIT 5
#define LPC_IOCON_P4_30_INV_MASK 0x40
#define LPC_IOCON_P4_30_INV 0x40
#define LPC_IOCON_P4_30_INV_BIT 6
#define LPC_IOCON_P4_30_SLEW_MASK 0x200
#define LPC_IOCON_P4_30_SLEW 0x200
#define LPC_IOCON_P4_30_SLEW_BIT 9
#define LPC_IOCON_P4_30_OD_MASK 0x400
#define LPC_IOCON_P4_30_OD 0x400
#define LPC_IOCON_P4_30_OD_BIT 10

#define LPC_IOCON_P4_31 (*(volatile unsigned long *)0x4002C27C)
#define LPC_IOCON_P4_31_OFFSET 0x27C
#define LPC_IOCON_P4_31_FUNC_MASK 0x7
#define LPC_IOCON_P4_31_FUNC_BIT 0
#define LPC_IOCON_P4_31_MODE_MASK 0x18
#define LPC_IOCON_P4_31_MODE_BIT 3
#define LPC_IOCON_P4_31_HYS_MASK 0x20
#define LPC_IOCON_P4_31_HYS 0x20
#define LPC_IOCON_P4_31_HYS_BIT 5
#define LPC_IOCON_P4_31_INV_MASK 0x40
#define LPC_IOCON_P4_31_INV 0x40
#define LPC_IOCON_P4_31_INV_BIT 6
#define LPC_IOCON_P4_31_SLEW_MASK 0x200
#define LPC_IOCON_P4_31_SLEW 0x200
#define LPC_IOCON_P4_31_SLEW_BIT 9
#define LPC_IOCON_P4_31_OD_MASK 0x400
#define LPC_IOCON_P4_31_OD 0x400
#define LPC_IOCON_P4_31_OD_BIT 10

#define LPC_IOCON_P5_0 (*(volatile unsigned long *)0x4002C280)
#define LPC_IOCON_P5_0_OFFSET 0x280
#define LPC_IOCON_P5_0_FUNC_MASK 0x7
#define LPC_IOCON_P5_0_FUNC_BIT 0
#define LPC_IOCON_P5_0_MODE_MASK 0x18
#define LPC_IOCON_P5_0_MODE_BIT 3
#define LPC_IOCON_P5_0_HYS_MASK 0x20
#define LPC_IOCON_P5_0_HYS 0x20
#define LPC_IOCON_P5_0_HYS_BIT 5
#define LPC_IOCON_P5_0_INV_MASK 0x40
#define LPC_IOCON_P5_0_INV 0x40
#define LPC_IOCON_P5_0_INV_BIT 6
#define LPC_IOCON_P5_0_SLEW_MASK 0x200
#define LPC_IOCON_P5_0_SLEW 0x200
#define LPC_IOCON_P5_0_SLEW_BIT 9
#define LPC_IOCON_P5_0_OD_MASK 0x400
#define LPC_IOCON_P5_0_OD 0x400
#define LPC_IOCON_P5_0_OD_BIT 10

#define LPC_IOCON_P5_1 (*(volatile unsigned long *)0x4002C284)
#define LPC_IOCON_P5_1_OFFSET 0x284
#define LPC_IOCON_P5_1_FUNC_MASK 0x7
#define LPC_IOCON_P5_1_FUNC_BIT 0
#define LPC_IOCON_P5_1_MODE_MASK 0x18
#define LPC_IOCON_P5_1_MODE_BIT 3
#define LPC_IOCON_P5_1_HYS_MASK 0x20
#define LPC_IOCON_P5_1_HYS 0x20
#define LPC_IOCON_P5_1_HYS_BIT 5
#define LPC_IOCON_P5_1_INV_MASK 0x40
#define LPC_IOCON_P5_1_INV 0x40
#define LPC_IOCON_P5_1_INV_BIT 6
#define LPC_IOCON_P5_1_SLEW_MASK 0x200
#define LPC_IOCON_P5_1_SLEW 0x200
#define LPC_IOCON_P5_1_SLEW_BIT 9
#define LPC_IOCON_P5_1_OD_MASK 0x400
#define LPC_IOCON_P5_1_OD 0x400
#define LPC_IOCON_P5_1_OD_BIT 10

#define LPC_IOCON_P5_2 (*(volatile unsigned long *)0x4002C288)
#define LPC_IOCON_P5_2_OFFSET 0x288
#define LPC_IOCON_P5_2_FUNC_MASK 0x7
#define LPC_IOCON_P5_2_FUNC_BIT 0
#define LPC_IOCON_P5_2_INV_MASK 0x40
#define LPC_IOCON_P5_2_INV 0x40
#define LPC_IOCON_P5_2_INV_BIT 6
#define LPC_IOCON_P5_2_HS_MASK 0x100
#define LPC_IOCON_P5_2_HS 0x100
#define LPC_IOCON_P5_2_HS_BIT 8
#define LPC_IOCON_P5_2_HIDRIVE_MASK 0x200
#define LPC_IOCON_P5_2_HIDRIVE 0x200
#define LPC_IOCON_P5_2_HIDRIVE_BIT 9

#define LPC_IOCON_P5_3 (*(volatile unsigned long *)0x4002C28C)
#define LPC_IOCON_P5_3_OFFSET 0x28C
#define LPC_IOCON_P5_3_FUNC_MASK 0x7
#define LPC_IOCON_P5_3_FUNC_BIT 0
#define LPC_IOCON_P5_3_INV_MASK 0x40
#define LPC_IOCON_P5_3_INV 0x40
#define LPC_IOCON_P5_3_INV_BIT 6
#define LPC_IOCON_P5_3_HS_MASK 0x100
#define LPC_IOCON_P5_3_HS 0x100
#define LPC_IOCON_P5_3_HS_BIT 8
#define LPC_IOCON_P5_3_HIDRIVE_MASK 0x200
#define LPC_IOCON_P5_3_HIDRIVE 0x200
#define LPC_IOCON_P5_3_HIDRIVE_BIT 9

#define LPC_IOCON_P5_4 (*(volatile unsigned long *)0x4002C290)
#define LPC_IOCON_P5_4_OFFSET 0x290
#define LPC_IOCON_P5_4_FUNC_MASK 0x7
#define LPC_IOCON_P5_4_FUNC_BIT 0
#define LPC_IOCON_P5_4_MODE_MASK 0x18
#define LPC_IOCON_P5_4_MODE_BIT 3
#define LPC_IOCON_P5_4_HYS_MASK 0x20
#define LPC_IOCON_P5_4_HYS 0x20
#define LPC_IOCON_P5_4_HYS_BIT 5
#define LPC_IOCON_P5_4_INV_MASK 0x40
#define LPC_IOCON_P5_4_INV 0x40
#define LPC_IOCON_P5_4_INV_BIT 6
#define LPC_IOCON_P5_4_SLEW_MASK 0x200
#define LPC_IOCON_P5_4_SLEW 0x200
#define LPC_IOCON_P5_4_SLEW_BIT 9
#define LPC_IOCON_P5_4_OD_MASK 0x400
#define LPC_IOCON_P5_4_OD 0x400
#define LPC_IOCON_P5_4_OD_BIT 10

#ifndef LPC_SSP1_BASE_ADDRESS
#define LPC_SSP1_BASE_ADDRESS 0x40030000
#endif

#define LPC_SSP1_CR0 (*(volatile unsigned long *)0x40030000)
#define LPC_SSP1_CR0_OFFSET 0x0
#define LPC_SSP1_CR0_DSS_MASK 0xF
#define LPC_SSP1_CR0_DSS_BIT 0
#define LPC_SSP1_CR0_FRF_MASK 0x30
#define LPC_SSP1_CR0_FRF_BIT 4
#define LPC_SSP1_CR0_CPOL_MASK 0x40
#define LPC_SSP1_CR0_CPOL 0x40
#define LPC_SSP1_CR0_CPOL_BIT 6
#define LPC_SSP1_CR0_CPHA_MASK 0x80
#define LPC_SSP1_CR0_CPHA 0x80
#define LPC_SSP1_CR0_CPHA_BIT 7
#define LPC_SSP1_CR0_SCR_MASK 0xFF00
#define LPC_SSP1_CR0_SCR_BIT 8

#define LPC_SSP1_CR1 (*(volatile unsigned long *)0x40030004)
#define LPC_SSP1_CR1_OFFSET 0x4
#define LPC_SSP1_CR1_LBM_MASK 0x1
#define LPC_SSP1_CR1_LBM 0x1
#define LPC_SSP1_CR1_LBM_BIT 0
#define LPC_SSP1_CR1_SSE_MASK 0x2
#define LPC_SSP1_CR1_SSE 0x2
#define LPC_SSP1_CR1_SSE_BIT 1
#define LPC_SSP1_CR1_MS_MASK 0x4
#define LPC_SSP1_CR1_MS 0x4
#define LPC_SSP1_CR1_MS_BIT 2
#define LPC_SSP1_CR1_SOD_MASK 0x8
#define LPC_SSP1_CR1_SOD 0x8
#define LPC_SSP1_CR1_SOD_BIT 3

#define LPC_SSP1_DR (*(volatile unsigned long *)0x40030008)
#define LPC_SSP1_DR_OFFSET 0x8
#define LPC_SSP1_DR_DATA_MASK 0xFFFF
#define LPC_SSP1_DR_DATA_BIT 0

#define LPC_SSP1_SR (*(volatile unsigned long *)0x4003000C)
#define LPC_SSP1_SR_OFFSET 0xC
#define LPC_SSP1_SR_TFE_MASK 0x1
#define LPC_SSP1_SR_TFE 0x1
#define LPC_SSP1_SR_TFE_BIT 0
#define LPC_SSP1_SR_TNF_MASK 0x2
#define LPC_SSP1_SR_TNF 0x2
#define LPC_SSP1_SR_TNF_BIT 1
#define LPC_SSP1_SR_RNE_MASK 0x4
#define LPC_SSP1_SR_RNE 0x4
#define LPC_SSP1_SR_RNE_BIT 2
#define LPC_SSP1_SR_RFF_MASK 0x8
#define LPC_SSP1_SR_RFF 0x8
#define LPC_SSP1_SR_RFF_BIT 3
#define LPC_SSP1_SR_BSY_MASK 0x10
#define LPC_SSP1_SR_BSY 0x10
#define LPC_SSP1_SR_BSY_BIT 4

#define LPC_SSP1_CPSR (*(volatile unsigned long *)0x40030010)
#define LPC_SSP1_CPSR_OFFSET 0x10
#define LPC_SSP1_CPSR_CPSDVSR_MASK 0xFF
#define LPC_SSP1_CPSR_CPSDVSR_BIT 0

#define LPC_SSP1_IMSC (*(volatile unsigned long *)0x40030014)
#define LPC_SSP1_IMSC_OFFSET 0x14
#define LPC_SSP1_IMSC_RORIM_MASK 0x1
#define LPC_SSP1_IMSC_RORIM 0x1
#define LPC_SSP1_IMSC_RORIM_BIT 0
#define LPC_SSP1_IMSC_RTIM_MASK 0x2
#define LPC_SSP1_IMSC_RTIM 0x2
#define LPC_SSP1_IMSC_RTIM_BIT 1
#define LPC_SSP1_IMSC_RXIM_MASK 0x4
#define LPC_SSP1_IMSC_RXIM 0x4
#define LPC_SSP1_IMSC_RXIM_BIT 2
#define LPC_SSP1_IMSC_TXIM_MASK 0x8
#define LPC_SSP1_IMSC_TXIM 0x8
#define LPC_SSP1_IMSC_TXIM_BIT 3

#define LPC_SSP1_RIS (*(volatile unsigned long *)0x40030018)
#define LPC_SSP1_RIS_OFFSET 0x18
#define LPC_SSP1_RIS_RORRIS_MASK 0x1
#define LPC_SSP1_RIS_RORRIS 0x1
#define LPC_SSP1_RIS_RORRIS_BIT 0
#define LPC_SSP1_RIS_RTRIS_MASK 0x2
#define LPC_SSP1_RIS_RTRIS 0x2
#define LPC_SSP1_RIS_RTRIS_BIT 1
#define LPC_SSP1_RIS_RXRIS_MASK 0x4
#define LPC_SSP1_RIS_RXRIS 0x4
#define LPC_SSP1_RIS_RXRIS_BIT 2
#define LPC_SSP1_RIS_TXRIS_MASK 0x8
#define LPC_SSP1_RIS_TXRIS 0x8
#define LPC_SSP1_RIS_TXRIS_BIT 3

#define LPC_SSP1_MIS (*(volatile unsigned long *)0x4003001C)
#define LPC_SSP1_MIS_OFFSET 0x1C
#define LPC_SSP1_MIS_RORMIS_MASK 0x1
#define LPC_SSP1_MIS_RORMIS 0x1
#define LPC_SSP1_MIS_RORMIS_BIT 0
#define LPC_SSP1_MIS_RTMIS_MASK 0x2
#define LPC_SSP1_MIS_RTMIS 0x2
#define LPC_SSP1_MIS_RTMIS_BIT 1
#define LPC_SSP1_MIS_RXMIS_MASK 0x4
#define LPC_SSP1_MIS_RXMIS 0x4
#define LPC_SSP1_MIS_RXMIS_BIT 2
#define LPC_SSP1_MIS_TXMIS_MASK 0x8
#define LPC_SSP1_MIS_TXMIS 0x8
#define LPC_SSP1_MIS_TXMIS_BIT 3

#define LPC_SSP1_ICR (*(volatile unsigned long *)0x40030020)
#define LPC_SSP1_ICR_OFFSET 0x20
#define LPC_SSP1_ICR_RORIC_MASK 0x1
#define LPC_SSP1_ICR_RORIC 0x1
#define LPC_SSP1_ICR_RORIC_BIT 0
#define LPC_SSP1_ICR_RTIC_MASK 0x2
#define LPC_SSP1_ICR_RTIC 0x2
#define LPC_SSP1_ICR_RTIC_BIT 1

#define LPC_SSP1_DMACR (*(volatile unsigned long *)0x40030024)
#define LPC_SSP1_DMACR_OFFSET 0x24
#define LPC_SSP1_DMACR_RXDMAE_MASK 0x1
#define LPC_SSP1_DMACR_RXDMAE 0x1
#define LPC_SSP1_DMACR_RXDMAE_BIT 0
#define LPC_SSP1_DMACR_TXDMAE_MASK 0x2
#define LPC_SSP1_DMACR_TXDMAE 0x2
#define LPC_SSP1_DMACR_TXDMAE_BIT 1

#ifndef LPC_ADC_BASE_ADDRESS
#define LPC_ADC_BASE_ADDRESS 0x40034000
#endif

#define LPC_ADC_CR (*(volatile unsigned long *)0x40034000)
#define LPC_ADC_CR_OFFSET 0x0
#define LPC_ADC_CR_SEL_MASK 0xFF
#define LPC_ADC_CR_SEL_BIT 0
#define LPC_ADC_CR_CLKDIV_MASK 0xFF00
#define LPC_ADC_CR_CLKDIV_BIT 8
#define LPC_ADC_CR_BURST_MASK 0x10000
#define LPC_ADC_CR_BURST 0x10000
#define LPC_ADC_CR_BURST_BIT 16
#define LPC_ADC_CR_PDN_MASK 0x200000
#define LPC_ADC_CR_PDN 0x200000
#define LPC_ADC_CR_PDN_BIT 21
#define LPC_ADC_CR_START_MASK 0x7000000
#define LPC_ADC_CR_START_BIT 24
#define LPC_ADC_CR_EDGE_MASK 0x8000000
#define LPC_ADC_CR_EDGE 0x8000000
#define LPC_ADC_CR_EDGE_BIT 27

#define LPC_ADC_GDR (*(volatile unsigned long *)0x40034004)
#define LPC_ADC_GDR_OFFSET 0x4
#define LPC_ADC_GDR_RESULT_MASK 0xFFF0
#define LPC_ADC_GDR_RESULT_BIT 4
#define LPC_ADC_GDR_CHN_MASK 0x7000000
#define LPC_ADC_GDR_CHN_BIT 24
#define LPC_ADC_GDR_OVERRUN_MASK 0x40000000
#define LPC_ADC_GDR_OVERRUN 0x40000000
#define LPC_ADC_GDR_OVERRUN_BIT 30
#define LPC_ADC_GDR_DONE_MASK 0x80000000
#define LPC_ADC_GDR_DONE 0x80000000
#define LPC_ADC_GDR_DONE_BIT 31

#define LPC_ADC_INTEN (*(volatile unsigned long *)0x4003400C)
#define LPC_ADC_INTEN_OFFSET 0xC
#define LPC_ADC_INTEN_ADINTEN0_MASK 0x1
#define LPC_ADC_INTEN_ADINTEN0 0x1
#define LPC_ADC_INTEN_ADINTEN0_BIT 0
#define LPC_ADC_INTEN_ADINTEN1_MASK 0x2
#define LPC_ADC_INTEN_ADINTEN1 0x2
#define LPC_ADC_INTEN_ADINTEN1_BIT 1
#define LPC_ADC_INTEN_ADINTEN2_MASK 0x4
#define LPC_ADC_INTEN_ADINTEN2 0x4
#define LPC_ADC_INTEN_ADINTEN2_BIT 2
#define LPC_ADC_INTEN_ADINTEN3_MASK 0x8
#define LPC_ADC_INTEN_ADINTEN3 0x8
#define LPC_ADC_INTEN_ADINTEN3_BIT 3
#define LPC_ADC_INTEN_ADINTEN4_MASK 0x10
#define LPC_ADC_INTEN_ADINTEN4 0x10
#define LPC_ADC_INTEN_ADINTEN4_BIT 4
#define LPC_ADC_INTEN_ADINTEN5_MASK 0x20
#define LPC_ADC_INTEN_ADINTEN5 0x20
#define LPC_ADC_INTEN_ADINTEN5_BIT 5
#define LPC_ADC_INTEN_ADINTEN6_MASK 0x40
#define LPC_ADC_INTEN_ADINTEN6 0x40
#define LPC_ADC_INTEN_ADINTEN6_BIT 6
#define LPC_ADC_INTEN_ADINTEN7_MASK 0x80
#define LPC_ADC_INTEN_ADINTEN7 0x80
#define LPC_ADC_INTEN_ADINTEN7_BIT 7
#define LPC_ADC_INTEN_ADGINTEN_MASK 0x100
#define LPC_ADC_INTEN_ADGINTEN 0x100
#define LPC_ADC_INTEN_ADGINTEN_BIT 8

#define LPC_ADC_DR0 (*(volatile unsigned long *)0x40034010)
#define LPC_ADC_DR0_OFFSET 0x10
#define LPC_ADC_DR0_RESULT_MASK 0xFFF0
#define LPC_ADC_DR0_RESULT_BIT 4
#define LPC_ADC_DR0_OVERRUN_MASK 0x40000000
#define LPC_ADC_DR0_OVERRUN 0x40000000
#define LPC_ADC_DR0_OVERRUN_BIT 30
#define LPC_ADC_DR0_DONE_MASK 0x80000000
#define LPC_ADC_DR0_DONE 0x80000000
#define LPC_ADC_DR0_DONE_BIT 31

#define LPC_ADC_DR1 (*(volatile unsigned long *)0x40034014)
#define LPC_ADC_DR1_OFFSET 0x14
#define LPC_ADC_DR1_RESULT_MASK 0xFFF0
#define LPC_ADC_DR1_RESULT_BIT 4
#define LPC_ADC_DR1_OVERRUN_MASK 0x40000000
#define LPC_ADC_DR1_OVERRUN 0x40000000
#define LPC_ADC_DR1_OVERRUN_BIT 30
#define LPC_ADC_DR1_DONE_MASK 0x80000000
#define LPC_ADC_DR1_DONE 0x80000000
#define LPC_ADC_DR1_DONE_BIT 31

#define LPC_ADC_DR2 (*(volatile unsigned long *)0x40034018)
#define LPC_ADC_DR2_OFFSET 0x18
#define LPC_ADC_DR2_RESULT_MASK 0xFFF0
#define LPC_ADC_DR2_RESULT_BIT 4
#define LPC_ADC_DR2_OVERRUN_MASK 0x40000000
#define LPC_ADC_DR2_OVERRUN 0x40000000
#define LPC_ADC_DR2_OVERRUN_BIT 30
#define LPC_ADC_DR2_DONE_MASK 0x80000000
#define LPC_ADC_DR2_DONE 0x80000000
#define LPC_ADC_DR2_DONE_BIT 31

#define LPC_ADC_DR3 (*(volatile unsigned long *)0x4003401C)
#define LPC_ADC_DR3_OFFSET 0x1C
#define LPC_ADC_DR3_RESULT_MASK 0xFFF0
#define LPC_ADC_DR3_RESULT_BIT 4
#define LPC_ADC_DR3_OVERRUN_MASK 0x40000000
#define LPC_ADC_DR3_OVERRUN 0x40000000
#define LPC_ADC_DR3_OVERRUN_BIT 30
#define LPC_ADC_DR3_DONE_MASK 0x80000000
#define LPC_ADC_DR3_DONE 0x80000000
#define LPC_ADC_DR3_DONE_BIT 31

#define LPC_ADC_DR4 (*(volatile unsigned long *)0x40034020)
#define LPC_ADC_DR4_OFFSET 0x20
#define LPC_ADC_DR4_RESULT_MASK 0xFFF0
#define LPC_ADC_DR4_RESULT_BIT 4
#define LPC_ADC_DR4_OVERRUN_MASK 0x40000000
#define LPC_ADC_DR4_OVERRUN 0x40000000
#define LPC_ADC_DR4_OVERRUN_BIT 30
#define LPC_ADC_DR4_DONE_MASK 0x80000000
#define LPC_ADC_DR4_DONE 0x80000000
#define LPC_ADC_DR4_DONE_BIT 31

#define LPC_ADC_DR5 (*(volatile unsigned long *)0x40034024)
#define LPC_ADC_DR5_OFFSET 0x24
#define LPC_ADC_DR5_RESULT_MASK 0xFFF0
#define LPC_ADC_DR5_RESULT_BIT 4
#define LPC_ADC_DR5_OVERRUN_MASK 0x40000000
#define LPC_ADC_DR5_OVERRUN 0x40000000
#define LPC_ADC_DR5_OVERRUN_BIT 30
#define LPC_ADC_DR5_DONE_MASK 0x80000000
#define LPC_ADC_DR5_DONE 0x80000000
#define LPC_ADC_DR5_DONE_BIT 31

#define LPC_ADC_DR6 (*(volatile unsigned long *)0x40034028)
#define LPC_ADC_DR6_OFFSET 0x28
#define LPC_ADC_DR6_RESULT_MASK 0xFFF0
#define LPC_ADC_DR6_RESULT_BIT 4
#define LPC_ADC_DR6_OVERRUN_MASK 0x40000000
#define LPC_ADC_DR6_OVERRUN 0x40000000
#define LPC_ADC_DR6_OVERRUN_BIT 30
#define LPC_ADC_DR6_DONE_MASK 0x80000000
#define LPC_ADC_DR6_DONE 0x80000000
#define LPC_ADC_DR6_DONE_BIT 31

#define LPC_ADC_DR7 (*(volatile unsigned long *)0x4003402C)
#define LPC_ADC_DR7_OFFSET 0x2C
#define LPC_ADC_DR7_RESULT_MASK 0xFFF0
#define LPC_ADC_DR7_RESULT_BIT 4
#define LPC_ADC_DR7_OVERRUN_MASK 0x40000000
#define LPC_ADC_DR7_OVERRUN 0x40000000
#define LPC_ADC_DR7_OVERRUN_BIT 30
#define LPC_ADC_DR7_DONE_MASK 0x80000000
#define LPC_ADC_DR7_DONE 0x80000000
#define LPC_ADC_DR7_DONE_BIT 31

#define LPC_ADC_STAT (*(volatile unsigned long *)0x40034030)
#define LPC_ADC_STAT_OFFSET 0x30
#define LPC_ADC_STAT_DONE0_MASK 0x1
#define LPC_ADC_STAT_DONE0 0x1
#define LPC_ADC_STAT_DONE0_BIT 0
#define LPC_ADC_STAT_DONE1_MASK 0x2
#define LPC_ADC_STAT_DONE1 0x2
#define LPC_ADC_STAT_DONE1_BIT 1
#define LPC_ADC_STAT_DONE2_MASK 0x4
#define LPC_ADC_STAT_DONE2 0x4
#define LPC_ADC_STAT_DONE2_BIT 2
#define LPC_ADC_STAT_DONE3_MASK 0x8
#define LPC_ADC_STAT_DONE3 0x8
#define LPC_ADC_STAT_DONE3_BIT 3
#define LPC_ADC_STAT_DONE4_MASK 0x10
#define LPC_ADC_STAT_DONE4 0x10
#define LPC_ADC_STAT_DONE4_BIT 4
#define LPC_ADC_STAT_DONE5_MASK 0x20
#define LPC_ADC_STAT_DONE5 0x20
#define LPC_ADC_STAT_DONE5_BIT 5
#define LPC_ADC_STAT_DONE6_MASK 0x40
#define LPC_ADC_STAT_DONE6 0x40
#define LPC_ADC_STAT_DONE6_BIT 6
#define LPC_ADC_STAT_DONE7_MASK 0x80
#define LPC_ADC_STAT_DONE7 0x80
#define LPC_ADC_STAT_DONE7_BIT 7
#define LPC_ADC_STAT_OVERRUN0_MASK 0x100
#define LPC_ADC_STAT_OVERRUN0 0x100
#define LPC_ADC_STAT_OVERRUN0_BIT 8
#define LPC_ADC_STAT_OVERRUN1_MASK 0x200
#define LPC_ADC_STAT_OVERRUN1 0x200
#define LPC_ADC_STAT_OVERRUN1_BIT 9
#define LPC_ADC_STAT_OVERRUN2_MASK 0x400
#define LPC_ADC_STAT_OVERRUN2 0x400
#define LPC_ADC_STAT_OVERRUN2_BIT 10
#define LPC_ADC_STAT_OVERRUN3_MASK 0x800
#define LPC_ADC_STAT_OVERRUN3 0x800
#define LPC_ADC_STAT_OVERRUN3_BIT 11
#define LPC_ADC_STAT_OVERRUN4_MASK 0x1000
#define LPC_ADC_STAT_OVERRUN4 0x1000
#define LPC_ADC_STAT_OVERRUN4_BIT 12
#define LPC_ADC_STAT_OVERRUN5_MASK 0x2000
#define LPC_ADC_STAT_OVERRUN5 0x2000
#define LPC_ADC_STAT_OVERRUN5_BIT 13
#define LPC_ADC_STAT_OVERRUN6_MASK 0x4000
#define LPC_ADC_STAT_OVERRUN6 0x4000
#define LPC_ADC_STAT_OVERRUN6_BIT 14
#define LPC_ADC_STAT_OVERRUN7_MASK 0x8000
#define LPC_ADC_STAT_OVERRUN7 0x8000
#define LPC_ADC_STAT_OVERRUN7_BIT 15
#define LPC_ADC_STAT_ADINT_MASK 0x10000
#define LPC_ADC_STAT_ADINT 0x10000
#define LPC_ADC_STAT_ADINT_BIT 16

#define LPC_ADC_TRM (*(volatile unsigned long *)0x40034034)
#define LPC_ADC_TRM_OFFSET 0x34
#define LPC_ADC_TRM_ADCOFFS_MASK 0xF0
#define LPC_ADC_TRM_ADCOFFS_BIT 4
#define LPC_ADC_TRM_TRIM_MASK 0xF00
#define LPC_ADC_TRM_TRIM_BIT 8

#ifndef LPC_CANAFRAM_BASE_ADDRESS
#define LPC_CANAFRAM_BASE_ADDRESS 0x40038000
#endif

#define LPC_CANAFRAM_MASK0 (*(volatile unsigned long *)0x40038000)
#define LPC_CANAFRAM_MASK0_OFFSET 0x0
#define LPC_CANAFRAM_MASK0_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK0_MASK_BIT 0

#define LPC_CANAFRAM_MASK1 (*(volatile unsigned long *)0x40038004)
#define LPC_CANAFRAM_MASK1_OFFSET 0x4
#define LPC_CANAFRAM_MASK1_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK1_MASK_BIT 0

#define LPC_CANAFRAM_MASK2 (*(volatile unsigned long *)0x40038008)
#define LPC_CANAFRAM_MASK2_OFFSET 0x8
#define LPC_CANAFRAM_MASK2_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK2_MASK_BIT 0

#define LPC_CANAFRAM_MASK3 (*(volatile unsigned long *)0x4003800C)
#define LPC_CANAFRAM_MASK3_OFFSET 0xC
#define LPC_CANAFRAM_MASK3_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK3_MASK_BIT 0

#define LPC_CANAFRAM_MASK4 (*(volatile unsigned long *)0x40038010)
#define LPC_CANAFRAM_MASK4_OFFSET 0x10
#define LPC_CANAFRAM_MASK4_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK4_MASK_BIT 0

#define LPC_CANAFRAM_MASK5 (*(volatile unsigned long *)0x40038014)
#define LPC_CANAFRAM_MASK5_OFFSET 0x14
#define LPC_CANAFRAM_MASK5_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK5_MASK_BIT 0

#define LPC_CANAFRAM_MASK6 (*(volatile unsigned long *)0x40038018)
#define LPC_CANAFRAM_MASK6_OFFSET 0x18
#define LPC_CANAFRAM_MASK6_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK6_MASK_BIT 0

#define LPC_CANAFRAM_MASK7 (*(volatile unsigned long *)0x4003801C)
#define LPC_CANAFRAM_MASK7_OFFSET 0x1C
#define LPC_CANAFRAM_MASK7_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK7_MASK_BIT 0

#define LPC_CANAFRAM_MASK8 (*(volatile unsigned long *)0x40038020)
#define LPC_CANAFRAM_MASK8_OFFSET 0x20
#define LPC_CANAFRAM_MASK8_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK8_MASK_BIT 0

#define LPC_CANAFRAM_MASK9 (*(volatile unsigned long *)0x40038024)
#define LPC_CANAFRAM_MASK9_OFFSET 0x24
#define LPC_CANAFRAM_MASK9_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK9_MASK_BIT 0

#define LPC_CANAFRAM_MASK10 (*(volatile unsigned long *)0x40038028)
#define LPC_CANAFRAM_MASK10_OFFSET 0x28
#define LPC_CANAFRAM_MASK10_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK10_MASK_BIT 0

#define LPC_CANAFRAM_MASK11 (*(volatile unsigned long *)0x4003802C)
#define LPC_CANAFRAM_MASK11_OFFSET 0x2C
#define LPC_CANAFRAM_MASK11_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK11_MASK_BIT 0

#define LPC_CANAFRAM_MASK12 (*(volatile unsigned long *)0x40038030)
#define LPC_CANAFRAM_MASK12_OFFSET 0x30
#define LPC_CANAFRAM_MASK12_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK12_MASK_BIT 0

#define LPC_CANAFRAM_MASK13 (*(volatile unsigned long *)0x40038034)
#define LPC_CANAFRAM_MASK13_OFFSET 0x34
#define LPC_CANAFRAM_MASK13_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK13_MASK_BIT 0

#define LPC_CANAFRAM_MASK14 (*(volatile unsigned long *)0x40038038)
#define LPC_CANAFRAM_MASK14_OFFSET 0x38
#define LPC_CANAFRAM_MASK14_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK14_MASK_BIT 0

#define LPC_CANAFRAM_MASK15 (*(volatile unsigned long *)0x4003803C)
#define LPC_CANAFRAM_MASK15_OFFSET 0x3C
#define LPC_CANAFRAM_MASK15_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK15_MASK_BIT 0

#define LPC_CANAFRAM_MASK16 (*(volatile unsigned long *)0x40038040)
#define LPC_CANAFRAM_MASK16_OFFSET 0x40
#define LPC_CANAFRAM_MASK16_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK16_MASK_BIT 0

#define LPC_CANAFRAM_MASK17 (*(volatile unsigned long *)0x40038044)
#define LPC_CANAFRAM_MASK17_OFFSET 0x44
#define LPC_CANAFRAM_MASK17_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK17_MASK_BIT 0

#define LPC_CANAFRAM_MASK18 (*(volatile unsigned long *)0x40038048)
#define LPC_CANAFRAM_MASK18_OFFSET 0x48
#define LPC_CANAFRAM_MASK18_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK18_MASK_BIT 0

#define LPC_CANAFRAM_MASK19 (*(volatile unsigned long *)0x4003804C)
#define LPC_CANAFRAM_MASK19_OFFSET 0x4C
#define LPC_CANAFRAM_MASK19_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK19_MASK_BIT 0

#define LPC_CANAFRAM_MASK20 (*(volatile unsigned long *)0x40038050)
#define LPC_CANAFRAM_MASK20_OFFSET 0x50
#define LPC_CANAFRAM_MASK20_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK20_MASK_BIT 0

#define LPC_CANAFRAM_MASK21 (*(volatile unsigned long *)0x40038054)
#define LPC_CANAFRAM_MASK21_OFFSET 0x54
#define LPC_CANAFRAM_MASK21_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK21_MASK_BIT 0

#define LPC_CANAFRAM_MASK22 (*(volatile unsigned long *)0x40038058)
#define LPC_CANAFRAM_MASK22_OFFSET 0x58
#define LPC_CANAFRAM_MASK22_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK22_MASK_BIT 0

#define LPC_CANAFRAM_MASK23 (*(volatile unsigned long *)0x4003805C)
#define LPC_CANAFRAM_MASK23_OFFSET 0x5C
#define LPC_CANAFRAM_MASK23_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK23_MASK_BIT 0

#define LPC_CANAFRAM_MASK24 (*(volatile unsigned long *)0x40038060)
#define LPC_CANAFRAM_MASK24_OFFSET 0x60
#define LPC_CANAFRAM_MASK24_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK24_MASK_BIT 0

#define LPC_CANAFRAM_MASK25 (*(volatile unsigned long *)0x40038064)
#define LPC_CANAFRAM_MASK25_OFFSET 0x64
#define LPC_CANAFRAM_MASK25_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK25_MASK_BIT 0

#define LPC_CANAFRAM_MASK26 (*(volatile unsigned long *)0x40038068)
#define LPC_CANAFRAM_MASK26_OFFSET 0x68
#define LPC_CANAFRAM_MASK26_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK26_MASK_BIT 0

#define LPC_CANAFRAM_MASK27 (*(volatile unsigned long *)0x4003806C)
#define LPC_CANAFRAM_MASK27_OFFSET 0x6C
#define LPC_CANAFRAM_MASK27_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK27_MASK_BIT 0

#define LPC_CANAFRAM_MASK28 (*(volatile unsigned long *)0x40038070)
#define LPC_CANAFRAM_MASK28_OFFSET 0x70
#define LPC_CANAFRAM_MASK28_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK28_MASK_BIT 0

#define LPC_CANAFRAM_MASK29 (*(volatile unsigned long *)0x40038074)
#define LPC_CANAFRAM_MASK29_OFFSET 0x74
#define LPC_CANAFRAM_MASK29_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK29_MASK_BIT 0

#define LPC_CANAFRAM_MASK30 (*(volatile unsigned long *)0x40038078)
#define LPC_CANAFRAM_MASK30_OFFSET 0x78
#define LPC_CANAFRAM_MASK30_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK30_MASK_BIT 0

#define LPC_CANAFRAM_MASK31 (*(volatile unsigned long *)0x4003807C)
#define LPC_CANAFRAM_MASK31_OFFSET 0x7C
#define LPC_CANAFRAM_MASK31_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK31_MASK_BIT 0

#define LPC_CANAFRAM_MASK32 (*(volatile unsigned long *)0x40038080)
#define LPC_CANAFRAM_MASK32_OFFSET 0x80
#define LPC_CANAFRAM_MASK32_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK32_MASK_BIT 0

#define LPC_CANAFRAM_MASK33 (*(volatile unsigned long *)0x40038084)
#define LPC_CANAFRAM_MASK33_OFFSET 0x84
#define LPC_CANAFRAM_MASK33_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK33_MASK_BIT 0

#define LPC_CANAFRAM_MASK34 (*(volatile unsigned long *)0x40038088)
#define LPC_CANAFRAM_MASK34_OFFSET 0x88
#define LPC_CANAFRAM_MASK34_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK34_MASK_BIT 0

#define LPC_CANAFRAM_MASK35 (*(volatile unsigned long *)0x4003808C)
#define LPC_CANAFRAM_MASK35_OFFSET 0x8C
#define LPC_CANAFRAM_MASK35_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK35_MASK_BIT 0

#define LPC_CANAFRAM_MASK36 (*(volatile unsigned long *)0x40038090)
#define LPC_CANAFRAM_MASK36_OFFSET 0x90
#define LPC_CANAFRAM_MASK36_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK36_MASK_BIT 0

#define LPC_CANAFRAM_MASK37 (*(volatile unsigned long *)0x40038094)
#define LPC_CANAFRAM_MASK37_OFFSET 0x94
#define LPC_CANAFRAM_MASK37_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK37_MASK_BIT 0

#define LPC_CANAFRAM_MASK38 (*(volatile unsigned long *)0x40038098)
#define LPC_CANAFRAM_MASK38_OFFSET 0x98
#define LPC_CANAFRAM_MASK38_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK38_MASK_BIT 0

#define LPC_CANAFRAM_MASK39 (*(volatile unsigned long *)0x4003809C)
#define LPC_CANAFRAM_MASK39_OFFSET 0x9C
#define LPC_CANAFRAM_MASK39_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK39_MASK_BIT 0

#define LPC_CANAFRAM_MASK40 (*(volatile unsigned long *)0x400380A0)
#define LPC_CANAFRAM_MASK40_OFFSET 0xA0
#define LPC_CANAFRAM_MASK40_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK40_MASK_BIT 0

#define LPC_CANAFRAM_MASK41 (*(volatile unsigned long *)0x400380A4)
#define LPC_CANAFRAM_MASK41_OFFSET 0xA4
#define LPC_CANAFRAM_MASK41_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK41_MASK_BIT 0

#define LPC_CANAFRAM_MASK42 (*(volatile unsigned long *)0x400380A8)
#define LPC_CANAFRAM_MASK42_OFFSET 0xA8
#define LPC_CANAFRAM_MASK42_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK42_MASK_BIT 0

#define LPC_CANAFRAM_MASK43 (*(volatile unsigned long *)0x400380AC)
#define LPC_CANAFRAM_MASK43_OFFSET 0xAC
#define LPC_CANAFRAM_MASK43_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK43_MASK_BIT 0

#define LPC_CANAFRAM_MASK44 (*(volatile unsigned long *)0x400380B0)
#define LPC_CANAFRAM_MASK44_OFFSET 0xB0
#define LPC_CANAFRAM_MASK44_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK44_MASK_BIT 0

#define LPC_CANAFRAM_MASK45 (*(volatile unsigned long *)0x400380B4)
#define LPC_CANAFRAM_MASK45_OFFSET 0xB4
#define LPC_CANAFRAM_MASK45_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK45_MASK_BIT 0

#define LPC_CANAFRAM_MASK46 (*(volatile unsigned long *)0x400380B8)
#define LPC_CANAFRAM_MASK46_OFFSET 0xB8
#define LPC_CANAFRAM_MASK46_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK46_MASK_BIT 0

#define LPC_CANAFRAM_MASK47 (*(volatile unsigned long *)0x400380BC)
#define LPC_CANAFRAM_MASK47_OFFSET 0xBC
#define LPC_CANAFRAM_MASK47_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK47_MASK_BIT 0

#define LPC_CANAFRAM_MASK48 (*(volatile unsigned long *)0x400380C0)
#define LPC_CANAFRAM_MASK48_OFFSET 0xC0
#define LPC_CANAFRAM_MASK48_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK48_MASK_BIT 0

#define LPC_CANAFRAM_MASK49 (*(volatile unsigned long *)0x400380C4)
#define LPC_CANAFRAM_MASK49_OFFSET 0xC4
#define LPC_CANAFRAM_MASK49_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK49_MASK_BIT 0

#define LPC_CANAFRAM_MASK50 (*(volatile unsigned long *)0x400380C8)
#define LPC_CANAFRAM_MASK50_OFFSET 0xC8
#define LPC_CANAFRAM_MASK50_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK50_MASK_BIT 0

#define LPC_CANAFRAM_MASK51 (*(volatile unsigned long *)0x400380CC)
#define LPC_CANAFRAM_MASK51_OFFSET 0xCC
#define LPC_CANAFRAM_MASK51_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK51_MASK_BIT 0

#define LPC_CANAFRAM_MASK52 (*(volatile unsigned long *)0x400380D0)
#define LPC_CANAFRAM_MASK52_OFFSET 0xD0
#define LPC_CANAFRAM_MASK52_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK52_MASK_BIT 0

#define LPC_CANAFRAM_MASK53 (*(volatile unsigned long *)0x400380D4)
#define LPC_CANAFRAM_MASK53_OFFSET 0xD4
#define LPC_CANAFRAM_MASK53_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK53_MASK_BIT 0

#define LPC_CANAFRAM_MASK54 (*(volatile unsigned long *)0x400380D8)
#define LPC_CANAFRAM_MASK54_OFFSET 0xD8
#define LPC_CANAFRAM_MASK54_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK54_MASK_BIT 0

#define LPC_CANAFRAM_MASK55 (*(volatile unsigned long *)0x400380DC)
#define LPC_CANAFRAM_MASK55_OFFSET 0xDC
#define LPC_CANAFRAM_MASK55_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK55_MASK_BIT 0

#define LPC_CANAFRAM_MASK56 (*(volatile unsigned long *)0x400380E0)
#define LPC_CANAFRAM_MASK56_OFFSET 0xE0
#define LPC_CANAFRAM_MASK56_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK56_MASK_BIT 0

#define LPC_CANAFRAM_MASK57 (*(volatile unsigned long *)0x400380E4)
#define LPC_CANAFRAM_MASK57_OFFSET 0xE4
#define LPC_CANAFRAM_MASK57_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK57_MASK_BIT 0

#define LPC_CANAFRAM_MASK58 (*(volatile unsigned long *)0x400380E8)
#define LPC_CANAFRAM_MASK58_OFFSET 0xE8
#define LPC_CANAFRAM_MASK58_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK58_MASK_BIT 0

#define LPC_CANAFRAM_MASK59 (*(volatile unsigned long *)0x400380EC)
#define LPC_CANAFRAM_MASK59_OFFSET 0xEC
#define LPC_CANAFRAM_MASK59_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK59_MASK_BIT 0

#define LPC_CANAFRAM_MASK60 (*(volatile unsigned long *)0x400380F0)
#define LPC_CANAFRAM_MASK60_OFFSET 0xF0
#define LPC_CANAFRAM_MASK60_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK60_MASK_BIT 0

#define LPC_CANAFRAM_MASK61 (*(volatile unsigned long *)0x400380F4)
#define LPC_CANAFRAM_MASK61_OFFSET 0xF4
#define LPC_CANAFRAM_MASK61_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK61_MASK_BIT 0

#define LPC_CANAFRAM_MASK62 (*(volatile unsigned long *)0x400380F8)
#define LPC_CANAFRAM_MASK62_OFFSET 0xF8
#define LPC_CANAFRAM_MASK62_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK62_MASK_BIT 0

#define LPC_CANAFRAM_MASK63 (*(volatile unsigned long *)0x400380FC)
#define LPC_CANAFRAM_MASK63_OFFSET 0xFC
#define LPC_CANAFRAM_MASK63_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK63_MASK_BIT 0

#define LPC_CANAFRAM_MASK64 (*(volatile unsigned long *)0x40038100)
#define LPC_CANAFRAM_MASK64_OFFSET 0x100
#define LPC_CANAFRAM_MASK64_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK64_MASK_BIT 0

#define LPC_CANAFRAM_MASK65 (*(volatile unsigned long *)0x40038104)
#define LPC_CANAFRAM_MASK65_OFFSET 0x104
#define LPC_CANAFRAM_MASK65_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK65_MASK_BIT 0

#define LPC_CANAFRAM_MASK66 (*(volatile unsigned long *)0x40038108)
#define LPC_CANAFRAM_MASK66_OFFSET 0x108
#define LPC_CANAFRAM_MASK66_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK66_MASK_BIT 0

#define LPC_CANAFRAM_MASK67 (*(volatile unsigned long *)0x4003810C)
#define LPC_CANAFRAM_MASK67_OFFSET 0x10C
#define LPC_CANAFRAM_MASK67_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK67_MASK_BIT 0

#define LPC_CANAFRAM_MASK68 (*(volatile unsigned long *)0x40038110)
#define LPC_CANAFRAM_MASK68_OFFSET 0x110
#define LPC_CANAFRAM_MASK68_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK68_MASK_BIT 0

#define LPC_CANAFRAM_MASK69 (*(volatile unsigned long *)0x40038114)
#define LPC_CANAFRAM_MASK69_OFFSET 0x114
#define LPC_CANAFRAM_MASK69_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK69_MASK_BIT 0

#define LPC_CANAFRAM_MASK70 (*(volatile unsigned long *)0x40038118)
#define LPC_CANAFRAM_MASK70_OFFSET 0x118
#define LPC_CANAFRAM_MASK70_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK70_MASK_BIT 0

#define LPC_CANAFRAM_MASK71 (*(volatile unsigned long *)0x4003811C)
#define LPC_CANAFRAM_MASK71_OFFSET 0x11C
#define LPC_CANAFRAM_MASK71_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK71_MASK_BIT 0

#define LPC_CANAFRAM_MASK72 (*(volatile unsigned long *)0x40038120)
#define LPC_CANAFRAM_MASK72_OFFSET 0x120
#define LPC_CANAFRAM_MASK72_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK72_MASK_BIT 0

#define LPC_CANAFRAM_MASK73 (*(volatile unsigned long *)0x40038124)
#define LPC_CANAFRAM_MASK73_OFFSET 0x124
#define LPC_CANAFRAM_MASK73_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK73_MASK_BIT 0

#define LPC_CANAFRAM_MASK74 (*(volatile unsigned long *)0x40038128)
#define LPC_CANAFRAM_MASK74_OFFSET 0x128
#define LPC_CANAFRAM_MASK74_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK74_MASK_BIT 0

#define LPC_CANAFRAM_MASK75 (*(volatile unsigned long *)0x4003812C)
#define LPC_CANAFRAM_MASK75_OFFSET 0x12C
#define LPC_CANAFRAM_MASK75_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK75_MASK_BIT 0

#define LPC_CANAFRAM_MASK76 (*(volatile unsigned long *)0x40038130)
#define LPC_CANAFRAM_MASK76_OFFSET 0x130
#define LPC_CANAFRAM_MASK76_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK76_MASK_BIT 0

#define LPC_CANAFRAM_MASK77 (*(volatile unsigned long *)0x40038134)
#define LPC_CANAFRAM_MASK77_OFFSET 0x134
#define LPC_CANAFRAM_MASK77_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK77_MASK_BIT 0

#define LPC_CANAFRAM_MASK78 (*(volatile unsigned long *)0x40038138)
#define LPC_CANAFRAM_MASK78_OFFSET 0x138
#define LPC_CANAFRAM_MASK78_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK78_MASK_BIT 0

#define LPC_CANAFRAM_MASK79 (*(volatile unsigned long *)0x4003813C)
#define LPC_CANAFRAM_MASK79_OFFSET 0x13C
#define LPC_CANAFRAM_MASK79_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK79_MASK_BIT 0

#define LPC_CANAFRAM_MASK80 (*(volatile unsigned long *)0x40038140)
#define LPC_CANAFRAM_MASK80_OFFSET 0x140
#define LPC_CANAFRAM_MASK80_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK80_MASK_BIT 0

#define LPC_CANAFRAM_MASK81 (*(volatile unsigned long *)0x40038144)
#define LPC_CANAFRAM_MASK81_OFFSET 0x144
#define LPC_CANAFRAM_MASK81_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK81_MASK_BIT 0

#define LPC_CANAFRAM_MASK82 (*(volatile unsigned long *)0x40038148)
#define LPC_CANAFRAM_MASK82_OFFSET 0x148
#define LPC_CANAFRAM_MASK82_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK82_MASK_BIT 0

#define LPC_CANAFRAM_MASK83 (*(volatile unsigned long *)0x4003814C)
#define LPC_CANAFRAM_MASK83_OFFSET 0x14C
#define LPC_CANAFRAM_MASK83_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK83_MASK_BIT 0

#define LPC_CANAFRAM_MASK84 (*(volatile unsigned long *)0x40038150)
#define LPC_CANAFRAM_MASK84_OFFSET 0x150
#define LPC_CANAFRAM_MASK84_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK84_MASK_BIT 0

#define LPC_CANAFRAM_MASK85 (*(volatile unsigned long *)0x40038154)
#define LPC_CANAFRAM_MASK85_OFFSET 0x154
#define LPC_CANAFRAM_MASK85_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK85_MASK_BIT 0

#define LPC_CANAFRAM_MASK86 (*(volatile unsigned long *)0x40038158)
#define LPC_CANAFRAM_MASK86_OFFSET 0x158
#define LPC_CANAFRAM_MASK86_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK86_MASK_BIT 0

#define LPC_CANAFRAM_MASK87 (*(volatile unsigned long *)0x4003815C)
#define LPC_CANAFRAM_MASK87_OFFSET 0x15C
#define LPC_CANAFRAM_MASK87_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK87_MASK_BIT 0

#define LPC_CANAFRAM_MASK88 (*(volatile unsigned long *)0x40038160)
#define LPC_CANAFRAM_MASK88_OFFSET 0x160
#define LPC_CANAFRAM_MASK88_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK88_MASK_BIT 0

#define LPC_CANAFRAM_MASK89 (*(volatile unsigned long *)0x40038164)
#define LPC_CANAFRAM_MASK89_OFFSET 0x164
#define LPC_CANAFRAM_MASK89_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK89_MASK_BIT 0

#define LPC_CANAFRAM_MASK90 (*(volatile unsigned long *)0x40038168)
#define LPC_CANAFRAM_MASK90_OFFSET 0x168
#define LPC_CANAFRAM_MASK90_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK90_MASK_BIT 0

#define LPC_CANAFRAM_MASK91 (*(volatile unsigned long *)0x4003816C)
#define LPC_CANAFRAM_MASK91_OFFSET 0x16C
#define LPC_CANAFRAM_MASK91_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK91_MASK_BIT 0

#define LPC_CANAFRAM_MASK92 (*(volatile unsigned long *)0x40038170)
#define LPC_CANAFRAM_MASK92_OFFSET 0x170
#define LPC_CANAFRAM_MASK92_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK92_MASK_BIT 0

#define LPC_CANAFRAM_MASK93 (*(volatile unsigned long *)0x40038174)
#define LPC_CANAFRAM_MASK93_OFFSET 0x174
#define LPC_CANAFRAM_MASK93_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK93_MASK_BIT 0

#define LPC_CANAFRAM_MASK94 (*(volatile unsigned long *)0x40038178)
#define LPC_CANAFRAM_MASK94_OFFSET 0x178
#define LPC_CANAFRAM_MASK94_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK94_MASK_BIT 0

#define LPC_CANAFRAM_MASK95 (*(volatile unsigned long *)0x4003817C)
#define LPC_CANAFRAM_MASK95_OFFSET 0x17C
#define LPC_CANAFRAM_MASK95_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK95_MASK_BIT 0

#define LPC_CANAFRAM_MASK96 (*(volatile unsigned long *)0x40038180)
#define LPC_CANAFRAM_MASK96_OFFSET 0x180
#define LPC_CANAFRAM_MASK96_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK96_MASK_BIT 0

#define LPC_CANAFRAM_MASK97 (*(volatile unsigned long *)0x40038184)
#define LPC_CANAFRAM_MASK97_OFFSET 0x184
#define LPC_CANAFRAM_MASK97_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK97_MASK_BIT 0

#define LPC_CANAFRAM_MASK98 (*(volatile unsigned long *)0x40038188)
#define LPC_CANAFRAM_MASK98_OFFSET 0x188
#define LPC_CANAFRAM_MASK98_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK98_MASK_BIT 0

#define LPC_CANAFRAM_MASK99 (*(volatile unsigned long *)0x4003818C)
#define LPC_CANAFRAM_MASK99_OFFSET 0x18C
#define LPC_CANAFRAM_MASK99_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK99_MASK_BIT 0

#define LPC_CANAFRAM_MASK100 (*(volatile unsigned long *)0x40038190)
#define LPC_CANAFRAM_MASK100_OFFSET 0x190
#define LPC_CANAFRAM_MASK100_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK100_MASK_BIT 0

#define LPC_CANAFRAM_MASK101 (*(volatile unsigned long *)0x40038194)
#define LPC_CANAFRAM_MASK101_OFFSET 0x194
#define LPC_CANAFRAM_MASK101_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK101_MASK_BIT 0

#define LPC_CANAFRAM_MASK102 (*(volatile unsigned long *)0x40038198)
#define LPC_CANAFRAM_MASK102_OFFSET 0x198
#define LPC_CANAFRAM_MASK102_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK102_MASK_BIT 0

#define LPC_CANAFRAM_MASK103 (*(volatile unsigned long *)0x4003819C)
#define LPC_CANAFRAM_MASK103_OFFSET 0x19C
#define LPC_CANAFRAM_MASK103_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK103_MASK_BIT 0

#define LPC_CANAFRAM_MASK104 (*(volatile unsigned long *)0x400381A0)
#define LPC_CANAFRAM_MASK104_OFFSET 0x1A0
#define LPC_CANAFRAM_MASK104_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK104_MASK_BIT 0

#define LPC_CANAFRAM_MASK105 (*(volatile unsigned long *)0x400381A4)
#define LPC_CANAFRAM_MASK105_OFFSET 0x1A4
#define LPC_CANAFRAM_MASK105_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK105_MASK_BIT 0

#define LPC_CANAFRAM_MASK106 (*(volatile unsigned long *)0x400381A8)
#define LPC_CANAFRAM_MASK106_OFFSET 0x1A8
#define LPC_CANAFRAM_MASK106_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK106_MASK_BIT 0

#define LPC_CANAFRAM_MASK107 (*(volatile unsigned long *)0x400381AC)
#define LPC_CANAFRAM_MASK107_OFFSET 0x1AC
#define LPC_CANAFRAM_MASK107_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK107_MASK_BIT 0

#define LPC_CANAFRAM_MASK108 (*(volatile unsigned long *)0x400381B0)
#define LPC_CANAFRAM_MASK108_OFFSET 0x1B0
#define LPC_CANAFRAM_MASK108_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK108_MASK_BIT 0

#define LPC_CANAFRAM_MASK109 (*(volatile unsigned long *)0x400381B4)
#define LPC_CANAFRAM_MASK109_OFFSET 0x1B4
#define LPC_CANAFRAM_MASK109_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK109_MASK_BIT 0

#define LPC_CANAFRAM_MASK110 (*(volatile unsigned long *)0x400381B8)
#define LPC_CANAFRAM_MASK110_OFFSET 0x1B8
#define LPC_CANAFRAM_MASK110_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK110_MASK_BIT 0

#define LPC_CANAFRAM_MASK111 (*(volatile unsigned long *)0x400381BC)
#define LPC_CANAFRAM_MASK111_OFFSET 0x1BC
#define LPC_CANAFRAM_MASK111_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK111_MASK_BIT 0

#define LPC_CANAFRAM_MASK112 (*(volatile unsigned long *)0x400381C0)
#define LPC_CANAFRAM_MASK112_OFFSET 0x1C0
#define LPC_CANAFRAM_MASK112_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK112_MASK_BIT 0

#define LPC_CANAFRAM_MASK113 (*(volatile unsigned long *)0x400381C4)
#define LPC_CANAFRAM_MASK113_OFFSET 0x1C4
#define LPC_CANAFRAM_MASK113_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK113_MASK_BIT 0

#define LPC_CANAFRAM_MASK114 (*(volatile unsigned long *)0x400381C8)
#define LPC_CANAFRAM_MASK114_OFFSET 0x1C8
#define LPC_CANAFRAM_MASK114_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK114_MASK_BIT 0

#define LPC_CANAFRAM_MASK115 (*(volatile unsigned long *)0x400381CC)
#define LPC_CANAFRAM_MASK115_OFFSET 0x1CC
#define LPC_CANAFRAM_MASK115_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK115_MASK_BIT 0

#define LPC_CANAFRAM_MASK116 (*(volatile unsigned long *)0x400381D0)
#define LPC_CANAFRAM_MASK116_OFFSET 0x1D0
#define LPC_CANAFRAM_MASK116_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK116_MASK_BIT 0

#define LPC_CANAFRAM_MASK117 (*(volatile unsigned long *)0x400381D4)
#define LPC_CANAFRAM_MASK117_OFFSET 0x1D4
#define LPC_CANAFRAM_MASK117_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK117_MASK_BIT 0

#define LPC_CANAFRAM_MASK118 (*(volatile unsigned long *)0x400381D8)
#define LPC_CANAFRAM_MASK118_OFFSET 0x1D8
#define LPC_CANAFRAM_MASK118_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK118_MASK_BIT 0

#define LPC_CANAFRAM_MASK119 (*(volatile unsigned long *)0x400381DC)
#define LPC_CANAFRAM_MASK119_OFFSET 0x1DC
#define LPC_CANAFRAM_MASK119_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK119_MASK_BIT 0

#define LPC_CANAFRAM_MASK120 (*(volatile unsigned long *)0x400381E0)
#define LPC_CANAFRAM_MASK120_OFFSET 0x1E0
#define LPC_CANAFRAM_MASK120_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK120_MASK_BIT 0

#define LPC_CANAFRAM_MASK121 (*(volatile unsigned long *)0x400381E4)
#define LPC_CANAFRAM_MASK121_OFFSET 0x1E4
#define LPC_CANAFRAM_MASK121_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK121_MASK_BIT 0

#define LPC_CANAFRAM_MASK122 (*(volatile unsigned long *)0x400381E8)
#define LPC_CANAFRAM_MASK122_OFFSET 0x1E8
#define LPC_CANAFRAM_MASK122_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK122_MASK_BIT 0

#define LPC_CANAFRAM_MASK123 (*(volatile unsigned long *)0x400381EC)
#define LPC_CANAFRAM_MASK123_OFFSET 0x1EC
#define LPC_CANAFRAM_MASK123_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK123_MASK_BIT 0

#define LPC_CANAFRAM_MASK124 (*(volatile unsigned long *)0x400381F0)
#define LPC_CANAFRAM_MASK124_OFFSET 0x1F0
#define LPC_CANAFRAM_MASK124_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK124_MASK_BIT 0

#define LPC_CANAFRAM_MASK125 (*(volatile unsigned long *)0x400381F4)
#define LPC_CANAFRAM_MASK125_OFFSET 0x1F4
#define LPC_CANAFRAM_MASK125_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK125_MASK_BIT 0

#define LPC_CANAFRAM_MASK126 (*(volatile unsigned long *)0x400381F8)
#define LPC_CANAFRAM_MASK126_OFFSET 0x1F8
#define LPC_CANAFRAM_MASK126_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK126_MASK_BIT 0

#define LPC_CANAFRAM_MASK127 (*(volatile unsigned long *)0x400381FC)
#define LPC_CANAFRAM_MASK127_OFFSET 0x1FC
#define LPC_CANAFRAM_MASK127_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK127_MASK_BIT 0

#define LPC_CANAFRAM_MASK128 (*(volatile unsigned long *)0x40038200)
#define LPC_CANAFRAM_MASK128_OFFSET 0x200
#define LPC_CANAFRAM_MASK128_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK128_MASK_BIT 0

#define LPC_CANAFRAM_MASK129 (*(volatile unsigned long *)0x40038204)
#define LPC_CANAFRAM_MASK129_OFFSET 0x204
#define LPC_CANAFRAM_MASK129_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK129_MASK_BIT 0

#define LPC_CANAFRAM_MASK130 (*(volatile unsigned long *)0x40038208)
#define LPC_CANAFRAM_MASK130_OFFSET 0x208
#define LPC_CANAFRAM_MASK130_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK130_MASK_BIT 0

#define LPC_CANAFRAM_MASK131 (*(volatile unsigned long *)0x4003820C)
#define LPC_CANAFRAM_MASK131_OFFSET 0x20C
#define LPC_CANAFRAM_MASK131_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK131_MASK_BIT 0

#define LPC_CANAFRAM_MASK132 (*(volatile unsigned long *)0x40038210)
#define LPC_CANAFRAM_MASK132_OFFSET 0x210
#define LPC_CANAFRAM_MASK132_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK132_MASK_BIT 0

#define LPC_CANAFRAM_MASK133 (*(volatile unsigned long *)0x40038214)
#define LPC_CANAFRAM_MASK133_OFFSET 0x214
#define LPC_CANAFRAM_MASK133_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK133_MASK_BIT 0

#define LPC_CANAFRAM_MASK134 (*(volatile unsigned long *)0x40038218)
#define LPC_CANAFRAM_MASK134_OFFSET 0x218
#define LPC_CANAFRAM_MASK134_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK134_MASK_BIT 0

#define LPC_CANAFRAM_MASK135 (*(volatile unsigned long *)0x4003821C)
#define LPC_CANAFRAM_MASK135_OFFSET 0x21C
#define LPC_CANAFRAM_MASK135_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK135_MASK_BIT 0

#define LPC_CANAFRAM_MASK136 (*(volatile unsigned long *)0x40038220)
#define LPC_CANAFRAM_MASK136_OFFSET 0x220
#define LPC_CANAFRAM_MASK136_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK136_MASK_BIT 0

#define LPC_CANAFRAM_MASK137 (*(volatile unsigned long *)0x40038224)
#define LPC_CANAFRAM_MASK137_OFFSET 0x224
#define LPC_CANAFRAM_MASK137_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK137_MASK_BIT 0

#define LPC_CANAFRAM_MASK138 (*(volatile unsigned long *)0x40038228)
#define LPC_CANAFRAM_MASK138_OFFSET 0x228
#define LPC_CANAFRAM_MASK138_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK138_MASK_BIT 0

#define LPC_CANAFRAM_MASK139 (*(volatile unsigned long *)0x4003822C)
#define LPC_CANAFRAM_MASK139_OFFSET 0x22C
#define LPC_CANAFRAM_MASK139_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK139_MASK_BIT 0

#define LPC_CANAFRAM_MASK140 (*(volatile unsigned long *)0x40038230)
#define LPC_CANAFRAM_MASK140_OFFSET 0x230
#define LPC_CANAFRAM_MASK140_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK140_MASK_BIT 0

#define LPC_CANAFRAM_MASK141 (*(volatile unsigned long *)0x40038234)
#define LPC_CANAFRAM_MASK141_OFFSET 0x234
#define LPC_CANAFRAM_MASK141_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK141_MASK_BIT 0

#define LPC_CANAFRAM_MASK142 (*(volatile unsigned long *)0x40038238)
#define LPC_CANAFRAM_MASK142_OFFSET 0x238
#define LPC_CANAFRAM_MASK142_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK142_MASK_BIT 0

#define LPC_CANAFRAM_MASK143 (*(volatile unsigned long *)0x4003823C)
#define LPC_CANAFRAM_MASK143_OFFSET 0x23C
#define LPC_CANAFRAM_MASK143_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK143_MASK_BIT 0

#define LPC_CANAFRAM_MASK144 (*(volatile unsigned long *)0x40038240)
#define LPC_CANAFRAM_MASK144_OFFSET 0x240
#define LPC_CANAFRAM_MASK144_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK144_MASK_BIT 0

#define LPC_CANAFRAM_MASK145 (*(volatile unsigned long *)0x40038244)
#define LPC_CANAFRAM_MASK145_OFFSET 0x244
#define LPC_CANAFRAM_MASK145_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK145_MASK_BIT 0

#define LPC_CANAFRAM_MASK146 (*(volatile unsigned long *)0x40038248)
#define LPC_CANAFRAM_MASK146_OFFSET 0x248
#define LPC_CANAFRAM_MASK146_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK146_MASK_BIT 0

#define LPC_CANAFRAM_MASK147 (*(volatile unsigned long *)0x4003824C)
#define LPC_CANAFRAM_MASK147_OFFSET 0x24C
#define LPC_CANAFRAM_MASK147_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK147_MASK_BIT 0

#define LPC_CANAFRAM_MASK148 (*(volatile unsigned long *)0x40038250)
#define LPC_CANAFRAM_MASK148_OFFSET 0x250
#define LPC_CANAFRAM_MASK148_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK148_MASK_BIT 0

#define LPC_CANAFRAM_MASK149 (*(volatile unsigned long *)0x40038254)
#define LPC_CANAFRAM_MASK149_OFFSET 0x254
#define LPC_CANAFRAM_MASK149_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK149_MASK_BIT 0

#define LPC_CANAFRAM_MASK150 (*(volatile unsigned long *)0x40038258)
#define LPC_CANAFRAM_MASK150_OFFSET 0x258
#define LPC_CANAFRAM_MASK150_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK150_MASK_BIT 0

#define LPC_CANAFRAM_MASK151 (*(volatile unsigned long *)0x4003825C)
#define LPC_CANAFRAM_MASK151_OFFSET 0x25C
#define LPC_CANAFRAM_MASK151_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK151_MASK_BIT 0

#define LPC_CANAFRAM_MASK152 (*(volatile unsigned long *)0x40038260)
#define LPC_CANAFRAM_MASK152_OFFSET 0x260
#define LPC_CANAFRAM_MASK152_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK152_MASK_BIT 0

#define LPC_CANAFRAM_MASK153 (*(volatile unsigned long *)0x40038264)
#define LPC_CANAFRAM_MASK153_OFFSET 0x264
#define LPC_CANAFRAM_MASK153_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK153_MASK_BIT 0

#define LPC_CANAFRAM_MASK154 (*(volatile unsigned long *)0x40038268)
#define LPC_CANAFRAM_MASK154_OFFSET 0x268
#define LPC_CANAFRAM_MASK154_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK154_MASK_BIT 0

#define LPC_CANAFRAM_MASK155 (*(volatile unsigned long *)0x4003826C)
#define LPC_CANAFRAM_MASK155_OFFSET 0x26C
#define LPC_CANAFRAM_MASK155_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK155_MASK_BIT 0

#define LPC_CANAFRAM_MASK156 (*(volatile unsigned long *)0x40038270)
#define LPC_CANAFRAM_MASK156_OFFSET 0x270
#define LPC_CANAFRAM_MASK156_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK156_MASK_BIT 0

#define LPC_CANAFRAM_MASK157 (*(volatile unsigned long *)0x40038274)
#define LPC_CANAFRAM_MASK157_OFFSET 0x274
#define LPC_CANAFRAM_MASK157_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK157_MASK_BIT 0

#define LPC_CANAFRAM_MASK158 (*(volatile unsigned long *)0x40038278)
#define LPC_CANAFRAM_MASK158_OFFSET 0x278
#define LPC_CANAFRAM_MASK158_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK158_MASK_BIT 0

#define LPC_CANAFRAM_MASK159 (*(volatile unsigned long *)0x4003827C)
#define LPC_CANAFRAM_MASK159_OFFSET 0x27C
#define LPC_CANAFRAM_MASK159_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK159_MASK_BIT 0

#define LPC_CANAFRAM_MASK160 (*(volatile unsigned long *)0x40038280)
#define LPC_CANAFRAM_MASK160_OFFSET 0x280
#define LPC_CANAFRAM_MASK160_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK160_MASK_BIT 0

#define LPC_CANAFRAM_MASK161 (*(volatile unsigned long *)0x40038284)
#define LPC_CANAFRAM_MASK161_OFFSET 0x284
#define LPC_CANAFRAM_MASK161_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK161_MASK_BIT 0

#define LPC_CANAFRAM_MASK162 (*(volatile unsigned long *)0x40038288)
#define LPC_CANAFRAM_MASK162_OFFSET 0x288
#define LPC_CANAFRAM_MASK162_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK162_MASK_BIT 0

#define LPC_CANAFRAM_MASK163 (*(volatile unsigned long *)0x4003828C)
#define LPC_CANAFRAM_MASK163_OFFSET 0x28C
#define LPC_CANAFRAM_MASK163_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK163_MASK_BIT 0

#define LPC_CANAFRAM_MASK164 (*(volatile unsigned long *)0x40038290)
#define LPC_CANAFRAM_MASK164_OFFSET 0x290
#define LPC_CANAFRAM_MASK164_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK164_MASK_BIT 0

#define LPC_CANAFRAM_MASK165 (*(volatile unsigned long *)0x40038294)
#define LPC_CANAFRAM_MASK165_OFFSET 0x294
#define LPC_CANAFRAM_MASK165_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK165_MASK_BIT 0

#define LPC_CANAFRAM_MASK166 (*(volatile unsigned long *)0x40038298)
#define LPC_CANAFRAM_MASK166_OFFSET 0x298
#define LPC_CANAFRAM_MASK166_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK166_MASK_BIT 0

#define LPC_CANAFRAM_MASK167 (*(volatile unsigned long *)0x4003829C)
#define LPC_CANAFRAM_MASK167_OFFSET 0x29C
#define LPC_CANAFRAM_MASK167_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK167_MASK_BIT 0

#define LPC_CANAFRAM_MASK168 (*(volatile unsigned long *)0x400382A0)
#define LPC_CANAFRAM_MASK168_OFFSET 0x2A0
#define LPC_CANAFRAM_MASK168_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK168_MASK_BIT 0

#define LPC_CANAFRAM_MASK169 (*(volatile unsigned long *)0x400382A4)
#define LPC_CANAFRAM_MASK169_OFFSET 0x2A4
#define LPC_CANAFRAM_MASK169_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK169_MASK_BIT 0

#define LPC_CANAFRAM_MASK170 (*(volatile unsigned long *)0x400382A8)
#define LPC_CANAFRAM_MASK170_OFFSET 0x2A8
#define LPC_CANAFRAM_MASK170_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK170_MASK_BIT 0

#define LPC_CANAFRAM_MASK171 (*(volatile unsigned long *)0x400382AC)
#define LPC_CANAFRAM_MASK171_OFFSET 0x2AC
#define LPC_CANAFRAM_MASK171_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK171_MASK_BIT 0

#define LPC_CANAFRAM_MASK172 (*(volatile unsigned long *)0x400382B0)
#define LPC_CANAFRAM_MASK172_OFFSET 0x2B0
#define LPC_CANAFRAM_MASK172_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK172_MASK_BIT 0

#define LPC_CANAFRAM_MASK173 (*(volatile unsigned long *)0x400382B4)
#define LPC_CANAFRAM_MASK173_OFFSET 0x2B4
#define LPC_CANAFRAM_MASK173_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK173_MASK_BIT 0

#define LPC_CANAFRAM_MASK174 (*(volatile unsigned long *)0x400382B8)
#define LPC_CANAFRAM_MASK174_OFFSET 0x2B8
#define LPC_CANAFRAM_MASK174_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK174_MASK_BIT 0

#define LPC_CANAFRAM_MASK175 (*(volatile unsigned long *)0x400382BC)
#define LPC_CANAFRAM_MASK175_OFFSET 0x2BC
#define LPC_CANAFRAM_MASK175_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK175_MASK_BIT 0

#define LPC_CANAFRAM_MASK176 (*(volatile unsigned long *)0x400382C0)
#define LPC_CANAFRAM_MASK176_OFFSET 0x2C0
#define LPC_CANAFRAM_MASK176_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK176_MASK_BIT 0

#define LPC_CANAFRAM_MASK177 (*(volatile unsigned long *)0x400382C4)
#define LPC_CANAFRAM_MASK177_OFFSET 0x2C4
#define LPC_CANAFRAM_MASK177_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK177_MASK_BIT 0

#define LPC_CANAFRAM_MASK178 (*(volatile unsigned long *)0x400382C8)
#define LPC_CANAFRAM_MASK178_OFFSET 0x2C8
#define LPC_CANAFRAM_MASK178_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK178_MASK_BIT 0

#define LPC_CANAFRAM_MASK179 (*(volatile unsigned long *)0x400382CC)
#define LPC_CANAFRAM_MASK179_OFFSET 0x2CC
#define LPC_CANAFRAM_MASK179_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK179_MASK_BIT 0

#define LPC_CANAFRAM_MASK180 (*(volatile unsigned long *)0x400382D0)
#define LPC_CANAFRAM_MASK180_OFFSET 0x2D0
#define LPC_CANAFRAM_MASK180_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK180_MASK_BIT 0

#define LPC_CANAFRAM_MASK181 (*(volatile unsigned long *)0x400382D4)
#define LPC_CANAFRAM_MASK181_OFFSET 0x2D4
#define LPC_CANAFRAM_MASK181_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK181_MASK_BIT 0

#define LPC_CANAFRAM_MASK182 (*(volatile unsigned long *)0x400382D8)
#define LPC_CANAFRAM_MASK182_OFFSET 0x2D8
#define LPC_CANAFRAM_MASK182_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK182_MASK_BIT 0

#define LPC_CANAFRAM_MASK183 (*(volatile unsigned long *)0x400382DC)
#define LPC_CANAFRAM_MASK183_OFFSET 0x2DC
#define LPC_CANAFRAM_MASK183_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK183_MASK_BIT 0

#define LPC_CANAFRAM_MASK184 (*(volatile unsigned long *)0x400382E0)
#define LPC_CANAFRAM_MASK184_OFFSET 0x2E0
#define LPC_CANAFRAM_MASK184_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK184_MASK_BIT 0

#define LPC_CANAFRAM_MASK185 (*(volatile unsigned long *)0x400382E4)
#define LPC_CANAFRAM_MASK185_OFFSET 0x2E4
#define LPC_CANAFRAM_MASK185_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK185_MASK_BIT 0

#define LPC_CANAFRAM_MASK186 (*(volatile unsigned long *)0x400382E8)
#define LPC_CANAFRAM_MASK186_OFFSET 0x2E8
#define LPC_CANAFRAM_MASK186_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK186_MASK_BIT 0

#define LPC_CANAFRAM_MASK187 (*(volatile unsigned long *)0x400382EC)
#define LPC_CANAFRAM_MASK187_OFFSET 0x2EC
#define LPC_CANAFRAM_MASK187_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK187_MASK_BIT 0

#define LPC_CANAFRAM_MASK188 (*(volatile unsigned long *)0x400382F0)
#define LPC_CANAFRAM_MASK188_OFFSET 0x2F0
#define LPC_CANAFRAM_MASK188_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK188_MASK_BIT 0

#define LPC_CANAFRAM_MASK189 (*(volatile unsigned long *)0x400382F4)
#define LPC_CANAFRAM_MASK189_OFFSET 0x2F4
#define LPC_CANAFRAM_MASK189_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK189_MASK_BIT 0

#define LPC_CANAFRAM_MASK190 (*(volatile unsigned long *)0x400382F8)
#define LPC_CANAFRAM_MASK190_OFFSET 0x2F8
#define LPC_CANAFRAM_MASK190_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK190_MASK_BIT 0

#define LPC_CANAFRAM_MASK191 (*(volatile unsigned long *)0x400382FC)
#define LPC_CANAFRAM_MASK191_OFFSET 0x2FC
#define LPC_CANAFRAM_MASK191_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK191_MASK_BIT 0

#define LPC_CANAFRAM_MASK192 (*(volatile unsigned long *)0x40038300)
#define LPC_CANAFRAM_MASK192_OFFSET 0x300
#define LPC_CANAFRAM_MASK192_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK192_MASK_BIT 0

#define LPC_CANAFRAM_MASK193 (*(volatile unsigned long *)0x40038304)
#define LPC_CANAFRAM_MASK193_OFFSET 0x304
#define LPC_CANAFRAM_MASK193_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK193_MASK_BIT 0

#define LPC_CANAFRAM_MASK194 (*(volatile unsigned long *)0x40038308)
#define LPC_CANAFRAM_MASK194_OFFSET 0x308
#define LPC_CANAFRAM_MASK194_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK194_MASK_BIT 0

#define LPC_CANAFRAM_MASK195 (*(volatile unsigned long *)0x4003830C)
#define LPC_CANAFRAM_MASK195_OFFSET 0x30C
#define LPC_CANAFRAM_MASK195_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK195_MASK_BIT 0

#define LPC_CANAFRAM_MASK196 (*(volatile unsigned long *)0x40038310)
#define LPC_CANAFRAM_MASK196_OFFSET 0x310
#define LPC_CANAFRAM_MASK196_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK196_MASK_BIT 0

#define LPC_CANAFRAM_MASK197 (*(volatile unsigned long *)0x40038314)
#define LPC_CANAFRAM_MASK197_OFFSET 0x314
#define LPC_CANAFRAM_MASK197_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK197_MASK_BIT 0

#define LPC_CANAFRAM_MASK198 (*(volatile unsigned long *)0x40038318)
#define LPC_CANAFRAM_MASK198_OFFSET 0x318
#define LPC_CANAFRAM_MASK198_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK198_MASK_BIT 0

#define LPC_CANAFRAM_MASK199 (*(volatile unsigned long *)0x4003831C)
#define LPC_CANAFRAM_MASK199_OFFSET 0x31C
#define LPC_CANAFRAM_MASK199_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK199_MASK_BIT 0

#define LPC_CANAFRAM_MASK200 (*(volatile unsigned long *)0x40038320)
#define LPC_CANAFRAM_MASK200_OFFSET 0x320
#define LPC_CANAFRAM_MASK200_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK200_MASK_BIT 0

#define LPC_CANAFRAM_MASK201 (*(volatile unsigned long *)0x40038324)
#define LPC_CANAFRAM_MASK201_OFFSET 0x324
#define LPC_CANAFRAM_MASK201_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK201_MASK_BIT 0

#define LPC_CANAFRAM_MASK202 (*(volatile unsigned long *)0x40038328)
#define LPC_CANAFRAM_MASK202_OFFSET 0x328
#define LPC_CANAFRAM_MASK202_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK202_MASK_BIT 0

#define LPC_CANAFRAM_MASK203 (*(volatile unsigned long *)0x4003832C)
#define LPC_CANAFRAM_MASK203_OFFSET 0x32C
#define LPC_CANAFRAM_MASK203_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK203_MASK_BIT 0

#define LPC_CANAFRAM_MASK204 (*(volatile unsigned long *)0x40038330)
#define LPC_CANAFRAM_MASK204_OFFSET 0x330
#define LPC_CANAFRAM_MASK204_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK204_MASK_BIT 0

#define LPC_CANAFRAM_MASK205 (*(volatile unsigned long *)0x40038334)
#define LPC_CANAFRAM_MASK205_OFFSET 0x334
#define LPC_CANAFRAM_MASK205_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK205_MASK_BIT 0

#define LPC_CANAFRAM_MASK206 (*(volatile unsigned long *)0x40038338)
#define LPC_CANAFRAM_MASK206_OFFSET 0x338
#define LPC_CANAFRAM_MASK206_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK206_MASK_BIT 0

#define LPC_CANAFRAM_MASK207 (*(volatile unsigned long *)0x4003833C)
#define LPC_CANAFRAM_MASK207_OFFSET 0x33C
#define LPC_CANAFRAM_MASK207_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK207_MASK_BIT 0

#define LPC_CANAFRAM_MASK208 (*(volatile unsigned long *)0x40038340)
#define LPC_CANAFRAM_MASK208_OFFSET 0x340
#define LPC_CANAFRAM_MASK208_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK208_MASK_BIT 0

#define LPC_CANAFRAM_MASK209 (*(volatile unsigned long *)0x40038344)
#define LPC_CANAFRAM_MASK209_OFFSET 0x344
#define LPC_CANAFRAM_MASK209_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK209_MASK_BIT 0

#define LPC_CANAFRAM_MASK210 (*(volatile unsigned long *)0x40038348)
#define LPC_CANAFRAM_MASK210_OFFSET 0x348
#define LPC_CANAFRAM_MASK210_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK210_MASK_BIT 0

#define LPC_CANAFRAM_MASK211 (*(volatile unsigned long *)0x4003834C)
#define LPC_CANAFRAM_MASK211_OFFSET 0x34C
#define LPC_CANAFRAM_MASK211_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK211_MASK_BIT 0

#define LPC_CANAFRAM_MASK212 (*(volatile unsigned long *)0x40038350)
#define LPC_CANAFRAM_MASK212_OFFSET 0x350
#define LPC_CANAFRAM_MASK212_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK212_MASK_BIT 0

#define LPC_CANAFRAM_MASK213 (*(volatile unsigned long *)0x40038354)
#define LPC_CANAFRAM_MASK213_OFFSET 0x354
#define LPC_CANAFRAM_MASK213_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK213_MASK_BIT 0

#define LPC_CANAFRAM_MASK214 (*(volatile unsigned long *)0x40038358)
#define LPC_CANAFRAM_MASK214_OFFSET 0x358
#define LPC_CANAFRAM_MASK214_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK214_MASK_BIT 0

#define LPC_CANAFRAM_MASK215 (*(volatile unsigned long *)0x4003835C)
#define LPC_CANAFRAM_MASK215_OFFSET 0x35C
#define LPC_CANAFRAM_MASK215_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK215_MASK_BIT 0

#define LPC_CANAFRAM_MASK216 (*(volatile unsigned long *)0x40038360)
#define LPC_CANAFRAM_MASK216_OFFSET 0x360
#define LPC_CANAFRAM_MASK216_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK216_MASK_BIT 0

#define LPC_CANAFRAM_MASK217 (*(volatile unsigned long *)0x40038364)
#define LPC_CANAFRAM_MASK217_OFFSET 0x364
#define LPC_CANAFRAM_MASK217_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK217_MASK_BIT 0

#define LPC_CANAFRAM_MASK218 (*(volatile unsigned long *)0x40038368)
#define LPC_CANAFRAM_MASK218_OFFSET 0x368
#define LPC_CANAFRAM_MASK218_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK218_MASK_BIT 0

#define LPC_CANAFRAM_MASK219 (*(volatile unsigned long *)0x4003836C)
#define LPC_CANAFRAM_MASK219_OFFSET 0x36C
#define LPC_CANAFRAM_MASK219_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK219_MASK_BIT 0

#define LPC_CANAFRAM_MASK220 (*(volatile unsigned long *)0x40038370)
#define LPC_CANAFRAM_MASK220_OFFSET 0x370
#define LPC_CANAFRAM_MASK220_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK220_MASK_BIT 0

#define LPC_CANAFRAM_MASK221 (*(volatile unsigned long *)0x40038374)
#define LPC_CANAFRAM_MASK221_OFFSET 0x374
#define LPC_CANAFRAM_MASK221_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK221_MASK_BIT 0

#define LPC_CANAFRAM_MASK222 (*(volatile unsigned long *)0x40038378)
#define LPC_CANAFRAM_MASK222_OFFSET 0x378
#define LPC_CANAFRAM_MASK222_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK222_MASK_BIT 0

#define LPC_CANAFRAM_MASK223 (*(volatile unsigned long *)0x4003837C)
#define LPC_CANAFRAM_MASK223_OFFSET 0x37C
#define LPC_CANAFRAM_MASK223_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK223_MASK_BIT 0

#define LPC_CANAFRAM_MASK224 (*(volatile unsigned long *)0x40038380)
#define LPC_CANAFRAM_MASK224_OFFSET 0x380
#define LPC_CANAFRAM_MASK224_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK224_MASK_BIT 0

#define LPC_CANAFRAM_MASK225 (*(volatile unsigned long *)0x40038384)
#define LPC_CANAFRAM_MASK225_OFFSET 0x384
#define LPC_CANAFRAM_MASK225_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK225_MASK_BIT 0

#define LPC_CANAFRAM_MASK226 (*(volatile unsigned long *)0x40038388)
#define LPC_CANAFRAM_MASK226_OFFSET 0x388
#define LPC_CANAFRAM_MASK226_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK226_MASK_BIT 0

#define LPC_CANAFRAM_MASK227 (*(volatile unsigned long *)0x4003838C)
#define LPC_CANAFRAM_MASK227_OFFSET 0x38C
#define LPC_CANAFRAM_MASK227_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK227_MASK_BIT 0

#define LPC_CANAFRAM_MASK228 (*(volatile unsigned long *)0x40038390)
#define LPC_CANAFRAM_MASK228_OFFSET 0x390
#define LPC_CANAFRAM_MASK228_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK228_MASK_BIT 0

#define LPC_CANAFRAM_MASK229 (*(volatile unsigned long *)0x40038394)
#define LPC_CANAFRAM_MASK229_OFFSET 0x394
#define LPC_CANAFRAM_MASK229_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK229_MASK_BIT 0

#define LPC_CANAFRAM_MASK230 (*(volatile unsigned long *)0x40038398)
#define LPC_CANAFRAM_MASK230_OFFSET 0x398
#define LPC_CANAFRAM_MASK230_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK230_MASK_BIT 0

#define LPC_CANAFRAM_MASK231 (*(volatile unsigned long *)0x4003839C)
#define LPC_CANAFRAM_MASK231_OFFSET 0x39C
#define LPC_CANAFRAM_MASK231_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK231_MASK_BIT 0

#define LPC_CANAFRAM_MASK232 (*(volatile unsigned long *)0x400383A0)
#define LPC_CANAFRAM_MASK232_OFFSET 0x3A0
#define LPC_CANAFRAM_MASK232_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK232_MASK_BIT 0

#define LPC_CANAFRAM_MASK233 (*(volatile unsigned long *)0x400383A4)
#define LPC_CANAFRAM_MASK233_OFFSET 0x3A4
#define LPC_CANAFRAM_MASK233_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK233_MASK_BIT 0

#define LPC_CANAFRAM_MASK234 (*(volatile unsigned long *)0x400383A8)
#define LPC_CANAFRAM_MASK234_OFFSET 0x3A8
#define LPC_CANAFRAM_MASK234_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK234_MASK_BIT 0

#define LPC_CANAFRAM_MASK235 (*(volatile unsigned long *)0x400383AC)
#define LPC_CANAFRAM_MASK235_OFFSET 0x3AC
#define LPC_CANAFRAM_MASK235_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK235_MASK_BIT 0

#define LPC_CANAFRAM_MASK236 (*(volatile unsigned long *)0x400383B0)
#define LPC_CANAFRAM_MASK236_OFFSET 0x3B0
#define LPC_CANAFRAM_MASK236_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK236_MASK_BIT 0

#define LPC_CANAFRAM_MASK237 (*(volatile unsigned long *)0x400383B4)
#define LPC_CANAFRAM_MASK237_OFFSET 0x3B4
#define LPC_CANAFRAM_MASK237_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK237_MASK_BIT 0

#define LPC_CANAFRAM_MASK238 (*(volatile unsigned long *)0x400383B8)
#define LPC_CANAFRAM_MASK238_OFFSET 0x3B8
#define LPC_CANAFRAM_MASK238_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK238_MASK_BIT 0

#define LPC_CANAFRAM_MASK239 (*(volatile unsigned long *)0x400383BC)
#define LPC_CANAFRAM_MASK239_OFFSET 0x3BC
#define LPC_CANAFRAM_MASK239_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK239_MASK_BIT 0

#define LPC_CANAFRAM_MASK240 (*(volatile unsigned long *)0x400383C0)
#define LPC_CANAFRAM_MASK240_OFFSET 0x3C0
#define LPC_CANAFRAM_MASK240_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK240_MASK_BIT 0

#define LPC_CANAFRAM_MASK241 (*(volatile unsigned long *)0x400383C4)
#define LPC_CANAFRAM_MASK241_OFFSET 0x3C4
#define LPC_CANAFRAM_MASK241_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK241_MASK_BIT 0

#define LPC_CANAFRAM_MASK242 (*(volatile unsigned long *)0x400383C8)
#define LPC_CANAFRAM_MASK242_OFFSET 0x3C8
#define LPC_CANAFRAM_MASK242_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK242_MASK_BIT 0

#define LPC_CANAFRAM_MASK243 (*(volatile unsigned long *)0x400383CC)
#define LPC_CANAFRAM_MASK243_OFFSET 0x3CC
#define LPC_CANAFRAM_MASK243_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK243_MASK_BIT 0

#define LPC_CANAFRAM_MASK244 (*(volatile unsigned long *)0x400383D0)
#define LPC_CANAFRAM_MASK244_OFFSET 0x3D0
#define LPC_CANAFRAM_MASK244_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK244_MASK_BIT 0

#define LPC_CANAFRAM_MASK245 (*(volatile unsigned long *)0x400383D4)
#define LPC_CANAFRAM_MASK245_OFFSET 0x3D4
#define LPC_CANAFRAM_MASK245_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK245_MASK_BIT 0

#define LPC_CANAFRAM_MASK246 (*(volatile unsigned long *)0x400383D8)
#define LPC_CANAFRAM_MASK246_OFFSET 0x3D8
#define LPC_CANAFRAM_MASK246_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK246_MASK_BIT 0

#define LPC_CANAFRAM_MASK247 (*(volatile unsigned long *)0x400383DC)
#define LPC_CANAFRAM_MASK247_OFFSET 0x3DC
#define LPC_CANAFRAM_MASK247_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK247_MASK_BIT 0

#define LPC_CANAFRAM_MASK248 (*(volatile unsigned long *)0x400383E0)
#define LPC_CANAFRAM_MASK248_OFFSET 0x3E0
#define LPC_CANAFRAM_MASK248_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK248_MASK_BIT 0

#define LPC_CANAFRAM_MASK249 (*(volatile unsigned long *)0x400383E4)
#define LPC_CANAFRAM_MASK249_OFFSET 0x3E4
#define LPC_CANAFRAM_MASK249_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK249_MASK_BIT 0

#define LPC_CANAFRAM_MASK250 (*(volatile unsigned long *)0x400383E8)
#define LPC_CANAFRAM_MASK250_OFFSET 0x3E8
#define LPC_CANAFRAM_MASK250_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK250_MASK_BIT 0

#define LPC_CANAFRAM_MASK251 (*(volatile unsigned long *)0x400383EC)
#define LPC_CANAFRAM_MASK251_OFFSET 0x3EC
#define LPC_CANAFRAM_MASK251_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK251_MASK_BIT 0

#define LPC_CANAFRAM_MASK252 (*(volatile unsigned long *)0x400383F0)
#define LPC_CANAFRAM_MASK252_OFFSET 0x3F0
#define LPC_CANAFRAM_MASK252_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK252_MASK_BIT 0

#define LPC_CANAFRAM_MASK253 (*(volatile unsigned long *)0x400383F4)
#define LPC_CANAFRAM_MASK253_OFFSET 0x3F4
#define LPC_CANAFRAM_MASK253_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK253_MASK_BIT 0

#define LPC_CANAFRAM_MASK254 (*(volatile unsigned long *)0x400383F8)
#define LPC_CANAFRAM_MASK254_OFFSET 0x3F8
#define LPC_CANAFRAM_MASK254_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK254_MASK_BIT 0

#define LPC_CANAFRAM_MASK255 (*(volatile unsigned long *)0x400383FC)
#define LPC_CANAFRAM_MASK255_OFFSET 0x3FC
#define LPC_CANAFRAM_MASK255_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK255_MASK_BIT 0

#define LPC_CANAFRAM_MASK256 (*(volatile unsigned long *)0x40038400)
#define LPC_CANAFRAM_MASK256_OFFSET 0x400
#define LPC_CANAFRAM_MASK256_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK256_MASK_BIT 0

#define LPC_CANAFRAM_MASK257 (*(volatile unsigned long *)0x40038404)
#define LPC_CANAFRAM_MASK257_OFFSET 0x404
#define LPC_CANAFRAM_MASK257_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK257_MASK_BIT 0

#define LPC_CANAFRAM_MASK258 (*(volatile unsigned long *)0x40038408)
#define LPC_CANAFRAM_MASK258_OFFSET 0x408
#define LPC_CANAFRAM_MASK258_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK258_MASK_BIT 0

#define LPC_CANAFRAM_MASK259 (*(volatile unsigned long *)0x4003840C)
#define LPC_CANAFRAM_MASK259_OFFSET 0x40C
#define LPC_CANAFRAM_MASK259_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK259_MASK_BIT 0

#define LPC_CANAFRAM_MASK260 (*(volatile unsigned long *)0x40038410)
#define LPC_CANAFRAM_MASK260_OFFSET 0x410
#define LPC_CANAFRAM_MASK260_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK260_MASK_BIT 0

#define LPC_CANAFRAM_MASK261 (*(volatile unsigned long *)0x40038414)
#define LPC_CANAFRAM_MASK261_OFFSET 0x414
#define LPC_CANAFRAM_MASK261_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK261_MASK_BIT 0

#define LPC_CANAFRAM_MASK262 (*(volatile unsigned long *)0x40038418)
#define LPC_CANAFRAM_MASK262_OFFSET 0x418
#define LPC_CANAFRAM_MASK262_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK262_MASK_BIT 0

#define LPC_CANAFRAM_MASK263 (*(volatile unsigned long *)0x4003841C)
#define LPC_CANAFRAM_MASK263_OFFSET 0x41C
#define LPC_CANAFRAM_MASK263_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK263_MASK_BIT 0

#define LPC_CANAFRAM_MASK264 (*(volatile unsigned long *)0x40038420)
#define LPC_CANAFRAM_MASK264_OFFSET 0x420
#define LPC_CANAFRAM_MASK264_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK264_MASK_BIT 0

#define LPC_CANAFRAM_MASK265 (*(volatile unsigned long *)0x40038424)
#define LPC_CANAFRAM_MASK265_OFFSET 0x424
#define LPC_CANAFRAM_MASK265_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK265_MASK_BIT 0

#define LPC_CANAFRAM_MASK266 (*(volatile unsigned long *)0x40038428)
#define LPC_CANAFRAM_MASK266_OFFSET 0x428
#define LPC_CANAFRAM_MASK266_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK266_MASK_BIT 0

#define LPC_CANAFRAM_MASK267 (*(volatile unsigned long *)0x4003842C)
#define LPC_CANAFRAM_MASK267_OFFSET 0x42C
#define LPC_CANAFRAM_MASK267_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK267_MASK_BIT 0

#define LPC_CANAFRAM_MASK268 (*(volatile unsigned long *)0x40038430)
#define LPC_CANAFRAM_MASK268_OFFSET 0x430
#define LPC_CANAFRAM_MASK268_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK268_MASK_BIT 0

#define LPC_CANAFRAM_MASK269 (*(volatile unsigned long *)0x40038434)
#define LPC_CANAFRAM_MASK269_OFFSET 0x434
#define LPC_CANAFRAM_MASK269_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK269_MASK_BIT 0

#define LPC_CANAFRAM_MASK270 (*(volatile unsigned long *)0x40038438)
#define LPC_CANAFRAM_MASK270_OFFSET 0x438
#define LPC_CANAFRAM_MASK270_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK270_MASK_BIT 0

#define LPC_CANAFRAM_MASK271 (*(volatile unsigned long *)0x4003843C)
#define LPC_CANAFRAM_MASK271_OFFSET 0x43C
#define LPC_CANAFRAM_MASK271_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK271_MASK_BIT 0

#define LPC_CANAFRAM_MASK272 (*(volatile unsigned long *)0x40038440)
#define LPC_CANAFRAM_MASK272_OFFSET 0x440
#define LPC_CANAFRAM_MASK272_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK272_MASK_BIT 0

#define LPC_CANAFRAM_MASK273 (*(volatile unsigned long *)0x40038444)
#define LPC_CANAFRAM_MASK273_OFFSET 0x444
#define LPC_CANAFRAM_MASK273_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK273_MASK_BIT 0

#define LPC_CANAFRAM_MASK274 (*(volatile unsigned long *)0x40038448)
#define LPC_CANAFRAM_MASK274_OFFSET 0x448
#define LPC_CANAFRAM_MASK274_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK274_MASK_BIT 0

#define LPC_CANAFRAM_MASK275 (*(volatile unsigned long *)0x4003844C)
#define LPC_CANAFRAM_MASK275_OFFSET 0x44C
#define LPC_CANAFRAM_MASK275_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK275_MASK_BIT 0

#define LPC_CANAFRAM_MASK276 (*(volatile unsigned long *)0x40038450)
#define LPC_CANAFRAM_MASK276_OFFSET 0x450
#define LPC_CANAFRAM_MASK276_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK276_MASK_BIT 0

#define LPC_CANAFRAM_MASK277 (*(volatile unsigned long *)0x40038454)
#define LPC_CANAFRAM_MASK277_OFFSET 0x454
#define LPC_CANAFRAM_MASK277_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK277_MASK_BIT 0

#define LPC_CANAFRAM_MASK278 (*(volatile unsigned long *)0x40038458)
#define LPC_CANAFRAM_MASK278_OFFSET 0x458
#define LPC_CANAFRAM_MASK278_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK278_MASK_BIT 0

#define LPC_CANAFRAM_MASK279 (*(volatile unsigned long *)0x4003845C)
#define LPC_CANAFRAM_MASK279_OFFSET 0x45C
#define LPC_CANAFRAM_MASK279_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK279_MASK_BIT 0

#define LPC_CANAFRAM_MASK280 (*(volatile unsigned long *)0x40038460)
#define LPC_CANAFRAM_MASK280_OFFSET 0x460
#define LPC_CANAFRAM_MASK280_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK280_MASK_BIT 0

#define LPC_CANAFRAM_MASK281 (*(volatile unsigned long *)0x40038464)
#define LPC_CANAFRAM_MASK281_OFFSET 0x464
#define LPC_CANAFRAM_MASK281_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK281_MASK_BIT 0

#define LPC_CANAFRAM_MASK282 (*(volatile unsigned long *)0x40038468)
#define LPC_CANAFRAM_MASK282_OFFSET 0x468
#define LPC_CANAFRAM_MASK282_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK282_MASK_BIT 0

#define LPC_CANAFRAM_MASK283 (*(volatile unsigned long *)0x4003846C)
#define LPC_CANAFRAM_MASK283_OFFSET 0x46C
#define LPC_CANAFRAM_MASK283_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK283_MASK_BIT 0

#define LPC_CANAFRAM_MASK284 (*(volatile unsigned long *)0x40038470)
#define LPC_CANAFRAM_MASK284_OFFSET 0x470
#define LPC_CANAFRAM_MASK284_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK284_MASK_BIT 0

#define LPC_CANAFRAM_MASK285 (*(volatile unsigned long *)0x40038474)
#define LPC_CANAFRAM_MASK285_OFFSET 0x474
#define LPC_CANAFRAM_MASK285_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK285_MASK_BIT 0

#define LPC_CANAFRAM_MASK286 (*(volatile unsigned long *)0x40038478)
#define LPC_CANAFRAM_MASK286_OFFSET 0x478
#define LPC_CANAFRAM_MASK286_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK286_MASK_BIT 0

#define LPC_CANAFRAM_MASK287 (*(volatile unsigned long *)0x4003847C)
#define LPC_CANAFRAM_MASK287_OFFSET 0x47C
#define LPC_CANAFRAM_MASK287_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK287_MASK_BIT 0

#define LPC_CANAFRAM_MASK288 (*(volatile unsigned long *)0x40038480)
#define LPC_CANAFRAM_MASK288_OFFSET 0x480
#define LPC_CANAFRAM_MASK288_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK288_MASK_BIT 0

#define LPC_CANAFRAM_MASK289 (*(volatile unsigned long *)0x40038484)
#define LPC_CANAFRAM_MASK289_OFFSET 0x484
#define LPC_CANAFRAM_MASK289_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK289_MASK_BIT 0

#define LPC_CANAFRAM_MASK290 (*(volatile unsigned long *)0x40038488)
#define LPC_CANAFRAM_MASK290_OFFSET 0x488
#define LPC_CANAFRAM_MASK290_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK290_MASK_BIT 0

#define LPC_CANAFRAM_MASK291 (*(volatile unsigned long *)0x4003848C)
#define LPC_CANAFRAM_MASK291_OFFSET 0x48C
#define LPC_CANAFRAM_MASK291_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK291_MASK_BIT 0

#define LPC_CANAFRAM_MASK292 (*(volatile unsigned long *)0x40038490)
#define LPC_CANAFRAM_MASK292_OFFSET 0x490
#define LPC_CANAFRAM_MASK292_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK292_MASK_BIT 0

#define LPC_CANAFRAM_MASK293 (*(volatile unsigned long *)0x40038494)
#define LPC_CANAFRAM_MASK293_OFFSET 0x494
#define LPC_CANAFRAM_MASK293_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK293_MASK_BIT 0

#define LPC_CANAFRAM_MASK294 (*(volatile unsigned long *)0x40038498)
#define LPC_CANAFRAM_MASK294_OFFSET 0x498
#define LPC_CANAFRAM_MASK294_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK294_MASK_BIT 0

#define LPC_CANAFRAM_MASK295 (*(volatile unsigned long *)0x4003849C)
#define LPC_CANAFRAM_MASK295_OFFSET 0x49C
#define LPC_CANAFRAM_MASK295_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK295_MASK_BIT 0

#define LPC_CANAFRAM_MASK296 (*(volatile unsigned long *)0x400384A0)
#define LPC_CANAFRAM_MASK296_OFFSET 0x4A0
#define LPC_CANAFRAM_MASK296_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK296_MASK_BIT 0

#define LPC_CANAFRAM_MASK297 (*(volatile unsigned long *)0x400384A4)
#define LPC_CANAFRAM_MASK297_OFFSET 0x4A4
#define LPC_CANAFRAM_MASK297_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK297_MASK_BIT 0

#define LPC_CANAFRAM_MASK298 (*(volatile unsigned long *)0x400384A8)
#define LPC_CANAFRAM_MASK298_OFFSET 0x4A8
#define LPC_CANAFRAM_MASK298_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK298_MASK_BIT 0

#define LPC_CANAFRAM_MASK299 (*(volatile unsigned long *)0x400384AC)
#define LPC_CANAFRAM_MASK299_OFFSET 0x4AC
#define LPC_CANAFRAM_MASK299_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK299_MASK_BIT 0

#define LPC_CANAFRAM_MASK300 (*(volatile unsigned long *)0x400384B0)
#define LPC_CANAFRAM_MASK300_OFFSET 0x4B0
#define LPC_CANAFRAM_MASK300_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK300_MASK_BIT 0

#define LPC_CANAFRAM_MASK301 (*(volatile unsigned long *)0x400384B4)
#define LPC_CANAFRAM_MASK301_OFFSET 0x4B4
#define LPC_CANAFRAM_MASK301_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK301_MASK_BIT 0

#define LPC_CANAFRAM_MASK302 (*(volatile unsigned long *)0x400384B8)
#define LPC_CANAFRAM_MASK302_OFFSET 0x4B8
#define LPC_CANAFRAM_MASK302_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK302_MASK_BIT 0

#define LPC_CANAFRAM_MASK303 (*(volatile unsigned long *)0x400384BC)
#define LPC_CANAFRAM_MASK303_OFFSET 0x4BC
#define LPC_CANAFRAM_MASK303_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK303_MASK_BIT 0

#define LPC_CANAFRAM_MASK304 (*(volatile unsigned long *)0x400384C0)
#define LPC_CANAFRAM_MASK304_OFFSET 0x4C0
#define LPC_CANAFRAM_MASK304_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK304_MASK_BIT 0

#define LPC_CANAFRAM_MASK305 (*(volatile unsigned long *)0x400384C4)
#define LPC_CANAFRAM_MASK305_OFFSET 0x4C4
#define LPC_CANAFRAM_MASK305_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK305_MASK_BIT 0

#define LPC_CANAFRAM_MASK306 (*(volatile unsigned long *)0x400384C8)
#define LPC_CANAFRAM_MASK306_OFFSET 0x4C8
#define LPC_CANAFRAM_MASK306_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK306_MASK_BIT 0

#define LPC_CANAFRAM_MASK307 (*(volatile unsigned long *)0x400384CC)
#define LPC_CANAFRAM_MASK307_OFFSET 0x4CC
#define LPC_CANAFRAM_MASK307_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK307_MASK_BIT 0

#define LPC_CANAFRAM_MASK308 (*(volatile unsigned long *)0x400384D0)
#define LPC_CANAFRAM_MASK308_OFFSET 0x4D0
#define LPC_CANAFRAM_MASK308_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK308_MASK_BIT 0

#define LPC_CANAFRAM_MASK309 (*(volatile unsigned long *)0x400384D4)
#define LPC_CANAFRAM_MASK309_OFFSET 0x4D4
#define LPC_CANAFRAM_MASK309_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK309_MASK_BIT 0

#define LPC_CANAFRAM_MASK310 (*(volatile unsigned long *)0x400384D8)
#define LPC_CANAFRAM_MASK310_OFFSET 0x4D8
#define LPC_CANAFRAM_MASK310_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK310_MASK_BIT 0

#define LPC_CANAFRAM_MASK311 (*(volatile unsigned long *)0x400384DC)
#define LPC_CANAFRAM_MASK311_OFFSET 0x4DC
#define LPC_CANAFRAM_MASK311_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK311_MASK_BIT 0

#define LPC_CANAFRAM_MASK312 (*(volatile unsigned long *)0x400384E0)
#define LPC_CANAFRAM_MASK312_OFFSET 0x4E0
#define LPC_CANAFRAM_MASK312_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK312_MASK_BIT 0

#define LPC_CANAFRAM_MASK313 (*(volatile unsigned long *)0x400384E4)
#define LPC_CANAFRAM_MASK313_OFFSET 0x4E4
#define LPC_CANAFRAM_MASK313_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK313_MASK_BIT 0

#define LPC_CANAFRAM_MASK314 (*(volatile unsigned long *)0x400384E8)
#define LPC_CANAFRAM_MASK314_OFFSET 0x4E8
#define LPC_CANAFRAM_MASK314_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK314_MASK_BIT 0

#define LPC_CANAFRAM_MASK315 (*(volatile unsigned long *)0x400384EC)
#define LPC_CANAFRAM_MASK315_OFFSET 0x4EC
#define LPC_CANAFRAM_MASK315_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK315_MASK_BIT 0

#define LPC_CANAFRAM_MASK316 (*(volatile unsigned long *)0x400384F0)
#define LPC_CANAFRAM_MASK316_OFFSET 0x4F0
#define LPC_CANAFRAM_MASK316_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK316_MASK_BIT 0

#define LPC_CANAFRAM_MASK317 (*(volatile unsigned long *)0x400384F4)
#define LPC_CANAFRAM_MASK317_OFFSET 0x4F4
#define LPC_CANAFRAM_MASK317_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK317_MASK_BIT 0

#define LPC_CANAFRAM_MASK318 (*(volatile unsigned long *)0x400384F8)
#define LPC_CANAFRAM_MASK318_OFFSET 0x4F8
#define LPC_CANAFRAM_MASK318_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK318_MASK_BIT 0

#define LPC_CANAFRAM_MASK319 (*(volatile unsigned long *)0x400384FC)
#define LPC_CANAFRAM_MASK319_OFFSET 0x4FC
#define LPC_CANAFRAM_MASK319_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK319_MASK_BIT 0

#define LPC_CANAFRAM_MASK320 (*(volatile unsigned long *)0x40038500)
#define LPC_CANAFRAM_MASK320_OFFSET 0x500
#define LPC_CANAFRAM_MASK320_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK320_MASK_BIT 0

#define LPC_CANAFRAM_MASK321 (*(volatile unsigned long *)0x40038504)
#define LPC_CANAFRAM_MASK321_OFFSET 0x504
#define LPC_CANAFRAM_MASK321_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK321_MASK_BIT 0

#define LPC_CANAFRAM_MASK322 (*(volatile unsigned long *)0x40038508)
#define LPC_CANAFRAM_MASK322_OFFSET 0x508
#define LPC_CANAFRAM_MASK322_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK322_MASK_BIT 0

#define LPC_CANAFRAM_MASK323 (*(volatile unsigned long *)0x4003850C)
#define LPC_CANAFRAM_MASK323_OFFSET 0x50C
#define LPC_CANAFRAM_MASK323_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK323_MASK_BIT 0

#define LPC_CANAFRAM_MASK324 (*(volatile unsigned long *)0x40038510)
#define LPC_CANAFRAM_MASK324_OFFSET 0x510
#define LPC_CANAFRAM_MASK324_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK324_MASK_BIT 0

#define LPC_CANAFRAM_MASK325 (*(volatile unsigned long *)0x40038514)
#define LPC_CANAFRAM_MASK325_OFFSET 0x514
#define LPC_CANAFRAM_MASK325_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK325_MASK_BIT 0

#define LPC_CANAFRAM_MASK326 (*(volatile unsigned long *)0x40038518)
#define LPC_CANAFRAM_MASK326_OFFSET 0x518
#define LPC_CANAFRAM_MASK326_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK326_MASK_BIT 0

#define LPC_CANAFRAM_MASK327 (*(volatile unsigned long *)0x4003851C)
#define LPC_CANAFRAM_MASK327_OFFSET 0x51C
#define LPC_CANAFRAM_MASK327_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK327_MASK_BIT 0

#define LPC_CANAFRAM_MASK328 (*(volatile unsigned long *)0x40038520)
#define LPC_CANAFRAM_MASK328_OFFSET 0x520
#define LPC_CANAFRAM_MASK328_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK328_MASK_BIT 0

#define LPC_CANAFRAM_MASK329 (*(volatile unsigned long *)0x40038524)
#define LPC_CANAFRAM_MASK329_OFFSET 0x524
#define LPC_CANAFRAM_MASK329_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK329_MASK_BIT 0

#define LPC_CANAFRAM_MASK330 (*(volatile unsigned long *)0x40038528)
#define LPC_CANAFRAM_MASK330_OFFSET 0x528
#define LPC_CANAFRAM_MASK330_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK330_MASK_BIT 0

#define LPC_CANAFRAM_MASK331 (*(volatile unsigned long *)0x4003852C)
#define LPC_CANAFRAM_MASK331_OFFSET 0x52C
#define LPC_CANAFRAM_MASK331_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK331_MASK_BIT 0

#define LPC_CANAFRAM_MASK332 (*(volatile unsigned long *)0x40038530)
#define LPC_CANAFRAM_MASK332_OFFSET 0x530
#define LPC_CANAFRAM_MASK332_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK332_MASK_BIT 0

#define LPC_CANAFRAM_MASK333 (*(volatile unsigned long *)0x40038534)
#define LPC_CANAFRAM_MASK333_OFFSET 0x534
#define LPC_CANAFRAM_MASK333_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK333_MASK_BIT 0

#define LPC_CANAFRAM_MASK334 (*(volatile unsigned long *)0x40038538)
#define LPC_CANAFRAM_MASK334_OFFSET 0x538
#define LPC_CANAFRAM_MASK334_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK334_MASK_BIT 0

#define LPC_CANAFRAM_MASK335 (*(volatile unsigned long *)0x4003853C)
#define LPC_CANAFRAM_MASK335_OFFSET 0x53C
#define LPC_CANAFRAM_MASK335_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK335_MASK_BIT 0

#define LPC_CANAFRAM_MASK336 (*(volatile unsigned long *)0x40038540)
#define LPC_CANAFRAM_MASK336_OFFSET 0x540
#define LPC_CANAFRAM_MASK336_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK336_MASK_BIT 0

#define LPC_CANAFRAM_MASK337 (*(volatile unsigned long *)0x40038544)
#define LPC_CANAFRAM_MASK337_OFFSET 0x544
#define LPC_CANAFRAM_MASK337_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK337_MASK_BIT 0

#define LPC_CANAFRAM_MASK338 (*(volatile unsigned long *)0x40038548)
#define LPC_CANAFRAM_MASK338_OFFSET 0x548
#define LPC_CANAFRAM_MASK338_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK338_MASK_BIT 0

#define LPC_CANAFRAM_MASK339 (*(volatile unsigned long *)0x4003854C)
#define LPC_CANAFRAM_MASK339_OFFSET 0x54C
#define LPC_CANAFRAM_MASK339_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK339_MASK_BIT 0

#define LPC_CANAFRAM_MASK340 (*(volatile unsigned long *)0x40038550)
#define LPC_CANAFRAM_MASK340_OFFSET 0x550
#define LPC_CANAFRAM_MASK340_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK340_MASK_BIT 0

#define LPC_CANAFRAM_MASK341 (*(volatile unsigned long *)0x40038554)
#define LPC_CANAFRAM_MASK341_OFFSET 0x554
#define LPC_CANAFRAM_MASK341_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK341_MASK_BIT 0

#define LPC_CANAFRAM_MASK342 (*(volatile unsigned long *)0x40038558)
#define LPC_CANAFRAM_MASK342_OFFSET 0x558
#define LPC_CANAFRAM_MASK342_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK342_MASK_BIT 0

#define LPC_CANAFRAM_MASK343 (*(volatile unsigned long *)0x4003855C)
#define LPC_CANAFRAM_MASK343_OFFSET 0x55C
#define LPC_CANAFRAM_MASK343_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK343_MASK_BIT 0

#define LPC_CANAFRAM_MASK344 (*(volatile unsigned long *)0x40038560)
#define LPC_CANAFRAM_MASK344_OFFSET 0x560
#define LPC_CANAFRAM_MASK344_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK344_MASK_BIT 0

#define LPC_CANAFRAM_MASK345 (*(volatile unsigned long *)0x40038564)
#define LPC_CANAFRAM_MASK345_OFFSET 0x564
#define LPC_CANAFRAM_MASK345_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK345_MASK_BIT 0

#define LPC_CANAFRAM_MASK346 (*(volatile unsigned long *)0x40038568)
#define LPC_CANAFRAM_MASK346_OFFSET 0x568
#define LPC_CANAFRAM_MASK346_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK346_MASK_BIT 0

#define LPC_CANAFRAM_MASK347 (*(volatile unsigned long *)0x4003856C)
#define LPC_CANAFRAM_MASK347_OFFSET 0x56C
#define LPC_CANAFRAM_MASK347_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK347_MASK_BIT 0

#define LPC_CANAFRAM_MASK348 (*(volatile unsigned long *)0x40038570)
#define LPC_CANAFRAM_MASK348_OFFSET 0x570
#define LPC_CANAFRAM_MASK348_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK348_MASK_BIT 0

#define LPC_CANAFRAM_MASK349 (*(volatile unsigned long *)0x40038574)
#define LPC_CANAFRAM_MASK349_OFFSET 0x574
#define LPC_CANAFRAM_MASK349_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK349_MASK_BIT 0

#define LPC_CANAFRAM_MASK350 (*(volatile unsigned long *)0x40038578)
#define LPC_CANAFRAM_MASK350_OFFSET 0x578
#define LPC_CANAFRAM_MASK350_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK350_MASK_BIT 0

#define LPC_CANAFRAM_MASK351 (*(volatile unsigned long *)0x4003857C)
#define LPC_CANAFRAM_MASK351_OFFSET 0x57C
#define LPC_CANAFRAM_MASK351_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK351_MASK_BIT 0

#define LPC_CANAFRAM_MASK352 (*(volatile unsigned long *)0x40038580)
#define LPC_CANAFRAM_MASK352_OFFSET 0x580
#define LPC_CANAFRAM_MASK352_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK352_MASK_BIT 0

#define LPC_CANAFRAM_MASK353 (*(volatile unsigned long *)0x40038584)
#define LPC_CANAFRAM_MASK353_OFFSET 0x584
#define LPC_CANAFRAM_MASK353_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK353_MASK_BIT 0

#define LPC_CANAFRAM_MASK354 (*(volatile unsigned long *)0x40038588)
#define LPC_CANAFRAM_MASK354_OFFSET 0x588
#define LPC_CANAFRAM_MASK354_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK354_MASK_BIT 0

#define LPC_CANAFRAM_MASK355 (*(volatile unsigned long *)0x4003858C)
#define LPC_CANAFRAM_MASK355_OFFSET 0x58C
#define LPC_CANAFRAM_MASK355_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK355_MASK_BIT 0

#define LPC_CANAFRAM_MASK356 (*(volatile unsigned long *)0x40038590)
#define LPC_CANAFRAM_MASK356_OFFSET 0x590
#define LPC_CANAFRAM_MASK356_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK356_MASK_BIT 0

#define LPC_CANAFRAM_MASK357 (*(volatile unsigned long *)0x40038594)
#define LPC_CANAFRAM_MASK357_OFFSET 0x594
#define LPC_CANAFRAM_MASK357_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK357_MASK_BIT 0

#define LPC_CANAFRAM_MASK358 (*(volatile unsigned long *)0x40038598)
#define LPC_CANAFRAM_MASK358_OFFSET 0x598
#define LPC_CANAFRAM_MASK358_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK358_MASK_BIT 0

#define LPC_CANAFRAM_MASK359 (*(volatile unsigned long *)0x4003859C)
#define LPC_CANAFRAM_MASK359_OFFSET 0x59C
#define LPC_CANAFRAM_MASK359_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK359_MASK_BIT 0

#define LPC_CANAFRAM_MASK360 (*(volatile unsigned long *)0x400385A0)
#define LPC_CANAFRAM_MASK360_OFFSET 0x5A0
#define LPC_CANAFRAM_MASK360_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK360_MASK_BIT 0

#define LPC_CANAFRAM_MASK361 (*(volatile unsigned long *)0x400385A4)
#define LPC_CANAFRAM_MASK361_OFFSET 0x5A4
#define LPC_CANAFRAM_MASK361_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK361_MASK_BIT 0

#define LPC_CANAFRAM_MASK362 (*(volatile unsigned long *)0x400385A8)
#define LPC_CANAFRAM_MASK362_OFFSET 0x5A8
#define LPC_CANAFRAM_MASK362_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK362_MASK_BIT 0

#define LPC_CANAFRAM_MASK363 (*(volatile unsigned long *)0x400385AC)
#define LPC_CANAFRAM_MASK363_OFFSET 0x5AC
#define LPC_CANAFRAM_MASK363_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK363_MASK_BIT 0

#define LPC_CANAFRAM_MASK364 (*(volatile unsigned long *)0x400385B0)
#define LPC_CANAFRAM_MASK364_OFFSET 0x5B0
#define LPC_CANAFRAM_MASK364_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK364_MASK_BIT 0

#define LPC_CANAFRAM_MASK365 (*(volatile unsigned long *)0x400385B4)
#define LPC_CANAFRAM_MASK365_OFFSET 0x5B4
#define LPC_CANAFRAM_MASK365_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK365_MASK_BIT 0

#define LPC_CANAFRAM_MASK366 (*(volatile unsigned long *)0x400385B8)
#define LPC_CANAFRAM_MASK366_OFFSET 0x5B8
#define LPC_CANAFRAM_MASK366_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK366_MASK_BIT 0

#define LPC_CANAFRAM_MASK367 (*(volatile unsigned long *)0x400385BC)
#define LPC_CANAFRAM_MASK367_OFFSET 0x5BC
#define LPC_CANAFRAM_MASK367_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK367_MASK_BIT 0

#define LPC_CANAFRAM_MASK368 (*(volatile unsigned long *)0x400385C0)
#define LPC_CANAFRAM_MASK368_OFFSET 0x5C0
#define LPC_CANAFRAM_MASK368_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK368_MASK_BIT 0

#define LPC_CANAFRAM_MASK369 (*(volatile unsigned long *)0x400385C4)
#define LPC_CANAFRAM_MASK369_OFFSET 0x5C4
#define LPC_CANAFRAM_MASK369_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK369_MASK_BIT 0

#define LPC_CANAFRAM_MASK370 (*(volatile unsigned long *)0x400385C8)
#define LPC_CANAFRAM_MASK370_OFFSET 0x5C8
#define LPC_CANAFRAM_MASK370_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK370_MASK_BIT 0

#define LPC_CANAFRAM_MASK371 (*(volatile unsigned long *)0x400385CC)
#define LPC_CANAFRAM_MASK371_OFFSET 0x5CC
#define LPC_CANAFRAM_MASK371_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK371_MASK_BIT 0

#define LPC_CANAFRAM_MASK372 (*(volatile unsigned long *)0x400385D0)
#define LPC_CANAFRAM_MASK372_OFFSET 0x5D0
#define LPC_CANAFRAM_MASK372_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK372_MASK_BIT 0

#define LPC_CANAFRAM_MASK373 (*(volatile unsigned long *)0x400385D4)
#define LPC_CANAFRAM_MASK373_OFFSET 0x5D4
#define LPC_CANAFRAM_MASK373_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK373_MASK_BIT 0

#define LPC_CANAFRAM_MASK374 (*(volatile unsigned long *)0x400385D8)
#define LPC_CANAFRAM_MASK374_OFFSET 0x5D8
#define LPC_CANAFRAM_MASK374_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK374_MASK_BIT 0

#define LPC_CANAFRAM_MASK375 (*(volatile unsigned long *)0x400385DC)
#define LPC_CANAFRAM_MASK375_OFFSET 0x5DC
#define LPC_CANAFRAM_MASK375_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK375_MASK_BIT 0

#define LPC_CANAFRAM_MASK376 (*(volatile unsigned long *)0x400385E0)
#define LPC_CANAFRAM_MASK376_OFFSET 0x5E0
#define LPC_CANAFRAM_MASK376_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK376_MASK_BIT 0

#define LPC_CANAFRAM_MASK377 (*(volatile unsigned long *)0x400385E4)
#define LPC_CANAFRAM_MASK377_OFFSET 0x5E4
#define LPC_CANAFRAM_MASK377_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK377_MASK_BIT 0

#define LPC_CANAFRAM_MASK378 (*(volatile unsigned long *)0x400385E8)
#define LPC_CANAFRAM_MASK378_OFFSET 0x5E8
#define LPC_CANAFRAM_MASK378_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK378_MASK_BIT 0

#define LPC_CANAFRAM_MASK379 (*(volatile unsigned long *)0x400385EC)
#define LPC_CANAFRAM_MASK379_OFFSET 0x5EC
#define LPC_CANAFRAM_MASK379_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK379_MASK_BIT 0

#define LPC_CANAFRAM_MASK380 (*(volatile unsigned long *)0x400385F0)
#define LPC_CANAFRAM_MASK380_OFFSET 0x5F0
#define LPC_CANAFRAM_MASK380_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK380_MASK_BIT 0

#define LPC_CANAFRAM_MASK381 (*(volatile unsigned long *)0x400385F4)
#define LPC_CANAFRAM_MASK381_OFFSET 0x5F4
#define LPC_CANAFRAM_MASK381_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK381_MASK_BIT 0

#define LPC_CANAFRAM_MASK382 (*(volatile unsigned long *)0x400385F8)
#define LPC_CANAFRAM_MASK382_OFFSET 0x5F8
#define LPC_CANAFRAM_MASK382_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK382_MASK_BIT 0

#define LPC_CANAFRAM_MASK383 (*(volatile unsigned long *)0x400385FC)
#define LPC_CANAFRAM_MASK383_OFFSET 0x5FC
#define LPC_CANAFRAM_MASK383_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK383_MASK_BIT 0

#define LPC_CANAFRAM_MASK384 (*(volatile unsigned long *)0x40038600)
#define LPC_CANAFRAM_MASK384_OFFSET 0x600
#define LPC_CANAFRAM_MASK384_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK384_MASK_BIT 0

#define LPC_CANAFRAM_MASK385 (*(volatile unsigned long *)0x40038604)
#define LPC_CANAFRAM_MASK385_OFFSET 0x604
#define LPC_CANAFRAM_MASK385_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK385_MASK_BIT 0

#define LPC_CANAFRAM_MASK386 (*(volatile unsigned long *)0x40038608)
#define LPC_CANAFRAM_MASK386_OFFSET 0x608
#define LPC_CANAFRAM_MASK386_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK386_MASK_BIT 0

#define LPC_CANAFRAM_MASK387 (*(volatile unsigned long *)0x4003860C)
#define LPC_CANAFRAM_MASK387_OFFSET 0x60C
#define LPC_CANAFRAM_MASK387_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK387_MASK_BIT 0

#define LPC_CANAFRAM_MASK388 (*(volatile unsigned long *)0x40038610)
#define LPC_CANAFRAM_MASK388_OFFSET 0x610
#define LPC_CANAFRAM_MASK388_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK388_MASK_BIT 0

#define LPC_CANAFRAM_MASK389 (*(volatile unsigned long *)0x40038614)
#define LPC_CANAFRAM_MASK389_OFFSET 0x614
#define LPC_CANAFRAM_MASK389_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK389_MASK_BIT 0

#define LPC_CANAFRAM_MASK390 (*(volatile unsigned long *)0x40038618)
#define LPC_CANAFRAM_MASK390_OFFSET 0x618
#define LPC_CANAFRAM_MASK390_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK390_MASK_BIT 0

#define LPC_CANAFRAM_MASK391 (*(volatile unsigned long *)0x4003861C)
#define LPC_CANAFRAM_MASK391_OFFSET 0x61C
#define LPC_CANAFRAM_MASK391_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK391_MASK_BIT 0

#define LPC_CANAFRAM_MASK392 (*(volatile unsigned long *)0x40038620)
#define LPC_CANAFRAM_MASK392_OFFSET 0x620
#define LPC_CANAFRAM_MASK392_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK392_MASK_BIT 0

#define LPC_CANAFRAM_MASK393 (*(volatile unsigned long *)0x40038624)
#define LPC_CANAFRAM_MASK393_OFFSET 0x624
#define LPC_CANAFRAM_MASK393_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK393_MASK_BIT 0

#define LPC_CANAFRAM_MASK394 (*(volatile unsigned long *)0x40038628)
#define LPC_CANAFRAM_MASK394_OFFSET 0x628
#define LPC_CANAFRAM_MASK394_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK394_MASK_BIT 0

#define LPC_CANAFRAM_MASK395 (*(volatile unsigned long *)0x4003862C)
#define LPC_CANAFRAM_MASK395_OFFSET 0x62C
#define LPC_CANAFRAM_MASK395_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK395_MASK_BIT 0

#define LPC_CANAFRAM_MASK396 (*(volatile unsigned long *)0x40038630)
#define LPC_CANAFRAM_MASK396_OFFSET 0x630
#define LPC_CANAFRAM_MASK396_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK396_MASK_BIT 0

#define LPC_CANAFRAM_MASK397 (*(volatile unsigned long *)0x40038634)
#define LPC_CANAFRAM_MASK397_OFFSET 0x634
#define LPC_CANAFRAM_MASK397_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK397_MASK_BIT 0

#define LPC_CANAFRAM_MASK398 (*(volatile unsigned long *)0x40038638)
#define LPC_CANAFRAM_MASK398_OFFSET 0x638
#define LPC_CANAFRAM_MASK398_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK398_MASK_BIT 0

#define LPC_CANAFRAM_MASK399 (*(volatile unsigned long *)0x4003863C)
#define LPC_CANAFRAM_MASK399_OFFSET 0x63C
#define LPC_CANAFRAM_MASK399_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK399_MASK_BIT 0

#define LPC_CANAFRAM_MASK400 (*(volatile unsigned long *)0x40038640)
#define LPC_CANAFRAM_MASK400_OFFSET 0x640
#define LPC_CANAFRAM_MASK400_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK400_MASK_BIT 0

#define LPC_CANAFRAM_MASK401 (*(volatile unsigned long *)0x40038644)
#define LPC_CANAFRAM_MASK401_OFFSET 0x644
#define LPC_CANAFRAM_MASK401_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK401_MASK_BIT 0

#define LPC_CANAFRAM_MASK402 (*(volatile unsigned long *)0x40038648)
#define LPC_CANAFRAM_MASK402_OFFSET 0x648
#define LPC_CANAFRAM_MASK402_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK402_MASK_BIT 0

#define LPC_CANAFRAM_MASK403 (*(volatile unsigned long *)0x4003864C)
#define LPC_CANAFRAM_MASK403_OFFSET 0x64C
#define LPC_CANAFRAM_MASK403_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK403_MASK_BIT 0

#define LPC_CANAFRAM_MASK404 (*(volatile unsigned long *)0x40038650)
#define LPC_CANAFRAM_MASK404_OFFSET 0x650
#define LPC_CANAFRAM_MASK404_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK404_MASK_BIT 0

#define LPC_CANAFRAM_MASK405 (*(volatile unsigned long *)0x40038654)
#define LPC_CANAFRAM_MASK405_OFFSET 0x654
#define LPC_CANAFRAM_MASK405_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK405_MASK_BIT 0

#define LPC_CANAFRAM_MASK406 (*(volatile unsigned long *)0x40038658)
#define LPC_CANAFRAM_MASK406_OFFSET 0x658
#define LPC_CANAFRAM_MASK406_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK406_MASK_BIT 0

#define LPC_CANAFRAM_MASK407 (*(volatile unsigned long *)0x4003865C)
#define LPC_CANAFRAM_MASK407_OFFSET 0x65C
#define LPC_CANAFRAM_MASK407_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK407_MASK_BIT 0

#define LPC_CANAFRAM_MASK408 (*(volatile unsigned long *)0x40038660)
#define LPC_CANAFRAM_MASK408_OFFSET 0x660
#define LPC_CANAFRAM_MASK408_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK408_MASK_BIT 0

#define LPC_CANAFRAM_MASK409 (*(volatile unsigned long *)0x40038664)
#define LPC_CANAFRAM_MASK409_OFFSET 0x664
#define LPC_CANAFRAM_MASK409_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK409_MASK_BIT 0

#define LPC_CANAFRAM_MASK410 (*(volatile unsigned long *)0x40038668)
#define LPC_CANAFRAM_MASK410_OFFSET 0x668
#define LPC_CANAFRAM_MASK410_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK410_MASK_BIT 0

#define LPC_CANAFRAM_MASK411 (*(volatile unsigned long *)0x4003866C)
#define LPC_CANAFRAM_MASK411_OFFSET 0x66C
#define LPC_CANAFRAM_MASK411_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK411_MASK_BIT 0

#define LPC_CANAFRAM_MASK412 (*(volatile unsigned long *)0x40038670)
#define LPC_CANAFRAM_MASK412_OFFSET 0x670
#define LPC_CANAFRAM_MASK412_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK412_MASK_BIT 0

#define LPC_CANAFRAM_MASK413 (*(volatile unsigned long *)0x40038674)
#define LPC_CANAFRAM_MASK413_OFFSET 0x674
#define LPC_CANAFRAM_MASK413_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK413_MASK_BIT 0

#define LPC_CANAFRAM_MASK414 (*(volatile unsigned long *)0x40038678)
#define LPC_CANAFRAM_MASK414_OFFSET 0x678
#define LPC_CANAFRAM_MASK414_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK414_MASK_BIT 0

#define LPC_CANAFRAM_MASK415 (*(volatile unsigned long *)0x4003867C)
#define LPC_CANAFRAM_MASK415_OFFSET 0x67C
#define LPC_CANAFRAM_MASK415_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK415_MASK_BIT 0

#define LPC_CANAFRAM_MASK416 (*(volatile unsigned long *)0x40038680)
#define LPC_CANAFRAM_MASK416_OFFSET 0x680
#define LPC_CANAFRAM_MASK416_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK416_MASK_BIT 0

#define LPC_CANAFRAM_MASK417 (*(volatile unsigned long *)0x40038684)
#define LPC_CANAFRAM_MASK417_OFFSET 0x684
#define LPC_CANAFRAM_MASK417_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK417_MASK_BIT 0

#define LPC_CANAFRAM_MASK418 (*(volatile unsigned long *)0x40038688)
#define LPC_CANAFRAM_MASK418_OFFSET 0x688
#define LPC_CANAFRAM_MASK418_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK418_MASK_BIT 0

#define LPC_CANAFRAM_MASK419 (*(volatile unsigned long *)0x4003868C)
#define LPC_CANAFRAM_MASK419_OFFSET 0x68C
#define LPC_CANAFRAM_MASK419_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK419_MASK_BIT 0

#define LPC_CANAFRAM_MASK420 (*(volatile unsigned long *)0x40038690)
#define LPC_CANAFRAM_MASK420_OFFSET 0x690
#define LPC_CANAFRAM_MASK420_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK420_MASK_BIT 0

#define LPC_CANAFRAM_MASK421 (*(volatile unsigned long *)0x40038694)
#define LPC_CANAFRAM_MASK421_OFFSET 0x694
#define LPC_CANAFRAM_MASK421_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK421_MASK_BIT 0

#define LPC_CANAFRAM_MASK422 (*(volatile unsigned long *)0x40038698)
#define LPC_CANAFRAM_MASK422_OFFSET 0x698
#define LPC_CANAFRAM_MASK422_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK422_MASK_BIT 0

#define LPC_CANAFRAM_MASK423 (*(volatile unsigned long *)0x4003869C)
#define LPC_CANAFRAM_MASK423_OFFSET 0x69C
#define LPC_CANAFRAM_MASK423_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK423_MASK_BIT 0

#define LPC_CANAFRAM_MASK424 (*(volatile unsigned long *)0x400386A0)
#define LPC_CANAFRAM_MASK424_OFFSET 0x6A0
#define LPC_CANAFRAM_MASK424_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK424_MASK_BIT 0

#define LPC_CANAFRAM_MASK425 (*(volatile unsigned long *)0x400386A4)
#define LPC_CANAFRAM_MASK425_OFFSET 0x6A4
#define LPC_CANAFRAM_MASK425_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK425_MASK_BIT 0

#define LPC_CANAFRAM_MASK426 (*(volatile unsigned long *)0x400386A8)
#define LPC_CANAFRAM_MASK426_OFFSET 0x6A8
#define LPC_CANAFRAM_MASK426_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK426_MASK_BIT 0

#define LPC_CANAFRAM_MASK427 (*(volatile unsigned long *)0x400386AC)
#define LPC_CANAFRAM_MASK427_OFFSET 0x6AC
#define LPC_CANAFRAM_MASK427_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK427_MASK_BIT 0

#define LPC_CANAFRAM_MASK428 (*(volatile unsigned long *)0x400386B0)
#define LPC_CANAFRAM_MASK428_OFFSET 0x6B0
#define LPC_CANAFRAM_MASK428_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK428_MASK_BIT 0

#define LPC_CANAFRAM_MASK429 (*(volatile unsigned long *)0x400386B4)
#define LPC_CANAFRAM_MASK429_OFFSET 0x6B4
#define LPC_CANAFRAM_MASK429_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK429_MASK_BIT 0

#define LPC_CANAFRAM_MASK430 (*(volatile unsigned long *)0x400386B8)
#define LPC_CANAFRAM_MASK430_OFFSET 0x6B8
#define LPC_CANAFRAM_MASK430_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK430_MASK_BIT 0

#define LPC_CANAFRAM_MASK431 (*(volatile unsigned long *)0x400386BC)
#define LPC_CANAFRAM_MASK431_OFFSET 0x6BC
#define LPC_CANAFRAM_MASK431_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK431_MASK_BIT 0

#define LPC_CANAFRAM_MASK432 (*(volatile unsigned long *)0x400386C0)
#define LPC_CANAFRAM_MASK432_OFFSET 0x6C0
#define LPC_CANAFRAM_MASK432_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK432_MASK_BIT 0

#define LPC_CANAFRAM_MASK433 (*(volatile unsigned long *)0x400386C4)
#define LPC_CANAFRAM_MASK433_OFFSET 0x6C4
#define LPC_CANAFRAM_MASK433_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK433_MASK_BIT 0

#define LPC_CANAFRAM_MASK434 (*(volatile unsigned long *)0x400386C8)
#define LPC_CANAFRAM_MASK434_OFFSET 0x6C8
#define LPC_CANAFRAM_MASK434_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK434_MASK_BIT 0

#define LPC_CANAFRAM_MASK435 (*(volatile unsigned long *)0x400386CC)
#define LPC_CANAFRAM_MASK435_OFFSET 0x6CC
#define LPC_CANAFRAM_MASK435_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK435_MASK_BIT 0

#define LPC_CANAFRAM_MASK436 (*(volatile unsigned long *)0x400386D0)
#define LPC_CANAFRAM_MASK436_OFFSET 0x6D0
#define LPC_CANAFRAM_MASK436_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK436_MASK_BIT 0

#define LPC_CANAFRAM_MASK437 (*(volatile unsigned long *)0x400386D4)
#define LPC_CANAFRAM_MASK437_OFFSET 0x6D4
#define LPC_CANAFRAM_MASK437_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK437_MASK_BIT 0

#define LPC_CANAFRAM_MASK438 (*(volatile unsigned long *)0x400386D8)
#define LPC_CANAFRAM_MASK438_OFFSET 0x6D8
#define LPC_CANAFRAM_MASK438_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK438_MASK_BIT 0

#define LPC_CANAFRAM_MASK439 (*(volatile unsigned long *)0x400386DC)
#define LPC_CANAFRAM_MASK439_OFFSET 0x6DC
#define LPC_CANAFRAM_MASK439_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK439_MASK_BIT 0

#define LPC_CANAFRAM_MASK440 (*(volatile unsigned long *)0x400386E0)
#define LPC_CANAFRAM_MASK440_OFFSET 0x6E0
#define LPC_CANAFRAM_MASK440_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK440_MASK_BIT 0

#define LPC_CANAFRAM_MASK441 (*(volatile unsigned long *)0x400386E4)
#define LPC_CANAFRAM_MASK441_OFFSET 0x6E4
#define LPC_CANAFRAM_MASK441_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK441_MASK_BIT 0

#define LPC_CANAFRAM_MASK442 (*(volatile unsigned long *)0x400386E8)
#define LPC_CANAFRAM_MASK442_OFFSET 0x6E8
#define LPC_CANAFRAM_MASK442_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK442_MASK_BIT 0

#define LPC_CANAFRAM_MASK443 (*(volatile unsigned long *)0x400386EC)
#define LPC_CANAFRAM_MASK443_OFFSET 0x6EC
#define LPC_CANAFRAM_MASK443_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK443_MASK_BIT 0

#define LPC_CANAFRAM_MASK444 (*(volatile unsigned long *)0x400386F0)
#define LPC_CANAFRAM_MASK444_OFFSET 0x6F0
#define LPC_CANAFRAM_MASK444_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK444_MASK_BIT 0

#define LPC_CANAFRAM_MASK445 (*(volatile unsigned long *)0x400386F4)
#define LPC_CANAFRAM_MASK445_OFFSET 0x6F4
#define LPC_CANAFRAM_MASK445_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK445_MASK_BIT 0

#define LPC_CANAFRAM_MASK446 (*(volatile unsigned long *)0x400386F8)
#define LPC_CANAFRAM_MASK446_OFFSET 0x6F8
#define LPC_CANAFRAM_MASK446_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK446_MASK_BIT 0

#define LPC_CANAFRAM_MASK447 (*(volatile unsigned long *)0x400386FC)
#define LPC_CANAFRAM_MASK447_OFFSET 0x6FC
#define LPC_CANAFRAM_MASK447_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK447_MASK_BIT 0

#define LPC_CANAFRAM_MASK448 (*(volatile unsigned long *)0x40038700)
#define LPC_CANAFRAM_MASK448_OFFSET 0x700
#define LPC_CANAFRAM_MASK448_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK448_MASK_BIT 0

#define LPC_CANAFRAM_MASK449 (*(volatile unsigned long *)0x40038704)
#define LPC_CANAFRAM_MASK449_OFFSET 0x704
#define LPC_CANAFRAM_MASK449_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK449_MASK_BIT 0

#define LPC_CANAFRAM_MASK450 (*(volatile unsigned long *)0x40038708)
#define LPC_CANAFRAM_MASK450_OFFSET 0x708
#define LPC_CANAFRAM_MASK450_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK450_MASK_BIT 0

#define LPC_CANAFRAM_MASK451 (*(volatile unsigned long *)0x4003870C)
#define LPC_CANAFRAM_MASK451_OFFSET 0x70C
#define LPC_CANAFRAM_MASK451_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK451_MASK_BIT 0

#define LPC_CANAFRAM_MASK452 (*(volatile unsigned long *)0x40038710)
#define LPC_CANAFRAM_MASK452_OFFSET 0x710
#define LPC_CANAFRAM_MASK452_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK452_MASK_BIT 0

#define LPC_CANAFRAM_MASK453 (*(volatile unsigned long *)0x40038714)
#define LPC_CANAFRAM_MASK453_OFFSET 0x714
#define LPC_CANAFRAM_MASK453_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK453_MASK_BIT 0

#define LPC_CANAFRAM_MASK454 (*(volatile unsigned long *)0x40038718)
#define LPC_CANAFRAM_MASK454_OFFSET 0x718
#define LPC_CANAFRAM_MASK454_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK454_MASK_BIT 0

#define LPC_CANAFRAM_MASK455 (*(volatile unsigned long *)0x4003871C)
#define LPC_CANAFRAM_MASK455_OFFSET 0x71C
#define LPC_CANAFRAM_MASK455_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK455_MASK_BIT 0

#define LPC_CANAFRAM_MASK456 (*(volatile unsigned long *)0x40038720)
#define LPC_CANAFRAM_MASK456_OFFSET 0x720
#define LPC_CANAFRAM_MASK456_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK456_MASK_BIT 0

#define LPC_CANAFRAM_MASK457 (*(volatile unsigned long *)0x40038724)
#define LPC_CANAFRAM_MASK457_OFFSET 0x724
#define LPC_CANAFRAM_MASK457_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK457_MASK_BIT 0

#define LPC_CANAFRAM_MASK458 (*(volatile unsigned long *)0x40038728)
#define LPC_CANAFRAM_MASK458_OFFSET 0x728
#define LPC_CANAFRAM_MASK458_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK458_MASK_BIT 0

#define LPC_CANAFRAM_MASK459 (*(volatile unsigned long *)0x4003872C)
#define LPC_CANAFRAM_MASK459_OFFSET 0x72C
#define LPC_CANAFRAM_MASK459_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK459_MASK_BIT 0

#define LPC_CANAFRAM_MASK460 (*(volatile unsigned long *)0x40038730)
#define LPC_CANAFRAM_MASK460_OFFSET 0x730
#define LPC_CANAFRAM_MASK460_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK460_MASK_BIT 0

#define LPC_CANAFRAM_MASK461 (*(volatile unsigned long *)0x40038734)
#define LPC_CANAFRAM_MASK461_OFFSET 0x734
#define LPC_CANAFRAM_MASK461_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK461_MASK_BIT 0

#define LPC_CANAFRAM_MASK462 (*(volatile unsigned long *)0x40038738)
#define LPC_CANAFRAM_MASK462_OFFSET 0x738
#define LPC_CANAFRAM_MASK462_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK462_MASK_BIT 0

#define LPC_CANAFRAM_MASK463 (*(volatile unsigned long *)0x4003873C)
#define LPC_CANAFRAM_MASK463_OFFSET 0x73C
#define LPC_CANAFRAM_MASK463_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK463_MASK_BIT 0

#define LPC_CANAFRAM_MASK464 (*(volatile unsigned long *)0x40038740)
#define LPC_CANAFRAM_MASK464_OFFSET 0x740
#define LPC_CANAFRAM_MASK464_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK464_MASK_BIT 0

#define LPC_CANAFRAM_MASK465 (*(volatile unsigned long *)0x40038744)
#define LPC_CANAFRAM_MASK465_OFFSET 0x744
#define LPC_CANAFRAM_MASK465_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK465_MASK_BIT 0

#define LPC_CANAFRAM_MASK466 (*(volatile unsigned long *)0x40038748)
#define LPC_CANAFRAM_MASK466_OFFSET 0x748
#define LPC_CANAFRAM_MASK466_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK466_MASK_BIT 0

#define LPC_CANAFRAM_MASK467 (*(volatile unsigned long *)0x4003874C)
#define LPC_CANAFRAM_MASK467_OFFSET 0x74C
#define LPC_CANAFRAM_MASK467_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK467_MASK_BIT 0

#define LPC_CANAFRAM_MASK468 (*(volatile unsigned long *)0x40038750)
#define LPC_CANAFRAM_MASK468_OFFSET 0x750
#define LPC_CANAFRAM_MASK468_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK468_MASK_BIT 0

#define LPC_CANAFRAM_MASK469 (*(volatile unsigned long *)0x40038754)
#define LPC_CANAFRAM_MASK469_OFFSET 0x754
#define LPC_CANAFRAM_MASK469_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK469_MASK_BIT 0

#define LPC_CANAFRAM_MASK470 (*(volatile unsigned long *)0x40038758)
#define LPC_CANAFRAM_MASK470_OFFSET 0x758
#define LPC_CANAFRAM_MASK470_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK470_MASK_BIT 0

#define LPC_CANAFRAM_MASK471 (*(volatile unsigned long *)0x4003875C)
#define LPC_CANAFRAM_MASK471_OFFSET 0x75C
#define LPC_CANAFRAM_MASK471_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK471_MASK_BIT 0

#define LPC_CANAFRAM_MASK472 (*(volatile unsigned long *)0x40038760)
#define LPC_CANAFRAM_MASK472_OFFSET 0x760
#define LPC_CANAFRAM_MASK472_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK472_MASK_BIT 0

#define LPC_CANAFRAM_MASK473 (*(volatile unsigned long *)0x40038764)
#define LPC_CANAFRAM_MASK473_OFFSET 0x764
#define LPC_CANAFRAM_MASK473_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK473_MASK_BIT 0

#define LPC_CANAFRAM_MASK474 (*(volatile unsigned long *)0x40038768)
#define LPC_CANAFRAM_MASK474_OFFSET 0x768
#define LPC_CANAFRAM_MASK474_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK474_MASK_BIT 0

#define LPC_CANAFRAM_MASK475 (*(volatile unsigned long *)0x4003876C)
#define LPC_CANAFRAM_MASK475_OFFSET 0x76C
#define LPC_CANAFRAM_MASK475_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK475_MASK_BIT 0

#define LPC_CANAFRAM_MASK476 (*(volatile unsigned long *)0x40038770)
#define LPC_CANAFRAM_MASK476_OFFSET 0x770
#define LPC_CANAFRAM_MASK476_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK476_MASK_BIT 0

#define LPC_CANAFRAM_MASK477 (*(volatile unsigned long *)0x40038774)
#define LPC_CANAFRAM_MASK477_OFFSET 0x774
#define LPC_CANAFRAM_MASK477_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK477_MASK_BIT 0

#define LPC_CANAFRAM_MASK478 (*(volatile unsigned long *)0x40038778)
#define LPC_CANAFRAM_MASK478_OFFSET 0x778
#define LPC_CANAFRAM_MASK478_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK478_MASK_BIT 0

#define LPC_CANAFRAM_MASK479 (*(volatile unsigned long *)0x4003877C)
#define LPC_CANAFRAM_MASK479_OFFSET 0x77C
#define LPC_CANAFRAM_MASK479_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK479_MASK_BIT 0

#define LPC_CANAFRAM_MASK480 (*(volatile unsigned long *)0x40038780)
#define LPC_CANAFRAM_MASK480_OFFSET 0x780
#define LPC_CANAFRAM_MASK480_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK480_MASK_BIT 0

#define LPC_CANAFRAM_MASK481 (*(volatile unsigned long *)0x40038784)
#define LPC_CANAFRAM_MASK481_OFFSET 0x784
#define LPC_CANAFRAM_MASK481_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK481_MASK_BIT 0

#define LPC_CANAFRAM_MASK482 (*(volatile unsigned long *)0x40038788)
#define LPC_CANAFRAM_MASK482_OFFSET 0x788
#define LPC_CANAFRAM_MASK482_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK482_MASK_BIT 0

#define LPC_CANAFRAM_MASK483 (*(volatile unsigned long *)0x4003878C)
#define LPC_CANAFRAM_MASK483_OFFSET 0x78C
#define LPC_CANAFRAM_MASK483_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK483_MASK_BIT 0

#define LPC_CANAFRAM_MASK484 (*(volatile unsigned long *)0x40038790)
#define LPC_CANAFRAM_MASK484_OFFSET 0x790
#define LPC_CANAFRAM_MASK484_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK484_MASK_BIT 0

#define LPC_CANAFRAM_MASK485 (*(volatile unsigned long *)0x40038794)
#define LPC_CANAFRAM_MASK485_OFFSET 0x794
#define LPC_CANAFRAM_MASK485_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK485_MASK_BIT 0

#define LPC_CANAFRAM_MASK486 (*(volatile unsigned long *)0x40038798)
#define LPC_CANAFRAM_MASK486_OFFSET 0x798
#define LPC_CANAFRAM_MASK486_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK486_MASK_BIT 0

#define LPC_CANAFRAM_MASK487 (*(volatile unsigned long *)0x4003879C)
#define LPC_CANAFRAM_MASK487_OFFSET 0x79C
#define LPC_CANAFRAM_MASK487_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK487_MASK_BIT 0

#define LPC_CANAFRAM_MASK488 (*(volatile unsigned long *)0x400387A0)
#define LPC_CANAFRAM_MASK488_OFFSET 0x7A0
#define LPC_CANAFRAM_MASK488_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK488_MASK_BIT 0

#define LPC_CANAFRAM_MASK489 (*(volatile unsigned long *)0x400387A4)
#define LPC_CANAFRAM_MASK489_OFFSET 0x7A4
#define LPC_CANAFRAM_MASK489_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK489_MASK_BIT 0

#define LPC_CANAFRAM_MASK490 (*(volatile unsigned long *)0x400387A8)
#define LPC_CANAFRAM_MASK490_OFFSET 0x7A8
#define LPC_CANAFRAM_MASK490_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK490_MASK_BIT 0

#define LPC_CANAFRAM_MASK491 (*(volatile unsigned long *)0x400387AC)
#define LPC_CANAFRAM_MASK491_OFFSET 0x7AC
#define LPC_CANAFRAM_MASK491_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK491_MASK_BIT 0

#define LPC_CANAFRAM_MASK492 (*(volatile unsigned long *)0x400387B0)
#define LPC_CANAFRAM_MASK492_OFFSET 0x7B0
#define LPC_CANAFRAM_MASK492_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK492_MASK_BIT 0

#define LPC_CANAFRAM_MASK493 (*(volatile unsigned long *)0x400387B4)
#define LPC_CANAFRAM_MASK493_OFFSET 0x7B4
#define LPC_CANAFRAM_MASK493_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK493_MASK_BIT 0

#define LPC_CANAFRAM_MASK494 (*(volatile unsigned long *)0x400387B8)
#define LPC_CANAFRAM_MASK494_OFFSET 0x7B8
#define LPC_CANAFRAM_MASK494_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK494_MASK_BIT 0

#define LPC_CANAFRAM_MASK495 (*(volatile unsigned long *)0x400387BC)
#define LPC_CANAFRAM_MASK495_OFFSET 0x7BC
#define LPC_CANAFRAM_MASK495_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK495_MASK_BIT 0

#define LPC_CANAFRAM_MASK496 (*(volatile unsigned long *)0x400387C0)
#define LPC_CANAFRAM_MASK496_OFFSET 0x7C0
#define LPC_CANAFRAM_MASK496_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK496_MASK_BIT 0

#define LPC_CANAFRAM_MASK497 (*(volatile unsigned long *)0x400387C4)
#define LPC_CANAFRAM_MASK497_OFFSET 0x7C4
#define LPC_CANAFRAM_MASK497_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK497_MASK_BIT 0

#define LPC_CANAFRAM_MASK498 (*(volatile unsigned long *)0x400387C8)
#define LPC_CANAFRAM_MASK498_OFFSET 0x7C8
#define LPC_CANAFRAM_MASK498_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK498_MASK_BIT 0

#define LPC_CANAFRAM_MASK499 (*(volatile unsigned long *)0x400387CC)
#define LPC_CANAFRAM_MASK499_OFFSET 0x7CC
#define LPC_CANAFRAM_MASK499_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK499_MASK_BIT 0

#define LPC_CANAFRAM_MASK500 (*(volatile unsigned long *)0x400387D0)
#define LPC_CANAFRAM_MASK500_OFFSET 0x7D0
#define LPC_CANAFRAM_MASK500_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK500_MASK_BIT 0

#define LPC_CANAFRAM_MASK501 (*(volatile unsigned long *)0x400387D4)
#define LPC_CANAFRAM_MASK501_OFFSET 0x7D4
#define LPC_CANAFRAM_MASK501_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK501_MASK_BIT 0

#define LPC_CANAFRAM_MASK502 (*(volatile unsigned long *)0x400387D8)
#define LPC_CANAFRAM_MASK502_OFFSET 0x7D8
#define LPC_CANAFRAM_MASK502_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK502_MASK_BIT 0

#define LPC_CANAFRAM_MASK503 (*(volatile unsigned long *)0x400387DC)
#define LPC_CANAFRAM_MASK503_OFFSET 0x7DC
#define LPC_CANAFRAM_MASK503_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK503_MASK_BIT 0

#define LPC_CANAFRAM_MASK504 (*(volatile unsigned long *)0x400387E0)
#define LPC_CANAFRAM_MASK504_OFFSET 0x7E0
#define LPC_CANAFRAM_MASK504_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK504_MASK_BIT 0

#define LPC_CANAFRAM_MASK505 (*(volatile unsigned long *)0x400387E4)
#define LPC_CANAFRAM_MASK505_OFFSET 0x7E4
#define LPC_CANAFRAM_MASK505_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK505_MASK_BIT 0

#define LPC_CANAFRAM_MASK506 (*(volatile unsigned long *)0x400387E8)
#define LPC_CANAFRAM_MASK506_OFFSET 0x7E8
#define LPC_CANAFRAM_MASK506_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK506_MASK_BIT 0

#define LPC_CANAFRAM_MASK507 (*(volatile unsigned long *)0x400387EC)
#define LPC_CANAFRAM_MASK507_OFFSET 0x7EC
#define LPC_CANAFRAM_MASK507_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK507_MASK_BIT 0

#define LPC_CANAFRAM_MASK508 (*(volatile unsigned long *)0x400387F0)
#define LPC_CANAFRAM_MASK508_OFFSET 0x7F0
#define LPC_CANAFRAM_MASK508_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK508_MASK_BIT 0

#define LPC_CANAFRAM_MASK509 (*(volatile unsigned long *)0x400387F4)
#define LPC_CANAFRAM_MASK509_OFFSET 0x7F4
#define LPC_CANAFRAM_MASK509_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK509_MASK_BIT 0

#define LPC_CANAFRAM_MASK510 (*(volatile unsigned long *)0x400387F8)
#define LPC_CANAFRAM_MASK510_OFFSET 0x7F8
#define LPC_CANAFRAM_MASK510_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK510_MASK_BIT 0

#define LPC_CANAFRAM_MASK511 (*(volatile unsigned long *)0x400387FC)
#define LPC_CANAFRAM_MASK511_OFFSET 0x7FC
#define LPC_CANAFRAM_MASK511_MASK_MASK 0xFFFFFFFF
#define LPC_CANAFRAM_MASK511_MASK_BIT 0

#ifndef LPC_CANAF_BASE_ADDRESS
#define LPC_CANAF_BASE_ADDRESS 0x4003C000
#endif

#define LPC_CANAF_AFMR (*(volatile unsigned long *)0x4003C000)
#define LPC_CANAF_AFMR_OFFSET 0x0
#define LPC_CANAF_AFMR_ACCOFF_MASK 0x1
#define LPC_CANAF_AFMR_ACCOFF 0x1
#define LPC_CANAF_AFMR_ACCOFF_BIT 0
#define LPC_CANAF_AFMR_ACCBP_MASK 0x2
#define LPC_CANAF_AFMR_ACCBP 0x2
#define LPC_CANAF_AFMR_ACCBP_BIT 1
#define LPC_CANAF_AFMR_EFCAN_MASK 0x4
#define LPC_CANAF_AFMR_EFCAN 0x4
#define LPC_CANAF_AFMR_EFCAN_BIT 2

#define LPC_CANAF_SFF_SA (*(volatile unsigned long *)0x4003C004)
#define LPC_CANAF_SFF_SA_OFFSET 0x4
#define LPC_CANAF_SFF_SA_SFF_SA_MASK 0x7FC
#define LPC_CANAF_SFF_SA_SFF_SA_BIT 2

#define LPC_CANAF_SFF_GRP_SA (*(volatile unsigned long *)0x4003C008)
#define LPC_CANAF_SFF_GRP_SA_OFFSET 0x8
#define LPC_CANAF_SFF_GRP_SA_SFF_GRP_SA_MASK 0xFFC
#define LPC_CANAF_SFF_GRP_SA_SFF_GRP_SA_BIT 2

#define LPC_CANAF_EFF_SA (*(volatile unsigned long *)0x4003C00C)
#define LPC_CANAF_EFF_SA_OFFSET 0xC
#define LPC_CANAF_EFF_SA_EFF_SA_MASK 0x7FC
#define LPC_CANAF_EFF_SA_EFF_SA_BIT 2

#define LPC_CANAF_EFF_GRP_SA (*(volatile unsigned long *)0x4003C010)
#define LPC_CANAF_EFF_GRP_SA_OFFSET 0x10
#define LPC_CANAF_EFF_GRP_SA_EFF_GRP_SA_MASK 0xFFC
#define LPC_CANAF_EFF_GRP_SA_EFF_GRP_SA_BIT 2

#define LPC_CANAF_ENDOFTABLE (*(volatile unsigned long *)0x4003C014)
#define LPC_CANAF_ENDOFTABLE_OFFSET 0x14
#define LPC_CANAF_ENDOFTABLE_ENDOFTABLE_MASK 0xFFC
#define LPC_CANAF_ENDOFTABLE_ENDOFTABLE_BIT 2

#define LPC_CANAF_LUTERRAD (*(volatile unsigned long *)0x4003C018)
#define LPC_CANAF_LUTERRAD_OFFSET 0x18
#define LPC_CANAF_LUTERRAD_LUTERRAD_MASK 0x7FC
#define LPC_CANAF_LUTERRAD_LUTERRAD_BIT 2

#define LPC_CANAF_LUTERR (*(volatile unsigned long *)0x4003C01C)
#define LPC_CANAF_LUTERR_OFFSET 0x1C
#define LPC_CANAF_LUTERR_LUTERR_MASK 0x1
#define LPC_CANAF_LUTERR_LUTERR 0x1
#define LPC_CANAF_LUTERR_LUTERR_BIT 0

#define LPC_CANAF_FCANIE (*(volatile unsigned long *)0x4003C020)
#define LPC_CANAF_FCANIE_OFFSET 0x20
#define LPC_CANAF_FCANIE_FCANIE_MASK 0x1
#define LPC_CANAF_FCANIE_FCANIE 0x1
#define LPC_CANAF_FCANIE_FCANIE_BIT 0

#define LPC_CANAF_FCANIC0 (*(volatile unsigned long *)0x4003C024)
#define LPC_CANAF_FCANIC0_OFFSET 0x24
#define LPC_CANAF_FCANIC0_INTPND_MASK 0xFFFFFFFF
#define LPC_CANAF_FCANIC0_INTPND_BIT 0

#define LPC_CANAF_FCANIC1 (*(volatile unsigned long *)0x4003C028)
#define LPC_CANAF_FCANIC1_OFFSET 0x28
#define LPC_CANAF_FCANIC1_IntPnd32_MASK 0xFFFFFFFF
#define LPC_CANAF_FCANIC1_IntPnd32_BIT 0

#ifndef LPC_CCAN_BASE_ADDRESS
#define LPC_CCAN_BASE_ADDRESS 0x40040000
#endif

#define LPC_CCAN_TXSR (*(volatile unsigned long *)0x40040000)
#define LPC_CCAN_TXSR_OFFSET 0x0
#define LPC_CCAN_TXSR_TS1_MASK 0x1
#define LPC_CCAN_TXSR_TS1 0x1
#define LPC_CCAN_TXSR_TS1_BIT 0
#define LPC_CCAN_TXSR_TS2_MASK 0x2
#define LPC_CCAN_TXSR_TS2 0x2
#define LPC_CCAN_TXSR_TS2_BIT 1
#define LPC_CCAN_TXSR_TBS1_MASK 0x100
#define LPC_CCAN_TXSR_TBS1 0x100
#define LPC_CCAN_TXSR_TBS1_BIT 8
#define LPC_CCAN_TXSR_TBS2_MASK 0x200
#define LPC_CCAN_TXSR_TBS2 0x200
#define LPC_CCAN_TXSR_TBS2_BIT 9
#define LPC_CCAN_TXSR_TCS1_MASK 0x10000
#define LPC_CCAN_TXSR_TCS1 0x10000
#define LPC_CCAN_TXSR_TCS1_BIT 16
#define LPC_CCAN_TXSR_TCS2_MASK 0x20000
#define LPC_CCAN_TXSR_TCS2 0x20000
#define LPC_CCAN_TXSR_TCS2_BIT 17

#define LPC_CCAN_RXSR (*(volatile unsigned long *)0x40040004)
#define LPC_CCAN_RXSR_OFFSET 0x4
#define LPC_CCAN_RXSR_RS1_MASK 0x1
#define LPC_CCAN_RXSR_RS1 0x1
#define LPC_CCAN_RXSR_RS1_BIT 0
#define LPC_CCAN_RXSR_RS2_MASK 0x2
#define LPC_CCAN_RXSR_RS2 0x2
#define LPC_CCAN_RXSR_RS2_BIT 1
#define LPC_CCAN_RXSR_RB1_MASK 0x100
#define LPC_CCAN_RXSR_RB1 0x100
#define LPC_CCAN_RXSR_RB1_BIT 8
#define LPC_CCAN_RXSR_RB2_MASK 0x200
#define LPC_CCAN_RXSR_RB2 0x200
#define LPC_CCAN_RXSR_RB2_BIT 9
#define LPC_CCAN_RXSR_DOS1_MASK 0x10000
#define LPC_CCAN_RXSR_DOS1 0x10000
#define LPC_CCAN_RXSR_DOS1_BIT 16
#define LPC_CCAN_RXSR_DOS2_MASK 0x20000
#define LPC_CCAN_RXSR_DOS2 0x20000
#define LPC_CCAN_RXSR_DOS2_BIT 17

#define LPC_CCAN_MSR (*(volatile unsigned long *)0x40040008)
#define LPC_CCAN_MSR_OFFSET 0x8
#define LPC_CCAN_MSR_E1_MASK 0x1
#define LPC_CCAN_MSR_E1 0x1
#define LPC_CCAN_MSR_E1_BIT 0
#define LPC_CCAN_MSR_E2_MASK 0x2
#define LPC_CCAN_MSR_E2 0x2
#define LPC_CCAN_MSR_E2_BIT 1
#define LPC_CCAN_MSR_BS1_MASK 0x100
#define LPC_CCAN_MSR_BS1 0x100
#define LPC_CCAN_MSR_BS1_BIT 8
#define LPC_CCAN_MSR_BS2_MASK 0x200
#define LPC_CCAN_MSR_BS2 0x200
#define LPC_CCAN_MSR_BS2_BIT 9

#ifndef LPC_CAN1_BASE_ADDRESS
#define LPC_CAN1_BASE_ADDRESS 0x40044000
#endif

#define LPC_CAN1_MOD (*(volatile unsigned long *)0x40044000)
#define LPC_CAN1_MOD_OFFSET 0x0
#define LPC_CAN1_MOD_RM_MASK 0x1
#define LPC_CAN1_MOD_RM 0x1
#define LPC_CAN1_MOD_RM_BIT 0
#define LPC_CAN1_MOD_LOM_MASK 0x2
#define LPC_CAN1_MOD_LOM 0x2
#define LPC_CAN1_MOD_LOM_BIT 1
#define LPC_CAN1_MOD_STM_MASK 0x4
#define LPC_CAN1_MOD_STM 0x4
#define LPC_CAN1_MOD_STM_BIT 2
#define LPC_CAN1_MOD_TPM_MASK 0x8
#define LPC_CAN1_MOD_TPM 0x8
#define LPC_CAN1_MOD_TPM_BIT 3
#define LPC_CAN1_MOD_SM_MASK 0x10
#define LPC_CAN1_MOD_SM 0x10
#define LPC_CAN1_MOD_SM_BIT 4
#define LPC_CAN1_MOD_RPM_MASK 0x20
#define LPC_CAN1_MOD_RPM 0x20
#define LPC_CAN1_MOD_RPM_BIT 5
#define LPC_CAN1_MOD_TM_MASK 0x80
#define LPC_CAN1_MOD_TM 0x80
#define LPC_CAN1_MOD_TM_BIT 7

#define LPC_CAN1_CMR (*(volatile unsigned long *)0x40044004)
#define LPC_CAN1_CMR_OFFSET 0x4
#define LPC_CAN1_CMR_TR_MASK 0x1
#define LPC_CAN1_CMR_TR 0x1
#define LPC_CAN1_CMR_TR_BIT 0
#define LPC_CAN1_CMR_AT_MASK 0x2
#define LPC_CAN1_CMR_AT 0x2
#define LPC_CAN1_CMR_AT_BIT 1
#define LPC_CAN1_CMR_RRB_MASK 0x4
#define LPC_CAN1_CMR_RRB 0x4
#define LPC_CAN1_CMR_RRB_BIT 2
#define LPC_CAN1_CMR_CDO_MASK 0x8
#define LPC_CAN1_CMR_CDO 0x8
#define LPC_CAN1_CMR_CDO_BIT 3
#define LPC_CAN1_CMR_SRR_MASK 0x10
#define LPC_CAN1_CMR_SRR 0x10
#define LPC_CAN1_CMR_SRR_BIT 4
#define LPC_CAN1_CMR_STB1_MASK 0x20
#define LPC_CAN1_CMR_STB1 0x20
#define LPC_CAN1_CMR_STB1_BIT 5
#define LPC_CAN1_CMR_STB2_MASK 0x40
#define LPC_CAN1_CMR_STB2 0x40
#define LPC_CAN1_CMR_STB2_BIT 6
#define LPC_CAN1_CMR_STB3_MASK 0x80
#define LPC_CAN1_CMR_STB3 0x80
#define LPC_CAN1_CMR_STB3_BIT 7

#define LPC_CAN1_GSR (*(volatile unsigned long *)0x40044008)
#define LPC_CAN1_GSR_OFFSET 0x8
#define LPC_CAN1_GSR_RBS_MASK 0x1
#define LPC_CAN1_GSR_RBS 0x1
#define LPC_CAN1_GSR_RBS_BIT 0
#define LPC_CAN1_GSR_DOS_MASK 0x2
#define LPC_CAN1_GSR_DOS 0x2
#define LPC_CAN1_GSR_DOS_BIT 1
#define LPC_CAN1_GSR_TBS_MASK 0x4
#define LPC_CAN1_GSR_TBS 0x4
#define LPC_CAN1_GSR_TBS_BIT 2
#define LPC_CAN1_GSR_TCS_MASK 0x8
#define LPC_CAN1_GSR_TCS 0x8
#define LPC_CAN1_GSR_TCS_BIT 3
#define LPC_CAN1_GSR_RS_MASK 0x10
#define LPC_CAN1_GSR_RS 0x10
#define LPC_CAN1_GSR_RS_BIT 4
#define LPC_CAN1_GSR_TS_MASK 0x20
#define LPC_CAN1_GSR_TS 0x20
#define LPC_CAN1_GSR_TS_BIT 5
#define LPC_CAN1_GSR_ES_MASK 0x40
#define LPC_CAN1_GSR_ES 0x40
#define LPC_CAN1_GSR_ES_BIT 6
#define LPC_CAN1_GSR_BS_MASK 0x80
#define LPC_CAN1_GSR_BS 0x80
#define LPC_CAN1_GSR_BS_BIT 7
#define LPC_CAN1_GSR_RXERR_MASK 0xFF0000
#define LPC_CAN1_GSR_RXERR_BIT 16
#define LPC_CAN1_GSR_TXERR_MASK 0xFF000000
#define LPC_CAN1_GSR_TXERR_BIT 24

#define LPC_CAN1_ICR (*(volatile unsigned long *)0x4004400C)
#define LPC_CAN1_ICR_OFFSET 0xC
#define LPC_CAN1_ICR_RI_MASK 0x1
#define LPC_CAN1_ICR_RI 0x1
#define LPC_CAN1_ICR_RI_BIT 0
#define LPC_CAN1_ICR_TI1_MASK 0x2
#define LPC_CAN1_ICR_TI1 0x2
#define LPC_CAN1_ICR_TI1_BIT 1
#define LPC_CAN1_ICR_EI_MASK 0x4
#define LPC_CAN1_ICR_EI 0x4
#define LPC_CAN1_ICR_EI_BIT 2
#define LPC_CAN1_ICR_DOI_MASK 0x8
#define LPC_CAN1_ICR_DOI 0x8
#define LPC_CAN1_ICR_DOI_BIT 3
#define LPC_CAN1_ICR_WUI_MASK 0x10
#define LPC_CAN1_ICR_WUI 0x10
#define LPC_CAN1_ICR_WUI_BIT 4
#define LPC_CAN1_ICR_EPI_MASK 0x20
#define LPC_CAN1_ICR_EPI 0x20
#define LPC_CAN1_ICR_EPI_BIT 5
#define LPC_CAN1_ICR_ALI_MASK 0x40
#define LPC_CAN1_ICR_ALI 0x40
#define LPC_CAN1_ICR_ALI_BIT 6
#define LPC_CAN1_ICR_BEI_MASK 0x80
#define LPC_CAN1_ICR_BEI 0x80
#define LPC_CAN1_ICR_BEI_BIT 7
#define LPC_CAN1_ICR_IDI_MASK 0x100
#define LPC_CAN1_ICR_IDI 0x100
#define LPC_CAN1_ICR_IDI_BIT 8
#define LPC_CAN1_ICR_TI2_MASK 0x200
#define LPC_CAN1_ICR_TI2 0x200
#define LPC_CAN1_ICR_TI2_BIT 9
#define LPC_CAN1_ICR_TI3_MASK 0x400
#define LPC_CAN1_ICR_TI3 0x400
#define LPC_CAN1_ICR_TI3_BIT 10
#define LPC_CAN1_ICR_ERRBIT4_0_MASK 0x1F0000
#define LPC_CAN1_ICR_ERRBIT4_0_BIT 16
#define LPC_CAN1_ICR_ERRDIR_MASK 0x200000
#define LPC_CAN1_ICR_ERRDIR 0x200000
#define LPC_CAN1_ICR_ERRDIR_BIT 21
#define LPC_CAN1_ICR_ERRC1_0_MASK 0xC00000
#define LPC_CAN1_ICR_ERRC1_0_BIT 22
#define LPC_CAN1_ICR_ALCBIT_MASK 0xFF000000
#define LPC_CAN1_ICR_ALCBIT_BIT 24

#define LPC_CAN1_IER (*(volatile unsigned long *)0x40044010)
#define LPC_CAN1_IER_OFFSET 0x10
#define LPC_CAN1_IER_RIE_MASK 0x1
#define LPC_CAN1_IER_RIE 0x1
#define LPC_CAN1_IER_RIE_BIT 0
#define LPC_CAN1_IER_TIE1_MASK 0x2
#define LPC_CAN1_IER_TIE1 0x2
#define LPC_CAN1_IER_TIE1_BIT 1
#define LPC_CAN1_IER_EIE_MASK 0x4
#define LPC_CAN1_IER_EIE 0x4
#define LPC_CAN1_IER_EIE_BIT 2
#define LPC_CAN1_IER_DOIE_MASK 0x8
#define LPC_CAN1_IER_DOIE 0x8
#define LPC_CAN1_IER_DOIE_BIT 3
#define LPC_CAN1_IER_WUIE_MASK 0x10
#define LPC_CAN1_IER_WUIE 0x10
#define LPC_CAN1_IER_WUIE_BIT 4
#define LPC_CAN1_IER_EPIE_MASK 0x20
#define LPC_CAN1_IER_EPIE 0x20
#define LPC_CAN1_IER_EPIE_BIT 5
#define LPC_CAN1_IER_ALIE_MASK 0x40
#define LPC_CAN1_IER_ALIE 0x40
#define LPC_CAN1_IER_ALIE_BIT 6
#define LPC_CAN1_IER_BEIE_MASK 0x80
#define LPC_CAN1_IER_BEIE 0x80
#define LPC_CAN1_IER_BEIE_BIT 7
#define LPC_CAN1_IER_IDIE_MASK 0x100
#define LPC_CAN1_IER_IDIE 0x100
#define LPC_CAN1_IER_IDIE_BIT 8
#define LPC_CAN1_IER_TIE2_MASK 0x200
#define LPC_CAN1_IER_TIE2 0x200
#define LPC_CAN1_IER_TIE2_BIT 9
#define LPC_CAN1_IER_TIE3_MASK 0x400
#define LPC_CAN1_IER_TIE3 0x400
#define LPC_CAN1_IER_TIE3_BIT 10

#define LPC_CAN1_BTR (*(volatile unsigned long *)0x40044014)
#define LPC_CAN1_BTR_OFFSET 0x14
#define LPC_CAN1_BTR_BRP_MASK 0x3FF
#define LPC_CAN1_BTR_BRP_BIT 0
#define LPC_CAN1_BTR_SJW_MASK 0xC000
#define LPC_CAN1_BTR_SJW_BIT 14
#define LPC_CAN1_BTR_TESG1_MASK 0xF0000
#define LPC_CAN1_BTR_TESG1_BIT 16
#define LPC_CAN1_BTR_TESG2_MASK 0x700000
#define LPC_CAN1_BTR_TESG2_BIT 20
#define LPC_CAN1_BTR_SAM_MASK 0x800000
#define LPC_CAN1_BTR_SAM 0x800000
#define LPC_CAN1_BTR_SAM_BIT 23

#define LPC_CAN1_EWL (*(volatile unsigned long *)0x40044018)
#define LPC_CAN1_EWL_OFFSET 0x18
#define LPC_CAN1_EWL_EWL_MASK 0xFF
#define LPC_CAN1_EWL_EWL_BIT 0

#define LPC_CAN1_SR (*(volatile unsigned long *)0x4004401C)
#define LPC_CAN1_SR_OFFSET 0x1C
#define LPC_CAN1_SR_RBS_1_MASK 0x1
#define LPC_CAN1_SR_RBS_1 0x1
#define LPC_CAN1_SR_RBS_1_BIT 0
#define LPC_CAN1_SR_DOS_1_MASK 0x2
#define LPC_CAN1_SR_DOS_1 0x2
#define LPC_CAN1_SR_DOS_1_BIT 1
#define LPC_CAN1_SR_TBS1_1_MASK 0x4
#define LPC_CAN1_SR_TBS1_1 0x4
#define LPC_CAN1_SR_TBS1_1_BIT 2
#define LPC_CAN1_SR_TCS1_1_MASK 0x8
#define LPC_CAN1_SR_TCS1_1 0x8
#define LPC_CAN1_SR_TCS1_1_BIT 3
#define LPC_CAN1_SR_RS_1_MASK 0x10
#define LPC_CAN1_SR_RS_1 0x10
#define LPC_CAN1_SR_RS_1_BIT 4
#define LPC_CAN1_SR_TS1_1_MASK 0x20
#define LPC_CAN1_SR_TS1_1 0x20
#define LPC_CAN1_SR_TS1_1_BIT 5
#define LPC_CAN1_SR_ES_1_MASK 0x40
#define LPC_CAN1_SR_ES_1 0x40
#define LPC_CAN1_SR_ES_1_BIT 6
#define LPC_CAN1_SR_BS_1_MASK 0x80
#define LPC_CAN1_SR_BS_1 0x80
#define LPC_CAN1_SR_BS_1_BIT 7
#define LPC_CAN1_SR_RBS_2_MASK 0x100
#define LPC_CAN1_SR_RBS_2 0x100
#define LPC_CAN1_SR_RBS_2_BIT 8
#define LPC_CAN1_SR_DOS_2_MASK 0x200
#define LPC_CAN1_SR_DOS_2 0x200
#define LPC_CAN1_SR_DOS_2_BIT 9
#define LPC_CAN1_SR_TBS2_2_MASK 0x400
#define LPC_CAN1_SR_TBS2_2 0x400
#define LPC_CAN1_SR_TBS2_2_BIT 10
#define LPC_CAN1_SR_TCS2_2_MASK 0x800
#define LPC_CAN1_SR_TCS2_2 0x800
#define LPC_CAN1_SR_TCS2_2_BIT 11
#define LPC_CAN1_SR_RS_2_MASK 0x1000
#define LPC_CAN1_SR_RS_2 0x1000
#define LPC_CAN1_SR_RS_2_BIT 12
#define LPC_CAN1_SR_TS2_2_MASK 0x2000
#define LPC_CAN1_SR_TS2_2 0x2000
#define LPC_CAN1_SR_TS2_2_BIT 13
#define LPC_CAN1_SR_ES_2_MASK 0x4000
#define LPC_CAN1_SR_ES_2 0x4000
#define LPC_CAN1_SR_ES_2_BIT 14
#define LPC_CAN1_SR_BS_2_MASK 0x8000
#define LPC_CAN1_SR_BS_2 0x8000
#define LPC_CAN1_SR_BS_2_BIT 15
#define LPC_CAN1_SR_RBS_3_MASK 0x10000
#define LPC_CAN1_SR_RBS_3 0x10000
#define LPC_CAN1_SR_RBS_3_BIT 16
#define LPC_CAN1_SR_DOS_3_MASK 0x20000
#define LPC_CAN1_SR_DOS_3 0x20000
#define LPC_CAN1_SR_DOS_3_BIT 17
#define LPC_CAN1_SR_TBS3_3_MASK 0x40000
#define LPC_CAN1_SR_TBS3_3 0x40000
#define LPC_CAN1_SR_TBS3_3_BIT 18
#define LPC_CAN1_SR_TCS3_3_MASK 0x80000
#define LPC_CAN1_SR_TCS3_3 0x80000
#define LPC_CAN1_SR_TCS3_3_BIT 19
#define LPC_CAN1_SR_RS_3_MASK 0x100000
#define LPC_CAN1_SR_RS_3 0x100000
#define LPC_CAN1_SR_RS_3_BIT 20
#define LPC_CAN1_SR_TS3_3_MASK 0x200000
#define LPC_CAN1_SR_TS3_3 0x200000
#define LPC_CAN1_SR_TS3_3_BIT 21
#define LPC_CAN1_SR_ES_3_MASK 0x400000
#define LPC_CAN1_SR_ES_3 0x400000
#define LPC_CAN1_SR_ES_3_BIT 22
#define LPC_CAN1_SR_BS_3_MASK 0x800000
#define LPC_CAN1_SR_BS_3 0x800000
#define LPC_CAN1_SR_BS_3_BIT 23

#define LPC_CAN1_RFS (*(volatile unsigned long *)0x40044020)
#define LPC_CAN1_RFS_OFFSET 0x20
#define LPC_CAN1_RFS_IDINDEX_MASK 0x3FF
#define LPC_CAN1_RFS_IDINDEX_BIT 0
#define LPC_CAN1_RFS_BP_MASK 0x400
#define LPC_CAN1_RFS_BP 0x400
#define LPC_CAN1_RFS_BP_BIT 10
#define LPC_CAN1_RFS_DLC_MASK 0xF0000
#define LPC_CAN1_RFS_DLC_BIT 16
#define LPC_CAN1_RFS_RTR_MASK 0x40000000
#define LPC_CAN1_RFS_RTR 0x40000000
#define LPC_CAN1_RFS_RTR_BIT 30
#define LPC_CAN1_RFS_FF_MASK 0x80000000
#define LPC_CAN1_RFS_FF 0x80000000
#define LPC_CAN1_RFS_FF_BIT 31

#define LPC_CAN1_RID (*(volatile unsigned long *)0x40044024)
#define LPC_CAN1_RID_OFFSET 0x24
#define LPC_CAN1_RID_ID_MASK 0x7FF
#define LPC_CAN1_RID_ID_BIT 0

#define LPC_CAN1_RDA (*(volatile unsigned long *)0x40044028)
#define LPC_CAN1_RDA_OFFSET 0x28
#define LPC_CAN1_RDA_DATA1_MASK 0xFF
#define LPC_CAN1_RDA_DATA1_BIT 0
#define LPC_CAN1_RDA_DATA2_MASK 0xFF00
#define LPC_CAN1_RDA_DATA2_BIT 8
#define LPC_CAN1_RDA_DATA3_MASK 0xFF0000
#define LPC_CAN1_RDA_DATA3_BIT 16
#define LPC_CAN1_RDA_DATA4_MASK 0xFF000000
#define LPC_CAN1_RDA_DATA4_BIT 24

#define LPC_CAN1_RDB (*(volatile unsigned long *)0x4004402C)
#define LPC_CAN1_RDB_OFFSET 0x2C
#define LPC_CAN1_RDB_DATA5_MASK 0xFF
#define LPC_CAN1_RDB_DATA5_BIT 0
#define LPC_CAN1_RDB_DATA6_MASK 0xFF00
#define LPC_CAN1_RDB_DATA6_BIT 8
#define LPC_CAN1_RDB_DATA7_MASK 0xFF0000
#define LPC_CAN1_RDB_DATA7_BIT 16
#define LPC_CAN1_RDB_DATA8_MASK 0xFF000000
#define LPC_CAN1_RDB_DATA8_BIT 24

#define LPC_CAN1_TFI1 (*(volatile unsigned long *)0x40044030)
#define LPC_CAN1_TFI1_OFFSET 0x30
#define LPC_CAN1_TFI1_PRIO_MASK 0xFF
#define LPC_CAN1_TFI1_PRIO_BIT 0
#define LPC_CAN1_TFI1_DLC_MASK 0xF0000
#define LPC_CAN1_TFI1_DLC_BIT 16
#define LPC_CAN1_TFI1_RTR_MASK 0x40000000
#define LPC_CAN1_TFI1_RTR 0x40000000
#define LPC_CAN1_TFI1_RTR_BIT 30
#define LPC_CAN1_TFI1_FF_MASK 0x80000000
#define LPC_CAN1_TFI1_FF 0x80000000
#define LPC_CAN1_TFI1_FF_BIT 31

#define LPC_CAN1_TFI2 (*(volatile unsigned long *)0x40044040)
#define LPC_CAN1_TFI2_OFFSET 0x40
#define LPC_CAN1_TFI2_PRIO_MASK 0xFF
#define LPC_CAN1_TFI2_PRIO_BIT 0
#define LPC_CAN1_TFI2_DLC_MASK 0xF0000
#define LPC_CAN1_TFI2_DLC_BIT 16
#define LPC_CAN1_TFI2_RTR_MASK 0x40000000
#define LPC_CAN1_TFI2_RTR 0x40000000
#define LPC_CAN1_TFI2_RTR_BIT 30
#define LPC_CAN1_TFI2_FF_MASK 0x80000000
#define LPC_CAN1_TFI2_FF 0x80000000
#define LPC_CAN1_TFI2_FF_BIT 31

#define LPC_CAN1_TFI3 (*(volatile unsigned long *)0x40044050)
#define LPC_CAN1_TFI3_OFFSET 0x50
#define LPC_CAN1_TFI3_PRIO_MASK 0xFF
#define LPC_CAN1_TFI3_PRIO_BIT 0
#define LPC_CAN1_TFI3_DLC_MASK 0xF0000
#define LPC_CAN1_TFI3_DLC_BIT 16
#define LPC_CAN1_TFI3_RTR_MASK 0x40000000
#define LPC_CAN1_TFI3_RTR 0x40000000
#define LPC_CAN1_TFI3_RTR_BIT 30
#define LPC_CAN1_TFI3_FF_MASK 0x80000000
#define LPC_CAN1_TFI3_FF 0x80000000
#define LPC_CAN1_TFI3_FF_BIT 31

#define LPC_CAN1_TID1 (*(volatile unsigned long *)0x40044034)
#define LPC_CAN1_TID1_OFFSET 0x34
#define LPC_CAN1_TID1_ID_MASK 0x7FF
#define LPC_CAN1_TID1_ID_BIT 0

#define LPC_CAN1_TID2 (*(volatile unsigned long *)0x40044044)
#define LPC_CAN1_TID2_OFFSET 0x44
#define LPC_CAN1_TID2_ID_MASK 0x7FF
#define LPC_CAN1_TID2_ID_BIT 0

#define LPC_CAN1_TID3 (*(volatile unsigned long *)0x40044054)
#define LPC_CAN1_TID3_OFFSET 0x54
#define LPC_CAN1_TID3_ID_MASK 0x7FF
#define LPC_CAN1_TID3_ID_BIT 0

#define LPC_CAN1_TDA1 (*(volatile unsigned long *)0x40044038)
#define LPC_CAN1_TDA1_OFFSET 0x38
#define LPC_CAN1_TDA1_DATA1_MASK 0xFF
#define LPC_CAN1_TDA1_DATA1_BIT 0
#define LPC_CAN1_TDA1_DATA2_MASK 0xFF00
#define LPC_CAN1_TDA1_DATA2_BIT 8
#define LPC_CAN1_TDA1_DATA3_MASK 0xFF0000
#define LPC_CAN1_TDA1_DATA3_BIT 16
#define LPC_CAN1_TDA1_DATA4_MASK 0xFF000000
#define LPC_CAN1_TDA1_DATA4_BIT 24

#define LPC_CAN1_TDA2 (*(volatile unsigned long *)0x40044048)
#define LPC_CAN1_TDA2_OFFSET 0x48
#define LPC_CAN1_TDA2_DATA1_MASK 0xFF
#define LPC_CAN1_TDA2_DATA1_BIT 0
#define LPC_CAN1_TDA2_DATA2_MASK 0xFF00
#define LPC_CAN1_TDA2_DATA2_BIT 8
#define LPC_CAN1_TDA2_DATA3_MASK 0xFF0000
#define LPC_CAN1_TDA2_DATA3_BIT 16
#define LPC_CAN1_TDA2_DATA4_MASK 0xFF000000
#define LPC_CAN1_TDA2_DATA4_BIT 24

#define LPC_CAN1_TDA3 (*(volatile unsigned long *)0x40044058)
#define LPC_CAN1_TDA3_OFFSET 0x58
#define LPC_CAN1_TDA3_DATA1_MASK 0xFF
#define LPC_CAN1_TDA3_DATA1_BIT 0
#define LPC_CAN1_TDA3_DATA2_MASK 0xFF00
#define LPC_CAN1_TDA3_DATA2_BIT 8
#define LPC_CAN1_TDA3_DATA3_MASK 0xFF0000
#define LPC_CAN1_TDA3_DATA3_BIT 16
#define LPC_CAN1_TDA3_DATA4_MASK 0xFF000000
#define LPC_CAN1_TDA3_DATA4_BIT 24

#define LPC_CAN1_TDB1 (*(volatile unsigned long *)0x4004403C)
#define LPC_CAN1_TDB1_OFFSET 0x3C
#define LPC_CAN1_TDB1_DATA5_MASK 0xFF
#define LPC_CAN1_TDB1_DATA5_BIT 0
#define LPC_CAN1_TDB1_DATA6_MASK 0xFF00
#define LPC_CAN1_TDB1_DATA6_BIT 8
#define LPC_CAN1_TDB1_DATA7_MASK 0xFF0000
#define LPC_CAN1_TDB1_DATA7_BIT 16
#define LPC_CAN1_TDB1_DATA8_MASK 0xFF000000
#define LPC_CAN1_TDB1_DATA8_BIT 24

#define LPC_CAN1_TDB2 (*(volatile unsigned long *)0x4004404C)
#define LPC_CAN1_TDB2_OFFSET 0x4C
#define LPC_CAN1_TDB2_DATA5_MASK 0xFF
#define LPC_CAN1_TDB2_DATA5_BIT 0
#define LPC_CAN1_TDB2_DATA6_MASK 0xFF00
#define LPC_CAN1_TDB2_DATA6_BIT 8
#define LPC_CAN1_TDB2_DATA7_MASK 0xFF0000
#define LPC_CAN1_TDB2_DATA7_BIT 16
#define LPC_CAN1_TDB2_DATA8_MASK 0xFF000000
#define LPC_CAN1_TDB2_DATA8_BIT 24

#define LPC_CAN1_TDB3 (*(volatile unsigned long *)0x4004405C)
#define LPC_CAN1_TDB3_OFFSET 0x5C
#define LPC_CAN1_TDB3_DATA5_MASK 0xFF
#define LPC_CAN1_TDB3_DATA5_BIT 0
#define LPC_CAN1_TDB3_DATA6_MASK 0xFF00
#define LPC_CAN1_TDB3_DATA6_BIT 8
#define LPC_CAN1_TDB3_DATA7_MASK 0xFF0000
#define LPC_CAN1_TDB3_DATA7_BIT 16
#define LPC_CAN1_TDB3_DATA8_MASK 0xFF000000
#define LPC_CAN1_TDB3_DATA8_BIT 24

#ifndef LPC_CAN2_BASE_ADDRESS
#define LPC_CAN2_BASE_ADDRESS 0x40048000
#endif

#define LPC_CAN2_MOD (*(volatile unsigned long *)0x40048000)
#define LPC_CAN2_MOD_OFFSET 0x0
#define LPC_CAN2_MOD_RM_MASK 0x1
#define LPC_CAN2_MOD_RM 0x1
#define LPC_CAN2_MOD_RM_BIT 0
#define LPC_CAN2_MOD_LOM_MASK 0x2
#define LPC_CAN2_MOD_LOM 0x2
#define LPC_CAN2_MOD_LOM_BIT 1
#define LPC_CAN2_MOD_STM_MASK 0x4
#define LPC_CAN2_MOD_STM 0x4
#define LPC_CAN2_MOD_STM_BIT 2
#define LPC_CAN2_MOD_TPM_MASK 0x8
#define LPC_CAN2_MOD_TPM 0x8
#define LPC_CAN2_MOD_TPM_BIT 3
#define LPC_CAN2_MOD_SM_MASK 0x10
#define LPC_CAN2_MOD_SM 0x10
#define LPC_CAN2_MOD_SM_BIT 4
#define LPC_CAN2_MOD_RPM_MASK 0x20
#define LPC_CAN2_MOD_RPM 0x20
#define LPC_CAN2_MOD_RPM_BIT 5
#define LPC_CAN2_MOD_TM_MASK 0x80
#define LPC_CAN2_MOD_TM 0x80
#define LPC_CAN2_MOD_TM_BIT 7

#define LPC_CAN2_CMR (*(volatile unsigned long *)0x40048004)
#define LPC_CAN2_CMR_OFFSET 0x4
#define LPC_CAN2_CMR_TR_MASK 0x1
#define LPC_CAN2_CMR_TR 0x1
#define LPC_CAN2_CMR_TR_BIT 0
#define LPC_CAN2_CMR_AT_MASK 0x2
#define LPC_CAN2_CMR_AT 0x2
#define LPC_CAN2_CMR_AT_BIT 1
#define LPC_CAN2_CMR_RRB_MASK 0x4
#define LPC_CAN2_CMR_RRB 0x4
#define LPC_CAN2_CMR_RRB_BIT 2
#define LPC_CAN2_CMR_CDO_MASK 0x8
#define LPC_CAN2_CMR_CDO 0x8
#define LPC_CAN2_CMR_CDO_BIT 3
#define LPC_CAN2_CMR_SRR_MASK 0x10
#define LPC_CAN2_CMR_SRR 0x10
#define LPC_CAN2_CMR_SRR_BIT 4
#define LPC_CAN2_CMR_STB1_MASK 0x20
#define LPC_CAN2_CMR_STB1 0x20
#define LPC_CAN2_CMR_STB1_BIT 5
#define LPC_CAN2_CMR_STB2_MASK 0x40
#define LPC_CAN2_CMR_STB2 0x40
#define LPC_CAN2_CMR_STB2_BIT 6
#define LPC_CAN2_CMR_STB3_MASK 0x80
#define LPC_CAN2_CMR_STB3 0x80
#define LPC_CAN2_CMR_STB3_BIT 7

#define LPC_CAN2_GSR (*(volatile unsigned long *)0x40048008)
#define LPC_CAN2_GSR_OFFSET 0x8
#define LPC_CAN2_GSR_RBS_MASK 0x1
#define LPC_CAN2_GSR_RBS 0x1
#define LPC_CAN2_GSR_RBS_BIT 0
#define LPC_CAN2_GSR_DOS_MASK 0x2
#define LPC_CAN2_GSR_DOS 0x2
#define LPC_CAN2_GSR_DOS_BIT 1
#define LPC_CAN2_GSR_TBS_MASK 0x4
#define LPC_CAN2_GSR_TBS 0x4
#define LPC_CAN2_GSR_TBS_BIT 2
#define LPC_CAN2_GSR_TCS_MASK 0x8
#define LPC_CAN2_GSR_TCS 0x8
#define LPC_CAN2_GSR_TCS_BIT 3
#define LPC_CAN2_GSR_RS_MASK 0x10
#define LPC_CAN2_GSR_RS 0x10
#define LPC_CAN2_GSR_RS_BIT 4
#define LPC_CAN2_GSR_TS_MASK 0x20
#define LPC_CAN2_GSR_TS 0x20
#define LPC_CAN2_GSR_TS_BIT 5
#define LPC_CAN2_GSR_ES_MASK 0x40
#define LPC_CAN2_GSR_ES 0x40
#define LPC_CAN2_GSR_ES_BIT 6
#define LPC_CAN2_GSR_BS_MASK 0x80
#define LPC_CAN2_GSR_BS 0x80
#define LPC_CAN2_GSR_BS_BIT 7
#define LPC_CAN2_GSR_RXERR_MASK 0xFF0000
#define LPC_CAN2_GSR_RXERR_BIT 16
#define LPC_CAN2_GSR_TXERR_MASK 0xFF000000
#define LPC_CAN2_GSR_TXERR_BIT 24

#define LPC_CAN2_ICR (*(volatile unsigned long *)0x4004800C)
#define LPC_CAN2_ICR_OFFSET 0xC
#define LPC_CAN2_ICR_RI_MASK 0x1
#define LPC_CAN2_ICR_RI 0x1
#define LPC_CAN2_ICR_RI_BIT 0
#define LPC_CAN2_ICR_TI1_MASK 0x2
#define LPC_CAN2_ICR_TI1 0x2
#define LPC_CAN2_ICR_TI1_BIT 1
#define LPC_CAN2_ICR_EI_MASK 0x4
#define LPC_CAN2_ICR_EI 0x4
#define LPC_CAN2_ICR_EI_BIT 2
#define LPC_CAN2_ICR_DOI_MASK 0x8
#define LPC_CAN2_ICR_DOI 0x8
#define LPC_CAN2_ICR_DOI_BIT 3
#define LPC_CAN2_ICR_WUI_MASK 0x10
#define LPC_CAN2_ICR_WUI 0x10
#define LPC_CAN2_ICR_WUI_BIT 4
#define LPC_CAN2_ICR_EPI_MASK 0x20
#define LPC_CAN2_ICR_EPI 0x20
#define LPC_CAN2_ICR_EPI_BIT 5
#define LPC_CAN2_ICR_ALI_MASK 0x40
#define LPC_CAN2_ICR_ALI 0x40
#define LPC_CAN2_ICR_ALI_BIT 6
#define LPC_CAN2_ICR_BEI_MASK 0x80
#define LPC_CAN2_ICR_BEI 0x80
#define LPC_CAN2_ICR_BEI_BIT 7
#define LPC_CAN2_ICR_IDI_MASK 0x100
#define LPC_CAN2_ICR_IDI 0x100
#define LPC_CAN2_ICR_IDI_BIT 8
#define LPC_CAN2_ICR_TI2_MASK 0x200
#define LPC_CAN2_ICR_TI2 0x200
#define LPC_CAN2_ICR_TI2_BIT 9
#define LPC_CAN2_ICR_TI3_MASK 0x400
#define LPC_CAN2_ICR_TI3 0x400
#define LPC_CAN2_ICR_TI3_BIT 10
#define LPC_CAN2_ICR_ERRBIT4_0_MASK 0x1F0000
#define LPC_CAN2_ICR_ERRBIT4_0_BIT 16
#define LPC_CAN2_ICR_ERRDIR_MASK 0x200000
#define LPC_CAN2_ICR_ERRDIR 0x200000
#define LPC_CAN2_ICR_ERRDIR_BIT 21
#define LPC_CAN2_ICR_ERRC1_0_MASK 0xC00000
#define LPC_CAN2_ICR_ERRC1_0_BIT 22
#define LPC_CAN2_ICR_ALCBIT_MASK 0xFF000000
#define LPC_CAN2_ICR_ALCBIT_BIT 24

#define LPC_CAN2_IER (*(volatile unsigned long *)0x40048010)
#define LPC_CAN2_IER_OFFSET 0x10
#define LPC_CAN2_IER_RIE_MASK 0x1
#define LPC_CAN2_IER_RIE 0x1
#define LPC_CAN2_IER_RIE_BIT 0
#define LPC_CAN2_IER_TIE1_MASK 0x2
#define LPC_CAN2_IER_TIE1 0x2
#define LPC_CAN2_IER_TIE1_BIT 1
#define LPC_CAN2_IER_EIE_MASK 0x4
#define LPC_CAN2_IER_EIE 0x4
#define LPC_CAN2_IER_EIE_BIT 2
#define LPC_CAN2_IER_DOIE_MASK 0x8
#define LPC_CAN2_IER_DOIE 0x8
#define LPC_CAN2_IER_DOIE_BIT 3
#define LPC_CAN2_IER_WUIE_MASK 0x10
#define LPC_CAN2_IER_WUIE 0x10
#define LPC_CAN2_IER_WUIE_BIT 4
#define LPC_CAN2_IER_EPIE_MASK 0x20
#define LPC_CAN2_IER_EPIE 0x20
#define LPC_CAN2_IER_EPIE_BIT 5
#define LPC_CAN2_IER_ALIE_MASK 0x40
#define LPC_CAN2_IER_ALIE 0x40
#define LPC_CAN2_IER_ALIE_BIT 6
#define LPC_CAN2_IER_BEIE_MASK 0x80
#define LPC_CAN2_IER_BEIE 0x80
#define LPC_CAN2_IER_BEIE_BIT 7
#define LPC_CAN2_IER_IDIE_MASK 0x100
#define LPC_CAN2_IER_IDIE 0x100
#define LPC_CAN2_IER_IDIE_BIT 8
#define LPC_CAN2_IER_TIE2_MASK 0x200
#define LPC_CAN2_IER_TIE2 0x200
#define LPC_CAN2_IER_TIE2_BIT 9
#define LPC_CAN2_IER_TIE3_MASK 0x400
#define LPC_CAN2_IER_TIE3 0x400
#define LPC_CAN2_IER_TIE3_BIT 10

#define LPC_CAN2_BTR (*(volatile unsigned long *)0x40048014)
#define LPC_CAN2_BTR_OFFSET 0x14
#define LPC_CAN2_BTR_BRP_MASK 0x3FF
#define LPC_CAN2_BTR_BRP_BIT 0
#define LPC_CAN2_BTR_SJW_MASK 0xC000
#define LPC_CAN2_BTR_SJW_BIT 14
#define LPC_CAN2_BTR_TESG1_MASK 0xF0000
#define LPC_CAN2_BTR_TESG1_BIT 16
#define LPC_CAN2_BTR_TESG2_MASK 0x700000
#define LPC_CAN2_BTR_TESG2_BIT 20
#define LPC_CAN2_BTR_SAM_MASK 0x800000
#define LPC_CAN2_BTR_SAM 0x800000
#define LPC_CAN2_BTR_SAM_BIT 23

#define LPC_CAN2_EWL (*(volatile unsigned long *)0x40048018)
#define LPC_CAN2_EWL_OFFSET 0x18
#define LPC_CAN2_EWL_EWL_MASK 0xFF
#define LPC_CAN2_EWL_EWL_BIT 0

#define LPC_CAN2_SR (*(volatile unsigned long *)0x4004801C)
#define LPC_CAN2_SR_OFFSET 0x1C
#define LPC_CAN2_SR_RBS_1_MASK 0x1
#define LPC_CAN2_SR_RBS_1 0x1
#define LPC_CAN2_SR_RBS_1_BIT 0
#define LPC_CAN2_SR_DOS_1_MASK 0x2
#define LPC_CAN2_SR_DOS_1 0x2
#define LPC_CAN2_SR_DOS_1_BIT 1
#define LPC_CAN2_SR_TBS1_1_MASK 0x4
#define LPC_CAN2_SR_TBS1_1 0x4
#define LPC_CAN2_SR_TBS1_1_BIT 2
#define LPC_CAN2_SR_TCS1_1_MASK 0x8
#define LPC_CAN2_SR_TCS1_1 0x8
#define LPC_CAN2_SR_TCS1_1_BIT 3
#define LPC_CAN2_SR_RS_1_MASK 0x10
#define LPC_CAN2_SR_RS_1 0x10
#define LPC_CAN2_SR_RS_1_BIT 4
#define LPC_CAN2_SR_TS1_1_MASK 0x20
#define LPC_CAN2_SR_TS1_1 0x20
#define LPC_CAN2_SR_TS1_1_BIT 5
#define LPC_CAN2_SR_ES_1_MASK 0x40
#define LPC_CAN2_SR_ES_1 0x40
#define LPC_CAN2_SR_ES_1_BIT 6
#define LPC_CAN2_SR_BS_1_MASK 0x80
#define LPC_CAN2_SR_BS_1 0x80
#define LPC_CAN2_SR_BS_1_BIT 7
#define LPC_CAN2_SR_RBS_2_MASK 0x100
#define LPC_CAN2_SR_RBS_2 0x100
#define LPC_CAN2_SR_RBS_2_BIT 8
#define LPC_CAN2_SR_DOS_2_MASK 0x200
#define LPC_CAN2_SR_DOS_2 0x200
#define LPC_CAN2_SR_DOS_2_BIT 9
#define LPC_CAN2_SR_TBS2_2_MASK 0x400
#define LPC_CAN2_SR_TBS2_2 0x400
#define LPC_CAN2_SR_TBS2_2_BIT 10
#define LPC_CAN2_SR_TCS2_2_MASK 0x800
#define LPC_CAN2_SR_TCS2_2 0x800
#define LPC_CAN2_SR_TCS2_2_BIT 11
#define LPC_CAN2_SR_RS_2_MASK 0x1000
#define LPC_CAN2_SR_RS_2 0x1000
#define LPC_CAN2_SR_RS_2_BIT 12
#define LPC_CAN2_SR_TS2_2_MASK 0x2000
#define LPC_CAN2_SR_TS2_2 0x2000
#define LPC_CAN2_SR_TS2_2_BIT 13
#define LPC_CAN2_SR_ES_2_MASK 0x4000
#define LPC_CAN2_SR_ES_2 0x4000
#define LPC_CAN2_SR_ES_2_BIT 14
#define LPC_CAN2_SR_BS_2_MASK 0x8000
#define LPC_CAN2_SR_BS_2 0x8000
#define LPC_CAN2_SR_BS_2_BIT 15
#define LPC_CAN2_SR_RBS_3_MASK 0x10000
#define LPC_CAN2_SR_RBS_3 0x10000
#define LPC_CAN2_SR_RBS_3_BIT 16
#define LPC_CAN2_SR_DOS_3_MASK 0x20000
#define LPC_CAN2_SR_DOS_3 0x20000
#define LPC_CAN2_SR_DOS_3_BIT 17
#define LPC_CAN2_SR_TBS3_3_MASK 0x40000
#define LPC_CAN2_SR_TBS3_3 0x40000
#define LPC_CAN2_SR_TBS3_3_BIT 18
#define LPC_CAN2_SR_TCS3_3_MASK 0x80000
#define LPC_CAN2_SR_TCS3_3 0x80000
#define LPC_CAN2_SR_TCS3_3_BIT 19
#define LPC_CAN2_SR_RS_3_MASK 0x100000
#define LPC_CAN2_SR_RS_3 0x100000
#define LPC_CAN2_SR_RS_3_BIT 20
#define LPC_CAN2_SR_TS3_3_MASK 0x200000
#define LPC_CAN2_SR_TS3_3 0x200000
#define LPC_CAN2_SR_TS3_3_BIT 21
#define LPC_CAN2_SR_ES_3_MASK 0x400000
#define LPC_CAN2_SR_ES_3 0x400000
#define LPC_CAN2_SR_ES_3_BIT 22
#define LPC_CAN2_SR_BS_3_MASK 0x800000
#define LPC_CAN2_SR_BS_3 0x800000
#define LPC_CAN2_SR_BS_3_BIT 23

#define LPC_CAN2_RFS (*(volatile unsigned long *)0x40048020)
#define LPC_CAN2_RFS_OFFSET 0x20
#define LPC_CAN2_RFS_IDINDEX_MASK 0x3FF
#define LPC_CAN2_RFS_IDINDEX_BIT 0
#define LPC_CAN2_RFS_BP_MASK 0x400
#define LPC_CAN2_RFS_BP 0x400
#define LPC_CAN2_RFS_BP_BIT 10
#define LPC_CAN2_RFS_DLC_MASK 0xF0000
#define LPC_CAN2_RFS_DLC_BIT 16
#define LPC_CAN2_RFS_RTR_MASK 0x40000000
#define LPC_CAN2_RFS_RTR 0x40000000
#define LPC_CAN2_RFS_RTR_BIT 30
#define LPC_CAN2_RFS_FF_MASK 0x80000000
#define LPC_CAN2_RFS_FF 0x80000000
#define LPC_CAN2_RFS_FF_BIT 31

#define LPC_CAN2_RID (*(volatile unsigned long *)0x40048024)
#define LPC_CAN2_RID_OFFSET 0x24
#define LPC_CAN2_RID_ID_MASK 0x7FF
#define LPC_CAN2_RID_ID_BIT 0

#define LPC_CAN2_RDA (*(volatile unsigned long *)0x40048028)
#define LPC_CAN2_RDA_OFFSET 0x28
#define LPC_CAN2_RDA_DATA1_MASK 0xFF
#define LPC_CAN2_RDA_DATA1_BIT 0
#define LPC_CAN2_RDA_DATA2_MASK 0xFF00
#define LPC_CAN2_RDA_DATA2_BIT 8
#define LPC_CAN2_RDA_DATA3_MASK 0xFF0000
#define LPC_CAN2_RDA_DATA3_BIT 16
#define LPC_CAN2_RDA_DATA4_MASK 0xFF000000
#define LPC_CAN2_RDA_DATA4_BIT 24

#define LPC_CAN2_RDB (*(volatile unsigned long *)0x4004802C)
#define LPC_CAN2_RDB_OFFSET 0x2C
#define LPC_CAN2_RDB_DATA5_MASK 0xFF
#define LPC_CAN2_RDB_DATA5_BIT 0
#define LPC_CAN2_RDB_DATA6_MASK 0xFF00
#define LPC_CAN2_RDB_DATA6_BIT 8
#define LPC_CAN2_RDB_DATA7_MASK 0xFF0000
#define LPC_CAN2_RDB_DATA7_BIT 16
#define LPC_CAN2_RDB_DATA8_MASK 0xFF000000
#define LPC_CAN2_RDB_DATA8_BIT 24

#define LPC_CAN2_TFI1 (*(volatile unsigned long *)0x40048030)
#define LPC_CAN2_TFI1_OFFSET 0x30
#define LPC_CAN2_TFI1_PRIO_MASK 0xFF
#define LPC_CAN2_TFI1_PRIO_BIT 0
#define LPC_CAN2_TFI1_DLC_MASK 0xF0000
#define LPC_CAN2_TFI1_DLC_BIT 16
#define LPC_CAN2_TFI1_RTR_MASK 0x40000000
#define LPC_CAN2_TFI1_RTR 0x40000000
#define LPC_CAN2_TFI1_RTR_BIT 30
#define LPC_CAN2_TFI1_FF_MASK 0x80000000
#define LPC_CAN2_TFI1_FF 0x80000000
#define LPC_CAN2_TFI1_FF_BIT 31

#define LPC_CAN2_TFI2 (*(volatile unsigned long *)0x40048040)
#define LPC_CAN2_TFI2_OFFSET 0x40
#define LPC_CAN2_TFI2_PRIO_MASK 0xFF
#define LPC_CAN2_TFI2_PRIO_BIT 0
#define LPC_CAN2_TFI2_DLC_MASK 0xF0000
#define LPC_CAN2_TFI2_DLC_BIT 16
#define LPC_CAN2_TFI2_RTR_MASK 0x40000000
#define LPC_CAN2_TFI2_RTR 0x40000000
#define LPC_CAN2_TFI2_RTR_BIT 30
#define LPC_CAN2_TFI2_FF_MASK 0x80000000
#define LPC_CAN2_TFI2_FF 0x80000000
#define LPC_CAN2_TFI2_FF_BIT 31

#define LPC_CAN2_TFI3 (*(volatile unsigned long *)0x40048050)
#define LPC_CAN2_TFI3_OFFSET 0x50
#define LPC_CAN2_TFI3_PRIO_MASK 0xFF
#define LPC_CAN2_TFI3_PRIO_BIT 0
#define LPC_CAN2_TFI3_DLC_MASK 0xF0000
#define LPC_CAN2_TFI3_DLC_BIT 16
#define LPC_CAN2_TFI3_RTR_MASK 0x40000000
#define LPC_CAN2_TFI3_RTR 0x40000000
#define LPC_CAN2_TFI3_RTR_BIT 30
#define LPC_CAN2_TFI3_FF_MASK 0x80000000
#define LPC_CAN2_TFI3_FF 0x80000000
#define LPC_CAN2_TFI3_FF_BIT 31

#define LPC_CAN2_TID1 (*(volatile unsigned long *)0x40048034)
#define LPC_CAN2_TID1_OFFSET 0x34
#define LPC_CAN2_TID1_ID_MASK 0x7FF
#define LPC_CAN2_TID1_ID_BIT 0

#define LPC_CAN2_TID2 (*(volatile unsigned long *)0x40048044)
#define LPC_CAN2_TID2_OFFSET 0x44
#define LPC_CAN2_TID2_ID_MASK 0x7FF
#define LPC_CAN2_TID2_ID_BIT 0

#define LPC_CAN2_TID3 (*(volatile unsigned long *)0x40048054)
#define LPC_CAN2_TID3_OFFSET 0x54
#define LPC_CAN2_TID3_ID_MASK 0x7FF
#define LPC_CAN2_TID3_ID_BIT 0

#define LPC_CAN2_TDA1 (*(volatile unsigned long *)0x40048038)
#define LPC_CAN2_TDA1_OFFSET 0x38
#define LPC_CAN2_TDA1_DATA1_MASK 0xFF
#define LPC_CAN2_TDA1_DATA1_BIT 0
#define LPC_CAN2_TDA1_DATA2_MASK 0xFF00
#define LPC_CAN2_TDA1_DATA2_BIT 8
#define LPC_CAN2_TDA1_DATA3_MASK 0xFF0000
#define LPC_CAN2_TDA1_DATA3_BIT 16
#define LPC_CAN2_TDA1_DATA4_MASK 0xFF000000
#define LPC_CAN2_TDA1_DATA4_BIT 24

#define LPC_CAN2_TDA2 (*(volatile unsigned long *)0x40048048)
#define LPC_CAN2_TDA2_OFFSET 0x48
#define LPC_CAN2_TDA2_DATA1_MASK 0xFF
#define LPC_CAN2_TDA2_DATA1_BIT 0
#define LPC_CAN2_TDA2_DATA2_MASK 0xFF00
#define LPC_CAN2_TDA2_DATA2_BIT 8
#define LPC_CAN2_TDA2_DATA3_MASK 0xFF0000
#define LPC_CAN2_TDA2_DATA3_BIT 16
#define LPC_CAN2_TDA2_DATA4_MASK 0xFF000000
#define LPC_CAN2_TDA2_DATA4_BIT 24

#define LPC_CAN2_TDA3 (*(volatile unsigned long *)0x40048058)
#define LPC_CAN2_TDA3_OFFSET 0x58
#define LPC_CAN2_TDA3_DATA1_MASK 0xFF
#define LPC_CAN2_TDA3_DATA1_BIT 0
#define LPC_CAN2_TDA3_DATA2_MASK 0xFF00
#define LPC_CAN2_TDA3_DATA2_BIT 8
#define LPC_CAN2_TDA3_DATA3_MASK 0xFF0000
#define LPC_CAN2_TDA3_DATA3_BIT 16
#define LPC_CAN2_TDA3_DATA4_MASK 0xFF000000
#define LPC_CAN2_TDA3_DATA4_BIT 24

#define LPC_CAN2_TDB1 (*(volatile unsigned long *)0x4004803C)
#define LPC_CAN2_TDB1_OFFSET 0x3C
#define LPC_CAN2_TDB1_DATA5_MASK 0xFF
#define LPC_CAN2_TDB1_DATA5_BIT 0
#define LPC_CAN2_TDB1_DATA6_MASK 0xFF00
#define LPC_CAN2_TDB1_DATA6_BIT 8
#define LPC_CAN2_TDB1_DATA7_MASK 0xFF0000
#define LPC_CAN2_TDB1_DATA7_BIT 16
#define LPC_CAN2_TDB1_DATA8_MASK 0xFF000000
#define LPC_CAN2_TDB1_DATA8_BIT 24

#define LPC_CAN2_TDB2 (*(volatile unsigned long *)0x4004804C)
#define LPC_CAN2_TDB2_OFFSET 0x4C
#define LPC_CAN2_TDB2_DATA5_MASK 0xFF
#define LPC_CAN2_TDB2_DATA5_BIT 0
#define LPC_CAN2_TDB2_DATA6_MASK 0xFF00
#define LPC_CAN2_TDB2_DATA6_BIT 8
#define LPC_CAN2_TDB2_DATA7_MASK 0xFF0000
#define LPC_CAN2_TDB2_DATA7_BIT 16
#define LPC_CAN2_TDB2_DATA8_MASK 0xFF000000
#define LPC_CAN2_TDB2_DATA8_BIT 24

#define LPC_CAN2_TDB3 (*(volatile unsigned long *)0x4004805C)
#define LPC_CAN2_TDB3_OFFSET 0x5C
#define LPC_CAN2_TDB3_DATA5_MASK 0xFF
#define LPC_CAN2_TDB3_DATA5_BIT 0
#define LPC_CAN2_TDB3_DATA6_MASK 0xFF00
#define LPC_CAN2_TDB3_DATA6_BIT 8
#define LPC_CAN2_TDB3_DATA7_MASK 0xFF0000
#define LPC_CAN2_TDB3_DATA7_BIT 16
#define LPC_CAN2_TDB3_DATA8_MASK 0xFF000000
#define LPC_CAN2_TDB3_DATA8_BIT 24

#ifndef LPC_I2C1_BASE_ADDRESS
#define LPC_I2C1_BASE_ADDRESS 0x4005C000
#endif

#define LPC_I2C1_CONSET (*(volatile unsigned long *)0x4005C000)
#define LPC_I2C1_CONSET_OFFSET 0x0
#define LPC_I2C1_CONSET_AA_MASK 0x4
#define LPC_I2C1_CONSET_AA 0x4
#define LPC_I2C1_CONSET_AA_BIT 2
#define LPC_I2C1_CONSET_SI_MASK 0x8
#define LPC_I2C1_CONSET_SI 0x8
#define LPC_I2C1_CONSET_SI_BIT 3
#define LPC_I2C1_CONSET_STO_MASK 0x10
#define LPC_I2C1_CONSET_STO 0x10
#define LPC_I2C1_CONSET_STO_BIT 4
#define LPC_I2C1_CONSET_STA_MASK 0x20
#define LPC_I2C1_CONSET_STA 0x20
#define LPC_I2C1_CONSET_STA_BIT 5
#define LPC_I2C1_CONSET_I2EN_MASK 0x40
#define LPC_I2C1_CONSET_I2EN 0x40
#define LPC_I2C1_CONSET_I2EN_BIT 6

#define LPC_I2C1_STAT (*(volatile unsigned long *)0x4005C004)
#define LPC_I2C1_STAT_OFFSET 0x4
#define LPC_I2C1_STAT_Status_MASK 0xF8
#define LPC_I2C1_STAT_Status_BIT 3

#define LPC_I2C1_DAT (*(volatile unsigned long *)0x4005C008)
#define LPC_I2C1_DAT_OFFSET 0x8
#define LPC_I2C1_DAT_Data_MASK 0xFF
#define LPC_I2C1_DAT_Data_BIT 0

#define LPC_I2C1_ADR0 (*(volatile unsigned long *)0x4005C00C)
#define LPC_I2C1_ADR0_OFFSET 0xC
#define LPC_I2C1_ADR0_GC_MASK 0x1
#define LPC_I2C1_ADR0_GC 0x1
#define LPC_I2C1_ADR0_GC_BIT 0
#define LPC_I2C1_ADR0_Address_MASK 0xFE
#define LPC_I2C1_ADR0_Address_BIT 1

#define LPC_I2C1_SCLH (*(volatile unsigned long *)0x4005C010)
#define LPC_I2C1_SCLH_OFFSET 0x10
#define LPC_I2C1_SCLH_SCLH_MASK 0xFFFF
#define LPC_I2C1_SCLH_SCLH_BIT 0

#define LPC_I2C1_SCLL (*(volatile unsigned long *)0x4005C014)
#define LPC_I2C1_SCLL_OFFSET 0x14
#define LPC_I2C1_SCLL_SCLL_MASK 0xFFFF
#define LPC_I2C1_SCLL_SCLL_BIT 0

#define LPC_I2C1_CONCLR (*(volatile unsigned long *)0x4005C018)
#define LPC_I2C1_CONCLR_OFFSET 0x18
#define LPC_I2C1_CONCLR_AAC_MASK 0x4
#define LPC_I2C1_CONCLR_AAC 0x4
#define LPC_I2C1_CONCLR_AAC_BIT 2
#define LPC_I2C1_CONCLR_SIC_MASK 0x8
#define LPC_I2C1_CONCLR_SIC 0x8
#define LPC_I2C1_CONCLR_SIC_BIT 3
#define LPC_I2C1_CONCLR_STAC_MASK 0x20
#define LPC_I2C1_CONCLR_STAC 0x20
#define LPC_I2C1_CONCLR_STAC_BIT 5
#define LPC_I2C1_CONCLR_I2ENC_MASK 0x40
#define LPC_I2C1_CONCLR_I2ENC 0x40
#define LPC_I2C1_CONCLR_I2ENC_BIT 6

#define LPC_I2C1_MMCTRL (*(volatile unsigned long *)0x4005C01C)
#define LPC_I2C1_MMCTRL_OFFSET 0x1C
#define LPC_I2C1_MMCTRL_MM_ENA_MASK 0x1
#define LPC_I2C1_MMCTRL_MM_ENA 0x1
#define LPC_I2C1_MMCTRL_MM_ENA_BIT 0
#define LPC_I2C1_MMCTRL_ENA_SCL_MASK 0x2
#define LPC_I2C1_MMCTRL_ENA_SCL 0x2
#define LPC_I2C1_MMCTRL_ENA_SCL_BIT 1
#define LPC_I2C1_MMCTRL_MATCH_ALL_MASK 0x4
#define LPC_I2C1_MMCTRL_MATCH_ALL 0x4
#define LPC_I2C1_MMCTRL_MATCH_ALL_BIT 2

#define LPC_I2C1_ADR1 (*(volatile unsigned long *)0x4005C020)
#define LPC_I2C1_ADR1_OFFSET 0x20
#define LPC_I2C1_ADR1_GC_MASK 0x1
#define LPC_I2C1_ADR1_GC 0x1
#define LPC_I2C1_ADR1_GC_BIT 0
#define LPC_I2C1_ADR1_Address_MASK 0xFE
#define LPC_I2C1_ADR1_Address_BIT 1

#define LPC_I2C1_ADR2 (*(volatile unsigned long *)0x4005C024)
#define LPC_I2C1_ADR2_OFFSET 0x24
#define LPC_I2C1_ADR2_GC_MASK 0x1
#define LPC_I2C1_ADR2_GC 0x1
#define LPC_I2C1_ADR2_GC_BIT 0
#define LPC_I2C1_ADR2_Address_MASK 0xFE
#define LPC_I2C1_ADR2_Address_BIT 1

#define LPC_I2C1_ADR3 (*(volatile unsigned long *)0x4005C028)
#define LPC_I2C1_ADR3_OFFSET 0x28
#define LPC_I2C1_ADR3_GC_MASK 0x1
#define LPC_I2C1_ADR3_GC 0x1
#define LPC_I2C1_ADR3_GC_BIT 0
#define LPC_I2C1_ADR3_Address_MASK 0xFE
#define LPC_I2C1_ADR3_Address_BIT 1

#define LPC_I2C1_DATA_BUFFER (*(volatile unsigned long *)0x4005C02C)
#define LPC_I2C1_DATA_BUFFER_OFFSET 0x2C
#define LPC_I2C1_DATA_BUFFER_Data_MASK 0xFF
#define LPC_I2C1_DATA_BUFFER_Data_BIT 0

#define LPC_I2C1_MASK0 (*(volatile unsigned long *)0x4005C030)
#define LPC_I2C1_MASK0_OFFSET 0x30
#define LPC_I2C1_MASK0_MASK_MASK 0xFE
#define LPC_I2C1_MASK0_MASK_BIT 1

#define LPC_I2C1_MASK1 (*(volatile unsigned long *)0x4005C034)
#define LPC_I2C1_MASK1_OFFSET 0x34
#define LPC_I2C1_MASK1_MASK_MASK 0xFE
#define LPC_I2C1_MASK1_MASK_BIT 1

#define LPC_I2C1_MASK2 (*(volatile unsigned long *)0x4005C038)
#define LPC_I2C1_MASK2_OFFSET 0x38
#define LPC_I2C1_MASK2_MASK_MASK 0xFE
#define LPC_I2C1_MASK2_MASK_BIT 1

#define LPC_I2C1_MASK3 (*(volatile unsigned long *)0x4005C03C)
#define LPC_I2C1_MASK3_OFFSET 0x3C
#define LPC_I2C1_MASK3_MASK_MASK 0xFE
#define LPC_I2C1_MASK3_MASK_BIT 1

#ifndef LPC_SSP0_BASE_ADDRESS
#define LPC_SSP0_BASE_ADDRESS 0x40088000
#endif

#define LPC_SSP0_CR0 (*(volatile unsigned long *)0x40088000)
#define LPC_SSP0_CR0_OFFSET 0x0
#define LPC_SSP0_CR0_DSS_MASK 0xF
#define LPC_SSP0_CR0_DSS_BIT 0
#define LPC_SSP0_CR0_FRF_MASK 0x30
#define LPC_SSP0_CR0_FRF_BIT 4
#define LPC_SSP0_CR0_CPOL_MASK 0x40
#define LPC_SSP0_CR0_CPOL 0x40
#define LPC_SSP0_CR0_CPOL_BIT 6
#define LPC_SSP0_CR0_CPHA_MASK 0x80
#define LPC_SSP0_CR0_CPHA 0x80
#define LPC_SSP0_CR0_CPHA_BIT 7
#define LPC_SSP0_CR0_SCR_MASK 0xFF00
#define LPC_SSP0_CR0_SCR_BIT 8

#define LPC_SSP0_CR1 (*(volatile unsigned long *)0x40088004)
#define LPC_SSP0_CR1_OFFSET 0x4
#define LPC_SSP0_CR1_LBM_MASK 0x1
#define LPC_SSP0_CR1_LBM 0x1
#define LPC_SSP0_CR1_LBM_BIT 0
#define LPC_SSP0_CR1_SSE_MASK 0x2
#define LPC_SSP0_CR1_SSE 0x2
#define LPC_SSP0_CR1_SSE_BIT 1
#define LPC_SSP0_CR1_MS_MASK 0x4
#define LPC_SSP0_CR1_MS 0x4
#define LPC_SSP0_CR1_MS_BIT 2
#define LPC_SSP0_CR1_SOD_MASK 0x8
#define LPC_SSP0_CR1_SOD 0x8
#define LPC_SSP0_CR1_SOD_BIT 3

#define LPC_SSP0_DR (*(volatile unsigned long *)0x40088008)
#define LPC_SSP0_DR_OFFSET 0x8
#define LPC_SSP0_DR_DATA_MASK 0xFFFF
#define LPC_SSP0_DR_DATA_BIT 0

#define LPC_SSP0_SR (*(volatile unsigned long *)0x4008800C)
#define LPC_SSP0_SR_OFFSET 0xC
#define LPC_SSP0_SR_TFE_MASK 0x1
#define LPC_SSP0_SR_TFE 0x1
#define LPC_SSP0_SR_TFE_BIT 0
#define LPC_SSP0_SR_TNF_MASK 0x2
#define LPC_SSP0_SR_TNF 0x2
#define LPC_SSP0_SR_TNF_BIT 1
#define LPC_SSP0_SR_RNE_MASK 0x4
#define LPC_SSP0_SR_RNE 0x4
#define LPC_SSP0_SR_RNE_BIT 2
#define LPC_SSP0_SR_RFF_MASK 0x8
#define LPC_SSP0_SR_RFF 0x8
#define LPC_SSP0_SR_RFF_BIT 3
#define LPC_SSP0_SR_BSY_MASK 0x10
#define LPC_SSP0_SR_BSY 0x10
#define LPC_SSP0_SR_BSY_BIT 4

#define LPC_SSP0_CPSR (*(volatile unsigned long *)0x40088010)
#define LPC_SSP0_CPSR_OFFSET 0x10
#define LPC_SSP0_CPSR_CPSDVSR_MASK 0xFF
#define LPC_SSP0_CPSR_CPSDVSR_BIT 0

#define LPC_SSP0_IMSC (*(volatile unsigned long *)0x40088014)
#define LPC_SSP0_IMSC_OFFSET 0x14
#define LPC_SSP0_IMSC_RORIM_MASK 0x1
#define LPC_SSP0_IMSC_RORIM 0x1
#define LPC_SSP0_IMSC_RORIM_BIT 0
#define LPC_SSP0_IMSC_RTIM_MASK 0x2
#define LPC_SSP0_IMSC_RTIM 0x2
#define LPC_SSP0_IMSC_RTIM_BIT 1
#define LPC_SSP0_IMSC_RXIM_MASK 0x4
#define LPC_SSP0_IMSC_RXIM 0x4
#define LPC_SSP0_IMSC_RXIM_BIT 2
#define LPC_SSP0_IMSC_TXIM_MASK 0x8
#define LPC_SSP0_IMSC_TXIM 0x8
#define LPC_SSP0_IMSC_TXIM_BIT 3

#define LPC_SSP0_RIS (*(volatile unsigned long *)0x40088018)
#define LPC_SSP0_RIS_OFFSET 0x18
#define LPC_SSP0_RIS_RORRIS_MASK 0x1
#define LPC_SSP0_RIS_RORRIS 0x1
#define LPC_SSP0_RIS_RORRIS_BIT 0
#define LPC_SSP0_RIS_RTRIS_MASK 0x2
#define LPC_SSP0_RIS_RTRIS 0x2
#define LPC_SSP0_RIS_RTRIS_BIT 1
#define LPC_SSP0_RIS_RXRIS_MASK 0x4
#define LPC_SSP0_RIS_RXRIS 0x4
#define LPC_SSP0_RIS_RXRIS_BIT 2
#define LPC_SSP0_RIS_TXRIS_MASK 0x8
#define LPC_SSP0_RIS_TXRIS 0x8
#define LPC_SSP0_RIS_TXRIS_BIT 3

#define LPC_SSP0_MIS (*(volatile unsigned long *)0x4008801C)
#define LPC_SSP0_MIS_OFFSET 0x1C
#define LPC_SSP0_MIS_RORMIS_MASK 0x1
#define LPC_SSP0_MIS_RORMIS 0x1
#define LPC_SSP0_MIS_RORMIS_BIT 0
#define LPC_SSP0_MIS_RTMIS_MASK 0x2
#define LPC_SSP0_MIS_RTMIS 0x2
#define LPC_SSP0_MIS_RTMIS_BIT 1
#define LPC_SSP0_MIS_RXMIS_MASK 0x4
#define LPC_SSP0_MIS_RXMIS 0x4
#define LPC_SSP0_MIS_RXMIS_BIT 2
#define LPC_SSP0_MIS_TXMIS_MASK 0x8
#define LPC_SSP0_MIS_TXMIS 0x8
#define LPC_SSP0_MIS_TXMIS_BIT 3

#define LPC_SSP0_ICR (*(volatile unsigned long *)0x40088020)
#define LPC_SSP0_ICR_OFFSET 0x20
#define LPC_SSP0_ICR_RORIC_MASK 0x1
#define LPC_SSP0_ICR_RORIC 0x1
#define LPC_SSP0_ICR_RORIC_BIT 0
#define LPC_SSP0_ICR_RTIC_MASK 0x2
#define LPC_SSP0_ICR_RTIC 0x2
#define LPC_SSP0_ICR_RTIC_BIT 1

#define LPC_SSP0_DMACR (*(volatile unsigned long *)0x40088024)
#define LPC_SSP0_DMACR_OFFSET 0x24
#define LPC_SSP0_DMACR_RXDMAE_MASK 0x1
#define LPC_SSP0_DMACR_RXDMAE 0x1
#define LPC_SSP0_DMACR_RXDMAE_BIT 0
#define LPC_SSP0_DMACR_TXDMAE_MASK 0x2
#define LPC_SSP0_DMACR_TXDMAE 0x2
#define LPC_SSP0_DMACR_TXDMAE_BIT 1

#ifndef LPC_DAC_BASE_ADDRESS
#define LPC_DAC_BASE_ADDRESS 0x4008C000
#endif

#define LPC_DAC_CR (*(volatile unsigned long *)0x4008C000)
#define LPC_DAC_CR_OFFSET 0x0
#define LPC_DAC_CR_VALUE_MASK 0xFFC0
#define LPC_DAC_CR_VALUE_BIT 6
#define LPC_DAC_CR_BIAS_MASK 0x10000
#define LPC_DAC_CR_BIAS 0x10000
#define LPC_DAC_CR_BIAS_BIT 16

#define LPC_DAC_CTRL (*(volatile unsigned long *)0x4008C004)
#define LPC_DAC_CTRL_OFFSET 0x4
#define LPC_DAC_CTRL_INT_DMA_REQ_MASK 0x1
#define LPC_DAC_CTRL_INT_DMA_REQ 0x1
#define LPC_DAC_CTRL_INT_DMA_REQ_BIT 0
#define LPC_DAC_CTRL_DBLBUF_ENA_MASK 0x2
#define LPC_DAC_CTRL_DBLBUF_ENA 0x2
#define LPC_DAC_CTRL_DBLBUF_ENA_BIT 1
#define LPC_DAC_CTRL_CNT_ENA_MASK 0x4
#define LPC_DAC_CTRL_CNT_ENA 0x4
#define LPC_DAC_CTRL_CNT_ENA_BIT 2
#define LPC_DAC_CTRL_DMA_ENA_MASK 0x8
#define LPC_DAC_CTRL_DMA_ENA 0x8
#define LPC_DAC_CTRL_DMA_ENA_BIT 3

#define LPC_DAC_CNTVAL (*(volatile unsigned long *)0x4008C008)
#define LPC_DAC_CNTVAL_OFFSET 0x8
#define LPC_DAC_CNTVAL_VALUE_MASK 0xFFFF
#define LPC_DAC_CNTVAL_VALUE_BIT 0

#ifndef LPC_TIMER2_BASE_ADDRESS
#define LPC_TIMER2_BASE_ADDRESS 0x40090000
#endif

#define LPC_TIMER2_IR (*(volatile unsigned long *)0x40090000)
#define LPC_TIMER2_IR_OFFSET 0x0
#define LPC_TIMER2_IR_MR0INT_MASK 0x1
#define LPC_TIMER2_IR_MR0INT 0x1
#define LPC_TIMER2_IR_MR0INT_BIT 0
#define LPC_TIMER2_IR_MR1INT_MASK 0x2
#define LPC_TIMER2_IR_MR1INT 0x2
#define LPC_TIMER2_IR_MR1INT_BIT 1
#define LPC_TIMER2_IR_MR2INT_MASK 0x4
#define LPC_TIMER2_IR_MR2INT 0x4
#define LPC_TIMER2_IR_MR2INT_BIT 2
#define LPC_TIMER2_IR_MR3INT_MASK 0x8
#define LPC_TIMER2_IR_MR3INT 0x8
#define LPC_TIMER2_IR_MR3INT_BIT 3
#define LPC_TIMER2_IR_CR0INT_MASK 0x10
#define LPC_TIMER2_IR_CR0INT 0x10
#define LPC_TIMER2_IR_CR0INT_BIT 4
#define LPC_TIMER2_IR_CR1INT_MASK 0x20
#define LPC_TIMER2_IR_CR1INT 0x20
#define LPC_TIMER2_IR_CR1INT_BIT 5

#define LPC_TIMER2_TCR (*(volatile unsigned long *)0x40090004)
#define LPC_TIMER2_TCR_OFFSET 0x4
#define LPC_TIMER2_TCR_CEN_MASK 0x1
#define LPC_TIMER2_TCR_CEN 0x1
#define LPC_TIMER2_TCR_CEN_BIT 0
#define LPC_TIMER2_TCR_CRST_MASK 0x2
#define LPC_TIMER2_TCR_CRST 0x2
#define LPC_TIMER2_TCR_CRST_BIT 1

#define LPC_TIMER2_TC (*(volatile unsigned long *)0x40090008)
#define LPC_TIMER2_TC_OFFSET 0x8
#define LPC_TIMER2_TC_TC_MASK 0xFFFFFFFF
#define LPC_TIMER2_TC_TC_BIT 0

#define LPC_TIMER2_PR (*(volatile unsigned long *)0x4009000C)
#define LPC_TIMER2_PR_OFFSET 0xC
#define LPC_TIMER2_PR_PM_MASK 0xFFFFFFFF
#define LPC_TIMER2_PR_PM_BIT 0

#define LPC_TIMER2_PC (*(volatile unsigned long *)0x40090010)
#define LPC_TIMER2_PC_OFFSET 0x10
#define LPC_TIMER2_PC_PC_MASK 0xFFFFFFFF
#define LPC_TIMER2_PC_PC_BIT 0

#define LPC_TIMER2_MCR (*(volatile unsigned long *)0x40090014)
#define LPC_TIMER2_MCR_OFFSET 0x14
#define LPC_TIMER2_MCR_MR0I_MASK 0x1
#define LPC_TIMER2_MCR_MR0I 0x1
#define LPC_TIMER2_MCR_MR0I_BIT 0
#define LPC_TIMER2_MCR_MR0R_MASK 0x2
#define LPC_TIMER2_MCR_MR0R 0x2
#define LPC_TIMER2_MCR_MR0R_BIT 1
#define LPC_TIMER2_MCR_MR0S_MASK 0x4
#define LPC_TIMER2_MCR_MR0S 0x4
#define LPC_TIMER2_MCR_MR0S_BIT 2
#define LPC_TIMER2_MCR_MR1I_MASK 0x8
#define LPC_TIMER2_MCR_MR1I 0x8
#define LPC_TIMER2_MCR_MR1I_BIT 3
#define LPC_TIMER2_MCR_MR1R_MASK 0x10
#define LPC_TIMER2_MCR_MR1R 0x10
#define LPC_TIMER2_MCR_MR1R_BIT 4
#define LPC_TIMER2_MCR_MR1S_MASK 0x20
#define LPC_TIMER2_MCR_MR1S 0x20
#define LPC_TIMER2_MCR_MR1S_BIT 5
#define LPC_TIMER2_MCR_MR2I_MASK 0x40
#define LPC_TIMER2_MCR_MR2I 0x40
#define LPC_TIMER2_MCR_MR2I_BIT 6
#define LPC_TIMER2_MCR_MR2R_MASK 0x80
#define LPC_TIMER2_MCR_MR2R 0x80
#define LPC_TIMER2_MCR_MR2R_BIT 7
#define LPC_TIMER2_MCR_MR2S_MASK 0x100
#define LPC_TIMER2_MCR_MR2S 0x100
#define LPC_TIMER2_MCR_MR2S_BIT 8
#define LPC_TIMER2_MCR_MR3I_MASK 0x200
#define LPC_TIMER2_MCR_MR3I 0x200
#define LPC_TIMER2_MCR_MR3I_BIT 9
#define LPC_TIMER2_MCR_MR3R_MASK 0x400
#define LPC_TIMER2_MCR_MR3R 0x400
#define LPC_TIMER2_MCR_MR3R_BIT 10
#define LPC_TIMER2_MCR_MR3S_MASK 0x800
#define LPC_TIMER2_MCR_MR3S 0x800
#define LPC_TIMER2_MCR_MR3S_BIT 11

#define LPC_TIMER2_MR0 (*(volatile unsigned long *)0x40090018)
#define LPC_TIMER2_MR0_OFFSET 0x18
#define LPC_TIMER2_MR0_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER2_MR0_MATCH_BIT 0

#define LPC_TIMER2_MR1 (*(volatile unsigned long *)0x4009001C)
#define LPC_TIMER2_MR1_OFFSET 0x1C
#define LPC_TIMER2_MR1_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER2_MR1_MATCH_BIT 0

#define LPC_TIMER2_MR2 (*(volatile unsigned long *)0x40090020)
#define LPC_TIMER2_MR2_OFFSET 0x20
#define LPC_TIMER2_MR2_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER2_MR2_MATCH_BIT 0

#define LPC_TIMER2_MR3 (*(volatile unsigned long *)0x40090024)
#define LPC_TIMER2_MR3_OFFSET 0x24
#define LPC_TIMER2_MR3_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER2_MR3_MATCH_BIT 0

#define LPC_TIMER2_CCR (*(volatile unsigned long *)0x40090028)
#define LPC_TIMER2_CCR_OFFSET 0x28
#define LPC_TIMER2_CCR_CAP0RE_MASK 0x1
#define LPC_TIMER2_CCR_CAP0RE 0x1
#define LPC_TIMER2_CCR_CAP0RE_BIT 0
#define LPC_TIMER2_CCR_CAP0FE_MASK 0x2
#define LPC_TIMER2_CCR_CAP0FE 0x2
#define LPC_TIMER2_CCR_CAP0FE_BIT 1
#define LPC_TIMER2_CCR_CAP0I_MASK 0x4
#define LPC_TIMER2_CCR_CAP0I 0x4
#define LPC_TIMER2_CCR_CAP0I_BIT 2
#define LPC_TIMER2_CCR_CAP1RE_MASK 0x8
#define LPC_TIMER2_CCR_CAP1RE 0x8
#define LPC_TIMER2_CCR_CAP1RE_BIT 3
#define LPC_TIMER2_CCR_CAP1FE_MASK 0x10
#define LPC_TIMER2_CCR_CAP1FE 0x10
#define LPC_TIMER2_CCR_CAP1FE_BIT 4
#define LPC_TIMER2_CCR_CAP1I_MASK 0x20
#define LPC_TIMER2_CCR_CAP1I 0x20
#define LPC_TIMER2_CCR_CAP1I_BIT 5

#define LPC_TIMER2_CR0 (*(volatile unsigned long *)0x4009002C)
#define LPC_TIMER2_CR0_OFFSET 0x2C
#define LPC_TIMER2_CR0_CAP_MASK 0xFFFFFFFF
#define LPC_TIMER2_CR0_CAP_BIT 0

#define LPC_TIMER2_CR1 (*(volatile unsigned long *)0x40090030)
#define LPC_TIMER2_CR1_OFFSET 0x30
#define LPC_TIMER2_CR1_CAP_MASK 0xFFFFFFFF
#define LPC_TIMER2_CR1_CAP_BIT 0

#define LPC_TIMER2_EMR (*(volatile unsigned long *)0x4009003C)
#define LPC_TIMER2_EMR_OFFSET 0x3C
#define LPC_TIMER2_EMR_EM0_MASK 0x1
#define LPC_TIMER2_EMR_EM0 0x1
#define LPC_TIMER2_EMR_EM0_BIT 0
#define LPC_TIMER2_EMR_EM1_MASK 0x2
#define LPC_TIMER2_EMR_EM1 0x2
#define LPC_TIMER2_EMR_EM1_BIT 1
#define LPC_TIMER2_EMR_EM2_MASK 0x4
#define LPC_TIMER2_EMR_EM2 0x4
#define LPC_TIMER2_EMR_EM2_BIT 2
#define LPC_TIMER2_EMR_EM3_MASK 0x8
#define LPC_TIMER2_EMR_EM3 0x8
#define LPC_TIMER2_EMR_EM3_BIT 3
#define LPC_TIMER2_EMR_EMC0_MASK 0x30
#define LPC_TIMER2_EMR_EMC0_BIT 4
#define LPC_TIMER2_EMR_EMC1_MASK 0xC0
#define LPC_TIMER2_EMR_EMC1_BIT 6
#define LPC_TIMER2_EMR_EMC2_MASK 0x300
#define LPC_TIMER2_EMR_EMC2_BIT 8
#define LPC_TIMER2_EMR_EMC3_MASK 0xC00
#define LPC_TIMER2_EMR_EMC3_BIT 10

#define LPC_TIMER2_CTCR (*(volatile unsigned long *)0x40090070)
#define LPC_TIMER2_CTCR_OFFSET 0x70
#define LPC_TIMER2_CTCR_CTMODE_MASK 0x3
#define LPC_TIMER2_CTCR_CTMODE_BIT 0
#define LPC_TIMER2_CTCR_CINSEL_MASK 0xC
#define LPC_TIMER2_CTCR_CINSEL_BIT 2

#ifndef LPC_TIMER3_BASE_ADDRESS
#define LPC_TIMER3_BASE_ADDRESS 0x40094000
#endif

#define LPC_TIMER3_IR (*(volatile unsigned long *)0x40094000)
#define LPC_TIMER3_IR_OFFSET 0x0
#define LPC_TIMER3_IR_MR0INT_MASK 0x1
#define LPC_TIMER3_IR_MR0INT 0x1
#define LPC_TIMER3_IR_MR0INT_BIT 0
#define LPC_TIMER3_IR_MR1INT_MASK 0x2
#define LPC_TIMER3_IR_MR1INT 0x2
#define LPC_TIMER3_IR_MR1INT_BIT 1
#define LPC_TIMER3_IR_MR2INT_MASK 0x4
#define LPC_TIMER3_IR_MR2INT 0x4
#define LPC_TIMER3_IR_MR2INT_BIT 2
#define LPC_TIMER3_IR_MR3INT_MASK 0x8
#define LPC_TIMER3_IR_MR3INT 0x8
#define LPC_TIMER3_IR_MR3INT_BIT 3
#define LPC_TIMER3_IR_CR0INT_MASK 0x10
#define LPC_TIMER3_IR_CR0INT 0x10
#define LPC_TIMER3_IR_CR0INT_BIT 4
#define LPC_TIMER3_IR_CR1INT_MASK 0x20
#define LPC_TIMER3_IR_CR1INT 0x20
#define LPC_TIMER3_IR_CR1INT_BIT 5

#define LPC_TIMER3_TCR (*(volatile unsigned long *)0x40094004)
#define LPC_TIMER3_TCR_OFFSET 0x4
#define LPC_TIMER3_TCR_CEN_MASK 0x1
#define LPC_TIMER3_TCR_CEN 0x1
#define LPC_TIMER3_TCR_CEN_BIT 0
#define LPC_TIMER3_TCR_CRST_MASK 0x2
#define LPC_TIMER3_TCR_CRST 0x2
#define LPC_TIMER3_TCR_CRST_BIT 1

#define LPC_TIMER3_TC (*(volatile unsigned long *)0x40094008)
#define LPC_TIMER3_TC_OFFSET 0x8
#define LPC_TIMER3_TC_TC_MASK 0xFFFFFFFF
#define LPC_TIMER3_TC_TC_BIT 0

#define LPC_TIMER3_PR (*(volatile unsigned long *)0x4009400C)
#define LPC_TIMER3_PR_OFFSET 0xC
#define LPC_TIMER3_PR_PM_MASK 0xFFFFFFFF
#define LPC_TIMER3_PR_PM_BIT 0

#define LPC_TIMER3_PC (*(volatile unsigned long *)0x40094010)
#define LPC_TIMER3_PC_OFFSET 0x10
#define LPC_TIMER3_PC_PC_MASK 0xFFFFFFFF
#define LPC_TIMER3_PC_PC_BIT 0

#define LPC_TIMER3_MCR (*(volatile unsigned long *)0x40094014)
#define LPC_TIMER3_MCR_OFFSET 0x14
#define LPC_TIMER3_MCR_MR0I_MASK 0x1
#define LPC_TIMER3_MCR_MR0I 0x1
#define LPC_TIMER3_MCR_MR0I_BIT 0
#define LPC_TIMER3_MCR_MR0R_MASK 0x2
#define LPC_TIMER3_MCR_MR0R 0x2
#define LPC_TIMER3_MCR_MR0R_BIT 1
#define LPC_TIMER3_MCR_MR0S_MASK 0x4
#define LPC_TIMER3_MCR_MR0S 0x4
#define LPC_TIMER3_MCR_MR0S_BIT 2
#define LPC_TIMER3_MCR_MR1I_MASK 0x8
#define LPC_TIMER3_MCR_MR1I 0x8
#define LPC_TIMER3_MCR_MR1I_BIT 3
#define LPC_TIMER3_MCR_MR1R_MASK 0x10
#define LPC_TIMER3_MCR_MR1R 0x10
#define LPC_TIMER3_MCR_MR1R_BIT 4
#define LPC_TIMER3_MCR_MR1S_MASK 0x20
#define LPC_TIMER3_MCR_MR1S 0x20
#define LPC_TIMER3_MCR_MR1S_BIT 5
#define LPC_TIMER3_MCR_MR2I_MASK 0x40
#define LPC_TIMER3_MCR_MR2I 0x40
#define LPC_TIMER3_MCR_MR2I_BIT 6
#define LPC_TIMER3_MCR_MR2R_MASK 0x80
#define LPC_TIMER3_MCR_MR2R 0x80
#define LPC_TIMER3_MCR_MR2R_BIT 7
#define LPC_TIMER3_MCR_MR2S_MASK 0x100
#define LPC_TIMER3_MCR_MR2S 0x100
#define LPC_TIMER3_MCR_MR2S_BIT 8
#define LPC_TIMER3_MCR_MR3I_MASK 0x200
#define LPC_TIMER3_MCR_MR3I 0x200
#define LPC_TIMER3_MCR_MR3I_BIT 9
#define LPC_TIMER3_MCR_MR3R_MASK 0x400
#define LPC_TIMER3_MCR_MR3R 0x400
#define LPC_TIMER3_MCR_MR3R_BIT 10
#define LPC_TIMER3_MCR_MR3S_MASK 0x800
#define LPC_TIMER3_MCR_MR3S 0x800
#define LPC_TIMER3_MCR_MR3S_BIT 11

#define LPC_TIMER3_MR0 (*(volatile unsigned long *)0x40094018)
#define LPC_TIMER3_MR0_OFFSET 0x18
#define LPC_TIMER3_MR0_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER3_MR0_MATCH_BIT 0

#define LPC_TIMER3_MR1 (*(volatile unsigned long *)0x4009401C)
#define LPC_TIMER3_MR1_OFFSET 0x1C
#define LPC_TIMER3_MR1_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER3_MR1_MATCH_BIT 0

#define LPC_TIMER3_MR2 (*(volatile unsigned long *)0x40094020)
#define LPC_TIMER3_MR2_OFFSET 0x20
#define LPC_TIMER3_MR2_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER3_MR2_MATCH_BIT 0

#define LPC_TIMER3_MR3 (*(volatile unsigned long *)0x40094024)
#define LPC_TIMER3_MR3_OFFSET 0x24
#define LPC_TIMER3_MR3_MATCH_MASK 0xFFFFFFFF
#define LPC_TIMER3_MR3_MATCH_BIT 0

#define LPC_TIMER3_CCR (*(volatile unsigned long *)0x40094028)
#define LPC_TIMER3_CCR_OFFSET 0x28
#define LPC_TIMER3_CCR_CAP0RE_MASK 0x1
#define LPC_TIMER3_CCR_CAP0RE 0x1
#define LPC_TIMER3_CCR_CAP0RE_BIT 0
#define LPC_TIMER3_CCR_CAP0FE_MASK 0x2
#define LPC_TIMER3_CCR_CAP0FE 0x2
#define LPC_TIMER3_CCR_CAP0FE_BIT 1
#define LPC_TIMER3_CCR_CAP0I_MASK 0x4
#define LPC_TIMER3_CCR_CAP0I 0x4
#define LPC_TIMER3_CCR_CAP0I_BIT 2
#define LPC_TIMER3_CCR_CAP1RE_MASK 0x8
#define LPC_TIMER3_CCR_CAP1RE 0x8
#define LPC_TIMER3_CCR_CAP1RE_BIT 3
#define LPC_TIMER3_CCR_CAP1FE_MASK 0x10
#define LPC_TIMER3_CCR_CAP1FE 0x10
#define LPC_TIMER3_CCR_CAP1FE_BIT 4
#define LPC_TIMER3_CCR_CAP1I_MASK 0x20
#define LPC_TIMER3_CCR_CAP1I 0x20
#define LPC_TIMER3_CCR_CAP1I_BIT 5

#define LPC_TIMER3_CR0 (*(volatile unsigned long *)0x4009402C)
#define LPC_TIMER3_CR0_OFFSET 0x2C
#define LPC_TIMER3_CR0_CAP_MASK 0xFFFFFFFF
#define LPC_TIMER3_CR0_CAP_BIT 0

#define LPC_TIMER3_CR1 (*(volatile unsigned long *)0x40094030)
#define LPC_TIMER3_CR1_OFFSET 0x30
#define LPC_TIMER3_CR1_CAP_MASK 0xFFFFFFFF
#define LPC_TIMER3_CR1_CAP_BIT 0

#define LPC_TIMER3_EMR (*(volatile unsigned long *)0x4009403C)
#define LPC_TIMER3_EMR_OFFSET 0x3C
#define LPC_TIMER3_EMR_EM0_MASK 0x1
#define LPC_TIMER3_EMR_EM0 0x1
#define LPC_TIMER3_EMR_EM0_BIT 0
#define LPC_TIMER3_EMR_EM1_MASK 0x2
#define LPC_TIMER3_EMR_EM1 0x2
#define LPC_TIMER3_EMR_EM1_BIT 1
#define LPC_TIMER3_EMR_EM2_MASK 0x4
#define LPC_TIMER3_EMR_EM2 0x4
#define LPC_TIMER3_EMR_EM2_BIT 2
#define LPC_TIMER3_EMR_EM3_MASK 0x8
#define LPC_TIMER3_EMR_EM3 0x8
#define LPC_TIMER3_EMR_EM3_BIT 3
#define LPC_TIMER3_EMR_EMC0_MASK 0x30
#define LPC_TIMER3_EMR_EMC0_BIT 4
#define LPC_TIMER3_EMR_EMC1_MASK 0xC0
#define LPC_TIMER3_EMR_EMC1_BIT 6
#define LPC_TIMER3_EMR_EMC2_MASK 0x300
#define LPC_TIMER3_EMR_EMC2_BIT 8
#define LPC_TIMER3_EMR_EMC3_MASK 0xC00
#define LPC_TIMER3_EMR_EMC3_BIT 10

#define LPC_TIMER3_CTCR (*(volatile unsigned long *)0x40094070)
#define LPC_TIMER3_CTCR_OFFSET 0x70
#define LPC_TIMER3_CTCR_CTMODE_MASK 0x3
#define LPC_TIMER3_CTCR_CTMODE_BIT 0
#define LPC_TIMER3_CTCR_CINSEL_MASK 0xC
#define LPC_TIMER3_CTCR_CINSEL_BIT 2

#ifndef LPC_UART2_BASE_ADDRESS
#define LPC_UART2_BASE_ADDRESS 0x40098000
#endif

#define LPC_UART2_RBR (*(volatile unsigned long *)0x40098000)
#define LPC_UART2_RBR_OFFSET 0x0
#define LPC_UART2_RBR_RBR_MASK 0xFF
#define LPC_UART2_RBR_RBR_BIT 0

#define LPC_UART2_THR (*(volatile unsigned long *)0x40098000)
#define LPC_UART2_THR_OFFSET 0x0
#define LPC_UART2_THR_THR_MASK 0xFF
#define LPC_UART2_THR_THR_BIT 0

#define LPC_UART2_DLL (*(volatile unsigned long *)0x40098000)
#define LPC_UART2_DLL_OFFSET 0x0
#define LPC_UART2_DLL_DLLSB_MASK 0xFF
#define LPC_UART2_DLL_DLLSB_BIT 0

#define LPC_UART2_DLM (*(volatile unsigned long *)0x40098004)
#define LPC_UART2_DLM_OFFSET 0x4
#define LPC_UART2_DLM_DLMSB_MASK 0xFF
#define LPC_UART2_DLM_DLMSB_BIT 0

#define LPC_UART2_IER (*(volatile unsigned long *)0x40098004)
#define LPC_UART2_IER_OFFSET 0x4
#define LPC_UART2_IER_RBRIE_MASK 0x1
#define LPC_UART2_IER_RBRIE 0x1
#define LPC_UART2_IER_RBRIE_BIT 0
#define LPC_UART2_IER_THREIE_MASK 0x2
#define LPC_UART2_IER_THREIE 0x2
#define LPC_UART2_IER_THREIE_BIT 1
#define LPC_UART2_IER_RXIE_MASK 0x4
#define LPC_UART2_IER_RXIE 0x4
#define LPC_UART2_IER_RXIE_BIT 2
#define LPC_UART2_IER_ABEOINTEN_MASK 0x100
#define LPC_UART2_IER_ABEOINTEN 0x100
#define LPC_UART2_IER_ABEOINTEN_BIT 8
#define LPC_UART2_IER_ABTOINTEN_MASK 0x200
#define LPC_UART2_IER_ABTOINTEN 0x200
#define LPC_UART2_IER_ABTOINTEN_BIT 9

#define LPC_UART2_IIR (*(volatile unsigned long *)0x40098008)
#define LPC_UART2_IIR_OFFSET 0x8
#define LPC_UART2_IIR_INTSTATUS_MASK 0x1
#define LPC_UART2_IIR_INTSTATUS 0x1
#define LPC_UART2_IIR_INTSTATUS_BIT 0
#define LPC_UART2_IIR_INTID_MASK 0xE
#define LPC_UART2_IIR_INTID_BIT 1
#define LPC_UART2_IIR_FIFOENABLE_MASK 0xC0
#define LPC_UART2_IIR_FIFOENABLE_BIT 6
#define LPC_UART2_IIR_ABEOINT_MASK 0x100
#define LPC_UART2_IIR_ABEOINT 0x100
#define LPC_UART2_IIR_ABEOINT_BIT 8
#define LPC_UART2_IIR_ABTOINT_MASK 0x200
#define LPC_UART2_IIR_ABTOINT 0x200
#define LPC_UART2_IIR_ABTOINT_BIT 9

#define LPC_UART2_FCR (*(volatile unsigned long *)0x40098008)
#define LPC_UART2_FCR_OFFSET 0x8
#define LPC_UART2_FCR_FIFOEN_MASK 0x1
#define LPC_UART2_FCR_FIFOEN 0x1
#define LPC_UART2_FCR_FIFOEN_BIT 0
#define LPC_UART2_FCR_RXFIFORES_MASK 0x2
#define LPC_UART2_FCR_RXFIFORES 0x2
#define LPC_UART2_FCR_RXFIFORES_BIT 1
#define LPC_UART2_FCR_TXFIFORES_MASK 0x4
#define LPC_UART2_FCR_TXFIFORES 0x4
#define LPC_UART2_FCR_TXFIFORES_BIT 2
#define LPC_UART2_FCR_DMAMODE_MASK 0x8
#define LPC_UART2_FCR_DMAMODE 0x8
#define LPC_UART2_FCR_DMAMODE_BIT 3
#define LPC_UART2_FCR_RXTRIGLVL_MASK 0xC0
#define LPC_UART2_FCR_RXTRIGLVL_BIT 6

#define LPC_UART2_LCR (*(volatile unsigned long *)0x4009800C)
#define LPC_UART2_LCR_OFFSET 0xC
#define LPC_UART2_LCR_WLS_MASK 0x3
#define LPC_UART2_LCR_WLS_BIT 0
#define LPC_UART2_LCR_SBS_MASK 0x4
#define LPC_UART2_LCR_SBS 0x4
#define LPC_UART2_LCR_SBS_BIT 2
#define LPC_UART2_LCR_PE_MASK 0x8
#define LPC_UART2_LCR_PE 0x8
#define LPC_UART2_LCR_PE_BIT 3
#define LPC_UART2_LCR_PS_MASK 0x30
#define LPC_UART2_LCR_PS_BIT 4
#define LPC_UART2_LCR_BC_MASK 0x40
#define LPC_UART2_LCR_BC 0x40
#define LPC_UART2_LCR_BC_BIT 6
#define LPC_UART2_LCR_DLAB_MASK 0x80
#define LPC_UART2_LCR_DLAB 0x80
#define LPC_UART2_LCR_DLAB_BIT 7

#define LPC_UART2_LSR (*(volatile unsigned long *)0x40098014)
#define LPC_UART2_LSR_OFFSET 0x14
#define LPC_UART2_LSR_RDR_MASK 0x1
#define LPC_UART2_LSR_RDR 0x1
#define LPC_UART2_LSR_RDR_BIT 0
#define LPC_UART2_LSR_OE_MASK 0x2
#define LPC_UART2_LSR_OE 0x2
#define LPC_UART2_LSR_OE_BIT 1
#define LPC_UART2_LSR_PE_MASK 0x4
#define LPC_UART2_LSR_PE 0x4
#define LPC_UART2_LSR_PE_BIT 2
#define LPC_UART2_LSR_FE_MASK 0x8
#define LPC_UART2_LSR_FE 0x8
#define LPC_UART2_LSR_FE_BIT 3
#define LPC_UART2_LSR_BI_MASK 0x10
#define LPC_UART2_LSR_BI 0x10
#define LPC_UART2_LSR_BI_BIT 4
#define LPC_UART2_LSR_THRE_MASK 0x20
#define LPC_UART2_LSR_THRE 0x20
#define LPC_UART2_LSR_THRE_BIT 5
#define LPC_UART2_LSR_TEMT_MASK 0x40
#define LPC_UART2_LSR_TEMT 0x40
#define LPC_UART2_LSR_TEMT_BIT 6
#define LPC_UART2_LSR_RXFE_MASK 0x80
#define LPC_UART2_LSR_RXFE 0x80
#define LPC_UART2_LSR_RXFE_BIT 7

#define LPC_UART2_SCR (*(volatile unsigned long *)0x4009801C)
#define LPC_UART2_SCR_OFFSET 0x1C
#define LPC_UART2_SCR_PAD_MASK 0xFF
#define LPC_UART2_SCR_PAD_BIT 0

#define LPC_UART2_ACR (*(volatile unsigned long *)0x40098020)
#define LPC_UART2_ACR_OFFSET 0x20
#define LPC_UART2_ACR_START_MASK 0x1
#define LPC_UART2_ACR_START 0x1
#define LPC_UART2_ACR_START_BIT 0
#define LPC_UART2_ACR_MODE_MASK 0x2
#define LPC_UART2_ACR_MODE 0x2
#define LPC_UART2_ACR_MODE_BIT 1
#define LPC_UART2_ACR_AUTORESTART_MASK 0x4
#define LPC_UART2_ACR_AUTORESTART 0x4
#define LPC_UART2_ACR_AUTORESTART_BIT 2
#define LPC_UART2_ACR_ABEOINTCLR_MASK 0x100
#define LPC_UART2_ACR_ABEOINTCLR 0x100
#define LPC_UART2_ACR_ABEOINTCLR_BIT 8
#define LPC_UART2_ACR_ABTOINTCLR_MASK 0x200
#define LPC_UART2_ACR_ABTOINTCLR 0x200
#define LPC_UART2_ACR_ABTOINTCLR_BIT 9

#define LPC_UART2_FDR (*(volatile unsigned long *)0x40098028)
#define LPC_UART2_FDR_OFFSET 0x28
#define LPC_UART2_FDR_DIVADDVAL_MASK 0xF
#define LPC_UART2_FDR_DIVADDVAL_BIT 0
#define LPC_UART2_FDR_MULVAL_MASK 0xF0
#define LPC_UART2_FDR_MULVAL_BIT 4

#define LPC_UART2_TER (*(volatile unsigned long *)0x40098030)
#define LPC_UART2_TER_OFFSET 0x30
#define LPC_UART2_TER_TXEN_MASK 0x80
#define LPC_UART2_TER_TXEN 0x80
#define LPC_UART2_TER_TXEN_BIT 7

#define LPC_UART2_RS485CTRL (*(volatile unsigned long *)0x4009804C)
#define LPC_UART2_RS485CTRL_OFFSET 0x4C
#define LPC_UART2_RS485CTRL_NMMEN_MASK 0x1
#define LPC_UART2_RS485CTRL_NMMEN 0x1
#define LPC_UART2_RS485CTRL_NMMEN_BIT 0
#define LPC_UART2_RS485CTRL_RXDIS_MASK 0x2
#define LPC_UART2_RS485CTRL_RXDIS 0x2
#define LPC_UART2_RS485CTRL_RXDIS_BIT 1
#define LPC_UART2_RS485CTRL_AADEN_MASK 0x4
#define LPC_UART2_RS485CTRL_AADEN 0x4
#define LPC_UART2_RS485CTRL_AADEN_BIT 2
#define LPC_UART2_RS485CTRL_DCTRL_MASK 0x10
#define LPC_UART2_RS485CTRL_DCTRL 0x10
#define LPC_UART2_RS485CTRL_DCTRL_BIT 4
#define LPC_UART2_RS485CTRL_OINV_MASK 0x20
#define LPC_UART2_RS485CTRL_OINV 0x20
#define LPC_UART2_RS485CTRL_OINV_BIT 5

#define LPC_UART2_RS485ADRMATCH (*(volatile unsigned long *)0x40098050)
#define LPC_UART2_RS485ADRMATCH_OFFSET 0x50
#define LPC_UART2_RS485ADRMATCH_ADRMATCH_MASK 0xFF
#define LPC_UART2_RS485ADRMATCH_ADRMATCH_BIT 0

#define LPC_UART2_RS485DLY (*(volatile unsigned long *)0x40098054)
#define LPC_UART2_RS485DLY_OFFSET 0x54
#define LPC_UART2_RS485DLY_DLY_MASK 0xFF
#define LPC_UART2_RS485DLY_DLY_BIT 0

#ifndef LPC_UART3_BASE_ADDRESS
#define LPC_UART3_BASE_ADDRESS 0x4009C000
#endif

#define LPC_UART3_RBR (*(volatile unsigned long *)0x4009C000)
#define LPC_UART3_RBR_OFFSET 0x0
#define LPC_UART3_RBR_RBR_MASK 0xFF
#define LPC_UART3_RBR_RBR_BIT 0

#define LPC_UART3_THR (*(volatile unsigned long *)0x4009C000)
#define LPC_UART3_THR_OFFSET 0x0
#define LPC_UART3_THR_THR_MASK 0xFF
#define LPC_UART3_THR_THR_BIT 0

#define LPC_UART3_DLL (*(volatile unsigned long *)0x4009C000)
#define LPC_UART3_DLL_OFFSET 0x0
#define LPC_UART3_DLL_DLLSB_MASK 0xFF
#define LPC_UART3_DLL_DLLSB_BIT 0

#define LPC_UART3_DLM (*(volatile unsigned long *)0x4009C004)
#define LPC_UART3_DLM_OFFSET 0x4
#define LPC_UART3_DLM_DLMSB_MASK 0xFF
#define LPC_UART3_DLM_DLMSB_BIT 0

#define LPC_UART3_IER (*(volatile unsigned long *)0x4009C004)
#define LPC_UART3_IER_OFFSET 0x4
#define LPC_UART3_IER_RBRIE_MASK 0x1
#define LPC_UART3_IER_RBRIE 0x1
#define LPC_UART3_IER_RBRIE_BIT 0
#define LPC_UART3_IER_THREIE_MASK 0x2
#define LPC_UART3_IER_THREIE 0x2
#define LPC_UART3_IER_THREIE_BIT 1
#define LPC_UART3_IER_RXIE_MASK 0x4
#define LPC_UART3_IER_RXIE 0x4
#define LPC_UART3_IER_RXIE_BIT 2
#define LPC_UART3_IER_ABEOINTEN_MASK 0x100
#define LPC_UART3_IER_ABEOINTEN 0x100
#define LPC_UART3_IER_ABEOINTEN_BIT 8
#define LPC_UART3_IER_ABTOINTEN_MASK 0x200
#define LPC_UART3_IER_ABTOINTEN 0x200
#define LPC_UART3_IER_ABTOINTEN_BIT 9

#define LPC_UART3_IIR (*(volatile unsigned long *)0x4009C008)
#define LPC_UART3_IIR_OFFSET 0x8
#define LPC_UART3_IIR_INTSTATUS_MASK 0x1
#define LPC_UART3_IIR_INTSTATUS 0x1
#define LPC_UART3_IIR_INTSTATUS_BIT 0
#define LPC_UART3_IIR_INTID_MASK 0xE
#define LPC_UART3_IIR_INTID_BIT 1
#define LPC_UART3_IIR_FIFOENABLE_MASK 0xC0
#define LPC_UART3_IIR_FIFOENABLE_BIT 6
#define LPC_UART3_IIR_ABEOINT_MASK 0x100
#define LPC_UART3_IIR_ABEOINT 0x100
#define LPC_UART3_IIR_ABEOINT_BIT 8
#define LPC_UART3_IIR_ABTOINT_MASK 0x200
#define LPC_UART3_IIR_ABTOINT 0x200
#define LPC_UART3_IIR_ABTOINT_BIT 9

#define LPC_UART3_FCR (*(volatile unsigned long *)0x4009C008)
#define LPC_UART3_FCR_OFFSET 0x8
#define LPC_UART3_FCR_FIFOEN_MASK 0x1
#define LPC_UART3_FCR_FIFOEN 0x1
#define LPC_UART3_FCR_FIFOEN_BIT 0
#define LPC_UART3_FCR_RXFIFORES_MASK 0x2
#define LPC_UART3_FCR_RXFIFORES 0x2
#define LPC_UART3_FCR_RXFIFORES_BIT 1
#define LPC_UART3_FCR_TXFIFORES_MASK 0x4
#define LPC_UART3_FCR_TXFIFORES 0x4
#define LPC_UART3_FCR_TXFIFORES_BIT 2
#define LPC_UART3_FCR_DMAMODE_MASK 0x8
#define LPC_UART3_FCR_DMAMODE 0x8
#define LPC_UART3_FCR_DMAMODE_BIT 3
#define LPC_UART3_FCR_RXTRIGLVL_MASK 0xC0
#define LPC_UART3_FCR_RXTRIGLVL_BIT 6

#define LPC_UART3_LCR (*(volatile unsigned long *)0x4009C00C)
#define LPC_UART3_LCR_OFFSET 0xC
#define LPC_UART3_LCR_WLS_MASK 0x3
#define LPC_UART3_LCR_WLS_BIT 0
#define LPC_UART3_LCR_SBS_MASK 0x4
#define LPC_UART3_LCR_SBS 0x4
#define LPC_UART3_LCR_SBS_BIT 2
#define LPC_UART3_LCR_PE_MASK 0x8
#define LPC_UART3_LCR_PE 0x8
#define LPC_UART3_LCR_PE_BIT 3
#define LPC_UART3_LCR_PS_MASK 0x30
#define LPC_UART3_LCR_PS_BIT 4
#define LPC_UART3_LCR_BC_MASK 0x40
#define LPC_UART3_LCR_BC 0x40
#define LPC_UART3_LCR_BC_BIT 6
#define LPC_UART3_LCR_DLAB_MASK 0x80
#define LPC_UART3_LCR_DLAB 0x80
#define LPC_UART3_LCR_DLAB_BIT 7

#define LPC_UART3_LSR (*(volatile unsigned long *)0x4009C014)
#define LPC_UART3_LSR_OFFSET 0x14
#define LPC_UART3_LSR_RDR_MASK 0x1
#define LPC_UART3_LSR_RDR 0x1
#define LPC_UART3_LSR_RDR_BIT 0
#define LPC_UART3_LSR_OE_MASK 0x2
#define LPC_UART3_LSR_OE 0x2
#define LPC_UART3_LSR_OE_BIT 1
#define LPC_UART3_LSR_PE_MASK 0x4
#define LPC_UART3_LSR_PE 0x4
#define LPC_UART3_LSR_PE_BIT 2
#define LPC_UART3_LSR_FE_MASK 0x8
#define LPC_UART3_LSR_FE 0x8
#define LPC_UART3_LSR_FE_BIT 3
#define LPC_UART3_LSR_BI_MASK 0x10
#define LPC_UART3_LSR_BI 0x10
#define LPC_UART3_LSR_BI_BIT 4
#define LPC_UART3_LSR_THRE_MASK 0x20
#define LPC_UART3_LSR_THRE 0x20
#define LPC_UART3_LSR_THRE_BIT 5
#define LPC_UART3_LSR_TEMT_MASK 0x40
#define LPC_UART3_LSR_TEMT 0x40
#define LPC_UART3_LSR_TEMT_BIT 6
#define LPC_UART3_LSR_RXFE_MASK 0x80
#define LPC_UART3_LSR_RXFE 0x80
#define LPC_UART3_LSR_RXFE_BIT 7

#define LPC_UART3_SCR (*(volatile unsigned long *)0x4009C01C)
#define LPC_UART3_SCR_OFFSET 0x1C
#define LPC_UART3_SCR_PAD_MASK 0xFF
#define LPC_UART3_SCR_PAD_BIT 0

#define LPC_UART3_ACR (*(volatile unsigned long *)0x4009C020)
#define LPC_UART3_ACR_OFFSET 0x20
#define LPC_UART3_ACR_START_MASK 0x1
#define LPC_UART3_ACR_START 0x1
#define LPC_UART3_ACR_START_BIT 0
#define LPC_UART3_ACR_MODE_MASK 0x2
#define LPC_UART3_ACR_MODE 0x2
#define LPC_UART3_ACR_MODE_BIT 1
#define LPC_UART3_ACR_AUTORESTART_MASK 0x4
#define LPC_UART3_ACR_AUTORESTART 0x4
#define LPC_UART3_ACR_AUTORESTART_BIT 2
#define LPC_UART3_ACR_ABEOINTCLR_MASK 0x100
#define LPC_UART3_ACR_ABEOINTCLR 0x100
#define LPC_UART3_ACR_ABEOINTCLR_BIT 8
#define LPC_UART3_ACR_ABTOINTCLR_MASK 0x200
#define LPC_UART3_ACR_ABTOINTCLR 0x200
#define LPC_UART3_ACR_ABTOINTCLR_BIT 9

#define LPC_UART3_FDR (*(volatile unsigned long *)0x4009C028)
#define LPC_UART3_FDR_OFFSET 0x28
#define LPC_UART3_FDR_DIVADDVAL_MASK 0xF
#define LPC_UART3_FDR_DIVADDVAL_BIT 0
#define LPC_UART3_FDR_MULVAL_MASK 0xF0
#define LPC_UART3_FDR_MULVAL_BIT 4

#define LPC_UART3_TER (*(volatile unsigned long *)0x4009C030)
#define LPC_UART3_TER_OFFSET 0x30
#define LPC_UART3_TER_TXEN_MASK 0x80
#define LPC_UART3_TER_TXEN 0x80
#define LPC_UART3_TER_TXEN_BIT 7

#define LPC_UART3_RS485CTRL (*(volatile unsigned long *)0x4009C04C)
#define LPC_UART3_RS485CTRL_OFFSET 0x4C
#define LPC_UART3_RS485CTRL_NMMEN_MASK 0x1
#define LPC_UART3_RS485CTRL_NMMEN 0x1
#define LPC_UART3_RS485CTRL_NMMEN_BIT 0
#define LPC_UART3_RS485CTRL_RXDIS_MASK 0x2
#define LPC_UART3_RS485CTRL_RXDIS 0x2
#define LPC_UART3_RS485CTRL_RXDIS_BIT 1
#define LPC_UART3_RS485CTRL_AADEN_MASK 0x4
#define LPC_UART3_RS485CTRL_AADEN 0x4
#define LPC_UART3_RS485CTRL_AADEN_BIT 2
#define LPC_UART3_RS485CTRL_DCTRL_MASK 0x10
#define LPC_UART3_RS485CTRL_DCTRL 0x10
#define LPC_UART3_RS485CTRL_DCTRL_BIT 4
#define LPC_UART3_RS485CTRL_OINV_MASK 0x20
#define LPC_UART3_RS485CTRL_OINV 0x20
#define LPC_UART3_RS485CTRL_OINV_BIT 5

#define LPC_UART3_RS485ADRMATCH (*(volatile unsigned long *)0x4009C050)
#define LPC_UART3_RS485ADRMATCH_OFFSET 0x50
#define LPC_UART3_RS485ADRMATCH_ADRMATCH_MASK 0xFF
#define LPC_UART3_RS485ADRMATCH_ADRMATCH_BIT 0

#define LPC_UART3_RS485DLY (*(volatile unsigned long *)0x4009C054)
#define LPC_UART3_RS485DLY_OFFSET 0x54
#define LPC_UART3_RS485DLY_DLY_MASK 0xFF
#define LPC_UART3_RS485DLY_DLY_BIT 0

#ifndef LPC_I2C2_BASE_ADDRESS
#define LPC_I2C2_BASE_ADDRESS 0x400A0000
#endif

#define LPC_I2C2_CONSET (*(volatile unsigned long *)0x400A0000)
#define LPC_I2C2_CONSET_OFFSET 0x0
#define LPC_I2C2_CONSET_AA_MASK 0x4
#define LPC_I2C2_CONSET_AA 0x4
#define LPC_I2C2_CONSET_AA_BIT 2
#define LPC_I2C2_CONSET_SI_MASK 0x8
#define LPC_I2C2_CONSET_SI 0x8
#define LPC_I2C2_CONSET_SI_BIT 3
#define LPC_I2C2_CONSET_STO_MASK 0x10
#define LPC_I2C2_CONSET_STO 0x10
#define LPC_I2C2_CONSET_STO_BIT 4
#define LPC_I2C2_CONSET_STA_MASK 0x20
#define LPC_I2C2_CONSET_STA 0x20
#define LPC_I2C2_CONSET_STA_BIT 5
#define LPC_I2C2_CONSET_I2EN_MASK 0x40
#define LPC_I2C2_CONSET_I2EN 0x40
#define LPC_I2C2_CONSET_I2EN_BIT 6

#define LPC_I2C2_STAT (*(volatile unsigned long *)0x400A0004)
#define LPC_I2C2_STAT_OFFSET 0x4
#define LPC_I2C2_STAT_Status_MASK 0xF8
#define LPC_I2C2_STAT_Status_BIT 3

#define LPC_I2C2_DAT (*(volatile unsigned long *)0x400A0008)
#define LPC_I2C2_DAT_OFFSET 0x8
#define LPC_I2C2_DAT_Data_MASK 0xFF
#define LPC_I2C2_DAT_Data_BIT 0

#define LPC_I2C2_ADR0 (*(volatile unsigned long *)0x400A000C)
#define LPC_I2C2_ADR0_OFFSET 0xC
#define LPC_I2C2_ADR0_GC_MASK 0x1
#define LPC_I2C2_ADR0_GC 0x1
#define LPC_I2C2_ADR0_GC_BIT 0
#define LPC_I2C2_ADR0_Address_MASK 0xFE
#define LPC_I2C2_ADR0_Address_BIT 1

#define LPC_I2C2_SCLH (*(volatile unsigned long *)0x400A0010)
#define LPC_I2C2_SCLH_OFFSET 0x10
#define LPC_I2C2_SCLH_SCLH_MASK 0xFFFF
#define LPC_I2C2_SCLH_SCLH_BIT 0

#define LPC_I2C2_SCLL (*(volatile unsigned long *)0x400A0014)
#define LPC_I2C2_SCLL_OFFSET 0x14
#define LPC_I2C2_SCLL_SCLL_MASK 0xFFFF
#define LPC_I2C2_SCLL_SCLL_BIT 0

#define LPC_I2C2_CONCLR (*(volatile unsigned long *)0x400A0018)
#define LPC_I2C2_CONCLR_OFFSET 0x18
#define LPC_I2C2_CONCLR_AAC_MASK 0x4
#define LPC_I2C2_CONCLR_AAC 0x4
#define LPC_I2C2_CONCLR_AAC_BIT 2
#define LPC_I2C2_CONCLR_SIC_MASK 0x8
#define LPC_I2C2_CONCLR_SIC 0x8
#define LPC_I2C2_CONCLR_SIC_BIT 3
#define LPC_I2C2_CONCLR_STAC_MASK 0x20
#define LPC_I2C2_CONCLR_STAC 0x20
#define LPC_I2C2_CONCLR_STAC_BIT 5
#define LPC_I2C2_CONCLR_I2ENC_MASK 0x40
#define LPC_I2C2_CONCLR_I2ENC 0x40
#define LPC_I2C2_CONCLR_I2ENC_BIT 6

#define LPC_I2C2_MMCTRL (*(volatile unsigned long *)0x400A001C)
#define LPC_I2C2_MMCTRL_OFFSET 0x1C
#define LPC_I2C2_MMCTRL_MM_ENA_MASK 0x1
#define LPC_I2C2_MMCTRL_MM_ENA 0x1
#define LPC_I2C2_MMCTRL_MM_ENA_BIT 0
#define LPC_I2C2_MMCTRL_ENA_SCL_MASK 0x2
#define LPC_I2C2_MMCTRL_ENA_SCL 0x2
#define LPC_I2C2_MMCTRL_ENA_SCL_BIT 1
#define LPC_I2C2_MMCTRL_MATCH_ALL_MASK 0x4
#define LPC_I2C2_MMCTRL_MATCH_ALL 0x4
#define LPC_I2C2_MMCTRL_MATCH_ALL_BIT 2

#define LPC_I2C2_ADR1 (*(volatile unsigned long *)0x400A0020)
#define LPC_I2C2_ADR1_OFFSET 0x20
#define LPC_I2C2_ADR1_GC_MASK 0x1
#define LPC_I2C2_ADR1_GC 0x1
#define LPC_I2C2_ADR1_GC_BIT 0
#define LPC_I2C2_ADR1_Address_MASK 0xFE
#define LPC_I2C2_ADR1_Address_BIT 1

#define LPC_I2C2_ADR2 (*(volatile unsigned long *)0x400A0024)
#define LPC_I2C2_ADR2_OFFSET 0x24
#define LPC_I2C2_ADR2_GC_MASK 0x1
#define LPC_I2C2_ADR2_GC 0x1
#define LPC_I2C2_ADR2_GC_BIT 0
#define LPC_I2C2_ADR2_Address_MASK 0xFE
#define LPC_I2C2_ADR2_Address_BIT 1

#define LPC_I2C2_ADR3 (*(volatile unsigned long *)0x400A0028)
#define LPC_I2C2_ADR3_OFFSET 0x28
#define LPC_I2C2_ADR3_GC_MASK 0x1
#define LPC_I2C2_ADR3_GC 0x1
#define LPC_I2C2_ADR3_GC_BIT 0
#define LPC_I2C2_ADR3_Address_MASK 0xFE
#define LPC_I2C2_ADR3_Address_BIT 1

#define LPC_I2C2_DATA_BUFFER (*(volatile unsigned long *)0x400A002C)
#define LPC_I2C2_DATA_BUFFER_OFFSET 0x2C
#define LPC_I2C2_DATA_BUFFER_Data_MASK 0xFF
#define LPC_I2C2_DATA_BUFFER_Data_BIT 0

#define LPC_I2C2_MASK0 (*(volatile unsigned long *)0x400A0030)
#define LPC_I2C2_MASK0_OFFSET 0x30
#define LPC_I2C2_MASK0_MASK_MASK 0xFE
#define LPC_I2C2_MASK0_MASK_BIT 1

#define LPC_I2C2_MASK1 (*(volatile unsigned long *)0x400A0034)
#define LPC_I2C2_MASK1_OFFSET 0x34
#define LPC_I2C2_MASK1_MASK_MASK 0xFE
#define LPC_I2C2_MASK1_MASK_BIT 1

#define LPC_I2C2_MASK2 (*(volatile unsigned long *)0x400A0038)
#define LPC_I2C2_MASK2_OFFSET 0x38
#define LPC_I2C2_MASK2_MASK_MASK 0xFE
#define LPC_I2C2_MASK2_MASK_BIT 1

#define LPC_I2C2_MASK3 (*(volatile unsigned long *)0x400A003C)
#define LPC_I2C2_MASK3_OFFSET 0x3C
#define LPC_I2C2_MASK3_MASK_MASK 0xFE
#define LPC_I2C2_MASK3_MASK_BIT 1

#ifndef LPC_UART4_BASE_ADDRESS
#define LPC_UART4_BASE_ADDRESS 0x400A4000
#endif

#define LPC_UART4_RBR (*(volatile unsigned long *)0x400A4000)
#define LPC_UART4_RBR_OFFSET 0x0
#define LPC_UART4_RBR_RBR_MASK 0xFF
#define LPC_UART4_RBR_RBR_BIT 0

#define LPC_UART4_THR (*(volatile unsigned long *)0x400A4000)
#define LPC_UART4_THR_OFFSET 0x0
#define LPC_UART4_THR_THR_MASK 0xFF
#define LPC_UART4_THR_THR_BIT 0

#define LPC_UART4_DLL (*(volatile unsigned long *)0x400A4000)
#define LPC_UART4_DLL_OFFSET 0x0
#define LPC_UART4_DLL_DLLSB_MASK 0xFF
#define LPC_UART4_DLL_DLLSB_BIT 0

#define LPC_UART4_DLM (*(volatile unsigned long *)0x400A4004)
#define LPC_UART4_DLM_OFFSET 0x4
#define LPC_UART4_DLM_DLMSB_MASK 0xFF
#define LPC_UART4_DLM_DLMSB_BIT 0

#define LPC_UART4_IER (*(volatile unsigned long *)0x400A4004)
#define LPC_UART4_IER_OFFSET 0x4
#define LPC_UART4_IER_RBRIE_MASK 0x1
#define LPC_UART4_IER_RBRIE 0x1
#define LPC_UART4_IER_RBRIE_BIT 0
#define LPC_UART4_IER_THREIE_MASK 0x2
#define LPC_UART4_IER_THREIE 0x2
#define LPC_UART4_IER_THREIE_BIT 1
#define LPC_UART4_IER_RXIE_MASK 0x4
#define LPC_UART4_IER_RXIE 0x4
#define LPC_UART4_IER_RXIE_BIT 2
#define LPC_UART4_IER_ABEOINTEN_MASK 0x100
#define LPC_UART4_IER_ABEOINTEN 0x100
#define LPC_UART4_IER_ABEOINTEN_BIT 8
#define LPC_UART4_IER_ABTOINTEN_MASK 0x200
#define LPC_UART4_IER_ABTOINTEN 0x200
#define LPC_UART4_IER_ABTOINTEN_BIT 9

#define LPC_UART4_IIR (*(volatile unsigned long *)0x400A4008)
#define LPC_UART4_IIR_OFFSET 0x8
#define LPC_UART4_IIR_INTSTATUS_MASK 0x1
#define LPC_UART4_IIR_INTSTATUS 0x1
#define LPC_UART4_IIR_INTSTATUS_BIT 0
#define LPC_UART4_IIR_INTID_MASK 0xE
#define LPC_UART4_IIR_INTID_BIT 1
#define LPC_UART4_IIR_FIFOENABLE_MASK 0xC0
#define LPC_UART4_IIR_FIFOENABLE_BIT 6
#define LPC_UART4_IIR_ABEOINT_MASK 0x100
#define LPC_UART4_IIR_ABEOINT 0x100
#define LPC_UART4_IIR_ABEOINT_BIT 8
#define LPC_UART4_IIR_ABTOINT_MASK 0x200
#define LPC_UART4_IIR_ABTOINT 0x200
#define LPC_UART4_IIR_ABTOINT_BIT 9

#define LPC_UART4_FCR (*(volatile unsigned long *)0x400A4008)
#define LPC_UART4_FCR_OFFSET 0x8
#define LPC_UART4_FCR_FIFOEN_MASK 0x1
#define LPC_UART4_FCR_FIFOEN 0x1
#define LPC_UART4_FCR_FIFOEN_BIT 0
#define LPC_UART4_FCR_RXFIFORES_MASK 0x2
#define LPC_UART4_FCR_RXFIFORES 0x2
#define LPC_UART4_FCR_RXFIFORES_BIT 1
#define LPC_UART4_FCR_TXFIFORES_MASK 0x4
#define LPC_UART4_FCR_TXFIFORES 0x4
#define LPC_UART4_FCR_TXFIFORES_BIT 2
#define LPC_UART4_FCR_DMAMODE_MASK 0x8
#define LPC_UART4_FCR_DMAMODE 0x8
#define LPC_UART4_FCR_DMAMODE_BIT 3
#define LPC_UART4_FCR_RXTRIGLVL_MASK 0xC0
#define LPC_UART4_FCR_RXTRIGLVL_BIT 6

#define LPC_UART4_LCR (*(volatile unsigned long *)0x400A400C)
#define LPC_UART4_LCR_OFFSET 0xC
#define LPC_UART4_LCR_WLS_MASK 0x3
#define LPC_UART4_LCR_WLS_BIT 0
#define LPC_UART4_LCR_SBS_MASK 0x4
#define LPC_UART4_LCR_SBS 0x4
#define LPC_UART4_LCR_SBS_BIT 2
#define LPC_UART4_LCR_PE_MASK 0x8
#define LPC_UART4_LCR_PE 0x8
#define LPC_UART4_LCR_PE_BIT 3
#define LPC_UART4_LCR_PS_MASK 0x30
#define LPC_UART4_LCR_PS_BIT 4
#define LPC_UART4_LCR_BC_MASK 0x40
#define LPC_UART4_LCR_BC 0x40
#define LPC_UART4_LCR_BC_BIT 6
#define LPC_UART4_LCR_DLAB_MASK 0x80
#define LPC_UART4_LCR_DLAB 0x80
#define LPC_UART4_LCR_DLAB_BIT 7

#define LPC_UART4_LSR (*(volatile unsigned long *)0x400A4014)
#define LPC_UART4_LSR_OFFSET 0x14
#define LPC_UART4_LSR_RDR_MASK 0x1
#define LPC_UART4_LSR_RDR 0x1
#define LPC_UART4_LSR_RDR_BIT 0
#define LPC_UART4_LSR_OE_MASK 0x2
#define LPC_UART4_LSR_OE 0x2
#define LPC_UART4_LSR_OE_BIT 1
#define LPC_UART4_LSR_PE_MASK 0x4
#define LPC_UART4_LSR_PE 0x4
#define LPC_UART4_LSR_PE_BIT 2
#define LPC_UART4_LSR_FE_MASK 0x8
#define LPC_UART4_LSR_FE 0x8
#define LPC_UART4_LSR_FE_BIT 3
#define LPC_UART4_LSR_BI_MASK 0x10
#define LPC_UART4_LSR_BI 0x10
#define LPC_UART4_LSR_BI_BIT 4
#define LPC_UART4_LSR_THRE_MASK 0x20
#define LPC_UART4_LSR_THRE 0x20
#define LPC_UART4_LSR_THRE_BIT 5
#define LPC_UART4_LSR_TEMT_MASK 0x40
#define LPC_UART4_LSR_TEMT 0x40
#define LPC_UART4_LSR_TEMT_BIT 6
#define LPC_UART4_LSR_RXFE_MASK 0x80
#define LPC_UART4_LSR_RXFE 0x80
#define LPC_UART4_LSR_RXFE_BIT 7

#define LPC_UART4_SCR (*(volatile unsigned long *)0x400A401C)
#define LPC_UART4_SCR_OFFSET 0x1C
#define LPC_UART4_SCR_Pad_MASK 0xFF
#define LPC_UART4_SCR_Pad_BIT 0

#define LPC_UART4_ACR (*(volatile unsigned long *)0x400A4020)
#define LPC_UART4_ACR_OFFSET 0x20
#define LPC_UART4_ACR_START_MASK 0x1
#define LPC_UART4_ACR_START 0x1
#define LPC_UART4_ACR_START_BIT 0
#define LPC_UART4_ACR_MODE_MASK 0x2
#define LPC_UART4_ACR_MODE 0x2
#define LPC_UART4_ACR_MODE_BIT 1
#define LPC_UART4_ACR_AUTORESTART_MASK 0x4
#define LPC_UART4_ACR_AUTORESTART 0x4
#define LPC_UART4_ACR_AUTORESTART_BIT 2
#define LPC_UART4_ACR_ABEOINTCLR_MASK 0x100
#define LPC_UART4_ACR_ABEOINTCLR 0x100
#define LPC_UART4_ACR_ABEOINTCLR_BIT 8
#define LPC_UART4_ACR_ABTOINTCLR_MASK 0x200
#define LPC_UART4_ACR_ABTOINTCLR 0x200
#define LPC_UART4_ACR_ABTOINTCLR_BIT 9

#define LPC_UART4_ICR (*(volatile unsigned long *)0x400A4024)
#define LPC_UART4_ICR_OFFSET 0x24
#define LPC_UART4_ICR_IRDAEN_MASK 0x1
#define LPC_UART4_ICR_IRDAEN 0x1
#define LPC_UART4_ICR_IRDAEN_BIT 0
#define LPC_UART4_ICR_IRDAINV_MASK 0x2
#define LPC_UART4_ICR_IRDAINV 0x2
#define LPC_UART4_ICR_IRDAINV_BIT 1
#define LPC_UART4_ICR_FIXPULSEEN_MASK 0x4
#define LPC_UART4_ICR_FIXPULSEEN 0x4
#define LPC_UART4_ICR_FIXPULSEEN_BIT 2
#define LPC_UART4_ICR_PULSEDIV_MASK 0x38
#define LPC_UART4_ICR_PULSEDIV_BIT 3

#define LPC_UART4_FDR (*(volatile unsigned long *)0x400A4028)
#define LPC_UART4_FDR_OFFSET 0x28
#define LPC_UART4_FDR_DIVADDVAL_MASK 0xF
#define LPC_UART4_FDR_DIVADDVAL_BIT 0
#define LPC_UART4_FDR_MULVAL_MASK 0xF0
#define LPC_UART4_FDR_MULVAL_BIT 4

#define LPC_UART4_OSR (*(volatile unsigned long *)0x400A402C)
#define LPC_UART4_OSR_OFFSET 0x2C
#define LPC_UART4_OSR_OSFRAC_MASK 0xE
#define LPC_UART4_OSR_OSFRAC_BIT 1
#define LPC_UART4_OSR_OSINT_MASK 0xF0
#define LPC_UART4_OSR_OSINT_BIT 4
#define LPC_UART4_OSR_FDINT_MASK 0x7F00
#define LPC_UART4_OSR_FDINT_BIT 8

#define LPC_UART4_SCICTRL (*(volatile unsigned long *)0x400A4048)
#define LPC_UART4_SCICTRL_OFFSET 0x48
#define LPC_UART4_SCICTRL_SCIEN_MASK 0x1
#define LPC_UART4_SCICTRL_SCIEN 0x1
#define LPC_UART4_SCICTRL_SCIEN_BIT 0
#define LPC_UART4_SCICTRL_NACKDIS_MASK 0x2
#define LPC_UART4_SCICTRL_NACKDIS 0x2
#define LPC_UART4_SCICTRL_NACKDIS_BIT 1
#define LPC_UART4_SCICTRL_PROTSEL_MASK 0x4
#define LPC_UART4_SCICTRL_PROTSEL 0x4
#define LPC_UART4_SCICTRL_PROTSEL_BIT 2
#define LPC_UART4_SCICTRL_TXRETRY_MASK 0xE0
#define LPC_UART4_SCICTRL_TXRETRY_BIT 5
#define LPC_UART4_SCICTRL_GUARDTIME_MASK 0xFF00
#define LPC_UART4_SCICTRL_GUARDTIME_BIT 8

#define LPC_UART4_RS485CTRL (*(volatile unsigned long *)0x400A404C)
#define LPC_UART4_RS485CTRL_OFFSET 0x4C
#define LPC_UART4_RS485CTRL_NMMEN_MASK 0x1
#define LPC_UART4_RS485CTRL_NMMEN 0x1
#define LPC_UART4_RS485CTRL_NMMEN_BIT 0
#define LPC_UART4_RS485CTRL_RXDIS_MASK 0x2
#define LPC_UART4_RS485CTRL_RXDIS 0x2
#define LPC_UART4_RS485CTRL_RXDIS_BIT 1
#define LPC_UART4_RS485CTRL_AADEN_MASK 0x4
#define LPC_UART4_RS485CTRL_AADEN 0x4
#define LPC_UART4_RS485CTRL_AADEN_BIT 2
#define LPC_UART4_RS485CTRL_DCTRL_MASK 0x10
#define LPC_UART4_RS485CTRL_DCTRL 0x10
#define LPC_UART4_RS485CTRL_DCTRL_BIT 4
#define LPC_UART4_RS485CTRL_OINV_MASK 0x20
#define LPC_UART4_RS485CTRL_OINV 0x20
#define LPC_UART4_RS485CTRL_OINV_BIT 5

#define LPC_UART4_RS485ADRMATCH (*(volatile unsigned long *)0x400A4050)
#define LPC_UART4_RS485ADRMATCH_OFFSET 0x50
#define LPC_UART4_RS485ADRMATCH_ADRMATCH_MASK 0xFF
#define LPC_UART4_RS485ADRMATCH_ADRMATCH_BIT 0

#define LPC_UART4_RS485DLY (*(volatile unsigned long *)0x400A4054)
#define LPC_UART4_RS485DLY_OFFSET 0x54
#define LPC_UART4_RS485DLY_DLY_MASK 0xFF
#define LPC_UART4_RS485DLY_DLY_BIT 0

#define LPC_UART4_SYNCCTRL (*(volatile unsigned long *)0x400A4058)
#define LPC_UART4_SYNCCTRL_OFFSET 0x58
#define LPC_UART4_SYNCCTRL_SYNC_MASK 0x1
#define LPC_UART4_SYNCCTRL_SYNC 0x1
#define LPC_UART4_SYNCCTRL_SYNC_BIT 0
#define LPC_UART4_SYNCCTRL_CSRC_MASK 0x2
#define LPC_UART4_SYNCCTRL_CSRC 0x2
#define LPC_UART4_SYNCCTRL_CSRC_BIT 1
#define LPC_UART4_SYNCCTRL_FES_MASK 0x4
#define LPC_UART4_SYNCCTRL_FES 0x4
#define LPC_UART4_SYNCCTRL_FES_BIT 2
#define LPC_UART4_SYNCCTRL_TSBYPASS_MASK 0x8
#define LPC_UART4_SYNCCTRL_TSBYPASS 0x8
#define LPC_UART4_SYNCCTRL_TSBYPASS_BIT 3
#define LPC_UART4_SYNCCTRL_CSCEN_MASK 0x10
#define LPC_UART4_SYNCCTRL_CSCEN 0x10
#define LPC_UART4_SYNCCTRL_CSCEN_BIT 4
#define LPC_UART4_SYNCCTRL_SSSDIS_MASK 0x20
#define LPC_UART4_SYNCCTRL_SSSDIS 0x20
#define LPC_UART4_SYNCCTRL_SSSDIS_BIT 5
#define LPC_UART4_SYNCCTRL_CCCLR_MASK 0x40
#define LPC_UART4_SYNCCTRL_CCCLR 0x40
#define LPC_UART4_SYNCCTRL_CCCLR_BIT 6

#ifndef LPC_I2S_BASE_ADDRESS
#define LPC_I2S_BASE_ADDRESS 0x400A8000
#endif

#define LPC_I2S_DAO (*(volatile unsigned long *)0x400A8000)
#define LPC_I2S_DAO_OFFSET 0x0
#define LPC_I2S_DAO_WORDWIDTH_MASK 0x3
#define LPC_I2S_DAO_WORDWIDTH_BIT 0
#define LPC_I2S_DAO_MONO_MASK 0x4
#define LPC_I2S_DAO_MONO 0x4
#define LPC_I2S_DAO_MONO_BIT 2
#define LPC_I2S_DAO_STOP_MASK 0x8
#define LPC_I2S_DAO_STOP 0x8
#define LPC_I2S_DAO_STOP_BIT 3
#define LPC_I2S_DAO_RESET_MASK 0x10
#define LPC_I2S_DAO_RESET 0x10
#define LPC_I2S_DAO_RESET_BIT 4
#define LPC_I2S_DAO_WS_SEL_MASK 0x20
#define LPC_I2S_DAO_WS_SEL 0x20
#define LPC_I2S_DAO_WS_SEL_BIT 5
#define LPC_I2S_DAO_WS_HALFPERIOD_MASK 0x7FC0
#define LPC_I2S_DAO_WS_HALFPERIOD_BIT 6
#define LPC_I2S_DAO_MUTE_MASK 0x8000
#define LPC_I2S_DAO_MUTE 0x8000
#define LPC_I2S_DAO_MUTE_BIT 15

#define LPC_I2S_DAI (*(volatile unsigned long *)0x400A8004)
#define LPC_I2S_DAI_OFFSET 0x4
#define LPC_I2S_DAI_WORDWIDTH_MASK 0x3
#define LPC_I2S_DAI_WORDWIDTH_BIT 0
#define LPC_I2S_DAI_MONO_MASK 0x4
#define LPC_I2S_DAI_MONO 0x4
#define LPC_I2S_DAI_MONO_BIT 2
#define LPC_I2S_DAI_STOP_MASK 0x8
#define LPC_I2S_DAI_STOP 0x8
#define LPC_I2S_DAI_STOP_BIT 3
#define LPC_I2S_DAI_RESET_MASK 0x10
#define LPC_I2S_DAI_RESET 0x10
#define LPC_I2S_DAI_RESET_BIT 4
#define LPC_I2S_DAI_WS_SEL_MASK 0x20
#define LPC_I2S_DAI_WS_SEL 0x20
#define LPC_I2S_DAI_WS_SEL_BIT 5
#define LPC_I2S_DAI_WS_HALFPERIOD_MASK 0x7FC0
#define LPC_I2S_DAI_WS_HALFPERIOD_BIT 6

#define LPC_I2S_TXFIFO (*(volatile unsigned long *)0x400A8008)
#define LPC_I2S_TXFIFO_OFFSET 0x8
#define LPC_I2S_TXFIFO_I2STXFIFO_MASK 0xFFFFFFFF
#define LPC_I2S_TXFIFO_I2STXFIFO_BIT 0

#define LPC_I2S_RXFIFO (*(volatile unsigned long *)0x400A800C)
#define LPC_I2S_RXFIFO_OFFSET 0xC
#define LPC_I2S_RXFIFO_I2SRXFIFO_MASK 0xFFFFFFFF
#define LPC_I2S_RXFIFO_I2SRXFIFO_BIT 0

#define LPC_I2S_STATE (*(volatile unsigned long *)0x400A8010)
#define LPC_I2S_STATE_OFFSET 0x10
#define LPC_I2S_STATE_IRQ_MASK 0x1
#define LPC_I2S_STATE_IRQ 0x1
#define LPC_I2S_STATE_IRQ_BIT 0
#define LPC_I2S_STATE_DMAREQ1_MASK 0x2
#define LPC_I2S_STATE_DMAREQ1 0x2
#define LPC_I2S_STATE_DMAREQ1_BIT 1
#define LPC_I2S_STATE_DMAREQ2_MASK 0x4
#define LPC_I2S_STATE_DMAREQ2 0x4
#define LPC_I2S_STATE_DMAREQ2_BIT 2
#define LPC_I2S_STATE_RX_LEVEL_MASK 0xF00
#define LPC_I2S_STATE_RX_LEVEL_BIT 8
#define LPC_I2S_STATE_TX_LEVEL_MASK 0xF0000
#define LPC_I2S_STATE_TX_LEVEL_BIT 16

#define LPC_I2S_DMA1 (*(volatile unsigned long *)0x400A8014)
#define LPC_I2S_DMA1_OFFSET 0x14
#define LPC_I2S_DMA1_RX_DMA1_ENABLE_MASK 0x1
#define LPC_I2S_DMA1_RX_DMA1_ENABLE 0x1
#define LPC_I2S_DMA1_RX_DMA1_ENABLE_BIT 0
#define LPC_I2S_DMA1_TX_DMA1_ENABLE_MASK 0x2
#define LPC_I2S_DMA1_TX_DMA1_ENABLE 0x2
#define LPC_I2S_DMA1_TX_DMA1_ENABLE_BIT 1
#define LPC_I2S_DMA1_RX_DEPTH_DMA1_MASK 0xF00
#define LPC_I2S_DMA1_RX_DEPTH_DMA1_BIT 8
#define LPC_I2S_DMA1_TX_DEPTH_DMA1_MASK 0xF0000
#define LPC_I2S_DMA1_TX_DEPTH_DMA1_BIT 16

#define LPC_I2S_DMA2 (*(volatile unsigned long *)0x400A8018)
#define LPC_I2S_DMA2_OFFSET 0x18
#define LPC_I2S_DMA2_RX_DMA2_ENABLE_MASK 0x1
#define LPC_I2S_DMA2_RX_DMA2_ENABLE 0x1
#define LPC_I2S_DMA2_RX_DMA2_ENABLE_BIT 0
#define LPC_I2S_DMA2_TX_DMA2_ENABLE_MASK 0x2
#define LPC_I2S_DMA2_TX_DMA2_ENABLE 0x2
#define LPC_I2S_DMA2_TX_DMA2_ENABLE_BIT 1
#define LPC_I2S_DMA2_RX_DEPTH_DMA2_MASK 0xF00
#define LPC_I2S_DMA2_RX_DEPTH_DMA2_BIT 8
#define LPC_I2S_DMA2_TX_DEPTH_DMA2_MASK 0xF0000
#define LPC_I2S_DMA2_TX_DEPTH_DMA2_BIT 16

#define LPC_I2S_IRQ (*(volatile unsigned long *)0x400A801C)
#define LPC_I2S_IRQ_OFFSET 0x1C
#define LPC_I2S_IRQ_RX_IRQ_ENABLE_MASK 0x1
#define LPC_I2S_IRQ_RX_IRQ_ENABLE 0x1
#define LPC_I2S_IRQ_RX_IRQ_ENABLE_BIT 0
#define LPC_I2S_IRQ_TX_IRQ_ENABLE_MASK 0x2
#define LPC_I2S_IRQ_TX_IRQ_ENABLE 0x2
#define LPC_I2S_IRQ_TX_IRQ_ENABLE_BIT 1
#define LPC_I2S_IRQ_RX_DEPTH_IRQ_MASK 0xF00
#define LPC_I2S_IRQ_RX_DEPTH_IRQ_BIT 8
#define LPC_I2S_IRQ_TX_DEPTH_IRQ_MASK 0xF0000
#define LPC_I2S_IRQ_TX_DEPTH_IRQ_BIT 16

#define LPC_I2S_TXRATE (*(volatile unsigned long *)0x400A8020)
#define LPC_I2S_TXRATE_OFFSET 0x20
#define LPC_I2S_TXRATE_Y_DIVIDER_MASK 0xFF
#define LPC_I2S_TXRATE_Y_DIVIDER_BIT 0
#define LPC_I2S_TXRATE_X_DIVIDER_MASK 0xFF00
#define LPC_I2S_TXRATE_X_DIVIDER_BIT 8

#define LPC_I2S_RXRATE (*(volatile unsigned long *)0x400A8024)
#define LPC_I2S_RXRATE_OFFSET 0x24
#define LPC_I2S_RXRATE_Y_DIVIDER_MASK 0xFF
#define LPC_I2S_RXRATE_Y_DIVIDER_BIT 0
#define LPC_I2S_RXRATE_X_DIVIDER_MASK 0xFF00
#define LPC_I2S_RXRATE_X_DIVIDER_BIT 8

#define LPC_I2S_TXBITRATE (*(volatile unsigned long *)0x400A8028)
#define LPC_I2S_TXBITRATE_OFFSET 0x28
#define LPC_I2S_TXBITRATE_TX_BITRATE_MASK 0x3F
#define LPC_I2S_TXBITRATE_TX_BITRATE_BIT 0

#define LPC_I2S_RXBITRATE (*(volatile unsigned long *)0x400A802C)
#define LPC_I2S_RXBITRATE_OFFSET 0x2C
#define LPC_I2S_RXBITRATE_RX_BITRATE_MASK 0x3F
#define LPC_I2S_RXBITRATE_RX_BITRATE_BIT 0

#define LPC_I2S_TXMODE (*(volatile unsigned long *)0x400A8030)
#define LPC_I2S_TXMODE_OFFSET 0x30
#define LPC_I2S_TXMODE_TXCLKSEL_MASK 0x3
#define LPC_I2S_TXMODE_TXCLKSEL_BIT 0
#define LPC_I2S_TXMODE_TX4PIN_MASK 0x4
#define LPC_I2S_TXMODE_TX4PIN 0x4
#define LPC_I2S_TXMODE_TX4PIN_BIT 2
#define LPC_I2S_TXMODE_TXMCENA_MASK 0x8
#define LPC_I2S_TXMODE_TXMCENA 0x8
#define LPC_I2S_TXMODE_TXMCENA_BIT 3

#define LPC_I2S_RXMODE (*(volatile unsigned long *)0x400A8034)
#define LPC_I2S_RXMODE_OFFSET 0x34
#define LPC_I2S_RXMODE_RXCLKSEL_MASK 0x3
#define LPC_I2S_RXMODE_RXCLKSEL_BIT 0
#define LPC_I2S_RXMODE_RX4PIN_MASK 0x4
#define LPC_I2S_RXMODE_RX4PIN 0x4
#define LPC_I2S_RXMODE_RX4PIN_BIT 2
#define LPC_I2S_RXMODE_RXMCENA_MASK 0x8
#define LPC_I2S_RXMODE_RXMCENA 0x8
#define LPC_I2S_RXMODE_RXMCENA_BIT 3

#ifndef LPC_SSP2_BASE_ADDRESS
#define LPC_SSP2_BASE_ADDRESS 0x400AC000
#endif

#ifndef LPC_MCPWM_BASE_ADDRESS
#define LPC_MCPWM_BASE_ADDRESS 0x400B8000
#endif

#define LPC_MCPWM_CON (*(volatile unsigned long *)0x400B8000)
#define LPC_MCPWM_CON_OFFSET 0x0
#define LPC_MCPWM_CON_RUN0_MASK 0x1
#define LPC_MCPWM_CON_RUN0 0x1
#define LPC_MCPWM_CON_RUN0_BIT 0
#define LPC_MCPWM_CON_CENTER0_MASK 0x2
#define LPC_MCPWM_CON_CENTER0 0x2
#define LPC_MCPWM_CON_CENTER0_BIT 1
#define LPC_MCPWM_CON_POLA0_MASK 0x4
#define LPC_MCPWM_CON_POLA0 0x4
#define LPC_MCPWM_CON_POLA0_BIT 2
#define LPC_MCPWM_CON_DTE0_MASK 0x8
#define LPC_MCPWM_CON_DTE0 0x8
#define LPC_MCPWM_CON_DTE0_BIT 3
#define LPC_MCPWM_CON_DISUP0_MASK 0x10
#define LPC_MCPWM_CON_DISUP0 0x10
#define LPC_MCPWM_CON_DISUP0_BIT 4
#define LPC_MCPWM_CON_RUN1_MASK 0x100
#define LPC_MCPWM_CON_RUN1 0x100
#define LPC_MCPWM_CON_RUN1_BIT 8
#define LPC_MCPWM_CON_CENTER1_MASK 0x200
#define LPC_MCPWM_CON_CENTER1 0x200
#define LPC_MCPWM_CON_CENTER1_BIT 9
#define LPC_MCPWM_CON_POLA1_MASK 0x400
#define LPC_MCPWM_CON_POLA1 0x400
#define LPC_MCPWM_CON_POLA1_BIT 10
#define LPC_MCPWM_CON_DTE1_MASK 0x800
#define LPC_MCPWM_CON_DTE1 0x800
#define LPC_MCPWM_CON_DTE1_BIT 11
#define LPC_MCPWM_CON_DISUP1_MASK 0x1000
#define LPC_MCPWM_CON_DISUP1 0x1000
#define LPC_MCPWM_CON_DISUP1_BIT 12
#define LPC_MCPWM_CON_RUN2_MASK 0x10000
#define LPC_MCPWM_CON_RUN2 0x10000
#define LPC_MCPWM_CON_RUN2_BIT 16
#define LPC_MCPWM_CON_CENTER2_MASK 0x20000
#define LPC_MCPWM_CON_CENTER2 0x20000
#define LPC_MCPWM_CON_CENTER2_BIT 17
#define LPC_MCPWM_CON_POLA2_MASK 0x40000
#define LPC_MCPWM_CON_POLA2 0x40000
#define LPC_MCPWM_CON_POLA2_BIT 18
#define LPC_MCPWM_CON_DTE2_MASK 0x80000
#define LPC_MCPWM_CON_DTE2 0x80000
#define LPC_MCPWM_CON_DTE2_BIT 19
#define LPC_MCPWM_CON_DISUP2_MASK 0x100000
#define LPC_MCPWM_CON_DISUP2 0x100000
#define LPC_MCPWM_CON_DISUP2_BIT 20
#define LPC_MCPWM_CON_INVBDC_MASK 0x20000000
#define LPC_MCPWM_CON_INVBDC 0x20000000
#define LPC_MCPWM_CON_INVBDC_BIT 29
#define LPC_MCPWM_CON_ACMODE_MASK 0x40000000
#define LPC_MCPWM_CON_ACMODE 0x40000000
#define LPC_MCPWM_CON_ACMODE_BIT 30
#define LPC_MCPWM_CON_DCMODE_MASK 0x80000000
#define LPC_MCPWM_CON_DCMODE 0x80000000
#define LPC_MCPWM_CON_DCMODE_BIT 31

#define LPC_MCPWM_CON_SET (*(volatile unsigned long *)0x400B8004)
#define LPC_MCPWM_CON_SET_OFFSET 0x4
#define LPC_MCPWM_CON_SET_RUN0_SET_MASK 0x1
#define LPC_MCPWM_CON_SET_RUN0_SET 0x1
#define LPC_MCPWM_CON_SET_RUN0_SET_BIT 0
#define LPC_MCPWM_CON_SET_CENTER0_SET_MASK 0x2
#define LPC_MCPWM_CON_SET_CENTER0_SET 0x2
#define LPC_MCPWM_CON_SET_CENTER0_SET_BIT 1
#define LPC_MCPWM_CON_SET_POLA0_SET_MASK 0x4
#define LPC_MCPWM_CON_SET_POLA0_SET 0x4
#define LPC_MCPWM_CON_SET_POLA0_SET_BIT 2
#define LPC_MCPWM_CON_SET_DTE0_SET_MASK 0x8
#define LPC_MCPWM_CON_SET_DTE0_SET 0x8
#define LPC_MCPWM_CON_SET_DTE0_SET_BIT 3
#define LPC_MCPWM_CON_SET_DISUP0_SET_MASK 0x10
#define LPC_MCPWM_CON_SET_DISUP0_SET 0x10
#define LPC_MCPWM_CON_SET_DISUP0_SET_BIT 4
#define LPC_MCPWM_CON_SET_RUN1_SET_MASK 0x100
#define LPC_MCPWM_CON_SET_RUN1_SET 0x100
#define LPC_MCPWM_CON_SET_RUN1_SET_BIT 8
#define LPC_MCPWM_CON_SET_CENTER1_SET_MASK 0x200
#define LPC_MCPWM_CON_SET_CENTER1_SET 0x200
#define LPC_MCPWM_CON_SET_CENTER1_SET_BIT 9
#define LPC_MCPWM_CON_SET_POLA1_SET_MASK 0x400
#define LPC_MCPWM_CON_SET_POLA1_SET 0x400
#define LPC_MCPWM_CON_SET_POLA1_SET_BIT 10
#define LPC_MCPWM_CON_SET_DTE1_SET_MASK 0x800
#define LPC_MCPWM_CON_SET_DTE1_SET 0x800
#define LPC_MCPWM_CON_SET_DTE1_SET_BIT 11
#define LPC_MCPWM_CON_SET_DISUP1_SET_MASK 0x1000
#define LPC_MCPWM_CON_SET_DISUP1_SET 0x1000
#define LPC_MCPWM_CON_SET_DISUP1_SET_BIT 12
#define LPC_MCPWM_CON_SET_RUN2_SET_MASK 0x10000
#define LPC_MCPWM_CON_SET_RUN2_SET 0x10000
#define LPC_MCPWM_CON_SET_RUN2_SET_BIT 16
#define LPC_MCPWM_CON_SET_CENTER2_SET_MASK 0x20000
#define LPC_MCPWM_CON_SET_CENTER2_SET 0x20000
#define LPC_MCPWM_CON_SET_CENTER2_SET_BIT 17
#define LPC_MCPWM_CON_SET_POLA2_SET_MASK 0x40000
#define LPC_MCPWM_CON_SET_POLA2_SET 0x40000
#define LPC_MCPWM_CON_SET_POLA2_SET_BIT 18
#define LPC_MCPWM_CON_SET_DTE2_SET_MASK 0x80000
#define LPC_MCPWM_CON_SET_DTE2_SET 0x80000
#define LPC_MCPWM_CON_SET_DTE2_SET_BIT 19
#define LPC_MCPWM_CON_SET_DISUP2_SET_MASK 0x100000
#define LPC_MCPWM_CON_SET_DISUP2_SET 0x100000
#define LPC_MCPWM_CON_SET_DISUP2_SET_BIT 20
#define LPC_MCPWM_CON_SET_INVBDC_SET_MASK 0x20000000
#define LPC_MCPWM_CON_SET_INVBDC_SET 0x20000000
#define LPC_MCPWM_CON_SET_INVBDC_SET_BIT 29
#define LPC_MCPWM_CON_SET_ACMODE_SET_MASK 0x40000000
#define LPC_MCPWM_CON_SET_ACMODE_SET 0x40000000
#define LPC_MCPWM_CON_SET_ACMODE_SET_BIT 30
#define LPC_MCPWM_CON_SET_DCMODE_SET_MASK 0x80000000
#define LPC_MCPWM_CON_SET_DCMODE_SET 0x80000000
#define LPC_MCPWM_CON_SET_DCMODE_SET_BIT 31

#define LPC_MCPWM_CON_CLR (*(volatile unsigned long *)0x400B8008)
#define LPC_MCPWM_CON_CLR_OFFSET 0x8
#define LPC_MCPWM_CON_CLR_RUN0_CLR_MASK 0x1
#define LPC_MCPWM_CON_CLR_RUN0_CLR 0x1
#define LPC_MCPWM_CON_CLR_RUN0_CLR_BIT 0
#define LPC_MCPWM_CON_CLR_CENTER0_CLR_MASK 0x2
#define LPC_MCPWM_CON_CLR_CENTER0_CLR 0x2
#define LPC_MCPWM_CON_CLR_CENTER0_CLR_BIT 1
#define LPC_MCPWM_CON_CLR_POLA0_CLR_MASK 0x4
#define LPC_MCPWM_CON_CLR_POLA0_CLR 0x4
#define LPC_MCPWM_CON_CLR_POLA0_CLR_BIT 2
#define LPC_MCPWM_CON_CLR_DTE0_CLR_MASK 0x8
#define LPC_MCPWM_CON_CLR_DTE0_CLR 0x8
#define LPC_MCPWM_CON_CLR_DTE0_CLR_BIT 3
#define LPC_MCPWM_CON_CLR_DISUP0_CLR_MASK 0x10
#define LPC_MCPWM_CON_CLR_DISUP0_CLR 0x10
#define LPC_MCPWM_CON_CLR_DISUP0_CLR_BIT 4
#define LPC_MCPWM_CON_CLR_RUN1_CLR_MASK 0x100
#define LPC_MCPWM_CON_CLR_RUN1_CLR 0x100
#define LPC_MCPWM_CON_CLR_RUN1_CLR_BIT 8
#define LPC_MCPWM_CON_CLR_CENTER1_CLR_MASK 0x200
#define LPC_MCPWM_CON_CLR_CENTER1_CLR 0x200
#define LPC_MCPWM_CON_CLR_CENTER1_CLR_BIT 9
#define LPC_MCPWM_CON_CLR_POLA1_CLR_MASK 0x400
#define LPC_MCPWM_CON_CLR_POLA1_CLR 0x400
#define LPC_MCPWM_CON_CLR_POLA1_CLR_BIT 10
#define LPC_MCPWM_CON_CLR_DTE1_CLR_MASK 0x800
#define LPC_MCPWM_CON_CLR_DTE1_CLR 0x800
#define LPC_MCPWM_CON_CLR_DTE1_CLR_BIT 11
#define LPC_MCPWM_CON_CLR_DISUP1_CLR_MASK 0x1000
#define LPC_MCPWM_CON_CLR_DISUP1_CLR 0x1000
#define LPC_MCPWM_CON_CLR_DISUP1_CLR_BIT 12
#define LPC_MCPWM_CON_CLR_RUN2_CLR_MASK 0x10000
#define LPC_MCPWM_CON_CLR_RUN2_CLR 0x10000
#define LPC_MCPWM_CON_CLR_RUN2_CLR_BIT 16
#define LPC_MCPWM_CON_CLR_CENTER2_CLR_MASK 0x20000
#define LPC_MCPWM_CON_CLR_CENTER2_CLR 0x20000
#define LPC_MCPWM_CON_CLR_CENTER2_CLR_BIT 17
#define LPC_MCPWM_CON_CLR_POLA2_CLR_MASK 0x40000
#define LPC_MCPWM_CON_CLR_POLA2_CLR 0x40000
#define LPC_MCPWM_CON_CLR_POLA2_CLR_BIT 18
#define LPC_MCPWM_CON_CLR_DTE2_CLR_MASK 0x80000
#define LPC_MCPWM_CON_CLR_DTE2_CLR 0x80000
#define LPC_MCPWM_CON_CLR_DTE2_CLR_BIT 19
#define LPC_MCPWM_CON_CLR_DISUP2_CLR_MASK 0x100000
#define LPC_MCPWM_CON_CLR_DISUP2_CLR 0x100000
#define LPC_MCPWM_CON_CLR_DISUP2_CLR_BIT 20
#define LPC_MCPWM_CON_CLR_INVBDC_CLR_MASK 0x20000000
#define LPC_MCPWM_CON_CLR_INVBDC_CLR 0x20000000
#define LPC_MCPWM_CON_CLR_INVBDC_CLR_BIT 29
#define LPC_MCPWM_CON_CLR_ACMOD_CLR_MASK 0x40000000
#define LPC_MCPWM_CON_CLR_ACMOD_CLR 0x40000000
#define LPC_MCPWM_CON_CLR_ACMOD_CLR_BIT 30
#define LPC_MCPWM_CON_CLR_DCMODE_CLR_MASK 0x80000000
#define LPC_MCPWM_CON_CLR_DCMODE_CLR 0x80000000
#define LPC_MCPWM_CON_CLR_DCMODE_CLR_BIT 31

#define LPC_MCPWM_CAPCON (*(volatile unsigned long *)0x400B800C)
#define LPC_MCPWM_CAPCON_OFFSET 0xC
#define LPC_MCPWM_CAPCON_CAP0MCI0_RE_MASK 0x1
#define LPC_MCPWM_CAPCON_CAP0MCI0_RE 0x1
#define LPC_MCPWM_CAPCON_CAP0MCI0_RE_BIT 0
#define LPC_MCPWM_CAPCON_CAP0MCI0_FE_MASK 0x2
#define LPC_MCPWM_CAPCON_CAP0MCI0_FE 0x2
#define LPC_MCPWM_CAPCON_CAP0MCI0_FE_BIT 1
#define LPC_MCPWM_CAPCON_CAP0MCI1_RE_MASK 0x4
#define LPC_MCPWM_CAPCON_CAP0MCI1_RE 0x4
#define LPC_MCPWM_CAPCON_CAP0MCI1_RE_BIT 2
#define LPC_MCPWM_CAPCON_CAP0MCI1_FE_MASK 0x8
#define LPC_MCPWM_CAPCON_CAP0MCI1_FE 0x8
#define LPC_MCPWM_CAPCON_CAP0MCI1_FE_BIT 3
#define LPC_MCPWM_CAPCON_CAP0MCI2_RE_MASK 0x10
#define LPC_MCPWM_CAPCON_CAP0MCI2_RE 0x10
#define LPC_MCPWM_CAPCON_CAP0MCI2_RE_BIT 4
#define LPC_MCPWM_CAPCON_CAP0MCI2_FE_MASK 0x20
#define LPC_MCPWM_CAPCON_CAP0MCI2_FE 0x20
#define LPC_MCPWM_CAPCON_CAP0MCI2_FE_BIT 5
#define LPC_MCPWM_CAPCON_CAP1MCI0_RE_MASK 0x40
#define LPC_MCPWM_CAPCON_CAP1MCI0_RE 0x40
#define LPC_MCPWM_CAPCON_CAP1MCI0_RE_BIT 6
#define LPC_MCPWM_CAPCON_CAP1MCI0_FE_MASK 0x80
#define LPC_MCPWM_CAPCON_CAP1MCI0_FE 0x80
#define LPC_MCPWM_CAPCON_CAP1MCI0_FE_BIT 7
#define LPC_MCPWM_CAPCON_CAP1MCI1_RE_MASK 0x100
#define LPC_MCPWM_CAPCON_CAP1MCI1_RE 0x100
#define LPC_MCPWM_CAPCON_CAP1MCI1_RE_BIT 8
#define LPC_MCPWM_CAPCON_CAP1MCI1_FE_MASK 0x200
#define LPC_MCPWM_CAPCON_CAP1MCI1_FE 0x200
#define LPC_MCPWM_CAPCON_CAP1MCI1_FE_BIT 9
#define LPC_MCPWM_CAPCON_CAP1MCI2_RE_MASK 0x400
#define LPC_MCPWM_CAPCON_CAP1MCI2_RE 0x400
#define LPC_MCPWM_CAPCON_CAP1MCI2_RE_BIT 10
#define LPC_MCPWM_CAPCON_CAP1MCI2_FE_MASK 0x800
#define LPC_MCPWM_CAPCON_CAP1MCI2_FE 0x800
#define LPC_MCPWM_CAPCON_CAP1MCI2_FE_BIT 11
#define LPC_MCPWM_CAPCON_CAP2MCI0_RE_MASK 0x1000
#define LPC_MCPWM_CAPCON_CAP2MCI0_RE 0x1000
#define LPC_MCPWM_CAPCON_CAP2MCI0_RE_BIT 12
#define LPC_MCPWM_CAPCON_CAP2MCI0_FE_MASK 0x2000
#define LPC_MCPWM_CAPCON_CAP2MCI0_FE 0x2000
#define LPC_MCPWM_CAPCON_CAP2MCI0_FE_BIT 13
#define LPC_MCPWM_CAPCON_CAP2MCI1_RE_MASK 0x4000
#define LPC_MCPWM_CAPCON_CAP2MCI1_RE 0x4000
#define LPC_MCPWM_CAPCON_CAP2MCI1_RE_BIT 14
#define LPC_MCPWM_CAPCON_CAP2MCI1_FE_MASK 0x8000
#define LPC_MCPWM_CAPCON_CAP2MCI1_FE 0x8000
#define LPC_MCPWM_CAPCON_CAP2MCI1_FE_BIT 15
#define LPC_MCPWM_CAPCON_CAP2MCI2_RE_MASK 0x10000
#define LPC_MCPWM_CAPCON_CAP2MCI2_RE 0x10000
#define LPC_MCPWM_CAPCON_CAP2MCI2_RE_BIT 16
#define LPC_MCPWM_CAPCON_CAP2MCI2_FE_MASK 0x20000
#define LPC_MCPWM_CAPCON_CAP2MCI2_FE 0x20000
#define LPC_MCPWM_CAPCON_CAP2MCI2_FE_BIT 17
#define LPC_MCPWM_CAPCON_RT0_MASK 0x40000
#define LPC_MCPWM_CAPCON_RT0 0x40000
#define LPC_MCPWM_CAPCON_RT0_BIT 18
#define LPC_MCPWM_CAPCON_RT1_MASK 0x80000
#define LPC_MCPWM_CAPCON_RT1 0x80000
#define LPC_MCPWM_CAPCON_RT1_BIT 19
#define LPC_MCPWM_CAPCON_RT2_MASK 0x100000
#define LPC_MCPWM_CAPCON_RT2 0x100000
#define LPC_MCPWM_CAPCON_RT2_BIT 20

#define LPC_MCPWM_CAPCON_SET (*(volatile unsigned long *)0x400B8010)
#define LPC_MCPWM_CAPCON_SET_OFFSET 0x10
#define LPC_MCPWM_CAPCON_SET_CAP0MCI0_RE_SET_MASK 0x1
#define LPC_MCPWM_CAPCON_SET_CAP0MCI0_RE_SET 0x1
#define LPC_MCPWM_CAPCON_SET_CAP0MCI0_RE_SET_BIT 0
#define LPC_MCPWM_CAPCON_SET_CAP0MCI0_FE_SET_MASK 0x2
#define LPC_MCPWM_CAPCON_SET_CAP0MCI0_FE_SET 0x2
#define LPC_MCPWM_CAPCON_SET_CAP0MCI0_FE_SET_BIT 1
#define LPC_MCPWM_CAPCON_SET_CAP0MCI1_RE_SET_MASK 0x4
#define LPC_MCPWM_CAPCON_SET_CAP0MCI1_RE_SET 0x4
#define LPC_MCPWM_CAPCON_SET_CAP0MCI1_RE_SET_BIT 2
#define LPC_MCPWM_CAPCON_SET_CAP0MCI1_FE_SET_MASK 0x8
#define LPC_MCPWM_CAPCON_SET_CAP0MCI1_FE_SET 0x8
#define LPC_MCPWM_CAPCON_SET_CAP0MCI1_FE_SET_BIT 3
#define LPC_MCPWM_CAPCON_SET_CAP0MCI2_RE_SET_MASK 0x10
#define LPC_MCPWM_CAPCON_SET_CAP0MCI2_RE_SET 0x10
#define LPC_MCPWM_CAPCON_SET_CAP0MCI2_RE_SET_BIT 4
#define LPC_MCPWM_CAPCON_SET_CAP0MCI2_FE_SET_MASK 0x20
#define LPC_MCPWM_CAPCON_SET_CAP0MCI2_FE_SET 0x20
#define LPC_MCPWM_CAPCON_SET_CAP0MCI2_FE_SET_BIT 5
#define LPC_MCPWM_CAPCON_SET_CAP1MCI0_RE_SET_MASK 0x40
#define LPC_MCPWM_CAPCON_SET_CAP1MCI0_RE_SET 0x40
#define LPC_MCPWM_CAPCON_SET_CAP1MCI0_RE_SET_BIT 6
#define LPC_MCPWM_CAPCON_SET_CAP1MCI0_FE_SET_MASK 0x80
#define LPC_MCPWM_CAPCON_SET_CAP1MCI0_FE_SET 0x80
#define LPC_MCPWM_CAPCON_SET_CAP1MCI0_FE_SET_BIT 7
#define LPC_MCPWM_CAPCON_SET_CAP1MCI1_RE_SET_MASK 0x100
#define LPC_MCPWM_CAPCON_SET_CAP1MCI1_RE_SET 0x100
#define LPC_MCPWM_CAPCON_SET_CAP1MCI1_RE_SET_BIT 8
#define LPC_MCPWM_CAPCON_SET_CAP1MCI1_FE_SET_MASK 0x200
#define LPC_MCPWM_CAPCON_SET_CAP1MCI1_FE_SET 0x200
#define LPC_MCPWM_CAPCON_SET_CAP1MCI1_FE_SET_BIT 9
#define LPC_MCPWM_CAPCON_SET_CAP1MCI2_RE_SET_MASK 0x400
#define LPC_MCPWM_CAPCON_SET_CAP1MCI2_RE_SET 0x400
#define LPC_MCPWM_CAPCON_SET_CAP1MCI2_RE_SET_BIT 10
#define LPC_MCPWM_CAPCON_SET_CAP1MCI2_FE_SET_MASK 0x800
#define LPC_MCPWM_CAPCON_SET_CAP1MCI2_FE_SET 0x800
#define LPC_MCPWM_CAPCON_SET_CAP1MCI2_FE_SET_BIT 11
#define LPC_MCPWM_CAPCON_SET_CAP2MCI0_RE_SET_MASK 0x1000
#define LPC_MCPWM_CAPCON_SET_CAP2MCI0_RE_SET 0x1000
#define LPC_MCPWM_CAPCON_SET_CAP2MCI0_RE_SET_BIT 12
#define LPC_MCPWM_CAPCON_SET_CAP2MCI0_FE_SET_MASK 0x2000
#define LPC_MCPWM_CAPCON_SET_CAP2MCI0_FE_SET 0x2000
#define LPC_MCPWM_CAPCON_SET_CAP2MCI0_FE_SET_BIT 13
#define LPC_MCPWM_CAPCON_SET_CAP2MCI1_RE_SET_MASK 0x4000
#define LPC_MCPWM_CAPCON_SET_CAP2MCI1_RE_SET 0x4000
#define LPC_MCPWM_CAPCON_SET_CAP2MCI1_RE_SET_BIT 14
#define LPC_MCPWM_CAPCON_SET_CAP2MCI1_FE_SET_MASK 0x8000
#define LPC_MCPWM_CAPCON_SET_CAP2MCI1_FE_SET 0x8000
#define LPC_MCPWM_CAPCON_SET_CAP2MCI1_FE_SET_BIT 15
#define LPC_MCPWM_CAPCON_SET_CAP2MCI2_RE_SET_MASK 0x10000
#define LPC_MCPWM_CAPCON_SET_CAP2MCI2_RE_SET 0x10000
#define LPC_MCPWM_CAPCON_SET_CAP2MCI2_RE_SET_BIT 16
#define LPC_MCPWM_CAPCON_SET_CAP2MCI2_FE_SET_MASK 0x20000
#define LPC_MCPWM_CAPCON_SET_CAP2MCI2_FE_SET 0x20000
#define LPC_MCPWM_CAPCON_SET_CAP2MCI2_FE_SET_BIT 17
#define LPC_MCPWM_CAPCON_SET_RT0_SET_MASK 0x40000
#define LPC_MCPWM_CAPCON_SET_RT0_SET 0x40000
#define LPC_MCPWM_CAPCON_SET_RT0_SET_BIT 18
#define LPC_MCPWM_CAPCON_SET_RT1_SET_MASK 0x80000
#define LPC_MCPWM_CAPCON_SET_RT1_SET 0x80000
#define LPC_MCPWM_CAPCON_SET_RT1_SET_BIT 19
#define LPC_MCPWM_CAPCON_SET_RT2_SET_MASK 0x100000
#define LPC_MCPWM_CAPCON_SET_RT2_SET 0x100000
#define LPC_MCPWM_CAPCON_SET_RT2_SET_BIT 20

#define LPC_MCPWM_CAPCON_CLR (*(volatile unsigned long *)0x400B8014)
#define LPC_MCPWM_CAPCON_CLR_OFFSET 0x14
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI0_RE_CLR_MASK 0x1
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI0_RE_CLR 0x1
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI0_RE_CLR_BIT 0
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI0_FE_CLR_MASK 0x2
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI0_FE_CLR 0x2
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI0_FE_CLR_BIT 1
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI1_RE_CLR_MASK 0x4
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI1_RE_CLR 0x4
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI1_RE_CLR_BIT 2
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI1_FE_CLR_MASK 0x8
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI1_FE_CLR 0x8
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI1_FE_CLR_BIT 3
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI2_RE_CLR_MASK 0x10
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI2_RE_CLR 0x10
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI2_RE_CLR_BIT 4
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI2_FE_CLR_MASK 0x20
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI2_FE_CLR 0x20
#define LPC_MCPWM_CAPCON_CLR_CAP0MCI2_FE_CLR_BIT 5
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI0_RE_CLR_MASK 0x40
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI0_RE_CLR 0x40
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI0_RE_CLR_BIT 6
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI0_FE_CLR_MASK 0x80
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI0_FE_CLR 0x80
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI0_FE_CLR_BIT 7
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI1_RE_CLR_MASK 0x100
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI1_RE_CLR 0x100
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI1_RE_CLR_BIT 8
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI1_FE_CLR_MASK 0x200
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI1_FE_CLR 0x200
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI1_FE_CLR_BIT 9
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI2_RE_CLR_MASK 0x400
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI2_RE_CLR 0x400
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI2_RE_CLR_BIT 10
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI2_FE_CLR_MASK 0x800
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI2_FE_CLR 0x800
#define LPC_MCPWM_CAPCON_CLR_CAP1MCI2_FE_CLR_BIT 11
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI0_RE_CLR_MASK 0x1000
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI0_RE_CLR 0x1000
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI0_RE_CLR_BIT 12
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI0_FE_CLR_MASK 0x2000
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI0_FE_CLR 0x2000
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI0_FE_CLR_BIT 13
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI1_RE_CLR_MASK 0x4000
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI1_RE_CLR 0x4000
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI1_RE_CLR_BIT 14
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI1_FE_CLR_MASK 0x8000
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI1_FE_CLR 0x8000
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI1_FE_CLR_BIT 15
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI2_RE_CLR_MASK 0x10000
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI2_RE_CLR 0x10000
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI2_RE_CLR_BIT 16
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI2_FE_CLR_MASK 0x20000
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI2_FE_CLR 0x20000
#define LPC_MCPWM_CAPCON_CLR_CAP2MCI2_FE_CLR_BIT 17
#define LPC_MCPWM_CAPCON_CLR_RT0_CLR_MASK 0x40000
#define LPC_MCPWM_CAPCON_CLR_RT0_CLR 0x40000
#define LPC_MCPWM_CAPCON_CLR_RT0_CLR_BIT 18
#define LPC_MCPWM_CAPCON_CLR_RT1_CLR_MASK 0x80000
#define LPC_MCPWM_CAPCON_CLR_RT1_CLR 0x80000
#define LPC_MCPWM_CAPCON_CLR_RT1_CLR_BIT 19
#define LPC_MCPWM_CAPCON_CLR_RT2_CLR_MASK 0x100000
#define LPC_MCPWM_CAPCON_CLR_RT2_CLR 0x100000
#define LPC_MCPWM_CAPCON_CLR_RT2_CLR_BIT 20

#define LPC_MCPWM_TC0 (*(volatile unsigned long *)0x400B8018)
#define LPC_MCPWM_TC0_OFFSET 0x18
#define LPC_MCPWM_TC0_MCTC_MASK 0xFFFFFFFF
#define LPC_MCPWM_TC0_MCTC_BIT 0

#define LPC_MCPWM_TC1 (*(volatile unsigned long *)0x400B801C)
#define LPC_MCPWM_TC1_OFFSET 0x1C
#define LPC_MCPWM_TC1_MCTC_MASK 0xFFFFFFFF
#define LPC_MCPWM_TC1_MCTC_BIT 0

#define LPC_MCPWM_TC2 (*(volatile unsigned long *)0x400B8020)
#define LPC_MCPWM_TC2_OFFSET 0x20
#define LPC_MCPWM_TC2_MCTC_MASK 0xFFFFFFFF
#define LPC_MCPWM_TC2_MCTC_BIT 0

#define LPC_MCPWM_LIM0 (*(volatile unsigned long *)0x400B8024)
#define LPC_MCPWM_LIM0_OFFSET 0x24
#define LPC_MCPWM_LIM0_MCLIM_MASK 0xFFFFFFFF
#define LPC_MCPWM_LIM0_MCLIM_BIT 0

#define LPC_MCPWM_LIM1 (*(volatile unsigned long *)0x400B8028)
#define LPC_MCPWM_LIM1_OFFSET 0x28
#define LPC_MCPWM_LIM1_MCLIM_MASK 0xFFFFFFFF
#define LPC_MCPWM_LIM1_MCLIM_BIT 0

#define LPC_MCPWM_LIM2 (*(volatile unsigned long *)0x400B802C)
#define LPC_MCPWM_LIM2_OFFSET 0x2C
#define LPC_MCPWM_LIM2_MCLIM_MASK 0xFFFFFFFF
#define LPC_MCPWM_LIM2_MCLIM_BIT 0

#define LPC_MCPWM_MAT0 (*(volatile unsigned long *)0x400B8030)
#define LPC_MCPWM_MAT0_OFFSET 0x30
#define LPC_MCPWM_MAT0_MCMAT_MASK 0xFFFFFFFF
#define LPC_MCPWM_MAT0_MCMAT_BIT 0

#define LPC_MCPWM_MAT1 (*(volatile unsigned long *)0x400B8034)
#define LPC_MCPWM_MAT1_OFFSET 0x34
#define LPC_MCPWM_MAT1_MCMAT_MASK 0xFFFFFFFF
#define LPC_MCPWM_MAT1_MCMAT_BIT 0

#define LPC_MCPWM_MAT2 (*(volatile unsigned long *)0x400B8038)
#define LPC_MCPWM_MAT2_OFFSET 0x38
#define LPC_MCPWM_MAT2_MCMAT_MASK 0xFFFFFFFF
#define LPC_MCPWM_MAT2_MCMAT_BIT 0

#define LPC_MCPWM_DT (*(volatile unsigned long *)0x400B803C)
#define LPC_MCPWM_DT_OFFSET 0x3C
#define LPC_MCPWM_DT_DT0_MASK 0x3FF
#define LPC_MCPWM_DT_DT0_BIT 0
#define LPC_MCPWM_DT_DT1_MASK 0xFFC00
#define LPC_MCPWM_DT_DT1_BIT 10
#define LPC_MCPWM_DT_DT2_MASK 0x3FF00000
#define LPC_MCPWM_DT_DT2_BIT 20

#define LPC_MCPWM_CCP (*(volatile unsigned long *)0x400B8040)
#define LPC_MCPWM_CCP_OFFSET 0x40
#define LPC_MCPWM_CCP_CCPA0_MASK 0x1
#define LPC_MCPWM_CCP_CCPA0 0x1
#define LPC_MCPWM_CCP_CCPA0_BIT 0
#define LPC_MCPWM_CCP_CCPB0_MASK 0x2
#define LPC_MCPWM_CCP_CCPB0 0x2
#define LPC_MCPWM_CCP_CCPB0_BIT 1
#define LPC_MCPWM_CCP_CCPA1_MASK 0x4
#define LPC_MCPWM_CCP_CCPA1 0x4
#define LPC_MCPWM_CCP_CCPA1_BIT 2
#define LPC_MCPWM_CCP_CCPB1_MASK 0x8
#define LPC_MCPWM_CCP_CCPB1 0x8
#define LPC_MCPWM_CCP_CCPB1_BIT 3
#define LPC_MCPWM_CCP_CCPA2_MASK 0x10
#define LPC_MCPWM_CCP_CCPA2 0x10
#define LPC_MCPWM_CCP_CCPA2_BIT 4
#define LPC_MCPWM_CCP_CCPB2_MASK 0x20
#define LPC_MCPWM_CCP_CCPB2 0x20
#define LPC_MCPWM_CCP_CCPB2_BIT 5

#define LPC_MCPWM_CAP0 (*(volatile unsigned long *)0x400B8044)
#define LPC_MCPWM_CAP0_OFFSET 0x44
#define LPC_MCPWM_CAP0_CAP_MASK 0xFFFFFFFF
#define LPC_MCPWM_CAP0_CAP_BIT 0

#define LPC_MCPWM_CAP1 (*(volatile unsigned long *)0x400B8048)
#define LPC_MCPWM_CAP1_OFFSET 0x48
#define LPC_MCPWM_CAP1_CAP_MASK 0xFFFFFFFF
#define LPC_MCPWM_CAP1_CAP_BIT 0

#define LPC_MCPWM_CAP2 (*(volatile unsigned long *)0x400B804C)
#define LPC_MCPWM_CAP2_OFFSET 0x4C
#define LPC_MCPWM_CAP2_CAP_MASK 0xFFFFFFFF
#define LPC_MCPWM_CAP2_CAP_BIT 0

#define LPC_MCPWM_INTEN (*(volatile unsigned long *)0x400B8050)
#define LPC_MCPWM_INTEN_OFFSET 0x50
#define LPC_MCPWM_INTEN_ILIM0_MASK 0x1
#define LPC_MCPWM_INTEN_ILIM0 0x1
#define LPC_MCPWM_INTEN_ILIM0_BIT 0
#define LPC_MCPWM_INTEN_IMAT0_MASK 0x2
#define LPC_MCPWM_INTEN_IMAT0 0x2
#define LPC_MCPWM_INTEN_IMAT0_BIT 1
#define LPC_MCPWM_INTEN_ICAP0_MASK 0x4
#define LPC_MCPWM_INTEN_ICAP0 0x4
#define LPC_MCPWM_INTEN_ICAP0_BIT 2
#define LPC_MCPWM_INTEN_ILIM1_MASK 0x10
#define LPC_MCPWM_INTEN_ILIM1 0x10
#define LPC_MCPWM_INTEN_ILIM1_BIT 4
#define LPC_MCPWM_INTEN_IMAT1_MASK 0x20
#define LPC_MCPWM_INTEN_IMAT1 0x20
#define LPC_MCPWM_INTEN_IMAT1_BIT 5
#define LPC_MCPWM_INTEN_ICAP1_MASK 0x40
#define LPC_MCPWM_INTEN_ICAP1 0x40
#define LPC_MCPWM_INTEN_ICAP1_BIT 6
#define LPC_MCPWM_INTEN_ILIM2_MASK 0x100
#define LPC_MCPWM_INTEN_ILIM2 0x100
#define LPC_MCPWM_INTEN_ILIM2_BIT 8
#define LPC_MCPWM_INTEN_IMAT2_MASK 0x200
#define LPC_MCPWM_INTEN_IMAT2 0x200
#define LPC_MCPWM_INTEN_IMAT2_BIT 9
#define LPC_MCPWM_INTEN_ICAP2_MASK 0x400
#define LPC_MCPWM_INTEN_ICAP2 0x400
#define LPC_MCPWM_INTEN_ICAP2_BIT 10
#define LPC_MCPWM_INTEN_ABORT_MASK 0x8000
#define LPC_MCPWM_INTEN_ABORT 0x8000
#define LPC_MCPWM_INTEN_ABORT_BIT 15

#define LPC_MCPWM_INTEN_SET (*(volatile unsigned long *)0x400B8054)
#define LPC_MCPWM_INTEN_SET_OFFSET 0x54
#define LPC_MCPWM_INTEN_SET_ILIM0_SET_MASK 0x1
#define LPC_MCPWM_INTEN_SET_ILIM0_SET 0x1
#define LPC_MCPWM_INTEN_SET_ILIM0_SET_BIT 0
#define LPC_MCPWM_INTEN_SET_IMAT0_SET_MASK 0x2
#define LPC_MCPWM_INTEN_SET_IMAT0_SET 0x2
#define LPC_MCPWM_INTEN_SET_IMAT0_SET_BIT 1
#define LPC_MCPWM_INTEN_SET_ICAP0_SET_MASK 0x4
#define LPC_MCPWM_INTEN_SET_ICAP0_SET 0x4
#define LPC_MCPWM_INTEN_SET_ICAP0_SET_BIT 2
#define LPC_MCPWM_INTEN_SET_ILIM1_SET_MASK 0x10
#define LPC_MCPWM_INTEN_SET_ILIM1_SET 0x10
#define LPC_MCPWM_INTEN_SET_ILIM1_SET_BIT 4
#define LPC_MCPWM_INTEN_SET_IMAT1_SET_MASK 0x20
#define LPC_MCPWM_INTEN_SET_IMAT1_SET 0x20
#define LPC_MCPWM_INTEN_SET_IMAT1_SET_BIT 5
#define LPC_MCPWM_INTEN_SET_ICAP1_SET_MASK 0x40
#define LPC_MCPWM_INTEN_SET_ICAP1_SET 0x40
#define LPC_MCPWM_INTEN_SET_ICAP1_SET_BIT 6
#define LPC_MCPWM_INTEN_SET_ILIM2_SET_MASK 0x200
#define LPC_MCPWM_INTEN_SET_ILIM2_SET 0x200
#define LPC_MCPWM_INTEN_SET_ILIM2_SET_BIT 9
#define LPC_MCPWM_INTEN_SET_IMAT2_SET_MASK 0x400
#define LPC_MCPWM_INTEN_SET_IMAT2_SET 0x400
#define LPC_MCPWM_INTEN_SET_IMAT2_SET_BIT 10
#define LPC_MCPWM_INTEN_SET_ICAP2_SET_MASK 0x800
#define LPC_MCPWM_INTEN_SET_ICAP2_SET 0x800
#define LPC_MCPWM_INTEN_SET_ICAP2_SET_BIT 11
#define LPC_MCPWM_INTEN_SET_ABORT_SET_MASK 0x8000
#define LPC_MCPWM_INTEN_SET_ABORT_SET 0x8000
#define LPC_MCPWM_INTEN_SET_ABORT_SET_BIT 15

#define LPC_MCPWM_INTEN_CLR (*(volatile unsigned long *)0x400B8058)
#define LPC_MCPWM_INTEN_CLR_OFFSET 0x58
#define LPC_MCPWM_INTEN_CLR_ILIM0_CLR_MASK 0x1
#define LPC_MCPWM_INTEN_CLR_ILIM0_CLR 0x1
#define LPC_MCPWM_INTEN_CLR_ILIM0_CLR_BIT 0
#define LPC_MCPWM_INTEN_CLR_IMAT0_CLR_MASK 0x2
#define LPC_MCPWM_INTEN_CLR_IMAT0_CLR 0x2
#define LPC_MCPWM_INTEN_CLR_IMAT0_CLR_BIT 1
#define LPC_MCPWM_INTEN_CLR_ICAP0_CLR_MASK 0x4
#define LPC_MCPWM_INTEN_CLR_ICAP0_CLR 0x4
#define LPC_MCPWM_INTEN_CLR_ICAP0_CLR_BIT 2
#define LPC_MCPWM_INTEN_CLR_ILIM1_CLR_MASK 0x10
#define LPC_MCPWM_INTEN_CLR_ILIM1_CLR 0x10
#define LPC_MCPWM_INTEN_CLR_ILIM1_CLR_BIT 4
#define LPC_MCPWM_INTEN_CLR_IMAT1_CLR_MASK 0x20
#define LPC_MCPWM_INTEN_CLR_IMAT1_CLR 0x20
#define LPC_MCPWM_INTEN_CLR_IMAT1_CLR_BIT 5
#define LPC_MCPWM_INTEN_CLR_ICAP1_CLR_MASK 0x40
#define LPC_MCPWM_INTEN_CLR_ICAP1_CLR 0x40
#define LPC_MCPWM_INTEN_CLR_ICAP1_CLR_BIT 6
#define LPC_MCPWM_INTEN_CLR_ILIM2_CLR_MASK 0x100
#define LPC_MCPWM_INTEN_CLR_ILIM2_CLR 0x100
#define LPC_MCPWM_INTEN_CLR_ILIM2_CLR_BIT 8
#define LPC_MCPWM_INTEN_CLR_IMAT2_CLR_MASK 0x200
#define LPC_MCPWM_INTEN_CLR_IMAT2_CLR 0x200
#define LPC_MCPWM_INTEN_CLR_IMAT2_CLR_BIT 9
#define LPC_MCPWM_INTEN_CLR_ICAP2_CLR_MASK 0x400
#define LPC_MCPWM_INTEN_CLR_ICAP2_CLR 0x400
#define LPC_MCPWM_INTEN_CLR_ICAP2_CLR_BIT 10
#define LPC_MCPWM_INTEN_CLR_ABORT_CLR_MASK 0x8000
#define LPC_MCPWM_INTEN_CLR_ABORT_CLR 0x8000
#define LPC_MCPWM_INTEN_CLR_ABORT_CLR_BIT 15

#define LPC_MCPWM_INTF (*(volatile unsigned long *)0x400B8068)
#define LPC_MCPWM_INTF_OFFSET 0x68
#define LPC_MCPWM_INTF_ILIM0_F_MASK 0x1
#define LPC_MCPWM_INTF_ILIM0_F 0x1
#define LPC_MCPWM_INTF_ILIM0_F_BIT 0
#define LPC_MCPWM_INTF_IMAT0_F_MASK 0x2
#define LPC_MCPWM_INTF_IMAT0_F 0x2
#define LPC_MCPWM_INTF_IMAT0_F_BIT 1
#define LPC_MCPWM_INTF_ICAP0_F_MASK 0x4
#define LPC_MCPWM_INTF_ICAP0_F 0x4
#define LPC_MCPWM_INTF_ICAP0_F_BIT 2
#define LPC_MCPWM_INTF_ILIM1_F_MASK 0x10
#define LPC_MCPWM_INTF_ILIM1_F 0x10
#define LPC_MCPWM_INTF_ILIM1_F_BIT 4
#define LPC_MCPWM_INTF_IMAT1_F_MASK 0x20
#define LPC_MCPWM_INTF_IMAT1_F 0x20
#define LPC_MCPWM_INTF_IMAT1_F_BIT 5
#define LPC_MCPWM_INTF_ICAP1_F_MASK 0x40
#define LPC_MCPWM_INTF_ICAP1_F 0x40
#define LPC_MCPWM_INTF_ICAP1_F_BIT 6
#define LPC_MCPWM_INTF_ILIM2_F_MASK 0x100
#define LPC_MCPWM_INTF_ILIM2_F 0x100
#define LPC_MCPWM_INTF_ILIM2_F_BIT 8
#define LPC_MCPWM_INTF_IMAT2_F_MASK 0x200
#define LPC_MCPWM_INTF_IMAT2_F 0x200
#define LPC_MCPWM_INTF_IMAT2_F_BIT 9
#define LPC_MCPWM_INTF_ICAP2_F_MASK 0x400
#define LPC_MCPWM_INTF_ICAP2_F 0x400
#define LPC_MCPWM_INTF_ICAP2_F_BIT 10
#define LPC_MCPWM_INTF_ABORT_F_MASK 0x8000
#define LPC_MCPWM_INTF_ABORT_F 0x8000
#define LPC_MCPWM_INTF_ABORT_F_BIT 15

#define LPC_MCPWM_INTF_SET (*(volatile unsigned long *)0x400B806C)
#define LPC_MCPWM_INTF_SET_OFFSET 0x6C
#define LPC_MCPWM_INTF_SET_ILIM0_F_SET_MASK 0x1
#define LPC_MCPWM_INTF_SET_ILIM0_F_SET 0x1
#define LPC_MCPWM_INTF_SET_ILIM0_F_SET_BIT 0
#define LPC_MCPWM_INTF_SET_IMAT0_F_SET_MASK 0x2
#define LPC_MCPWM_INTF_SET_IMAT0_F_SET 0x2
#define LPC_MCPWM_INTF_SET_IMAT0_F_SET_BIT 1
#define LPC_MCPWM_INTF_SET_ICAP0_F_SET_MASK 0x4
#define LPC_MCPWM_INTF_SET_ICAP0_F_SET 0x4
#define LPC_MCPWM_INTF_SET_ICAP0_F_SET_BIT 2
#define LPC_MCPWM_INTF_SET_ILIM1_F_SET_MASK 0x10
#define LPC_MCPWM_INTF_SET_ILIM1_F_SET 0x10
#define LPC_MCPWM_INTF_SET_ILIM1_F_SET_BIT 4
#define LPC_MCPWM_INTF_SET_IMAT1_F_SET_MASK 0x20
#define LPC_MCPWM_INTF_SET_IMAT1_F_SET 0x20
#define LPC_MCPWM_INTF_SET_IMAT1_F_SET_BIT 5
#define LPC_MCPWM_INTF_SET_ICAP1_F_SET_MASK 0x40
#define LPC_MCPWM_INTF_SET_ICAP1_F_SET 0x40
#define LPC_MCPWM_INTF_SET_ICAP1_F_SET_BIT 6
#define LPC_MCPWM_INTF_SET_ILIM2_F_SET_MASK 0x100
#define LPC_MCPWM_INTF_SET_ILIM2_F_SET 0x100
#define LPC_MCPWM_INTF_SET_ILIM2_F_SET_BIT 8
#define LPC_MCPWM_INTF_SET_IMAT2_F_SET_MASK 0x200
#define LPC_MCPWM_INTF_SET_IMAT2_F_SET 0x200
#define LPC_MCPWM_INTF_SET_IMAT2_F_SET_BIT 9
#define LPC_MCPWM_INTF_SET_ICAP2_F_SET_MASK 0x400
#define LPC_MCPWM_INTF_SET_ICAP2_F_SET 0x400
#define LPC_MCPWM_INTF_SET_ICAP2_F_SET_BIT 10
#define LPC_MCPWM_INTF_SET_ABORT_F_SET_MASK 0x8000
#define LPC_MCPWM_INTF_SET_ABORT_F_SET 0x8000
#define LPC_MCPWM_INTF_SET_ABORT_F_SET_BIT 15

#define LPC_MCPWM_INTF_CLR (*(volatile unsigned long *)0x400B8070)
#define LPC_MCPWM_INTF_CLR_OFFSET 0x70
#define LPC_MCPWM_INTF_CLR_ILIM0_F_CLR_MASK 0x1
#define LPC_MCPWM_INTF_CLR_ILIM0_F_CLR 0x1
#define LPC_MCPWM_INTF_CLR_ILIM0_F_CLR_BIT 0
#define LPC_MCPWM_INTF_CLR_IMAT0_F_CLR_MASK 0x2
#define LPC_MCPWM_INTF_CLR_IMAT0_F_CLR 0x2
#define LPC_MCPWM_INTF_CLR_IMAT0_F_CLR_BIT 1
#define LPC_MCPWM_INTF_CLR_ICAP0_F_CLR_MASK 0x4
#define LPC_MCPWM_INTF_CLR_ICAP0_F_CLR 0x4
#define LPC_MCPWM_INTF_CLR_ICAP0_F_CLR_BIT 2
#define LPC_MCPWM_INTF_CLR_ILIM1_F_CLR_MASK 0x10
#define LPC_MCPWM_INTF_CLR_ILIM1_F_CLR 0x10
#define LPC_MCPWM_INTF_CLR_ILIM1_F_CLR_BIT 4
#define LPC_MCPWM_INTF_CLR_IMAT1_F_CLR_MASK 0x20
#define LPC_MCPWM_INTF_CLR_IMAT1_F_CLR 0x20
#define LPC_MCPWM_INTF_CLR_IMAT1_F_CLR_BIT 5
#define LPC_MCPWM_INTF_CLR_ICAP1_F_CLR_MASK 0x40
#define LPC_MCPWM_INTF_CLR_ICAP1_F_CLR 0x40
#define LPC_MCPWM_INTF_CLR_ICAP1_F_CLR_BIT 6
#define LPC_MCPWM_INTF_CLR_ILIM2_F_CLR_MASK 0x100
#define LPC_MCPWM_INTF_CLR_ILIM2_F_CLR 0x100
#define LPC_MCPWM_INTF_CLR_ILIM2_F_CLR_BIT 8
#define LPC_MCPWM_INTF_CLR_IMAT2_F_CLR_MASK 0x200
#define LPC_MCPWM_INTF_CLR_IMAT2_F_CLR 0x200
#define LPC_MCPWM_INTF_CLR_IMAT2_F_CLR_BIT 9
#define LPC_MCPWM_INTF_CLR_ICAP2_F_CLR_MASK 0x400
#define LPC_MCPWM_INTF_CLR_ICAP2_F_CLR 0x400
#define LPC_MCPWM_INTF_CLR_ICAP2_F_CLR_BIT 10
#define LPC_MCPWM_INTF_CLR_ABORT_F_CLR_MASK 0x8000
#define LPC_MCPWM_INTF_CLR_ABORT_F_CLR 0x8000
#define LPC_MCPWM_INTF_CLR_ABORT_F_CLR_BIT 15

#define LPC_MCPWM_CNTCON (*(volatile unsigned long *)0x400B805C)
#define LPC_MCPWM_CNTCON_OFFSET 0x5C
#define LPC_MCPWM_CNTCON_TC0MCI0_RE_MASK 0x1
#define LPC_MCPWM_CNTCON_TC0MCI0_RE 0x1
#define LPC_MCPWM_CNTCON_TC0MCI0_RE_BIT 0
#define LPC_MCPWM_CNTCON_TC0MCI0_FE_MASK 0x2
#define LPC_MCPWM_CNTCON_TC0MCI0_FE 0x2
#define LPC_MCPWM_CNTCON_TC0MCI0_FE_BIT 1
#define LPC_MCPWM_CNTCON_TC0MCI1_RE_MASK 0x4
#define LPC_MCPWM_CNTCON_TC0MCI1_RE 0x4
#define LPC_MCPWM_CNTCON_TC0MCI1_RE_BIT 2
#define LPC_MCPWM_CNTCON_TC0MCI1_FE_MASK 0x8
#define LPC_MCPWM_CNTCON_TC0MCI1_FE 0x8
#define LPC_MCPWM_CNTCON_TC0MCI1_FE_BIT 3
#define LPC_MCPWM_CNTCON_TC0MCI2_RE_MASK 0x10
#define LPC_MCPWM_CNTCON_TC0MCI2_RE 0x10
#define LPC_MCPWM_CNTCON_TC0MCI2_RE_BIT 4
#define LPC_MCPWM_CNTCON_TC0MCI2_FE_MASK 0x20
#define LPC_MCPWM_CNTCON_TC0MCI2_FE 0x20
#define LPC_MCPWM_CNTCON_TC0MCI2_FE_BIT 5
#define LPC_MCPWM_CNTCON_TC1MCI0_RE_MASK 0x40
#define LPC_MCPWM_CNTCON_TC1MCI0_RE 0x40
#define LPC_MCPWM_CNTCON_TC1MCI0_RE_BIT 6
#define LPC_MCPWM_CNTCON_TC1MCI0_FE_MASK 0x80
#define LPC_MCPWM_CNTCON_TC1MCI0_FE 0x80
#define LPC_MCPWM_CNTCON_TC1MCI0_FE_BIT 7
#define LPC_MCPWM_CNTCON_TC1MCI1_RE_MASK 0x100
#define LPC_MCPWM_CNTCON_TC1MCI1_RE 0x100
#define LPC_MCPWM_CNTCON_TC1MCI1_RE_BIT 8
#define LPC_MCPWM_CNTCON_TC1MCI1_FE_MASK 0x200
#define LPC_MCPWM_CNTCON_TC1MCI1_FE 0x200
#define LPC_MCPWM_CNTCON_TC1MCI1_FE_BIT 9
#define LPC_MCPWM_CNTCON_TC1MCI2_RE_MASK 0x400
#define LPC_MCPWM_CNTCON_TC1MCI2_RE 0x400
#define LPC_MCPWM_CNTCON_TC1MCI2_RE_BIT 10
#define LPC_MCPWM_CNTCON_TC1MCI2_FE_MASK 0x800
#define LPC_MCPWM_CNTCON_TC1MCI2_FE 0x800
#define LPC_MCPWM_CNTCON_TC1MCI2_FE_BIT 11
#define LPC_MCPWM_CNTCON_TC2MCI0_RE_MASK 0x1000
#define LPC_MCPWM_CNTCON_TC2MCI0_RE 0x1000
#define LPC_MCPWM_CNTCON_TC2MCI0_RE_BIT 12
#define LPC_MCPWM_CNTCON_TC2MCI0_FE_MASK 0x2000
#define LPC_MCPWM_CNTCON_TC2MCI0_FE 0x2000
#define LPC_MCPWM_CNTCON_TC2MCI0_FE_BIT 13
#define LPC_MCPWM_CNTCON_TC2MCI1_RE_MASK 0x4000
#define LPC_MCPWM_CNTCON_TC2MCI1_RE 0x4000
#define LPC_MCPWM_CNTCON_TC2MCI1_RE_BIT 14
#define LPC_MCPWM_CNTCON_TC2MCI1_FE_MASK 0x8000
#define LPC_MCPWM_CNTCON_TC2MCI1_FE 0x8000
#define LPC_MCPWM_CNTCON_TC2MCI1_FE_BIT 15
#define LPC_MCPWM_CNTCON_TC2MCI2_RE_MASK 0x10000
#define LPC_MCPWM_CNTCON_TC2MCI2_RE 0x10000
#define LPC_MCPWM_CNTCON_TC2MCI2_RE_BIT 16
#define LPC_MCPWM_CNTCON_TC2MCI2_FE_MASK 0x20000
#define LPC_MCPWM_CNTCON_TC2MCI2_FE 0x20000
#define LPC_MCPWM_CNTCON_TC2MCI2_FE_BIT 17
#define LPC_MCPWM_CNTCON_CNTR0_MASK 0x20000000
#define LPC_MCPWM_CNTCON_CNTR0 0x20000000
#define LPC_MCPWM_CNTCON_CNTR0_BIT 29
#define LPC_MCPWM_CNTCON_CNTR1_MASK 0x40000000
#define LPC_MCPWM_CNTCON_CNTR1 0x40000000
#define LPC_MCPWM_CNTCON_CNTR1_BIT 30
#define LPC_MCPWM_CNTCON_CNTR2_MASK 0x80000000
#define LPC_MCPWM_CNTCON_CNTR2 0x80000000
#define LPC_MCPWM_CNTCON_CNTR2_BIT 31

#define LPC_MCPWM_CNTCON_SET (*(volatile unsigned long *)0x400B8060)
#define LPC_MCPWM_CNTCON_SET_OFFSET 0x60
#define LPC_MCPWM_CNTCON_SET_TC0MCI0_RE_SET_MASK 0x1
#define LPC_MCPWM_CNTCON_SET_TC0MCI0_RE_SET 0x1
#define LPC_MCPWM_CNTCON_SET_TC0MCI0_RE_SET_BIT 0
#define LPC_MCPWM_CNTCON_SET_TC0MCI0_FE_SET_MASK 0x2
#define LPC_MCPWM_CNTCON_SET_TC0MCI0_FE_SET 0x2
#define LPC_MCPWM_CNTCON_SET_TC0MCI0_FE_SET_BIT 1
#define LPC_MCPWM_CNTCON_SET_TC0MCI1_RE_SET_MASK 0x4
#define LPC_MCPWM_CNTCON_SET_TC0MCI1_RE_SET 0x4
#define LPC_MCPWM_CNTCON_SET_TC0MCI1_RE_SET_BIT 2
#define LPC_MCPWM_CNTCON_SET_TC0MCI1_FE_SET_MASK 0x8
#define LPC_MCPWM_CNTCON_SET_TC0MCI1_FE_SET 0x8
#define LPC_MCPWM_CNTCON_SET_TC0MCI1_FE_SET_BIT 3
#define LPC_MCPWM_CNTCON_SET_TC0MCI2_RE_SET_MASK 0x10
#define LPC_MCPWM_CNTCON_SET_TC0MCI2_RE_SET 0x10
#define LPC_MCPWM_CNTCON_SET_TC0MCI2_RE_SET_BIT 4
#define LPC_MCPWM_CNTCON_SET_TC0MCI2_FE_SET_MASK 0x20
#define LPC_MCPWM_CNTCON_SET_TC0MCI2_FE_SET 0x20
#define LPC_MCPWM_CNTCON_SET_TC0MCI2_FE_SET_BIT 5
#define LPC_MCPWM_CNTCON_SET_TC1MCI0_RE_SET_MASK 0x40
#define LPC_MCPWM_CNTCON_SET_TC1MCI0_RE_SET 0x40
#define LPC_MCPWM_CNTCON_SET_TC1MCI0_RE_SET_BIT 6
#define LPC_MCPWM_CNTCON_SET_TC1MCI0_FE_SET_MASK 0x80
#define LPC_MCPWM_CNTCON_SET_TC1MCI0_FE_SET 0x80
#define LPC_MCPWM_CNTCON_SET_TC1MCI0_FE_SET_BIT 7
#define LPC_MCPWM_CNTCON_SET_TC1MCI1_RE_SET_MASK 0x100
#define LPC_MCPWM_CNTCON_SET_TC1MCI1_RE_SET 0x100
#define LPC_MCPWM_CNTCON_SET_TC1MCI1_RE_SET_BIT 8
#define LPC_MCPWM_CNTCON_SET_TC1MCI1_FE_SET_MASK 0x200
#define LPC_MCPWM_CNTCON_SET_TC1MCI1_FE_SET 0x200
#define LPC_MCPWM_CNTCON_SET_TC1MCI1_FE_SET_BIT 9
#define LPC_MCPWM_CNTCON_SET_TC1MCI2_RE_SET_MASK 0x400
#define LPC_MCPWM_CNTCON_SET_TC1MCI2_RE_SET 0x400
#define LPC_MCPWM_CNTCON_SET_TC1MCI2_RE_SET_BIT 10
#define LPC_MCPWM_CNTCON_SET_TC1MCI2_FE_SET_MASK 0x800
#define LPC_MCPWM_CNTCON_SET_TC1MCI2_FE_SET 0x800
#define LPC_MCPWM_CNTCON_SET_TC1MCI2_FE_SET_BIT 11
#define LPC_MCPWM_CNTCON_SET_TC2MCI0_RE_SET_MASK 0x1000
#define LPC_MCPWM_CNTCON_SET_TC2MCI0_RE_SET 0x1000
#define LPC_MCPWM_CNTCON_SET_TC2MCI0_RE_SET_BIT 12
#define LPC_MCPWM_CNTCON_SET_TC2MCI0_FE_SET_MASK 0x2000
#define LPC_MCPWM_CNTCON_SET_TC2MCI0_FE_SET 0x2000
#define LPC_MCPWM_CNTCON_SET_TC2MCI0_FE_SET_BIT 13
#define LPC_MCPWM_CNTCON_SET_TC2MCI1_RE_SET_MASK 0x4000
#define LPC_MCPWM_CNTCON_SET_TC2MCI1_RE_SET 0x4000
#define LPC_MCPWM_CNTCON_SET_TC2MCI1_RE_SET_BIT 14
#define LPC_MCPWM_CNTCON_SET_TC2MCI1_FE_SET_MASK 0x8000
#define LPC_MCPWM_CNTCON_SET_TC2MCI1_FE_SET 0x8000
#define LPC_MCPWM_CNTCON_SET_TC2MCI1_FE_SET_BIT 15
#define LPC_MCPWM_CNTCON_SET_TC2MCI2_RE_SET_MASK 0x10000
#define LPC_MCPWM_CNTCON_SET_TC2MCI2_RE_SET 0x10000
#define LPC_MCPWM_CNTCON_SET_TC2MCI2_RE_SET_BIT 16
#define LPC_MCPWM_CNTCON_SET_TC2MCI2_FE_SET_MASK 0x20000
#define LPC_MCPWM_CNTCON_SET_TC2MCI2_FE_SET 0x20000
#define LPC_MCPWM_CNTCON_SET_TC2MCI2_FE_SET_BIT 17
#define LPC_MCPWM_CNTCON_SET_CNTR0_SET_MASK 0x20000000
#define LPC_MCPWM_CNTCON_SET_CNTR0_SET 0x20000000
#define LPC_MCPWM_CNTCON_SET_CNTR0_SET_BIT 29
#define LPC_MCPWM_CNTCON_SET_CNTR1_SET_MASK 0x40000000
#define LPC_MCPWM_CNTCON_SET_CNTR1_SET 0x40000000
#define LPC_MCPWM_CNTCON_SET_CNTR1_SET_BIT 30
#define LPC_MCPWM_CNTCON_SET_CNTR2_SET_MASK 0x80000000
#define LPC_MCPWM_CNTCON_SET_CNTR2_SET 0x80000000
#define LPC_MCPWM_CNTCON_SET_CNTR2_SET_BIT 31

#define LPC_MCPWM_CNTCON_CLR (*(volatile unsigned long *)0x400B8064)
#define LPC_MCPWM_CNTCON_CLR_OFFSET 0x64
#define LPC_MCPWM_CNTCON_CLR_TC0MCI0_RE_CLR_MASK 0x1
#define LPC_MCPWM_CNTCON_CLR_TC0MCI0_RE_CLR 0x1
#define LPC_MCPWM_CNTCON_CLR_TC0MCI0_RE_CLR_BIT 0
#define LPC_MCPWM_CNTCON_CLR_TC0MCI0_FE_CLR_MASK 0x2
#define LPC_MCPWM_CNTCON_CLR_TC0MCI0_FE_CLR 0x2
#define LPC_MCPWM_CNTCON_CLR_TC0MCI0_FE_CLR_BIT 1
#define LPC_MCPWM_CNTCON_CLR_TC0MCI1_RE_CLR_MASK 0x4
#define LPC_MCPWM_CNTCON_CLR_TC0MCI1_RE_CLR 0x4
#define LPC_MCPWM_CNTCON_CLR_TC0MCI1_RE_CLR_BIT 2
#define LPC_MCPWM_CNTCON_CLR_TC0MCI1_FE_CLR_MASK 0x8
#define LPC_MCPWM_CNTCON_CLR_TC0MCI1_FE_CLR 0x8
#define LPC_MCPWM_CNTCON_CLR_TC0MCI1_FE_CLR_BIT 3
#define LPC_MCPWM_CNTCON_CLR_TC0MCI2_RE_MASK 0x10
#define LPC_MCPWM_CNTCON_CLR_TC0MCI2_RE 0x10
#define LPC_MCPWM_CNTCON_CLR_TC0MCI2_RE_BIT 4
#define LPC_MCPWM_CNTCON_CLR_TC0MCI2_FE_CLR_MASK 0x20
#define LPC_MCPWM_CNTCON_CLR_TC0MCI2_FE_CLR 0x20
#define LPC_MCPWM_CNTCON_CLR_TC0MCI2_FE_CLR_BIT 5
#define LPC_MCPWM_CNTCON_CLR_TC1MCI0_RE_CLR_MASK 0x40
#define LPC_MCPWM_CNTCON_CLR_TC1MCI0_RE_CLR 0x40
#define LPC_MCPWM_CNTCON_CLR_TC1MCI0_RE_CLR_BIT 6
#define LPC_MCPWM_CNTCON_CLR_TC1MCI0_FE_CLR_MASK 0x80
#define LPC_MCPWM_CNTCON_CLR_TC1MCI0_FE_CLR 0x80
#define LPC_MCPWM_CNTCON_CLR_TC1MCI0_FE_CLR_BIT 7
#define LPC_MCPWM_CNTCON_CLR_TC1MCI1_RE_CLR_MASK 0x100
#define LPC_MCPWM_CNTCON_CLR_TC1MCI1_RE_CLR 0x100
#define LPC_MCPWM_CNTCON_CLR_TC1MCI1_RE_CLR_BIT 8
#define LPC_MCPWM_CNTCON_CLR_TC1MCI1_FE_CLR_MASK 0x200
#define LPC_MCPWM_CNTCON_CLR_TC1MCI1_FE_CLR 0x200
#define LPC_MCPWM_CNTCON_CLR_TC1MCI1_FE_CLR_BIT 9
#define LPC_MCPWM_CNTCON_CLR_TC1MCI2_RE_CLR_MASK 0x400
#define LPC_MCPWM_CNTCON_CLR_TC1MCI2_RE_CLR 0x400
#define LPC_MCPWM_CNTCON_CLR_TC1MCI2_RE_CLR_BIT 10
#define LPC_MCPWM_CNTCON_CLR_TC1MCI2_FE_CLR_MASK 0x800
#define LPC_MCPWM_CNTCON_CLR_TC1MCI2_FE_CLR 0x800
#define LPC_MCPWM_CNTCON_CLR_TC1MCI2_FE_CLR_BIT 11
#define LPC_MCPWM_CNTCON_CLR_TC2MCI0_RE_CLR_MASK 0x1000
#define LPC_MCPWM_CNTCON_CLR_TC2MCI0_RE_CLR 0x1000
#define LPC_MCPWM_CNTCON_CLR_TC2MCI0_RE_CLR_BIT 12
#define LPC_MCPWM_CNTCON_CLR_TC2MCI0_FE_CLR_MASK 0x2000
#define LPC_MCPWM_CNTCON_CLR_TC2MCI0_FE_CLR 0x2000
#define LPC_MCPWM_CNTCON_CLR_TC2MCI0_FE_CLR_BIT 13
#define LPC_MCPWM_CNTCON_CLR_TC2MCI1_RE_CLR_MASK 0x4000
#define LPC_MCPWM_CNTCON_CLR_TC2MCI1_RE_CLR 0x4000
#define LPC_MCPWM_CNTCON_CLR_TC2MCI1_RE_CLR_BIT 14
#define LPC_MCPWM_CNTCON_CLR_TC2MCI1_FE_CLR_MASK 0x8000
#define LPC_MCPWM_CNTCON_CLR_TC2MCI1_FE_CLR 0x8000
#define LPC_MCPWM_CNTCON_CLR_TC2MCI1_FE_CLR_BIT 15
#define LPC_MCPWM_CNTCON_CLR_TC2MCI2_RE_CLR_MASK 0x10000
#define LPC_MCPWM_CNTCON_CLR_TC2MCI2_RE_CLR 0x10000
#define LPC_MCPWM_CNTCON_CLR_TC2MCI2_RE_CLR_BIT 16
#define LPC_MCPWM_CNTCON_CLR_TC2MCI2_FE_CLR_MASK 0x20000
#define LPC_MCPWM_CNTCON_CLR_TC2MCI2_FE_CLR 0x20000
#define LPC_MCPWM_CNTCON_CLR_TC2MCI2_FE_CLR_BIT 17
#define LPC_MCPWM_CNTCON_CLR_CNTR0_CLR_MASK 0x20000000
#define LPC_MCPWM_CNTCON_CLR_CNTR0_CLR 0x20000000
#define LPC_MCPWM_CNTCON_CLR_CNTR0_CLR_BIT 29
#define LPC_MCPWM_CNTCON_CLR_CNTR1_CLR_MASK 0x40000000
#define LPC_MCPWM_CNTCON_CLR_CNTR1_CLR 0x40000000
#define LPC_MCPWM_CNTCON_CLR_CNTR1_CLR_BIT 30
#define LPC_MCPWM_CNTCON_CLR_CNTR2_CLR_MASK 0x80000000
#define LPC_MCPWM_CNTCON_CLR_CNTR2_CLR 0x80000000
#define LPC_MCPWM_CNTCON_CLR_CNTR2_CLR_BIT 31

#define LPC_MCPWM_CAP_CLR (*(volatile unsigned long *)0x400B8074)
#define LPC_MCPWM_CAP_CLR_OFFSET 0x74
#define LPC_MCPWM_CAP_CLR_CAP_CLR0_MASK 0x1
#define LPC_MCPWM_CAP_CLR_CAP_CLR0 0x1
#define LPC_MCPWM_CAP_CLR_CAP_CLR0_BIT 0
#define LPC_MCPWM_CAP_CLR_CAP_CLR1_MASK 0x2
#define LPC_MCPWM_CAP_CLR_CAP_CLR1 0x2
#define LPC_MCPWM_CAP_CLR_CAP_CLR1_BIT 1
#define LPC_MCPWM_CAP_CLR_CAP_CLR2_MASK 0x4
#define LPC_MCPWM_CAP_CLR_CAP_CLR2 0x4
#define LPC_MCPWM_CAP_CLR_CAP_CLR2_BIT 2

#ifndef LPC_QEI_BASE_ADDRESS
#define LPC_QEI_BASE_ADDRESS 0x400BC000
#endif

#define LPC_QEI_CON (*(volatile unsigned long *)0x400BC000)
#define LPC_QEI_CON_OFFSET 0x0
#define LPC_QEI_CON_RESP_MASK 0x1
#define LPC_QEI_CON_RESP 0x1
#define LPC_QEI_CON_RESP_BIT 0
#define LPC_QEI_CON_RESPI_MASK 0x2
#define LPC_QEI_CON_RESPI 0x2
#define LPC_QEI_CON_RESPI_BIT 1
#define LPC_QEI_CON_RESV_MASK 0x4
#define LPC_QEI_CON_RESV 0x4
#define LPC_QEI_CON_RESV_BIT 2
#define LPC_QEI_CON_RESI_MASK 0x8
#define LPC_QEI_CON_RESI 0x8
#define LPC_QEI_CON_RESI_BIT 3

#define LPC_QEI_CONF (*(volatile unsigned long *)0x400BC008)
#define LPC_QEI_CONF_OFFSET 0x8
#define LPC_QEI_CONF_DIRINV_MASK 0x1
#define LPC_QEI_CONF_DIRINV 0x1
#define LPC_QEI_CONF_DIRINV_BIT 0
#define LPC_QEI_CONF_SIGMODE_MASK 0x2
#define LPC_QEI_CONF_SIGMODE 0x2
#define LPC_QEI_CONF_SIGMODE_BIT 1
#define LPC_QEI_CONF_CAPMODE_MASK 0x4
#define LPC_QEI_CONF_CAPMODE 0x4
#define LPC_QEI_CONF_CAPMODE_BIT 2
#define LPC_QEI_CONF_INVINX_MASK 0x8
#define LPC_QEI_CONF_INVINX 0x8
#define LPC_QEI_CONF_INVINX_BIT 3
#define LPC_QEI_CONF_CRESPI_MASK 0x10
#define LPC_QEI_CONF_CRESPI 0x10
#define LPC_QEI_CONF_CRESPI_BIT 4
#define LPC_QEI_CONF_INXGATE_MASK 0xF0000
#define LPC_QEI_CONF_INXGATE_BIT 16

#define LPC_QEI_STAT (*(volatile unsigned long *)0x400BC004)
#define LPC_QEI_STAT_OFFSET 0x4
#define LPC_QEI_STAT_DIR_MASK 0x1
#define LPC_QEI_STAT_DIR 0x1
#define LPC_QEI_STAT_DIR_BIT 0

#define LPC_QEI_POS (*(volatile unsigned long *)0x400BC00C)
#define LPC_QEI_POS_OFFSET 0xC
#define LPC_QEI_POS_POS_MASK 0xFFFFFFFF
#define LPC_QEI_POS_POS_BIT 0

#define LPC_QEI_MAXPOS (*(volatile unsigned long *)0x400BC010)
#define LPC_QEI_MAXPOS_OFFSET 0x10
#define LPC_QEI_MAXPOS_MAXPOS_MASK 0xFFFFFFFF
#define LPC_QEI_MAXPOS_MAXPOS_BIT 0

#define LPC_QEI_CMPOS0 (*(volatile unsigned long *)0x400BC014)
#define LPC_QEI_CMPOS0_OFFSET 0x14
#define LPC_QEI_CMPOS0_PCMP0_MASK 0xFFFFFFFF
#define LPC_QEI_CMPOS0_PCMP0_BIT 0

#define LPC_QEI_CMPOS1 (*(volatile unsigned long *)0x400BC018)
#define LPC_QEI_CMPOS1_OFFSET 0x18
#define LPC_QEI_CMPOS1_PCMP1_MASK 0xFFFFFFFF
#define LPC_QEI_CMPOS1_PCMP1_BIT 0

#define LPC_QEI_CMPOS2 (*(volatile unsigned long *)0x400BC01C)
#define LPC_QEI_CMPOS2_OFFSET 0x1C
#define LPC_QEI_CMPOS2_PCMP2_MASK 0xFFFFFFFF
#define LPC_QEI_CMPOS2_PCMP2_BIT 0

#define LPC_QEI_INXCNT (*(volatile unsigned long *)0x400BC020)
#define LPC_QEI_INXCNT_OFFSET 0x20
#define LPC_QEI_INXCNT_ENCPOS_MASK 0xFFFFFFFF
#define LPC_QEI_INXCNT_ENCPOS_BIT 0

#define LPC_QEI_INXCMP0 (*(volatile unsigned long *)0x400BC024)
#define LPC_QEI_INXCMP0_OFFSET 0x24
#define LPC_QEI_INXCMP0_ICMP0_MASK 0xFFFFFFFF
#define LPC_QEI_INXCMP0_ICMP0_BIT 0

#define LPC_QEI_LOAD (*(volatile unsigned long *)0x400BC028)
#define LPC_QEI_LOAD_OFFSET 0x28
#define LPC_QEI_LOAD_VELLOAD_MASK 0xFFFFFFFF
#define LPC_QEI_LOAD_VELLOAD_BIT 0

#define LPC_QEI_TIME (*(volatile unsigned long *)0x400BC02C)
#define LPC_QEI_TIME_OFFSET 0x2C
#define LPC_QEI_TIME_VELVAL_MASK 0xFFFFFFFF
#define LPC_QEI_TIME_VELVAL_BIT 0

#define LPC_QEI_VEL (*(volatile unsigned long *)0x400BC030)
#define LPC_QEI_VEL_OFFSET 0x30
#define LPC_QEI_VEL_VELPC_MASK 0xFFFFFFFF
#define LPC_QEI_VEL_VELPC_BIT 0

#define LPC_QEI_CAP (*(volatile unsigned long *)0x400BC034)
#define LPC_QEI_CAP_OFFSET 0x34
#define LPC_QEI_CAP_VELCAP_MASK 0xFFFFFFFF
#define LPC_QEI_CAP_VELCAP_BIT 0

#define LPC_QEI_VELCOMP (*(volatile unsigned long *)0x400BC038)
#define LPC_QEI_VELCOMP_OFFSET 0x38
#define LPC_QEI_VELCOMP_VELPC_MASK 0xFFFFFFFF
#define LPC_QEI_VELCOMP_VELPC_BIT 0

#define LPC_QEI_FILTERPHA (*(volatile unsigned long *)0x400BC03C)
#define LPC_QEI_FILTERPHA_OFFSET 0x3C
#define LPC_QEI_FILTERPHA_FILTA_MASK 0xFFFFFFFF
#define LPC_QEI_FILTERPHA_FILTA_BIT 0

#define LPC_QEI_FILTERPHB (*(volatile unsigned long *)0x400BC040)
#define LPC_QEI_FILTERPHB_OFFSET 0x40
#define LPC_QEI_FILTERPHB_FILTB_MASK 0xFFFFFFFF
#define LPC_QEI_FILTERPHB_FILTB_BIT 0

#define LPC_QEI_FILTERINX (*(volatile unsigned long *)0x400BC044)
#define LPC_QEI_FILTERINX_OFFSET 0x44
#define LPC_QEI_FILTERINX_FITLINX_MASK 0xFFFFFFFF
#define LPC_QEI_FILTERINX_FITLINX_BIT 0

#define LPC_QEI_WINDOW (*(volatile unsigned long *)0x400BC048)
#define LPC_QEI_WINDOW_OFFSET 0x48
#define LPC_QEI_WINDOW_WINDOW_MASK 0xFFFFFFFF
#define LPC_QEI_WINDOW_WINDOW_BIT 0

#define LPC_QEI_INXCMP1 (*(volatile unsigned long *)0x400BC04C)
#define LPC_QEI_INXCMP1_OFFSET 0x4C
#define LPC_QEI_INXCMP1_ICMP1_MASK 0xFFFFFFFF
#define LPC_QEI_INXCMP1_ICMP1_BIT 0

#define LPC_QEI_INXCMP2 (*(volatile unsigned long *)0x400BC050)
#define LPC_QEI_INXCMP2_OFFSET 0x50
#define LPC_QEI_INXCMP2_ICMP2_MASK 0xFFFFFFFF
#define LPC_QEI_INXCMP2_ICMP2_BIT 0

#define LPC_QEI_INTSTAT (*(volatile unsigned long *)0x400BCFE0)
#define LPC_QEI_INTSTAT_OFFSET 0xFE0
#define LPC_QEI_INTSTAT_INX_INT_MASK 0x1
#define LPC_QEI_INTSTAT_INX_INT 0x1
#define LPC_QEI_INTSTAT_INX_INT_BIT 0
#define LPC_QEI_INTSTAT_TIM_INT_MASK 0x2
#define LPC_QEI_INTSTAT_TIM_INT 0x2
#define LPC_QEI_INTSTAT_TIM_INT_BIT 1
#define LPC_QEI_INTSTAT_VELC_INT_MASK 0x4
#define LPC_QEI_INTSTAT_VELC_INT 0x4
#define LPC_QEI_INTSTAT_VELC_INT_BIT 2
#define LPC_QEI_INTSTAT_DIR_INT_MASK 0x8
#define LPC_QEI_INTSTAT_DIR_INT 0x8
#define LPC_QEI_INTSTAT_DIR_INT_BIT 3
#define LPC_QEI_INTSTAT_ERR_INT_MASK 0x10
#define LPC_QEI_INTSTAT_ERR_INT 0x10
#define LPC_QEI_INTSTAT_ERR_INT_BIT 4
#define LPC_QEI_INTSTAT_ENCLK_INT_MASK 0x20
#define LPC_QEI_INTSTAT_ENCLK_INT 0x20
#define LPC_QEI_INTSTAT_ENCLK_INT_BIT 5
#define LPC_QEI_INTSTAT_POS0_INT_MASK 0x40
#define LPC_QEI_INTSTAT_POS0_INT 0x40
#define LPC_QEI_INTSTAT_POS0_INT_BIT 6
#define LPC_QEI_INTSTAT_POS1_INT_MASK 0x80
#define LPC_QEI_INTSTAT_POS1_INT 0x80
#define LPC_QEI_INTSTAT_POS1_INT_BIT 7
#define LPC_QEI_INTSTAT_POS2_INT_MASK 0x100
#define LPC_QEI_INTSTAT_POS2_INT 0x100
#define LPC_QEI_INTSTAT_POS2_INT_BIT 8
#define LPC_QEI_INTSTAT_REV0_INT_MASK 0x200
#define LPC_QEI_INTSTAT_REV0_INT 0x200
#define LPC_QEI_INTSTAT_REV0_INT_BIT 9
#define LPC_QEI_INTSTAT_POS0REV_INT_MASK 0x400
#define LPC_QEI_INTSTAT_POS0REV_INT 0x400
#define LPC_QEI_INTSTAT_POS0REV_INT_BIT 10
#define LPC_QEI_INTSTAT_POS1REV_INT_MASK 0x800
#define LPC_QEI_INTSTAT_POS1REV_INT 0x800
#define LPC_QEI_INTSTAT_POS1REV_INT_BIT 11
#define LPC_QEI_INTSTAT_POS2REV_INT_MASK 0x1000
#define LPC_QEI_INTSTAT_POS2REV_INT 0x1000
#define LPC_QEI_INTSTAT_POS2REV_INT_BIT 12
#define LPC_QEI_INTSTAT_REV1_INT_MASK 0x2000
#define LPC_QEI_INTSTAT_REV1_INT 0x2000
#define LPC_QEI_INTSTAT_REV1_INT_BIT 13
#define LPC_QEI_INTSTAT_REV2_INT_MASK 0x4000
#define LPC_QEI_INTSTAT_REV2_INT 0x4000
#define LPC_QEI_INTSTAT_REV2_INT_BIT 14
#define LPC_QEI_INTSTAT_MAXPOS_INT_MASK 0x8000
#define LPC_QEI_INTSTAT_MAXPOS_INT 0x8000
#define LPC_QEI_INTSTAT_MAXPOS_INT_BIT 15

#define LPC_QEI_SET (*(volatile unsigned long *)0x400BCFEC)
#define LPC_QEI_SET_OFFSET 0xFEC
#define LPC_QEI_SET_INX_INT_MASK 0x1
#define LPC_QEI_SET_INX_INT 0x1
#define LPC_QEI_SET_INX_INT_BIT 0
#define LPC_QEI_SET_TIM_INT_MASK 0x2
#define LPC_QEI_SET_TIM_INT 0x2
#define LPC_QEI_SET_TIM_INT_BIT 1
#define LPC_QEI_SET_VELC_INT_MASK 0x4
#define LPC_QEI_SET_VELC_INT 0x4
#define LPC_QEI_SET_VELC_INT_BIT 2
#define LPC_QEI_SET_DIR_INT_MASK 0x8
#define LPC_QEI_SET_DIR_INT 0x8
#define LPC_QEI_SET_DIR_INT_BIT 3
#define LPC_QEI_SET_ERR_INT_MASK 0x10
#define LPC_QEI_SET_ERR_INT 0x10
#define LPC_QEI_SET_ERR_INT_BIT 4
#define LPC_QEI_SET_ENCLK_INT_MASK 0x20
#define LPC_QEI_SET_ENCLK_INT 0x20
#define LPC_QEI_SET_ENCLK_INT_BIT 5
#define LPC_QEI_SET_POS0_INT_MASK 0x40
#define LPC_QEI_SET_POS0_INT 0x40
#define LPC_QEI_SET_POS0_INT_BIT 6
#define LPC_QEI_SET_POS1_INT_MASK 0x80
#define LPC_QEI_SET_POS1_INT 0x80
#define LPC_QEI_SET_POS1_INT_BIT 7
#define LPC_QEI_SET_POS2_INT_MASK 0x100
#define LPC_QEI_SET_POS2_INT 0x100
#define LPC_QEI_SET_POS2_INT_BIT 8
#define LPC_QEI_SET_REV0_INT_MASK 0x200
#define LPC_QEI_SET_REV0_INT 0x200
#define LPC_QEI_SET_REV0_INT_BIT 9
#define LPC_QEI_SET_POS0REV_INT_MASK 0x400
#define LPC_QEI_SET_POS0REV_INT 0x400
#define LPC_QEI_SET_POS0REV_INT_BIT 10
#define LPC_QEI_SET_POS1REV_INT_MASK 0x800
#define LPC_QEI_SET_POS1REV_INT 0x800
#define LPC_QEI_SET_POS1REV_INT_BIT 11
#define LPC_QEI_SET_POS2REV_INT_MASK 0x1000
#define LPC_QEI_SET_POS2REV_INT 0x1000
#define LPC_QEI_SET_POS2REV_INT_BIT 12
#define LPC_QEI_SET_REV1_INT_MASK 0x2000
#define LPC_QEI_SET_REV1_INT 0x2000
#define LPC_QEI_SET_REV1_INT_BIT 13
#define LPC_QEI_SET_REV2_INT_MASK 0x4000
#define LPC_QEI_SET_REV2_INT 0x4000
#define LPC_QEI_SET_REV2_INT_BIT 14
#define LPC_QEI_SET_MAXPOS_INT_MASK 0x8000
#define LPC_QEI_SET_MAXPOS_INT 0x8000
#define LPC_QEI_SET_MAXPOS_INT_BIT 15

#define LPC_QEI_CLR (*(volatile unsigned long *)0x400BCFE8)
#define LPC_QEI_CLR_OFFSET 0xFE8
#define LPC_QEI_CLR_INX_INT_MASK 0x1
#define LPC_QEI_CLR_INX_INT 0x1
#define LPC_QEI_CLR_INX_INT_BIT 0
#define LPC_QEI_CLR_TIM_INT_MASK 0x2
#define LPC_QEI_CLR_TIM_INT 0x2
#define LPC_QEI_CLR_TIM_INT_BIT 1
#define LPC_QEI_CLR_VELC_INT_MASK 0x4
#define LPC_QEI_CLR_VELC_INT 0x4
#define LPC_QEI_CLR_VELC_INT_BIT 2
#define LPC_QEI_CLR_DIR_INT_MASK 0x8
#define LPC_QEI_CLR_DIR_INT 0x8
#define LPC_QEI_CLR_DIR_INT_BIT 3
#define LPC_QEI_CLR_ERR_INT_MASK 0x10
#define LPC_QEI_CLR_ERR_INT 0x10
#define LPC_QEI_CLR_ERR_INT_BIT 4
#define LPC_QEI_CLR_ENCLK_INT_MASK 0x20
#define LPC_QEI_CLR_ENCLK_INT 0x20
#define LPC_QEI_CLR_ENCLK_INT_BIT 5
#define LPC_QEI_CLR_POS0_INT_MASK 0x40
#define LPC_QEI_CLR_POS0_INT 0x40
#define LPC_QEI_CLR_POS0_INT_BIT 6
#define LPC_QEI_CLR_POS1_INT_MASK 0x80
#define LPC_QEI_CLR_POS1_INT 0x80
#define LPC_QEI_CLR_POS1_INT_BIT 7
#define LPC_QEI_CLR_POS2_INT_MASK 0x100
#define LPC_QEI_CLR_POS2_INT 0x100
#define LPC_QEI_CLR_POS2_INT_BIT 8
#define LPC_QEI_CLR_REV0_INT_MASK 0x200
#define LPC_QEI_CLR_REV0_INT 0x200
#define LPC_QEI_CLR_REV0_INT_BIT 9
#define LPC_QEI_CLR_POS0REV_INT_MASK 0x400
#define LPC_QEI_CLR_POS0REV_INT 0x400
#define LPC_QEI_CLR_POS0REV_INT_BIT 10
#define LPC_QEI_CLR_POS1REV_INT_MASK 0x800
#define LPC_QEI_CLR_POS1REV_INT 0x800
#define LPC_QEI_CLR_POS1REV_INT_BIT 11
#define LPC_QEI_CLR_POS2REV_INT_MASK 0x1000
#define LPC_QEI_CLR_POS2REV_INT 0x1000
#define LPC_QEI_CLR_POS2REV_INT_BIT 12
#define LPC_QEI_CLR_REV1_INT_MASK 0x2000
#define LPC_QEI_CLR_REV1_INT 0x2000
#define LPC_QEI_CLR_REV1_INT_BIT 13
#define LPC_QEI_CLR_REV2_INT_MASK 0x4000
#define LPC_QEI_CLR_REV2_INT 0x4000
#define LPC_QEI_CLR_REV2_INT_BIT 14
#define LPC_QEI_CLR_MAXPOS_INT_MASK 0x8000
#define LPC_QEI_CLR_MAXPOS_INT 0x8000
#define LPC_QEI_CLR_MAXPOS_INT_BIT 15

#define LPC_QEI_IE (*(volatile unsigned long *)0x400BCFE4)
#define LPC_QEI_IE_OFFSET 0xFE4
#define LPC_QEI_IE_INX_INT_MASK 0x1
#define LPC_QEI_IE_INX_INT 0x1
#define LPC_QEI_IE_INX_INT_BIT 0
#define LPC_QEI_IE_TIM_INT_MASK 0x2
#define LPC_QEI_IE_TIM_INT 0x2
#define LPC_QEI_IE_TIM_INT_BIT 1
#define LPC_QEI_IE_VELC_INT_MASK 0x4
#define LPC_QEI_IE_VELC_INT 0x4
#define LPC_QEI_IE_VELC_INT_BIT 2
#define LPC_QEI_IE_DIR_INT_MASK 0x8
#define LPC_QEI_IE_DIR_INT 0x8
#define LPC_QEI_IE_DIR_INT_BIT 3
#define LPC_QEI_IE_ERR_INT_MASK 0x10
#define LPC_QEI_IE_ERR_INT 0x10
#define LPC_QEI_IE_ERR_INT_BIT 4
#define LPC_QEI_IE_ENCLK_INT_MASK 0x20
#define LPC_QEI_IE_ENCLK_INT 0x20
#define LPC_QEI_IE_ENCLK_INT_BIT 5
#define LPC_QEI_IE_POS0_INT_MASK 0x40
#define LPC_QEI_IE_POS0_INT 0x40
#define LPC_QEI_IE_POS0_INT_BIT 6
#define LPC_QEI_IE_POS1_INT_MASK 0x80
#define LPC_QEI_IE_POS1_INT 0x80
#define LPC_QEI_IE_POS1_INT_BIT 7
#define LPC_QEI_IE_POS2_INT_MASK 0x100
#define LPC_QEI_IE_POS2_INT 0x100
#define LPC_QEI_IE_POS2_INT_BIT 8
#define LPC_QEI_IE_REV0_INT_MASK 0x200
#define LPC_QEI_IE_REV0_INT 0x200
#define LPC_QEI_IE_REV0_INT_BIT 9
#define LPC_QEI_IE_POS0REV_INT_MASK 0x400
#define LPC_QEI_IE_POS0REV_INT 0x400
#define LPC_QEI_IE_POS0REV_INT_BIT 10
#define LPC_QEI_IE_POS1REV_INT_MASK 0x800
#define LPC_QEI_IE_POS1REV_INT 0x800
#define LPC_QEI_IE_POS1REV_INT_BIT 11
#define LPC_QEI_IE_POS2REV_INT_MASK 0x1000
#define LPC_QEI_IE_POS2REV_INT 0x1000
#define LPC_QEI_IE_POS2REV_INT_BIT 12
#define LPC_QEI_IE_REV1_INT_MASK 0x2000
#define LPC_QEI_IE_REV1_INT 0x2000
#define LPC_QEI_IE_REV1_INT_BIT 13
#define LPC_QEI_IE_REV2_INT_MASK 0x4000
#define LPC_QEI_IE_REV2_INT 0x4000
#define LPC_QEI_IE_REV2_INT_BIT 14
#define LPC_QEI_IE_MAXPOS_INT_MASK 0x8000
#define LPC_QEI_IE_MAXPOS_INT 0x8000
#define LPC_QEI_IE_MAXPOS_INT_BIT 15

#define LPC_QEI_IES (*(volatile unsigned long *)0x400BCFDC)
#define LPC_QEI_IES_OFFSET 0xFDC
#define LPC_QEI_IES_INX_INT_MASK 0x1
#define LPC_QEI_IES_INX_INT 0x1
#define LPC_QEI_IES_INX_INT_BIT 0
#define LPC_QEI_IES_TIM_INT_MASK 0x2
#define LPC_QEI_IES_TIM_INT 0x2
#define LPC_QEI_IES_TIM_INT_BIT 1
#define LPC_QEI_IES_VELC_INT_MASK 0x4
#define LPC_QEI_IES_VELC_INT 0x4
#define LPC_QEI_IES_VELC_INT_BIT 2
#define LPC_QEI_IES_DIR_INT_MASK 0x8
#define LPC_QEI_IES_DIR_INT 0x8
#define LPC_QEI_IES_DIR_INT_BIT 3
#define LPC_QEI_IES_ERR_INT_MASK 0x10
#define LPC_QEI_IES_ERR_INT 0x10
#define LPC_QEI_IES_ERR_INT_BIT 4
#define LPC_QEI_IES_ENCLK_INT_MASK 0x20
#define LPC_QEI_IES_ENCLK_INT 0x20
#define LPC_QEI_IES_ENCLK_INT_BIT 5
#define LPC_QEI_IES_POS0_INT_MASK 0x40
#define LPC_QEI_IES_POS0_INT 0x40
#define LPC_QEI_IES_POS0_INT_BIT 6
#define LPC_QEI_IES_POS1_INT_MASK 0x80
#define LPC_QEI_IES_POS1_INT 0x80
#define LPC_QEI_IES_POS1_INT_BIT 7
#define LPC_QEI_IES_POS2_INT_MASK 0x100
#define LPC_QEI_IES_POS2_INT 0x100
#define LPC_QEI_IES_POS2_INT_BIT 8
#define LPC_QEI_IES_REV0_INT_MASK 0x200
#define LPC_QEI_IES_REV0_INT 0x200
#define LPC_QEI_IES_REV0_INT_BIT 9
#define LPC_QEI_IES_POS0REV_INT_MASK 0x400
#define LPC_QEI_IES_POS0REV_INT 0x400
#define LPC_QEI_IES_POS0REV_INT_BIT 10
#define LPC_QEI_IES_POS1REV_INT_MASK 0x800
#define LPC_QEI_IES_POS1REV_INT 0x800
#define LPC_QEI_IES_POS1REV_INT_BIT 11
#define LPC_QEI_IES_POS2REV_INT_MASK 0x1000
#define LPC_QEI_IES_POS2REV_INT 0x1000
#define LPC_QEI_IES_POS2REV_INT_BIT 12
#define LPC_QEI_IES_REV1_INT_MASK 0x2000
#define LPC_QEI_IES_REV1_INT 0x2000
#define LPC_QEI_IES_REV1_INT_BIT 13
#define LPC_QEI_IES_REV2_INT_MASK 0x4000
#define LPC_QEI_IES_REV2_INT 0x4000
#define LPC_QEI_IES_REV2_INT_BIT 14
#define LPC_QEI_IES_MAXPOS_INT_MASK 0x8000
#define LPC_QEI_IES_MAXPOS_INT 0x8000
#define LPC_QEI_IES_MAXPOS_INT_BIT 15

#define LPC_QEI_IEC (*(volatile unsigned long *)0x400BCFD8)
#define LPC_QEI_IEC_OFFSET 0xFD8
#define LPC_QEI_IEC_INX_INT_MASK 0x1
#define LPC_QEI_IEC_INX_INT 0x1
#define LPC_QEI_IEC_INX_INT_BIT 0
#define LPC_QEI_IEC_TIM_INT_MASK 0x2
#define LPC_QEI_IEC_TIM_INT 0x2
#define LPC_QEI_IEC_TIM_INT_BIT 1
#define LPC_QEI_IEC_VELC_INT_MASK 0x4
#define LPC_QEI_IEC_VELC_INT 0x4
#define LPC_QEI_IEC_VELC_INT_BIT 2
#define LPC_QEI_IEC_DIR_INT_MASK 0x8
#define LPC_QEI_IEC_DIR_INT 0x8
#define LPC_QEI_IEC_DIR_INT_BIT 3
#define LPC_QEI_IEC_ERR_INT_MASK 0x10
#define LPC_QEI_IEC_ERR_INT 0x10
#define LPC_QEI_IEC_ERR_INT_BIT 4
#define LPC_QEI_IEC_ENCLK_INT_MASK 0x20
#define LPC_QEI_IEC_ENCLK_INT 0x20
#define LPC_QEI_IEC_ENCLK_INT_BIT 5
#define LPC_QEI_IEC_POS0_INT_MASK 0x40
#define LPC_QEI_IEC_POS0_INT 0x40
#define LPC_QEI_IEC_POS0_INT_BIT 6
#define LPC_QEI_IEC_POS1_INT_MASK 0x80
#define LPC_QEI_IEC_POS1_INT 0x80
#define LPC_QEI_IEC_POS1_INT_BIT 7
#define LPC_QEI_IEC_POS2_INT_MASK 0x100
#define LPC_QEI_IEC_POS2_INT 0x100
#define LPC_QEI_IEC_POS2_INT_BIT 8
#define LPC_QEI_IEC_REV0_INT_MASK 0x200
#define LPC_QEI_IEC_REV0_INT 0x200
#define LPC_QEI_IEC_REV0_INT_BIT 9
#define LPC_QEI_IEC_POS0REV_INT_MASK 0x400
#define LPC_QEI_IEC_POS0REV_INT 0x400
#define LPC_QEI_IEC_POS0REV_INT_BIT 10
#define LPC_QEI_IEC_POS1REV_INT_MASK 0x800
#define LPC_QEI_IEC_POS1REV_INT 0x800
#define LPC_QEI_IEC_POS1REV_INT_BIT 11
#define LPC_QEI_IEC_POS2REV_INT_MASK 0x1000
#define LPC_QEI_IEC_POS2REV_INT 0x1000
#define LPC_QEI_IEC_POS2REV_INT_BIT 12
#define LPC_QEI_IEC_REV1_INT_MASK 0x2000
#define LPC_QEI_IEC_REV1_INT 0x2000
#define LPC_QEI_IEC_REV1_INT_BIT 13
#define LPC_QEI_IEC_REV2_INT_MASK 0x4000
#define LPC_QEI_IEC_REV2_INT 0x4000
#define LPC_QEI_IEC_REV2_INT_BIT 14
#define LPC_QEI_IEC_MAXPOS_INT_MASK 0x8000
#define LPC_QEI_IEC_MAXPOS_INT 0x8000
#define LPC_QEI_IEC_MAXPOS_INT_BIT 15

#ifndef LPC_SDMMC_BASE_ADDRESS
#define LPC_SDMMC_BASE_ADDRESS 0x400C0000
#endif

#define LPC_SDMMC_PWR (*(volatile unsigned long *)0x400C0000)
#define LPC_SDMMC_PWR_OFFSET 0x0
#define LPC_SDMMC_PWR_CTRL_MASK 0x3
#define LPC_SDMMC_PWR_CTRL_BIT 0
#define LPC_SDMMC_PWR_OPENDRAIN_MASK 0x40
#define LPC_SDMMC_PWR_OPENDRAIN 0x40
#define LPC_SDMMC_PWR_OPENDRAIN_BIT 6
#define LPC_SDMMC_PWR_ROD_MASK 0x80
#define LPC_SDMMC_PWR_ROD 0x80
#define LPC_SDMMC_PWR_ROD_BIT 7

#define LPC_SDMMC_CLOCK (*(volatile unsigned long *)0x400C0004)
#define LPC_SDMMC_CLOCK_OFFSET 0x4
#define LPC_SDMMC_CLOCK_CLKDIV_MASK 0xFF
#define LPC_SDMMC_CLOCK_CLKDIV_BIT 0
#define LPC_SDMMC_CLOCK_ENABLE_MASK 0x100
#define LPC_SDMMC_CLOCK_ENABLE 0x100
#define LPC_SDMMC_CLOCK_ENABLE_BIT 8
#define LPC_SDMMC_CLOCK_PWRSAVE_MASK 0x200
#define LPC_SDMMC_CLOCK_PWRSAVE 0x200
#define LPC_SDMMC_CLOCK_PWRSAVE_BIT 9
#define LPC_SDMMC_CLOCK_BYPASS_MASK 0x400
#define LPC_SDMMC_CLOCK_BYPASS 0x400
#define LPC_SDMMC_CLOCK_BYPASS_BIT 10
#define LPC_SDMMC_CLOCK_WIDEBUS_MASK 0x800
#define LPC_SDMMC_CLOCK_WIDEBUS 0x800
#define LPC_SDMMC_CLOCK_WIDEBUS_BIT 11

#define LPC_SDMMC_ARGUMENT (*(volatile unsigned long *)0x400C0008)
#define LPC_SDMMC_ARGUMENT_OFFSET 0x8
#define LPC_SDMMC_ARGUMENT_CmdArg_MASK 0xFFFFFFFF
#define LPC_SDMMC_ARGUMENT_CmdArg_BIT 0

#define LPC_SDMMC_COMMAND (*(volatile unsigned long *)0x400C000C)
#define LPC_SDMMC_COMMAND_OFFSET 0xC
#define LPC_SDMMC_COMMAND_CmdIndex_MASK 0x3F
#define LPC_SDMMC_COMMAND_CmdIndex_BIT 0
#define LPC_SDMMC_COMMAND_Response_MASK 0x40
#define LPC_SDMMC_COMMAND_Response 0x40
#define LPC_SDMMC_COMMAND_Response_BIT 6
#define LPC_SDMMC_COMMAND_LongRsp_MASK 0x80
#define LPC_SDMMC_COMMAND_LongRsp 0x80
#define LPC_SDMMC_COMMAND_LongRsp_BIT 7
#define LPC_SDMMC_COMMAND_Interrupt_MASK 0x100
#define LPC_SDMMC_COMMAND_Interrupt 0x100
#define LPC_SDMMC_COMMAND_Interrupt_BIT 8
#define LPC_SDMMC_COMMAND_Pending_MASK 0x200
#define LPC_SDMMC_COMMAND_Pending 0x200
#define LPC_SDMMC_COMMAND_Pending_BIT 9
#define LPC_SDMMC_COMMAND_Enable_MASK 0x400
#define LPC_SDMMC_COMMAND_Enable 0x400
#define LPC_SDMMC_COMMAND_Enable_BIT 10

#define LPC_SDMMC_RESPCMD (*(volatile unsigned long *)0x400C0010)
#define LPC_SDMMC_RESPCMD_OFFSET 0x10
#define LPC_SDMMC_RESPCMD_RESPCMD_MASK 0x3F
#define LPC_SDMMC_RESPCMD_RESPCMD_BIT 0

#define LPC_SDMMC_RESPONSE0 (*(volatile unsigned long *)0x400C0014)
#define LPC_SDMMC_RESPONSE0_OFFSET 0x14
#define LPC_SDMMC_RESPONSE0_STATUS_MASK 0xFFFFFFFF
#define LPC_SDMMC_RESPONSE0_STATUS_BIT 0

#define LPC_SDMMC_RESPONSE1 (*(volatile unsigned long *)0x400C0018)
#define LPC_SDMMC_RESPONSE1_OFFSET 0x18
#define LPC_SDMMC_RESPONSE1_STATUS_MASK 0xFFFFFFFF
#define LPC_SDMMC_RESPONSE1_STATUS_BIT 0

#define LPC_SDMMC_RESPONSE2 (*(volatile unsigned long *)0x400C001C)
#define LPC_SDMMC_RESPONSE2_OFFSET 0x1C
#define LPC_SDMMC_RESPONSE2_STATUS_MASK 0xFFFFFFFF
#define LPC_SDMMC_RESPONSE2_STATUS_BIT 0

#define LPC_SDMMC_RESPONSE3 (*(volatile unsigned long *)0x400C0020)
#define LPC_SDMMC_RESPONSE3_OFFSET 0x20
#define LPC_SDMMC_RESPONSE3_STATUS_MASK 0xFFFFFFFF
#define LPC_SDMMC_RESPONSE3_STATUS_BIT 0

#define LPC_SDMMC_DATATIMER (*(volatile unsigned long *)0x400C0024)
#define LPC_SDMMC_DATATIMER_OFFSET 0x24
#define LPC_SDMMC_DATATIMER_DATATIME_MASK 0xFFFFFFFF
#define LPC_SDMMC_DATATIMER_DATATIME_BIT 0

#define LPC_SDMMC_DATALENGTH (*(volatile unsigned long *)0x400C0028)
#define LPC_SDMMC_DATALENGTH_OFFSET 0x28
#define LPC_SDMMC_DATALENGTH_DATALENGTH_MASK 0xFFFF
#define LPC_SDMMC_DATALENGTH_DATALENGTH_BIT 0

#define LPC_SDMMC_DATACTRL (*(volatile unsigned long *)0x400C002C)
#define LPC_SDMMC_DATACTRL_OFFSET 0x2C
#define LPC_SDMMC_DATACTRL_ENABLE_MASK 0x1
#define LPC_SDMMC_DATACTRL_ENABLE 0x1
#define LPC_SDMMC_DATACTRL_ENABLE_BIT 0
#define LPC_SDMMC_DATACTRL_DIRECTION_MASK 0x2
#define LPC_SDMMC_DATACTRL_DIRECTION 0x2
#define LPC_SDMMC_DATACTRL_DIRECTION_BIT 1
#define LPC_SDMMC_DATACTRL_MODE_MASK 0x4
#define LPC_SDMMC_DATACTRL_MODE 0x4
#define LPC_SDMMC_DATACTRL_MODE_BIT 2
#define LPC_SDMMC_DATACTRL_DMAENABLE_MASK 0x8
#define LPC_SDMMC_DATACTRL_DMAENABLE 0x8
#define LPC_SDMMC_DATACTRL_DMAENABLE_BIT 3
#define LPC_SDMMC_DATACTRL_BLOCKSIZE_MASK 0xF0
#define LPC_SDMMC_DATACTRL_BLOCKSIZE_BIT 4

#define LPC_SDMMC_DATACNT (*(volatile unsigned long *)0x400C0030)
#define LPC_SDMMC_DATACNT_OFFSET 0x30
#define LPC_SDMMC_DATACNT_DATACOUNT_MASK 0xFFFF
#define LPC_SDMMC_DATACNT_DATACOUNT_BIT 0

#define LPC_SDMMC_STATUS (*(volatile unsigned long *)0x400C0034)
#define LPC_SDMMC_STATUS_OFFSET 0x34
#define LPC_SDMMC_STATUS_CMDCRCFAIL_MASK 0x1
#define LPC_SDMMC_STATUS_CMDCRCFAIL 0x1
#define LPC_SDMMC_STATUS_CMDCRCFAIL_BIT 0
#define LPC_SDMMC_STATUS_DATACRCFAIL_MASK 0x2
#define LPC_SDMMC_STATUS_DATACRCFAIL 0x2
#define LPC_SDMMC_STATUS_DATACRCFAIL_BIT 1
#define LPC_SDMMC_STATUS_CMDTIMEOUT_MASK 0x4
#define LPC_SDMMC_STATUS_CMDTIMEOUT 0x4
#define LPC_SDMMC_STATUS_CMDTIMEOUT_BIT 2
#define LPC_SDMMC_STATUS_DATATIMEOUT_MASK 0x8
#define LPC_SDMMC_STATUS_DATATIMEOUT 0x8
#define LPC_SDMMC_STATUS_DATATIMEOUT_BIT 3
#define LPC_SDMMC_STATUS_TXUNDERRUN_MASK 0x10
#define LPC_SDMMC_STATUS_TXUNDERRUN 0x10
#define LPC_SDMMC_STATUS_TXUNDERRUN_BIT 4
#define LPC_SDMMC_STATUS_RXOVERRUN_MASK 0x20
#define LPC_SDMMC_STATUS_RXOVERRUN 0x20
#define LPC_SDMMC_STATUS_RXOVERRUN_BIT 5
#define LPC_SDMMC_STATUS_CMDRESPEND_MASK 0x40
#define LPC_SDMMC_STATUS_CMDRESPEND 0x40
#define LPC_SDMMC_STATUS_CMDRESPEND_BIT 6
#define LPC_SDMMC_STATUS_CMDSENT_MASK 0x80
#define LPC_SDMMC_STATUS_CMDSENT 0x80
#define LPC_SDMMC_STATUS_CMDSENT_BIT 7
#define LPC_SDMMC_STATUS_DATAEND_MASK 0x100
#define LPC_SDMMC_STATUS_DATAEND 0x100
#define LPC_SDMMC_STATUS_DATAEND_BIT 8
#define LPC_SDMMC_STATUS_STARTBITERR_MASK 0x200
#define LPC_SDMMC_STATUS_STARTBITERR 0x200
#define LPC_SDMMC_STATUS_STARTBITERR_BIT 9
#define LPC_SDMMC_STATUS_DATABLOCKEND_MASK 0x400
#define LPC_SDMMC_STATUS_DATABLOCKEND 0x400
#define LPC_SDMMC_STATUS_DATABLOCKEND_BIT 10
#define LPC_SDMMC_STATUS_CMDACTIVE_MASK 0x800
#define LPC_SDMMC_STATUS_CMDACTIVE 0x800
#define LPC_SDMMC_STATUS_CMDACTIVE_BIT 11
#define LPC_SDMMC_STATUS_TXACTIVE_MASK 0x1000
#define LPC_SDMMC_STATUS_TXACTIVE 0x1000
#define LPC_SDMMC_STATUS_TXACTIVE_BIT 12
#define LPC_SDMMC_STATUS_RXACTIVE_MASK 0x2000
#define LPC_SDMMC_STATUS_RXACTIVE 0x2000
#define LPC_SDMMC_STATUS_RXACTIVE_BIT 13
#define LPC_SDMMC_STATUS_TXFIFOHALFEMPTY_MASK 0x4000
#define LPC_SDMMC_STATUS_TXFIFOHALFEMPTY 0x4000
#define LPC_SDMMC_STATUS_TXFIFOHALFEMPTY_BIT 14
#define LPC_SDMMC_STATUS_RXFIFOHALFFULL_MASK 0x8000
#define LPC_SDMMC_STATUS_RXFIFOHALFFULL 0x8000
#define LPC_SDMMC_STATUS_RXFIFOHALFFULL_BIT 15
#define LPC_SDMMC_STATUS_TXFIFOFULL_MASK 0x10000
#define LPC_SDMMC_STATUS_TXFIFOFULL 0x10000
#define LPC_SDMMC_STATUS_TXFIFOFULL_BIT 16
#define LPC_SDMMC_STATUS_RXFIFOFULL_MASK 0x20000
#define LPC_SDMMC_STATUS_RXFIFOFULL 0x20000
#define LPC_SDMMC_STATUS_RXFIFOFULL_BIT 17
#define LPC_SDMMC_STATUS_TXFIFOEMPTY_MASK 0x40000
#define LPC_SDMMC_STATUS_TXFIFOEMPTY 0x40000
#define LPC_SDMMC_STATUS_TXFIFOEMPTY_BIT 18
#define LPC_SDMMC_STATUS_RXFIFOEMPTY_MASK 0x80000
#define LPC_SDMMC_STATUS_RXFIFOEMPTY 0x80000
#define LPC_SDMMC_STATUS_RXFIFOEMPTY_BIT 19
#define LPC_SDMMC_STATUS_TXDATAAVLBL_MASK 0x100000
#define LPC_SDMMC_STATUS_TXDATAAVLBL 0x100000
#define LPC_SDMMC_STATUS_TXDATAAVLBL_BIT 20
#define LPC_SDMMC_STATUS_RXDATAAVLBL_MASK 0x200000
#define LPC_SDMMC_STATUS_RXDATAAVLBL 0x200000
#define LPC_SDMMC_STATUS_RXDATAAVLBL_BIT 21

#define LPC_SDMMC_CLEAR (*(volatile unsigned long *)0x400C0038)
#define LPC_SDMMC_CLEAR_OFFSET 0x38
#define LPC_SDMMC_CLEAR_CMDCRCFAILCLR_MASK 0x1
#define LPC_SDMMC_CLEAR_CMDCRCFAILCLR 0x1
#define LPC_SDMMC_CLEAR_CMDCRCFAILCLR_BIT 0
#define LPC_SDMMC_CLEAR_DATACRCFAILCLR_MASK 0x2
#define LPC_SDMMC_CLEAR_DATACRCFAILCLR 0x2
#define LPC_SDMMC_CLEAR_DATACRCFAILCLR_BIT 1
#define LPC_SDMMC_CLEAR_CMDTIMEOUTCLR_MASK 0x4
#define LPC_SDMMC_CLEAR_CMDTIMEOUTCLR 0x4
#define LPC_SDMMC_CLEAR_CMDTIMEOUTCLR_BIT 2
#define LPC_SDMMC_CLEAR_DATATIMEOUTCLR_MASK 0x8
#define LPC_SDMMC_CLEAR_DATATIMEOUTCLR 0x8
#define LPC_SDMMC_CLEAR_DATATIMEOUTCLR_BIT 3
#define LPC_SDMMC_CLEAR_TXUNDERRUNCLR_MASK 0x10
#define LPC_SDMMC_CLEAR_TXUNDERRUNCLR 0x10
#define LPC_SDMMC_CLEAR_TXUNDERRUNCLR_BIT 4
#define LPC_SDMMC_CLEAR_RXOVERRUNCLR_MASK 0x20
#define LPC_SDMMC_CLEAR_RXOVERRUNCLR 0x20
#define LPC_SDMMC_CLEAR_RXOVERRUNCLR_BIT 5
#define LPC_SDMMC_CLEAR_CMDRESPENDCLR_MASK 0x40
#define LPC_SDMMC_CLEAR_CMDRESPENDCLR 0x40
#define LPC_SDMMC_CLEAR_CMDRESPENDCLR_BIT 6
#define LPC_SDMMC_CLEAR_CMDSENTCLR_MASK 0x80
#define LPC_SDMMC_CLEAR_CMDSENTCLR 0x80
#define LPC_SDMMC_CLEAR_CMDSENTCLR_BIT 7
#define LPC_SDMMC_CLEAR_DATAENDCLR_MASK 0x100
#define LPC_SDMMC_CLEAR_DATAENDCLR 0x100
#define LPC_SDMMC_CLEAR_DATAENDCLR_BIT 8
#define LPC_SDMMC_CLEAR_STARTBITERRCLR_MASK 0x200
#define LPC_SDMMC_CLEAR_STARTBITERRCLR 0x200
#define LPC_SDMMC_CLEAR_STARTBITERRCLR_BIT 9
#define LPC_SDMMC_CLEAR_DATABLOCKENDCLR_MASK 0x400
#define LPC_SDMMC_CLEAR_DATABLOCKENDCLR 0x400
#define LPC_SDMMC_CLEAR_DATABLOCKENDCLR_BIT 10

#define LPC_SDMMC_MASK0 (*(volatile unsigned long *)0x400C003C)
#define LPC_SDMMC_MASK0_OFFSET 0x3C
#define LPC_SDMMC_MASK0_MASK0_MASK 0x1
#define LPC_SDMMC_MASK0_MASK0 0x1
#define LPC_SDMMC_MASK0_MASK0_BIT 0
#define LPC_SDMMC_MASK0_MASK1_MASK 0x2
#define LPC_SDMMC_MASK0_MASK1 0x2
#define LPC_SDMMC_MASK0_MASK1_BIT 1
#define LPC_SDMMC_MASK0_MASK2_MASK 0x4
#define LPC_SDMMC_MASK0_MASK2 0x4
#define LPC_SDMMC_MASK0_MASK2_BIT 2
#define LPC_SDMMC_MASK0_MASK3_MASK 0x8
#define LPC_SDMMC_MASK0_MASK3 0x8
#define LPC_SDMMC_MASK0_MASK3_BIT 3
#define LPC_SDMMC_MASK0_MASK4_MASK 0x10
#define LPC_SDMMC_MASK0_MASK4 0x10
#define LPC_SDMMC_MASK0_MASK4_BIT 4
#define LPC_SDMMC_MASK0_MASK5_MASK 0x20
#define LPC_SDMMC_MASK0_MASK5 0x20
#define LPC_SDMMC_MASK0_MASK5_BIT 5
#define LPC_SDMMC_MASK0_MASK6_MASK 0x40
#define LPC_SDMMC_MASK0_MASK6 0x40
#define LPC_SDMMC_MASK0_MASK6_BIT 6
#define LPC_SDMMC_MASK0_MASK7_MASK 0x80
#define LPC_SDMMC_MASK0_MASK7 0x80
#define LPC_SDMMC_MASK0_MASK7_BIT 7
#define LPC_SDMMC_MASK0_MASK8_MASK 0x100
#define LPC_SDMMC_MASK0_MASK8 0x100
#define LPC_SDMMC_MASK0_MASK8_BIT 8
#define LPC_SDMMC_MASK0_MASK9_MASK 0x200
#define LPC_SDMMC_MASK0_MASK9 0x200
#define LPC_SDMMC_MASK0_MASK9_BIT 9
#define LPC_SDMMC_MASK0_MASK10_MASK 0x400
#define LPC_SDMMC_MASK0_MASK10 0x400
#define LPC_SDMMC_MASK0_MASK10_BIT 10
#define LPC_SDMMC_MASK0_MASK11_MASK 0x800
#define LPC_SDMMC_MASK0_MASK11 0x800
#define LPC_SDMMC_MASK0_MASK11_BIT 11
#define LPC_SDMMC_MASK0_MASK12_MASK 0x1000
#define LPC_SDMMC_MASK0_MASK12 0x1000
#define LPC_SDMMC_MASK0_MASK12_BIT 12
#define LPC_SDMMC_MASK0_MASK13_MASK 0x2000
#define LPC_SDMMC_MASK0_MASK13 0x2000
#define LPC_SDMMC_MASK0_MASK13_BIT 13
#define LPC_SDMMC_MASK0_MASK14_MASK 0x4000
#define LPC_SDMMC_MASK0_MASK14 0x4000
#define LPC_SDMMC_MASK0_MASK14_BIT 14
#define LPC_SDMMC_MASK0_MASK15_MASK 0x8000
#define LPC_SDMMC_MASK0_MASK15 0x8000
#define LPC_SDMMC_MASK0_MASK15_BIT 15
#define LPC_SDMMC_MASK0_MASK16_MASK 0x10000
#define LPC_SDMMC_MASK0_MASK16 0x10000
#define LPC_SDMMC_MASK0_MASK16_BIT 16
#define LPC_SDMMC_MASK0_MASK17_MASK 0x20000
#define LPC_SDMMC_MASK0_MASK17 0x20000
#define LPC_SDMMC_MASK0_MASK17_BIT 17
#define LPC_SDMMC_MASK0_MASK18_MASK 0x40000
#define LPC_SDMMC_MASK0_MASK18 0x40000
#define LPC_SDMMC_MASK0_MASK18_BIT 18
#define LPC_SDMMC_MASK0_MASK19_MASK 0x80000
#define LPC_SDMMC_MASK0_MASK19 0x80000
#define LPC_SDMMC_MASK0_MASK19_BIT 19
#define LPC_SDMMC_MASK0_MASK20_MASK 0x100000
#define LPC_SDMMC_MASK0_MASK20 0x100000
#define LPC_SDMMC_MASK0_MASK20_BIT 20
#define LPC_SDMMC_MASK0_MASK21_MASK 0x200000
#define LPC_SDMMC_MASK0_MASK21 0x200000
#define LPC_SDMMC_MASK0_MASK21_BIT 21

#define LPC_SDMMC_FIFOCNT (*(volatile unsigned long *)0x400C0048)
#define LPC_SDMMC_FIFOCNT_OFFSET 0x48
#define LPC_SDMMC_FIFOCNT_DATACOUNT_MASK 0x7FFF
#define LPC_SDMMC_FIFOCNT_DATACOUNT_BIT 0

#define LPC_SDMMC_FIFO0 (*(volatile unsigned long *)0x400C0080)
#define LPC_SDMMC_FIFO0_OFFSET 0x80
#define LPC_SDMMC_FIFO0_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO0_DATA_BIT 0

#define LPC_SDMMC_FIFO1 (*(volatile unsigned long *)0x400C0084)
#define LPC_SDMMC_FIFO1_OFFSET 0x84
#define LPC_SDMMC_FIFO1_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO1_DATA_BIT 0

#define LPC_SDMMC_FIFO2 (*(volatile unsigned long *)0x400C0088)
#define LPC_SDMMC_FIFO2_OFFSET 0x88
#define LPC_SDMMC_FIFO2_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO2_DATA_BIT 0

#define LPC_SDMMC_FIFO3 (*(volatile unsigned long *)0x400C008C)
#define LPC_SDMMC_FIFO3_OFFSET 0x8C
#define LPC_SDMMC_FIFO3_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO3_DATA_BIT 0

#define LPC_SDMMC_FIFO4 (*(volatile unsigned long *)0x400C0090)
#define LPC_SDMMC_FIFO4_OFFSET 0x90
#define LPC_SDMMC_FIFO4_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO4_DATA_BIT 0

#define LPC_SDMMC_FIFO5 (*(volatile unsigned long *)0x400C0094)
#define LPC_SDMMC_FIFO5_OFFSET 0x94
#define LPC_SDMMC_FIFO5_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO5_DATA_BIT 0

#define LPC_SDMMC_FIFO6 (*(volatile unsigned long *)0x400C0098)
#define LPC_SDMMC_FIFO6_OFFSET 0x98
#define LPC_SDMMC_FIFO6_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO6_DATA_BIT 0

#define LPC_SDMMC_FIFO7 (*(volatile unsigned long *)0x400C009C)
#define LPC_SDMMC_FIFO7_OFFSET 0x9C
#define LPC_SDMMC_FIFO7_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO7_DATA_BIT 0

#define LPC_SDMMC_FIFO8 (*(volatile unsigned long *)0x400C00A0)
#define LPC_SDMMC_FIFO8_OFFSET 0xA0
#define LPC_SDMMC_FIFO8_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO8_DATA_BIT 0

#define LPC_SDMMC_FIFO9 (*(volatile unsigned long *)0x400C00A4)
#define LPC_SDMMC_FIFO9_OFFSET 0xA4
#define LPC_SDMMC_FIFO9_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO9_DATA_BIT 0

#define LPC_SDMMC_FIFO10 (*(volatile unsigned long *)0x400C00A8)
#define LPC_SDMMC_FIFO10_OFFSET 0xA8
#define LPC_SDMMC_FIFO10_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO10_DATA_BIT 0

#define LPC_SDMMC_FIFO11 (*(volatile unsigned long *)0x400C00AC)
#define LPC_SDMMC_FIFO11_OFFSET 0xAC
#define LPC_SDMMC_FIFO11_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO11_DATA_BIT 0

#define LPC_SDMMC_FIFO12 (*(volatile unsigned long *)0x400C00B0)
#define LPC_SDMMC_FIFO12_OFFSET 0xB0
#define LPC_SDMMC_FIFO12_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO12_DATA_BIT 0

#define LPC_SDMMC_FIFO13 (*(volatile unsigned long *)0x400C00B4)
#define LPC_SDMMC_FIFO13_OFFSET 0xB4
#define LPC_SDMMC_FIFO13_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO13_DATA_BIT 0

#define LPC_SDMMC_FIFO14 (*(volatile unsigned long *)0x400C00B8)
#define LPC_SDMMC_FIFO14_OFFSET 0xB8
#define LPC_SDMMC_FIFO14_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO14_DATA_BIT 0

#define LPC_SDMMC_FIFO15 (*(volatile unsigned long *)0x400C00BC)
#define LPC_SDMMC_FIFO15_OFFSET 0xBC
#define LPC_SDMMC_FIFO15_DATA_MASK 0xFFFFFFFF
#define LPC_SDMMC_FIFO15_DATA_BIT 0

#ifndef LPC_SYSCON_BASE_ADDRESS
#define LPC_SYSCON_BASE_ADDRESS 0x400FC000
#endif

#define LPC_SYSCON_FLASHCFG (*(volatile unsigned long *)0x400FC000)
#define LPC_SYSCON_FLASHCFG_OFFSET 0x0
#define LPC_SYSCON_FLASHCFG_FLASHTIM_MASK 0xF000
#define LPC_SYSCON_FLASHCFG_FLASHTIM_BIT 12

#define LPC_SYSCON_PLLCON0 (*(volatile unsigned long *)0x400FC080)
#define LPC_SYSCON_PLLCON0_OFFSET 0x80
#define LPC_SYSCON_PLLCON0_PLLE_MASK 0x1
#define LPC_SYSCON_PLLCON0_PLLE 0x1
#define LPC_SYSCON_PLLCON0_PLLE_BIT 0

#define LPC_SYSCON_PLLCON1 (*(volatile unsigned long *)0x400FC0A0)
#define LPC_SYSCON_PLLCON1_OFFSET 0xA0
#define LPC_SYSCON_PLLCON1_PLLE_MASK 0x1
#define LPC_SYSCON_PLLCON1_PLLE 0x1
#define LPC_SYSCON_PLLCON1_PLLE_BIT 0

#define LPC_SYSCON_PLLCFG0 (*(volatile unsigned long *)0x400FC084)
#define LPC_SYSCON_PLLCFG0_OFFSET 0x84
#define LPC_SYSCON_PLLCFG0_MSEL_MASK 0x1F
#define LPC_SYSCON_PLLCFG0_MSEL_BIT 0
#define LPC_SYSCON_PLLCFG0_PSEL_MASK 0x60
#define LPC_SYSCON_PLLCFG0_PSEL_BIT 5

#define LPC_SYSCON_PLLCFG1 (*(volatile unsigned long *)0x400FC0A4)
#define LPC_SYSCON_PLLCFG1_OFFSET 0xA4
#define LPC_SYSCON_PLLCFG1_MSEL_MASK 0x1F
#define LPC_SYSCON_PLLCFG1_MSEL_BIT 0
#define LPC_SYSCON_PLLCFG1_PSEL_MASK 0x60
#define LPC_SYSCON_PLLCFG1_PSEL_BIT 5

#define LPC_SYSCON_PLLSTAT0 (*(volatile unsigned long *)0x400FC088)
#define LPC_SYSCON_PLLSTAT0_OFFSET 0x88
#define LPC_SYSCON_PLLSTAT0_MSEL_MASK 0x1F
#define LPC_SYSCON_PLLSTAT0_MSEL_BIT 0
#define LPC_SYSCON_PLLSTAT0_PSEL_MASK 0x60
#define LPC_SYSCON_PLLSTAT0_PSEL_BIT 5
#define LPC_SYSCON_PLLSTAT0_PLLE_STAT_MASK 0x100
#define LPC_SYSCON_PLLSTAT0_PLLE_STAT 0x100
#define LPC_SYSCON_PLLSTAT0_PLLE_STAT_BIT 8
#define LPC_SYSCON_PLLSTAT0_PLOCK_MASK 0x400
#define LPC_SYSCON_PLLSTAT0_PLOCK 0x400
#define LPC_SYSCON_PLLSTAT0_PLOCK_BIT 10

#define LPC_SYSCON_PLLSTAT1 (*(volatile unsigned long *)0x400FC0A8)
#define LPC_SYSCON_PLLSTAT1_OFFSET 0xA8
#define LPC_SYSCON_PLLSTAT1_MSEL_MASK 0x1F
#define LPC_SYSCON_PLLSTAT1_MSEL_BIT 0
#define LPC_SYSCON_PLLSTAT1_PSEL_MASK 0x60
#define LPC_SYSCON_PLLSTAT1_PSEL_BIT 5
#define LPC_SYSCON_PLLSTAT1_PLLE_STAT_MASK 0x100
#define LPC_SYSCON_PLLSTAT1_PLLE_STAT 0x100
#define LPC_SYSCON_PLLSTAT1_PLLE_STAT_BIT 8
#define LPC_SYSCON_PLLSTAT1_PLOCK_MASK 0x400
#define LPC_SYSCON_PLLSTAT1_PLOCK 0x400
#define LPC_SYSCON_PLLSTAT1_PLOCK_BIT 10

#define LPC_SYSCON_PLLFEED0 (*(volatile unsigned long *)0x400FC08C)
#define LPC_SYSCON_PLLFEED0_OFFSET 0x8C
#define LPC_SYSCON_PLLFEED0_PLLFEED_MASK 0xFF
#define LPC_SYSCON_PLLFEED0_PLLFEED_BIT 0

#define LPC_SYSCON_PLLFEED1 (*(volatile unsigned long *)0x400FC0AC)
#define LPC_SYSCON_PLLFEED1_OFFSET 0xAC
#define LPC_SYSCON_PLLFEED1_PLLFEED_MASK 0xFF
#define LPC_SYSCON_PLLFEED1_PLLFEED_BIT 0

#define LPC_SYSCON_PCON (*(volatile unsigned long *)0x400FC0C0)
#define LPC_SYSCON_PCON_OFFSET 0xC0
#define LPC_SYSCON_PCON_PM0_MASK 0x1
#define LPC_SYSCON_PCON_PM0 0x1
#define LPC_SYSCON_PCON_PM0_BIT 0
#define LPC_SYSCON_PCON_PM1_MASK 0x2
#define LPC_SYSCON_PCON_PM1 0x2
#define LPC_SYSCON_PCON_PM1_BIT 1
#define LPC_SYSCON_PCON_BODRPM_MASK 0x4
#define LPC_SYSCON_PCON_BODRPM 0x4
#define LPC_SYSCON_PCON_BODRPM_BIT 2
#define LPC_SYSCON_PCON_BOGD_MASK 0x8
#define LPC_SYSCON_PCON_BOGD 0x8
#define LPC_SYSCON_PCON_BOGD_BIT 3
#define LPC_SYSCON_PCON_BORD_MASK 0x10
#define LPC_SYSCON_PCON_BORD 0x10
#define LPC_SYSCON_PCON_BORD_BIT 4
#define LPC_SYSCON_PCON_SMFLAG_MASK 0x100
#define LPC_SYSCON_PCON_SMFLAG 0x100
#define LPC_SYSCON_PCON_SMFLAG_BIT 8
#define LPC_SYSCON_PCON_DSFLAG_MASK 0x200
#define LPC_SYSCON_PCON_DSFLAG 0x200
#define LPC_SYSCON_PCON_DSFLAG_BIT 9
#define LPC_SYSCON_PCON_PDFLAG_MASK 0x400
#define LPC_SYSCON_PCON_PDFLAG 0x400
#define LPC_SYSCON_PCON_PDFLAG_BIT 10
#define LPC_SYSCON_PCON_DPDFLAG_MASK 0x800
#define LPC_SYSCON_PCON_DPDFLAG 0x800
#define LPC_SYSCON_PCON_DPDFLAG_BIT 11

#define LPC_SYSCON_PCONP0 (*(volatile unsigned long *)0x400FC0C4)
#define LPC_SYSCON_PCONP0_OFFSET 0xC4
#define LPC_SYSCON_PCONP0_PCLCD_MASK 0x1
#define LPC_SYSCON_PCONP0_PCLCD 0x1
#define LPC_SYSCON_PCONP0_PCLCD_BIT 0
#define LPC_SYSCON_PCONP0_PCTIM0_MASK 0x2
#define LPC_SYSCON_PCONP0_PCTIM0 0x2
#define LPC_SYSCON_PCONP0_PCTIM0_BIT 1
#define LPC_SYSCON_PCONP0_PCTIM1_MASK 0x4
#define LPC_SYSCON_PCONP0_PCTIM1 0x4
#define LPC_SYSCON_PCONP0_PCTIM1_BIT 2
#define LPC_SYSCON_PCONP0_PCUART0_MASK 0x8
#define LPC_SYSCON_PCONP0_PCUART0 0x8
#define LPC_SYSCON_PCONP0_PCUART0_BIT 3
#define LPC_SYSCON_PCONP0_PCUART1_MASK 0x10
#define LPC_SYSCON_PCONP0_PCUART1 0x10
#define LPC_SYSCON_PCONP0_PCUART1_BIT 4
#define LPC_SYSCON_PCONP0_PCPWM0_MASK 0x20
#define LPC_SYSCON_PCONP0_PCPWM0 0x20
#define LPC_SYSCON_PCONP0_PCPWM0_BIT 5
#define LPC_SYSCON_PCONP0_PCPWM1_MASK 0x40
#define LPC_SYSCON_PCONP0_PCPWM1 0x40
#define LPC_SYSCON_PCONP0_PCPWM1_BIT 6
#define LPC_SYSCON_PCONP0_PCI2C0_MASK 0x80
#define LPC_SYSCON_PCONP0_PCI2C0 0x80
#define LPC_SYSCON_PCONP0_PCI2C0_BIT 7
#define LPC_SYSCON_PCONP0_PCUART4_MASK 0x100
#define LPC_SYSCON_PCONP0_PCUART4 0x100
#define LPC_SYSCON_PCONP0_PCUART4_BIT 8
#define LPC_SYSCON_PCONP0_PCRTC_MASK 0x200
#define LPC_SYSCON_PCONP0_PCRTC 0x200
#define LPC_SYSCON_PCONP0_PCRTC_BIT 9
#define LPC_SYSCON_PCONP0_PCSSP1_MASK 0x400
#define LPC_SYSCON_PCONP0_PCSSP1 0x400
#define LPC_SYSCON_PCONP0_PCSSP1_BIT 10
#define LPC_SYSCON_PCONP0_PCEMC_MASK 0x800
#define LPC_SYSCON_PCONP0_PCEMC 0x800
#define LPC_SYSCON_PCONP0_PCEMC_BIT 11
#define LPC_SYSCON_PCONP0_PCADC_MASK 0x1000
#define LPC_SYSCON_PCONP0_PCADC 0x1000
#define LPC_SYSCON_PCONP0_PCADC_BIT 12
#define LPC_SYSCON_PCONP0_PCCAN1_MASK 0x2000
#define LPC_SYSCON_PCONP0_PCCAN1 0x2000
#define LPC_SYSCON_PCONP0_PCCAN1_BIT 13
#define LPC_SYSCON_PCONP0_PCCAN2_MASK 0x4000
#define LPC_SYSCON_PCONP0_PCCAN2 0x4000
#define LPC_SYSCON_PCONP0_PCCAN2_BIT 14
#define LPC_SYSCON_PCONP0_PCGPIO_MASK 0x8000
#define LPC_SYSCON_PCONP0_PCGPIO 0x8000
#define LPC_SYSCON_PCONP0_PCGPIO_BIT 15
#define LPC_SYSCON_PCONP0_PCSPIFI_MASK 0x10000
#define LPC_SYSCON_PCONP0_PCSPIFI 0x10000
#define LPC_SYSCON_PCONP0_PCSPIFI_BIT 16
#define LPC_SYSCON_PCONP0_PCMCPWM_MASK 0x20000
#define LPC_SYSCON_PCONP0_PCMCPWM 0x20000
#define LPC_SYSCON_PCONP0_PCMCPWM_BIT 17
#define LPC_SYSCON_PCONP0_PCQEI_MASK 0x40000
#define LPC_SYSCON_PCONP0_PCQEI 0x40000
#define LPC_SYSCON_PCONP0_PCQEI_BIT 18
#define LPC_SYSCON_PCONP0_PCI2C1_MASK 0x80000
#define LPC_SYSCON_PCONP0_PCI2C1 0x80000
#define LPC_SYSCON_PCONP0_PCI2C1_BIT 19
#define LPC_SYSCON_PCONP0_PCSSP2_MASK 0x100000
#define LPC_SYSCON_PCONP0_PCSSP2 0x100000
#define LPC_SYSCON_PCONP0_PCSSP2_BIT 20
#define LPC_SYSCON_PCONP0_PCSSP0_MASK 0x200000
#define LPC_SYSCON_PCONP0_PCSSP0 0x200000
#define LPC_SYSCON_PCONP0_PCSSP0_BIT 21
#define LPC_SYSCON_PCONP0_PCTIM2_MASK 0x400000
#define LPC_SYSCON_PCONP0_PCTIM2 0x400000
#define LPC_SYSCON_PCONP0_PCTIM2_BIT 22
#define LPC_SYSCON_PCONP0_PCTIM3_MASK 0x800000
#define LPC_SYSCON_PCONP0_PCTIM3 0x800000
#define LPC_SYSCON_PCONP0_PCTIM3_BIT 23
#define LPC_SYSCON_PCONP0_PCUART2_MASK 0x1000000
#define LPC_SYSCON_PCONP0_PCUART2 0x1000000
#define LPC_SYSCON_PCONP0_PCUART2_BIT 24
#define LPC_SYSCON_PCONP0_PCUART3_MASK 0x2000000
#define LPC_SYSCON_PCONP0_PCUART3 0x2000000
#define LPC_SYSCON_PCONP0_PCUART3_BIT 25
#define LPC_SYSCON_PCONP0_PCI2C2_MASK 0x4000000
#define LPC_SYSCON_PCONP0_PCI2C2 0x4000000
#define LPC_SYSCON_PCONP0_PCI2C2_BIT 26
#define LPC_SYSCON_PCONP0_PCI2S_MASK 0x8000000
#define LPC_SYSCON_PCONP0_PCI2S 0x8000000
#define LPC_SYSCON_PCONP0_PCI2S_BIT 27
#define LPC_SYSCON_PCONP0_PCSDC_MASK 0x10000000
#define LPC_SYSCON_PCONP0_PCSDC 0x10000000
#define LPC_SYSCON_PCONP0_PCSDC_BIT 28
#define LPC_SYSCON_PCONP0_PCGPDMA_MASK 0x20000000
#define LPC_SYSCON_PCONP0_PCGPDMA 0x20000000
#define LPC_SYSCON_PCONP0_PCGPDMA_BIT 29
#define LPC_SYSCON_PCONP0_PCENET_MASK 0x40000000
#define LPC_SYSCON_PCONP0_PCENET 0x40000000
#define LPC_SYSCON_PCONP0_PCENET_BIT 30
#define LPC_SYSCON_PCONP0_PCUSB_MASK 0x80000000
#define LPC_SYSCON_PCONP0_PCUSB 0x80000000
#define LPC_SYSCON_PCONP0_PCUSB_BIT 31

#define LPC_SYSCON_PCONP1 (*(volatile unsigned long *)0x400FC0C8)
#define LPC_SYSCON_PCONP1_OFFSET 0xC8
#define LPC_SYSCON_PCONP1_PCCMP_MASK 0x8
#define LPC_SYSCON_PCONP1_PCCMP 0x8
#define LPC_SYSCON_PCONP1_PCCMP_BIT 3

#define LPC_SYSCON_EMCCLKSEL (*(volatile unsigned long *)0x400FC100)
#define LPC_SYSCON_EMCCLKSEL_OFFSET 0x100
#define LPC_SYSCON_EMCCLKSEL_EMCDIV_MASK 0x1
#define LPC_SYSCON_EMCCLKSEL_EMCDIV 0x1
#define LPC_SYSCON_EMCCLKSEL_EMCDIV_BIT 0

#define LPC_SYSCON_CCLKSEL (*(volatile unsigned long *)0x400FC104)
#define LPC_SYSCON_CCLKSEL_OFFSET 0x104
#define LPC_SYSCON_CCLKSEL_CCLKDIV_MASK 0x1F
#define LPC_SYSCON_CCLKSEL_CCLKDIV_BIT 0
#define LPC_SYSCON_CCLKSEL_CCLKSEL_MASK 0x100
#define LPC_SYSCON_CCLKSEL_CCLKSEL 0x100
#define LPC_SYSCON_CCLKSEL_CCLKSEL_BIT 8

#define LPC_SYSCON_USBCLKSEL (*(volatile unsigned long *)0x400FC108)
#define LPC_SYSCON_USBCLKSEL_OFFSET 0x108
#define LPC_SYSCON_USBCLKSEL_USBDIV_MASK 0x1F
#define LPC_SYSCON_USBCLKSEL_USBDIV_BIT 0
#define LPC_SYSCON_USBCLKSEL_USBSEL_MASK 0x300
#define LPC_SYSCON_USBCLKSEL_USBSEL_BIT 8

#define LPC_SYSCON_CLKSRCSEL (*(volatile unsigned long *)0x400FC10C)
#define LPC_SYSCON_CLKSRCSEL_OFFSET 0x10C
#define LPC_SYSCON_CLKSRCSEL_CLKSRC_MASK 0x1
#define LPC_SYSCON_CLKSRCSEL_CLKSRC 0x1
#define LPC_SYSCON_CLKSRCSEL_CLKSRC_BIT 0

#define LPC_SYSCON_CANSLEEPCLR (*(volatile unsigned long *)0x400FC110)
#define LPC_SYSCON_CANSLEEPCLR_OFFSET 0x110
#define LPC_SYSCON_CANSLEEPCLR_CAN1SLEEP_MASK 0x2
#define LPC_SYSCON_CANSLEEPCLR_CAN1SLEEP 0x2
#define LPC_SYSCON_CANSLEEPCLR_CAN1SLEEP_BIT 1
#define LPC_SYSCON_CANSLEEPCLR_CAN2SLEEP_MASK 0x4
#define LPC_SYSCON_CANSLEEPCLR_CAN2SLEEP 0x4
#define LPC_SYSCON_CANSLEEPCLR_CAN2SLEEP_BIT 2

#define LPC_SYSCON_CANWAKEFLAGS (*(volatile unsigned long *)0x400FC114)
#define LPC_SYSCON_CANWAKEFLAGS_OFFSET 0x114
#define LPC_SYSCON_CANWAKEFLAGS_CAN1WAKE_MASK 0x2
#define LPC_SYSCON_CANWAKEFLAGS_CAN1WAKE 0x2
#define LPC_SYSCON_CANWAKEFLAGS_CAN1WAKE_BIT 1
#define LPC_SYSCON_CANWAKEFLAGS_CAN2WAKE_MASK 0x4
#define LPC_SYSCON_CANWAKEFLAGS_CAN2WAKE 0x4
#define LPC_SYSCON_CANWAKEFLAGS_CAN2WAKE_BIT 2

#define LPC_SYSCON_EXTINT (*(volatile unsigned long *)0x400FC140)
#define LPC_SYSCON_EXTINT_OFFSET 0x140
#define LPC_SYSCON_EXTINT_EINT0_MASK 0x1
#define LPC_SYSCON_EXTINT_EINT0 0x1
#define LPC_SYSCON_EXTINT_EINT0_BIT 0
#define LPC_SYSCON_EXTINT_EINT1_MASK 0x2
#define LPC_SYSCON_EXTINT_EINT1 0x2
#define LPC_SYSCON_EXTINT_EINT1_BIT 1
#define LPC_SYSCON_EXTINT_EINT2_MASK 0x4
#define LPC_SYSCON_EXTINT_EINT2 0x4
#define LPC_SYSCON_EXTINT_EINT2_BIT 2
#define LPC_SYSCON_EXTINT_EINT3_MASK 0x8
#define LPC_SYSCON_EXTINT_EINT3 0x8
#define LPC_SYSCON_EXTINT_EINT3_BIT 3

#define LPC_SYSCON_EXTMODE (*(volatile unsigned long *)0x400FC148)
#define LPC_SYSCON_EXTMODE_OFFSET 0x148
#define LPC_SYSCON_EXTMODE_EXTMODE0_MASK 0x1
#define LPC_SYSCON_EXTMODE_EXTMODE0 0x1
#define LPC_SYSCON_EXTMODE_EXTMODE0_BIT 0
#define LPC_SYSCON_EXTMODE_EXTMODE1_MASK 0x2
#define LPC_SYSCON_EXTMODE_EXTMODE1 0x2
#define LPC_SYSCON_EXTMODE_EXTMODE1_BIT 1
#define LPC_SYSCON_EXTMODE_EXTMODE2_MASK 0x4
#define LPC_SYSCON_EXTMODE_EXTMODE2 0x4
#define LPC_SYSCON_EXTMODE_EXTMODE2_BIT 2
#define LPC_SYSCON_EXTMODE_EXTMODE3_MASK 0x8
#define LPC_SYSCON_EXTMODE_EXTMODE3 0x8
#define LPC_SYSCON_EXTMODE_EXTMODE3_BIT 3

#define LPC_SYSCON_EXTPOLAR (*(volatile unsigned long *)0x400FC14C)
#define LPC_SYSCON_EXTPOLAR_OFFSET 0x14C
#define LPC_SYSCON_EXTPOLAR_EXTPOLAR0_MASK 0x1
#define LPC_SYSCON_EXTPOLAR_EXTPOLAR0 0x1
#define LPC_SYSCON_EXTPOLAR_EXTPOLAR0_BIT 0
#define LPC_SYSCON_EXTPOLAR_EXTPOLAR1_MASK 0x2
#define LPC_SYSCON_EXTPOLAR_EXTPOLAR1 0x2
#define LPC_SYSCON_EXTPOLAR_EXTPOLAR1_BIT 1
#define LPC_SYSCON_EXTPOLAR_EXTPOLAR2_MASK 0x4
#define LPC_SYSCON_EXTPOLAR_EXTPOLAR2 0x4
#define LPC_SYSCON_EXTPOLAR_EXTPOLAR2_BIT 2
#define LPC_SYSCON_EXTPOLAR_EXTPOLAR3_MASK 0x8
#define LPC_SYSCON_EXTPOLAR_EXTPOLAR3 0x8
#define LPC_SYSCON_EXTPOLAR_EXTPOLAR3_BIT 3

#define LPC_SYSCON_RSID (*(volatile unsigned long *)0x400FC180)
#define LPC_SYSCON_RSID_OFFSET 0x180
#define LPC_SYSCON_RSID_POR_MASK 0x1
#define LPC_SYSCON_RSID_POR 0x1
#define LPC_SYSCON_RSID_POR_BIT 0
#define LPC_SYSCON_RSID_EXTR_MASK 0x2
#define LPC_SYSCON_RSID_EXTR 0x2
#define LPC_SYSCON_RSID_EXTR_BIT 1
#define LPC_SYSCON_RSID_WDTR_MASK 0x4
#define LPC_SYSCON_RSID_WDTR 0x4
#define LPC_SYSCON_RSID_WDTR_BIT 2
#define LPC_SYSCON_RSID_BODR_MASK 0x8
#define LPC_SYSCON_RSID_BODR 0x8
#define LPC_SYSCON_RSID_BODR_BIT 3
#define LPC_SYSCON_RSID_SYSRESET_MASK 0x10
#define LPC_SYSCON_RSID_SYSRESET 0x10
#define LPC_SYSCON_RSID_SYSRESET_BIT 4
#define LPC_SYSCON_RSID_LOCKUP_MASK 0x20
#define LPC_SYSCON_RSID_LOCKUP 0x20
#define LPC_SYSCON_RSID_LOCKUP_BIT 5

#define LPC_SYSCON_MATRIXARB (*(volatile unsigned long *)0x400FC188)
#define LPC_SYSCON_MATRIXARB_OFFSET 0x188
#define LPC_SYSCON_MATRIXARB_PRI_ICODE_MASK 0x3
#define LPC_SYSCON_MATRIXARB_PRI_ICODE_BIT 0
#define LPC_SYSCON_MATRIXARB_PRI_DCODE_MASK 0xC
#define LPC_SYSCON_MATRIXARB_PRI_DCODE_BIT 2
#define LPC_SYSCON_MATRIXARB_PRI_SYS_MASK 0x30
#define LPC_SYSCON_MATRIXARB_PRI_SYS_BIT 4
#define LPC_SYSCON_MATRIXARB_PRI_GPDMA_MASK 0xC0
#define LPC_SYSCON_MATRIXARB_PRI_GPDMA_BIT 6
#define LPC_SYSCON_MATRIXARB_PRI_ETH_MASK 0x300
#define LPC_SYSCON_MATRIXARB_PRI_ETH_BIT 8
#define LPC_SYSCON_MATRIXARB_PRI_LCD_MASK 0xC00
#define LPC_SYSCON_MATRIXARB_PRI_LCD_BIT 10
#define LPC_SYSCON_MATRIXARB_PRI_USB_MASK 0x3000
#define LPC_SYSCON_MATRIXARB_PRI_USB_BIT 12
#define LPC_SYSCON_MATRIXARB_ROM_LAT_MASK 0x10000
#define LPC_SYSCON_MATRIXARB_ROM_LAT 0x10000
#define LPC_SYSCON_MATRIXARB_ROM_LAT_BIT 16

#define LPC_SYSCON_SCS (*(volatile unsigned long *)0x400FC1A0)
#define LPC_SYSCON_SCS_OFFSET 0x1A0
#define LPC_SYSCON_SCS_EMCSC_MASK 0x1
#define LPC_SYSCON_SCS_EMCSC 0x1
#define LPC_SYSCON_SCS_EMCSC_BIT 0
#define LPC_SYSCON_SCS_EMCRD_MASK 0x2
#define LPC_SYSCON_SCS_EMCRD 0x2
#define LPC_SYSCON_SCS_EMCRD_BIT 1
#define LPC_SYSCON_SCS_EMCBC_MASK 0x4
#define LPC_SYSCON_SCS_EMCBC 0x4
#define LPC_SYSCON_SCS_EMCBC_BIT 2
#define LPC_SYSCON_SCS_MCIPWRAL_MASK 0x8
#define LPC_SYSCON_SCS_MCIPWRAL 0x8
#define LPC_SYSCON_SCS_MCIPWRAL_BIT 3
#define LPC_SYSCON_SCS_OSCRS_MASK 0x10
#define LPC_SYSCON_SCS_OSCRS 0x10
#define LPC_SYSCON_SCS_OSCRS_BIT 4
#define LPC_SYSCON_SCS_OSCEN_MASK 0x20
#define LPC_SYSCON_SCS_OSCEN 0x20
#define LPC_SYSCON_SCS_OSCEN_BIT 5
#define LPC_SYSCON_SCS_OSCSTAT_MASK 0x40
#define LPC_SYSCON_SCS_OSCSTAT 0x40
#define LPC_SYSCON_SCS_OSCSTAT_BIT 6

#define LPC_SYSCON_PCLKSEL (*(volatile unsigned long *)0x400FC1A8)
#define LPC_SYSCON_PCLKSEL_OFFSET 0x1A8
#define LPC_SYSCON_PCLKSEL_PCLKDIV_MASK 0x1F
#define LPC_SYSCON_PCLKSEL_PCLKDIV_BIT 0

#define LPC_SYSCON_PBOOST (*(volatile unsigned long *)0x400FC1B0)
#define LPC_SYSCON_PBOOST_OFFSET 0x1B0
#define LPC_SYSCON_PBOOST_Boost_MASK 0x3
#define LPC_SYSCON_PBOOST_Boost_BIT 0

#define LPC_SYSCON_SPIFICLKSEL (*(volatile unsigned long *)0x400FC1B4)
#define LPC_SYSCON_SPIFICLKSEL_OFFSET 0x1B4
#define LPC_SYSCON_SPIFICLKSEL_SPIFIDIV_MASK 0x1F
#define LPC_SYSCON_SPIFICLKSEL_SPIFIDIV_BIT 0
#define LPC_SYSCON_SPIFICLKSEL_SPIFISEL_MASK 0x300
#define LPC_SYSCON_SPIFICLKSEL_SPIFISEL_BIT 8

#define LPC_SYSCON_LCD_CFG (*(volatile unsigned long *)0x400FC1B8)
#define LPC_SYSCON_LCD_CFG_OFFSET 0x1B8
#define LPC_SYSCON_LCD_CFG_CLKDIV_MASK 0x1F
#define LPC_SYSCON_LCD_CFG_CLKDIV_BIT 0

#define LPC_SYSCON_USBINTST (*(volatile unsigned long *)0x400FC1C0)
#define LPC_SYSCON_USBINTST_OFFSET 0x1C0
#define LPC_SYSCON_USBINTST_USB_INT_REQ_LP_MASK 0x1
#define LPC_SYSCON_USBINTST_USB_INT_REQ_LP 0x1
#define LPC_SYSCON_USBINTST_USB_INT_REQ_LP_BIT 0
#define LPC_SYSCON_USBINTST_USB_INT_REQ_HP_MASK 0x2
#define LPC_SYSCON_USBINTST_USB_INT_REQ_HP 0x2
#define LPC_SYSCON_USBINTST_USB_INT_REQ_HP_BIT 1
#define LPC_SYSCON_USBINTST_USB_INT_REQ_DMA_MASK 0x4
#define LPC_SYSCON_USBINTST_USB_INT_REQ_DMA 0x4
#define LPC_SYSCON_USBINTST_USB_INT_REQ_DMA_BIT 2
#define LPC_SYSCON_USBINTST_USB_HOST_INT_MASK 0x8
#define LPC_SYSCON_USBINTST_USB_HOST_INT 0x8
#define LPC_SYSCON_USBINTST_USB_HOST_INT_BIT 3
#define LPC_SYSCON_USBINTST_USB_ATX_INT_MASK 0x10
#define LPC_SYSCON_USBINTST_USB_ATX_INT 0x10
#define LPC_SYSCON_USBINTST_USB_ATX_INT_BIT 4
#define LPC_SYSCON_USBINTST_USB_OTG_INT_MASK 0x20
#define LPC_SYSCON_USBINTST_USB_OTG_INT 0x20
#define LPC_SYSCON_USBINTST_USB_OTG_INT_BIT 5
#define LPC_SYSCON_USBINTST_USB_I2C_INT_MASK 0x40
#define LPC_SYSCON_USBINTST_USB_I2C_INT 0x40
#define LPC_SYSCON_USBINTST_USB_I2C_INT_BIT 6
#define LPC_SYSCON_USBINTST_USB_NEED_CLK_MASK 0x100
#define LPC_SYSCON_USBINTST_USB_NEED_CLK 0x100
#define LPC_SYSCON_USBINTST_USB_NEED_CLK_BIT 8
#define LPC_SYSCON_USBINTST_EN_USB_INTS_MASK 0x80000000
#define LPC_SYSCON_USBINTST_EN_USB_INTS 0x80000000
#define LPC_SYSCON_USBINTST_EN_USB_INTS_BIT 31

#define LPC_SYSCON_DMACREQSEL (*(volatile unsigned long *)0x400FC1C4)
#define LPC_SYSCON_DMACREQSEL_OFFSET 0x1C4
#define LPC_SYSCON_DMACREQSEL_DMASEL00_MASK 0x1
#define LPC_SYSCON_DMACREQSEL_DMASEL00 0x1
#define LPC_SYSCON_DMACREQSEL_DMASEL00_BIT 0
#define LPC_SYSCON_DMACREQSEL_DMASEL01_MASK 0x2
#define LPC_SYSCON_DMACREQSEL_DMASEL01 0x2
#define LPC_SYSCON_DMACREQSEL_DMASEL01_BIT 1
#define LPC_SYSCON_DMACREQSEL_DMASEL02_MASK 0x4
#define LPC_SYSCON_DMACREQSEL_DMASEL02 0x4
#define LPC_SYSCON_DMACREQSEL_DMASEL02_BIT 2
#define LPC_SYSCON_DMACREQSEL_DMASEL03_MASK 0x8
#define LPC_SYSCON_DMACREQSEL_DMASEL03 0x8
#define LPC_SYSCON_DMACREQSEL_DMASEL03_BIT 3
#define LPC_SYSCON_DMACREQSEL_DMASEL04_MASK 0x10
#define LPC_SYSCON_DMACREQSEL_DMASEL04 0x10
#define LPC_SYSCON_DMACREQSEL_DMASEL04_BIT 4
#define LPC_SYSCON_DMACREQSEL_DMASEL05_MASK 0x20
#define LPC_SYSCON_DMACREQSEL_DMASEL05 0x20
#define LPC_SYSCON_DMACREQSEL_DMASEL05_BIT 5
#define LPC_SYSCON_DMACREQSEL_DMASEL06_MASK 0x40
#define LPC_SYSCON_DMACREQSEL_DMASEL06 0x40
#define LPC_SYSCON_DMACREQSEL_DMASEL06_BIT 6
#define LPC_SYSCON_DMACREQSEL_DMASEL07_MASK 0x80
#define LPC_SYSCON_DMACREQSEL_DMASEL07 0x80
#define LPC_SYSCON_DMACREQSEL_DMASEL07_BIT 7
#define LPC_SYSCON_DMACREQSEL_DMASEL10_MASK 0x400
#define LPC_SYSCON_DMACREQSEL_DMASEL10 0x400
#define LPC_SYSCON_DMACREQSEL_DMASEL10_BIT 10
#define LPC_SYSCON_DMACREQSEL_DMASEL11_MASK 0x800
#define LPC_SYSCON_DMACREQSEL_DMASEL11 0x800
#define LPC_SYSCON_DMACREQSEL_DMASEL11_BIT 11
#define LPC_SYSCON_DMACREQSEL_DMASEL12_MASK 0x1000
#define LPC_SYSCON_DMACREQSEL_DMASEL12 0x1000
#define LPC_SYSCON_DMACREQSEL_DMASEL12_BIT 12
#define LPC_SYSCON_DMACREQSEL_DMASEL13_MASK 0x2000
#define LPC_SYSCON_DMACREQSEL_DMASEL13 0x2000
#define LPC_SYSCON_DMACREQSEL_DMASEL13_BIT 13
#define LPC_SYSCON_DMACREQSEL_DMASEL14_MASK 0x4000
#define LPC_SYSCON_DMACREQSEL_DMASEL14 0x4000
#define LPC_SYSCON_DMACREQSEL_DMASEL14_BIT 14
#define LPC_SYSCON_DMACREQSEL_DMASEL15_MASK 0x8000
#define LPC_SYSCON_DMACREQSEL_DMASEL15 0x8000
#define LPC_SYSCON_DMACREQSEL_DMASEL15_BIT 15

#define LPC_SYSCON_CLKOUTCFG (*(volatile unsigned long *)0x400FC1C8)
#define LPC_SYSCON_CLKOUTCFG_OFFSET 0x1C8
#define LPC_SYSCON_CLKOUTCFG_CLKOUTSEL_MASK 0xF
#define LPC_SYSCON_CLKOUTCFG_CLKOUTSEL_BIT 0
#define LPC_SYSCON_CLKOUTCFG_CLKOUTDIV_MASK 0xF0
#define LPC_SYSCON_CLKOUTCFG_CLKOUTDIV_BIT 4
#define LPC_SYSCON_CLKOUTCFG_CLKOUT_EN_MASK 0x100
#define LPC_SYSCON_CLKOUTCFG_CLKOUT_EN 0x100
#define LPC_SYSCON_CLKOUTCFG_CLKOUT_EN_BIT 8
#define LPC_SYSCON_CLKOUTCFG_CLKOUT_ACT_MASK 0x200
#define LPC_SYSCON_CLKOUTCFG_CLKOUT_ACT 0x200
#define LPC_SYSCON_CLKOUTCFG_CLKOUT_ACT_BIT 9

#define LPC_SYSCON_RSTCON0 (*(volatile unsigned long *)0x400FC1CC)
#define LPC_SYSCON_RSTCON0_OFFSET 0x1CC
#define LPC_SYSCON_RSTCON0_RSTLCD_MASK 0x1
#define LPC_SYSCON_RSTCON0_RSTLCD 0x1
#define LPC_SYSCON_RSTCON0_RSTLCD_BIT 0
#define LPC_SYSCON_RSTCON0_RSTTIM0_MASK 0x2
#define LPC_SYSCON_RSTCON0_RSTTIM0 0x2
#define LPC_SYSCON_RSTCON0_RSTTIM0_BIT 1
#define LPC_SYSCON_RSTCON0_RSTTIM1_MASK 0x4
#define LPC_SYSCON_RSTCON0_RSTTIM1 0x4
#define LPC_SYSCON_RSTCON0_RSTTIM1_BIT 2
#define LPC_SYSCON_RSTCON0_RSTUART0_MASK 0x8
#define LPC_SYSCON_RSTCON0_RSTUART0 0x8
#define LPC_SYSCON_RSTCON0_RSTUART0_BIT 3
#define LPC_SYSCON_RSTCON0_RSTUART1_MASK 0x10
#define LPC_SYSCON_RSTCON0_RSTUART1 0x10
#define LPC_SYSCON_RSTCON0_RSTUART1_BIT 4
#define LPC_SYSCON_RSTCON0_RSTPWM0_MASK 0x20
#define LPC_SYSCON_RSTCON0_RSTPWM0 0x20
#define LPC_SYSCON_RSTCON0_RSTPWM0_BIT 5
#define LPC_SYSCON_RSTCON0_RSTPWM1_MASK 0x40
#define LPC_SYSCON_RSTCON0_RSTPWM1 0x40
#define LPC_SYSCON_RSTCON0_RSTPWM1_BIT 6
#define LPC_SYSCON_RSTCON0_RSTI2C0_MASK 0x80
#define LPC_SYSCON_RSTCON0_RSTI2C0 0x80
#define LPC_SYSCON_RSTCON0_RSTI2C0_BIT 7
#define LPC_SYSCON_RSTCON0_RSTUART4_MASK 0x100
#define LPC_SYSCON_RSTCON0_RSTUART4 0x100
#define LPC_SYSCON_RSTCON0_RSTUART4_BIT 8
#define LPC_SYSCON_RSTCON0_RSTRTC_MASK 0x200
#define LPC_SYSCON_RSTCON0_RSTRTC 0x200
#define LPC_SYSCON_RSTCON0_RSTRTC_BIT 9
#define LPC_SYSCON_RSTCON0_RSTSSP1_MASK 0x400
#define LPC_SYSCON_RSTCON0_RSTSSP1 0x400
#define LPC_SYSCON_RSTCON0_RSTSSP1_BIT 10
#define LPC_SYSCON_RSTCON0_RSTEMC_MASK 0x800
#define LPC_SYSCON_RSTCON0_RSTEMC 0x800
#define LPC_SYSCON_RSTCON0_RSTEMC_BIT 11
#define LPC_SYSCON_RSTCON0_RSTADC_MASK 0x1000
#define LPC_SYSCON_RSTCON0_RSTADC 0x1000
#define LPC_SYSCON_RSTCON0_RSTADC_BIT 12
#define LPC_SYSCON_RSTCON0_RSTCAN1_MASK 0x2000
#define LPC_SYSCON_RSTCON0_RSTCAN1 0x2000
#define LPC_SYSCON_RSTCON0_RSTCAN1_BIT 13
#define LPC_SYSCON_RSTCON0_RSTCAN2_MASK 0x4000
#define LPC_SYSCON_RSTCON0_RSTCAN2 0x4000
#define LPC_SYSCON_RSTCON0_RSTCAN2_BIT 14
#define LPC_SYSCON_RSTCON0_RSTGPIO_MASK 0x8000
#define LPC_SYSCON_RSTCON0_RSTGPIO 0x8000
#define LPC_SYSCON_RSTCON0_RSTGPIO_BIT 15
#define LPC_SYSCON_RSTCON0_RSTSPIFI_MASK 0x10000
#define LPC_SYSCON_RSTCON0_RSTSPIFI 0x10000
#define LPC_SYSCON_RSTCON0_RSTSPIFI_BIT 16
#define LPC_SYSCON_RSTCON0_RSTMCPWM_MASK 0x20000
#define LPC_SYSCON_RSTCON0_RSTMCPWM 0x20000
#define LPC_SYSCON_RSTCON0_RSTMCPWM_BIT 17
#define LPC_SYSCON_RSTCON0_RSTQEI_MASK 0x40000
#define LPC_SYSCON_RSTCON0_RSTQEI 0x40000
#define LPC_SYSCON_RSTCON0_RSTQEI_BIT 18
#define LPC_SYSCON_RSTCON0_RSTI2C1_MASK 0x80000
#define LPC_SYSCON_RSTCON0_RSTI2C1 0x80000
#define LPC_SYSCON_RSTCON0_RSTI2C1_BIT 19
#define LPC_SYSCON_RSTCON0_RSTSSP2_MASK 0x100000
#define LPC_SYSCON_RSTCON0_RSTSSP2 0x100000
#define LPC_SYSCON_RSTCON0_RSTSSP2_BIT 20
#define LPC_SYSCON_RSTCON0_RSTSSP0_MASK 0x200000
#define LPC_SYSCON_RSTCON0_RSTSSP0 0x200000
#define LPC_SYSCON_RSTCON0_RSTSSP0_BIT 21
#define LPC_SYSCON_RSTCON0_RSTTIM2_MASK 0x400000
#define LPC_SYSCON_RSTCON0_RSTTIM2 0x400000
#define LPC_SYSCON_RSTCON0_RSTTIM2_BIT 22
#define LPC_SYSCON_RSTCON0_RSTTIM3_MASK 0x800000
#define LPC_SYSCON_RSTCON0_RSTTIM3 0x800000
#define LPC_SYSCON_RSTCON0_RSTTIM3_BIT 23
#define LPC_SYSCON_RSTCON0_RSTUART2_MASK 0x1000000
#define LPC_SYSCON_RSTCON0_RSTUART2 0x1000000
#define LPC_SYSCON_RSTCON0_RSTUART2_BIT 24
#define LPC_SYSCON_RSTCON0_RSTUART3_MASK 0x2000000
#define LPC_SYSCON_RSTCON0_RSTUART3 0x2000000
#define LPC_SYSCON_RSTCON0_RSTUART3_BIT 25
#define LPC_SYSCON_RSTCON0_RSTI2C2_MASK 0x4000000
#define LPC_SYSCON_RSTCON0_RSTI2C2 0x4000000
#define LPC_SYSCON_RSTCON0_RSTI2C2_BIT 26
#define LPC_SYSCON_RSTCON0_RSTI2S_MASK 0x8000000
#define LPC_SYSCON_RSTCON0_RSTI2S 0x8000000
#define LPC_SYSCON_RSTCON0_RSTI2S_BIT 27
#define LPC_SYSCON_RSTCON0_RSTSDC_MASK 0x10000000
#define LPC_SYSCON_RSTCON0_RSTSDC 0x10000000
#define LPC_SYSCON_RSTCON0_RSTSDC_BIT 28
#define LPC_SYSCON_RSTCON0_RSTGPDMA_MASK 0x20000000
#define LPC_SYSCON_RSTCON0_RSTGPDMA 0x20000000
#define LPC_SYSCON_RSTCON0_RSTGPDMA_BIT 29
#define LPC_SYSCON_RSTCON0_RSTENET_MASK 0x40000000
#define LPC_SYSCON_RSTCON0_RSTENET 0x40000000
#define LPC_SYSCON_RSTCON0_RSTENET_BIT 30
#define LPC_SYSCON_RSTCON0_RSTUSB_MASK 0x80000000
#define LPC_SYSCON_RSTCON0_RSTUSB 0x80000000
#define LPC_SYSCON_RSTCON0_RSTUSB_BIT 31

#define LPC_SYSCON_RSTCON1 (*(volatile unsigned long *)0x400FC1D0)
#define LPC_SYSCON_RSTCON1_OFFSET 0x1D0
#define LPC_SYSCON_RSTCON1_RSTIOCON_MASK 0x1
#define LPC_SYSCON_RSTCON1_RSTIOCON 0x1
#define LPC_SYSCON_RSTCON1_RSTIOCON_BIT 0
#define LPC_SYSCON_RSTCON1_RSTDAC_MASK 0x2
#define LPC_SYSCON_RSTCON1_RSTDAC 0x2
#define LPC_SYSCON_RSTCON1_RSTDAC_BIT 1
#define LPC_SYSCON_RSTCON1_RSTCANACC_MASK 0x4
#define LPC_SYSCON_RSTCON1_RSTCANACC 0x4
#define LPC_SYSCON_RSTCON1_RSTCANACC_BIT 2
#define LPC_SYSCON_RSTCON1_RSTCMP_MASK 0x8
#define LPC_SYSCON_RSTCON1_RSTCMP 0x8
#define LPC_SYSCON_RSTCON1_RSTCMP_BIT 3

#define LPC_SYSCON_EMCDLYCTL (*(volatile unsigned long *)0x400FC1DC)
#define LPC_SYSCON_EMCDLYCTL_OFFSET 0x1DC
#define LPC_SYSCON_EMCDLYCTL_CMDDLY_MASK 0x1F
#define LPC_SYSCON_EMCDLYCTL_CMDDLY_BIT 0
#define LPC_SYSCON_EMCDLYCTL_FBCLKDLY_MASK 0x1F00
#define LPC_SYSCON_EMCDLYCTL_FBCLKDLY_BIT 8
#define LPC_SYSCON_EMCDLYCTL_CLKOUT0DLY_MASK 0x1F0000
#define LPC_SYSCON_EMCDLYCTL_CLKOUT0DLY_BIT 16
#define LPC_SYSCON_EMCDLYCTL_CLKOUT1DLY_MASK 0x1F000000
#define LPC_SYSCON_EMCDLYCTL_CLKOUT1DLY_BIT 24

#define LPC_SYSCON_EMCCAL (*(volatile unsigned long *)0x400FC1E0)
#define LPC_SYSCON_EMCCAL_OFFSET 0x1E0
#define LPC_SYSCON_EMCCAL_CALVALUE_MASK 0xFF
#define LPC_SYSCON_EMCCAL_CALVALUE_BIT 0
#define LPC_SYSCON_EMCCAL_START_MASK 0x4000
#define LPC_SYSCON_EMCCAL_START 0x4000
#define LPC_SYSCON_EMCCAL_START_BIT 14
#define LPC_SYSCON_EMCCAL_DONE_MASK 0x8000
#define LPC_SYSCON_EMCCAL_DONE 0x8000
#define LPC_SYSCON_EMCCAL_DONE_BIT 15

#endif
